/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var $e=["exports","require","vs/base/browser/dom","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/base/common/errors","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/base/common/strings","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/nls","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/browser/event","vs/base/common/lazy","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/map","vs/base/common/numbers","vs/base/common/buffer","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(ne){for(var t=[],E=0,C=ne.length;E<C;E++)t[E]=$e[ne[E]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:zt,setPrototypeOf:Wt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Nt,construct:Ct}=typeof Reflect<"u"&&Reflect;Nt||(Nt=function(t,E,C){return t.apply(E,C)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Ct||(Ct=function(t,E){return new t(...E)});const oi=ut(Array.prototype.forEach),jt=ut(Array.prototype.pop),wt=ut(Array.prototype.push),Et=ut(String.prototype.toLowerCase),Pt=ut(String.prototype.toString),li=ut(String.prototype.match),dt=ut(String.prototype.replace),ai=ut(String.prototype.indexOf),hi=ut(String.prototype.trim),ht=ut(RegExp.prototype.test),vt=ui(TypeError);function ut(ne){return function(t){for(var E=arguments.length,C=new Array(E>1?E-1:0),n=1;n<E;n++)C[n-1]=arguments[n];return Nt(ne,t,C)}}function ui(ne){return function(){for(var t=arguments.length,E=new Array(t),C=0;C<t;C++)E[C]=arguments[C];return Ct(ne,E)}}function He(ne,t,E){var C;E=(C=E)!==null&&C!==void 0?C:Et,Wt&&Wt(ne,null);let n=t.length;for(;n--;){let H=t[n];if(typeof H=="string"){const D=E(H);D!==H&&(ii(t)||(t[n]=D),H=D)}ne[H]=!0}return ne}function bt(ne){const t=ri(null);for(const[E,C]of zt(ne))t[E]=C;return t}function At(ne,t){for(;ne!==null;){const C=si(ne,t);if(C){if(C.get)return ut(C.get);if(typeof C.value=="function")return ut(C.value)}ne=ni(ne)}function E(C){return console.warn("fallback value for",C),null}return E}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Rt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Lt=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),It=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ut=ot(["#text"]),qt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),Mt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Vt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),kt=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),_t=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Qt=ft(/^html$/i);var Kt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:_t,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Qt});const vi=()=>typeof window>"u"?null:window,yi=function(t,E){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const n="data-tt-policy-suffix";E&&E.hasAttribute(n)&&(C=E.getAttribute(n));const H="dompurify"+(C?"#"+C:"");try{return t.createPolicy(H,{createHTML(D){return D},createScriptURL(D){return D}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function xt(){let ne=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=ze=>xt(ze);if(t.version="3.0.5",t.removed=[],!ne||!ne.document||ne.document.nodeType!==9)return t.isSupported=!1,t;const E=ne.document,C=E.currentScript;let{document:n}=ne;const{DocumentFragment:H,HTMLTemplateElement:D,Node:k,Element:m,NodeFilter:p,NamedNodeMap:v=ne.NamedNodeMap||ne.MozNamedAttrMap,HTMLFormElement:M,DOMParser:l,trustedTypes:h}=ne,e=m.prototype,s=At(e,"cloneNode"),f=At(e,"nextSibling"),c=At(e,"childNodes"),a=At(e,"parentNode");if(typeof D=="function"){const ze=n.createElement("template");ze.content&&ze.content.ownerDocument&&(n=ze.content.ownerDocument)}let $,d="";const{implementation:b,createNodeIterator:u,createDocumentFragment:N,getElementsByTagName:B}=n,{importNode:R}=E;let W={};t.isSupported=typeof zt=="function"&&typeof a=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:z,ERB_EXPR:y,TMPLIT_EXPR:O,DATA_ATTR:U,ARIA_ATTR:S,IS_SCRIPT_OR_DATA:P,ATTR_WHITESPACE:L}=Kt;let{IS_ALLOWED_URI:G}=Kt,Z=null;const ge=He({},[...Ht,...Rt,...Lt,...It,...Ut]);let ue=null;const te=He({},[...qt,...Mt,...Vt,...kt]);let me=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),Re=null,Ne=null,Be=!0,re=!0,J=!1,ae=!0,se=!1,Y=!1,K=!1,ie=!1,fe=!1,De=!1,Te=!1,Se=!0,_=!1;const g="user-content-";let A=!0,F=!1,r={},i=null;const o=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let w=null;const I=He({},["audio","video","img","source","image","track"]);let T=null;const j=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),V="http://www.w3.org/1998/Math/MathML",X="http://www.w3.org/2000/svg",oe="http://www.w3.org/1999/xhtml";let be=oe,ye=!1,we=null;const Ee=He({},[V,X,oe],Pt);let ve;const Pe=["application/xhtml+xml","text/html"],Ie="text/html";let Me,Ze=null;const et=n.createElement("form"),xe=function(he){return he instanceof RegExp||he instanceof Function},x=function(he){if(!(Ze&&Ze===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),ve=Pe.indexOf(he.PARSER_MEDIA_TYPE)===-1?ve=Ie:ve=he.PARSER_MEDIA_TYPE,Me=ve==="application/xhtml+xml"?Pt:Et,Z="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Me):ge,ue="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Me):te,we="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Pt):Ee,T="ADD_URI_SAFE_ATTR"in he?He(bt(j),he.ADD_URI_SAFE_ATTR,Me):j,w="ADD_DATA_URI_TAGS"in he?He(bt(I),he.ADD_DATA_URI_TAGS,Me):I,i="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Me):o,Re="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Me):{},Ne="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Me):{},r="USE_PROFILES"in he?he.USE_PROFILES:!1,Be=he.ALLOW_ARIA_ATTR!==!1,re=he.ALLOW_DATA_ATTR!==!1,J=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ae=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,se=he.SAFE_FOR_TEMPLATES||!1,Y=he.WHOLE_DOCUMENT||!1,fe=he.RETURN_DOM||!1,De=he.RETURN_DOM_FRAGMENT||!1,Te=he.RETURN_TRUSTED_TYPE||!1,ie=he.FORCE_BODY||!1,Se=he.SANITIZE_DOM!==!1,_=he.SANITIZE_NAMED_PROPS||!1,A=he.KEEP_CONTENT!==!1,F=he.IN_PLACE||!1,G=he.ALLOWED_URI_REGEXP||_t,be=he.NAMESPACE||oe,me=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(me.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&xe(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(me.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(me.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),se&&(re=!1),De&&(fe=!0),r&&(Z=He({},[...Ut]),ue=[],r.html===!0&&(He(Z,Ht),He(ue,qt)),r.svg===!0&&(He(Z,Rt),He(ue,Mt),He(ue,kt)),r.svgFilters===!0&&(He(Z,Lt),He(ue,Mt),He(ue,kt)),r.mathMl===!0&&(He(Z,It),He(ue,Vt),He(ue,kt))),he.ADD_TAGS&&(Z===ge&&(Z=bt(Z)),He(Z,he.ADD_TAGS,Me)),he.ADD_ATTR&&(ue===te&&(ue=bt(ue)),He(ue,he.ADD_ATTR,Me)),he.ADD_URI_SAFE_ATTR&&He(T,he.ADD_URI_SAFE_ATTR,Me),he.FORBID_CONTENTS&&(i===o&&(i=bt(i)),He(i,he.FORBID_CONTENTS,Me)),A&&(Z["#text"]=!0),Y&&He(Z,["html","head","body"]),Z.table&&(He(Z,["tbody"]),delete Re.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');$=he.TRUSTED_TYPES_POLICY,d=$.createHTML("")}else $===void 0&&($=yi(h,C)),$!==null&&typeof d=="string"&&(d=$.createHTML(""));ot&&ot(he),Ze=he}},le=He({},["mi","mo","mn","ms","mtext"]),de=He({},["foreignobject","desc","title","annotation-xml"]),Ae=He({},["title","style","font","a","script"]),Ce=He({},Rt);He(Ce,Lt),He(Ce,ci);const je=He({},It);He(je,fi);const _e=function(he){let Fe=a(he);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:be,tagName:"template"});const Le=Et(he.tagName),qe=Et(Fe.tagName);return we[he.namespaceURI]?he.namespaceURI===X?Fe.namespaceURI===oe?Le==="svg":Fe.namespaceURI===V?Le==="svg"&&(qe==="annotation-xml"||le[qe]):!!Ce[Le]:he.namespaceURI===V?Fe.namespaceURI===oe?Le==="math":Fe.namespaceURI===X?Le==="math"&&de[qe]:!!je[Le]:he.namespaceURI===oe?Fe.namespaceURI===X&&!de[qe]||Fe.namespaceURI===V&&!le[qe]?!1:!je[Le]&&(Ae[Le]||!Ce[Le]):!!(ve==="application/xhtml+xml"&&we[he.namespaceURI]):!1},Ke=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},Je=function(he,Fe){try{wt(t.removed,{attribute:Fe.getAttributeNode(he),from:Fe})}catch{wt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(he),he==="is"&&!ue[he])if(fe||De)try{Ke(Fe)}catch{}else try{Fe.setAttribute(he,"")}catch{}},tt=function(he){let Fe,Le;if(ie)he="<remove></remove>"+he;else{const lt=li(he,/^[\r\n\t ]+/);Le=lt&&lt[0]}ve==="application/xhtml+xml"&&be===oe&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const qe=$?$.createHTML(he):he;if(be===oe)try{Fe=new l().parseFromString(qe,ve)}catch{}if(!Fe||!Fe.documentElement){Fe=b.createDocument(be,"template",null);try{Fe.documentElement.innerHTML=ye?d:qe}catch{}}const it=Fe.body||Fe.documentElement;return he&&Le&&it.insertBefore(n.createTextNode(Le),it.childNodes[0]||null),be===oe?B.call(Fe,Y?"html":"body")[0]:Y?Fe.documentElement:it},Xe=function(he){return u.call(he.ownerDocument||he,he,p.SHOW_ELEMENT|p.SHOW_COMMENT|p.SHOW_TEXT,null,!1)},nt=function(he){return he instanceof M&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof v)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},st=function(he){return typeof k=="object"?he instanceof k:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},rt=function(he,Fe,Le){W[he]&&oi(W[he],qe=>{qe.call(t,Fe,Le,Ze)})},gt=function(he){let Fe;if(rt("beforeSanitizeElements",he,null),nt(he))return Ke(he),!0;const Le=Me(he.nodeName);if(rt("uponSanitizeElement",he,{tagName:Le,allowedTags:Z}),he.hasChildNodes()&&!st(he.firstElementChild)&&(!st(he.content)||!st(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ke(he),!0;if(!Z[Le]||Re[Le]){if(!Re[Le]&&mt(Le)&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,Le)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Le)))return!1;if(A&&!i[Le]){const qe=a(he)||he.parentNode,it=c(he)||he.childNodes;if(it&&qe){const lt=it.length;for(let Ge=lt-1;Ge>=0;--Ge)qe.insertBefore(s(it[Ge],!0),f(he))}}return Ke(he),!0}return he instanceof m&&!_e(he)||(Le==="noscript"||Le==="noembed"||Le==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ke(he),!0):(se&&he.nodeType===3&&(Fe=he.textContent,Fe=dt(Fe,z," "),Fe=dt(Fe,y," "),Fe=dt(Fe,O," "),he.textContent!==Fe&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Fe)),rt("afterSanitizeElements",he,null),!1)},St=function(he,Fe,Le){if(Se&&(Fe==="id"||Fe==="name")&&(Le in n||Le in et))return!1;if(!(re&&!Ne[Fe]&&ht(U,Fe))){if(!(Be&&ht(S,Fe))){if(!ue[Fe]||Ne[Fe]){if(!(mt(he)&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,he)||me.tagNameCheck instanceof Function&&me.tagNameCheck(he))&&(me.attributeNameCheck instanceof RegExp&&ht(me.attributeNameCheck,Fe)||me.attributeNameCheck instanceof Function&&me.attributeNameCheck(Fe))||Fe==="is"&&me.allowCustomizedBuiltInElements&&(me.tagNameCheck instanceof RegExp&&ht(me.tagNameCheck,Le)||me.tagNameCheck instanceof Function&&me.tagNameCheck(Le))))return!1}else if(!T[Fe]){if(!ht(G,dt(Le,L,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&he!=="script"&&ai(Le,"data:")===0&&w[he])){if(!(J&&!ht(P,dt(Le,L,"")))){if(Le)return!1}}}}}}return!0},mt=function(he){return he.indexOf("-")>0},Ft=function(he){let Fe,Le,qe,it;rt("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Ge={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ue};for(it=lt.length;it--;){Fe=lt[it];const{name:ct,namespaceURI:$t}=Fe;if(Le=ct==="value"?Fe.value:hi(Fe.value),qe=Me(ct),Ge.attrName=qe,Ge.attrValue=Le,Ge.keepAttr=!0,Ge.forceKeepAttr=void 0,rt("uponSanitizeAttribute",he,Ge),Le=Ge.attrValue,Ge.forceKeepAttr||(Je(ct,he),!Ge.keepAttr))continue;if(!ae&&ht(/\/>/i,Le)){Je(ct,he);continue}se&&(Le=dt(Le,z," "),Le=dt(Le,y," "),Le=dt(Le,O," "));const yt=Me(he.nodeName);if(St(yt,qe,Le)){if(_&&(qe==="id"||qe==="name")&&(Je(ct,he),Le=g+Le),$&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!$t)switch(h.getAttributeType(yt,qe)){case"TrustedHTML":{Le=$.createHTML(Le);break}case"TrustedScriptURL":{Le=$.createScriptURL(Le);break}}try{$t?he.setAttributeNS($t,ct,Le):he.setAttribute(ct,Le),jt(t.removed)}catch{}}}rt("afterSanitizeAttributes",he,null)},Ot=function ze(he){let Fe;const Le=Xe(he);for(rt("beforeSanitizeShadowDOM",he,null);Fe=Le.nextNode();)rt("uponSanitizeShadowNode",Fe,null),!gt(Fe)&&(Fe.content instanceof H&&ze(Fe.content),Ft(Fe));rt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(ze){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Le,qe,it;if(ye=!ze,ye&&(ze="<!-->"),typeof ze!="string"&&!st(ze))if(typeof ze.toString=="function"){if(ze=ze.toString(),typeof ze!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return ze;if(K||x(he),t.removed=[],typeof ze=="string"&&(F=!1),F){if(ze.nodeName){const ct=Me(ze.nodeName);if(!Z[ct]||Re[ct])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(ze instanceof k)Fe=tt("<!---->"),Le=Fe.ownerDocument.importNode(ze,!0),Le.nodeType===1&&Le.nodeName==="BODY"||Le.nodeName==="HTML"?Fe=Le:Fe.appendChild(Le);else{if(!fe&&!se&&!Y&&ze.indexOf("<")===-1)return $&&Te?$.createHTML(ze):ze;if(Fe=tt(ze),!Fe)return fe?null:Te?d:""}Fe&&ie&&Ke(Fe.firstChild);const lt=Xe(F?ze:Fe);for(;qe=lt.nextNode();)gt(qe)||(qe.content instanceof H&&Ot(qe.content),Ft(qe));if(F)return ze;if(fe){if(De)for(it=N.call(Fe.ownerDocument);Fe.firstChild;)it.appendChild(Fe.firstChild);else it=Fe;return(ue.shadowroot||ue.shadowrootmode)&&(it=R.call(E,it,!0)),it}let Ge=Y?Fe.outerHTML:Fe.innerHTML;return Y&&Z["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Qt,Fe.ownerDocument.doctype.name)&&(Ge="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Ge),se&&(Ge=dt(Ge,z," "),Ge=dt(Ge,y," "),Ge=dt(Ge,O," ")),$&&Te?$.createHTML(Ge):Ge},t.setConfig=function(ze){x(ze),K=!0},t.clearConfig=function(){Ze=null,K=!1},t.isValidAttribute=function(ze,he,Fe){Ze||x({});const Le=Me(ze),qe=Me(he);return St(Le,qe,Fe)},t.addHook=function(ze,he){typeof he=="function"&&(W[ze]=W[ze]||[],wt(W[ze],he))},t.removeHook=function(ze){if(W[ze])return jt(W[ze])},t.removeHooks=function(ze){W[ze]&&(W[ze]=[])},t.removeAllHooks=function(){W={}},t}var Di=xt();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define($e[42],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zR=t.$yR=void 0;class E{constructor(D){this.domNode=D,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(D){const k=C(D);this.a!==k&&(this.a=k,this.domNode.style.maxWidth=this.a)}setWidth(D){const k=C(D);this.b!==k&&(this.b=k,this.domNode.style.width=this.b)}setHeight(D){const k=C(D);this.c!==k&&(this.c=k,this.domNode.style.height=this.c)}setTop(D){const k=C(D);this.d!==k&&(this.d=k,this.domNode.style.top=this.d)}setLeft(D){const k=C(D);this.e!==k&&(this.e=k,this.domNode.style.left=this.e)}setBottom(D){const k=C(D);this.f!==k&&(this.f=k,this.domNode.style.bottom=this.f)}setRight(D){const k=C(D);this.g!==k&&(this.g=k,this.domNode.style.right=this.g)}setPaddingTop(D){const k=C(D);this.h!==k&&(this.h=k,this.domNode.style.paddingTop=this.h)}setPaddingLeft(D){const k=C(D);this.i!==k&&(this.i=k,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(D){const k=C(D);this.j!==k&&(this.j=k,this.domNode.style.paddingBottom=this.j)}setPaddingRight(D){const k=C(D);this.k!==k&&(this.k=k,this.domNode.style.paddingRight=this.k)}setFontFamily(D){this.l!==D&&(this.l=D,this.domNode.style.fontFamily=this.l)}setFontWeight(D){this.m!==D&&(this.m=D,this.domNode.style.fontWeight=this.m)}setFontSize(D){const k=C(D);this.n!==k&&(this.n=k,this.domNode.style.fontSize=this.n)}setFontStyle(D){this.o!==D&&(this.o=D,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(D){this.p!==D&&(this.p=D,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(D){this.q!==D&&(this.q=D,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(D){this.r!==D&&(this.r=D,this.domNode.style.textDecoration=this.r)}setLineHeight(D){const k=C(D);this.s!==k&&(this.s=k,this.domNode.style.lineHeight=this.s)}setLetterSpacing(D){const k=C(D);this.t!==k&&(this.t=k,this.domNode.style.letterSpacing=this.t)}setClassName(D){this.u!==D&&(this.u=D,this.domNode.className=this.u)}toggleClassName(D,k){this.domNode.classList.toggle(D,k),this.u=this.domNode.className}setDisplay(D){this.v!==D&&(this.v=D,this.domNode.style.display=this.v)}setPosition(D){this.w!==D&&(this.w=D,this.domNode.style.position=this.w)}setVisibility(D){this.x!==D&&(this.x=D,this.domNode.style.visibility=this.x)}setColor(D){this.y!==D&&(this.y=D,this.domNode.style.color=this.y)}setBackgroundColor(D){this.z!==D&&(this.z=D,this.domNode.style.backgroundColor=this.z)}setLayerHinting(D){this.A!==D&&(this.A=D,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(D){this.C!==D&&(this.C=D,this.domNode.style.boxShadow=D)}setContain(D){this.B!==D&&(this.B=D,this.domNode.style.contain=this.B)}setAttribute(D,k){this.domNode.setAttribute(D,k)}removeAttribute(D){this.domNode.removeAttribute(D)}appendChild(D){this.domNode.appendChild(D.domNode)}removeChild(D){this.domNode.removeChild(D.domNode)}}t.$yR=E;function C(H){return typeof H=="number"?`${H}px`:H}function n(H){return new E(H)}t.$zR=n}),define($e[69],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QP=t.$PP=void 0;const E=new WeakMap;function C(k){if(!k.parent||k.parent===k)return null;try{const m=k.location,p=k.parent.location;if(m.origin!=="null"&&p.origin!=="null"&&m.origin!==p.origin)return null}catch{return null}return k.parent}class n{static a(m){let p=E.get(m);if(!p){p=[],E.set(m,p);let v=m,M;do M=C(v),M?p.push({window:new WeakRef(v),iframeElement:v.frameElement||null}):p.push({window:new WeakRef(v),iframeElement:null}),v=M;while(v)}return p.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(m,p){if(!p||m===p)return{top:0,left:0};let v=0,M=0;const l=this.a(m);for(const h of l){const e=h.window.deref();if(v+=e?.scrollY??0,M+=e?.scrollX??0,e===p||!h.iframeElement)break;const s=h.iframeElement.getBoundingClientRect();v+=s.top,M+=s.left}return{top:v,left:M}}}t.$PP=n;async function H(k,m){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const p=JSON.stringify({parentOrigin:k,salt:m}),M=new TextEncoder().encode(p),l=await crypto.subtle.digest("sha-256",M);return D(l)}t.$QP=H;function D(k){const p=Array.from(new Uint8Array(k)).map(v=>v.toString(16).padStart(2,"0")).join("");return BigInt(`0x${p}`).toString(32).padStart(52,"0")}}),define($e[70],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fS=t.$eS=t.$dS=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var E;(function(D){D[D.Copy=0]="Copy",D[D.Move=1]="Move"})(E||(t.ListDragOverEffectType=E={}));var C;(function(D){D.Over="drop-target",D.Before="drop-target-before",D.After="drop-target-after"})(C||(t.ListDragOverEffectPosition=C={})),t.$dS={reject(){return{accept:!1}},accept(){return{accept:!0}}};class n extends Error{constructor(k,m){super(`ListError [${k}] ${m}`)}}t.$eS=n;class H{constructor(){this.c=new WeakMap}getHeight(k){return this.c.get(k)??this.d(k)}setDynamicHeight(k,m){m>0&&this.c.set(k,m)}}t.$fS=H}),define($e[71],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6R=void 0;class E{constructor(n){this.a=n}splice(n,H,D){this.a.forEach(k=>k.splice(n,H,D))}}t.$6R=E}),define($e[43],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=void 0;const E=20;class C{constructor(H,D,k,m,p,v){this.a=Math.round(D),this.b=Math.round(k),this.c=Math.round(H),this.d=m,this.e=p,this.f=v,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const D=Math.round(H);return this.d!==D?(this.d=D,this.m(),!0):!1}setScrollSize(H){const D=Math.round(H);return this.e!==D?(this.e=D,this.m(),!0):!1}setScrollPosition(H){const D=Math.round(H);return this.f!==D?(this.f=D,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,D,k,m,p){const v=Math.max(0,k-H),M=Math.max(0,v-2*D),l=m>0&&m>k;if(!l)return{computedAvailableSize:Math.round(v),computedIsNeeded:l,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(E,Math.floor(k*M/m))),e=(M-h)/(m-k),s=p*e;return{computedAvailableSize:Math.round(v),computedIsNeeded:l,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(s)}}m(){const H=C.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const D=H-this.c-this.i/2;return Math.round(D/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const D=H-this.c;let k=this.f;return D<this.k?k-=this.d:k+=this.d,k}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const D=this.k+H;return Math.round(D/this.j)}}t.$ER=C}),define($e[26],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0T=t.$9T=t.$8T=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var E;(function(m){m[m.Hidden=0]="Hidden",m[m.Visible=1]="Visible",m[m.Recurse=2]="Recurse"})(E||(t.TreeVisibility=E={}));var C;(function(m){m[m.Expanded=0]="Expanded",m[m.Collapsed=1]="Collapsed",m[m.PreserveOrExpanded=2]="PreserveOrExpanded",m[m.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var n;(function(m){m[m.Unknown=0]="Unknown",m[m.Twistie=1]="Twistie",m[m.Element=2]="Element",m[m.Filter=3]="Filter"})(n||(t.TreeMouseEventTarget=n={}));var H;(function(m){m[m.Down=0]="Down",m[m.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$8T={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(m=!1){return{accept:!0,bubble:0,autoExpand:m}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(m=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:m}}};class D extends Error{constructor(p,v){super(`TreeError [${p}] ${v}`)}}t.$9T=D;class k{constructor(p){this.a=p,this.b=new WeakMap}map(p){let v=this.b.get(p);return v||(v=this.a(p),this.b.set(p,v)),v}}t.$0T=k}),define($e[21],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uP=t.$window=t.$sP=t.$rP=void 0;function E(n,H){const D=n;typeof D.vscodeWindowId!="number"&&Object.defineProperty(D,"vscodeWindowId",{get:()=>H})}t.$rP=E,t.$sP=window,t.$window=t.$sP;function C(n){return n===t.$sP?!1:typeof n?.vscodeWindowId=="number"}t.$uP=C}),define($e[72],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rb=t.$qb=t.$pb=t.$ob=t.$nb=t.$mb=t.$lb=t.$kb=t.$jb=t.$ib=t.$hb=t.$gb=t.$fb=void 0;function E(s,f,c){const a=C(s,f);if(a!==-1)return s[a]}t.$fb=E;function C(s,f,c=s.length-1){for(let a=c;a>=0;a--){const $=s[a];if(f($))return a}return-1}t.$gb=C;function n(s,f){const c=H(s,f);return c===-1?void 0:s[c]}t.$hb=n;function H(s,f,c=0,a=s.length){let $=c,d=a;for(;$<d;){const b=Math.floor(($+d)/2);f(s[b])?$=b+1:d=b}return $-1}t.$ib=H;function D(s,f){const c=k(s,f);return c===s.length?void 0:s[c]}t.$jb=D;function k(s,f,c=0,a=s.length){let $=c,d=a;for(;$<d;){const b=Math.floor(($+d)/2);f(s[b])?d=b:$=b+1}return $}t.$kb=k;function m(s,f,c=0,a=s.length){const $=k(s,f,c,a);return $===s.length?-1:$}t.$lb=m;class p{static{this.assertInvariants=!1}constructor(f){this.e=f,this.c=0}findLastMonotonous(f){if(p.assertInvariants){if(this.d){for(const a of this.e)if(this.d(a)&&!f(a))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=f}const c=H(this.e,f,this.c);return this.c=c+1,c===-1?void 0:this.e[c]}}t.$mb=p;function v(s,f){if(s.length===0)return;let c=s[0];for(let a=1;a<s.length;a++){const $=s[a];f($,c)>0&&(c=$)}return c}t.$nb=v;function M(s,f){if(s.length===0)return;let c=s[0];for(let a=1;a<s.length;a++){const $=s[a];f($,c)>=0&&(c=$)}return c}t.$ob=M;function l(s,f){return v(s,(c,a)=>-f(c,a))}t.$pb=l;function h(s,f){if(s.length===0)return-1;let c=0;for(let a=1;a<s.length;a++){const $=s[a];f($,s[c])>0&&(c=a)}return c}t.$qb=h;function e(s,f){for(const c of s){const a=f(c);if(a!==void 0)return a}}t.$rb=e}),define($e[73],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$N=t.$M=t.$L=t.$K=void 0;function E(D,k){const m=Object.create(null);for(const p of D){const v=k(p);let M=m[v];M||(M=m[v]=[]),M.push(p)}return m}t.$K=E;function C(D,k){const m=[],p=[];for(const v of D)k.has(v)||m.push(v);for(const v of k)D.has(v)||p.push(v);return{removed:m,added:p}}t.$L=C;function n(D,k){const m=[],p=[];for(const[v,M]of D)k.has(v)||m.push(M);for(const[v,M]of k)D.has(v)||p.push(M);return{removed:m,added:p}}t.$M=n;function H(D,k){const m=new Set;for(const p of k)D.has(p)&&m.add(p);return m}t.$N=H}),define($e[74],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ot=t.$nt=t.$mt=t.$lt=void 0;function E(k,m){const p=Math.pow(10,m);return Math.round(k*p)/p}class C{constructor(m,p,v,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,p))|0,this.b=Math.min(255,Math.max(0,v))|0,this.a=E(Math.max(Math.min(1,M),0),3)}static equals(m,p){return m.r===p.r&&m.g===p.g&&m.b===p.b&&m.a===p.a}}t.$lt=C;class n{constructor(m,p,v,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=E(Math.max(Math.min(1,p),0),3),this.l=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,M),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.l===p.l&&m.a===p.a}static fromRGBA(m){const p=m.r/255,v=m.g/255,M=m.b/255,l=m.a,h=Math.max(p,v,M),e=Math.min(p,v,M);let s=0,f=0;const c=(e+h)/2,a=h-e;if(a>0){switch(f=Math.min(c<=.5?a/(2*c):a/(2-2*c),1),h){case p:s=(v-M)/a+(v<M?6:0);break;case v:s=(M-p)/a+2;break;case M:s=(p-v)/a+4;break}s*=60,s=Math.round(s)}return new n(s,f,c,l)}static i(m,p,v){return v<0&&(v+=1),v>1&&(v-=1),v<1/6?m+(p-m)*6*v:v<1/2?p:v<2/3?m+(p-m)*(2/3-v)*6:m}static toRGBA(m){const p=m.h/360,{s:v,l:M,a:l}=m;let h,e,s;if(v===0)h=e=s=M;else{const f=M<.5?M*(1+v):M+v-M*v,c=2*M-f;h=n.i(c,f,p+1/3),e=n.i(c,f,p),s=n.i(c,f,p-1/3)}return new C(Math.round(h*255),Math.round(e*255),Math.round(s*255),l)}}t.$mt=n;class H{constructor(m,p,v,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=E(Math.max(Math.min(1,p),0),3),this.v=E(Math.max(Math.min(1,v),0),3),this.a=E(Math.max(Math.min(1,M),0),3)}static equals(m,p){return m.h===p.h&&m.s===p.s&&m.v===p.v&&m.a===p.a}static fromRGBA(m){const p=m.r/255,v=m.g/255,M=m.b/255,l=Math.max(p,v,M),h=Math.min(p,v,M),e=l-h,s=l===0?0:e/l;let f;return e===0?f=0:l===p?f=((v-M)/e%6+6)%6:l===v?f=(M-p)/e+2:f=(p-v)/e+4,new H(Math.round(f*60),s,l,m.a)}static toRGBA(m){const{h:p,s:v,v:M,a:l}=m,h=M*v,e=h*(1-Math.abs(p/60%2-1)),s=M-h;let[f,c,a]=[0,0,0];return p<60?(f=h,c=e):p<120?(f=e,c=h):p<180?(c=h,a=e):p<240?(c=e,a=h):p<300?(f=e,a=h):p<=360&&(f=h,a=e),f=Math.round((f+s)*255),c=Math.round((c+s)*255),a=Math.round((a+s)*255),new C(f,c,a,l)}}t.$nt=H;class D{static fromHex(m){return D.Format.CSS.parseHex(m)||D.red}static equals(m,p){return!m&&!p?!0:!m||!p?!1:m.equals(p)}get hsla(){return this.i?this.i:n.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(m){if(m)if(m instanceof C)this.rgba=m;else if(m instanceof n)this.i=m,this.rgba=n.toRGBA(m);else if(m instanceof H)this.j=m,this.rgba=H.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(m){return!!m&&C.equals(this.rgba,m.rgba)&&n.equals(this.hsla,m.hsla)&&H.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=D.k(this.rgba.r),p=D.k(this.rgba.g),v=D.k(this.rgba.b),M=.2126*m+.7152*p+.0722*v;return E(M,4)}static k(m){const p=m/255;return p<=.03928?p/12.92:Math.pow((p+.055)/1.055,2.4)}getContrastRatio(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p>v?(p+.05)/(v+.05):(v+.05)/(p+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p>v}isDarkerThan(m){const p=this.getRelativeLuminance(),v=m.getRelativeLuminance();return p<v}lighten(m){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new D(new n(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:p,g:v,b:M,a:l}=this.rgba;return new D(new C(p,v,M,l*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const p=m.rgba,v=this.rgba.a,M=p.a,l=v+M*(1-v);if(l<1e-6)return D.transparent;const h=this.rgba.r*v/l+p.r*M*(1-v)/l,e=this.rgba.g*v/l+p.g*M*(1-v)/l,s=this.rgba.b*v/l+p.b*M*(1-v)/l;return new D(new C(h,e,s,l))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:p,g:v,b:M,a:l}=this.rgba;return new D(new C(m.rgba.r-l*(m.rgba.r-p),m.rgba.g-l*(m.rgba.g-v),m.rgba.b-l*(m.rgba.b-M),1))}flatten(...m){const p=m.reduceRight((v,M)=>D.o(M,v));return D.o(this,p)}static o(m,p){const v=1-m.rgba.a;return new D(new C(v*p.rgba.r+m.rgba.a*m.rgba.r,v*p.rgba.g+m.rgba.a*m.rgba.g,v*p.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(m,p,v){if(m.isLighterThan(p))return m;v=v||.5;const M=m.getRelativeLuminance(),l=p.getRelativeLuminance();return v=v*(l-M)/l,m.lighten(v)}static getDarkerColor(m,p,v){if(m.isDarkerThan(p))return m;v=v||.5;const M=m.getRelativeLuminance(),l=p.getRelativeLuminance();return v=v*(M-l)/M,m.darken(v)}static{this.white=new D(new C(255,255,255,1))}static{this.black=new D(new C(0,0,0,1))}static{this.red=new D(new C(255,0,0,1))}static{this.blue=new D(new C(0,0,255,1))}static{this.green=new D(new C(0,255,0,1))}static{this.cyan=new D(new C(0,255,255,1))}static{this.lightgrey=new D(new C(211,211,211,1))}static{this.transparent=new D(new C(0,0,0,0))}}t.$ot=D,function(k){let m;(function(p){let v;(function(M){function l(u){return u.rgba.a===1?`rgb(${u.rgba.r}, ${u.rgba.g}, ${u.rgba.b})`:k.Format.CSS.formatRGBA(u)}M.formatRGB=l;function h(u){return`rgba(${u.rgba.r}, ${u.rgba.g}, ${u.rgba.b}, ${+u.rgba.a.toFixed(2)})`}M.formatRGBA=h;function e(u){return u.hsla.a===1?`hsl(${u.hsla.h}, ${(u.hsla.s*100).toFixed(2)}%, ${(u.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(u)}M.formatHSL=e;function s(u){return`hsla(${u.hsla.h}, ${(u.hsla.s*100).toFixed(2)}%, ${(u.hsla.l*100).toFixed(2)}%, ${u.hsla.a.toFixed(2)})`}M.formatHSLA=s;function f(u){const N=u.toString(16);return N.length!==2?"0"+N:N}function c(u){return`#${f(u.rgba.r)}${f(u.rgba.g)}${f(u.rgba.b)}`}M.formatHex=c;function a(u,N=!1){return N&&u.rgba.a===1?k.Format.CSS.formatHex(u):`#${f(u.rgba.r)}${f(u.rgba.g)}${f(u.rgba.b)}${f(Math.round(u.rgba.a*255))}`}M.formatHexA=a;function $(u){return u.isOpaque()?k.Format.CSS.formatHex(u):k.Format.CSS.formatRGBA(u)}M.format=$;function d(u){const N=u.length;if(N===0||u.charCodeAt(0)!==35)return null;if(N===7){const B=16*b(u.charCodeAt(1))+b(u.charCodeAt(2)),R=16*b(u.charCodeAt(3))+b(u.charCodeAt(4)),W=16*b(u.charCodeAt(5))+b(u.charCodeAt(6));return new k(new C(B,R,W,1))}if(N===9){const B=16*b(u.charCodeAt(1))+b(u.charCodeAt(2)),R=16*b(u.charCodeAt(3))+b(u.charCodeAt(4)),W=16*b(u.charCodeAt(5))+b(u.charCodeAt(6)),z=16*b(u.charCodeAt(7))+b(u.charCodeAt(8));return new k(new C(B,R,W,z/255))}if(N===4){const B=b(u.charCodeAt(1)),R=b(u.charCodeAt(2)),W=b(u.charCodeAt(3));return new k(new C(16*B+B,16*R+R,16*W+W))}if(N===5){const B=b(u.charCodeAt(1)),R=b(u.charCodeAt(2)),W=b(u.charCodeAt(3)),z=b(u.charCodeAt(4));return new k(new C(16*B+B,16*R+R,16*W+W,(16*z+z)/255))}return null}M.parseHex=d;function b(u){switch(u){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(v=p.CSS||(p.CSS={}))})(m=k.Format||(k.Format={}))}(D||(t.$ot=D={}))}),define($e[27],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bh=t.$Ah=t.$zh=void 0;function E(D){return(k,m,p)=>{let v=null,M=null;if(typeof p.value=="function"?(v="value",M=p.value):typeof p.get=="function"&&(v="get",M=p.get),!M)throw new Error("not supported");p[v]=D(M,m)}}function C(D,k,m){let p=null,v=null;if(typeof m.value=="function"?(p="value",v=m.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(p="get",v=m.get),!v)throw new Error("not supported");const M=`$memoize$${k}`;m[p]=function(...l){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,l)}),this[M]}}t.$zh=C;function n(D,k,m){return E((p,v)=>{const M=`$debounce$${v}`,l=`$debounce$result$${v}`;return function(...h){this[l]||(this[l]=m?m():void 0),clearTimeout(this[M]),k&&(this[l]=k(this[l],...h),h=[this[l]]),this[M]=setTimeout(()=>{p.apply(this,h),this[l]=m?m():void 0},D)}})}t.$Ah=n;function H(D,k,m){return E((p,v)=>{const M=`$throttle$timer$${v}`,l=`$throttle$result$${v}`,h=`$throttle$lastRun$${v}`,e=`$throttle$pending$${v}`;return function(...s){if(this[l]||(this[l]=m?m():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),k&&(this[l]=k(this[l],...s)),this[e])return;const f=this[h]+D;f<=Date.now()?(this[h]=Date.now(),p.apply(this,[this[l]]),this[l]=m?m():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),p.apply(this,[this[l]]),this[l]=m?m():void 0},f-Date.now()))}})}t.$Bh=H}),define($e[75],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zs=void 0;class E{constructor(n,H,D,k){this.originalStart=n,this.originalLength=H,this.modifiedStart=D,this.modifiedLength=k}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$Zs=E}),define($e[6],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$0=t.$9=t.$8=t.$7=t.$6=t.$5=t.$4=t.$3=t.$2=t.$1=t.$Z=t.setUnexpectedErrorHandler=t.$X=t.$W=void 0;class E{constructor(){this.b=[],this.a=function(u){setTimeout(()=>{throw u.stack?$.isErrorNoTelemetry(u)?new $(u.message+`

`+u.stack):new Error(u.message+`

`+u.stack):u},0)}}addListener(u){return this.b.push(u),()=>{this.d(u)}}c(u){this.b.forEach(N=>{N(u)})}d(u){this.b.splice(this.b.indexOf(u),1)}setUnexpectedErrorHandler(u){this.a=u}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(u){this.a(u),this.c(u)}onUnexpectedExternalError(u){this.a(u)}}t.$W=E,t.$X=new E;function C(b){t.$X.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=C;function n(b){if(!b||typeof b!="object")return!1;const u=b;return u.code==="EPIPE"&&u.syscall?.toUpperCase()==="WRITE"}t.$Z=n;function H(b){p(b)||t.$X.onUnexpectedError(b)}t.$1=H;function D(b){p(b)||t.$X.onUnexpectedExternalError(b)}t.$2=D;function k(b){if(b instanceof Error){const{name:u,message:N}=b,B=b.stacktrace||b.stack;return{$isError:!0,name:u,message:N,stack:B,noTelemetry:$.isErrorNoTelemetry(b)}}return b}t.$3=k;const m="Canceled";function p(b){return b instanceof v?!0:b instanceof Error&&b.name===m&&b.message===m}t.$4=p;class v extends Error{constructor(){super(m),this.name=this.message}}t.$5=v;function M(){const b=new Error(m);return b.name=b.message,b}t.$6=M;function l(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.$7=l;function h(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.$8=h;class e extends TypeError{constructor(u){super(u?`${u} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function s(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.$0=s;class f extends Error{constructor(u){super("NotImplemented"),u&&(this.message=u)}}t.$$=f;class c extends Error{constructor(u){super("NotSupported"),u&&(this.message=u)}}t.$_=c;class a extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=a;class $ extends Error{constructor(u){super(u),this.name="CodeExpectedError"}static fromError(u){if(u instanceof $)return u;const N=new $;return N.message=u.message,N.stack=u.stack,N}static isErrorNoTelemetry(u){return u.name==="CodeExpectedError"}}t.$bb=$;class d extends Error{constructor(u){super(u||"An unexpected bug occurred."),Object.setPrototypeOf(this,d.prototype)}}t.$cb=d}),define($e[12],pe([1,0,6,72]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ac=t.$_b=t.$$b=t.$0b=t.$9b=t.$8b=t.$7b=t.CompareResult=t.$6b=t.$5b=t.$4b=t.$3b=t.$2b=t.$1b=t.$Zb=t.$Yb=t.$Xb=t.$Wb=t.$Vb=t.$Ub=t.$Tb=t.$Sb=t.$Rb=t.$Qb=t.$Pb=t.$Ob=t.$Nb=t.$Mb=t.$Lb=t.$Kb=t.$Jb=t.$Ib=t.$Hb=t.$Gb=t.top=t.$Eb=t.$Db=t.$Cb=t.$Bb=t.$Ab=t.$zb=t.$yb=t.$xb=t.$wb=t.$vb=t.$ub=t.$tb=t.$sb=void 0;function n(_,g=0){return _[_.length-(1+g)]}t.$sb=n;function H(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}t.$tb=H;function D(_,g,A=(F,r)=>F===r){if(_===g)return!0;if(!_||!g||_.length!==g.length)return!1;for(let F=0,r=_.length;F<r;F++)if(!A(_[F],g[F]))return!1;return!0}t.$ub=D;function k(_,g){const A=_.length-1;g<A&&(_[g]=_[A]),_.pop()}t.$vb=k;function m(_,g,A){return p(_.length,F=>A(_[F],g))}t.$wb=m;function p(_,g){let A=0,F=_-1;for(;A<=F;){const r=(A+F)/2|0,i=g(r);if(i<0)A=r+1;else if(i>0)F=r-1;else return r}return-(A+1)}t.$xb=p;function v(_,g,A){if(_=_|0,_>=g.length)throw new TypeError("invalid index");const F=g[Math.floor(g.length*Math.random())],r=[],i=[],o=[];for(const w of g){const I=A(w,F);I<0?r.push(w):I>0?i.push(w):o.push(w)}return _<r.length?v(_,r,A):_<r.length+o.length?o[0]:v(_-(r.length+o.length),i,A)}t.$yb=v;function M(_,g){const A=[];let F;for(const r of _.slice(0).sort(g))!F||g(F[0],r)!==0?(F=[r],A.push(F)):F.push(r);return A}t.$zb=M;function*l(_,g){let A,F;for(const r of _)F!==void 0&&g(F,r)?A.push(r):(A&&(yield A),A=[r]),F=r;A&&(yield A)}t.$Ab=l;function h(_,g){for(let A=0;A<=_.length;A++)g(A===0?void 0:_[A-1],A===_.length?void 0:_[A])}t.$Bb=h;function e(_,g){for(let A=0;A<_.length;A++)g(A===0?void 0:_[A-1],_[A],A+1===_.length?void 0:_[A+1])}t.$Cb=e;function s(_,g,A){const F=[];function r(w,I,T){if(I===0&&T.length===0)return;const j=F[F.length-1];j&&j.start+j.deleteCount===w?(j.deleteCount+=I,j.toInsert.push(...T)):F.push({start:w,deleteCount:I,toInsert:T})}let i=0,o=0;for(;;){if(i===_.length){r(i,0,g.slice(o));break}if(o===g.length){r(i,_.length-i,[]);break}const w=_[i],I=g[o],T=A(w,I);T===0?(i+=1,o+=1):T<0?(r(i,1,[]),i+=1):T>0&&(r(i,0,[I]),o+=1)}return F}t.$Db=s;function f(_,g,A){const F=s(_,g,A),r=[],i=[];for(const o of F)r.push(..._.slice(o.start,o.start+o.deleteCount)),i.push(...o.toInsert);return{removed:r,added:i}}t.$Eb=f;function c(_,g,A){if(A===0)return[];const F=_.slice(0,A).sort(g);return $(_,g,F,A,_.length),F}t.top=c;function a(_,g,A,F,r){return A===0?Promise.resolve([]):new Promise((i,o)=>{(async()=>{const w=_.length,I=_.slice(0,A).sort(g);for(let T=A,j=Math.min(A+F,w);T<w;T=j,j=Math.min(j+F,w)){if(T>A&&await new Promise(V=>setTimeout(V)),r&&r.isCancellationRequested)throw new E.$5;$(_,g,I,T,j)}return I})().then(i,o)})}t.$Gb=a;function $(_,g,A,F,r){for(const i=A.length;F<r;F++){const o=_[F];if(g(o,A[i-1])<0){A.pop();const w=(0,C.$kb)(A,I=>g(o,I)<0);A.splice(w,0,o)}}}function d(_){return _.filter(g=>!!g)}t.$Hb=d;function b(_){let g=0;for(let A=0;A<_.length;A++)_[A]&&(_[g]=_[A],g+=1);_.length=g}t.$Ib=b;function u(_,g,A){_.splice(A,0,_.splice(g,1)[0])}t.$Jb=u;function N(_){return!Array.isArray(_)||_.length===0}t.$Kb=N;function B(_){return Array.isArray(_)&&_.length>0}t.$Lb=B;function R(_,g=A=>A){const A=new Set;return _.filter(F=>{const r=g(F);return A.has(r)?!1:(A.add(r),!0)})}t.$Mb=R;function W(_){const g=new Set;return A=>{const F=_(A);return g.has(F)?!1:(g.add(F),!0)}}t.$Nb=W;function z(_,g){return _.length>0?_[0]:g}t.$Ob=z;function y(_,g){return _.length>0?_[_.length-1]:g}t.$Pb=y;function O(_,g,A=(F,r)=>F===r){let F=0;for(let r=0,i=Math.min(_.length,g.length);r<i&&A(_[r],g[r]);r++)F++;return F}t.$Qb=O;function U(_){return[].concat(..._)}t.$Rb=U;function S(_,g){let A=typeof g=="number"?_:0;typeof g=="number"?A=_:(A=0,g=_);const F=[];if(A<=g)for(let r=A;r<g;r++)F.push(r);else for(let r=A;r>g;r--)F.push(r);return F}t.$Sb=S;function P(_,g,A){return _.reduce((F,r)=>(F[g(r)]=A?A(r):r,F),Object.create(null))}t.$Tb=P;function L(_,g){return _.push(g),()=>G(_,g)}t.$Ub=L;function G(_,g){const A=_.indexOf(g);if(A>-1)return _.splice(A,1),g}t.$Vb=G;function Z(_,g,A){const F=_.slice(0,g),r=_.slice(g);return F.concat(A,r)}t.$Wb=Z;function ge(_,g){let A;if(typeof g=="number"){let F=g;A=()=>{const r=Math.sin(F++)*179426549;return r-Math.floor(r)}}else A=Math.random;for(let F=_.length-1;F>0;F-=1){const r=Math.floor(A()*(F+1)),i=_[F];_[F]=_[r],_[r]=i}}t.$Xb=ge;function ue(_,g){const A=_.indexOf(g);A>-1&&(_.splice(A,1),_.unshift(g))}t.$Yb=ue;function te(_,g){const A=_.indexOf(g);A>-1&&(_.splice(A,1),_.push(g))}t.$Zb=te;function me(_,g){for(const A of g)_.push(A)}t.$1b=me;function Re(_,g){return Array.isArray(_)?_.map(g):g(_)}t.$2b=Re;function Ne(_){return Array.isArray(_)?_:[_]}t.$3b=Ne;function Be(_){return _[Math.floor(Math.random()*_.length)]}t.$4b=Be;function re(_,g,A){const F=ae(_,g),r=_.length,i=A.length;_.length=r+i;for(let o=r-1;o>=F;o--)_[o+i]=_[o];for(let o=0;o<i;o++)_[o+F]=A[o]}t.$5b=re;function J(_,g,A,F){const r=ae(_,g);let i=_.splice(r,A);return i===void 0&&(i=[]),re(_,r,F),i}t.$6b=J;function ae(_,g){return g<0?Math.max(g+_.length,0):Math.min(g,_.length)}var se;(function(_){function g(i){return i<0}_.isLessThan=g;function A(i){return i<=0}_.isLessThanOrEqual=A;function F(i){return i>0}_.isGreaterThan=F;function r(i){return i===0}_.isNeitherLessOrGreaterThan=r,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(se||(t.CompareResult=se={}));function Y(_,g){return(A,F)=>g(_(A),_(F))}t.$7b=Y;function K(..._){return(g,A)=>{for(const F of _){const r=F(g,A);if(!se.isNeitherLessOrGreaterThan(r))return r}return se.neitherLessOrGreaterThan}}t.$8b=K;const ie=(_,g)=>_-g;t.$9b=ie;const fe=(_,g)=>(0,t.$9b)(_?1:0,g?1:0);t.$0b=fe;function De(_){return(g,A)=>-_(g,A)}t.$$b=De;class Te{constructor(g){this.g=g,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(g){let A=this.c;for(;A<this.g.length&&g(this.g[A]);)A++;const F=A===this.c?null:this.g.slice(this.c,A);return this.c=A,F}takeFromEndWhile(g){let A=this.d;for(;A>=0&&g(this.g[A]);)A--;const F=A===this.d?null:this.g.slice(A+1,this.d+1);return this.d=A,F}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const g=this.g[this.c];return this.c++,g}removeLast(){const g=this.g[this.d];return this.d--,g}takeCount(g){const A=this.g.slice(this.c,this.c+g);return this.c+=g,A}}t.$_b=Te;class Se{static{this.empty=new Se(g=>{})}constructor(g){this.iterate=g}forEach(g){this.iterate(A=>(g(A),!0))}toArray(){const g=[];return this.iterate(A=>(g.push(A),!0)),g}filter(g){return new Se(A=>this.iterate(F=>g(F)?A(F):!0))}map(g){return new Se(A=>this.iterate(F=>A(g(F))))}some(g){let A=!1;return this.iterate(F=>(A=g(F),!A)),A}findFirst(g){let A;return this.iterate(F=>g(F)?(A=F,!1):!0),A}findLast(g){let A;return this.iterate(F=>(g(F)&&(A=F),!0)),A}findLastMaxBy(g){let A,F=!0;return this.iterate(r=>((F||se.isGreaterThan(g(r,A)))&&(F=!1,A=r),!0)),A}}t.$ac=Se}),define($e[76],pe([1,0,6]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0c=t.$9c=t.$8c=t.$7c=t.$6c=t.ok=void 0;function C(p,v){if(!p)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}t.ok=C;function n(p,v="Unreachable"){throw new Error(v)}t.$6c=n;function H(p){if(!p)throw new E.$cb("Assertion Failed")}t.$7c=H;function D(p){p||(0,E.$1)(new E.$cb("Assertion Failed"))}t.$8c=D;function k(p){if(!p()){debugger;p(),(0,E.$1)(new E.$cb("Assertion Failed"))}}t.$9c=k;function m(p,v){let M=0;for(;M<p.length-1;){const l=p[M],h=p[M+1];if(!v(l,h))return!1;M++}return!0}t.$0c=m}),define($e[44],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=void 0;function E(C,n){const H=this;let D=!1,k;return function(){if(D)return k;if(D=!0,n)try{k=C.apply(H,arguments)}finally{n()}else k=C.apply(H,arguments);return k}}t.$db=E}),define($e[77],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CN=t.$BN=void 0;class E{constructor(n){this.a=n,this.b=0}nextId(){return this.a+ ++this.b}}t.$BN=E,t.$CN=new E("id#")}),define($e[28],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(C){function n(u){return u&&typeof u=="object"&&typeof u[Symbol.iterator]=="function"}C.is=n;const H=Object.freeze([]);function D(){return H}C.empty=D;function*k(u){yield u}C.single=k;function m(u){return n(u)?u:k(u)}C.wrap=m;function p(u){return u||H}C.from=p;function*v(u){for(let N=u.length-1;N>=0;N--)yield u[N]}C.reverse=v;function M(u){return!u||u[Symbol.iterator]().next().done===!0}C.isEmpty=M;function l(u){return u[Symbol.iterator]().next().value}C.first=l;function h(u,N){for(const B of u)if(N(B))return!0;return!1}C.some=h;function e(u,N){for(const B of u)if(N(B))return B}C.find=e;function*s(u,N){for(const B of u)N(B)&&(yield B)}C.filter=s;function*f(u,N){let B=0;for(const R of u)yield N(R,B++)}C.map=f;function*c(...u){for(const N of u)yield*N}C.concat=c;function a(u,N,B){let R=B;for(const W of u)R=N(R,W);return R}C.reduce=a;function*$(u,N,B=u.length){for(N<0&&(N+=u.length),B<0?B+=u.length:B>u.length&&(B=u.length);N<B;N++)yield u[N]}C.slice=$;function d(u,N=Number.POSITIVE_INFINITY){const B=[];if(N===0)return[B,u];const R=u[Symbol.iterator]();for(let W=0;W<N;W++){const z=R.next();if(z.done)return[B,C.empty()];B.push(z.value)}return[B,{[Symbol.iterator](){return R}}]}C.consume=d;async function b(u){const N=[];for await(const B of u)N.push(B);return Promise.resolve(N)}C.asyncToArray=b})(E||(t.Iterable=E={}))}),define($e[45],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9q=t.KeyMod=t.KeyCodeUtils=t.$8q=t.$7q=t.$6q=t.$5q=t.$4q=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(E||(t.KeyCode=E={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class n{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(s,f){this._keyCodeToStr[s]=f,this._strToKeyCode[f.toLowerCase()]=s}keyCodeToStr(s){return this._keyCodeToStr[s]}strToKeyCode(s){return this._strToKeyCode[s.toLowerCase()]||0}}const H=new n,D=new n,k=new n;t.$4q=new Array(230),t.$5q={};const m=[],p=Object.create(null),v=Object.create(null);t.$6q={lowerCaseToEnum:e=>v[e]||0,toEnum:e=>p[e]||0,toString:e=>m[e]||"None"},t.$7q=[],t.$8q=[];for(let e=0;e<=193;e++)t.$7q[e]=-1;for(let e=0;e<=132;e++)t.$8q[e]=-1;(function(){const e="",s=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],f=[],c=[];for(const a of s){const[$,d,b,u,N,B,R,W,z]=a;if(c[d]||(c[d]=!0,m[d]=b,p[b]=d,v[b.toLowerCase()]=d,$&&(t.$7q[d]=u,u!==0&&u!==3&&u!==5&&u!==4&&u!==6&&u!==57&&(t.$8q[u]=d))),!f[u]){if(f[u]=!0,!N)throw new Error(`String representation missing for key code ${u} around scan code ${b}`);H.define(u,N),D.define(u,W||N),k.define(u,z||W||N)}B&&(t.$4q[B]=u),R&&(t.$5q[R]=u)}t.$8q[3]=46})();var M;(function(e){function s(b){return H.keyCodeToStr(b)}e.toString=s;function f(b){return H.strToKeyCode(b)}e.fromString=f;function c(b){return D.keyCodeToStr(b)}e.toUserSettingsUS=c;function a(b){return k.keyCodeToStr(b)}e.toUserSettingsGeneral=a;function $(b){return D.strToKeyCode(b)||k.strToKeyCode(b)}e.fromUserSettings=$;function d(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(b)}e.toElectronAccelerator=d})(M||(t.KeyCodeUtils=M={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l||(t.KeyMod=l={}));function h(e,s){const f=(s&65535)<<16>>>0;return(e|f)>>>0}t.$9q=h}),define($e[78],pe([1,0,6]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$dr=t.$cr=t.$br=t.$ar=t.$_q=t.$$q=t.$0q=void 0;var C;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(C||(C={}));function n(M,l){if(typeof M=="number"){if(M===0)return null;const h=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new m([H(h,l),H(e,l)]):new m([H(h,l)])}else{const h=[];for(let e=0;e<M.length;e++)h.push(H(M[e],l));return new m(h)}}t.$0q=n;function H(M,l){const h=!!(M&2048),e=!!(M&256),s=l===2?e:h,f=!!(M&1024),c=!!(M&512),a=l===2?h:e,$=M&255;return new D(s,f,c,a,$)}t.$$q=H;class D{constructor(l,h,e,s,f){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.keyCode=f}equals(l){return l instanceof D&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`K${l}${h}${e}${s}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new m([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$_q=D;class k{constructor(l,h,e,s,f){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.scanCode=f}equals(l){return l instanceof k&&this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}getHashCode(){const l=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",s=this.metaKey?"1":"0";return`S${l}${h}${e}${s}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$ar=k;class m{constructor(l){if(l.length===0)throw(0,E.$7)("chords");this.chords=l}getHashCode(){let l="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(l+=";"),l+=this.chords[h].getHashCode();return l}equals(l){if(l===null||this.chords.length!==l.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(l.chords[h]))return!1;return!0}}t.$br=m;class p{constructor(l,h,e,s,f,c){this.ctrlKey=l,this.shiftKey=h,this.altKey=e,this.metaKey=s,this.keyLabel=f,this.keyAriaLabel=c}}t.$cr=p;class v{}t.$dr=v}),define($e[23],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class E{constructor(n){this.d=n,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(n){this.c=n}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=E}),define($e[46],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4c=void 0;class E{static{this.Undefined=new E(void 0)}constructor(H){this.element=H,this.next=E.Undefined,this.prev=E.Undefined}}class C{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let H=this.a;for(;H!==E.Undefined;){const D=H.next;H.prev=E.Undefined,H.next=E.Undefined,H=D}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,D){const k=new E(H);if(this.a===E.Undefined)this.a=k,this.b=k;else if(D){const p=this.b;this.b=k,k.prev=p,p.next=k}else{const p=this.a;this.a=k,k.next=p,p.prev=k}this.c+=1;let m=!1;return()=>{m||(m=!0,this.e(k))}}shift(){if(this.a!==E.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==E.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==E.Undefined&&H.next!==E.Undefined){const D=H.prev;D.next=H.next,H.next.prev=D}else H.prev===E.Undefined&&H.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):H.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):H.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==E.Undefined;)yield H.element,H=H.next}}t.$4c=C}),define($e[32],pe([1,0]),function(ne,t){"use strict";var E,C,n;Object.defineProperty(t,"__esModule",{value:!0}),t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.$Cc=t.Touch=t.$Bc=t.$Ac=t.$zc=t.$yc=t.$xc=void 0;function H($,d,b){let u=$.get(d);return u===void 0&&(u=b,$.set(d,u)),u}t.$xc=H;function D($){const d=[];return $.forEach((b,u)=>{d.push(`${u} => ${b}`)}),`Map(${$.size}) {${d.join(", ")}}`}t.$yc=D;function k($){const d=[];return $.forEach(b=>{d.push(b)}),`Set(${$.size}) {${d.join(", ")}}`}t.$zc=k;class m{constructor(d,b){this.uri=d,this.value=b}}function p($){return Array.isArray($)}class v{static{this.c=d=>d.toString()}constructor(d,b){if(this[E]="ResourceMap",d instanceof v)this.d=new Map(d.d),this.e=b??v.c;else if(p(d)){this.d=new Map,this.e=b??v.c;for(const[u,N]of d)this.set(u,N)}else this.d=new Map,this.e=d??v.c}set(d,b){return this.d.set(this.e(d),new m(d,b)),this}get(d){return this.d.get(this.e(d))?.value}has(d){return this.d.has(this.e(d))}get size(){return this.d.size}clear(){this.d.clear()}delete(d){return this.d.delete(this.e(d))}forEach(d,b){typeof b<"u"&&(d=d.bind(b));for(const[u,N]of this.d)d(N.value,N.uri,this)}*values(){for(const d of this.d.values())yield d.value}*keys(){for(const d of this.d.values())yield d.uri}*entries(){for(const d of this.d.values())yield[d.uri,d.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,d]of this.d)yield[d.uri,d.value]}}t.$Ac=v;class M{constructor(d,b){this[C]="ResourceSet",!d||typeof d=="function"?this.c=new v(d):(this.c=new v(b),d.forEach(this.add,this))}get size(){return this.c.size}add(d){return this.c.set(d,d),this}clear(){this.c.clear()}delete(d){return this.c.delete(d)}forEach(d,b){this.c.forEach((u,N)=>d.call(b,N,N,this))}has(d){return this.c.has(d)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Bc=M;var l;(function($){$[$.None=0]="None",$[$.AsOld=1]="AsOld",$[$.AsNew=2]="AsNew"})(l||(t.Touch=l={}));class h{constructor(){this[n]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(d){return this.c.has(d)}get(d,b=0){const u=this.c.get(d);if(u)return b!==0&&this.l(u,b),u.value}set(d,b,u=0){let N=this.c.get(d);if(N)N.value=b,u!==0&&this.l(N,u);else{switch(N={key:d,value:b,next:void 0,previous:void 0},u){case 0:this.j(N);break;case 1:this.i(N);break;case 2:this.j(N);break;default:this.j(N);break}this.c.set(d,N),this.f++}return this}delete(d){return!!this.remove(d)}remove(d){const b=this.c.get(d);if(b)return this.c.delete(d),this.k(b),this.f--,b.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const d=this.d;return this.c.delete(d.key),this.k(d),this.f--,d.value}forEach(d,b){const u=this.g;let N=this.d;for(;N;){if(b?d.bind(b)(N.value,N.key,this):d(N.value,N.key,this),this.g!==u)throw new Error("LinkedMap got modified during iteration.");N=N.next}}keys(){const d=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(d.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:u.key,done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}values(){const d=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(d.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:u.value,done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}entries(){const d=this,b=this.g;let u=this.d;const N={[Symbol.iterator](){return N},next(){if(d.g!==b)throw new Error("LinkedMap got modified during iteration.");if(u){const B={value:[u.key,u.value],done:!1};return u=u.next,B}else return{value:void 0,done:!0}}};return N}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(d){if(d>=this.size)return;if(d===0){this.clear();return}let b=this.d,u=this.size;for(;b&&u>d;)this.c.delete(b.key),b=b.next,u--;this.d=b,this.f=u,b&&(b.previous=void 0),this.g++}i(d){if(!this.d&&!this.e)this.e=d;else if(this.d)d.next=this.d,this.d.previous=d;else throw new Error("Invalid list");this.d=d,this.g++}j(d){if(!this.d&&!this.e)this.d=d;else if(this.e)d.previous=this.e,this.e.next=d;else throw new Error("Invalid list");this.e=d,this.g++}k(d){if(d===this.d&&d===this.e)this.d=void 0,this.e=void 0;else if(d===this.d){if(!d.next)throw new Error("Invalid list");d.next.previous=void 0,this.d=d.next}else if(d===this.e){if(!d.previous)throw new Error("Invalid list");d.previous.next=void 0,this.e=d.previous}else{const b=d.next,u=d.previous;if(!b||!u)throw new Error("Invalid list");b.previous=u,u.next=b}d.next=void 0,d.previous=void 0,this.g++}l(d,b){if(!this.d||!this.e)throw new Error("Invalid list");if(!(b!==1&&b!==2)){if(b===1){if(d===this.d)return;const u=d.next,N=d.previous;d===this.e?(N.next=void 0,this.e=N):(u.previous=N,N.next=u),d.previous=void 0,d.next=this.d,this.d.previous=d,this.d=d,this.g++}else if(b===2){if(d===this.e)return;const u=d.next,N=d.previous;d===this.d?(u.previous=void 0,this.d=u):(u.previous=N,N.next=u),d.next=void 0,d.previous=this.e,this.e.next=d,this.e=d,this.g++}}}toJSON(){const d=[];return this.forEach((b,u)=>{d.push([u,b])}),d}fromJSON(d){this.clear();for(const[b,u]of d)this.set(b,u)}}t.$Cc=h;class e extends h{constructor(d,b=1){super(),this.m=d,this.n=Math.min(Math.max(0,b),1)}get limit(){return this.m}set limit(d){this.m=d,this.o()}get ratio(){return this.n}set ratio(d){this.n=Math.min(Math.max(0,d),1),this.o()}get(d,b=2){return super.get(d,b)}peek(d){return super.get(d,0)}set(d,b){return super.set(d,b,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}t.$Dc=e;class s{constructor(){this.c=new Map}add(d){return this.c.set(d,(this.c.get(d)||0)+1),this}delete(d){let b=this.c.get(d)||0;return b===0?!1:(b--,b===0?this.c.delete(d):this.c.set(d,b),!0)}has(d){return this.c.has(d)}}t.$Ec=s;class f{constructor(d){if(this.c=new Map,this.d=new Map,d)for(const[b,u]of d)this.set(b,u)}clear(){this.c.clear(),this.d.clear()}set(d,b){this.c.set(d,b),this.d.set(b,d)}get(d){return this.c.get(d)}getKey(d){return this.d.get(d)}delete(d){const b=this.c.get(d);return b===void 0?!1:(this.c.delete(d),this.d.delete(b),!0)}forEach(d,b){this.c.forEach((u,N)=>{d.call(b,u,N,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Fc=f;class c{constructor(){this.c=new Map}add(d,b){let u=this.c.get(d);u||(u=new Set,this.c.set(d,u)),u.add(b)}delete(d,b){const u=this.c.get(d);u&&(u.delete(b),u.size===0&&this.c.delete(d))}forEach(d,b){const u=this.c.get(d);u&&u.forEach(b)}get(d){const b=this.c.get(d);return b||new Set}}t.$Gc=c;function a($,d){if($===d)return!0;if($.size!==d.size)return!1;for(const[b,u]of $)if(!d.has(b)||d.get(b)!==u)return!1;for(const[b]of d)if(!$.has(b))return!1;return!0}t.$Hc=a}),define($e[3],pe([1,0,12,73,32,44,28]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Tc=t.$Sc=t.$Rc=t.$Qc=t.$Pc=t.$Oc=t.$Nc=t.$Mc=t.$Lc=t.$Kc=t.$Jc=t.$Ic=void 0;const k=!1;let m=null;class p{constructor(){this.b=new Map}static{this.a=0}c(L){let G=this.b.get(L);return G||(G={parent:null,source:null,isSingleton:!1,value:L,idx:p.a++},this.b.set(L,G)),G}trackDisposable(L){const G=this.c(L);G.source||(G.source=new Error().stack)}setParent(L,G){const Z=this.c(L);Z.parent=G}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,G){const Z=G.get(L);if(Z)return Z;const ge=L.parent?this.f(this.c(L.parent),G):L;return G.set(L,ge),ge}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,Z])=>Z.source!==null&&!this.f(Z,L).isSingleton).flatMap(([Z])=>Z)}computeLeakingDisposables(L=10,G){let Z;if(G)Z=G;else{const Re=new Map,Ne=[...this.b.values()].filter(re=>re.source!==null&&!this.f(re,Re).isSingleton);if(Ne.length===0)return;const Be=new Set(Ne.map(re=>re.value));if(Z=Ne.filter(re=>!(re.parent&&Be.has(re.parent))),Z.length===0)throw new Error("There are cyclic diposable chains!")}if(!Z)return;function ge(Re){function Ne(re,J){for(;re.length>0&&J.some(ae=>typeof ae=="string"?ae===re[0]:re[0].match(ae));)re.shift()}const Be=Re.source.split(`
`).map(re=>re.trim().replace("at ","")).filter(re=>re!=="");return Ne(Be,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Be.reverse()}const ue=new n.$Gc;for(const Re of Z){const Ne=ge(Re);for(let Be=0;Be<=Ne.length;Be++)ue.add(Ne.slice(0,Be).join(`
`),Re)}Z.sort((0,E.$7b)(Re=>Re.idx,E.$9b));let te="",me=0;for(const Re of Z.slice(0,L)){me++;const Ne=ge(Re),Be=[];for(let re=0;re<Ne.length;re++){let J=Ne[re];J=`(shared with ${ue.get(Ne.slice(0,re+1).join(`
`)).size}/${Z.length} leaks) at ${J}`;const se=ue.get(Ne.slice(0,re).join(`
`)),Y=(0,C.$K)([...se].map(K=>ge(K)[re]),K=>K);delete Y[Ne[re]];for(const[K,ie]of Object.entries(Y))Be.unshift(`    - stacktraces of ${ie.length} other leaks continue with ${K}`);Be.unshift(J)}te+=`


==================== Leaking disposable ${me}/${Z.length}: ${Re.value.constructor.name} ====================
${Be.join(`
`)}
============================================================

`}return Z.length>L&&(te+=`


... and ${Z.length-L} more leaking disposables

`),{leaks:Z,details:te}}}t.$Ic=p;function v(P){m=P}if(t.$Jc=v,k){const P="__is_disposable_tracked__";v(new class{trackDisposable(L){const G=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[P]||console.log(G)},3e3)}setParent(L,G){if(L&&L!==u.None)try{L[P]=!0}catch{}}markAsDisposed(L){if(L&&L!==u.None)try{L[P]=!0}catch{}}markAsSingleton(L){}})}function M(P){return m?.trackDisposable(P),P}t.$Kc=M;function l(P){m?.markAsDisposed(P)}t.$Lc=l;function h(P,L){m?.setParent(P,L)}function e(P,L){if(m)for(const G of P)m.setParent(G,L)}function s(P){return m?.markAsSingleton(P),P}t.$Mc=s;function f(P){return typeof P.dispose=="function"&&P.dispose.length===0}t.$Nc=f;function c(P){if(D.Iterable.is(P)){const L=[];for(const G of P)if(G)try{G.dispose()}catch(Z){L.push(Z)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(P)?[]:P}else if(P)return P.dispose(),P}t.$Oc=c;function a(P){for(const L of P)f(L)&&L.dispose();return[]}t.$Pc=a;function $(...P){const L=d(()=>c(P));return e(P,L),L}t.$Qc=$;function d(P){const L=M({dispose:(0,H.$db)(()=>{l(L),P()})});return L}t.$Rc=d;class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,M(this)}dispose(){this.g||(l(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{c(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return h(L,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),h(L,null))}}t.$Sc=b;class u{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,M(this),h(this.q,this)}dispose(){l(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}t.$Tc=u;class N{constructor(){this.b=!1,M(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&h(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,l(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&h(L,null),L}}t.$Uc=N;class B{constructor(L){this.a=new N,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}t.$Vc=B;class R{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Wc=R;class W{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,M(this)}set(L){let G=L;return this.unset=()=>G=void 0,this.isset=()=>G!==void 0,this.dispose=()=>{G&&(G(),G=void 0,l(this))},this}}t.$Xc=W;class z{constructor(){this.a=new Map}acquire(L,...G){let Z=this.a.get(L);Z||(Z={counter:0,object:this.b(L,...G)},this.a.set(L,Z));const{object:ge}=Z,ue=(0,H.$db)(()=>{--Z.counter===0&&(this.c(L,Z.object),this.a.delete(L))});return Z.counter++,{object:ge,dispose:ue}}}t.$Yc=z;class y{constructor(L){this.a=L}async acquire(L,...G){const Z=this.a.acquire(L,...G);try{return{object:await Z.object,dispose:()=>Z.dispose()}}catch(ge){throw Z.dispose(),ge}}}t.$Zc=y;class O{constructor(L){this.object=L}dispose(){}}t.$1c=O;function U(P){const L=new b;try{P(L)}finally{L.dispose()}}t.$2c=U;class S{constructor(){this.a=new Map,this.b=!1,M(this)}dispose(){l(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{c(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,G,Z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),Z||this.a.get(L)?.dispose(),this.a.set(L,G)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$3c=S}),function(ne,t){typeof define=="function"&&define.amd?define($e[79],pe([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(ne=typeof globalThis<"u"?globalThis:ne||self,t(ne.marked={}))}(this,function(ne){"use strict";function t(g,A){for(var F=0;F<A.length;F++){var r=A[F];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(g,r.key,r)}}function E(g,A,F){return A&&t(g.prototype,A),F&&t(g,F),Object.defineProperty(g,"prototype",{writable:!1}),g}function C(g,A){if(g){if(typeof g=="string")return n(g,A);var F=Object.prototype.toString.call(g).slice(8,-1);if(F==="Object"&&g.constructor&&(F=g.constructor.name),F==="Map"||F==="Set")return Array.from(g);if(F==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(F))return n(g,A)}}function n(g,A){(A==null||A>g.length)&&(A=g.length);for(var F=0,r=new Array(A);F<A;F++)r[F]=g[F];return r}function H(g,A){var F=typeof Symbol<"u"&&g[Symbol.iterator]||g["@@iterator"];if(F)return(F=F.call(g)).next.bind(F);if(Array.isArray(g)||(F=C(g))||A&&g&&typeof g.length=="number"){F&&(g=F);var r=0;return function(){return r>=g.length?{done:!0}:{done:!1,value:g[r++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ne.defaults=D();function k(g){ne.defaults=g}var m=/[&<>"']/,p=/[&<>"']/g,v=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(A){return l[A]};function e(g,A){if(A){if(m.test(g))return g.replace(p,h)}else if(v.test(g))return g.replace(M,h);return g}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(g){return g.replace(s,function(A,F){return F=F.toLowerCase(),F==="colon"?":":F.charAt(0)==="#"?F.charAt(1)==="x"?String.fromCharCode(parseInt(F.substring(2),16)):String.fromCharCode(+F.substring(1)):""})}var c=/(^|[^\[])\^/g;function a(g,A){g=typeof g=="string"?g:g.source,A=A||"";var F={replace:function(i,o){return o=o.source||o,o=o.replace(c,"$1"),g=g.replace(i,o),F},getRegex:function(){return new RegExp(g,A)}};return F}var $=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(g,A,F){if(g){var r;try{r=decodeURIComponent(f(F)).replace($,"").toLowerCase()}catch{return null}if(r.indexOf("javascript:")===0||r.indexOf("vbscript:")===0||r.indexOf("data:")===0)return null}A&&!d.test(F)&&(F=W(A,F));try{F=encodeURI(F).replace(/%25/g,"%")}catch{return null}return F}var u={},N=/^[^:]+:\/*[^/]*$/,B=/^([^:]+:)[\s\S]*$/,R=/^([^:]+:\/*[^/]*)[\s\S]*$/;function W(g,A){u[" "+g]||(N.test(g)?u[" "+g]=g+"/":u[" "+g]=U(g,"/",!0)),g=u[" "+g];var F=g.indexOf(":")===-1;return A.substring(0,2)==="//"?F?A:g.replace(B,"$1")+A:A.charAt(0)==="/"?F?A:g.replace(R,"$1")+A:g+A}var z={exec:function(){}};function y(g){for(var A=1,F,r;A<arguments.length;A++){F=arguments[A];for(r in F)Object.prototype.hasOwnProperty.call(F,r)&&(g[r]=F[r])}return g}function O(g,A){var F=g.replace(/\|/g,function(o,w,I){for(var T=!1,j=w;--j>=0&&I[j]==="\\";)T=!T;return T?"|":" |"}),r=F.split(/ \|/),i=0;if(r[0].trim()||r.shift(),r.length>0&&!r[r.length-1].trim()&&r.pop(),r.length>A)r.splice(A);else for(;r.length<A;)r.push("");for(;i<r.length;i++)r[i]=r[i].trim().replace(/\\\|/g,"|");return r}function U(g,A,F){var r=g.length;if(r===0)return"";for(var i=0;i<r;){var o=g.charAt(r-i-1);if(o===A&&!F)i++;else if(o!==A&&F)i++;else break}return g.slice(0,r-i)}function S(g,A){if(g.indexOf(A[1])===-1)return-1;for(var F=g.length,r=0,i=0;i<F;i++)if(g[i]==="\\")i++;else if(g[i]===A[0])r++;else if(g[i]===A[1]&&(r--,r<0))return i;return-1}function P(g){g&&g.sanitize&&!g.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(g,A){if(A<1)return"";for(var F="";A>1;)A&1&&(F+=g),A>>=1,g+=g;return F+g}function G(g,A,F,r){var i=A.href,o=A.title?e(A.title):null,w=g[1].replace(/\\([\[\]])/g,"$1");if(g[0].charAt(0)!=="!"){r.state.inLink=!0;var I={type:"link",raw:F,href:i,title:o,text:w,tokens:r.inlineTokens(w)};return r.state.inLink=!1,I}return{type:"image",raw:F,href:i,title:o,text:e(w)}}function Z(g,A){var F=g.match(/^(\s+)(?:```)/);if(F===null)return A;var r=F[1];return A.split(`
`).map(function(i){var o=i.match(/^\s+/);if(o===null)return i;var w=o[0];return w.length>=r.length?i.slice(r.length):i}).join(`
`)}var ge=function(){function g(F){this.options=F||ne.defaults}var A=g.prototype;return A.space=function(r){var i=this.rules.block.newline.exec(r);if(i&&i[0].length>0)return{type:"space",raw:i[0]}},A.code=function(r){var i=this.rules.block.code.exec(r);if(i){var o=i[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:i[0],codeBlockStyle:"indented",text:this.options.pedantic?o:U(o,`
`)}}},A.fences=function(r){var i=this.rules.block.fences.exec(r);if(i){var o=i[0],w=Z(o,i[3]||"");return{type:"code",raw:o,lang:i[2]?i[2].trim():i[2],text:w}}},A.heading=function(r){var i=this.rules.block.heading.exec(r);if(i){var o=i[2].trim();if(/#$/.test(o)){var w=U(o,"#");(this.options.pedantic||!w||/ $/.test(w))&&(o=w.trim())}return{type:"heading",raw:i[0],depth:i[1].length,text:o,tokens:this.lexer.inline(o)}}},A.hr=function(r){var i=this.rules.block.hr.exec(r);if(i)return{type:"hr",raw:i[0]}},A.blockquote=function(r){var i=this.rules.block.blockquote.exec(r);if(i){var o=i[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:i[0],tokens:this.lexer.blockTokens(o,[]),text:o}}},A.list=function(r){var i=this.rules.block.list.exec(r);if(i){var o,w,I,T,j,V,X,oe,be,ye,we,Ee,ve=i[1].trim(),Pe=ve.length>1,Ie={type:"list",raw:"",ordered:Pe,start:Pe?+ve.slice(0,-1):"",loose:!1,items:[]};ve=Pe?"\\d{1,9}\\"+ve.slice(-1):"\\"+ve,this.options.pedantic&&(ve=Pe?ve:"[*+-]");for(var Me=new RegExp("^( {0,3}"+ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");r&&(Ee=!1,!(!(i=Me.exec(r))||this.rules.block.hr.test(r)));){if(o=i[0],r=r.substring(o.length),oe=i[2].split(`
`,1)[0],be=r.split(`
`,1)[0],this.options.pedantic?(T=2,we=oe.trimLeft()):(T=i[2].search(/[^ ]/),T=T>4?1:T,we=oe.slice(T),T+=i[1].length),V=!1,!oe&&/^ *$/.test(be)&&(o+=be+`
`,r=r.substring(be.length+1),Ee=!0),!Ee)for(var Ze=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,T-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),xe=new RegExp("^ {0,"+Math.min(3,T-1)+"}(?:```|~~~)"),x=new RegExp("^ {0,"+Math.min(3,T-1)+"}#");r&&(ye=r.split(`
`,1)[0],oe=ye,this.options.pedantic&&(oe=oe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(xe.test(oe)||x.test(oe)||Ze.test(oe)||et.test(r)));){if(oe.search(/[^ ]/)>=T||!oe.trim())we+=`
`+oe.slice(T);else if(!V)we+=`
`+oe;else break;!V&&!oe.trim()&&(V=!0),o+=ye+`
`,r=r.substring(ye.length+1)}Ie.loose||(X?Ie.loose=!0:/\n *\n *$/.test(o)&&(X=!0)),this.options.gfm&&(w=/^\[[ xX]\] /.exec(we),w&&(I=w[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:o,task:!!w,checked:I,loose:!1,text:we}),Ie.raw+=o}Ie.items[Ie.items.length-1].raw=o.trimRight(),Ie.items[Ie.items.length-1].text=we.trimRight(),Ie.raw=Ie.raw.trimRight();var le=Ie.items.length;for(j=0;j<le;j++){this.lexer.state.top=!1,Ie.items[j].tokens=this.lexer.blockTokens(Ie.items[j].text,[]);var de=Ie.items[j].tokens.filter(function(Ce){return Ce.type==="space"}),Ae=de.every(function(Ce){for(var je=Ce.raw.split(""),_e=0,Ke=H(je),Je;!(Je=Ke()).done;){var tt=Je.value;if(tt===`
`&&(_e+=1),_e>1)return!0}return!1});!Ie.loose&&de.length&&Ae&&(Ie.loose=!0,Ie.items[j].loose=!0)}return Ie}},A.html=function(r){var i=this.rules.block.html.exec(r);if(i){var o={type:"html",raw:i[0],pre:!this.options.sanitizer&&(i[1]==="pre"||i[1]==="script"||i[1]==="style"),text:i[0]};if(this.options.sanitize){var w=this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]);o.type="paragraph",o.text=w,o.tokens=this.lexer.inline(w)}return o}},A.def=function(r){var i=this.rules.block.def.exec(r);if(i){i[3]&&(i[3]=i[3].substring(1,i[3].length-1));var o=i[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:o,raw:i[0],href:i[2],title:i[3]}}},A.table=function(r){var i=this.rules.block.table.exec(r);if(i){var o={type:"table",header:O(i[1]).map(function(X){return{text:X}}),align:i[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:i[3]&&i[3].trim()?i[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(o.header.length===o.align.length){o.raw=i[0];var w=o.align.length,I,T,j,V;for(I=0;I<w;I++)/^ *-+: *$/.test(o.align[I])?o.align[I]="right":/^ *:-+: *$/.test(o.align[I])?o.align[I]="center":/^ *:-+ *$/.test(o.align[I])?o.align[I]="left":o.align[I]=null;for(w=o.rows.length,I=0;I<w;I++)o.rows[I]=O(o.rows[I],o.header.length).map(function(X){return{text:X}});for(w=o.header.length,T=0;T<w;T++)o.header[T].tokens=this.lexer.inline(o.header[T].text);for(w=o.rows.length,T=0;T<w;T++)for(V=o.rows[T],j=0;j<V.length;j++)V[j].tokens=this.lexer.inline(V[j].text);return o}}},A.lheading=function(r){var i=this.rules.block.lheading.exec(r);if(i)return{type:"heading",raw:i[0],depth:i[2].charAt(0)==="="?1:2,text:i[1],tokens:this.lexer.inline(i[1])}},A.paragraph=function(r){var i=this.rules.block.paragraph.exec(r);if(i){var o=i[1].charAt(i[1].length-1)===`
`?i[1].slice(0,-1):i[1];return{type:"paragraph",raw:i[0],text:o,tokens:this.lexer.inline(o)}}},A.text=function(r){var i=this.rules.block.text.exec(r);if(i)return{type:"text",raw:i[0],text:i[0],tokens:this.lexer.inline(i[0])}},A.escape=function(r){var i=this.rules.inline.escape.exec(r);if(i)return{type:"escape",raw:i[0],text:e(i[1])}},A.tag=function(r){var i=this.rules.inline.tag.exec(r);if(i)return!this.lexer.state.inLink&&/^<a /i.test(i[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(i[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(i[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(i[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:i[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(i[0]):e(i[0]):i[0]}},A.link=function(r){var i=this.rules.inline.link.exec(r);if(i){var o=i[2].trim();if(!this.options.pedantic&&/^</.test(o)){if(!/>$/.test(o))return;var w=U(o.slice(0,-1),"\\");if((o.length-w.length)%2===0)return}else{var I=S(i[2],"()");if(I>-1){var T=i[0].indexOf("!")===0?5:4,j=T+i[1].length+I;i[2]=i[2].substring(0,I),i[0]=i[0].substring(0,j).trim(),i[3]=""}}var V=i[2],X="";if(this.options.pedantic){var oe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(V);oe&&(V=oe[1],X=oe[3])}else X=i[3]?i[3].slice(1,-1):"";return V=V.trim(),/^</.test(V)&&(this.options.pedantic&&!/>$/.test(o)?V=V.slice(1):V=V.slice(1,-1)),G(i,{href:V&&V.replace(this.rules.inline._escapes,"$1"),title:X&&X.replace(this.rules.inline._escapes,"$1")},i[0],this.lexer)}},A.reflink=function(r,i){var o;if((o=this.rules.inline.reflink.exec(r))||(o=this.rules.inline.nolink.exec(r))){var w=(o[2]||o[1]).replace(/\s+/g," ");if(w=i[w.toLowerCase()],!w||!w.href){var I=o[0].charAt(0);return{type:"text",raw:I,text:I}}return G(o,w,o[0],this.lexer)}},A.emStrong=function(r,i,o){o===void 0&&(o="");var w=this.rules.inline.emStrong.lDelim.exec(r);if(w&&!(w[3]&&o.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var I=w[1]||w[2]||"";if(!I||I&&(o===""||this.rules.inline.punctuation.exec(o))){var T=w[0].length-1,j,V,X=T,oe=0,be=w[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,i=i.slice(-1*r.length+T);(w=be.exec(i))!=null;)if(j=w[1]||w[2]||w[3]||w[4]||w[5]||w[6],!!j){if(V=j.length,w[3]||w[4]){X+=V;continue}else if((w[5]||w[6])&&T%3&&!((T+V)%3)){oe+=V;continue}if(X-=V,!(X>0)){if(V=Math.min(V,V+X+oe),Math.min(T,V)%2){var ye=r.slice(1,T+w.index+V);return{type:"em",raw:r.slice(0,T+w.index+V+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}var we=r.slice(2,T+w.index+V-1);return{type:"strong",raw:r.slice(0,T+w.index+V+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},A.codespan=function(r){var i=this.rules.inline.code.exec(r);if(i){var o=i[2].replace(/\n/g," "),w=/[^ ]/.test(o),I=/^ /.test(o)&&/ $/.test(o);return w&&I&&(o=o.substring(1,o.length-1)),o=e(o,!0),{type:"codespan",raw:i[0],text:o}}},A.br=function(r){var i=this.rules.inline.br.exec(r);if(i)return{type:"br",raw:i[0]}},A.del=function(r){var i=this.rules.inline.del.exec(r);if(i)return{type:"del",raw:i[0],text:i[2],tokens:this.lexer.inlineTokens(i[2])}},A.autolink=function(r,i){var o=this.rules.inline.autolink.exec(r);if(o){var w,I;return o[2]==="@"?(w=e(this.options.mangle?i(o[1]):o[1]),I="mailto:"+w):(w=e(o[1]),I=w),{type:"link",raw:o[0],text:w,href:I,tokens:[{type:"text",raw:w,text:w}]}}},A.url=function(r,i){var o;if(o=this.rules.inline.url.exec(r)){var w,I;if(o[2]==="@")w=e(this.options.mangle?i(o[0]):o[0]),I="mailto:"+w;else{var T;do T=o[0],o[0]=this.rules.inline._backpedal.exec(o[0])[0];while(T!==o[0]);w=e(o[0]),o[1]==="www."?I="http://"+w:I=w}return{type:"link",raw:o[0],text:w,href:I,tokens:[{type:"text",raw:w,text:w}]}}},A.inlineText=function(r,i){var o=this.rules.inline.text.exec(r);if(o){var w;return this.lexer.state.inRawBlock?w=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(o[0]):e(o[0]):o[0]:w=e(this.options.smartypants?i(o[0]):o[0]),{type:"text",raw:o[0],text:w}}},g}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:z,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=a(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=a(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=a(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=a(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=a(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=a(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=y({},ue),ue.gfm=y({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=a(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=a(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=y({},ue.normal,{html:a(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:z,paragraph:a(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var te={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:z,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:z,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};te._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",te.punctuation=a(te.punctuation).replace(/punctuation/g,te._punctuation).getRegex(),te.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,te.escapedEmSt=/\\\*|\\_/g,te._comment=a(ue._comment).replace("(?:-->|$)","-->").getRegex(),te.emStrong.lDelim=a(te.emStrong.lDelim).replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimAst=a(te.emStrong.rDelimAst,"g").replace(/punct/g,te._punctuation).getRegex(),te.emStrong.rDelimUnd=a(te.emStrong.rDelimUnd,"g").replace(/punct/g,te._punctuation).getRegex(),te._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,te._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,te._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,te.autolink=a(te.autolink).replace("scheme",te._scheme).replace("email",te._email).getRegex(),te._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,te.tag=a(te.tag).replace("comment",te._comment).replace("attribute",te._attribute).getRegex(),te._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,te._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,te._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,te.link=a(te.link).replace("label",te._label).replace("href",te._href).replace("title",te._title).getRegex(),te.reflink=a(te.reflink).replace("label",te._label).replace("ref",ue._label).getRegex(),te.nolink=a(te.nolink).replace("ref",ue._label).getRegex(),te.reflinkSearch=a(te.reflinkSearch,"g").replace("reflink",te.reflink).replace("nolink",te.nolink).getRegex(),te.normal=y({},te),te.pedantic=y({},te.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:a(/^!?\[(label)\]\((.*?)\)/).replace("label",te._label).getRegex(),reflink:a(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",te._label).getRegex()}),te.gfm=y({},te.normal,{escape:a(te.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),te.gfm.url=a(te.gfm.url,"i").replace("email",te.gfm._extended_email).getRegex(),te.breaks=y({},te.gfm,{br:a(te.br).replace("{2,}","*").getRegex(),text:a(te.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function me(g){return g.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Re(g){var A="",F,r,i=g.length;for(F=0;F<i;F++)r=g.charCodeAt(F),Math.random()>.5&&(r="x"+r.toString(16)),A+="&#"+r+";";return A}var Ne=function(){function g(F){this.tokens=[],this.tokens.links=Object.create(null),this.options=F||ne.defaults,this.options.tokenizer=this.options.tokenizer||new ge,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var r={block:ue.normal,inline:te.normal};this.options.pedantic?(r.block=ue.pedantic,r.inline=te.pedantic):this.options.gfm&&(r.block=ue.gfm,this.options.breaks?r.inline=te.breaks:r.inline=te.gfm),this.tokenizer.rules=r}g.lex=function(r,i){var o=new g(i);return o.lex(r)},g.lexInline=function(r,i){var o=new g(i);return o.inlineTokens(r)};var A=g.prototype;return A.lex=function(r){r=r.replace(/\r\n|\r/g,`
`),this.blockTokens(r,this.tokens);for(var i;i=this.inlineQueue.shift();)this.inlineTokens(i.src,i.tokens);return this.tokens},A.blockTokens=function(r,i){var o=this;i===void 0&&(i=[]),this.options.pedantic?r=r.replace(/\t/g,"    ").replace(/^ +$/gm,""):r=r.replace(/^( *)(\t+)/gm,function(X,oe,be){return oe+"    ".repeat(be.length)});for(var w,I,T,j;r;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(X){return(w=X.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.space(r)){r=r.substring(w.raw.length),w.raw.length===1&&i.length>0?i[i.length-1].raw+=`
`:i.push(w);continue}if(w=this.tokenizer.code(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(w);continue}if(w=this.tokenizer.fences(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.heading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.hr(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.blockquote(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.list(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.html(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.def(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&(I.type==="paragraph"||I.type==="text")?(I.raw+=`
`+w.raw,I.text+=`
`+w.raw,this.inlineQueue[this.inlineQueue.length-1].src=I.text):this.tokens.links[w.tag]||(this.tokens.links[w.tag]={href:w.href,title:w.title});continue}if(w=this.tokenizer.table(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.lheading(r)){r=r.substring(w.raw.length),i.push(w);continue}if(T=r,this.options.extensions&&this.options.extensions.startBlock&&function(){var X=1/0,oe=r.slice(1),be=void 0;o.options.extensions.startBlock.forEach(function(ye){be=ye.call({lexer:this},oe),typeof be=="number"&&be>=0&&(X=Math.min(X,be))}),X<1/0&&X>=0&&(T=r.substring(0,X+1))}(),this.state.top&&(w=this.tokenizer.paragraph(T))){I=i[i.length-1],j&&I.type==="paragraph"?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(w),j=T.length!==r.length,r=r.substring(w.raw.length);continue}if(w=this.tokenizer.text(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&I.type==="text"?(I.raw+=`
`+w.raw,I.text+=`
`+w.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=I.text):i.push(w);continue}if(r){var V="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(V);break}else throw new Error(V)}}return this.state.top=!0,i},A.inline=function(r,i){return i===void 0&&(i=[]),this.inlineQueue.push({src:r,tokens:i}),i},A.inlineTokens=function(r,i){var o=this;i===void 0&&(i=[]);var w,I,T,j=r,V,X,oe;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(V=this.tokenizer.rules.inline.reflinkSearch.exec(j))!=null;)be.includes(V[0].slice(V[0].lastIndexOf("[")+1,-1))&&(j=j.slice(0,V.index)+"["+L("a",V[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(V=this.tokenizer.rules.inline.blockSkip.exec(j))!=null;)j=j.slice(0,V.index)+"["+L("a",V[0].length-2)+"]"+j.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(V=this.tokenizer.rules.inline.escapedEmSt.exec(j))!=null;)j=j.slice(0,V.index)+"++"+j.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;r;)if(X||(oe=""),X=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(w=we.call({lexer:o},r,i))?(r=r.substring(w.raw.length),i.push(w),!0):!1}))){if(w=this.tokenizer.escape(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.tag(r)){r=r.substring(w.raw.length),I=i[i.length-1],I&&w.type==="text"&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):i.push(w);continue}if(w=this.tokenizer.link(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.reflink(r,this.tokens.links)){r=r.substring(w.raw.length),I=i[i.length-1],I&&w.type==="text"&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):i.push(w);continue}if(w=this.tokenizer.emStrong(r,j,oe)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.codespan(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.br(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.del(r)){r=r.substring(w.raw.length),i.push(w);continue}if(w=this.tokenizer.autolink(r,Re)){r=r.substring(w.raw.length),i.push(w);continue}if(!this.state.inLink&&(w=this.tokenizer.url(r,Re))){r=r.substring(w.raw.length),i.push(w);continue}if(T=r,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Ee=r.slice(1),ve=void 0;o.options.extensions.startInline.forEach(function(Pe){ve=Pe.call({lexer:this},Ee),typeof ve=="number"&&ve>=0&&(we=Math.min(we,ve))}),we<1/0&&we>=0&&(T=r.substring(0,we+1))}(),w=this.tokenizer.inlineText(T,me)){r=r.substring(w.raw.length),w.raw.slice(-1)!=="_"&&(oe=w.raw.slice(-1)),X=!0,I=i[i.length-1],I&&I.type==="text"?(I.raw+=w.raw,I.text+=w.text):i.push(w);continue}if(r){var ye="Infinite loop on byte: "+r.charCodeAt(0);if(this.options.silent){console.error(ye);break}else throw new Error(ye)}}return i},E(g,null,[{key:"rules",get:function(){return{block:ue,inline:te}}}]),g}(),Be=function(){function g(F){this.options=F||ne.defaults}var A=g.prototype;return A.code=function(r,i,o){var w=(i||"").match(/\S*/)[0];if(this.options.highlight){var I=this.options.highlight(r,w);I!=null&&I!==r&&(o=!0,r=I)}return r=r.replace(/\n$/,"")+`
`,w?'<pre><code class="'+this.options.langPrefix+e(w,!0)+'">'+(o?r:e(r,!0))+`</code></pre>
`:"<pre><code>"+(o?r:e(r,!0))+`</code></pre>
`},A.blockquote=function(r){return`<blockquote>
`+r+`</blockquote>
`},A.html=function(r){return r},A.heading=function(r,i,o,w){if(this.options.headerIds){var I=this.options.headerPrefix+w.slug(o);return"<h"+i+' id="'+I+'">'+r+"</h"+i+`>
`}return"<h"+i+">"+r+"</h"+i+`>
`},A.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},A.list=function(r,i,o){var w=i?"ol":"ul",I=i&&o!==1?' start="'+o+'"':"";return"<"+w+I+`>
`+r+"</"+w+`>
`},A.listitem=function(r){return"<li>"+r+`</li>
`},A.checkbox=function(r){return"<input "+(r?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},A.paragraph=function(r){return"<p>"+r+`</p>
`},A.table=function(r,i){return i&&(i="<tbody>"+i+"</tbody>"),`<table>
<thead>
`+r+`</thead>
`+i+`</table>
`},A.tablerow=function(r){return`<tr>
`+r+`</tr>
`},A.tablecell=function(r,i){var o=i.header?"th":"td",w=i.align?"<"+o+' align="'+i.align+'">':"<"+o+">";return w+r+("</"+o+`>
`)},A.strong=function(r){return"<strong>"+r+"</strong>"},A.em=function(r){return"<em>"+r+"</em>"},A.codespan=function(r){return"<code>"+r+"</code>"},A.br=function(){return this.options.xhtml?"<br/>":"<br>"},A.del=function(r){return"<del>"+r+"</del>"},A.link=function(r,i,o){if(r=b(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<a href="'+e(r)+'"';return i&&(w+=' title="'+i+'"'),w+=">"+o+"</a>",w},A.image=function(r,i,o){if(r=b(this.options.sanitize,this.options.baseUrl,r),r===null)return o;var w='<img src="'+r+'" alt="'+o+'"';return i&&(w+=' title="'+i+'"'),w+=this.options.xhtml?"/>":">",w},A.text=function(r){return r},g}(),re=function(){function g(){}var A=g.prototype;return A.strong=function(r){return r},A.em=function(r){return r},A.codespan=function(r){return r},A.del=function(r){return r},A.html=function(r){return r},A.text=function(r){return r},A.link=function(r,i,o){return""+o},A.image=function(r,i,o){return""+o},A.br=function(){return""},g}(),J=function(){function g(){this.seen={}}var A=g.prototype;return A.serialize=function(r){return r.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},A.getNextSafeSlug=function(r,i){var o=r,w=0;if(this.seen.hasOwnProperty(o)){w=this.seen[r];do w++,o=r+"-"+w;while(this.seen.hasOwnProperty(o))}return i||(this.seen[r]=w,this.seen[o]=0),o},A.slug=function(r,i){i===void 0&&(i={});var o=this.serialize(r);return this.getNextSafeSlug(o,i.dryrun)},g}(),ae=function(){function g(F){this.options=F||ne.defaults,this.options.renderer=this.options.renderer||new Be,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new re,this.slugger=new J}g.parse=function(r,i){var o=new g(i);return o.parse(r)},g.parseInline=function(r,i){var o=new g(i);return o.parseInline(r)};var A=g.prototype;return A.parse=function(r,i){i===void 0&&(i=!0);var o="",w,I,T,j,V,X,oe,be,ye,we,Ee,ve,Pe,Ie,Me,Ze,et,xe,x,le=r.length;for(w=0;w<le;w++){if(we=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(x=this.options.extensions.renderers[we.type].call({parser:this},we),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){o+=x||"";continue}switch(we.type){case"space":continue;case"hr":{o+=this.renderer.hr();continue}case"heading":{o+=this.renderer.heading(this.parseInline(we.tokens),we.depth,f(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{o+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(be="",oe="",j=we.header.length,I=0;I<j;I++)oe+=this.renderer.tablecell(this.parseInline(we.header[I].tokens),{header:!0,align:we.align[I]});for(be+=this.renderer.tablerow(oe),ye="",j=we.rows.length,I=0;I<j;I++){for(X=we.rows[I],oe="",V=X.length,T=0;T<V;T++)oe+=this.renderer.tablecell(this.parseInline(X[T].tokens),{header:!1,align:we.align[T]});ye+=this.renderer.tablerow(oe)}o+=this.renderer.table(be,ye);continue}case"blockquote":{ye=this.parse(we.tokens),o+=this.renderer.blockquote(ye);continue}case"list":{for(Ee=we.ordered,ve=we.start,Pe=we.loose,j=we.items.length,ye="",I=0;I<j;I++)Me=we.items[I],Ze=Me.checked,et=Me.task,Ie="",Me.task&&(xe=this.renderer.checkbox(Ze),Pe?Me.tokens.length>0&&Me.tokens[0].type==="paragraph"?(Me.tokens[0].text=xe+" "+Me.tokens[0].text,Me.tokens[0].tokens&&Me.tokens[0].tokens.length>0&&Me.tokens[0].tokens[0].type==="text"&&(Me.tokens[0].tokens[0].text=xe+" "+Me.tokens[0].tokens[0].text)):Me.tokens.unshift({type:"text",text:xe}):Ie+=xe),Ie+=this.parse(Me.tokens,Pe),ye+=this.renderer.listitem(Ie,et,Ze);o+=this.renderer.list(ye,Ee,ve);continue}case"html":{o+=this.renderer.html(we.text);continue}case"paragraph":{o+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(ye=we.tokens?this.parseInline(we.tokens):we.text;w+1<le&&r[w+1].type==="text";)we=r[++w],ye+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);o+=i?this.renderer.paragraph(ye):ye;continue}default:{var de='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return o},A.parseInline=function(r,i){i=i||this.renderer;var o="",w,I,T,j=r.length;for(w=0;w<j;w++){if(I=r[w],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[I.type]&&(T=this.options.extensions.renderers[I.type].call({parser:this},I),T!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(I.type))){o+=T||"";continue}switch(I.type){case"escape":{o+=i.text(I.text);break}case"html":{o+=i.html(I.text);break}case"link":{o+=i.link(I.href,I.title,this.parseInline(I.tokens,i));break}case"image":{o+=i.image(I.href,I.title,I.text);break}case"strong":{o+=i.strong(this.parseInline(I.tokens,i));break}case"em":{o+=i.em(this.parseInline(I.tokens,i));break}case"codespan":{o+=i.codespan(I.text);break}case"br":{o+=i.br();break}case"del":{o+=i.del(this.parseInline(I.tokens,i));break}case"text":{o+=i.text(I.text);break}default:{var V='Token with "'+I.type+'" type was not found.';if(this.options.silent){console.error(V);return}else throw new Error(V)}}}return o},g}();function se(g,A,F){if(typeof g>"u"||g===null)throw new Error("marked(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");if(typeof A=="function"&&(F=A,A=null),A=y({},se.defaults,A||{}),P(A),F){var r=A.highlight,i;try{i=Ne.lex(g,A)}catch(j){return F(j)}var o=function(V){var X;if(!V)try{A.walkTokens&&se.walkTokens(i,A.walkTokens),X=ae.parse(i,A)}catch(oe){V=oe}return A.highlight=r,V?F(V):F(null,X)};if(!r||r.length<3||(delete A.highlight,!i.length))return o();var w=0;se.walkTokens(i,function(j){j.type==="code"&&(w++,setTimeout(function(){r(j.text,j.lang,function(V,X){if(V)return o(V);X!=null&&X!==j.text&&(j.text=X,j.escaped=!0),w--,w===0&&o()})},0))}),w===0&&o();return}function I(j){if(j.message+=`
Please report this to https://github.com/markedjs/marked.`,A.silent)return"<p>An error occurred:</p><pre>"+e(j.message+"",!0)+"</pre>";throw j}try{var T=Ne.lex(g,A);if(A.walkTokens){if(A.async)return Promise.all(se.walkTokens(T,A.walkTokens)).then(function(){return ae.parse(T,A)}).catch(I);se.walkTokens(T,A.walkTokens)}return ae.parse(T,A)}catch(j){I(j)}}se.options=se.setOptions=function(g){return y(se.defaults,g),k(se.defaults),se},se.getDefaults=D,se.defaults=ne.defaults,se.use=function(){for(var g=arguments.length,A=new Array(g),F=0;F<g;F++)A[F]=arguments[F];var r=y.apply(void 0,[{}].concat(A)),i=se.defaults.extensions||{renderers:{},childTokens:{}},o;A.forEach(function(w){if(w.extensions&&(o=!0,w.extensions.forEach(function(T){if(!T.name)throw new Error("extension name required");if(T.renderer){var j=i.renderers?i.renderers[T.name]:null;j?i.renderers[T.name]=function(){for(var V=arguments.length,X=new Array(V),oe=0;oe<V;oe++)X[oe]=arguments[oe];var be=T.renderer.apply(this,X);return be===!1&&(be=j.apply(this,X)),be}:i.renderers[T.name]=T.renderer}if(T.tokenizer){if(!T.level||T.level!=="block"&&T.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");i[T.level]?i[T.level].unshift(T.tokenizer):i[T.level]=[T.tokenizer],T.start&&(T.level==="block"?i.startBlock?i.startBlock.push(T.start):i.startBlock=[T.start]:T.level==="inline"&&(i.startInline?i.startInline.push(T.start):i.startInline=[T.start]))}T.childTokens&&(i.childTokens[T.name]=T.childTokens)})),w.renderer&&function(){var T=se.defaults.renderer||new Be,j=function(oe){var be=T[oe];T[oe]=function(){for(var ye=arguments.length,we=new Array(ye),Ee=0;Ee<ye;Ee++)we[Ee]=arguments[Ee];var ve=w.renderer[oe].apply(T,we);return ve===!1&&(ve=be.apply(T,we)),ve}};for(var V in w.renderer)j(V);r.renderer=T}(),w.tokenizer&&function(){var T=se.defaults.tokenizer||new ge,j=function(oe){var be=T[oe];T[oe]=function(){for(var ye=arguments.length,we=new Array(ye),Ee=0;Ee<ye;Ee++)we[Ee]=arguments[Ee];var ve=w.tokenizer[oe].apply(T,we);return ve===!1&&(ve=be.apply(T,we)),ve}};for(var V in w.tokenizer)j(V);r.tokenizer=T}(),w.walkTokens){var I=se.defaults.walkTokens;r.walkTokens=function(T){var j=[];return j.push(w.walkTokens.call(this,T)),I&&(j=j.concat(I.call(this,T))),j}}o&&(r.extensions=i),se.setOptions(r)})},se.walkTokens=function(g,A){for(var F=[],r=function(){var I=o.value;switch(F=F.concat(A.call(se,I)),I.type){case"table":{for(var T=H(I.header),j;!(j=T()).done;){var V=j.value;F=F.concat(se.walkTokens(V.tokens,A))}for(var X=H(I.rows),oe;!(oe=X()).done;)for(var be=oe.value,ye=H(be),we;!(we=ye()).done;){var Ee=we.value;F=F.concat(se.walkTokens(Ee.tokens,A))}break}case"list":{F=F.concat(se.walkTokens(I.items,A));break}default:se.defaults.extensions&&se.defaults.extensions.childTokens&&se.defaults.extensions.childTokens[I.type]?se.defaults.extensions.childTokens[I.type].forEach(function(ve){F=F.concat(se.walkTokens(I[ve],A))}):I.tokens&&(F=F.concat(se.walkTokens(I.tokens,A)))}},i=H(g),o;!(o=i()).done;)r();return F},se.parseInline=function(g,A){if(typeof g>"u"||g===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof g!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(g)+", string expected");A=y({},se.defaults,A||{}),P(A);try{var F=Ne.lexInline(g,A);return A.walkTokens&&se.walkTokens(F,A.walkTokens),ae.parseInline(F,A)}catch(r){if(r.message+=`
Please report this to https://github.com/markedjs/marked.`,A.silent)return"<p>An error occurred:</p><pre>"+e(r.message+"",!0)+"</pre>";throw r}},se.Parser=ae,se.parser=ae.parse,se.Renderer=Be,se.TextRenderer=re,se.Lexer=Ne,se.lexer=Ne.lex,se.Tokenizer=ge,se.Slugger=J,se.parse=se;var Y=se.options,K=se.setOptions,ie=se.use,fe=se.walkTokens,De=se.parseInline,Te=se,Se=ae.parse,_=Ne.lex;ne.Lexer=Ne,ne.Parser=ae,ne.Renderer=Be,ne.Slugger=J,ne.TextRenderer=re,ne.Tokenizer=ge,ne.getDefaults=D,ne.lexer=_,ne.marked=se,ne.options=Y,ne.parse=Te,ne.parseInline=De,ne.parser=Se,ne.setOptions=K,ne.use=ie,ne.walkTokens=fe,Object.defineProperty(ne,"__esModule",{value:!0})}),define($e[80],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Tj=void 0;function E(s){const f=H(s);if(f&&f.length>0)return new Uint32Array(f)}t.$Tj=E;let C=0;const n=new Uint32Array(10);function H(s){if(C=0,D(s,M,4352),C>0||(D(s,l,4449),C>0)||(D(s,h,4520),C>0)||(D(s,e,12593),C))return n.subarray(0,C);if(s>=44032&&s<=55203){const f=s-44032,c=f%588,a=Math.floor(f/588),$=Math.floor(c/28),d=c%28-1;if(a<M.length?D(a,M,0):4352+a-12593<e.length&&D(4352+a,e,12593),$<l.length?D($,l,0):4449+$-12593<e.length&&D(4449+$-12593,e,12593),d>=0&&(d<h.length?D(d,h,0):4520+d-12593<e.length&&D(4520+d-12593,e,12593)),C>0)return n.subarray(0,C)}}function D(s,f,c){s>=c&&s<c+f.length&&k(f[s-c])}function k(s){s!==0&&(n[C++]=s&255,s>>8&&(n[C++]=s>>8&255),s>>16&&(n[C++]=s>>16&255))}var m;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var p;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(p||(p={}));var v;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(v||(v={}));const M=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define($e[81],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;class E{constructor(n,H=0,D=n.length,k=H-1){this.a=n,this.b=H,this.c=D,this.d=k}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$oT=E}),define($e[82],pe([1,0,81]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qT=t.$pT=void 0;class C{constructor(D=[],k=10){this.h(D),this.b=k,this.d()}getHistory(){return this.j}add(D){this.a.delete(D),this.a.add(D),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(D){return this.a.has(D)}clear(){this.h([]),this.d()}d(){this.f();const D=this.j;this.c=new E.$oT(D,0,D.length,D.length)}f(){const D=this.j;D.length>this.b&&this.h(D.slice(D.length-this.b))}g(){const D=this.c.current();return D?this.j.indexOf(D):-1}h(D){this.a=new Set;for(const k of D)this.a.add(k)}get j(){const D=[];return this.a.forEach(k=>D.push(k)),D}}t.$pT=C;class n{get size(){return this.f}constructor(D,k=10){if(this.g=k,D.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:D[0],previous:void 0,next:void 0},this.a=new Set([D[0]]);for(let m=1;m<D.length;m++)this.add(D[m])}add(D){const k={value:D,previous:this.c,next:void 0};for(this.c.next=k,this.c=k,this.d=this.c,this.f++,this.a.has(D)?this.h(D):this.a.add(D);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(D){if(this.c.value===D)return D;const k=this.c.value;return this.a.delete(k),this.c.value=D,this.a.has(D)?this.h(D):this.a.add(D),k}prepend(D){if(this.f===this.g||this.a.has(D))return;const k={value:D,previous:void 0,next:this.b};this.b.previous=k,this.b=k,this.f++,this.a.add(D)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(D){return this.a.has(D)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let D=this.b;for(;D;)yield D.value,D=D.next}h(D){let k=this.b;for(;k!==this.c;)k.value===D&&(k===this.b?(this.b=this.b.next,this.b.previous=void 0):(k.previous.next=k.next,k.next.previous=k.previous),this.f--),k=k.next}}t.$qT=n}),define($e[33],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$am=t.$_l=t.$$l=t.rot=t.$9l=void 0;function E(k,m,p){return Math.min(Math.max(k,m),p)}t.$9l=E;function C(k,m){return(m+k%m)%m}t.rot=C;class n{constructor(){this.a=0}getNext(){return this.a++}}t.$$l=n;class H{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$_l=H;class D{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const p=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$am=D}),define($e[47],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(C){function n(m,p){if(m.start>=p.end||p.start>=m.end)return{start:0,end:0};const v=Math.max(m.start,p.start),M=Math.min(m.end,p.end);return M-v<=0?{start:0,end:0}:{start:v,end:M}}C.intersect=n;function H(m){return m.end-m.start<=0}C.isEmpty=H;function D(m,p){return!H(n(m,p))}C.intersects=D;function k(m,p){const v=[],M={start:m.start,end:Math.min(p.start,m.end)},l={start:Math.max(p.end,m.start),end:m.end};return H(M)||v.push(M),H(l)||v.push(l),v}C.relativeComplement=k})(E||(t.Range=E={}))}),define($e[83],pe([1,0,47]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0R=t.$9R=t.$8R=t.$7R=void 0;function C(m,p){const v=[];for(const M of p){if(m.start>=M.range.end)continue;if(m.end<M.range.start)break;const l=E.Range.intersect(m,M.range);E.Range.isEmpty(l)||v.push({range:l,size:M.size})}return v}t.$7R=C;function n({start:m,end:p},v){return{start:m+v,end:p+v}}t.$8R=n;function H(m){const p=[];let v=null;for(const M of m){const l=M.range.start,h=M.range.end,e=M.size;if(v&&e===v.size){v.range.end=h;continue}v={range:{start:l,end:h},size:e},p.push(v)}return p}t.$9R=H;function D(...m){return H(m.reduce((p,v)=>p.concat(v),[]))}class k{get paddingTop(){return this.c}set paddingTop(p){this.b=this.b+p-this.c,this.c=p}constructor(p){this.a=[],this.b=0,this.c=0,this.c=p??0,this.b=this.c}splice(p,v,M=[]){const l=M.length-v,h=C({start:0,end:p},this.a),e=C({start:p+v,end:Number.POSITIVE_INFINITY},this.a).map(f=>({range:n(f.range,l),size:f.size})),s=M.map((f,c)=>({range:{start:p+c,end:p+c+1},size:f.size}));this.a=D(h,s,e),this.b=this.c+this.a.reduce((f,c)=>f+c.size*(c.range.end-c.range.start),0)}get count(){const p=this.a.length;return p?this.a[p-1].range.end:0}get size(){return this.b}indexAt(p){if(p<0)return-1;if(p<this.c)return 0;let v=0,M=this.c;for(const l of this.a){const h=l.range.end-l.range.start,e=M+h*l.size;if(p<e)return v+Math.floor((p-M)/l.size);v+=h,M=e}return v}indexAfter(p){return Math.min(this.indexAt(p)+1,this.count)}positionAt(p){if(p<0)return-1;let v=0,M=0;for(const l of this.a){const h=l.range.end-l.range.start,e=M+h;if(p<e)return this.c+v+(p-M)*l.size;v+=h*l.size,M=e}return-1}}t.$0R=k}),define($e[84],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sd=void 0;const E=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(H){return new C(H)}constructor(H){this.c=E&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$Sd=C}),define($e[4],pe([1,0,6,44,3,46,84]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.$5d=t.$4d=t.$3d=t.$2d=t.$1d=t.$Zd=t.$Yd=t.$Xd=t.$Wd=t.$Vd=t.$Ud=t.Event=void 0;const k=!1,m=!1;var p;(function(U){U.None=()=>n.$Tc.None;function S(r){if(m){const{onDidAddListener:i}=r,o=e.create();let w=0;r.onDidAddListener=()=>{++w===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),o.print()),i?.()}}}function P(r,i){return Be(r,()=>{},0,void 0,!0,void 0,i)}U.defer=P;function L(r){return(i,o=null,w)=>{let I=!1,T;return T=r(j=>{if(!I)return T?T.dispose():I=!0,i.call(o,j)},null,w),I&&T.dispose(),T}}U.once=L;function G(r,i,o){return Re((w,I=null,T)=>r(j=>w.call(I,i(j)),null,T),o)}U.map=G;function Z(r,i,o){return Re((w,I=null,T)=>r(j=>{i(j),w.call(I,j)},null,T),o)}U.forEach=Z;function ge(r,i,o){return Re((w,I=null,T)=>r(j=>i(j)&&w.call(I,j),null,T),o)}U.filter=ge;function ue(r){return r}U.signal=ue;function te(...r){return(i,o=null,w)=>{const I=(0,n.$Qc)(...r.map(T=>T(j=>i.call(o,j))));return Ne(I,w)}}U.any=te;function me(r,i,o,w){let I=o;return G(r,T=>(I=i(I,T),I),w)}U.reduce=me;function Re(r,i){let o;const w={onWillAddFirstListener(){o=r(I.fire,I)},onDidRemoveLastListener(){o?.dispose()}};i||S(w);const I=new $(w);return i?.add(I),I.event}function Ne(r,i){return i instanceof Array?i.push(r):i&&i.add(r),r}function Be(r,i,o=100,w=!1,I=!1,T,j){let V,X,oe,be=0,ye;const we={leakWarningThreshold:T,onWillAddFirstListener(){V=r(ve=>{be++,X=i(X,ve),w&&!oe&&(Ee.fire(X),X=void 0),ye=()=>{const Pe=X;X=void 0,oe=void 0,(!w||be>1)&&Ee.fire(Pe),be=0},typeof o=="number"?(clearTimeout(oe),oe=setTimeout(ye,o)):oe===void 0&&(oe=0,queueMicrotask(ye))})},onWillRemoveListener(){I&&be>0&&ye?.()},onDidRemoveLastListener(){ye=void 0,V.dispose()}};j||S(we);const Ee=new $(we);return j?.add(Ee),Ee.event}U.debounce=Be;function re(r,i=0,o){return U.debounce(r,(w,I)=>w?(w.push(I),w):[I],i,void 0,!0,void 0,o)}U.accumulate=re;function J(r,i=(w,I)=>w===I,o){let w=!0,I;return ge(r,T=>{const j=w||!i(T,I);return w=!1,I=T,j},o)}U.latch=J;function ae(r,i,o){return[U.filter(r,i,o),U.filter(r,w=>!i(w),o)]}U.split=ae;function se(r,i=!1,o=[],w){let I=o.slice(),T=r(X=>{I?I.push(X):V.fire(X)});w&&w.add(T);const j=()=>{I?.forEach(X=>V.fire(X)),I=null},V=new $({onWillAddFirstListener(){T||(T=r(X=>V.fire(X)),w&&w.add(T))},onDidAddFirstListener(){I&&(i?setTimeout(j):j())},onDidRemoveLastListener(){T&&T.dispose(),T=null}});return w&&w.add(V),V.event}U.buffer=se;function Y(r,i){return(w,I,T)=>{const j=i(new ie);return r(function(V){const X=j.evaluate(V);X!==K&&w.call(I,X)},void 0,T)}}U.chain=Y;const K=Symbol("HaltChainable");class ie{constructor(){this.f=[]}map(i){return this.f.push(i),this}forEach(i){return this.f.push(o=>(i(o),o)),this}filter(i){return this.f.push(o=>i(o)?o:K),this}reduce(i,o){let w=o;return this.f.push(I=>(w=i(w,I),w)),this}latch(i=(o,w)=>o===w){let o=!0,w;return this.f.push(I=>{const T=o||!i(I,w);return o=!1,w=I,T?I:K}),this}evaluate(i){for(const o of this.f)if(i=o(i),i===K)break;return i}}function fe(r,i,o=w=>w){const w=(...V)=>j.fire(o(...V)),I=()=>r.on(i,w),T=()=>r.removeListener(i,w),j=new $({onWillAddFirstListener:I,onDidRemoveLastListener:T});return j.event}U.fromNodeEventEmitter=fe;function De(r,i,o=w=>w){const w=(...V)=>j.fire(o(...V)),I=()=>r.addEventListener(i,w),T=()=>r.removeEventListener(i,w),j=new $({onWillAddFirstListener:I,onDidRemoveLastListener:T});return j.event}U.fromDOMEventEmitter=De;function Te(r){return new Promise(i=>L(r)(i))}U.toPromise=Te;function Se(r){const i=new $;return r.then(o=>{i.fire(o)},()=>{i.fire(void 0)}).finally(()=>{i.dispose()}),i.event}U.fromPromise=Se;function _(r,i,o){return i(o),r(w=>i(w))}U.runAndSubscribe=_;class g{constructor(i,o){this._observable=i,this.f=0,this.g=!1;const w={onWillAddFirstListener:()=>{i.addObserver(this)},onDidRemoveLastListener:()=>{i.removeObserver(this)}};o||S(w),this.emitter=new $(w),o&&o.add(this.emitter)}beginUpdate(i){this.f++}handlePossibleChange(i){}handleChange(i,o){this.g=!0}endUpdate(i){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function A(r,i){return new g(r,i).emitter.event}U.fromObservable=A;function F(r){return(i,o,w)=>{let I=0,T=!1;const j={beginUpdate(){I++},endUpdate(){I--,I===0&&(r.reportChanges(),T&&(T=!1,i.call(o)))},handlePossibleChange(){},handleChange(){T=!0}};r.addObserver(j),r.reportChanges();const V={dispose(){r.removeObserver(j)}};return w instanceof n.$Sc?w.add(V):Array.isArray(w)&&w.push(V),V}}U.fromObservableLight=F})(p||(t.Event=p={}));class v{static{this.all=new Set}static{this.f=0}constructor(S){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${S}_${v.f++}`,v.all.add(this)}start(S){this.g=new D.$Sd,this.listenerCount=S}stop(){if(this.g){const S=this.g.elapsed();this.durations.push(S),this.elapsedOverall+=S,this.invocationCount+=1,this.g=void 0}}}t.$Ud=v;let M=-1;function l(U){const S=M;return M=U,{dispose(){M=S}}}t.$Vd=l;class h{constructor(S,P=Math.random().toString(18).slice(2,5)){this.threshold=S,this.name=P,this.g=0}dispose(){this.f?.clear()}check(S,P){const L=this.threshold;if(L<=0||P<L)return;this.f||(this.f=new Map);const G=this.f.get(S.value)||0;if(this.f.set(S.value,G+1),this.g-=1,this.g<=0){this.g=L*.5;let Z,ge=0;for(const[ue,te]of this.f)(!Z||ge<te)&&(Z=ue,ge=te);console.warn(`[${this.name}] potential listener LEAK detected, having ${P} listeners already. MOST frequent listener (${ge}):`),console.warn(Z)}return()=>{const Z=this.f.get(S.value)||0;this.f.set(S.value,Z-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(S){this.value=S}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let s=0;class f{constructor(S){this.value=S,this.id=s++}}const c=2,a=(U,S)=>{if(U instanceof f)S(U);else for(let P=0;P<U.length;P++){const L=U[P];L&&S(L)}};class ${constructor(S){this.w=0,this.f=S,this.g=M>0||this.f?.leakWarningThreshold?new h(this.f?.leakWarningThreshold??M):void 0,this.j=this.f?._profName?new v(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(k){const S=this.t;queueMicrotask(()=>{a(S,P=>P.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(S,P,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),n.$Tc.None;if(this.m)return n.$Tc.None;P&&(S=S.bind(P));const G=new f(S);let Z,ge;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(G.stack=e.create(),Z=this.g.check(G.stack,this.w+1)),k&&(G.stack=ge??e.create()),this.t?this.t instanceof f?(this.u??=new b,this.t=[this.t,G]):this.t.push(G):(this.f?.onWillAddFirstListener?.(this),this.t=G,this.f?.onDidAddFirstListener?.(this)),this.w++;const ue=(0,n.$Rc)(()=>{Z?.(),this.x(G)});return L instanceof n.$Sc?L.add(ue):Array.isArray(L)&&L.push(ue),ue},this.q}x(S){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const P=this.t,L=P.indexOf(S);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,P[L]=void 0;const G=this.u.current===this;if(this.w*c<=P.length){let Z=0;for(let ge=0;ge<P.length;ge++)P[ge]?P[Z++]=P[ge]:G&&(this.u.end--,Z<this.u.i&&this.u.i--);P.length=Z}}y(S,P){if(!S)return;const L=this.f?.onListenerError||E.$1;if(!L){S.value(P);return}try{S.value(P)}catch(G){L(G)}}z(S){const P=S.current.t;for(;S.i<S.end;)this.y(P[S.i++],S.value);S.reset()}fire(S){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof f)this.y(this.t,S);else{const P=this.u;P.enqueue(this,S,this.t.length),this.z(P)}this.j?.stop()}hasListeners(){return this.w>0}}t.$Wd=$;const d=()=>new b;t.$Xd=d;class b{constructor(){this.i=-1,this.end=0}enqueue(S,P,L){this.i=0,this.end=L,this.current=S,this.value=P}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class u extends ${async fireAsync(S,P,L){if(this.t)for(this.h||(this.h=new H.$4c),a(this.t,G=>this.h.push([G.value,S]));this.h.size>0&&!P.isCancellationRequested;){const[G,Z]=this.h.shift(),ge=[],ue={...Z,token:P,waitUntil:te=>{if(Object.isFrozen(ge))throw new Error("waitUntil can NOT be called asynchronous");L&&(te=L(te,G)),ge.push(te)}};try{G(ue)}catch(te){(0,E.$1)(te);continue}Object.freeze(ge),await Promise.allSettled(ge).then(te=>{for(const me of te)me.status==="rejected"&&(0,E.$1)(me.reason)})}}}t.$Yd=u;class N extends ${get isPaused(){return this.h!==0}constructor(S){super(S),this.h=0,this.s=new H.$4c,this.A=S?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const S=Array.from(this.s);this.s.clear(),super.fire(this.A(S))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(S){this.w&&(this.h!==0?this.s.push(S):super.fire(S))}}t.$Zd=N;class B extends N{constructor(S){super(S),this.k=S.delay??100}fire(S){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(S)}}t.$1d=B;class R extends ${constructor(S){super(S),this.h=[],this.k=S?.merge}fire(S){this.hasListeners()&&(this.h.push(S),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(P=>super.fire(P)),this.h=[]}))}}t.$2d=R;class W{constructor(){this.g=!1,this.h=[],this.f=new $({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(S){const P={event:S,listener:null};this.h.push(P),this.g&&this.m(P);const L=()=>{this.g&&this.o(P);const G=this.h.indexOf(P);this.h.splice(G,1)};return(0,n.$Rc)((0,C.$db)(L))}j(){this.g=!0,this.h.forEach(S=>this.m(S))}k(){this.g=!1,this.h.forEach(S=>this.o(S))}m(S){S.listener=S.event(P=>this.f.fire(P))}o(S){S.listener?.dispose(),S.listener=null}dispose(){this.f.dispose();for(const S of this.h)S.listener?.dispose();this.h=[]}}t.$3d=W;class z{constructor(S,P,L,G){this.f=new n.$Sc;const Z=this.f.add(new W),ge=this.f.add(new n.$3c);function ue(te){ge.set(te,Z.add(G(te)))}for(const te of S)ue(te);this.f.add(P(te=>{ue(te)})),this.f.add(L(te=>{ge.deleteAndDispose(te)})),this.event=Z.event}dispose(){this.f.dispose()}}t.$4d=z;class y{constructor(){this.f=[]}wrapEvent(S){return(P,L,G)=>S(Z=>{const ge=this.f[this.f.length-1];ge?ge.push(()=>P.call(L,Z)):P.call(L,Z)},void 0,G)}bufferEvents(S){const P=[];this.f.push(P);const L=S();return this.f.pop(),P.forEach(G=>G()),L}}t.$5d=y;class O{constructor(){this.f=!1,this.g=p.None,this.h=n.$Tc.None,this.j=new $({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(S){this.g=S,this.f&&(this.h.dispose(),this.h=S(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$6d=O}),define($e[16],pe([1,0,21,4]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NP=t.$MP=t.$LP=t.$KP=t.$JP=t.$IP=t.$HP=t.$GP=t.$FP=t.$EP=t.$DP=t.$CP=t.$BP=t.$AP=t.$zP=t.$yP=t.$xP=t.$wP=void 0;class n{constructor(){this.a=new Map,this.b=new C.$Wd,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$Wd,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new n}getZoomLevel(c){return this.a.get(this.f(c))??0}setZoomLevel(c,a){if(this.getZoomLevel(a)===c)return;const $=this.f(a);this.a.set($,c),this.b.fire($)}getZoomFactor(c){return this.c.get(this.f(c))??1}setZoomFactor(c,a){this.c.set(this.f(a),c)}setFullscreen(c,a){if(this.isFullscreen(a)===c)return;const $=this.f(a);this.e.set($,c),this.d.fire($)}isFullscreen(c){return!!this.e.get(this.f(c))}f(c){return c.vscodeWindowId}}function H(f,c,a){typeof c=="string"&&(c=f.matchMedia(c)),c.addEventListener("change",a)}t.$wP=H;function D(f,c){n.INSTANCE.setZoomLevel(f,c)}t.$xP=D;function k(f){return n.INSTANCE.getZoomLevel(f)}t.$yP=k,t.$zP=n.INSTANCE.onDidChangeZoomLevel;function m(f){return n.INSTANCE.getZoomFactor(f)}t.$AP=m;function p(f,c){n.INSTANCE.setZoomFactor(f,c)}t.$BP=p;function v(f,c){n.INSTANCE.setFullscreen(f,c)}t.$CP=v;function M(f){return n.INSTANCE.isFullscreen(f)}t.$DP=M,t.$EP=n.INSTANCE.onDidChangeFullscreen;const l=navigator.userAgent;t.$FP=l.indexOf("Firefox")>=0,t.$GP=l.indexOf("AppleWebKit")>=0,t.$HP=l.indexOf("Chrome")>=0,t.$IP=!t.$HP&&l.indexOf("Safari")>=0,t.$JP=!t.$HP&&!t.$IP&&t.$GP,t.$KP=l.indexOf("Electron/")>=0,t.$LP=l.indexOf("Android")>=0;let h=!1;if(typeof E.$sP.matchMedia=="function"){const f=E.$sP.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),c=E.$sP.matchMedia("(display-mode: fullscreen)");h=f.matches,H(E.$sP,f,({matches:a})=>{h&&c.matches||(h=a)})}function e(){return h}t.$MP=e;function s(){return navigator?.windowControlsOverlay?.visible}t.$NP=s}),define($e[22],pe([1,0,4]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2R=void 0;class C{get event(){return this.a.event}constructor(H,D,k){const m=p=>this.a.fire(p);this.a=new E.$Wd({onWillAddFirstListener:()=>H.addEventListener(D,m,k),onDidRemoveLastListener:()=>H.removeEventListener(D,m,k)})}dispose(){this.a.dispose()}}t.$2R=C}),define($e[29],pe([1,0,4]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7d=t.CancellationToken=void 0;const C=Object.freeze(function(k,m){const p=setTimeout(k.bind(m),0);return{dispose(){clearTimeout(p)}}});var n;(function(k){function m(p){return p===k.None||p===k.Cancelled||p instanceof H?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}k.isCancellationToken=m,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(n||(t.CancellationToken=n={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new E.$Wd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(m){this.f=void 0,this.g=void 0,this.g=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=n.Cancelled}dispose(m=!1){m&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=n.None}}t.$7d=D}),define($e[85],pe([1,0,29]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$He=t.$Ge=t.$Fe=void 0;class C{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new E.$7d,m=this.b(k.token);return this.a={promise:m,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}t.$Fe=C;class n{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const m=JSON.stringify(k);return this.b!==m&&(this.b=m,this.a=this.c(k)),this.a}}t.$Ge=n;class H{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const m=this.b(k);return this.a.set(k,m),m}}t.$He=H}),define($e[48],pe([1,0,4,3]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ps=t.$os=t.$ns=t.$ms=t.ScrollbarVisibility=void 0;var n;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(n||(t.ScrollbarVisibility=n={}));class H{constructor(e,s,f,c,a,$,d){this.c=e,this._scrollStateBrand=void 0,this.c&&(s=s|0,f=f|0,c=c|0,a=a|0,$=$|0,d=d|0),this.rawScrollLeft=c,this.rawScrollTop=d,s<0&&(s=0),c+s>f&&(c=f-s),c<0&&(c=0),a<0&&(a=0),d+a>$&&(d=$-a),d<0&&(d=0),this.width=s,this.scrollWidth=f,this.scrollLeft=c,this.height=a,this.scrollHeight=$,this.scrollTop=d}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,s){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,s?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,s?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,s){const f=this.width!==e.width,c=this.scrollWidth!==e.scrollWidth,a=this.scrollLeft!==e.scrollLeft,$=this.height!==e.height,d=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:s,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:f,scrollWidthChanged:c,scrollLeftChanged:a,heightChanged:$,scrollHeightChanged:d,scrollTopChanged:b}}}t.$ms=H;class D extends C.$Tc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new E.$Wd),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,s){const f=this.g.withScrollDimensions(e,s);this.n(f,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const s=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(s,!1)}setScrollPositionSmooth(e,s){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const f=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===f.scrollLeft&&this.h.to.scrollTop===f.scrollTop)return;let c;s?c=new v(this.h.from,f,this.h.startTime,this.h.duration):c=this.h.combine(this.g,f,this.c),this.h.dispose(),this.h=c}else{const f=this.g.withScrollPosition(e);this.h=v.start(this.g,f,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),s=this.g.withScrollPosition(e);if(this.n(s,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,s){const f=this.g;f.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(f,s)))}}t.$ns=D;class k{constructor(e,s,f){this.scrollLeft=e,this.scrollTop=s,this.isDone=f}}t.$os=k;function m(h,e){const s=e-h;return function(f){return h+s*l(f)}}function p(h,e,s){return function(f){return f<s?h(f/s):e((f-s)/(1-s))}}class v{constructor(e,s,f,c){this.from=e,this.to=s,this.duration=c,this.startTime=f,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,s,f){if(Math.abs(e-s)>2.5*f){let a,$;return e<s?(a=e+.75*f,$=s-.75*f):(a=e-.75*f,$=s+.75*f),p(m(e,a),m($,s),.33)}return m(e,s)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const s=(e-this.startTime)/this.duration;if(s<1){const f=this.c(s),c=this.d(s);return new k(f,c,!1)}return new k(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,s,f){return v.start(e,s,f)}static start(e,s,f){f=f+10;const c=Date.now()-10;return new v(e,s,c,f)}}t.$ps=v;function M(h){return Math.pow(h,3)}function l(h){return 1-M(1-h)}}),define($e[86],pe([1,0,6,3]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$de=t.$ce=t.$be=t.$ae=t.$_d=t.$$d=t.$0d=t.$9d=t.$8d=void 0;function n(d){const b=d;return b?typeof b.read=="function":!1}t.$8d=n;function H(d){const b=d;return b?[b.on,b.pause,b.resume,b.destroy].every(u=>typeof u=="function"):!1}t.$9d=H;function D(d){const b=d;return b?H(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.$0d=D;function k(d,b){return new m(d,b)}t.$$d=k;class m{constructor(b,u){this.e=b,this.f=u,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(u=>this.d.push(u))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(u=>u(b))}h(b){this.c.error.length===0?(0,E.$1)(b):this.c.error.slice(0).forEach(u=>u(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,u){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(u),this.resume();break;case"end":this.c.end.push(u),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(u),this.a.flowing&&this.k();break}}removeListener(b,u){if(this.a.destroyed)return;let N;switch(b){case"data":N=this.c.data;break;case"end":N=this.c.end;break;case"error":N=this.c.error;break}if(N){const B=N.indexOf(u);B>=0&&N.splice(B,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const u=[...this.d];this.d.length=0,u.forEach(N=>N())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(d,b){const u=[];let N;for(;(N=d.read())!==null;)u.push(N);return b(u)}t.$_d=p;function v(d,b,u){const N=[];let B;for(;(B=d.read())!==null&&N.length<u;)N.push(B);return B===null&&N.length>0?b(N):{read:()=>{if(N.length>0)return N.shift();if(typeof B<"u"){const R=B;return B=void 0,R}return d.read()}}}t.$ae=v;function M(d,b){return new Promise((u,N)=>{const B=[];l(d,{onData:R=>{b&&B.push(R)},onError:R=>{b?N(R):u(void 0)},onEnd:()=>{u(b?b(B):void 0)}})})}t.$be=M;function l(d,b,u){d.on("error",N=>{u?.isCancellationRequested||b.onError(N)}),d.on("end",()=>{u?.isCancellationRequested||b.onEnd()}),d.on("data",N=>{u?.isCancellationRequested||b.onData(N)})}t.$ce=l;function h(d,b){return new Promise((u,N)=>{const B=new C.$Sc,R=[],W=O=>{if(R.push(O),R.length>b)return B.dispose(),d.pause(),u({stream:d,buffer:R,ended:!1})},z=O=>(B.dispose(),N(O)),y=()=>(B.dispose(),u({stream:d,buffer:R,ended:!0}));B.add((0,C.$Rc)(()=>d.removeListener("error",z))),d.on("error",z),B.add((0,C.$Rc)(()=>d.removeListener("end",y))),d.on("end",y),B.add((0,C.$Rc)(()=>d.removeListener("data",W))),d.on("data",W)})}t.$de=h;function e(d,b){const u=k(b);return u.end(d),u}t.$ee=e;function s(){const d=k(()=>{throw new Error("not supported")});return d.end(),d}t.$fe=s;function f(d){let b=!1;return{read:()=>b?null:(b=!0,d)}}t.$ge=f;function c(d,b,u){const N=k(u);return l(d,{onData:B=>N.write(b.data(B)),onError:B=>N.error(b.error?b.error(B):B),onEnd:()=>N.end()}),N}t.$he=c;function a(d,b,u){let N=!1;return{read:()=>{const B=b.read();return N?B:(N=!0,B!==null?u([d,B]):d)}}}t.$ie=a;function $(d,b,u){let N=!1;const B=k(u);return l(b,{onData:R=>N?B.write(R):(N=!0,B.write(u([d,R]))),onError:R=>B.error(R),onEnd:()=>{N||(N=!0,B.write(d)),B.end()}}),B}t.$je=$}),define($e[34],pe([1,0,23,86]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ee=t.$De=t.$Ce=t.$Be=t.$Ae=t.$ze=t.$ye=t.$xe=t.$we=t.$ve=t.$ue=t.$te=t.$se=t.$re=t.$qe=t.$pe=t.$oe=t.$ne=t.$me=t.$le=t.$ke=void 0;const n=typeof Buffer<"u",H=new E.$V(()=>new Uint8Array(256));let D,k;class m{static alloc(P){return n?new m(Buffer.allocUnsafe(P)):new m(new Uint8Array(P))}static wrap(P){return n&&!Buffer.isBuffer(P)&&(P=Buffer.from(P.buffer,P.byteOffset,P.byteLength)),new m(P)}static fromString(P,L){return!(L?.dontUseNodeBuffer||!1)&&n?new m(Buffer.from(P)):(D||(D=new TextEncoder),new m(D.encode(P)))}static fromByteArray(P){const L=m.alloc(P.length);for(let G=0,Z=P.length;G<Z;G++)L.buffer[G]=P[G];return L}static concat(P,L){if(typeof L>"u"){L=0;for(let ge=0,ue=P.length;ge<ue;ge++)L+=P[ge].byteLength}const G=m.alloc(L);let Z=0;for(let ge=0,ue=P.length;ge<ue;ge++){const te=P[ge];G.set(te,Z),Z+=te.byteLength}return G}constructor(P){this.buffer=P,this.byteLength=this.buffer.byteLength}clone(){const P=m.alloc(this.byteLength);return P.set(this),P}toString(){return n?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(P,L){return new m(this.buffer.subarray(P,L))}set(P,L){if(P instanceof m)this.buffer.set(P.buffer,L);else if(P instanceof Uint8Array)this.buffer.set(P,L);else if(P instanceof ArrayBuffer)this.buffer.set(new Uint8Array(P),L);else if(ArrayBuffer.isView(P))this.buffer.set(new Uint8Array(P.buffer,P.byteOffset,P.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(P){return l(this.buffer,P)}writeUInt32BE(P,L){h(this.buffer,P,L)}readUInt32LE(P){return e(this.buffer,P)}writeUInt32LE(P,L){s(this.buffer,P,L)}readUInt8(P){return f(this.buffer,P)}writeUInt8(P,L){c(this.buffer,P,L)}indexOf(P,L=0){return p(this.buffer,P instanceof m?P.buffer:P,L)}}t.$ke=m;function p(S,P,L=0){const G=P.byteLength,Z=S.byteLength;if(G===0)return 0;if(G===1)return S.indexOf(P[0]);if(G>Z-L)return-1;const ge=H.value;ge.fill(P.length);for(let Re=0;Re<P.length;Re++)ge[P[Re]]=P.length-Re-1;let ue=L+P.length-1,te=ue,me=-1;for(;ue<Z;)if(S[ue]===P[te]){if(te===0){me=ue;break}ue--,te--}else ue+=Math.max(P.length-te,ge[S[ue]]),te=P.length-1;return me}t.$le=p;function v(S,P){return S[P+0]<<0>>>0|S[P+1]<<8>>>0}t.$me=v;function M(S,P,L){S[L+0]=P&255,P=P>>>8,S[L+1]=P&255}t.$ne=M;function l(S,P){return S[P]*2**24+S[P+1]*2**16+S[P+2]*2**8+S[P+3]}t.$oe=l;function h(S,P,L){S[L+3]=P,P=P>>>8,S[L+2]=P,P=P>>>8,S[L+1]=P,P=P>>>8,S[L]=P}t.$pe=h;function e(S,P){return S[P+0]<<0>>>0|S[P+1]<<8>>>0|S[P+2]<<16>>>0|S[P+3]<<24>>>0}t.$qe=e;function s(S,P,L){S[L+0]=P&255,P=P>>>8,S[L+1]=P&255,P=P>>>8,S[L+2]=P&255,P=P>>>8,S[L+3]=P&255}t.$re=s;function f(S,P){return S[P]}t.$se=f;function c(S,P,L){S[L]=P}t.$te=c;function a(S){return C.$_d(S,P=>m.concat(P))}t.$ue=a;function $(S){return C.$ge(S)}t.$ve=$;function d(S){return C.$be(S,P=>m.concat(P))}t.$we=d;async function b(S){return S.ended?m.concat(S.buffer):m.concat([...S.buffer,await d(S.stream)])}t.$xe=b;function u(S){return C.$ee(S,P=>m.concat(P))}t.$ye=u;function N(S){return C.$he(S,{data:P=>typeof P=="string"?m.fromString(P):m.wrap(P)},P=>m.concat(P))}t.$ze=N;function B(S){return C.$$d(P=>m.concat(P),S)}t.$Ae=B;function R(S,P){return C.$ie(S,P,L=>m.concat(L))}t.$Be=R;function W(S,P){return C.$je(S,P,L=>m.concat(L))}t.$Ce=W;function z(S){let P=0,L=0,G=0;const Z=new Uint8Array(Math.floor(S.length/4*3)),ge=te=>{switch(L){case 3:Z[G++]=P|te,L=0;break;case 2:Z[G++]=P|te>>>2,P=te<<6,L=3;break;case 1:Z[G++]=P|te>>>4,P=te<<4,L=2;break;default:P=te<<2,L=1}};for(let te=0;te<S.length;te++){const me=S.charCodeAt(te);if(me>=65&&me<=90)ge(me-65);else if(me>=97&&me<=122)ge(me-97+26);else if(me>=48&&me<=57)ge(me-48+52);else if(me===43||me===45)ge(62);else if(me===47||me===95)ge(63);else{if(me===61)break;throw new SyntaxError(`Unexpected base64 character ${S[te]}`)}}const ue=G;for(;L>0;)ge(0);return m.wrap(Z).slice(0,ue)}t.$De=z;const y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function U({buffer:S},P=!0,L=!1){const G=L?O:y;let Z="";const ge=S.byteLength%3;let ue=0;for(;ue<S.byteLength-ge;ue+=3){const te=S[ue+0],me=S[ue+1],Re=S[ue+2];Z+=G[te>>>2],Z+=G[(te<<4|me>>>4)&63],Z+=G[(me<<2|Re>>>6)&63],Z+=G[Re&63]}if(ge===1){const te=S[ue+0];Z+=G[te>>>2],Z+=G[te<<4&63],P&&(Z+="==")}else if(ge===2){const te=S[ue+0],me=S[ue+1];Z+=G[te>>>2],Z+=G[(te<<4|me>>>4)&63],Z+=G[me<<2&63],P&&(Z+="=")}return Z}t.$Ee=U}),define($e[10],pe([1,0,85,23]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$If=t.$Hf=t.$Gf=t.$Ff=t.GraphemeBreakType=t.$Ef=t.$Df=t.$Cf=t.$Bf=t.$Af=t.$zf=t.$yf=t.$xf=t.$wf=t.$vf=t.$uf=t.$tf=t.$sf=t.$rf=t.$qf=t.$pf=t.$of=t.$nf=t.$mf=t.$lf=t.$kf=t.$jf=t.$if=t.$hf=t.$gf=t.$ff=t.$ef=t.$df=t.$cf=t.$bf=t.$af=t.$_e=t.$$e=t.$0e=t.$9e=t.$8e=t.$7e=t.$6e=t.$5e=t.$4e=t.$3e=t.$2e=t.$1e=t.$Ze=t.$Ye=t.$Xe=t.$We=t.$Ve=t.$Ue=t.$Te=t.$Se=t.$Re=t.$Qe=t.$Pe=t.$Oe=t.$Ne=t.$Me=t.$Le=t.$Ke=void 0;function n(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.$Ke=n;const H=/{(\d+)}/g;function D(x,...le){return le.length===0?x:x.replace(H,function(de,Ae){const Ce=parseInt(Ae,10);return isNaN(Ce)||Ce<0||Ce>=le.length?de:le[Ce]})}t.$Le=D;const k=/{([^}]+)}/g;function m(x,le){return Object.keys(le).length===0?x:x.replace(k,(de,Ae)=>le[Ae]??de)}t.$Me=m;function p(x){return x.replace(/[<>"'&]/g,le=>{switch(le){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return le})}t.$Ne=p;function v(x){return x.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}t.$Oe=v;function M(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.$Pe=M;function l(x,le){let de=0;const Ae=le.charCodeAt(0);for(let Ce=x.length-1;Ce>=0;Ce--)x.charCodeAt(Ce)===Ae&&de++;return de}t.$Qe=l;function h(x,le,de="\u2026"){return x.length<=le?x:`${x.substr(0,le)}${de}`}t.$Re=h;function e(x,le,de="\u2026"){if(x.length<=le)return x;const Ae=Math.ceil(le/2)-de.length/2,Ce=Math.floor(le/2)-de.length/2;return`${x.substr(0,Ae)}${de}${x.substr(x.length-Ce)}`}t.$Se=e;function s(x,le=" "){const de=f(x,le);return c(de,le)}t.$Te=s;function f(x,le){if(!x||!le)return x;const de=le.length;if(de===0||x.length===0)return x;let Ae=0;for(;x.indexOf(le,Ae)===Ae;)Ae=Ae+de;return x.substring(Ae)}t.$Ue=f;function c(x,le){if(!x||!le)return x;const de=le.length,Ae=x.length;if(de===0||Ae===0)return x;let Ce=Ae,je=-1;for(;je=x.lastIndexOf(le,Ce-1),!(je===-1||je+de!==Ce);){if(je===0)return"";Ce=je}return x.substring(0,Ce)}t.$Ve=c;function a(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.$We=a;function $(x){return x.replace(/\*/g,"")}t.$Xe=$;function d(x,le,de={}){if(!x)throw new Error("Cannot create regex from empty string");le||(x=M(x)),de.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ae="";return de.global&&(Ae+="g"),de.matchCase||(Ae+="i"),de.multiline&&(Ae+="m"),de.unicode&&(Ae+="u"),new RegExp(x,Ae)}t.$Ye=d;function b(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.$Ze=b;function u(x){return x.split(/\r\n|\r|\n/)}t.$1e=u;function N(x){for(let le=0,de=x.length;le<de;le++){const Ae=x.charCodeAt(le);if(Ae!==32&&Ae!==9)return le}return-1}t.$2e=N;function B(x,le=0,de=x.length){for(let Ae=le;Ae<de;Ae++){const Ce=x.charCodeAt(Ae);if(Ce!==32&&Ce!==9)return x.substring(le,Ae)}return x.substring(le,de)}t.$3e=B;function R(x,le=x.length-1){for(let de=le;de>=0;de--){const Ae=x.charCodeAt(de);if(Ae!==32&&Ae!==9)return de}return-1}t.$4e=R;function W(x,le,de){const Ae=[];let Ce=0;for(const je of x.matchAll(le)){if(Ae.push(x.slice(Ce,je.index)),je.index===void 0)throw new Error("match.index should be defined");Ce=je.index+je[0].length,Ae.push(de(je[0],...je.slice(1),je.index,x,je.groups))}return Ae.push(x.slice(Ce)),Promise.all(Ae).then(je=>je.join(""))}t.$5e=W;function z(x,le){return x<le?-1:x>le?1:0}t.$6e=z;function y(x,le,de=0,Ae=x.length,Ce=0,je=le.length){for(;de<Ae&&Ce<je;de++,Ce++){const Je=x.charCodeAt(de),tt=le.charCodeAt(Ce);if(Je<tt)return-1;if(Je>tt)return 1}const _e=Ae-de,Ke=je-Ce;return _e<Ke?-1:_e>Ke?1:0}t.$7e=y;function O(x,le){return U(x,le,0,x.length,0,le.length)}t.$8e=O;function U(x,le,de=0,Ae=x.length,Ce=0,je=le.length){for(;de<Ae&&Ce<je;de++,Ce++){let Je=x.charCodeAt(de),tt=le.charCodeAt(Ce);if(Je===tt)continue;if(Je>=128||tt>=128)return y(x.toLowerCase(),le.toLowerCase(),de,Ae,Ce,je);P(Je)&&(Je-=32),P(tt)&&(tt-=32);const Xe=Je-tt;if(Xe!==0)return Xe}const _e=Ae-de,Ke=je-Ce;return _e<Ke?-1:_e>Ke?1:0}t.$9e=U;function S(x){return x>=48&&x<=57}t.$0e=S;function P(x){return x>=97&&x<=122}t.$$e=P;function L(x){return x>=65&&x<=90}t.$_e=L;function G(x,le){return x.length===le.length&&U(x,le)===0}t.$af=G;function Z(x,le){const de=le.length;return le.length>x.length?!1:U(x,le,0,de)===0}t.$bf=Z;function ge(x,le){const de=Math.min(x.length,le.length);let Ae;for(Ae=0;Ae<de;Ae++)if(x.charCodeAt(Ae)!==le.charCodeAt(Ae))return Ae;return de}t.$cf=ge;function ue(x,le){const de=Math.min(x.length,le.length);let Ae;const Ce=x.length-1,je=le.length-1;for(Ae=0;Ae<de;Ae++)if(x.charCodeAt(Ce-Ae)!==le.charCodeAt(je-Ae))return Ae;return de}t.$df=ue;function te(x){return 55296<=x&&x<=56319}t.$ef=te;function me(x){return 56320<=x&&x<=57343}t.$ff=me;function Re(x,le){return(x-55296<<10)+(le-56320)+65536}t.$gf=Re;function Ne(x,le,de){const Ae=x.charCodeAt(de);if(te(Ae)&&de+1<le){const Ce=x.charCodeAt(de+1);if(me(Ce))return Re(Ae,Ce)}return Ae}t.$hf=Ne;function Be(x,le){const de=x.charCodeAt(le-1);if(me(de)&&le>1){const Ae=x.charCodeAt(le-2);if(te(Ae))return Re(Ae,de)}return de}class re{get offset(){return this.e}constructor(le,de=0){this.c=le,this.d=le.length,this.e=de}setOffset(le){this.e=le}prevCodePoint(){const le=Be(this.c,this.e);return this.e-=le>=65536?2:1,le}nextCodePoint(){const le=Ne(this.c,this.d,this.e);return this.e+=le>=65536?2:1,le}eol(){return this.e>=this.d}}t.$if=re;class J{get offset(){return this.c.offset}constructor(le,de=0){this.c=new re(le,de)}nextGraphemeLength(){const le=Ee.getInstance(),de=this.c,Ae=de.offset;let Ce=le.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const je=de.offset,_e=le.getGraphemeBreakType(de.nextCodePoint());if(ye(Ce,_e)){de.setOffset(je);break}Ce=_e}return de.offset-Ae}prevGraphemeLength(){const le=Ee.getInstance(),de=this.c,Ae=de.offset;let Ce=le.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const je=de.offset,_e=le.getGraphemeBreakType(de.prevCodePoint());if(ye(_e,Ce)){de.setOffset(je);break}Ce=_e}return Ae-de.offset}eol(){return this.c.eol()}}t.$jf=J;function ae(x,le){return new J(x,le).nextGraphemeLength()}t.$kf=ae;function se(x,le){return new J(x,le).prevGraphemeLength()}t.$lf=se;function Y(x,le){le>0&&me(x.charCodeAt(le))&&le--;const de=le+ae(x,le);return[de-se(x,de),de]}t.$mf=Y;function K(x){const le=new J(x);let de=0;for(;!le.eol();)de++,le.nextGraphemeLength();return de}t.$nf=K;let ie;function fe(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function De(x){return ie||(ie=fe()),ie.test(x)}t.$of=De;const Te=/^[\t\n\r\x20-\x7E]*$/;function Se(x){return Te.test(x)}t.$pf=Se,t.$qf=/[\u2028\u2029]/;function _(x){return t.$qf.test(x)}t.$rf=_;function g(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.$sf=g;function A(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.$tf=A;function F(x,le,de=""){const Ae=x.trimStart();if(Ae.length<le)return Ae;const Ce=/\b/g;let je=0;for(;Ce.test(Ae)&&!(Ae.length-Ce.lastIndex<le);)je=Ce.lastIndex,Ce.lastIndex+=1;return je===0?Ae:de+Ae.substring(je).trimStart()}t.$uf=F;const r=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,i=/\x1b\].*?\x07/g;function o(x){return x&&(x=x.replace(r,"").replace(i,"")),x}t.$vf=o,t.$wf="\uFEFF";function w(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.$xf=w;function I(x){return w(x)?x.substr(1):x}t.$yf=I;function T(x,le){if(!x||!le||x.length<le.length)return!1;const de=le.length,Ae=x.toLowerCase();let Ce=0,je=-1;for(;Ce<de;){const _e=Ae.indexOf(le[Ce],je+1);if(_e<0)return!1;je=_e,Ce++}return!0}t.$zf=T;function j(x,le=!1){return x?(le&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.$Af=j;function V(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.$Bf=V;function X(x,le=1){if(le===0)return"";let de=-1;do de=x.indexOf(`
`,de+1),le--;while(le>0&&de>=0);return de===-1?x:(x[de-1]==="\r"&&de--,x.substr(0,de))}t.$Cf=X;function oe(x){return x=x%(2*26),x<26?String.fromCharCode(97+x):String.fromCharCode(65+x-26)}t.$Df=oe;function be(x){return Ee.getInstance().getGraphemeBreakType(x)}t.$Ef=be;function ye(x,le){return x===0?le!==5&&le!==7:x===2&&le===3?!1:x===4||x===2||x===3||le===4||le===2||le===3?!0:!(x===8&&(le===8||le===9||le===11||le===12)||(x===11||x===9)&&(le===9||le===10)||(x===12||x===10)&&le===10||le===5||le===13||le===7||x===1||x===13&&le===14||x===6&&le===6)}var we;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(we||(t.GraphemeBreakType=we={}));class Ee{static{this.c=null}static getInstance(){return Ee.c||(Ee.c=new Ee),Ee.c}constructor(){this.d=ve()}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const de=this.d,Ae=de.length/3;let Ce=1;for(;Ce<=Ae;)if(le<de[3*Ce])Ce=2*Ce;else if(le>de[3*Ce+1])Ce=2*Ce+1;else return de[3*Ce+2];return 0}}function ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Pe(x,le){if(x===0)return 0;const de=Ie(x,le);if(de!==void 0)return de;const Ae=new re(le,x);return Ae.prevCodePoint(),Ae.offset}t.$Ff=Pe;function Ie(x,le){const de=new re(le,x);let Ae=de.prevCodePoint();for(;Me(Ae)||Ae===65039||Ae===8419;){if(de.offset===0)return;Ae=de.prevCodePoint()}if(!A(Ae))return;let Ce=de.offset;return Ce>0&&de.prevCodePoint()===8205&&(Ce=de.offset),Ce}function Me(x){return 127995<=x&&x<=127999}var Ze;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),t.$Gf="\xA0";class et{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new E.$Ge(le=>{function de(Xe){const nt=new Map;for(let st=0;st<Xe.length;st+=2)nt.set(Xe[st],Xe[st+1]);return nt}function Ae(Xe,nt){const st=new Map(Xe);for(const[rt,gt]of nt)st.set(rt,gt);return st}function Ce(Xe,nt){if(!Xe)return nt;const st=new Map;for(const[rt,gt]of Xe)nt.has(rt)&&st.set(rt,gt);return st}const je=this.c.value;let _e=le.filter(Xe=>!Xe.startsWith("_")&&Xe in je);_e.length===0&&(_e=["_default"]);let Ke;for(const Xe of _e){const nt=de(je[Xe]);Ke=Ce(Ke,nt)}const Je=de(je._common),tt=Ae(Je,Ke);return new et(tt)})}static getInstance(le){return et.d.get(Array.from(le))}static{this.e=new C.$V(()=>Object.keys(et.c.value).filter(le=>!le.startsWith("_")))}static getLocales(){return et.e.value}constructor(le){this.f=le}isAmbiguous(le){return this.f.has(le)}getPrimaryConfusable(le){return this.f.get(le)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$Hf=et;class xe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(xe.c())),this.d}static isInvisibleCharacter(le){return xe.e().has(le)}static get codePoints(){return xe.e()}}t.$If=xe}),define($e[35],pe([1,0,32,80,10]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$j=t.$0j=t.$9j=t.$8j=t.FuzzyScore=t.$7j=t.$6j=t.$5j=t.$4j=t.$3j=t.$2j=t.$1j=t.$Zj=t.$Yj=t.$Xj=t.$Wj=t.$Vj=t.or=void 0;function H(...T){return function(j,V){for(let X=0,oe=T.length;X<oe;X++){const be=T[X](j,V);if(be)return be}return null}}t.or=H,t.$Vj=D.bind(void 0,!1),t.$Wj=D.bind(void 0,!0);function D(T,j,V){if(!V||V.length<j.length)return null;let X;return T?X=n.$bf(V,j):X=V.indexOf(j)===0,X?j.length>0?[{start:0,end:j.length}]:[]:null}function k(T,j){const V=j.toLowerCase().indexOf(T.toLowerCase());return V===-1?null:[{start:V,end:V+T.length}]}t.$Xj=k;function m(T,j){return p(T.toLowerCase(),j.toLowerCase(),0,0)}t.$Yj=m;function p(T,j,V,X){if(V===T.length)return[];if(X===j.length)return null;if(T[V]===j[X]){let oe=null;return(oe=p(T,j,V+1,X+1))?d({start:X,end:X+1},oe):null}return p(T,j,V,X+1)}function v(T){return 97<=T&&T<=122}function M(T){return 65<=T&&T<=90}t.$Zj=M;function l(T){return 48<=T&&T<=57}function h(T){return T===32||T===9||T===10||T===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(T=>e.add(T.charCodeAt(0)));function s(T){return h(T)||e.has(T)}function f(T,j){return T===j||s(T)&&s(j)}const c=new Map;function a(T){if(c.has(T))return c.get(T);let j;const V=(0,C.$Tj)(T);return V&&(j=V),c.set(T,j),j}function $(T){return v(T)||M(T)||l(T)}function d(T,j){return j.length===0?j=[T]:T.end===j[0].start?j[0].start=T.start:j.unshift(T),j}function b(T,j){for(let V=j;V<T.length;V++){const X=T.charCodeAt(V);if(M(X)||l(X)||V>0&&!$(T.charCodeAt(V-1)))return V}return T.length}function u(T,j,V,X){if(V===T.length)return[];if(X===j.length)return null;if(T[V]!==j[X].toLowerCase())return null;{let oe=null,be=X+1;for(oe=u(T,j,V+1,X+1);!oe&&(be=b(j,be))<j.length;)oe=u(T,j,V+1,be),be++;return oe===null?null:d({start:X,end:X+1},oe)}}function N(T){let j=0,V=0,X=0,oe=0,be=0;for(let Pe=0;Pe<T.length;Pe++)be=T.charCodeAt(Pe),M(be)&&j++,v(be)&&V++,$(be)&&X++,l(be)&&oe++;const ye=j/T.length,we=V/T.length,Ee=X/T.length,ve=oe/T.length;return{upperPercent:ye,lowerPercent:we,alphaPercent:Ee,numericPercent:ve}}function B(T){const{upperPercent:j,lowerPercent:V}=T;return V===0&&j>.6}function R(T){const{upperPercent:j,lowerPercent:V,alphaPercent:X,numericPercent:oe}=T;return V>.2&&j<.8&&X>.6&&oe<.2}function W(T){let j=0,V=0,X=0,oe=0;for(let be=0;be<T.length;be++)X=T.charCodeAt(be),M(X)&&j++,v(X)&&V++,h(X)&&oe++;return(j===0||V===0)&&oe===0?T.length<=30:j<=5}function z(T,j){if(!j||(j=j.trim(),j.length===0)||!W(T)||j.length>60)return null;const V=N(j);if(!R(V)){if(!B(V))return null;j=j.toLowerCase()}let X=null,oe=0;for(T=T.toLowerCase();oe<j.length&&(X=u(T,j,0,oe))===null;)oe=b(j,oe+1);return X}t.$1j=z;function y(T,j,V=!1){if(!j||j.length===0)return null;let X=null,oe=0;for(T=T.toLowerCase(),j=j.toLowerCase();oe<j.length&&(X=O(T,j,0,oe,V),X===null);)oe=U(j,oe+1);return X}t.$2j=y;function O(T,j,V,X,oe){let be=0;if(V===T.length)return[];if(X===j.length)return null;if(!f(T.charCodeAt(V),j.charCodeAt(X))){const Ee=a(T.charCodeAt(V));if(!Ee)return null;for(let ve=0;ve<Ee.length;ve++)if(!f(Ee[ve],j.charCodeAt(X+ve)))return null;be+=Ee.length-1}let ye=null,we=X+be+1;if(ye=O(T,j,V+1,we,oe),!oe)for(;!ye&&(we=U(j,we))<j.length;)ye=O(T,j,V+1,we,oe),we++;if(!ye)return null;if(T.charCodeAt(V)!==j.charCodeAt(X)){const Ee=a(T.charCodeAt(V));if(!Ee)return ye;for(let ve=0;ve<Ee.length;ve++)if(Ee[ve]!==j.charCodeAt(X+ve))return ye}return d({start:X,end:X+be+1},ye)}function U(T,j){for(let V=j;V<T.length;V++)if(s(T.charCodeAt(V))||V>0&&s(T.charCodeAt(V-1)))return V;return T.length}const S=H(t.$Wj,z,k),P=H(t.$Wj,z,m),L=new E.$Dc(1e4);function G(T,j,V=!1){if(typeof T!="string"||typeof j!="string")return null;let X=L.get(T);X||(X=new RegExp(n.$We(T),"i"),L.set(T,X));const oe=X.exec(j);return oe?[{start:oe.index,end:oe.index+oe[0].length}]:V?P(T,j):S(T,j)}t.$3j=G;function Z(T,j){const V=A(T,T.toLowerCase(),0,j,j.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return V?ue(V):null}t.$4j=Z;function ge(T,j,V,X,oe,be){const ye=Math.min(13,T.length);for(;V<ye;V++){const we=A(T,j,V,X,oe,be,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(we)return we}return[0,be]}t.$5j=ge;function ue(T){if(typeof T>"u")return[];const j=[],V=T[1];for(let X=T.length-1;X>1;X--){const oe=T[X]+V,be=j[j.length-1];be&&be.end===oe?be.end=oe+1:j.push({start:oe,end:oe+1})}return j}t.$6j=ue;const te=128;function me(){const T=[],j=[];for(let V=0;V<=te;V++)j[V]=0;for(let V=0;V<=te;V++)T.push(j.slice(0));return T}function Re(T){const j=[];for(let V=0;V<=T;V++)j[V]=0;return j}const Ne=Re(2*te),Be=Re(2*te),re=me(),J=me(),ae=me(),se=!1;function Y(T,j,V,X,oe){function be(we,Ee,ve=" "){for(;we.length<Ee;)we=ve+we;return we}let ye=` |   |${X.split("").map(we=>be(we,3)).join("|")}
`;for(let we=0;we<=V;we++)we===0?ye+=" |":ye+=`${j[we-1]}|`,ye+=T[we].slice(0,oe+1).map(Ee=>be(Ee.toString(),3)).join("|")+`
`;return ye}function K(T,j,V,X){T=T.substr(j),V=V.substr(X),console.log(Y(J,T,T.length,V,V.length)),console.log(Y(ae,T,T.length,V,V.length)),console.log(Y(re,T,T.length,V,V.length))}function ie(T,j){if(j<0||j>=T.length)return!1;const V=T.codePointAt(j);switch(V){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!n.$tf(V)}}function fe(T,j){if(j<0||j>=T.length)return!1;switch(T.charCodeAt(j)){case 32:case 9:return!0;default:return!1}}function De(T,j,V){return j[T]!==V[T]}function Te(T,j,V,X,oe,be,ye=!1){for(;j<V&&oe<be;)T[j]===X[oe]&&(ye&&(Ne[j]=oe),j+=1),oe+=1;return j===V}t.$7j=Te;var Se;(function(T){T[T.Diag=1]="Diag",T[T.Left=2]="Left",T[T.LeftLeft=3]="LeftLeft"})(Se||(Se={}));var _;(function(T){T.Default=[-100,0];function j(V){return!V||V.length===2&&V[0]===-100&&V[1]===0}T.isDefault=j})(_||(t.FuzzyScore=_={}));class g{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(j,V){this.firstMatchCanBeWeak=j,this.boostFullMatch=V}}t.$8j=g;function A(T,j,V,X,oe,be,ye=g.default){const we=T.length>te?te:T.length,Ee=X.length>te?te:X.length;if(V>=we||be>=Ee||we-V>Ee-be||!Te(j,V,we,oe,be,Ee,!0))return;F(we,Ee,V,be,j,oe);let ve=1,Pe=1,Ie=V,Me=be;const Ze=[!1];for(ve=1,Ie=V;Ie<we;ve++,Ie++){const de=Ne[Ie],Ae=Be[Ie],Ce=Ie+1<we?Be[Ie+1]:Ee;for(Pe=de-be+1,Me=de;Me<Ce;Pe++,Me++){let je=Number.MIN_SAFE_INTEGER,_e=!1;Me<=Ae&&(je=r(T,j,Ie,V,X,oe,Me,Ee,be,re[ve-1][Pe-1]===0,Ze));let Ke=0;je!==Number.MAX_SAFE_INTEGER&&(_e=!0,Ke=je+J[ve-1][Pe-1]);const Je=Me>de,tt=Je?J[ve][Pe-1]+(re[ve][Pe-1]>0?-5:0):0,Xe=Me>de+1&&re[ve][Pe-1]>0,nt=Xe?J[ve][Pe-2]+(re[ve][Pe-2]>0?-5:0):0;if(Xe&&(!Je||nt>=tt)&&(!_e||nt>=Ke))J[ve][Pe]=nt,ae[ve][Pe]=3,re[ve][Pe]=0;else if(Je&&(!_e||tt>=Ke))J[ve][Pe]=tt,ae[ve][Pe]=2,re[ve][Pe]=0;else if(_e)J[ve][Pe]=Ke,ae[ve][Pe]=1,re[ve][Pe]=re[ve-1][Pe-1]+1;else throw new Error("not possible")}}if(se&&K(T,V,X,be),!Ze[0]&&!ye.firstMatchCanBeWeak)return;ve--,Pe--;const et=[J[ve][Pe],be];let xe=0,x=0;for(;ve>=1;){let de=Pe;do{const Ae=ae[ve][de];if(Ae===3)de=de-2;else if(Ae===2)de=de-1;else break}while(de>=1);xe>1&&j[V+ve-1]===oe[be+Pe-1]&&!De(de+be-1,X,oe)&&xe+1>re[ve][de]&&(de=Pe),de===Pe?xe++:xe=1,x||(x=de),ve--,Pe=de-1,et.push(Pe)}Ee===we&&ye.boostFullMatch&&(et[0]+=2);const le=x-we;return et[0]-=le,et}t.$9j=A;function F(T,j,V,X,oe,be){let ye=T-1,we=j-1;for(;ye>=V&&we>=X;)oe[ye]===be[we]&&(Be[ye]=we,ye--),we--}function r(T,j,V,X,oe,be,ye,we,Ee,ve,Pe){if(j[V]!==be[ye])return Number.MIN_SAFE_INTEGER;let Ie=1,Me=!1;return ye===V-X?Ie=T[V]===oe[ye]?7:5:De(ye,oe,be)&&(ye===0||!De(ye-1,oe,be))?(Ie=T[V]===oe[ye]?7:5,Me=!0):ie(be,ye)&&(ye===0||!ie(be,ye-1))?Ie=5:(ie(be,ye-1)||fe(be,ye-1))&&(Ie=5,Me=!0),Ie>1&&V===X&&(Pe[0]=!0),Me||(Me=De(ye,oe,be)||ie(be,ye-1)||fe(be,ye-1)),V===X?ye>Ee&&(Ie-=Me?3:5):ve?Ie+=Me?2:0:Ie+=Me?0:1,ye+1===we&&(Ie-=Me?3:5),Ie}function i(T,j,V,X,oe,be,ye){return w(T,j,V,X,oe,be,!0,ye)}t.$0j=i;function o(T,j,V,X,oe,be,ye){return w(T,j,V,X,oe,be,!1,ye)}t.$$j=o;function w(T,j,V,X,oe,be,ye,we){let Ee=A(T,j,V,X,oe,be,we);if(Ee&&!ye)return Ee;if(T.length>=3){const ve=Math.min(7,T.length-1);for(let Pe=V+1;Pe<ve;Pe++){const Ie=I(T,Pe);if(Ie){const Me=A(Ie,Ie.toLowerCase(),V,X,oe,be,we);Me&&(Me[0]-=3,(!Ee||Me[0]>Ee[0])&&(Ee=Me))}}}return Ee}function I(T,j){if(j+1>=T.length)return;const V=T[j],X=T[j+1];if(V!==X)return T.slice(0,j)+X+V+T.slice(j+2)}}),define($e[49],pe([1,0,10]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2i=t.$1i=t.$Zi=t.$Yi=t.$Xi=t.$Wi=t.$Vi=void 0;function C(c){return n(c,0)}t.$Vi=C;function n(c,a){switch(typeof c){case"object":return c===null?H(349,a):Array.isArray(c)?m(c,a):p(c,a);case"string":return k(c,a);case"boolean":return D(c,a);case"number":return H(c,a);case"undefined":return H(937,a);default:return H(617,a)}}t.$Wi=n;function H(c,a){return(a<<5)-a+c|0}t.$Xi=H;function D(c,a){return H(c?433:863,a)}function k(c,a){a=H(149417,a);for(let $=0,d=c.length;$<d;$++)a=H(c.charCodeAt($),a);return a}t.$Yi=k;function m(c,a){return a=H(104579,a),c.reduce(($,d)=>n(d,$),a)}function p(c,a){return a=H(181387,a),Object.keys(c).sort().reduce(($,d)=>($=k(d,$),n(c[d],$)),a)}class v{constructor(){this.g=0}get value(){return this.g}hash(a){return this.g=n(a,this.g),this.g}}t.$Zi=v;var M;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function l(c,a,$=32){const d=$-a,b=~((1<<d)-1);return(c<<a|(b&c)>>>d)>>>0}function h(c,a=0,$=c.byteLength,d=0){for(let b=0;b<$;b++)c[a+b]=d}function e(c,a,$="0"){for(;c.length<a;)c=$+c;return c}function s(c,a=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map($=>$.toString(16).padStart(2,"0")).join(""):e((c>>>0).toString(16),a/4)}t.$1i=s;class f{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(a){const $=a.length;if($===0)return;const d=this.p;let b=this.r,u=this.u,N,B;for(u!==0?(N=u,B=-1,u=0):(N=a.charCodeAt(0),B=0);;){let R=N;if(E.$ef(N))if(B+1<$){const W=a.charCodeAt(B+1);E.$ff(W)?(B++,R=E.$gf(N,W)):R=65533}else{u=N;break}else E.$ff(N)&&(R=65533);if(b=this.w(d,b,R),B++,B<$)N=a.charCodeAt(B);else break}this.r=b,this.u=u}w(a,$,d){return d<128?a[$++]=d:d<2048?(a[$++]=192|(d&1984)>>>6,a[$++]=128|(d&63)>>>0):d<65536?(a[$++]=224|(d&61440)>>>12,a[$++]=128|(d&4032)>>>6,a[$++]=128|(d&63)>>>0):(a[$++]=240|(d&1835008)>>>18,a[$++]=128|(d&258048)>>>12,a[$++]=128|(d&4032)>>>6,a[$++]=128|(d&63)>>>0),$>=64&&(this.y(),$-=64,this.t+=64,a[0]=a[64],a[1]=a[65],a[2]=a[66]),$}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),s(this.h)+s(this.l)+s(this.m)+s(this.n)+s(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const a=8*this.t;this.q.setUint32(56,Math.floor(a/4294967296),!1),this.q.setUint32(60,a%4294967296,!1),this.y()}y(){const a=f.g,$=this.q;for(let y=0;y<64;y+=4)a.setUint32(y,$.getUint32(y,!1),!1);for(let y=64;y<320;y+=4)a.setUint32(y,l(a.getUint32(y-12,!1)^a.getUint32(y-32,!1)^a.getUint32(y-56,!1)^a.getUint32(y-64,!1),1),!1);let d=this.h,b=this.l,u=this.m,N=this.n,B=this.o,R,W,z;for(let y=0;y<80;y++)y<20?(R=b&u|~b&N,W=1518500249):y<40?(R=b^u^N,W=1859775393):y<60?(R=b&u|b&N|u&N,W=2400959708):(R=b^u^N,W=3395469782),z=l(d,5)+R+B+W+a.getUint32(y*4,!1)&4294967295,B=N,N=u,u=l(b,30),b=d,d=z;this.h=this.h+d&4294967295,this.l=this.l+b&4294967295,this.m=this.m+u&4294967295,this.n=this.n+N&4294967295,this.o=this.o+B&4294967295}}t.$2i=f}),define($e[87],pe([1,0,75,49]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3s=t.$2s=t.$1s=void 0;class n{constructor(l){this.a=l}getElements(){const l=this.a,h=new Int32Array(l.length);for(let e=0,s=l.length;e<s;e++)h[e]=l.charCodeAt(e);return h}}t.$1s=n;function H(M,l,h){return new v(new n(M),new n(l)).ComputeDiff(h).changes}t.$2s=H;class D{static Assert(l,h){if(!l)throw new Error(h)}}class k{static Copy(l,h,e,s,f){for(let c=0;c<f;c++)e[s+c]=l[h+c]}static Copy2(l,h,e,s,f){for(let c=0;c<f;c++)e[s+c]=l[h+c]}}var m;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class p{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new E.$Zs(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(l,h){this.b=Math.min(this.b,l),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(l,h){this.b=Math.min(this.b,l),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class v{constructor(l,h,e=null){this.a=e,this.b=l,this.c=h;const[s,f,c]=v.o(l),[a,$,d]=v.o(h);this.d=c&&d,this.e=s,this.f=f,this.g=a,this.h=$,this.k=[],this.m=[]}static n(l){return l.length>0&&typeof l[0]=="string"}static o(l){const h=l.getElements();if(v.n(h)){const e=new Int32Array(h.length);for(let s=0,f=h.length;s<f;s++)e[s]=(0,C.$Yi)(h[s],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(l,h){return this.f[l]!==this.h[h]?!1:this.d?this.e[l]===this.g[h]:!0}q(l,h){if(!this.p(l,h))return!1;const e=v.r(this.b,l),s=v.r(this.c,h);return e===s}static r(l,h){return typeof l.getStrictElement=="function"?l.getStrictElement(h):null}s(l,h){return this.f[l]!==this.f[h]?!1:this.d?this.e[l]===this.e[h]:!0}u(l,h){return this.h[l]!==this.h[h]?!1:this.d?this.g[l]===this.g[h]:!0}ComputeDiff(l){return this.v(0,this.f.length-1,0,this.h.length-1,l)}v(l,h,e,s,f){const c=[!1];let a=this.w(l,h,e,s,c);return f&&(a=this.z(a)),{quitEarly:c[0],changes:a}}w(l,h,e,s,f){for(f[0]=!1;l<=h&&e<=s&&this.p(l,e);)l++,e++;for(;h>=l&&s>=e&&this.p(h,s);)h--,s--;if(l>h||e>s){let u;return e<=s?(D.Assert(l===h+1,"originalStart should only be one more than originalEnd"),u=[new E.$Zs(l,0,e,s-e+1)]):l<=h?(D.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),u=[new E.$Zs(l,h-l+1,e,0)]):(D.Assert(l===h+1,"originalStart should only be one more than originalEnd"),D.Assert(e===s+1,"modifiedStart should only be one more than modifiedEnd"),u=[]),u}const c=[0],a=[0],$=this.y(l,h,e,s,c,a,f),d=c[0],b=a[0];if($!==null)return $;if(!f[0]){const u=this.w(l,d,e,b,f);let N=[];return f[0]?N=[new E.$Zs(d+1,h-(d+1)+1,b+1,s-(b+1)+1)]:N=this.w(d+1,h,b+1,s,f),this.H(u,N)}return[new E.$Zs(l,h-l+1,e,s-e+1)]}x(l,h,e,s,f,c,a,$,d,b,u,N,B,R,W,z,y,O){let U=null,S=null,P=new p,L=h,G=e,Z=B[0]-z[0]-s,ge=-1073741824,ue=this.k.length-1;do{const te=Z+l;te===L||te<G&&d[te-1]<d[te+1]?(u=d[te+1],R=u-Z-s,u<ge&&P.MarkNextChange(),ge=u,P.AddModifiedElement(u+1,R),Z=te+1-l):(u=d[te-1]+1,R=u-Z-s,u<ge&&P.MarkNextChange(),ge=u-1,P.AddOriginalElement(u,R+1),Z=te-1-l),ue>=0&&(d=this.k[ue],l=d[0],L=1,G=d.length-1)}while(--ue>=-1);if(U=P.getReverseChanges(),O[0]){let te=B[0]+1,me=z[0]+1;if(U!==null&&U.length>0){const Re=U[U.length-1];te=Math.max(te,Re.getOriginalEnd()),me=Math.max(me,Re.getModifiedEnd())}S=[new E.$Zs(te,N-te+1,me,W-me+1)]}else{P=new p,L=c,G=a,Z=B[0]-z[0]-$,ge=1073741824,ue=y?this.m.length-1:this.m.length-2;do{const te=Z+f;te===L||te<G&&b[te-1]>=b[te+1]?(u=b[te+1]-1,R=u-Z-$,u>ge&&P.MarkNextChange(),ge=u+1,P.AddOriginalElement(u+1,R+1),Z=te+1-f):(u=b[te-1],R=u-Z-$,u>ge&&P.MarkNextChange(),ge=u,P.AddModifiedElement(u+1,R+1),Z=te-1-f),ue>=0&&(b=this.m[ue],f=b[0],L=1,G=b.length-1)}while(--ue>=-1);S=P.getChanges()}return this.H(U,S)}y(l,h,e,s,f,c,a){let $=0,d=0,b=0,u=0,N=0,B=0;l--,e--,f[0]=0,c[0]=0,this.k=[],this.m=[];const R=h-l+(s-e),W=R+1,z=new Int32Array(W),y=new Int32Array(W),O=s-e,U=h-l,S=l-e,P=h-s,G=(U-O)%2===0;z[O]=l,y[U]=h,a[0]=!1;for(let Z=1;Z<=R/2+1;Z++){let ge=0,ue=0;b=this.J(O-Z,Z,O,W),u=this.J(O+Z,Z,O,W);for(let me=b;me<=u;me+=2){me===b||me<u&&z[me-1]<z[me+1]?$=z[me+1]:$=z[me-1]+1,d=$-(me-O)-S;const Re=$;for(;$<h&&d<s&&this.p($+1,d+1);)$++,d++;if(z[me]=$,$+d>ge+ue&&(ge=$,ue=d),!G&&Math.abs(me-U)<=Z-1&&$>=y[me])return f[0]=$,c[0]=d,Re<=y[me]&&1447>0&&Z<=1448?this.x(O,b,u,S,U,N,B,P,z,y,$,h,f,d,s,c,G,a):null}const te=(ge-l+(ue-e)-Z)/2;if(this.a!==null&&!this.a(ge,te))return a[0]=!0,f[0]=ge,c[0]=ue,te>0&&1447>0&&Z<=1448?this.x(O,b,u,S,U,N,B,P,z,y,$,h,f,d,s,c,G,a):(l++,e++,[new E.$Zs(l,h-l+1,e,s-e+1)]);N=this.J(U-Z,Z,U,W),B=this.J(U+Z,Z,U,W);for(let me=N;me<=B;me+=2){me===N||me<B&&y[me-1]>=y[me+1]?$=y[me+1]-1:$=y[me-1],d=$-(me-U)-P;const Re=$;for(;$>l&&d>e&&this.p($,d);)$--,d--;if(y[me]=$,G&&Math.abs(me-O)<=Z&&$<=z[me])return f[0]=$,c[0]=d,Re>=z[me]&&1447>0&&Z<=1448?this.x(O,b,u,S,U,N,B,P,z,y,$,h,f,d,s,c,G,a):null}if(Z<=1447){let me=new Int32Array(u-b+2);me[0]=O-b+1,k.Copy2(z,b,me,1,u-b+1),this.k.push(me),me=new Int32Array(B-N+2),me[0]=U-N+1,k.Copy2(y,N,me,1,B-N+1),this.m.push(me)}}return this.x(O,b,u,S,U,N,B,P,z,y,$,h,f,d,s,c,G,a)}z(l){for(let h=0;h<l.length;h++){const e=l[h],s=h<l.length-1?l[h+1].originalStart:this.f.length,f=h<l.length-1?l[h+1].modifiedStart:this.h.length,c=e.originalLength>0,a=e.modifiedLength>0;for(;e.originalStart+e.originalLength<s&&e.modifiedStart+e.modifiedLength<f&&(!c||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!a||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const d=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!d)break;e.originalStart++,e.modifiedStart++}const $=[null];if(h<l.length-1&&this.I(l[h],l[h+1],$)){l[h]=$[0],l.splice(h+1,1),h--;continue}}for(let h=l.length-1;h>=0;h--){const e=l[h];let s=0,f=0;if(h>0){const u=l[h-1];s=u.originalStart+u.originalLength,f=u.modifiedStart+u.modifiedLength}const c=e.originalLength>0,a=e.modifiedLength>0;let $=0,d=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let u=1;;u++){const N=e.originalStart-u,B=e.modifiedStart-u;if(N<s||B<f||c&&!this.s(N,N+e.originalLength)||a&&!this.u(B,B+e.modifiedLength))break;const W=(N===s&&B===f?5:0)+this.G(N,e.originalLength,B,e.modifiedLength);W>d&&(d=W,$=u)}e.originalStart-=$,e.modifiedStart-=$;const b=[null];if(h>0&&this.I(l[h-1],l[h],b)){l[h-1]=b[0],l.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=l.length;h<e;h++){const s=l[h-1],f=l[h],c=f.originalStart-s.originalStart-s.originalLength,a=s.originalStart,$=f.originalStart+f.originalLength,d=$-a,b=s.modifiedStart,u=f.modifiedStart+f.modifiedLength,N=u-b;if(c<5&&d<20&&N<20){const B=this.A(a,d,b,N,c);if(B){const[R,W]=B;(R!==s.originalStart+s.originalLength||W!==s.modifiedStart+s.modifiedLength)&&(s.originalLength=R-s.originalStart,s.modifiedLength=W-s.modifiedStart,f.originalStart=R+c,f.modifiedStart=W+c,f.originalLength=$-f.originalStart,f.modifiedLength=u-f.modifiedStart)}}}return l}A(l,h,e,s,f){if(h<f||s<f)return null;const c=l+h-f+1,a=e+s-f+1;let $=0,d=0,b=0;for(let u=l;u<c;u++)for(let N=e;N<a;N++){const B=this.B(u,N,f);B>0&&B>$&&($=B,d=u,b=N)}return $>0?[d,b]:null}B(l,h,e){let s=0;for(let f=0;f<e;f++){if(!this.p(l+f,h+f))return 0;s+=this.e[l+f].length}return s}C(l){return l<=0||l>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[l])}D(l,h){if(this.C(l)||this.C(l-1))return!0;if(h>0){const e=l+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(l){return l<=0||l>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[l])}F(l,h){if(this.E(l)||this.E(l-1))return!0;if(h>0){const e=l+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(l,h,e,s){const f=this.D(l,h)?1:0,c=this.F(e,s)?1:0;return f+c}H(l,h){const e=[];if(l.length===0||h.length===0)return h.length>0?h:l;if(this.I(l[l.length-1],h[0],e)){const s=new Array(l.length+h.length-1);return k.Copy(l,0,s,0,l.length-1),s[l.length-1]=e[0],k.Copy(h,1,s,l.length,h.length-1),s}else{const s=new Array(l.length+h.length);return k.Copy(l,0,s,0,l.length),k.Copy(h,0,s,l.length,h.length),s}}I(l,h,e){if(D.Assert(l.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),D.Assert(l.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=h.originalStart||l.modifiedStart+l.modifiedLength>=h.modifiedStart){const s=l.originalStart;let f=l.originalLength;const c=l.modifiedStart;let a=l.modifiedLength;return l.originalStart+l.originalLength>=h.originalStart&&(f=h.originalStart+h.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=h.modifiedStart&&(a=h.modifiedStart+h.modifiedLength-l.modifiedStart),e[0]=new E.$Zs(s,f,c,a),!0}else return e[0]=null,!1}J(l,h,e,s){if(l>=0&&l<s)return l;const f=e,c=s-e-1,a=h%2===0;if(l<0){const $=f%2===0;return a===$?0:1}else{const $=c%2===0;return a===$?s-1:s-2}}}t.$3s=v}),define($e[50],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Td=void 0,t.$Td=Symbol("MicrotaskDelay")}),define($e[88],pe([1,0,12,10]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bi=t.$ai=t.$_h=t.$$h=t.$0h=void 0;class n{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),s=this.b.charCodeAt(this.c);return e-s}value(){return this.b[this.c]}}t.$0h=n;class H{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$7e)(h,this.b,0,h.length,this.c,this.d):(0,C.$9e)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$$h=H;class D{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const s=this.b.charCodeAt(e);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$7e)(h,this.b,0,h.length,this.d,this.e):(0,C.$9e)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$_h=D;var k;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(k||(k={}));class m{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$8e)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$8e)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$6e)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$6e)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$ai=m;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(v||(v={}));class M{static forUris(h=()=>!1,e=()=>!1){return new M(new m(h,e))}static forPaths(h=!1){return new M(new D(void 0,!h))}static forStrings(){return new M(new n)}static forConfigKeys(){return new M(new H)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const s=e.slice(0);(0,E.$Xb)(s);for(const f of s)this.set(f,h)}else{const s=h.slice(0);(0,E.$Xb)(s);for(const f of s)this.set(f[0],f[1])}}set(h,e){const s=this.b.reset(h);let f;this.c||(this.c=new p,this.c.segment=s.value());const c=[];for(f=this.c;;){const $=s.cmp(f.segment);if($>0)f.left||(f.left=new p,f.left.segment=s.value()),c.push([-1,f]),f=f.left;else if($<0)f.right||(f.right=new p,f.right.segment=s.value()),c.push([1,f]),f=f.right;else if(s.hasNext())s.next(),f.mid||(f.mid=new p,f.mid.segment=s.value()),c.push([0,f]),f=f.mid;else break}const a=f.value;f.value=e,f.key=h;for(let $=c.length-1;$>=0;$--){const d=c[$][1];d.updateHeight();const b=d.balanceFactor();if(b<-1||b>1){const u=c[$][0],N=c[$+1][0];if(u===1&&N===1)c[$][1]=d.rotateLeft();else if(u===-1&&N===-1)c[$][1]=d.rotateRight();else if(u===1&&N===-1)d.right=c[$+1][1]=c[$+1][1].rotateRight(),c[$][1]=d.rotateLeft();else if(u===-1&&N===1)d.left=c[$+1][1]=c[$+1][1].rotateLeft(),c[$][1]=d.rotateRight();else throw new Error;if($>0)switch(c[$-1][0]){case-1:c[$-1][1].left=c[$][1];break;case 1:c[$-1][1].right=c[$][1];break;case 0:c[$-1][1].mid=c[$][1];break}else this.c=c[0][1]}}return a}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let s=this.c;for(;s;){const f=e.cmp(s.segment);if(f>0)s=s.left;else if(f<0)s=s.right;else if(e.hasNext())e.next(),s=s.mid;else break}return s}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const s=this.b.reset(h),f=[];let c=this.c;for(;c;){const a=s.cmp(c.segment);if(a>0)f.push([-1,c]),c=c.left;else if(a<0)f.push([1,c]),c=c.right;else if(s.hasNext())s.next(),f.push([0,c]),c=c.mid;else break}if(c){if(e?(c.left=void 0,c.mid=void 0,c.right=void 0,c.height=1):(c.key=void 0,c.value=void 0),!c.mid&&!c.value)if(c.left&&c.right){const a=this.f(c.right);if(a.key){const{key:$,value:d,segment:b}=a;this.e(a.key,!1),c.key=$,c.value=d,c.segment=b}}else{const a=c.left??c.right;if(f.length>0){const[$,d]=f[f.length-1];switch($){case-1:d.left=a;break;case 0:d.mid=a;break;case 1:d.right=a;break}}else this.c=a}for(let a=f.length-1;a>=0;a--){const $=f[a][1];$.updateHeight();const d=$.balanceFactor();if(d>1?($.right.balanceFactor()>=0||($.right=$.right.rotateRight()),f[a][1]=$.rotateLeft()):d<-1&&($.left.balanceFactor()<=0||($.left=$.left.rotateLeft()),f[a][1]=$.rotateRight()),a>0)switch(f[a-1][0]){case-1:f[a-1][1].left=f[a][1];break;case 1:f[a-1][1].right=f[a][1];break;case 0:f[a-1][1].mid=f[a][1];break}else this.c=f[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let s=this.c,f;for(;s;){const c=e.cmp(s.segment);if(c>0)s=s.left;else if(c<0)s=s.right;else if(e.hasNext())e.next(),f=s.value||f,s=s.mid;else break}return s&&s.value||f}findSuperstr(h){return this.g(h,!1)}g(h,e){const s=this.b.reset(h);let f=this.c;for(;f;){const c=s.cmp(f.segment);if(c>0)f=f.left;else if(c<0)f=f.right;else if(s.hasNext())s.next(),f=f.mid;else return f.mid?this.h(f.mid):e?f.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,s]of this)h(s,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const s=e.balanceFactor();return s<-1||s>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$bi=M}),define($e[7],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1f=t.$Zf=t.$Yf=t.$Xf=t.$Wf=t.$Vf=t.$Uf=t.$Tf=t.$Sf=t.$Rf=t.$Qf=t.$Pf=t.$Of=t.$Nf=t.$Mf=t.$Lf=t.$Kf=t.$Jf=void 0;function E(b){return typeof b=="string"}t.$Jf=E;function C(b){return Array.isArray(b)&&b.every(u=>E(u))}t.$Kf=C;function n(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}t.$Lf=n;function H(b){const u=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof u}t.$Mf=H;function D(b){return typeof b=="number"&&!isNaN(b)}t.$Nf=D;function k(b){return!!b&&typeof b[Symbol.iterator]=="function"}t.$Of=k;function m(b){return b===!0||b===!1}t.$Pf=m;function p(b){return typeof b>"u"}t.$Qf=p;function v(b){return!M(b)}t.$Rf=v;function M(b){return p(b)||b===null}t.$Sf=M;function l(b,u){if(!b)throw new Error(u?`Unexpected type, expected '${u}'`:"Unexpected type")}t.$Tf=l;function h(b){if(M(b))throw new Error("Assertion Failed: argument is undefined or null");return b}t.$Uf=h;function e(...b){const u=[];for(let N=0;N<b.length;N++){const B=b[N];if(M(B))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);u.push(B)}return u}t.$Vf=e;const s=Object.prototype.hasOwnProperty;function f(b){if(!n(b))return!1;for(const u in b)if(s.call(b,u))return!1;return!0}t.$Wf=f;function c(b){return typeof b=="function"}t.$Xf=c;function a(...b){return b.length>0&&b.every(c)}t.$Yf=a;function $(b,u){const N=Math.min(b.length,u.length);for(let B=0;B<N;B++)d(b[B],u[B])}t.$Zf=$;function d(b,u){if(E(u)){if(typeof b!==u)throw new Error(`argument does not match constraint: typeof ${u}`)}else if(c(u)){try{if(b instanceof u)return}catch{}if(!M(b)&&b.constructor===u||u.length===1&&u.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.$1f=d}),define($e[17],pe([1,0,7]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bk=t.$ak=t.$_j=void 0;const C=Object.create(null);function n(k,m){if((0,E.$Jf)(m)){const p=C[m];if(p===void 0)throw new Error(`${k} references an unknown codicon: ${m}`);m=p}return C[k]=m,{id:k}}function H(){return C}t.$_j=H;function D(){return Object.values(t.$bk)}t.$ak=D,t.$bk={add:n("add",6e4),plus:n("plus",6e4),gistNew:n("gist-new",6e4),repoCreate:n("repo-create",6e4),lightbulb:n("lightbulb",60001),lightBulb:n("light-bulb",60001),repo:n("repo",60002),repoDelete:n("repo-delete",60002),gistFork:n("gist-fork",60003),repoForked:n("repo-forked",60003),gitPullRequest:n("git-pull-request",60004),gitPullRequestAbandoned:n("git-pull-request-abandoned",60004),recordKeys:n("record-keys",60005),keyboard:n("keyboard",60005),tag:n("tag",60006),tagAdd:n("tag-add",60006),tagRemove:n("tag-remove",60006),gitPullRequestLabel:n("git-pull-request-label",60006),person:n("person",60007),personFollow:n("person-follow",60007),personOutline:n("person-outline",60007),personFilled:n("person-filled",60007),gitBranch:n("git-branch",60008),gitBranchCreate:n("git-branch-create",60008),gitBranchDelete:n("git-branch-delete",60008),sourceControl:n("source-control",60008),mirror:n("mirror",60009),mirrorPublic:n("mirror-public",60009),star:n("star",60010),starAdd:n("star-add",60010),starDelete:n("star-delete",60010),starEmpty:n("star-empty",60010),comment:n("comment",60011),commentAdd:n("comment-add",60011),alert:n("alert",60012),warning:n("warning",60012),search:n("search",60013),searchSave:n("search-save",60013),logOut:n("log-out",60014),signOut:n("sign-out",60014),logIn:n("log-in",60015),signIn:n("sign-in",60015),eye:n("eye",60016),eyeUnwatch:n("eye-unwatch",60016),eyeWatch:n("eye-watch",60016),circleFilled:n("circle-filled",60017),primitiveDot:n("primitive-dot",60017),closeDirty:n("close-dirty",60017),debugBreakpoint:n("debug-breakpoint",60017),debugBreakpointDisabled:n("debug-breakpoint-disabled",60017),debugBreakpointPending:n("debug-breakpoint-pending",60377),debugHint:n("debug-hint",60017),primitiveSquare:n("primitive-square",60018),edit:n("edit",60019),pencil:n("pencil",60019),info:n("info",60020),issueOpened:n("issue-opened",60020),gistPrivate:n("gist-private",60021),gitForkPrivate:n("git-fork-private",60021),lock:n("lock",60021),mirrorPrivate:n("mirror-private",60021),close:n("close",60022),removeClose:n("remove-close",60022),x:n("x",60022),repoSync:n("repo-sync",60023),sync:n("sync",60023),clone:n("clone",60024),desktopDownload:n("desktop-download",60024),beaker:n("beaker",60025),microscope:n("microscope",60025),vm:n("vm",60026),deviceDesktop:n("device-desktop",60026),file:n("file",60027),fileText:n("file-text",60027),more:n("more",60028),ellipsis:n("ellipsis",60028),kebabHorizontal:n("kebab-horizontal",60028),mailReply:n("mail-reply",60029),reply:n("reply",60029),organization:n("organization",60030),organizationFilled:n("organization-filled",60030),organizationOutline:n("organization-outline",60030),newFile:n("new-file",60031),fileAdd:n("file-add",60031),newFolder:n("new-folder",60032),fileDirectoryCreate:n("file-directory-create",60032),trash:n("trash",60033),trashcan:n("trashcan",60033),history:n("history",60034),clock:n("clock",60034),folder:n("folder",60035),fileDirectory:n("file-directory",60035),symbolFolder:n("symbol-folder",60035),logoGithub:n("logo-github",60036),markGithub:n("mark-github",60036),github:n("github",60036),terminal:n("terminal",60037),console:n("console",60037),repl:n("repl",60037),zap:n("zap",60038),symbolEvent:n("symbol-event",60038),error:n("error",60039),stop:n("stop",60039),variable:n("variable",60040),symbolVariable:n("symbol-variable",60040),array:n("array",60042),symbolArray:n("symbol-array",60042),symbolModule:n("symbol-module",60043),symbolPackage:n("symbol-package",60043),symbolNamespace:n("symbol-namespace",60043),symbolObject:n("symbol-object",60043),symbolMethod:n("symbol-method",60044),symbolFunction:n("symbol-function",60044),symbolConstructor:n("symbol-constructor",60044),symbolBoolean:n("symbol-boolean",60047),symbolNull:n("symbol-null",60047),symbolNumeric:n("symbol-numeric",60048),symbolNumber:n("symbol-number",60048),symbolStructure:n("symbol-structure",60049),symbolStruct:n("symbol-struct",60049),symbolParameter:n("symbol-parameter",60050),symbolTypeParameter:n("symbol-type-parameter",60050),symbolKey:n("symbol-key",60051),symbolText:n("symbol-text",60051),symbolReference:n("symbol-reference",60052),goToFile:n("go-to-file",60052),symbolEnum:n("symbol-enum",60053),symbolValue:n("symbol-value",60053),symbolRuler:n("symbol-ruler",60054),symbolUnit:n("symbol-unit",60054),activateBreakpoints:n("activate-breakpoints",60055),archive:n("archive",60056),arrowBoth:n("arrow-both",60057),arrowDown:n("arrow-down",60058),arrowLeft:n("arrow-left",60059),arrowRight:n("arrow-right",60060),arrowSmallDown:n("arrow-small-down",60061),arrowSmallLeft:n("arrow-small-left",60062),arrowSmallRight:n("arrow-small-right",60063),arrowSmallUp:n("arrow-small-up",60064),arrowUp:n("arrow-up",60065),bell:n("bell",60066),bold:n("bold",60067),book:n("book",60068),bookmark:n("bookmark",60069),debugBreakpointConditionalUnverified:n("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:n("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:n("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:n("debug-breakpoint-data-unverified",60072),debugBreakpointData:n("debug-breakpoint-data",60073),debugBreakpointDataDisabled:n("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:n("debug-breakpoint-log-unverified",60074),debugBreakpointLog:n("debug-breakpoint-log",60075),debugBreakpointLogDisabled:n("debug-breakpoint-log-disabled",60075),briefcase:n("briefcase",60076),broadcast:n("broadcast",60077),browser:n("browser",60078),bug:n("bug",60079),calendar:n("calendar",60080),caseSensitive:n("case-sensitive",60081),check:n("check",60082),checklist:n("checklist",60083),chevronDown:n("chevron-down",60084),dropDownButton:n("drop-down-button",60084),chevronLeft:n("chevron-left",60085),chevronRight:n("chevron-right",60086),chevronUp:n("chevron-up",60087),chromeClose:n("chrome-close",60088),chromeMaximize:n("chrome-maximize",60089),chromeMinimize:n("chrome-minimize",60090),chromeRestore:n("chrome-restore",60091),circle:n("circle",60092),circleOutline:n("circle-outline",60092),debugBreakpointUnverified:n("debug-breakpoint-unverified",60092),circleSlash:n("circle-slash",60093),circuitBoard:n("circuit-board",60094),clearAll:n("clear-all",60095),clippy:n("clippy",60096),closeAll:n("close-all",60097),cloudDownload:n("cloud-download",60098),cloudUpload:n("cloud-upload",60099),code:n("code",60100),collapseAll:n("collapse-all",60101),colorMode:n("color-mode",60102),commentDiscussion:n("comment-discussion",60103),compareChanges:n("compare-changes",60157),creditCard:n("credit-card",60105),dash:n("dash",60108),dashboard:n("dashboard",60109),database:n("database",60110),debugContinue:n("debug-continue",60111),debugDisconnect:n("debug-disconnect",60112),debugPause:n("debug-pause",60113),debugRestart:n("debug-restart",60114),debugStart:n("debug-start",60115),debugStepInto:n("debug-step-into",60116),debugStepOut:n("debug-step-out",60117),debugStepOver:n("debug-step-over",60118),debugStop:n("debug-stop",60119),debug:n("debug",60120),deviceCameraVideo:n("device-camera-video",60121),deviceCamera:n("device-camera",60122),deviceMobile:n("device-mobile",60123),diffAdded:n("diff-added",60124),diffIgnored:n("diff-ignored",60125),diffModified:n("diff-modified",60126),diffRemoved:n("diff-removed",60127),diffRenamed:n("diff-renamed",60128),diff:n("diff",60129),discard:n("discard",60130),editorLayout:n("editor-layout",60131),emptyWindow:n("empty-window",60132),exclude:n("exclude",60133),extensions:n("extensions",60134),eyeClosed:n("eye-closed",60135),fileBinary:n("file-binary",60136),fileCode:n("file-code",60137),fileMedia:n("file-media",60138),filePdf:n("file-pdf",60139),fileSubmodule:n("file-submodule",60140),fileSymlinkDirectory:n("file-symlink-directory",60141),fileSymlinkFile:n("file-symlink-file",60142),fileZip:n("file-zip",60143),files:n("files",60144),filter:n("filter",60145),flame:n("flame",60146),foldDown:n("fold-down",60147),foldUp:n("fold-up",60148),fold:n("fold",60149),folderActive:n("folder-active",60150),folderOpened:n("folder-opened",60151),gear:n("gear",60152),gift:n("gift",60153),gistSecret:n("gist-secret",60154),gist:n("gist",60155),gitCommit:n("git-commit",60156),gitCompare:n("git-compare",60157),gitMerge:n("git-merge",60158),githubAction:n("github-action",60159),githubAlt:n("github-alt",60160),globe:n("globe",60161),grabber:n("grabber",60162),graph:n("graph",60163),gripper:n("gripper",60164),heart:n("heart",60165),home:n("home",60166),horizontalRule:n("horizontal-rule",60167),hubot:n("hubot",60168),inbox:n("inbox",60169),issueClosed:n("issue-closed",60324),issueReopened:n("issue-reopened",60171),issues:n("issues",60172),italic:n("italic",60173),jersey:n("jersey",60174),json:n("json",60175),bracket:n("bracket",60175),kebabVertical:n("kebab-vertical",60176),key:n("key",60177),law:n("law",60178),lightbulbAutofix:n("lightbulb-autofix",60179),linkExternal:n("link-external",60180),link:n("link",60181),listOrdered:n("list-ordered",60182),listUnordered:n("list-unordered",60183),liveShare:n("live-share",60184),loading:n("loading",60185),location:n("location",60186),mailRead:n("mail-read",60187),mail:n("mail",60188),markdown:n("markdown",60189),megaphone:n("megaphone",60190),mention:n("mention",60191),milestone:n("milestone",60192),gitPullRequestMilestone:n("git-pull-request-milestone",60192),mortarBoard:n("mortar-board",60193),move:n("move",60194),multipleWindows:n("multiple-windows",60195),mute:n("mute",60196),noNewline:n("no-newline",60197),note:n("note",60198),octoface:n("octoface",60199),openPreview:n("open-preview",60200),package:n("package",60201),paintcan:n("paintcan",60202),pin:n("pin",60203),play:n("play",60204),run:n("run",60204),plug:n("plug",60205),preserveCase:n("preserve-case",60206),preview:n("preview",60207),project:n("project",60208),pulse:n("pulse",60209),question:n("question",60210),quote:n("quote",60211),radioTower:n("radio-tower",60212),reactions:n("reactions",60213),references:n("references",60214),refresh:n("refresh",60215),regex:n("regex",60216),remoteExplorer:n("remote-explorer",60217),remote:n("remote",60218),remove:n("remove",60219),replaceAll:n("replace-all",60220),replace:n("replace",60221),repoClone:n("repo-clone",60222),repoForcePush:n("repo-force-push",60223),repoPull:n("repo-pull",60224),repoPush:n("repo-push",60225),report:n("report",60226),requestChanges:n("request-changes",60227),rocket:n("rocket",60228),rootFolderOpened:n("root-folder-opened",60229),rootFolder:n("root-folder",60230),rss:n("rss",60231),ruby:n("ruby",60232),saveAll:n("save-all",60233),saveAs:n("save-as",60234),save:n("save",60235),screenFull:n("screen-full",60236),screenNormal:n("screen-normal",60237),searchStop:n("search-stop",60238),server:n("server",60240),settingsGear:n("settings-gear",60241),settings:n("settings",60242),shield:n("shield",60243),smiley:n("smiley",60244),sortPrecedence:n("sort-precedence",60245),splitHorizontal:n("split-horizontal",60246),splitVertical:n("split-vertical",60247),squirrel:n("squirrel",60248),starFull:n("star-full",60249),starHalf:n("star-half",60250),symbolClass:n("symbol-class",60251),symbolColor:n("symbol-color",60252),symbolCustomColor:n("symbol-customcolor",60252),symbolConstant:n("symbol-constant",60253),symbolEnumMember:n("symbol-enum-member",60254),symbolField:n("symbol-field",60255),symbolFile:n("symbol-file",60256),symbolInterface:n("symbol-interface",60257),symbolKeyword:n("symbol-keyword",60258),symbolMisc:n("symbol-misc",60259),symbolOperator:n("symbol-operator",60260),symbolProperty:n("symbol-property",60261),wrench:n("wrench",60261),wrenchSubaction:n("wrench-subaction",60261),symbolSnippet:n("symbol-snippet",60262),tasklist:n("tasklist",60263),telescope:n("telescope",60264),textSize:n("text-size",60265),threeBars:n("three-bars",60266),thumbsdown:n("thumbsdown",60267),thumbsup:n("thumbsup",60268),tools:n("tools",60269),triangleDown:n("triangle-down",60270),triangleLeft:n("triangle-left",60271),triangleRight:n("triangle-right",60272),triangleUp:n("triangle-up",60273),twitter:n("twitter",60274),unfold:n("unfold",60275),unlock:n("unlock",60276),unmute:n("unmute",60277),unverified:n("unverified",60278),verified:n("verified",60279),versions:n("versions",60280),vmActive:n("vm-active",60281),vmOutline:n("vm-outline",60282),vmRunning:n("vm-running",60283),watch:n("watch",60284),whitespace:n("whitespace",60285),wholeWord:n("whole-word",60286),window:n("window",60287),wordWrap:n("word-wrap",60288),zoomIn:n("zoom-in",60289),zoomOut:n("zoom-out",60290),listFilter:n("list-filter",60291),listFlat:n("list-flat",60292),listSelection:n("list-selection",60293),selection:n("selection",60293),listTree:n("list-tree",60294),debugBreakpointFunctionUnverified:n("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:n("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:n("debug-breakpoint-function-disabled",60296),debugStackframeActive:n("debug-stackframe-active",60297),circleSmallFilled:n("circle-small-filled",60298),debugStackframeDot:n("debug-stackframe-dot",60298),debugStackframe:n("debug-stackframe",60299),debugStackframeFocused:n("debug-stackframe-focused",60299),debugBreakpointUnsupported:n("debug-breakpoint-unsupported",60300),symbolString:n("symbol-string",60301),debugReverseContinue:n("debug-reverse-continue",60302),debugStepBack:n("debug-step-back",60303),debugRestartFrame:n("debug-restart-frame",60304),callIncoming:n("call-incoming",60306),callOutgoing:n("call-outgoing",60307),menu:n("menu",60308),expandAll:n("expand-all",60309),feedback:n("feedback",60310),gitPullRequestReviewer:n("git-pull-request-reviewer",60310),groupByRefType:n("group-by-ref-type",60311),ungroupByRefType:n("ungroup-by-ref-type",60312),account:n("account",60313),gitPullRequestAssignee:n("git-pull-request-assignee",60313),bellDot:n("bell-dot",60314),debugConsole:n("debug-console",60315),library:n("library",60316),output:n("output",60317),runAll:n("run-all",60318),syncIgnored:n("sync-ignored",60319),pinned:n("pinned",60320),githubInverted:n("github-inverted",60321),debugAlt:n("debug-alt",60305),serverProcess:n("server-process",60322),serverEnvironment:n("server-environment",60323),pass:n("pass",60324),stopCircle:n("stop-circle",60325),playCircle:n("play-circle",60326),record:n("record",60327),debugAltSmall:n("debug-alt-small",60328),vmConnect:n("vm-connect",60329),cloud:n("cloud",60330),merge:n("merge",60331),exportIcon:n("export",60332),graphLeft:n("graph-left",60333),magnet:n("magnet",60334),notebook:n("notebook",60335),redo:n("redo",60336),checkAll:n("check-all",60337),pinnedDirty:n("pinned-dirty",60338),passFilled:n("pass-filled",60339),circleLargeFilled:n("circle-large-filled",60340),circleLarge:n("circle-large",60341),circleLargeOutline:n("circle-large-outline",60341),combine:n("combine",60342),gather:n("gather",60342),table:n("table",60343),variableGroup:n("variable-group",60344),typeHierarchy:n("type-hierarchy",60345),typeHierarchySub:n("type-hierarchy-sub",60346),typeHierarchySuper:n("type-hierarchy-super",60347),gitPullRequestCreate:n("git-pull-request-create",60348),runAbove:n("run-above",60349),runBelow:n("run-below",60350),notebookTemplate:n("notebook-template",60351),debugRerun:n("debug-rerun",60352),workspaceTrusted:n("workspace-trusted",60353),workspaceUntrusted:n("workspace-untrusted",60354),workspaceUnspecified:n("workspace-unspecified",60355),terminalCmd:n("terminal-cmd",60356),terminalDebian:n("terminal-debian",60357),terminalLinux:n("terminal-linux",60358),terminalPowershell:n("terminal-powershell",60359),terminalTmux:n("terminal-tmux",60360),terminalUbuntu:n("terminal-ubuntu",60361),terminalBash:n("terminal-bash",60362),arrowSwap:n("arrow-swap",60363),copy:n("copy",60364),personAdd:n("person-add",60365),filterFilled:n("filter-filled",60366),wand:n("wand",60367),debugLineByLine:n("debug-line-by-line",60368),inspect:n("inspect",60369),layers:n("layers",60370),layersDot:n("layers-dot",60371),layersActive:n("layers-active",60372),compass:n("compass",60373),compassDot:n("compass-dot",60374),compassActive:n("compass-active",60375),azure:n("azure",60376),issueDraft:n("issue-draft",60377),gitPullRequestClosed:n("git-pull-request-closed",60378),gitPullRequestDraft:n("git-pull-request-draft",60379),debugAll:n("debug-all",60380),debugCoverage:n("debug-coverage",60381),runErrors:n("run-errors",60382),folderLibrary:n("folder-library",60383),debugContinueSmall:n("debug-continue-small",60384),beakerStop:n("beaker-stop",60385),graphLine:n("graph-line",60386),graphScatter:n("graph-scatter",60387),pieChart:n("pie-chart",60388),bracketDot:n("bracket-dot",60389),bracketError:n("bracket-error",60390),lockSmall:n("lock-small",60391),azureDevops:n("azure-devops",60392),verifiedFilled:n("verified-filled",60393),newLine:n("newline",60394),layout:n("layout",60395),layoutActivitybarLeft:n("layout-activitybar-left",60396),layoutActivitybarRight:n("layout-activitybar-right",60397),layoutPanelLeft:n("layout-panel-left",60398),layoutPanelCenter:n("layout-panel-center",60399),layoutPanelJustify:n("layout-panel-justify",60400),layoutPanelRight:n("layout-panel-right",60401),layoutPanel:n("layout-panel",60402),layoutSidebarLeft:n("layout-sidebar-left",60403),layoutSidebarRight:n("layout-sidebar-right",60404),layoutStatusbar:n("layout-statusbar",60405),layoutMenubar:n("layout-menubar",60406),layoutCentered:n("layout-centered",60407),layoutSidebarRightOff:n("layout-sidebar-right-off",60416),layoutPanelOff:n("layout-panel-off",60417),layoutSidebarLeftOff:n("layout-sidebar-left-off",60418),target:n("target",60408),indent:n("indent",60409),recordSmall:n("record-small",60410),errorSmall:n("error-small",60411),arrowCircleDown:n("arrow-circle-down",60412),arrowCircleLeft:n("arrow-circle-left",60413),arrowCircleRight:n("arrow-circle-right",60414),arrowCircleUp:n("arrow-circle-up",60415),heartFilled:n("heart-filled",60420),map:n("map",60421),mapFilled:n("map-filled",60422),circleSmall:n("circle-small",60423),bellSlash:n("bell-slash",60424),bellSlashDot:n("bell-slash-dot",60425),commentUnresolved:n("comment-unresolved",60426),gitPullRequestGoToChanges:n("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:n("git-pull-request-new-changes",60428),searchFuzzy:n("search-fuzzy",60429),commentDraft:n("comment-draft",60430),send:n("send",60431),sparkle:n("sparkle",60432),insert:n("insert",60433),mic:n("mic",60434),thumbsDownFilled:n("thumbsdown-filled",60435),thumbsUpFilled:n("thumbsup-filled",60436),coffee:n("coffee",60437),snake:n("snake",60438),game:n("game",60439),vr:n("vr",60440),chip:n("chip",60441),piano:n("piano",60442),music:n("music",60443),micFilled:n("mic-filled",60444),gitFetch:n("git-fetch",60445),copilot:n("copilot",60446),lightbulbSparkle:n("lightbulb-sparkle",60447),lightbulbSparkleAutofix:n("lightbulb-sparkle-autofix",60447),robot:n("robot",60448),sparkleFilled:n("sparkle-filled",60449),diffSingle:n("diff-single",60450),diffMultiple:n("diff-multiple",60451),surroundWith:n("surround-with",60452),gitStash:n("git-stash",60454),gitStashApply:n("git-stash-apply",60455),gitStashPop:n("git-stash-pop",60456),coverage:n("coverage",60462),runAllCoverage:n("run-all-coverage",60461),runCoverage:n("run-all-coverage",60460),dialogError:n("dialog-error","error"),dialogWarning:n("dialog-warning","warning"),dialogInfo:n("dialog-info","info"),dialogClose:n("dialog-close","close"),treeItemExpanded:n("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:n("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:n("tree-filter-on-type-off","list-selection"),treeFilterClear:n("tree-filter-clear","close"),treeItemLoading:n("tree-item-loading","loading"),menuSelection:n("menu-selection","check"),menuSubmenu:n("menu-submenu","chevron-right"),menuBarMore:n("menubar-more","more"),scrollbarButtonLeft:n("scrollbar-button-left","triangle-left"),scrollbarButtonRight:n("scrollbar-button-right","triangle-right"),scrollbarButtonUp:n("scrollbar-button-up","triangle-up"),scrollbarButtonDown:n("scrollbar-button-down","triangle-down"),toolBarMore:n("toolbar-more","more"),quickInputBack:n("quick-input-back","arrow-left")}}),define($e[51],pe([1,0,7]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Jn=t.$In=t.$Hn=t.$Gn=t.$Fn=t.$En=t.$Dn=t.$Cn=t.$Bn=t.$An=t.$zn=t.$yn=void 0;function C(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const a=Array.isArray(c)?[]:{};return Object.entries(c).forEach(([$,d])=>{a[$]=d&&typeof d=="object"?C(d):d}),a}t.$yn=C;function n(c){if(!c||typeof c!="object")return c;const a=[c];for(;a.length>0;){const $=a.shift();Object.freeze($);for(const d in $)if(H.call($,d)){const b=$[d];typeof b=="object"&&!Object.isFrozen(b)&&!(0,E.$Mf)(b)&&a.push(b)}}return c}t.$zn=n;const H=Object.prototype.hasOwnProperty;function D(c,a){return k(c,a,new Set)}t.$An=D;function k(c,a,$){if((0,E.$Sf)(c))return c;const d=a(c);if(typeof d<"u")return d;if(Array.isArray(c)){const b=[];for(const u of c)b.push(k(u,a,$));return b}if((0,E.$Lf)(c)){if($.has(c))throw new Error("Cannot clone recursive data-structure");$.add(c);const b={};for(const u in c)H.call(c,u)&&(b[u]=k(c[u],a,$));return $.delete(c),b}return c}function m(c,a,$=!0){return(0,E.$Lf)(c)?((0,E.$Lf)(a)&&Object.keys(a).forEach(d=>{d in c?$&&((0,E.$Lf)(c[d])&&(0,E.$Lf)(a[d])?m(c[d],a[d],$):c[d]=a[d]):c[d]=a[d]}),c):a}t.$Bn=m;function p(c,a){if(c===a)return!0;if(c==null||a===null||a===void 0||typeof c!=typeof a||typeof c!="object"||Array.isArray(c)!==Array.isArray(a))return!1;let $,d;if(Array.isArray(c)){if(c.length!==a.length)return!1;for($=0;$<c.length;$++)if(!p(c[$],a[$]))return!1}else{const b=[];for(d in c)b.push(d);b.sort();const u=[];for(d in a)u.push(d);if(u.sort(),!p(b,u))return!1;for($=0;$<b.length;$++)if(!p(c[b[$]],a[b[$]]))return!1}return!0}t.$Cn=p;function v(c){const a=new Set;return JSON.stringify(c,($,d)=>{if((0,E.$Lf)(d)||Array.isArray(d)){if(a.has(d))return"[Circular]";a.add(d)}return d})}t.$Dn=v;function M(c,a){const $=Object.create(null);return!c||!a||Object.keys(a).forEach(b=>{const u=c[b],N=a[b];p(u,N)||($[b]=N)}),$}t.$En=M;function l(c,a){const $=a.toLowerCase(),d=Object.keys(c).find(b=>b.toLowerCase()===$);return d?c[d]:c[a]}t.$Fn=l;function h(c,a){const $=Object.create(null);for(const[d,b]of Object.entries(c))a(d,b)&&($[d]=b);return $}t.$Gn=h;function e(c){let a=[];for(;Object.prototype!==c;)a=a.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return a}t.$Hn=e;function s(c){const a=[];for(const $ of e(c))typeof c[$]=="function"&&a.push($);return a}t.$In=s;function f(c,a){const $=b=>function(){const u=Array.prototype.slice.call(arguments,0);return a(b,u)},d={};for(const b of c)d[b]=$(b);return d}t.$Jn=f}),define($e[18],pe([1,0,17]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.$ck=t.ThemeColor=void 0;var C;(function(D){function k(m){return m&&typeof m=="object"&&typeof m.id=="string"}D.isThemeColor=k})(C||(t.ThemeColor=C={}));function n(D){return{id:D}}t.$ck=n;var H;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function m(a){const $=k.exec(a.id);if(!$)return m(E.$bk.error);const[,d,b]=$,u=["codicon","codicon-"+d];return b&&u.push("codicon-modifier-"+b.substring(1)),u}D.asClassNameArray=m;function p(a){return m(a).join(" ")}D.asClassName=p;function v(a){return"."+m(a).join(".")}D.asCSSSelector=v;function M(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(typeof a.color>"u"||C.isThemeColor(a.color))}D.isThemeIcon=M;const l=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function h(a){const $=l.exec(a);if(!$)return;const[,d]=$;return{id:d}}D.fromString=h;function e(a){return{id:a}}D.fromId=e;function s(a,$){let d=a.id;const b=d.lastIndexOf("~");return b!==-1&&(d=d.substring(0,b)),$&&(d=`${d}~${$}`),{id:d}}D.modify=s;function f(a){const $=a.id.lastIndexOf("~");if($!==-1)return a.id.substring($+1)}D.getModifier=f;function c(a,$){return a.id===$.id&&a.color?.id===$.color?.id}D.isEqual=c})(H||(t.ThemeIcon=H={}))}),define($e[36],pe([1,0,35,10,18]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ik=t.$hk=t.$gk=t.$fk=t.$ek=t.$dk=void 0;const H="$(",D=new RegExp(`\\$\\(${n.ThemeIcon.iconNameExpression}(?:${n.ThemeIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${D.source}`,"g");function m(c){return c.replace(k,(a,$)=>$?a:`\\${a}`)}t.$dk=m;const p=new RegExp(`\\\\${D.source}`,"g");function v(c){return c.replace(p,a=>`\\${a}`)}t.$ek=v;const M=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function l(c){return c.indexOf(H)===-1?c:c.replace(M,(a,$,d,b)=>d?a:$||b||"")}t.$fk=l;function h(c){return c?c.replace(/\$\((.*?)\)/g,(a,$)=>` ${$} `).trim():""}t.$gk=h;const e=new RegExp(`\\$\\(${n.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(c){e.lastIndex=0;let a="";const $=[];let d=0;for(;;){const b=e.lastIndex,u=e.exec(c),N=c.substring(b,u?.index);if(N.length>0){a+=N;for(let B=0;B<N.length;B++)$.push(d)}if(!u)break;d+=u[0].length}return{text:a,iconOffsets:$}}t.$hk=s;function f(c,a,$=!1){const{text:d,iconOffsets:b}=a;if(!b||b.length===0)return(0,E.$3j)(c,d,$);const u=(0,C.$Ue)(d," "),N=d.length-u.length,B=(0,E.$3j)(c,u,$);if(B)for(const R of B){const W=b[R.start+N]+N;R.start+=W,R.end+=W}return B}t.$ik=f}),define($e[89],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QU=t.$PU=void 0,t.$PU="vscode:contextmenu",t.$QU="vscode:onCloseContextMenu"}),define($e[90],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$XU=void 0;class E{constructor(n,H){this.a=n,this.onMessage=H}send(n){try{this.a.send("vscode:message",n.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$XU=E}),define($e[30],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const E=globalThis.vscode;t.$O=E.ipcRenderer,t.$P=E.ipcMessagePort,t.$Q=E.webFrame,t.$R=E.process,t.$S=E.context}),define($e[91],pe([1,0,89,30]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TU=void 0;let n=0;function H(k,m,p){const v=[],M=n++,l=`vscode:onContextMenu${M}`,h=(e,s,f)=>{v[s].click?.(f)};C.$O.once(l,h),C.$O.once(E.$QU,(e,s)=>{s===M&&(C.$O.removeListener(l,h),p?.())}),C.$O.send(E.$PU,M,k.map(e=>D(e,v)),l,m)}t.$TU=H;function D(k,m){const p={id:m.length,label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:typeof k.enabled=="boolean"?k.enabled:!0,visible:typeof k.visible=="boolean"?k.visible:!0};return m.push(k),Array.isArray(k.submenu)&&(p.submenu=k.submenu.map(v=>D(v,m))),p}}),define($e[52],pe([8]),{}),define($e[92],pe([8]),{}),define($e[93],pe([8]),{}),define($e[94],pe([8]),{}),define($e[95],pe([1,0,93,94]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define($e[96],pe([8]),{}),define($e[97],pe([8]),{}),define($e[98],pe([8]),{}),define($e[99],pe([8]),{}),define($e[100],pe([8]),{}),define($e[101],pe([8]),{}),define($e[102],pe([8]),{}),define($e[103],pe([8]),{}),define($e[104],pe([8]),{}),define($e[105],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define($e[106],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInput",t)}),define($e[107],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define($e[108],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define($e[109],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/inputbox/inputBox",t)}),define($e[110],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define($e[111],pe([13,11]),function(ne,t){return ne.create("vs/base/browser/ui/tree/abstractTree",t)}),define($e[112],pe([13,11]),function(ne,t){return ne.create("vs/base/common/actions",t)}),define($e[37],pe([1,0,4,3,112]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ri=t.$Qi=t.$Pi=t.$Oi=t.$Ni=t.$Mi=void 0;class H extends C.$Tc{constructor(l,h="",e="",s=!0,f){super(),this.h=this.B(new E.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=h,this.u=e,this.w=s,this.C=f}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,h){this.C&&await this.C(l)}}t.$Mi=H;class D extends C.$Tc{constructor(){super(...arguments),this.f=this.B(new E.$Wd),this.onWillRun=this.f.event,this.m=this.B(new E.$Wd),this.onDidRun=this.m.event}async run(l,h){if(!l.enabled)return;this.f.fire({action:l});let e;try{await this.u(l,h)}catch(s){e=s}this.m.fire({action:l,error:e})}async u(l,h){await l.run(h)}}t.$Ni=D;class k{constructor(){this.id=k.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let h=[];for(const e of l)e.length&&(h.length?h=[...h,new k,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$Oi=k;class m{get actions(){return this.a}constructor(l,h,e,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=h,this.class=s,this.a=e}async run(){}}t.$Pi=m;class p extends H{static{this.ID="vs.actions.empty"}constructor(){super(p.ID,n.localize(0,null),void 0,!1)}}t.$Qi=p;function v(M){return{id:M.id,label:M.label,class:M.class,enabled:M.enabled??!0,checked:M.checked,run:async(...l)=>M.run(...l),tooltip:M.label}}t.$Ri=v}),define($e[113],pe([13,11]),function(ne,t){return ne.create("vs/base/common/platform",t)}),define($e[5],pe([1,0,113]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$J=t.$I=t.$H=t.$G=t.$F=t.$E=t.$D=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.$h=t.Platform=t.$g=void 0,t.$g="en";let C=!1,n=!1,H=!1,D=!1,k=!1,m=!1,p=!1,v=!1,M=!1,l=!1,h,e=t.$g,s=t.$g,f,c;const a=globalThis;let $;typeof a.vscode<"u"&&typeof a.vscode.process<"u"?$=a.vscode.process:typeof process<"u"&&($=process);const d=typeof $?.versions?.electron=="string",b=d&&$?.type==="renderer";if(typeof $=="object"){C=$.platform==="win32",n=$.platform==="darwin",H=$.platform==="linux",D=H&&!!$.env.SNAP&&!!$.env.SNAP_REVISION,p=d,M=!!$.env.CI||!!$.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$g,e=t.$g;const S=$.env.VSCODE_NLS_CONFIG;if(S)try{const P=JSON.parse(S),L=P.availableLanguages["*"];h=P.locale,s=P.osLocale,e=L||t.$g,f=P._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!b?(c=navigator.userAgent,C=c.indexOf("Windows")>=0,n=c.indexOf("Macintosh")>=0,v=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=c.indexOf("Linux")>=0,l=c?.indexOf("Mobi")>=0,m=!0,h=E.getConfiguredDefaultLocale(E.localize(0,null))||t.$g,e=h,s=navigator.language):console.error("Unable to resolve platform.");var u;(function(S){S[S.Web=0]="Web",S[S.Mac=1]="Mac",S[S.Linux=2]="Linux",S[S.Windows=3]="Windows"})(u||(t.Platform=u={}));function N(S){switch(S){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.$h=N;let B=0;n?B=1:C?B=3:H&&(B=2),t.$i=C,t.$j=n,t.$k=H,t.$l=D,t.$m=k,t.$n=p,t.$o=m,t.$p=m&&typeof a.importScripts=="function",t.$q=t.$p?a.origin:void 0,t.$r=v,t.$s=l,t.$t=M,t.$u=B,t.$v=c,t.$w=e;var R;(function(S){function P(){return t.$w}S.value=P;function L(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}S.isDefaultVariant=L;function G(){return t.$w==="en"}S.isDefault=G})(R||(t.Language=R={})),t.$x=h,t.$y=s,t.$z=f,t.$A=typeof a.postMessage=="function"&&!a.importScripts,t.$B=(()=>{if(t.$A){const S=[];a.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let G=0,Z=S.length;G<Z;G++){const ge=S[G];if(ge.id===L.data.vscodeScheduleAsyncWork){S.splice(G,1),ge.callback();return}}});let P=0;return L=>{const G=++P;S.push({id:G,callback:L}),a.postMessage({vscodeScheduleAsyncWork:G},"*")}}return S=>setTimeout(S)})();var W;(function(S){S[S.Windows=1]="Windows",S[S.Macintosh=2]="Macintosh",S[S.Linux=3]="Linux"})(W||(t.OperatingSystem=W={})),t.OS=n||v?2:C?1:3;let z=!0,y=!1;function O(){if(!y){y=!0;const S=new Uint8Array(2);S[0]=1,S[1]=2,z=new Uint16Array(S.buffer)[0]===513}return z}t.$D=O,t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function U(S){return parseFloat(S)>=20}t.$J=U}),define($e[114],pe([1,0,16,21,5]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$OP=t.KeyboardSupport=void 0;var H;(function(D){D[D.Always=0]="Always",D[D.FullScreen=1]="FullScreen",D[D.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$OP={clipboard:{writeText:n.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:n.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:n.$m||E.$MP()?0:navigator.keyboard||E.$IP?1:2,touch:"ontouchstart"in C.$sP||navigator.maxTouchPoints>0,pointerEvents:C.$sP.PointerEvent&&("ontouchstart"in C.$sP||navigator.maxTouchPoints>0)}}),define($e[14],pe([1,0,16,45,78,5]),function(ne,t,E,C,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$WP=t.$VP=t.$UP=void 0;function D(e){if(e.charCode){const f=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(f)}const s=e.keyCode;if(s===3)return 7;if(E.$FP)switch(s){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(E.$GP){if(H.$j&&s===93)return 57;if(!H.$j&&s===92)return 57}return C.$4q[s]||0}const k=H.$j?256:2048,m=512,p=1024,v=H.$j?2048:256;function M(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.$UP=M;function l(e){const s=[];return e.ctrlKey&&s.push("ctrl"),e.shiftKey&&s.push("shift"),e.altKey&&s.push("alt"),e.metaKey&&s.push("meta"),`modifiers: [${s.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}t.$VP=l;class h{constructor(s){this._standardKeyboardEventBrand=!0;const f=s;this.browserEvent=f,this.target=f.target,this.ctrlKey=f.ctrlKey,this.shiftKey=f.shiftKey,this.altKey=f.altKey,this.metaKey=f.metaKey,this.altGraphKey=f.getModifierState("AltGraph"),this.keyCode=D(f),this.code=f.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(s){return this.a===s}c(){let s=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode);let f=0;return this.ctrlKey&&(f|=k),this.altKey&&(f|=m),this.shiftKey&&(f|=p),this.metaKey&&(f|=v),f|=s,f}d(){let s=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(s=this.keyCode),new n.$_q(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,s)}}t.$WP=h}),define($e[19],pe([1,0,16,69,5]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$TP=t.$SP=t.$RP=void 0;class H{constructor(p,v){this.timestamp=Date.now(),this.browserEvent=v,this.leftButton=v.button===0,this.middleButton=v.button===1,this.rightButton=v.button===2,this.buttons=v.buttons,this.target=v.target,this.detail=v.detail||1,v.type==="dblclick"&&(this.detail=2),this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,typeof v.pageX=="number"?(this.posx=v.pageX,this.posy=v.pageY):(this.posx=v.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=v.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const M=C.$PP.getPositionOfChildWindowRelativeToAncestorWindow(p,v.view);this.posx-=M.left,this.posy-=M.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$RP=H;class D extends H{constructor(p,v){super(p,v),this.dataTransfer=v.dataTransfer}}t.$SP=D;class k{constructor(p,v=0,M=0){this.browserEvent=p||null,this.target=p?p.target||p.targetNode||p.srcElement:null,this.deltaY=M,this.deltaX=v;let l=!1;if(E.$HP){const h=navigator.userAgent.match(/Chrome\/(\d+)/);l=(h?parseInt(h[1]):123)<=122}if(p){const h=p,e=p,s=p.view?.devicePixelRatio||1;if(typeof h.wheelDeltaY<"u")l?this.deltaY=h.wheelDeltaY/(120*s):this.deltaY=h.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(p.type==="wheel"){const f=p;f.deltaMode===f.DOM_DELTA_LINE?E.$FP&&!n.$j?this.deltaY=-p.deltaY/3:this.deltaY=-p.deltaY:this.deltaY=-p.deltaY/40}if(typeof h.wheelDeltaX<"u")E.$IP&&n.$i?this.deltaX=-(h.wheelDeltaX/120):l?this.deltaX=h.wheelDeltaX/(120*s):this.deltaX=h.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-p.detail/3;else if(p.type==="wheel"){const f=p;f.deltaMode===f.DOM_DELTA_LINE?E.$FP&&!n.$j?this.deltaX=-p.deltaX/3:this.deltaX=-p.deltaX:this.deltaX=-p.deltaX/40}this.deltaY===0&&this.deltaX===0&&p.wheelDelta&&(l?this.deltaY=p.wheelDelta/(120*s):this.deltaY=p.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$TP=k}),define($e[115],pe([1,0,5]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ec=t.$dc=t.env=t.cwd=void 0;let C;const n=globalThis.vscode;if(typeof n<"u"&&typeof n.process<"u"){const H=n.process;C={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return E.$i?"win32":E.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$dc=C.platform,t.$ec=C.arch}),define($e[24],pe([1,0,115]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tc=t.sep=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=t.$fc=void 0;const C=65,n=97,H=90,D=122,k=46,m=47,p=92,v=58,M=63;class l extends Error{constructor(N,B,R){let W;typeof B=="string"&&B.indexOf("not ")===0?(W="must not be",B=B.replace(/^not /,"")):W="must be";const z=N.indexOf(".")!==-1?"property":"argument";let y=`The "${N}" ${z} ${W} of type ${B}`;y+=`. Received type ${typeof R}`,super(y),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,N){if(u===null||typeof u!="object")throw new l(N,"Object",u)}function e(u,N){if(typeof u!="string")throw new l(N,"string",u)}const s=E.$dc==="win32";function f(u){return u===m||u===p}function c(u){return u===m}function a(u){return u>=C&&u<=H||u>=n&&u<=D}function $(u,N,B,R){let W="",z=0,y=-1,O=0,U=0;for(let S=0;S<=u.length;++S){if(S<u.length)U=u.charCodeAt(S);else{if(R(U))break;U=m}if(R(U)){if(!(y===S-1||O===1))if(O===2){if(W.length<2||z!==2||W.charCodeAt(W.length-1)!==k||W.charCodeAt(W.length-2)!==k){if(W.length>2){const P=W.lastIndexOf(B);P===-1?(W="",z=0):(W=W.slice(0,P),z=W.length-1-W.lastIndexOf(B)),y=S,O=0;continue}else if(W.length!==0){W="",z=0,y=S,O=0;continue}}N&&(W+=W.length>0?`${B}..`:"..",z=2)}else W.length>0?W+=`${B}${u.slice(y+1,S)}`:W=u.slice(y+1,S),z=S-y-1;y=S,O=0}else U===k&&O!==-1?++O:O=-1}return W}function d(u,N){h(N,"pathObject");const B=N.dir||N.root,R=N.base||`${N.name||""}${N.ext||""}`;return B?B===N.root?`${B}${R}`:`${B}${u}${R}`:R}t.$fc={resolve(...u){let N="",B="",R=!1;for(let W=u.length-1;W>=-1;W--){let z;if(W>=0){if(z=u[W],e(z,"path"),z.length===0)continue}else N.length===0?z=E.cwd():(z=E.env[`=${N}`]||E.cwd(),(z===void 0||z.slice(0,2).toLowerCase()!==N.toLowerCase()&&z.charCodeAt(2)===p)&&(z=`${N}\\`));const y=z.length;let O=0,U="",S=!1;const P=z.charCodeAt(0);if(y===1)f(P)&&(O=1,S=!0);else if(f(P))if(S=!0,f(z.charCodeAt(1))){let L=2,G=L;for(;L<y&&!f(z.charCodeAt(L));)L++;if(L<y&&L!==G){const Z=z.slice(G,L);for(G=L;L<y&&f(z.charCodeAt(L));)L++;if(L<y&&L!==G){for(G=L;L<y&&!f(z.charCodeAt(L));)L++;(L===y||L!==G)&&(U=`\\\\${Z}\\${z.slice(G,L)}`,O=L)}}}else O=1;else a(P)&&z.charCodeAt(1)===v&&(U=z.slice(0,2),O=2,y>2&&f(z.charCodeAt(2))&&(S=!0,O=3));if(U.length>0)if(N.length>0){if(U.toLowerCase()!==N.toLowerCase())continue}else N=U;if(R){if(N.length>0)break}else if(B=`${z.slice(O)}\\${B}`,R=S,S&&N.length>0)break}return B=$(B,!R,"\\",f),R?`${N}\\${B}`:`${N}${B}`||"."},normalize(u){e(u,"path");const N=u.length;if(N===0)return".";let B=0,R,W=!1;const z=u.charCodeAt(0);if(N===1)return c(z)?"\\":u;if(f(z))if(W=!0,f(u.charCodeAt(1))){let O=2,U=O;for(;O<N&&!f(u.charCodeAt(O));)O++;if(O<N&&O!==U){const S=u.slice(U,O);for(U=O;O<N&&f(u.charCodeAt(O));)O++;if(O<N&&O!==U){for(U=O;O<N&&!f(u.charCodeAt(O));)O++;if(O===N)return`\\\\${S}\\${u.slice(U)}\\`;O!==U&&(R=`\\\\${S}\\${u.slice(U,O)}`,B=O)}}}else B=1;else a(z)&&u.charCodeAt(1)===v&&(R=u.slice(0,2),B=2,N>2&&f(u.charCodeAt(2))&&(W=!0,B=3));let y=B<N?$(u.slice(B),!W,"\\",f):"";return y.length===0&&!W&&(y="."),y.length>0&&f(u.charCodeAt(N-1))&&(y+="\\"),R===void 0?W?`\\${y}`:y:W?`${R}\\${y}`:`${R}${y}`},isAbsolute(u){e(u,"path");const N=u.length;if(N===0)return!1;const B=u.charCodeAt(0);return f(B)||N>2&&a(B)&&u.charCodeAt(1)===v&&f(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let N,B;for(let z=0;z<u.length;++z){const y=u[z];e(y,"path"),y.length>0&&(N===void 0?N=B=y:N+=`\\${y}`)}if(N===void 0)return".";let R=!0,W=0;if(typeof B=="string"&&f(B.charCodeAt(0))){++W;const z=B.length;z>1&&f(B.charCodeAt(1))&&(++W,z>2&&(f(B.charCodeAt(2))?++W:R=!1))}if(R){for(;W<N.length&&f(N.charCodeAt(W));)W++;W>=2&&(N=`\\${N.slice(W)}`)}return t.$fc.normalize(N)},relative(u,N){if(e(u,"from"),e(N,"to"),u===N)return"";const B=t.$fc.resolve(u),R=t.$fc.resolve(N);if(B===R||(u=B.toLowerCase(),N=R.toLowerCase(),u===N))return"";let W=0;for(;W<u.length&&u.charCodeAt(W)===p;)W++;let z=u.length;for(;z-1>W&&u.charCodeAt(z-1)===p;)z--;const y=z-W;let O=0;for(;O<N.length&&N.charCodeAt(O)===p;)O++;let U=N.length;for(;U-1>O&&N.charCodeAt(U-1)===p;)U--;const S=U-O,P=y<S?y:S;let L=-1,G=0;for(;G<P;G++){const ge=u.charCodeAt(W+G);if(ge!==N.charCodeAt(O+G))break;ge===p&&(L=G)}if(G!==P){if(L===-1)return R}else{if(S>P){if(N.charCodeAt(O+G)===p)return R.slice(O+G+1);if(G===2)return R.slice(O+G)}y>P&&(u.charCodeAt(W+G)===p?L=G:G===2&&(L=3)),L===-1&&(L=0)}let Z="";for(G=W+L+1;G<=z;++G)(G===z||u.charCodeAt(G)===p)&&(Z+=Z.length===0?"..":"\\..");return O+=L,Z.length>0?`${Z}${R.slice(O,U)}`:(R.charCodeAt(O)===p&&++O,R.slice(O,U))},toNamespacedPath(u){if(typeof u!="string"||u.length===0)return u;const N=t.$fc.resolve(u);if(N.length<=2)return u;if(N.charCodeAt(0)===p){if(N.charCodeAt(1)===p){const B=N.charCodeAt(2);if(B!==M&&B!==k)return`\\\\?\\UNC\\${N.slice(2)}`}}else if(a(N.charCodeAt(0))&&N.charCodeAt(1)===v&&N.charCodeAt(2)===p)return`\\\\?\\${N}`;return u},dirname(u){e(u,"path");const N=u.length;if(N===0)return".";let B=-1,R=0;const W=u.charCodeAt(0);if(N===1)return f(W)?u:".";if(f(W)){if(B=R=1,f(u.charCodeAt(1))){let O=2,U=O;for(;O<N&&!f(u.charCodeAt(O));)O++;if(O<N&&O!==U){for(U=O;O<N&&f(u.charCodeAt(O));)O++;if(O<N&&O!==U){for(U=O;O<N&&!f(u.charCodeAt(O));)O++;if(O===N)return u;O!==U&&(B=R=O+1)}}}}else a(W)&&u.charCodeAt(1)===v&&(B=N>2&&f(u.charCodeAt(2))?3:2,R=B);let z=-1,y=!0;for(let O=N-1;O>=R;--O)if(f(u.charCodeAt(O))){if(!y){z=O;break}}else y=!1;if(z===-1){if(B===-1)return".";z=B}return u.slice(0,z)},basename(u,N){N!==void 0&&e(N,"ext"),e(u,"path");let B=0,R=-1,W=!0,z;if(u.length>=2&&a(u.charCodeAt(0))&&u.charCodeAt(1)===v&&(B=2),N!==void 0&&N.length>0&&N.length<=u.length){if(N===u)return"";let y=N.length-1,O=-1;for(z=u.length-1;z>=B;--z){const U=u.charCodeAt(z);if(f(U)){if(!W){B=z+1;break}}else O===-1&&(W=!1,O=z+1),y>=0&&(U===N.charCodeAt(y)?--y===-1&&(R=z):(y=-1,R=O))}return B===R?R=O:R===-1&&(R=u.length),u.slice(B,R)}for(z=u.length-1;z>=B;--z)if(f(u.charCodeAt(z))){if(!W){B=z+1;break}}else R===-1&&(W=!1,R=z+1);return R===-1?"":u.slice(B,R)},extname(u){e(u,"path");let N=0,B=-1,R=0,W=-1,z=!0,y=0;u.length>=2&&u.charCodeAt(1)===v&&a(u.charCodeAt(0))&&(N=R=2);for(let O=u.length-1;O>=N;--O){const U=u.charCodeAt(O);if(f(U)){if(!z){R=O+1;break}continue}W===-1&&(z=!1,W=O+1),U===k?B===-1?B=O:y!==1&&(y=1):B!==-1&&(y=-1)}return B===-1||W===-1||y===0||y===1&&B===W-1&&B===R+1?"":u.slice(B,W)},format:d.bind(null,"\\"),parse(u){e(u,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return N;const B=u.length;let R=0,W=u.charCodeAt(0);if(B===1)return f(W)?(N.root=N.dir=u,N):(N.base=N.name=u,N);if(f(W)){if(R=1,f(u.charCodeAt(1))){let L=2,G=L;for(;L<B&&!f(u.charCodeAt(L));)L++;if(L<B&&L!==G){for(G=L;L<B&&f(u.charCodeAt(L));)L++;if(L<B&&L!==G){for(G=L;L<B&&!f(u.charCodeAt(L));)L++;L===B?R=L:L!==G&&(R=L+1)}}}}else if(a(W)&&u.charCodeAt(1)===v){if(B<=2)return N.root=N.dir=u,N;if(R=2,f(u.charCodeAt(2))){if(B===3)return N.root=N.dir=u,N;R=3}}R>0&&(N.root=u.slice(0,R));let z=-1,y=R,O=-1,U=!0,S=u.length-1,P=0;for(;S>=R;--S){if(W=u.charCodeAt(S),f(W)){if(!U){y=S+1;break}continue}O===-1&&(U=!1,O=S+1),W===k?z===-1?z=S:P!==1&&(P=1):z!==-1&&(P=-1)}return O!==-1&&(z===-1||P===0||P===1&&z===O-1&&z===y+1?N.base=N.name=u.slice(y,O):(N.name=u.slice(y,z),N.base=u.slice(y,O),N.ext=u.slice(z,O))),y>0&&y!==R?N.dir=u.slice(0,y-1):N.dir=N.root,N},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(s){const u=/\\/g;return()=>{const N=E.cwd().replace(u,"/");return N.slice(N.indexOf("/"))}}return()=>E.cwd()})();t.$gc={resolve(...u){let N="",B=!1;for(let R=u.length-1;R>=-1&&!B;R--){const W=R>=0?u[R]:b();e(W,"path"),W.length!==0&&(N=`${W}/${N}`,B=W.charCodeAt(0)===m)}return N=$(N,!B,"/",c),B?`/${N}`:N.length>0?N:"."},normalize(u){if(e(u,"path"),u.length===0)return".";const N=u.charCodeAt(0)===m,B=u.charCodeAt(u.length-1)===m;return u=$(u,!N,"/",c),u.length===0?N?"/":B?"./":".":(B&&(u+="/"),N?`/${u}`:u)},isAbsolute(u){return e(u,"path"),u.length>0&&u.charCodeAt(0)===m},join(...u){if(u.length===0)return".";let N;for(let B=0;B<u.length;++B){const R=u[B];e(R,"path"),R.length>0&&(N===void 0?N=R:N+=`/${R}`)}return N===void 0?".":t.$gc.normalize(N)},relative(u,N){if(e(u,"from"),e(N,"to"),u===N||(u=t.$gc.resolve(u),N=t.$gc.resolve(N),u===N))return"";const B=1,R=u.length,W=R-B,z=1,y=N.length-z,O=W<y?W:y;let U=-1,S=0;for(;S<O;S++){const L=u.charCodeAt(B+S);if(L!==N.charCodeAt(z+S))break;L===m&&(U=S)}if(S===O)if(y>O){if(N.charCodeAt(z+S)===m)return N.slice(z+S+1);if(S===0)return N.slice(z+S)}else W>O&&(u.charCodeAt(B+S)===m?U=S:S===0&&(U=0));let P="";for(S=B+U+1;S<=R;++S)(S===R||u.charCodeAt(S)===m)&&(P+=P.length===0?"..":"/..");return`${P}${N.slice(z+U)}`},toNamespacedPath(u){return u},dirname(u){if(e(u,"path"),u.length===0)return".";const N=u.charCodeAt(0)===m;let B=-1,R=!0;for(let W=u.length-1;W>=1;--W)if(u.charCodeAt(W)===m){if(!R){B=W;break}}else R=!1;return B===-1?N?"/":".":N&&B===1?"//":u.slice(0,B)},basename(u,N){N!==void 0&&e(N,"ext"),e(u,"path");let B=0,R=-1,W=!0,z;if(N!==void 0&&N.length>0&&N.length<=u.length){if(N===u)return"";let y=N.length-1,O=-1;for(z=u.length-1;z>=0;--z){const U=u.charCodeAt(z);if(U===m){if(!W){B=z+1;break}}else O===-1&&(W=!1,O=z+1),y>=0&&(U===N.charCodeAt(y)?--y===-1&&(R=z):(y=-1,R=O))}return B===R?R=O:R===-1&&(R=u.length),u.slice(B,R)}for(z=u.length-1;z>=0;--z)if(u.charCodeAt(z)===m){if(!W){B=z+1;break}}else R===-1&&(W=!1,R=z+1);return R===-1?"":u.slice(B,R)},extname(u){e(u,"path");let N=-1,B=0,R=-1,W=!0,z=0;for(let y=u.length-1;y>=0;--y){const O=u.charCodeAt(y);if(O===m){if(!W){B=y+1;break}continue}R===-1&&(W=!1,R=y+1),O===k?N===-1?N=y:z!==1&&(z=1):N!==-1&&(z=-1)}return N===-1||R===-1||z===0||z===1&&N===R-1&&N===B+1?"":u.slice(N,R)},format:d.bind(null,"/"),parse(u){e(u,"path");const N={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return N;const B=u.charCodeAt(0)===m;let R;B?(N.root="/",R=1):R=0;let W=-1,z=0,y=-1,O=!0,U=u.length-1,S=0;for(;U>=R;--U){const P=u.charCodeAt(U);if(P===m){if(!O){z=U+1;break}continue}y===-1&&(O=!1,y=U+1),P===k?W===-1?W=U:S!==1&&(S=1):W!==-1&&(S=-1)}if(y!==-1){const P=z===0&&B?1:z;W===-1||S===0||S===1&&W===y-1&&W===z+1?N.base=N.name=u.slice(P,y):(N.name=u.slice(P,W),N.base=u.slice(P,y),N.ext=u.slice(W,y))}return z>0?N.dir=u.slice(0,z-1):B&&(N.dir="/"),N},sep:"/",delimiter:":",win32:null,posix:null},t.$gc.win32=t.$fc.win32=t.$fc,t.$gc.posix=t.$fc.posix=t.$gc,t.$hc=s?t.$fc.normalize:t.$gc.normalize,t.$ic=s?t.$fc.isAbsolute:t.$gc.isAbsolute,t.$jc=s?t.$fc.join:t.$gc.join,t.$kc=s?t.$fc.resolve:t.$gc.resolve,t.$lc=s?t.$fc.relative:t.$gc.relative,t.$mc=s?t.$fc.dirname:t.$gc.dirname,t.$nc=s?t.$fc.basename:t.$gc.basename,t.$oc=s?t.$fc.extname:t.$gc.extname,t.$pc=s?t.$fc.format:t.$gc.format,t.$qc=s?t.$fc.parse:t.$gc.parse,t.$rc=s?t.$fc.toNamespacedPath:t.$gc.toNamespacedPath,t.sep=s?t.$fc.sep:t.$gc.sep,t.$tc=s?t.$fc.delimiter:t.$gc.delimiter}),define($e[116],pe([1,0,24,5,10,7]),function(ne,t,E,C,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$eg=t.$dg=t.$cg=t.$bg=t.$ag=t.$_f=t.$$f=t.$0f=t.$9f=t.$8f=t.$7f=t.$6f=t.$5f=t.$4f=t.$3f=t.$2f=void 0;function D(z){return z===47||z===92}t.$2f=D;function k(z){return z.replace(/[\\/]/g,E.$gc.sep)}t.$3f=k;function m(z){return z.indexOf("/")===-1&&(z=k(z)),/^[a-zA-Z]:(\/|$)/.test(z)&&(z="/"+z),z}t.$4f=m;function p(z,y=E.$gc.sep){if(!z)return"";const O=z.length,U=z.charCodeAt(0);if(D(U)){if(D(z.charCodeAt(1))&&!D(z.charCodeAt(2))){let P=3;const L=P;for(;P<O&&!D(z.charCodeAt(P));P++);if(L!==P&&!D(z.charCodeAt(P+1))){for(P+=1;P<O;P++)if(D(z.charCodeAt(P)))return z.slice(0,P+1).replace(/[\\/]/g,y)}}return y}else if(c(U)&&z.charCodeAt(1)===58)return D(z.charCodeAt(2))?z.slice(0,2)+y:z.slice(0,2);let S=z.indexOf("://");if(S!==-1){for(S+=3;S<O;S++)if(D(z.charCodeAt(S)))return z.slice(0,S+1)}return""}t.$5f=p;function v(z){if(!C.$i||!z||z.length<5)return!1;let y=z.charCodeAt(0);if(y!==92||(y=z.charCodeAt(1),y!==92))return!1;let O=2;const U=O;for(;O<z.length&&(y=z.charCodeAt(O),y!==92);O++);return!(U===O||(y=z.charCodeAt(O+1),isNaN(y)||y===92))}t.$6f=v;const M=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(z,y=C.$i){const O=y?M:l;return!(!z||z.length===0||/^\s+$/.test(z)||(O.lastIndex=0,O.test(z))||y&&h.test(z)||z==="."||z===".."||y&&z[z.length-1]==="."||y&&z.length!==z.trim().length||z.length>255)}t.$7f=e;function s(z,y,O){const U=z===y;return!O||U?U:!z||!y?!1:(0,n.$af)(z,y)}t.$8f=s;function f(z,y,O,U=E.sep){if(z===y)return!0;if(!z||!y||y.length>z.length)return!1;if(O){if(!(0,n.$bf)(z,y))return!1;if(y.length===z.length)return!0;let P=y.length;return y.charAt(y.length-1)===U&&P--,z.charAt(P)===U}return y.charAt(y.length-1)!==U&&(y+=U),z.indexOf(y)===0}t.$9f=f;function c(z){return z>=65&&z<=90||z>=97&&z<=122}t.$0f=c;function a(z,y){return C.$i&&z.endsWith(":")&&(z+=E.sep),(0,E.$ic)(z)||(z=(0,E.$jc)(y,z)),z=(0,E.$hc)(z),C.$i?(z=(0,n.$Ve)(z,E.sep),z.endsWith(":")&&(z+=E.sep)):(z=(0,n.$Ve)(z,E.sep),z||(z=E.sep)),z}t.$$f=a;function $(z){const y=(0,E.$hc)(z);return C.$i?z.length>3?!1:d(y)&&(z.length===2||y.charCodeAt(2)===92):y===E.$gc.sep}t.$_f=$;function d(z,y=C.$i){return y?c(z.charCodeAt(0))&&z.charCodeAt(1)===58:!1}t.$ag=d;function b(z,y=C.$i){return d(z,y)?z[0]:void 0}t.$bg=b;function u(z,y,O){return y.length>z.length?-1:z===y?0:(O&&(z=z.toLowerCase(),y=y.toLowerCase()),z.indexOf(y))}t.$cg=u;function N(z){const y=z.split(":");let O,U,S;for(const P of y){const L=Number(P);(0,H.$Nf)(L)?U===void 0?U=L:S===void 0&&(S=L):O=O?[O,P].join(":"):P}if(!O)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:O,line:U!==void 0?U:void 0,column:S!==void 0?S:U!==void 0?1:void 0}}t.$dg=N;const B="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",R="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function W(z,y,O=8){let U="";for(let P=0;P<O;P++){let L;P===0&&C.$i&&!y&&(O===3||O===4)?L=R:L=B,U+=L.charAt(Math.floor(Math.random()*L.length))}let S;return y?S=`${y}-${U}`:S=U,z?(0,E.$jc)(z,S):S}t.$eg=W}),define($e[117],pe([1,0,24]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ls=t.$ks=t.$js=t.$is=t.$hs=void 0,t.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},n={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(v){const M=(0,E.$oc)(v),l=C[M.toLowerCase()];return l!==void 0?l:D(v)}t.$is=H;function D(v){const M=(0,E.$oc)(v);return n[M.toLowerCase()]}t.$js=D;function k(v){for(const M in n)if(n[M]===v)return M}t.$ks=k;const m=/^(.+)\/(.+?)(;.+)?$/;function p(v,M){const l=m.exec(v);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:M?void 0:v}t.$ls=p}),define($e[15],pe([1,0,24,5]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wc=t.$vc=t.URI=void 0;const n=/^\w[\w\d+.-]*$/,H=/^\//,D=/^\/\//;function k(R,W){if(!R.scheme&&W)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${R.authority}", path: "${R.path}", query: "${R.query}", fragment: "${R.fragment}"}`);if(R.scheme&&!n.test(R.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(R.path){if(R.authority){if(!H.test(R.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(R.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(R,W){return!R&&!W?"file":R}function p(R,W){switch(R){case"https":case"http":case"file":W?W[0]!==M&&(W=M+W):W=M;break}return W}const v="",M="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(W){return W instanceof h?!0:W?typeof W.authority=="string"&&typeof W.fragment=="string"&&typeof W.path=="string"&&typeof W.query=="string"&&typeof W.scheme=="string"&&typeof W.fsPath=="string"&&typeof W.with=="function"&&typeof W.toString=="function":!1}constructor(W,z,y,O,U,S=!1){typeof W=="object"?(this.scheme=W.scheme||v,this.authority=W.authority||v,this.path=W.path||v,this.query=W.query||v,this.fragment=W.fragment||v):(this.scheme=m(W,S),this.authority=z||v,this.path=p(this.scheme,y||v),this.query=O||v,this.fragment=U||v,k(this,S))}get fsPath(){return d(this,!1)}with(W){if(!W)return this;let{scheme:z,authority:y,path:O,query:U,fragment:S}=W;return z===void 0?z=this.scheme:z===null&&(z=v),y===void 0?y=this.authority:y===null&&(y=v),O===void 0?O=this.path:O===null&&(O=v),U===void 0?U=this.query:U===null&&(U=v),S===void 0?S=this.fragment:S===null&&(S=v),z===this.scheme&&y===this.authority&&O===this.path&&U===this.query&&S===this.fragment?this:new f(z,y,O,U,S)}static parse(W,z=!1){const y=l.exec(W);return y?new f(y[2]||v,B(y[4]||v),B(y[5]||v),B(y[7]||v),B(y[9]||v),z):new f(v,v,v,v,v)}static file(W){let z=v;if(C.$i&&(W=W.replace(/\\/g,M)),W[0]===M&&W[1]===M){const y=W.indexOf(M,2);y===-1?(z=W.substring(2),W=M):(z=W.substring(2,y),W=W.substring(y)||M)}return new f("file",z,W,v,v)}static from(W,z){return new f(W.scheme,W.authority,W.path,W.query,W.fragment,z)}static joinPath(W,...z){if(!W.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let y;return C.$i&&W.scheme==="file"?y=h.file(E.$fc.join(d(W,!0),...z)).path:y=E.$gc.join(W.path,...z),W.with({path:y})}toString(W=!1){return b(this,W)}toJSON(){return this}static revive(W){if(W){if(W instanceof h)return W;{const z=new f(W);return z._formatted=W.external??null,z._fsPath=W._sep===s?W.fsPath??null:null,z}}else return W}}t.URI=h;function e(R){return!R||typeof R!="object"?!1:typeof R.scheme=="string"&&(typeof R.authority=="string"||typeof R.authority>"u")&&(typeof R.path=="string"||typeof R.path>"u")&&(typeof R.query=="string"||typeof R.query>"u")&&(typeof R.fragment=="string"||typeof R.fragment>"u")}t.$vc=e;const s=C.$i?1:void 0;class f extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(W=!1){return W?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const W={$mid:1};return this._fsPath&&(W.fsPath=this._fsPath,W._sep=s),this._formatted&&(W.external=this._formatted),this.path&&(W.path=this.path),this.scheme&&(W.scheme=this.scheme),this.authority&&(W.authority=this.authority),this.query&&(W.query=this.query),this.fragment&&(W.fragment=this.fragment),W}}const c={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function a(R,W,z){let y,O=-1;for(let U=0;U<R.length;U++){const S=R.charCodeAt(U);if(S>=97&&S<=122||S>=65&&S<=90||S>=48&&S<=57||S===45||S===46||S===95||S===126||W&&S===47||z&&S===91||z&&S===93||z&&S===58)O!==-1&&(y+=encodeURIComponent(R.substring(O,U)),O=-1),y!==void 0&&(y+=R.charAt(U));else{y===void 0&&(y=R.substr(0,U));const P=c[S];P!==void 0?(O!==-1&&(y+=encodeURIComponent(R.substring(O,U)),O=-1),y+=P):O===-1&&(O=U)}}return O!==-1&&(y+=encodeURIComponent(R.substring(O))),y!==void 0?y:R}function $(R){let W;for(let z=0;z<R.length;z++){const y=R.charCodeAt(z);y===35||y===63?(W===void 0&&(W=R.substr(0,z)),W+=c[y]):W!==void 0&&(W+=R[z])}return W!==void 0?W:R}function d(R,W){let z;return R.authority&&R.path.length>1&&R.scheme==="file"?z=`//${R.authority}${R.path}`:R.path.charCodeAt(0)===47&&(R.path.charCodeAt(1)>=65&&R.path.charCodeAt(1)<=90||R.path.charCodeAt(1)>=97&&R.path.charCodeAt(1)<=122)&&R.path.charCodeAt(2)===58?W?z=R.path.substr(1):z=R.path[1].toLowerCase()+R.path.substr(2):z=R.path,C.$i&&(z=z.replace(/\//g,"\\")),z}t.$wc=d;function b(R,W){const z=W?$:a;let y="",{scheme:O,authority:U,path:S,query:P,fragment:L}=R;if(O&&(y+=O,y+=":"),(U||O==="file")&&(y+=M,y+=M),U){let G=U.indexOf("@");if(G!==-1){const Z=U.substr(0,G);U=U.substr(G+1),G=Z.lastIndexOf(":"),G===-1?y+=z(Z,!1,!1):(y+=z(Z.substr(0,G),!1,!1),y+=":",y+=z(Z.substr(G+1),!1,!0)),y+="@"}U=U.toLowerCase(),G=U.lastIndexOf(":"),G===-1?y+=z(U,!1,!0):(y+=z(U.substr(0,G),!1,!0),y+=U.substr(G))}if(S){if(S.length>=3&&S.charCodeAt(0)===47&&S.charCodeAt(2)===58){const G=S.charCodeAt(1);G>=65&&G<=90&&(S=`/${String.fromCharCode(G+32)}:${S.substr(3)}`)}else if(S.length>=2&&S.charCodeAt(1)===58){const G=S.charCodeAt(0);G>=65&&G<=90&&(S=`${String.fromCharCode(G+32)}:${S.substr(2)}`)}y+=z(S,!0,!1)}return P&&(y+="?",y+=z(P,!1,!1)),L&&(y+="#",y+=W?L:a(L,!1,!1)),y}function u(R){try{return decodeURIComponent(R)}catch{return R.length>3?R.substr(0,3)+u(R.substr(3)):R}}const N=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function B(R){return R.match(N)?R.replace(N,W=>u(W)):R}}),define($e[53],pe([1,0,34,15]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Eh=t.$Dh=t.$Ch=void 0;function n(m){return JSON.stringify(m,D)}t.$Ch=n;function H(m){let p=JSON.parse(m);return p=k(p),p}t.$Dh=H;function D(m,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:p.flags}:p}function k(m,p=0){if(!m||p>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return C.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof E.$ke||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let v=0;v<m.length;++v)m[v]=k(m[v],p+1);else for(const v in m)Object.hasOwnProperty.call(m,v)&&(m[v]=k(m[v],p+1))}return m}t.$Eh=k}),define($e[31],pe([1,0,6,5,10,15]),function(ne,t,E,C,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$pg=t.$og=t.$ng=t.$mg=t.$lg=t.$kg=t.$jg=t.$ig=t.$hg=t.$gg=t.$fg=t.Schemas=void 0;var D;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(D||(t.Schemas=D={}));function k(l,h){return H.URI.isUri(l)?(0,n.$af)(l.scheme,h):(0,n.$bf)(l,h+":")}t.$fg=k;function m(l,...h){return h.some(e=>k(l,e))}t.$gg=m,t.$hg="vscode-tkn",t.$ig="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${D.vscodeRemoteResource}`}set(h,e,s){this.a[h]=e,this.b[h]=s}setConnectionToken(h,e){this.c[h]=e}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch($){return E.$1($),h}const e=h.authority;let s=this.a[e];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const f=this.b[e],c=this.c[e];let a=`path=${encodeURIComponent(h.path)}`;return typeof c=="string"&&(a+=`&${t.$ig}=${encodeURIComponent(c)}`),H.URI.from({scheme:C.$o?this.d:D.vscodeRemoteResource,authority:`${s}:${f}`,path:this.f,query:a})}}t.$jg=new p,t.$kg="vs/../../extensions",t.$lg="vs/../../node_modules",t.$mg="vs/../../node_modules.asar",t.$ng="vs/../../node_modules.asar.unpacked",t.$og="vscode-app";class v{static{this.a=t.$og}asBrowserUri(h){const e=this.b(h,ne);return this.uriToBrowserUri(e)}uriToBrowserUri(h){return h.scheme===D.vscodeRemote?t.$jg.rewrite(h):h.scheme===D.file&&(C.$m||C.$q===`${D.vscodeFileResource}://${v.a}`)?h.with({scheme:D.vscodeFileResource,authority:h.authority||v.a,query:null,fragment:null}):h}asFileUri(h){const e=this.b(h,ne);return this.uriToFileUri(e)}uriToFileUri(h){return h.scheme===D.vscodeFileResource?h.with({scheme:D.file,authority:h.authority!==v.a?h.authority:null,query:null,fragment:null}):h}b(h,e){return H.URI.isUri(h)?h:H.URI.parse(e.toUrl(h))}}t.$pg=new v;var M;(function(l){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(h.get("3"));const e="vscode-coi";function s(c){let a;typeof c=="string"?a=new URL(c).searchParams:c instanceof URL?a=c.searchParams:H.URI.isUri(c)&&(a=new URL(c.toString(!0)).searchParams);const $=a?.get(e);if($)return h.get($)}l.getHeadersFromQuery=s;function f(c,a,$){if(!globalThis.crossOriginIsolated)return;const d=a&&$?"3":$?"2":"1";c instanceof URLSearchParams?c.set(e,d):c[e]=d}l.addSearchParam=f})(M||(t.COI=M={}))}),define($e[38],pe([1,0,116,31,24,5,10,15]),function(ne,t,E,C,n,H,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sg=t.DataUri=t.$Rg=t.$Qg=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Jg=t.$Ig=t.$Hg=t.$Gg=t.$Fg=t.$Eg=t.$Dg=t.$Cg=t.$Bg=t.$Ag=t.$zg=t.$yg=t.$xg=t.$wg=void 0;function m(h){return(0,k.$wc)(h,!0)}t.$wg=m;class p{constructor(e){this.a=e}compare(e,s,f=!1){return e===s?0:(0,D.$6e)(this.getComparisonKey(e,f),this.getComparisonKey(s,f))}isEqual(e,s,f=!1){return e===s?!0:!e||!s?!1:this.getComparisonKey(e,f)===this.getComparisonKey(s,f)}getComparisonKey(e,s=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,s,f=!1){if(e.scheme===s.scheme){if(e.scheme===C.Schemas.file)return E.$9f(m(e),m(s),this.a(e))&&e.query===s.query&&(f||e.fragment===s.fragment);if((0,t.$Ng)(e.authority,s.authority))return E.$9f(e.path,s.path,this.a(e),"/")&&e.query===s.query&&(f||e.fragment===s.fragment)}return!1}joinPath(e,...s){return k.URI.joinPath(e,...s)}basenameOrAuthority(e){return(0,t.$Fg)(e)||e.authority}basename(e){return n.$gc.basename(e.path)}extname(e){return n.$gc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let s;return e.scheme===C.Schemas.file?s=k.URI.file(n.$mc(m(e))).path:(s=n.$gc.dirname(e.path),e.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),s="/")),e.with({path:s})}normalizePath(e){if(!e.path.length)return e;let s;return e.scheme===C.Schemas.file?s=k.URI.file(n.$hc(m(e))).path:s=n.$gc.normalize(e.path),e.with({path:s})}relativePath(e,s){if(e.scheme!==s.scheme||!(0,t.$Ng)(e.authority,s.authority))return;if(e.scheme===C.Schemas.file){const a=n.$lc(m(e),m(s));return H.$i?E.$3f(a):a}let f=e.path||"/";const c=s.path||"/";if(this.a(e)){let a=0;for(const $=Math.min(f.length,c.length);a<$&&!(f.charCodeAt(a)!==c.charCodeAt(a)&&f.charAt(a).toLowerCase()!==c.charAt(a).toLowerCase());a++);f=c.substr(0,a)+f.substr(a)}return n.$gc.relative(f,c)}resolvePath(e,s){if(e.scheme===C.Schemas.file){const f=k.URI.file(n.$kc(m(e),s));return e.with({authority:f.authority,path:f.path})}return s=E.$4f(s),e.with({path:n.$gc.resolve(e.path,s)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,s){return e===s||e!==void 0&&s!==void 0&&(0,D.$af)(e,s)}hasTrailingPathSeparator(e,s=n.sep){if(e.scheme===C.Schemas.file){const f=m(e);return f.length>E.$5f(f).length&&f[f.length-1]===s}else{const f=e.path;return f.length>1&&f.charCodeAt(f.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,s=n.sep){return(0,t.$Og)(e,s)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,s=n.sep){let f=!1;if(e.scheme===C.Schemas.file){const c=m(e);f=c!==void 0&&c.length===E.$5f(c).length&&c[c.length-1]===s}else{s="/";const c=e.path;f=c.length===1&&c.charCodeAt(c.length-1)===47}return!f&&!(0,t.$Og)(e,s)?e.with({path:e.path+"/"}):e}}t.$xg=p,t.$yg=new p(()=>!1),t.$zg=new p(h=>h.scheme===C.Schemas.file?!H.$k:!0),t.$Ag=new p(h=>!0),t.$Bg=t.$yg.isEqual.bind(t.$yg),t.$Cg=t.$yg.isEqualOrParent.bind(t.$yg),t.$Dg=t.$yg.getComparisonKey.bind(t.$yg),t.$Eg=t.$yg.basenameOrAuthority.bind(t.$yg),t.$Fg=t.$yg.basename.bind(t.$yg),t.$Gg=t.$yg.extname.bind(t.$yg),t.$Hg=t.$yg.dirname.bind(t.$yg),t.$Ig=t.$yg.joinPath.bind(t.$yg),t.$Jg=t.$yg.normalizePath.bind(t.$yg),t.$Kg=t.$yg.relativePath.bind(t.$yg),t.$Lg=t.$yg.resolvePath.bind(t.$yg),t.$Mg=t.$yg.isAbsolutePath.bind(t.$yg),t.$Ng=t.$yg.isEqualAuthority.bind(t.$yg),t.$Og=t.$yg.hasTrailingPathSeparator.bind(t.$yg),t.$Pg=t.$yg.removeTrailingPathSeparator.bind(t.$yg),t.$Qg=t.$yg.addTrailingPathSeparator.bind(t.$yg);function v(h,e){const s=[];for(let f=0;f<h.length;f++){const c=e(h[f]);h.some((a,$)=>$===f?!1:(0,t.$Cg)(c,e(a)))||s.push(h[f])}return s}t.$Rg=v;var M;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(s){const f=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach($=>{const[d,b]=$.split(":");d&&b&&f.set(d,b)});const a=s.path.substring(0,s.path.indexOf(";"));return a&&f.set(h.META_DATA_MIME,a),f}h.parseMetaData=e})(M||(t.DataUri=M={}));function l(h,e,s){if(e){let f=h.path;return f&&f[0]!==n.$gc.sep&&(f=n.$gc.sep+f),h.with({scheme:s,authority:e,path:f})}return h.with({scheme:s})}t.$Sg=l}),define($e[9],pe([1,0,29,6,4,3,38,5,50,23]),function(ne,t,E,C,n,H,D,k,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yh=t.$xh=t.$wh=t.$vh=t.$uh=t.$th=t.Promises=t.$sh=t.$rh=t.$qh=t.$ph=t.$oh=t.$nh=t.$mh=t.$lh=t.$kh=t.$jh=t.$ih=t.$hh=t.$gh=t.$fh=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=t.$Wg=t.$Vg=t.$Ug=t.$Tg=void 0;function v(F){return!!F&&typeof F.then=="function"}t.$Tg=v;function M(F){const r=new E.$7d,i=F(r.token),o=new Promise((w,I)=>{const T=r.token.onCancellationRequested(()=>{T.dispose(),I(new C.$5)});Promise.resolve(i).then(j=>{T.dispose(),r.dispose(),w(j)},j=>{T.dispose(),r.dispose(),I(j)})});return new class{cancel(){r.cancel(),r.dispose()}then(w,I){return o.then(w,I)}catch(w){return this.then(void 0,w)}finally(w){return o.finally(w)}}}t.$Ug=M;function l(F,r,i){return new Promise((o,w)=>{const I=r.onCancellationRequested(()=>{I.dispose(),o(i)});F.then(o,w).finally(()=>I.dispose())})}t.$Vg=l;function h(F,r){return new Promise((i,o)=>{const w=r.onCancellationRequested(()=>{w.dispose(),o(new C.$5)});F.then(i,o).finally(()=>w.dispose())})}t.$Wg=h;async function e(F){let r=-1;const i=F.map((o,w)=>o.then(I=>(r=w,I)));try{return await Promise.race(i)}finally{F.forEach((o,w)=>{w!==r&&o.cancel()})}}t.$Xg=e;function s(F,r,i){let o;const w=setTimeout(()=>{o?.(void 0),i?.()},r);return Promise.race([F.finally(()=>clearTimeout(w)),new Promise(I=>o=I)])}t.$Yg=s;function f(F){return new Promise((r,i)=>{const o=F();v(o)?o.then(r,i):r(o)})}t.$Zg=f;function c(){let F,r;return{promise:new Promise((o,w)=>{F=o,r=w}),resolve:F,reject:r}}t.$1g=c;class a{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(r){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=r,!this.b){const i=()=>{if(this.b=null,this.f)return;const o=this.queue(this.d);return this.d=null,o};this.b=new Promise(o=>{this.a.then(i,i).then(o)})}return new Promise((i,o)=>{this.b.then(i,o)})}return this.a=r(),new Promise((i,o)=>{this.a.then(w=>{this.a=null,i(w)},w=>{this.a=null,o(w)})})}dispose(){this.f=!0}}t.$2g=a;class ${constructor(){this.a=Promise.resolve(null)}queue(r){return this.a=this.a.then(()=>r(),()=>r())}}t.$3g=$;class d{constructor(){this.a=new Map}queue(r,i){const w=(this.a.get(r)??Promise.resolve()).catch(()=>{}).then(i).finally(()=>{this.a.get(r)===w&&this.a.delete(r)});return this.a.set(r,w),w}}t.$4g=d;const b=(F,r)=>{let i=!0;const o=setTimeout(()=>{i=!1,r()},F);return{isTriggered:()=>i,dispose:()=>{clearTimeout(o),i=!1}}},u=F=>{let r=!0;return queueMicrotask(()=>{r&&(r=!1,F())}),{isTriggered:()=>r,dispose:()=>{r=!1}}};class N{constructor(r){this.defaultDelay=r,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(r,i=this.defaultDelay){this.g=r,this.h(),this.b||(this.b=new Promise((w,I)=>{this.d=w,this.f=I}).then(()=>{if(this.b=null,this.d=null,this.g){const w=this.g;return this.g=null,w()}}));const o=()=>{this.a=null,this.d?.(null)};return this.a=i===m.$Td?u(o):b(i,o),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$5g=N;class B{constructor(r){this.a=new N(r),this.b=new a}trigger(r,i){return this.a.trigger(()=>this.b.queue(r),i)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$6g=B;class R{constructor(){this.a=!1,this.b=new Promise((r,i)=>{this.d=r})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$7g=R;class W extends R{constructor(r){super(),this.f=setTimeout(()=>this.open(),r)}open(){clearTimeout(this.f),super.open()}}t.$8g=W;function z(F,r){return r?new Promise((i,o)=>{const w=setTimeout(()=>{I.dispose(),i()},F),I=r.onCancellationRequested(()=>{clearTimeout(w),I.dispose(),o(new C.$5)})}):M(i=>z(F,i))}t.$9g=z;function y(F,r=0,i){const o=setTimeout(()=>{F(),i&&w.dispose()},r),w=(0,H.$Rc)(()=>{clearTimeout(o),i?.deleteAndLeak(w)});return i?.add(w),w}t.$0g=y;function O(F){const r=[];let i=0;const o=F.length;function w(){return i<o?F[i++]():null}function I(T){T!=null&&r.push(T);const j=w();return j?j.then(I):Promise.resolve(r)}return Promise.resolve(null).then(I)}t.$$g=O;function U(F,r=o=>!!o,i=null){let o=0;const w=F.length,I=()=>{if(o>=w)return Promise.resolve(i);const T=F[o++];return Promise.resolve(T()).then(V=>r(V)?Promise.resolve(V):I())};return I()}t.$_g=U;function S(F,r=o=>!!o,i=null){if(F.length===0)return Promise.resolve(i);let o=F.length;const w=()=>{o=-1;for(const I of F)I.cancel?.()};return new Promise((I,T)=>{for(const j of F)j.then(V=>{--o>=0&&r(V)?(w(),I(V)):o===0&&I(i)}).catch(V=>{--o>=0&&(w(),T(V))})})}t.$ah=S;class P{constructor(r){this.a=0,this.b=!1,this.f=r,this.g=[],this.d=0,this.h=new n.$Wd}whenIdle(){return this.size>0?n.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(r){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((i,o)=>{this.g.push({factory:r,c:i,e:o}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const r=this.g.shift();this.d++;const i=r.factory();i.then(r.c,r.e),i.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$bh=P;class L extends P{constructor(){super(1)}}t.$ch=L;class G{constructor(){this.a=new ae,this.b=0}queue(r){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,r())):this.a.run(this.b++,r())}}t.$dh=G;class Z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const r=new K;return this.b.add(r),r.p}g(){for(const[,r]of this.a)if(r.size>0)return!1;return!0}queueSize(r,i=D.$yg){const o=i.getComparisonKey(r);return this.a.get(o)?.size??0}queueFor(r,i,o=D.$yg){const w=o.getComparisonKey(r);let I=this.a.get(w);if(!I){I=new L;const T=this.f++,j=n.Event.once(I.onDrained)(()=>{I?.dispose(),this.a.delete(w),this.h(),this.d?.deleteAndDispose(T),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$3c),this.d.set(T,j),this.a.set(w,I)}return I.queue(i)}h(){this.g()&&this.j()}j(){for(const r of this.b)r.complete();this.b.clear()}dispose(){for(const[,r]of this.a)r.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$eh=Z;class ge{constructor(r,i){this.a=-1,typeof r=="function"&&typeof i=="number"&&this.setIfNotSet(r,i)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(r,i){this.cancel(),this.a=setTimeout(()=>{this.a=-1,r()},i)}setIfNotSet(r,i){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,r()},i))}}t.$fh=ge;class ue{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(r,i,o=globalThis){this.cancel();const w=o.setInterval(()=>{r()},i);this.d=(0,H.$Rc)(()=>{o.clearInterval(w),this.d=void 0})}dispose(){this.cancel()}}t.$gh=ue;class te{constructor(r,i){this.b=-1,this.a=r,this.d=i,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(r=this.d){this.cancel(),this.b=setTimeout(this.f,r)}get delay(){return this.d}set delay(r){this.d=r}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$hh=te;class me{constructor(r,i){i%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${i}ms is not a multiple of 1000ms.`),this.a=r,this.b=i,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(r=this.b){r%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${r}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(r/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$ih=me;class Re extends te{constructor(r,i){super(r,i),this.j=[]}work(r){this.j.push(r),this.isScheduled()||this.schedule()}h(){const r=this.j;this.j=[],this.a?.(r)}dispose(){this.j=[],super.dispose()}}t.$jh=Re;class Ne extends H.$Tc{constructor(r,i){super(),this.g=r,this.h=i,this.a=[],this.b=this.B(new H.$Uc),this.f=!1}get pending(){return this.a.length}work(r){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+r.length>this.g.maxBufferedWork)return!1}else if(this.pending+r.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const i of r)this.a.push(i);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new te(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$kh=Ne,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$mh=(F,r)=>{(0,k.$B)(()=>{if(i)return;const o=Date.now()+15;r(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,o-Date.now())}}))});let i=!1;return{dispose(){i||(i=!0)}}}:t.$mh=(F,r,i)=>{const o=F.requestIdleCallback(r,typeof i=="number"?{timeout:i}:void 0);let w=!1;return{dispose(){w||(w=!0,F.cancelIdleCallback(o))}}},t.$lh=F=>(0,t.$mh)(globalThis,F)}();class Be{constructor(r,i){this.g=!1,this.d=()=>{try{this.j=i()}catch(o){this.l=o}finally{this.g=!0}},this.f=(0,t.$mh)(r,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$nh=Be;class re extends Be{constructor(r){super(globalThis,r)}}t.$oh=re;async function J(F,r,i){let o;for(let w=0;w<i;w++)try{return await F()}catch(I){o=I,await z(r)}throw o}t.$ph=J;class ae{isRunning(r){return typeof r=="number"?this.a?.taskId===r:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(r,i,o){return this.a={taskId:r,cancel:()=>o?.(),promise:i},i.then(()=>this.d(r),()=>this.d(r)),i}d(r){this.a&&r===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const r=this.b;this.b=void 0,r.run().then(r.promiseResolve,r.promiseReject)}}queue(r){if(this.b)this.b.run=r;else{const{promise:i,resolve:o,reject:w}=c();this.b={run:r,promise:i,promiseResolve:o,promiseReject:w}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$qh=ae;class se{constructor(r,i=()=>Date.now()){this.d=r,this.f=i,this.a=0,this.b=0}increment(){const r=this.f();return r-this.a>this.d&&(this.a=r,this.b=0),this.b++,this.b}}t.$rh=se;var Y;(function(F){F[F.Resolved=0]="Resolved",F[F.Rejected=1]="Rejected"})(Y||(Y={}));class K{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((r,i)=>{this.a=r,this.b=i})}complete(r){return new Promise(i=>{this.a(r),this.d={outcome:0,value:r},i()})}error(r){return new Promise(i=>{this.b(r),this.d={outcome:1,value:r},i()})}cancel(){return this.error(new C.$5)}}t.$sh=K;var ie;(function(F){async function r(o){let w;const I=await Promise.all(o.map(T=>T.then(j=>j,j=>{w||(w=j)})));if(typeof w<"u")throw w;return I}F.settled=r;function i(o){return new Promise(async(w,I)=>{try{await o(w,I)}catch(T){I(T)}})}F.withAsyncBody=i})(ie||(t.Promises=ie={}));class fe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(r){this.a=void 0,this.b=void 0,this.d=!1,this.promise=r.then(i=>(this.a=i,this.d=!0,i),i=>{throw this.b=i,this.d=!0,i})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$th=fe;class De{constructor(r){this.b=r,this.a=new p.$V(()=>new fe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$uh=De;var Te;(function(F){F[F.Initial=0]="Initial",F[F.DoneOK=1]="DoneOK",F[F.DoneError=2]="DoneError"})(Te||(Te={}));class Se{static fromArray(r){return new Se(i=>{i.emitMany(r)})}static fromPromise(r){return new Se(async i=>{i.emitMany(await r)})}static fromPromises(r){return new Se(async i=>{await Promise.all(r.map(async o=>i.emitOne(await o)))})}static merge(r){return new Se(async i=>{await Promise.all(r.map(async o=>{for await(const w of o)i.emitOne(w)}))})}static{this.EMPTY=Se.fromArray([])}constructor(r){this.a=0,this.b=[],this.d=null,this.f=new n.$Wd,queueMicrotask(async()=>{const i={emitOne:o=>this.g(o),emitMany:o=>this.h(o),reject:o=>this.k(o)};try{await Promise.resolve(r(i)),this.j()}catch(o){this.k(o)}finally{i.emitOne=void 0,i.emitMany=void 0,i.reject=void 0}})}[Symbol.asyncIterator](){let r=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(r<this.b.length)return{done:!1,value:this.b[r++]};if(this.a===1)return{done:!0,value:void 0};await n.Event.toPromise(this.f.event)}while(!0)}}}static map(r,i){return new Se(async o=>{for await(const w of r)o.emitOne(i(w))})}map(r){return Se.map(this,r)}static filter(r,i){return new Se(async o=>{for await(const w of r)i(w)&&o.emitOne(w)})}filter(r){return Se.filter(this,r)}static coalesce(r){return Se.filter(r,i=>!!i)}coalesce(){return Se.coalesce(this)}static async toPromise(r){const i=[];for await(const o of r)i.push(o);return i}toPromise(){return Se.toPromise(this)}g(r){this.a===0&&(this.b.push(r),this.f.fire())}h(r){this.a===0&&(this.b=this.b.concat(r),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(r){this.a===0&&(this.a=2,this.d=r,this.f.fire())}}t.$vh=Se;class _ extends Se{constructor(r,i){super(i),this.l=r}cancel(){this.l.cancel()}}t.$wh=_;function g(F){const r=new E.$7d,i=F(r.token);return new _(r,async o=>{const w=r.token.onCancellationRequested(()=>{w.dispose(),r.dispose(),o.reject(new C.$5)});try{for await(const I of i){if(r.token.isCancellationRequested)return;o.emitOne(I)}w.dispose(),r.dispose()}catch(I){w.dispose(),r.dispose(),o.reject(I)}})}t.$xh=g;class A{constructor(){this.a=new K,this.b=new Se(o=>{if(r){o.reject(r);return}return i&&o.emitMany(i),this.d=w=>o.reject(w),this.f=w=>o.emitOne(w),this.a.p});let r,i;this.f=o=>{i||(i=[]),i.push(o)},this.d=o=>{r||(r=o)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(r){this.d(r),this.a.complete()}emitOne(r){this.f(r)}}t.$yh=A}),define($e[2],pe([1,0,16,114,14,19,9,6,4,118,3,31,5,15,49,21]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h,e,s){"use strict";var f;Object.defineProperty(t,"__esModule",{value:!0}),t.$tR=t.$sR=t.h=t.$qR=t.$pR=t.$oR=t.$nR=t.$mR=t.$lR=t.$kR=t.$jR=t.DetectedFullscreenMode=t.$iR=t.$hR=t.$gR=t.$fR=t.$eR=t.$dR=t.$cR=t.$bR=t.$aR=t.$_Q=t.$$Q=t.$0Q=t.$9Q=t.$8Q=t.$7Q=t.$6Q=t.$5Q=t.$=t.Namespace=t.$3Q=t.$2Q=t.$1Q=t.$ZQ=t.$YQ=t.$XQ=t.$WQ=t.$VQ=t.$UQ=t.$TQ=t.$SQ=t.$RQ=t.$QQ=t.$PQ=t.$OQ=t.$NQ=t.$MQ=t.$LQ=t.$KQ=t.$JQ=t.$IQ=t.$HQ=t.$GQ=t.$FQ=t.$EQ=t.$DQ=t.$CQ=t.$BQ=t.$AQ=t.$zQ=t.$yQ=t.$xQ=t.$wQ=t.$vQ=t.$uQ=t.$tQ=t.$sQ=t.$rQ=t.$qQ=t.$pQ=t.$oQ=t.$nQ=t.$mQ=t.$lQ=t.$kQ=t.$jQ=t.$iQ=t.$hQ=t.$gQ=t.$fQ=t.$eQ=t.$dQ=t.$cQ=t.$bQ=t.$aQ=t.$_P=t.$$P=t.$0P=t.$9P=t.$8P=t.$7P=t.$6P=t.$5P=t.$4P=t.$3P=t.$2P=t.$1P=t.$ZP=t.$YP=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,f=function(){const q=new Map;(0,s.$rP)(s.$sP,1);const Q={window:s.$sP,disposables:new v.$Sc};q.set(s.$sP.vscodeWindowId,Q);const ee=new m.$Wd,ce=new m.$Wd,ke=new m.$Wd;function We(Oe,Ue){return(typeof Oe=="number"?q.get(Oe):void 0)??(Ue?Q:void 0)}return{onDidRegisterWindow:ee.event,onWillUnregisterWindow:ke.event,onDidUnregisterWindow:ce.event,registerWindow(Oe){if(q.has(Oe.vscodeWindowId))return v.$Tc.None;const Ue=new v.$Sc,Ve={window:Oe,disposables:Ue.add(new v.$Sc)};return q.set(Oe.vscodeWindowId,Ve),Ue.add((0,v.$Rc)(()=>{q.delete(Oe.vscodeWindowId),ce.fire(Oe)})),Ue.add($(Oe,t.$TQ.BEFORE_UNLOAD,()=>{ke.fire(Oe)})),ee.fire(Ve),Ue},getWindows(){return q.values()},getWindowsCount(){return q.size},getWindowId(Oe){return Oe.vscodeWindowId},hasWindow(Oe){return q.has(Oe)},getWindowById:We,getWindow(Oe){const Ue=Oe;if(Ue?.ownerDocument?.defaultView)return Ue.ownerDocument.defaultView.window;const Ve=Oe;return Ve?.view?Ve.view.window:s.$sP},getDocument(Oe){const Ue=Oe;return(0,t.getWindow)(Ue).document}}}(),t.registerWindow=f.registerWindow,t.getWindow=f.getWindow,t.getDocument=f.getDocument,t.getWindows=f.getWindows,t.getWindowsCount=f.getWindowsCount,t.getWindowId=f.getWindowId,t.getWindowById=f.getWindowById,t.hasWindow=f.hasWindow,t.onDidRegisterWindow=f.onDidRegisterWindow,t.onWillUnregisterWindow=f.onWillUnregisterWindow,t.onDidUnregisterWindow=f.onDidUnregisterWindow;function c(q){for(;q.firstChild;)q.firstChild.remove()}t.$YP=c;class a{constructor(Q,ee,ce,ke){this.f=Q,this.g=ee,this.d=ce,this.j=ke||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function $(q,Q,ee,ce){return new a(q,Q,ee,ce)}t.$ZP=$;function d(q,Q){return function(ee){return Q(new H.$RP(q,ee))}}function b(q){return function(Q){return q(new n.$WP(Q))}}const u=function(Q,ee,ce,ke){let We=ce;return ee==="click"||ee==="mousedown"?We=d((0,t.getWindow)(Q),ce):(ee==="keydown"||ee==="keypress"||ee==="keyup")&&(We=b(ce)),$(Q,ee,We,ke)};t.$1P=u;const N=function(Q,ee,ce){const ke=d((0,t.getWindow)(Q),ee);return R(Q,ke,ce)};t.$2P=N;const B=function(Q,ee,ce){const ke=d((0,t.getWindow)(Q),ee);return z(Q,ke,ce)};t.$3P=B;function R(q,Q,ee){return $(q,l.$r&&C.$OP.pointerEvents?t.$TQ.POINTER_DOWN:t.$TQ.MOUSE_DOWN,Q,ee)}t.$4P=R;function W(q,Q,ee){return $(q,l.$r&&C.$OP.pointerEvents?t.$TQ.POINTER_MOVE:t.$TQ.MOUSE_MOVE,Q,ee)}t.$5P=W;function z(q,Q,ee){return $(q,l.$r&&C.$OP.pointerEvents?t.$TQ.POINTER_UP:t.$TQ.MOUSE_UP,Q,ee)}t.$6P=z;function y(q,Q,ee){return(0,D.$mh)(q,Q,ee)}t.$7P=y;class O extends D.$nh{constructor(Q,ee){super(Q,ee)}}t.$8P=O;function U(q,Q,ee,ce){let ke=0;const We=q.setInterval(()=>{ke++,(typeof ce=="number"&&ke>=ce||Q()===!0)&&Oe.dispose()},ee),Oe=(0,v.$Rc)(()=>{q.clearInterval(We)});return Oe}t.$$P=U;class S extends D.$gh{constructor(Q){super(),this.f=Q&&(0,t.getWindow)(Q)}cancelAndSet(Q,ee,ce){return super.cancelAndSet(Q,ee,ce??this.f)}}t.$_P=S;class P{constructor(Q,ee=0){this.d=Q,this.priority=ee,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Q){(0,k.$1)(Q)}}static sort(Q,ee){return ee.priority-Q.priority}}(function(){const q=new Map,Q=new Map,ee=new Map,ce=new Map,ke=We=>{ee.set(We,!1);const Oe=q.get(We)??[];for(Q.set(We,Oe),q.set(We,[]),ce.set(We,!0);Oe.length>0;)Oe.sort(P.sort),Oe.shift().execute();ce.set(We,!1)};t.$0P=(We,Oe,Ue=0)=>{const Ve=(0,t.getWindowId)(We),Qe=new P(Oe,Ue);let at=q.get(Ve);return at||(at=[],q.set(Ve,at)),at.push(Qe),ee.get(Ve)||(ee.set(Ve,!0),We.requestAnimationFrame(()=>ke(Ve))),Qe},t.$9P=(We,Oe,Ue)=>{const Ve=(0,t.getWindowId)(We);if(ce.get(Ve)){const Qe=new P(Oe,Ue);let at=Q.get(Ve);return at||(at=[],Q.set(Ve,at)),at.push(Qe),Qe}else return(0,t.$0P)(We,Oe,Ue)}})();function L(q,Q){return(0,t.$0P)(q,Q,1e4)}t.$aQ=L;function G(q,Q){return(0,t.$0P)(q,Q,-1e4)}t.$bQ=G;const Z=8,ge=function(q,Q){return Q};class ue extends v.$Tc{constructor(Q,ee,ce,ke=ge,We=Z){super();let Oe=null,Ue=0;const Ve=this.B(new D.$fh),Qe=()=>{Ue=new Date().getTime(),ce(Oe),Oe=null};this.B($(Q,ee,at=>{Oe=ke(Oe,at);const Tt=new Date().getTime()-Ue;Tt>=We?(Ve.cancel(),Qe()):Ve.setIfNotSet(Qe,We-Tt)}))}}function te(q,Q,ee,ce,ke){return new ue(q,Q,ee,ce,ke)}t.$cQ=te;function me(q){return(0,t.getWindow)(q).getComputedStyle(q,null)}t.$dQ=me;function Re(q,Q){const ee=(0,t.getWindow)(q),ce=ee.document;if(q!==ce.body)return new Be(q.clientWidth,q.clientHeight);if(l.$r&&ee?.visualViewport)return new Be(ee.visualViewport.width,ee.visualViewport.height);if(ee?.innerWidth&&ee.innerHeight)return new Be(ee.innerWidth,ee.innerHeight);if(ce.body&&ce.body.clientWidth&&ce.body.clientHeight)return new Be(ce.body.clientWidth,ce.body.clientHeight);if(ce.documentElement&&ce.documentElement.clientWidth&&ce.documentElement.clientHeight)return new Be(ce.documentElement.clientWidth,ce.documentElement.clientHeight);if(Q)return Re(Q);throw new Error("Unable to figure out browser width and height")}t.$eQ=Re;class Ne{static d(Q,ee){return parseFloat(ee)||0}static f(Q,ee,ce){const ke=me(Q),We=ke?ke.getPropertyValue(ee):"0";return Ne.d(Q,We)}static getBorderLeftWidth(Q){return Ne.f(Q,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Q){return Ne.f(Q,"border-right-width","borderRightWidth")}static getBorderTopWidth(Q){return Ne.f(Q,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Q){return Ne.f(Q,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Q){return Ne.f(Q,"padding-left","paddingLeft")}static getPaddingRight(Q){return Ne.f(Q,"padding-right","paddingRight")}static getPaddingTop(Q){return Ne.f(Q,"padding-top","paddingTop")}static getPaddingBottom(Q){return Ne.f(Q,"padding-bottom","paddingBottom")}static getMarginLeft(Q){return Ne.f(Q,"margin-left","marginLeft")}static getMarginTop(Q){return Ne.f(Q,"margin-top","marginTop")}static getMarginRight(Q){return Ne.f(Q,"margin-right","marginRight")}static getMarginBottom(Q){return Ne.f(Q,"margin-bottom","marginBottom")}}class Be{static{this.None=new Be(0,0)}constructor(Q,ee){this.width=Q,this.height=ee}with(Q=this.width,ee=this.height){return Q!==this.width||ee!==this.height?new Be(Q,ee):this}static is(Q){return typeof Q=="object"&&typeof Q.height=="number"&&typeof Q.width=="number"}static lift(Q){return Q instanceof Be?Q:new Be(Q.width,Q.height)}static equals(Q,ee){return Q===ee?!0:!Q||!ee?!1:Q.width===ee.width&&Q.height===ee.height}}t.$fQ=Be;function re(q){let Q=q.offsetParent,ee=q.offsetTop,ce=q.offsetLeft;for(;(q=q.parentNode)!==null&&q!==q.ownerDocument.body&&q!==q.ownerDocument.documentElement;){ee-=q.scrollTop;const ke=I(q)?null:me(q);ke&&(ce-=ke.direction!=="rtl"?q.scrollLeft:-q.scrollLeft),q===Q&&(ce+=Ne.getBorderLeftWidth(q),ee+=Ne.getBorderTopWidth(q),ee+=q.offsetTop,ce+=q.offsetLeft,Q=q.offsetParent)}return{left:ce,top:ee}}t.$gQ=re;function J(q,Q,ee){typeof Q=="number"&&(q.style.width=`${Q}px`),typeof ee=="number"&&(q.style.height=`${ee}px`)}t.$hQ=J;function ae(q,Q,ee,ce,ke,We="absolute"){typeof Q=="number"&&(q.style.top=`${Q}px`),typeof ee=="number"&&(q.style.right=`${ee}px`),typeof ce=="number"&&(q.style.bottom=`${ce}px`),typeof ke=="number"&&(q.style.left=`${ke}px`),q.style.position=We}t.$iQ=ae;function se(q){const Q=q.getBoundingClientRect(),ee=(0,t.getWindow)(q);return{left:Q.left+ee.scrollX,top:Q.top+ee.scrollY,width:Q.width,height:Q.height}}t.$jQ=se;function Y(q){let Q=q,ee=1;do{const ce=me(Q).zoom;ce!=null&&ce!=="1"&&(ee*=ce),Q=Q.parentElement}while(Q!==null&&Q!==Q.ownerDocument.documentElement);return ee}t.$kQ=Y;function K(q){const Q=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.offsetWidth+Q}t.$lQ=K;function ie(q){const Q=Ne.getBorderLeftWidth(q)+Ne.getBorderRightWidth(q),ee=Ne.getPaddingLeft(q)+Ne.getPaddingRight(q);return q.offsetWidth-Q-ee}t.$mQ=ie;function fe(q){const Q=Ne.getMarginLeft(q)+Ne.getMarginRight(q);return q.scrollWidth+Q}t.$nQ=fe;function De(q){const Q=Ne.getBorderTopWidth(q)+Ne.getBorderBottomWidth(q),ee=Ne.getPaddingTop(q)+Ne.getPaddingBottom(q);return q.offsetHeight-Q-ee}t.$oQ=De;function Te(q){const Q=Ne.getMarginTop(q)+Ne.getMarginBottom(q);return q.offsetHeight+Q}t.$pQ=Te;function Se(q,Q){if(q===null)return 0;const ee=re(q),ce=re(Q);return ee.left-ce.left}function _(q,Q){const ee=Q.map(ke=>Math.max(fe(ke),K(ke))+Se(ke,q)||0);return Math.max(...ee)}t.$qQ=_;function g(q,Q){return!!Q?.contains(q)}t.$rQ=g;const A="parentFlowToElementId";function F(q,Q){q.dataset[A]=Q.id}t.$sQ=F;function r(q){const Q=q.dataset[A];return typeof Q=="string"?q.ownerDocument.getElementById(Q):null}function i(q,Q){let ee=q;for(;ee;){if(ee===Q)return!0;if(ee instanceof HTMLElement){const ce=r(ee);if(ce){ee=ce;continue}}ee=ee.parentNode}return!1}t.$tQ=i;function o(q,Q,ee){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q.classList.contains(Q))return q;if(ee){if(typeof ee=="string"){if(q.classList.contains(ee))return null}else if(q===ee)return null}q=q.parentNode}return null}t.$uQ=o;function w(q,Q,ee){return!!o(q,Q,ee)}t.$vQ=w;function I(q){return q&&!!q.host&&!!q.mode}t.$wQ=I;function T(q){return!!j(q)}t.$xQ=T;function j(q){for(;q.parentNode;){if(q===q.ownerDocument?.body)return null;q=q.parentNode}return I(q)?q:null}t.$yQ=j;function V(){let q=ye().activeElement;for(;q?.shadowRoot;)q=q.shadowRoot.activeElement;return q}t.$zQ=V;function X(q){return V()===q}t.$AQ=X;function oe(q){return g(V(),q)}t.$BQ=oe;function be(q){return q.ownerDocument===ye()}t.$CQ=be;function ye(){return(0,t.getWindowsCount)()<=1?s.$sP.document:Array.from((0,t.getWindows)()).map(({window:Q})=>Q.document).find(Q=>Q.hasFocus())??s.$sP.document}t.$DQ=ye;function we(){return ye().defaultView?.window??s.$sP}t.$EQ=we;function Ee(q){const Q=(0,t.getWindow)(q);Q.document.hasFocus()||Q.focus()}t.$FQ=Ee;const ve=new Map;function Pe(q){return ve.has(q)}t.$GQ=Pe;function Ie(){return new Me}t.$HQ=Ie;class Me{constructor(){this.d="",this.f=void 0}setStyle(Q){Q!==this.d&&(this.d=Q,this.f?this.f.innerText=Q:this.f=Ze(s.$sP.document.head,ee=>ee.innerText=Q))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ze(q=s.$sP.document.head,Q,ee){const ce=document.createElement("style");if(ce.type="text/css",ce.media="screen",Q?.(ce),q.appendChild(ce),ee&&ee.add((0,v.$Rc)(()=>q.removeChild(ce))),q===s.$sP.document.head){const ke=new Set;ve.set(ce,ke);for(const{window:We,disposables:Oe}of(0,t.getWindows)()){if(We===s.$sP)continue;const Ue=Oe.add(xe(ce,ke,We));ee?.add(Ue)}}return ce}t.$IQ=Ze;function et(q){const Q=new v.$Sc;for(const[ee,ce]of ve)Q.add(xe(ee,ce,q));return Q}t.$JQ=et;function xe(q,Q,ee){const ce=new v.$Sc,ke=q.cloneNode(!0);ee.document.head.appendChild(ke),ce.add((0,v.$Rc)(()=>ee.document.head.removeChild(ke)));for(const We of je(q))ke.sheet?.insertRule(We.cssText,ke.sheet?.cssRules.length);return ce.add(t.$KQ.observe(q,ce,{childList:!0})(()=>{ke.textContent=q.textContent})),Q.add(ke),ce.add((0,v.$Rc)(()=>Q.delete(ke))),ce}t.$KQ=new class{constructor(){this.mutationObservers=new Map}observe(q,Q,ee){let ce=this.mutationObservers.get(q);ce||(ce=new Map,this.mutationObservers.set(q,ce));const ke=(0,e.$Vi)(ee);let We=ce.get(ke);if(We)We.users+=1;else{const Oe=new m.$Wd,Ue=new MutationObserver(Qe=>Oe.fire(Qe));Ue.observe(q,ee);const Ve=We={users:1,observer:Ue,onDidMutate:Oe.event};Q.add((0,v.$Rc)(()=>{Ve.users-=1,Ve.users===0&&(Oe.dispose(),Ue.disconnect(),ce?.delete(ke),ce?.size===0&&this.mutationObservers.delete(q))})),ce.set(ke,We)}return We.onDidMutate}};function x(q=s.$sP.document.head){return de("meta",q)}t.$LQ=x;function le(q=s.$sP.document.head){return de("link",q)}t.$MQ=le;function de(q,Q=s.$sP.document.head){const ee=document.createElement(q);return Q.appendChild(ee),ee}let Ae=null;function Ce(){return Ae||(Ae=Ze()),Ae}function je(q){return q?.sheet?.rules?q.sheet.rules:q?.sheet?.cssRules?q.sheet.cssRules:[]}function _e(q,Q,ee=Ce()){if(!(!ee||!Q)){ee.sheet?.insertRule(`${q} {${Q}}`,0);for(const ce of ve.get(ee)??[])_e(q,Q,ce)}}t.$NQ=_e;function Ke(q,Q=Ce()){if(!Q)return;const ee=je(Q),ce=[];for(let ke=0;ke<ee.length;ke++){const We=ee[ke];Je(We)&&We.selectorText.indexOf(q)!==-1&&ce.push(ke)}for(let ke=ce.length-1;ke>=0;ke--)Q.sheet?.deleteRule(ce[ke]);for(const ke of ve.get(Q)??[])Ke(q,ke)}t.$OQ=Ke;function Je(q){return typeof q.selectorText=="string"}function tt(q){return q instanceof MouseEvent||q instanceof(0,t.getWindow)(q).MouseEvent}t.$PQ=tt;function Xe(q){return q instanceof KeyboardEvent||q instanceof(0,t.getWindow)(q).KeyboardEvent}t.$QQ=Xe;function nt(q){return q instanceof PointerEvent||q instanceof(0,t.getWindow)(q).PointerEvent}t.$RQ=nt;function st(q){return q instanceof DragEvent||q instanceof(0,t.getWindow)(q).DragEvent}t.$SQ=st,t.$TQ={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.$GP?"webkitAnimationStart":"animationstart",ANIMATION_END:E.$GP?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.$GP?"webkitAnimationIteration":"animationiteration"};function rt(q){const Q=q;return!!(Q&&typeof Q.preventDefault=="function"&&typeof Q.stopPropagation=="function")}t.$UQ=rt,t.$VQ={stop:(q,Q)=>(q.preventDefault(),Q&&q.stopPropagation(),q)};function gt(q){const Q=[];for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)Q[ee]=q.scrollTop,q=q.parentNode;return Q}t.$WQ=gt;function St(q,Q){for(let ee=0;q&&q.nodeType===q.ELEMENT_NODE;ee++)q.scrollTop!==Q[ee]&&(q.scrollTop=Q[ee]),q=q.parentNode}t.$XQ=St;class mt extends v.$Tc{static m(Q){if(Q instanceof HTMLElement){const ee=j(Q),ce=ee?ee.activeElement:Q.ownerDocument.activeElement;return g(ce,Q)}else{const ee=Q;return g(ee.document.activeElement,ee.document)}}constructor(Q){super(),this.f=this.B(new m.$Wd),this.onDidFocus=this.f.event,this.g=this.B(new m.$Wd),this.onDidBlur=this.g.event;let ee=mt.m(Q),ce=!1;const ke=()=>{ce=!1,ee||(ee=!0,this.f.fire())},We=()=>{ee&&(ce=!0,(Q instanceof HTMLElement?(0,t.getWindow)(Q):Q).setTimeout(()=>{ce&&(ce=!1,ee=!1,this.g.fire())},0))};this.j=()=>{mt.m(Q)!==ee&&(ee?We():ke())},this.B($(Q,t.$TQ.FOCUS,ke,!0)),this.B($(Q,t.$TQ.BLUR,We,!0)),Q instanceof HTMLElement&&(this.B($(Q,t.$TQ.FOCUS_IN,()=>this.j())),this.B($(Q,t.$TQ.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function Ft(q){return new mt(q)}t.$YQ=Ft;function Ot(q,Q){return q.after(Q),Q}t.$ZQ=Ot;function ze(q,...Q){if(q.append(...Q),Q.length===1&&typeof Q[0]!="string")return Q[0]}t.$1Q=ze;function he(q,Q){return q.insertBefore(Q,q.firstChild),Q}t.$2Q=he;function Fe(q,...Q){q.innerText="",ze(q,...Q)}t.$3Q=Fe;const Le=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var qe;(function(q){q.HTML="http://www.w3.org/1999/xhtml",q.SVG="http://www.w3.org/2000/svg"})(qe||(t.Namespace=qe={}));function it(q,Q,ee,...ce){const ke=Le.exec(Q);if(!ke)throw new Error("Bad use of emmet");const We=ke[1]||"div";let Oe;return q!==qe.HTML?Oe=document.createElementNS(q,We):Oe=document.createElement(We),ke[3]&&(Oe.id=ke[3]),ke[4]&&(Oe.className=ke[4].replace(/\./g," ").trim()),ee&&Object.entries(ee).forEach(([Ue,Ve])=>{typeof Ve>"u"||(/^on\w+$/.test(Ue)?Oe[Ue]=Ve:Ue==="selected"?Ve&&Oe.setAttribute(Ue,"true"):Oe.setAttribute(Ue,Ve))}),Oe.append(...ce),Oe}function lt(q,Q,...ee){return it(qe.HTML,q,Q,...ee)}t.$=lt,lt.SVG=function(q,Q,...ee){return it(qe.SVG,q,Q,...ee)};function Ge(q,Q){const ee=[];return q.forEach((ce,ke)=>{ke>0&&(Q instanceof Node?ee.push(Q.cloneNode()):ee.push(document.createTextNode(Q))),ee.push(ce)}),ee}t.$5Q=Ge;function ct(q,...Q){q?$t(...Q):yt(...Q)}t.$6Q=ct;function $t(...q){for(const Q of q)Q.style.display="",Q.removeAttribute("aria-hidden")}t.$7Q=$t;function yt(...q){for(const Q of q)Q.style.display="none",Q.setAttribute("aria-hidden","true")}t.$8Q=yt;function Gt(q,Q){for(;q&&q.nodeType===q.ELEMENT_NODE;){if(q instanceof HTMLElement&&q.hasAttribute(Q))return q;q=q.parentNode}return null}function Ai(q){!q||!q.hasAttribute("tabIndex")||(q.ownerDocument.activeElement===q&&Gt(q.parentElement,"tabIndex")?.focus(),q.removeAttribute("tabindex"))}t.$9Q=Ai;function ki(q){return Q=>{Q.preventDefault(),Q.stopPropagation(),q(Q)}}t.$0Q=ki;function Si(q){return new Promise(Q=>{if(q.document.readyState==="complete"||q.document&&q.document.body!==null)Q(void 0);else{const ce=()=>{q.window.removeEventListener("DOMContentLoaded",ce,!1),Q()};q.window.addEventListener("DOMContentLoaded",ce,!1)}})}t.$$Q=Si;function Fi(q,Q){const ee=q.devicePixelRatio*Q;return Math.max(1,Math.floor(ee))/q.devicePixelRatio}t.$_Q=Fi;function Ti(q){s.$sP.open(q,"_blank","noopener")}t.$aR=Ti;const Yt=780,Zt=640;function Ni(q){const Q=Math.floor(s.$sP.screenLeft+s.$sP.innerWidth/2-Yt/2),ee=Math.floor(s.$sP.screenTop+s.$sP.innerHeight/2-Zt/2);s.$sP.open(q,"_blank",`width=${Yt},height=${Zt},top=${ee},left=${Q}`)}t.$bR=Ni;function Ci(q,Q=!0){const ee=s.$sP.open();return ee?(Q&&(ee.opener=null),ee.location.href=q,!0):!1}t.$cR=Ci;function Pi(q,Q){const ee=()=>{Q(),ce=(0,t.$0P)(q,ee)};let ce=(0,t.$0P)(q,ee);return(0,v.$Rc)(()=>ce.dispose())}t.$dR=Pi,M.$jg.setPreferredWebSchema(/^https:/.test(s.$sP.location.href)?"https":"http");function Ri(q){return q?`url('${M.$pg.uriToBrowserUri(q).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.$eR=Ri;function Li(q){return`'${q.replace(/'/g,"%27")}'`}t.$fR=Li;function Xt(q,Q){if(q!==void 0){const ee=q.match(/^\s*var\((.+)\)$/);if(ee){const ce=ee[1].split(",",2);return ce.length===2&&(Q=Xt(ce[1].trim(),Q)),`var(${ce[0]}, ${Q})`}return q}return Q}t.$gR=Xt;function Ii(q,Q){let ee;if(h.URI.isUri(q))ee=q.toString(!0);else{const We=new Blob([q]);ee=URL.createObjectURL(We),setTimeout(()=>URL.revokeObjectURL(ee))}const ce=we(),ke=document.createElement("a");ce.document.body.appendChild(ke),ke.download=Q,ke.href=ee,ke.click(),setTimeout(()=>ce.document.body.removeChild(ke))}t.$hR=Ii;function Mi(){return new Promise(q=>{const Q=we(),ee=document.createElement("input");Q.document.body.appendChild(ee),ee.type="file",ee.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(ee,"input"))(()=>{q(ee.files??void 0)}),ee.click(),setTimeout(()=>Q.document.body.removeChild(ee))})}t.$iR=Mi;var Dt;(function(q){q[q.DOCUMENT=1]="DOCUMENT",q[q.BROWSER=2]="BROWSER"})(Dt||(t.DetectedFullscreenMode=Dt={}));function Oi(q){return q.document.fullscreenElement||q.document.webkitFullscreenElement||q.document.webkitIsFullScreen?{mode:Dt.DOCUMENT,guess:!1}:q.innerHeight===q.screen.height?{mode:Dt.BROWSER,guess:!1}:(l.$j||l.$k)&&q.outerHeight===q.screen.height&&q.outerWidth===q.screen.width?{mode:Dt.BROWSER,guess:!0}:null}t.$jR=Oi;function Jt(q,Q=!1){const ee=document.createElement("a");return p.addHook("afterSanitizeAttributes",ce=>{for(const ke of["href","src"])if(ce.hasAttribute(ke)){const We=ce.getAttribute(ke);if(ke==="href"&&We.startsWith("#"))continue;if(ee.href=We,!q.includes(ee.protocol.replace(/:$/,""))){if(Q&&ke==="src"&&ee.href.startsWith("data:"))continue;ce.removeAttribute(ke)}}}),(0,v.$Rc)(()=>{p.removeHook("afterSanitizeAttributes")})}t.$kR=Jt;const Bi=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.$lR=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const zi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Wi(q,Q){const ee=Jt(Bi);try{const ce=p.sanitize(Q,zi);q.innerHTML=ce}finally{ee.dispose()}}t.$mR=Wi;function ji(q){const Q=new Uint16Array(q.length);for(let ke=0;ke<Q.length;ke++)Q[ke]=q.charCodeAt(ke);let ee="";const ce=new Uint8Array(Q.buffer);for(let ke=0;ke<ce.length;ke++)ee+=String.fromCharCode(ce[ke]);return ee}function Hi(q){return btoa(ji(q))}t.$nR=Hi;class pt extends m.$Wd{constructor(){super(),this.o=new v.$Sc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(m.Event.runAndSubscribe(t.onDidRegisterWindow,({window:Q,disposables:ee})=>this.C(Q,ee),{window:s.$sP,disposables:this.o}))}C(Q,ee){ee.add($(Q,"keydown",ce=>{if(ce.defaultPrevented)return;const ke=new n.$WP(ce);if(!(ke.keyCode===6&&ce.repeat)){if(ce.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(ce.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(ce.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(ce.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(ke.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyPressed&&(this.A.event=ce,this.fire(this.A))}},!0)),ee.add($(Q,"keyup",ce=>{ce.defaultPrevented||(!ce.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!ce.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!ce.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!ce.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=ce.altKey,this.A.ctrlKey=ce.ctrlKey,this.A.metaKey=ce.metaKey,this.A.shiftKey=ce.shiftKey,this.A.lastKeyReleased&&(this.A.event=ce,this.fire(this.A)))},!0)),ee.add($(Q.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add($(Q.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),ee.add($(Q.document.body,"mousemove",ce=>{ce.buttons&&(this.A.lastKeyPressed=void 0)},!0)),ee.add($(Q,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$oR=pt;function Ui(q){const Q=document.cookie.match("(^|[^;]+)\\s*"+q+"\\s*=\\s*([^;]+)");return Q?Q.pop():void 0}t.$pR=Ui;class qi extends v.$Tc{constructor(Q,ee){super(),this.j=Q,this.m=ee,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B($(this.j,t.$TQ.DRAG_START,Q=>{this.m.onDragStart?.(Q)})),this.m.onDrag&&this.B($(this.j,t.$TQ.DRAG,Q=>{this.m.onDrag?.(Q)})),this.B($(this.j,t.$TQ.DRAG_ENTER,Q=>{this.f++,this.g=Q.timeStamp,this.m.onDragEnter?.(Q)})),this.B($(this.j,t.$TQ.DRAG_OVER,Q=>{Q.preventDefault(),this.m.onDragOver?.(Q,Q.timeStamp-this.g)})),this.B($(this.j,t.$TQ.DRAG_LEAVE,Q=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(Q))})),this.B($(this.j,t.$TQ.DRAG_END,Q=>{this.f=0,this.g=0,this.m.onDragEnd?.(Q)})),this.B($(this.j,t.$TQ.DROP,Q=>{this.f=0,this.g=0,this.m.onDrop?.(Q)}))}}t.$qR=qi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function _i(q,...Q){let ee,ce;Array.isArray(Q[0])?(ee={},ce=Q[0]):(ee=Q[0]||{},ce=Q[1]);const ke=Vi.exec(q);if(!ke||!ke.groups)throw new Error("Bad use of h");const We=ke.groups.tag||"div",Oe=document.createElement(We);ke.groups.id&&(Oe.id=ke.groups.id);const Ue=[];if(ke.groups.class)for(const Qe of ke.groups.class.split("."))Qe!==""&&Ue.push(Qe);if(ee.className!==void 0)for(const Qe of ee.className.split("."))Qe!==""&&Ue.push(Qe);Ue.length>0&&(Oe.className=Ue.join(" "));const Ve={};if(ke.groups.name&&(Ve[ke.groups.name]=Oe),ce)for(const Qe of ce)Qe instanceof HTMLElement?Oe.appendChild(Qe):typeof Qe=="string"?Oe.append(Qe):"root"in Qe&&(Object.assign(Ve,Qe),Oe.appendChild(Qe.root));for(const[Qe,at]of Object.entries(ee))if(Qe!=="className")if(Qe==="style")for(const[Tt,Bt]of Object.entries(at))Oe.style.setProperty(ei(Tt),typeof Bt=="number"?Bt+"px":""+Bt);else Qe==="tabIndex"?Oe.tabIndex=at:Oe.setAttribute(ei(Qe),at.toString());return Ve.root=Oe,Ve}t.h=_i;function ei(q){return q.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(q,Q,ee){for(const{name:ce,value:ke}of q.attributes)(!ee||ee.includes(ce))&&Q.setAttribute(ce,ke)}t.$sR=ti;function Qi(q,Q,ee){const ce=q.getAttribute(ee);ce?Q.setAttribute(ee,ce):Q.removeAttribute(ee)}function Ki(q,Q,ee){ti(q,Q,ee);const ce=new v.$Sc;return ce.add(t.$KQ.observe(q,ce,{attributes:!0,attributeFilter:ee})(ke=>{for(const We of ke)We.type==="attributes"&&We.attributeName&&Qi(q,Q,We.attributeName)})),ce}t.$tR=Ki}),define($e[54],pe([1,0,2,3,117]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wR=t.$vR=t.$uR=void 0;class H extends C.$Tc{constructor(m,p){super(),this.B((0,E.$ZP)(m,"dragover",v=>{v.preventDefault(),this.a||(this.a=setTimeout(()=>{p(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(v=>{this.B((0,E.$ZP)(m,v,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$uR=H,t.$vR={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:n.$hs.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function D(k,m,p,v,M){const l=document.createElement("div");if(l.className=p,l.textContent=m,M&&(l.style.color=M),v&&(l.style.background=v),k.dataTransfer){const h=(0,E.getWindow)(k).document;h.body.appendChild(l),k.dataTransfer.setDragImage(l,-10,-10),setTimeout(()=>h.body.removeChild(l),0)}}t.$wR=D}),define($e[55],pe([1,0,2]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1R=t.$ZR=t.$YR=void 0;function C(l,h={}){const e=H(h);return e.textContent=l,e}t.$YR=C;function n(l,h={}){const e=H(h);return m(e,p(l,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}t.$ZR=n;function H(l){const h=l.inline?"span":"div",e=document.createElement(h);return l.className&&(e.className=l.className),e}t.$1R=H;class D{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var k;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(k||(k={}));function m(l,h,e,s){let f;if(h.type===2)f=document.createTextNode(h.content||"");else if(h.type===3)f=document.createElement("b");else if(h.type===4)f=document.createElement("i");else if(h.type===7&&s)f=document.createElement("code");else if(h.type===5&&e){const c=document.createElement("a");e.disposables.add(E.$1P(c,"click",a=>{e.callback(String(h.index),a)})),f=c}else h.type===8?f=document.createElement("br"):h.type===1&&(f=l);f&&l!==f&&l.appendChild(f),f&&Array.isArray(h.children)&&h.children.forEach(c=>{m(f,c,e,s)})}function p(l,h){const e={type:1,children:[]};let s=0,f=e;const c=[],a=new D(l);for(;!a.eos();){let $=a.next();const d=$==="\\"&&M(a.peek(),h)!==0;if(d&&($=a.next()),!d&&v($,h)&&$===a.peek()){a.advance(),f.type===2&&(f=c.pop());const b=M($,h);if(f.type===b||f.type===5&&b===6)f=c.pop();else{const u={type:b,children:[]};b===5&&(u.index=s,s++),f.children.push(u),c.push(f),f=u}}else if($===`
`)f.type===2&&(f=c.pop()),f.children.push({type:8});else if(f.type!==2){const b={type:2,content:$};f.children.push(b),c.push(f),f=b}else f.content+=$}return f.type===2&&(f=c.pop()),c.length,e}function v(l,h){return M(l,h)!==0}function M(l,h){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define($e[56],pe([1,0,2,3]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=void 0;class n{constructor(){this.a=new C.$Sc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(D,k){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const m=this.c;this.c=null,D&&m&&m(k)}isMonitoring(){return!!this.b}startMonitoring(D,k,m,p,v){this.isMonitoring()&&this.stopMonitoring(!1),this.b=p,this.c=v;let M=D;try{D.setPointerCapture(k),this.a.add((0,C.$Rc)(()=>{try{D.releasePointerCapture(k)}catch{}}))}catch{M=E.getWindow(D)}this.a.add(E.$ZP(M,E.$TQ.POINTER_MOVE,l=>{if(l.buttons!==m){this.stopMonitoring(!0);return}l.preventDefault(),this.b(l)})),this.a.add(E.$ZP(M,E.$TQ.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.$AR=n});var Ye=this&&this.__decorate||function(ne,t,E,C){var n=arguments.length,H=n<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,E):C,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(ne,t,E,C);else for(var k=ne.length-1;k>=0;k--)(D=ne[k])&&(H=(n<3?D(H):n>3?D(t,E,H):D(t,E))||H);return n>3&&H&&Object.defineProperty(t,E,H),H};define($e[25],pe([1,0,2,21,12,27,4,3,46]),function(ne,t,E,C,n,H,D,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xR=t.EventType=void 0;var p;(function(M){M.Tap="-monaco-gesturetap",M.Change="-monaco-gesturechange",M.Start="-monaco-gesturestart",M.End="-monaco-gesturesend",M.Contextmenu="-monaco-gesturecontextmenu"})(p||(t.EventType=p={}));class v extends k.$Tc{static{this.a=-.005}static{this.c=700}static{this.r=400}constructor(){super(),this.f=!1,this.g=new m.$4c,this.h=new m.$4c,this.m={},this.j=null,this.n=0,this.B(D.Event.runAndSubscribe(E.onDidRegisterWindow,({window:l,disposables:h})=>{h.add(E.$ZP(l.document,"touchstart",e=>this.s(e),{passive:!1})),h.add(E.$ZP(l.document,"touchend",e=>this.u(l,e))),h.add(E.$ZP(l.document,"touchmove",e=>this.D(e),{passive:!1}))},{window:C.$sP,disposables:this.q}))}static addTarget(l){if(!v.isTouchDevice())return k.$Tc.None;v.b||(v.b=(0,k.$Mc)(new v));const h=v.b.g.push(l);return(0,k.$Rc)(h)}static ignoreTarget(l){if(!v.isTouchDevice())return k.$Tc.None;v.b||(v.b=(0,k.$Mc)(new v));const h=v.b.h.push(l);return(0,k.$Rc)(h)}static isTouchDevice(){return"ontouchstart"in C.$sP||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}s(l){const h=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let e=0,s=l.targetTouches.length;e<s;e++){const f=l.targetTouches.item(e);this.m[f.identifier]={id:f.identifier,initialTarget:f.target,initialTimeStamp:h,initialPageX:f.pageX,initialPageY:f.pageY,rollingTimestamps:[h],rollingPageX:[f.pageX],rollingPageY:[f.pageY]};const c=this.w(p.Start,f.target);c.pageX=f.pageX,c.pageY=f.pageY,this.z(c)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}u(l,h){const e=Date.now(),s=Object.keys(this.m).length;for(let f=0,c=h.changedTouches.length;f<c;f++){const a=h.changedTouches.item(f);if(!this.m.hasOwnProperty(String(a.identifier))){console.warn("move of an UNKNOWN touch",a);continue}const $=this.m[a.identifier],d=Date.now()-$.initialTimeStamp;if(d<v.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const b=this.w(p.Tap,$.initialTarget);b.pageX=n.$sb($.rollingPageX),b.pageY=n.$sb($.rollingPageY),this.z(b)}else if(d>=v.c&&Math.abs($.initialPageX-n.$sb($.rollingPageX))<30&&Math.abs($.initialPageY-n.$sb($.rollingPageY))<30){const b=this.w(p.Contextmenu,$.initialTarget);b.pageX=n.$sb($.rollingPageX),b.pageY=n.$sb($.rollingPageY),this.z(b)}else if(s===1){const b=n.$sb($.rollingPageX),u=n.$sb($.rollingPageY),N=n.$sb($.rollingTimestamps)-$.rollingTimestamps[0],B=b-$.rollingPageX[0],R=u-$.rollingPageY[0],W=[...this.g].filter(z=>$.initialTarget instanceof Node&&z.contains($.initialTarget));this.C(l,W,e,Math.abs(B)/N,B>0?1:-1,b,Math.abs(R)/N,R>0?1:-1,u)}this.z(this.w(p.End,$.initialTarget)),delete this.m[a.identifier]}this.f&&(h.preventDefault(),h.stopPropagation(),this.f=!1)}w(l,h){const e=document.createEvent("CustomEvent");return e.initEvent(l,!1,!0),e.initialTarget=h,e.tapCount=0,e}z(l){if(l.type===p.Tap){const h=new Date().getTime();let e=0;h-this.n>v.r?e=1:e=2,this.n=h,l.tapCount=e}else(l.type===p.Change||l.type===p.Contextmenu)&&(this.n=0);if(l.initialTarget instanceof Node){for(const h of this.h)if(h.contains(l.initialTarget))return;for(const h of this.g)h.contains(l.initialTarget)&&(h.dispatchEvent(l),this.f=!0)}}C(l,h,e,s,f,c,a,$,d){this.j=E.$0P(l,()=>{const b=Date.now(),u=b-e;let N=0,B=0,R=!0;s+=v.a*u,a+=v.a*u,s>0&&(R=!1,N=f*s*u),a>0&&(R=!1,B=$*a*u);const W=this.w(p.Change);W.translationX=N,W.translationY=B,h.forEach(z=>z.dispatchEvent(W)),R||this.C(l,h,b,s,f,c+N,a,$,d+B)})}D(l){const h=Date.now();for(let e=0,s=l.changedTouches.length;e<s;e++){const f=l.changedTouches.item(e);if(!this.m.hasOwnProperty(String(f.identifier))){console.warn("end of an UNKNOWN touch",f);continue}const c=this.m[f.identifier],a=this.w(p.Change,c.initialTarget);a.translationX=f.pageX-n.$sb(c.rollingPageX),a.translationY=f.pageY-n.$sb(c.rollingPageY),a.pageX=f.pageX,a.pageY=f.pageY,this.z(a),c.rollingPageX.length>3&&(c.rollingPageX.shift(),c.rollingPageY.shift(),c.rollingTimestamps.shift()),c.rollingPageX.push(f.pageX),c.rollingPageY.push(f.pageY),c.rollingTimestamps.push(h)}this.f&&(l.preventDefault(),l.stopPropagation(),this.f=!1)}}t.$xR=v,Ye([H.$zh],v,"isTouchDevice",null)}),define($e[57],pe([1,0,2,92]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5R=t.$4R=t.$3R=void 0;const C=2e4;let n,H,D,k,m;function p(h){n=document.createElement("div"),n.className="monaco-aria-container";const e=()=>{const f=document.createElement("div");return f.className="monaco-alert",f.setAttribute("role","alert"),f.setAttribute("aria-atomic","true"),n.appendChild(f),f};H=e(),D=e();const s=()=>{const f=document.createElement("div");return f.className="monaco-status",f.setAttribute("aria-live","polite"),f.setAttribute("aria-atomic","true"),n.appendChild(f),f};k=s(),m=s(),h.appendChild(n)}t.$3R=p;function v(h){n&&(H.textContent!==h?(E.$YP(D),l(H,h)):(E.$YP(H),l(D,h)))}t.$4R=v;function M(h){n&&(k.textContent!==h?(E.$YP(m),l(k,h)):(E.$YP(k),l(m,h)))}t.$5R=M;function l(h,e){E.$YP(h),e.length>C&&(e=e.substr(0,C)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define($e[119],pe([1,0,2,18]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wS=t.$vS=void 0;const n=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(k){const m=new Array;let p,v=0,M=0;for(;(p=n.exec(k))!==null;){M=p.index||0,v<M&&m.push(k.substring(v,M)),v=(p.index||0)+p[0].length;const[,l,h]=p;m.push(l?`$(${h})`:D({id:h}))}return v<k.length&&m.push(k.substring(v)),m}t.$vS=H;function D(k){const m=E.$("span");return m.classList.add(...C.ThemeIcon.asClassNameArray(k)),m}t.$wS=D}),define($e[120],pe([1,0,2]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$$R=void 0;function C(H){try{H.parentElement?.removeChild(H)}catch{}}class n{constructor(D){this.d=D,this.a=new Map,this.b=new Set,this.c=!1}alloc(D){let k=this.h(D).pop(),m=!1;if(k)m=this.b.has(k.domNode),m&&this.b.delete(k.domNode);else{const p=(0,E.$)(".monaco-list-row"),M=this.i(D).renderTemplate(p);k={domNode:p,templateId:D,templateData:M}}return{row:k,isReusingConnectedDomNode:m}}release(D){D&&this.f(D)}transact(D){if(this.c)throw new Error("Already in transaction");this.c=!0;try{D()}finally{for(const k of this.b)this.g(k);this.b.clear(),this.c=!1}}f(D){const{domNode:k,templateId:m}=D;k&&(this.c?this.b.add(k):this.g(k)),this.h(m).push(D)}g(D){D.classList.remove("scrolling"),C(D)}h(D){let k=this.a.get(D);return k||(k=[],this.a.set(D,k)),k}dispose(){this.a.forEach((D,k)=>{for(const m of D)this.i(k).disposeTemplate(m.templateData),m.templateData=null}),this.a.clear(),this.b.clear()}i(D){const k=this.d.get(D);if(!k)throw new Error(`No renderer found for ${D}`);return k}}t.$$R=n}),define($e[121],pe([1,0,9,3]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FR=void 0;class n extends C.$Tc{constructor(D,k,m){super(),this.a=D,this.b=k,this.c=m,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new E.$fh)}setVisibility(D){this.a!==D&&(this.a=D,this.s())}setShouldBeVisible(D){this.g=D,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const D=this.r();this.h!==D&&(this.h=D,this.ensureVisibility())}setIsNeeded(D){this.j!==D&&(this.j=D,this.ensureVisibility())}setDomNode(D){this.f=D,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(D){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(D?" fade":"")))}}t.$FR=n}),define($e[122],pe([1,0,2,25,12,4,3,5]),function(ne,t,E,C,n,H,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DS=void 0;class m extends D.$Tc{constructor(v,M,l,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$Wd),this.h=l,this.j(),this.setOptions(v,M)}j(){this.B(C.$xR.addTarget(this.a)),[C.EventType.Tap].forEach(v=>{this.B(E.$ZP(this.a,v,M=>{this.a.focus()}))}),this.B(E.$1P(this.a,"click",v=>{E.$VQ.stop(v,!0)})),this.B(E.$1P(this.a,"change",v=>{this.a.title=v.target.value,this.g.fire({index:v.target.selectedIndex,selected:v.target.value})})),this.B(E.$1P(this.a,"keydown",v=>{let M=!1;k.$j?(v.keyCode===18||v.keyCode===16||v.keyCode===10)&&(M=!0):(v.keyCode===18&&v.altKey||v.keyCode===10||v.keyCode===3)&&(M=!0),M&&v.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(v,M){(!this.c||!n.$ub(this.c,v))&&(this.c=v,this.a.options.length=0,this.c.forEach((l,h)=>{this.a.add(this.m(l.text,h,l.isDisabled))})),M!==void 0&&this.select(M)}select(v){this.c.length===0?this.f=0:v>=0&&v<this.c.length?this.f=v:v>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(v){this.b.ariaLabel=v,this.a.setAttribute("aria-label",v)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(v){this.a.tabIndex=v?0:-1}render(v){v.classList.add("select-container"),v.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(v){this.h=v,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(v,M,l){const h=document.createElement("option");return h.value=v,h.text=v,h.disabled=!!l,h}}t.$DS=m}),define($e[58],pe([1,0,26,12,9,50,87,4,28]),function(ne,t,E,C,n,H,D,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aU=t.$_T=t.$$T=void 0;function p(h){return typeof h=="object"&&"visibility"in h&&"data"in h}t.$$T=p;function v(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}t.$_T=v;function M(h){return typeof h.collapsible=="boolean"}class l{constructor(e,s,f,c={}){this.o=e,this.p=s,this.rootRef=[],this.d=new k.$5d,this.f=new k.$Wd,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new k.$Wd,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new k.$Wd,this.onDidSplice=this.l.event,this.m=new n.$5g(H.$Td),this.h=typeof c.collapseByDefault>"u"?!1:c.collapseByDefault,this.j=c.filter,this.k=typeof c.autoExpandSingleChildren>"u"?!1:c.autoExpandSingleChildren,this.c={parent:void 0,element:f,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,s,f=m.Iterable.empty(),c={}){if(e.length===0)throw new E.$9T(this.o,"Invalid tree location");c.diffIdentityProvider?this.q(c.diffIdentityProvider,e,s,f,c):this.s(e,s,f,c)}q(e,s,f,c=m.Iterable.empty(),a,$=a.diffDepth??0){const{parentNode:d}=this.G(s);if(!d.lastDiffIds)return this.s(s,f,c,a);const b=[...c],u=s[s.length-1],N=new D.$3s({getElements:()=>d.lastDiffIds},{getElements:()=>[...d.children.slice(0,u),...b,...d.children.slice(u+f)].map(y=>e.getId(y.element).toString())}).ComputeDiff(!1);if(N.quitEarly)return d.lastDiffIds=void 0,this.s(s,f,b,a);const B=s.slice(0,-1),R=(y,O,U)=>{if($>0)for(let S=0;S<U;S++)y--,O--,this.q(e,[...B,y,0],Number.MAX_SAFE_INTEGER,b[O].children,a,$-1)};let W=Math.min(d.children.length,u+f),z=b.length;for(const y of N.changes.sort((O,U)=>U.originalStart-O.originalStart))R(W,z,W-(y.originalStart+y.originalLength)),W=y.originalStart,z=y.modifiedStart-u,this.s([...B,W],y.originalLength,m.Iterable.slice(b,z,z+y.modifiedLength),a);R(W,z,W)}s(e,s,f=m.Iterable.empty(),{onDidCreateNode:c,onDidDeleteNode:a,diffIdentityProvider:$}){const{parentNode:d,listIndex:b,revealed:u,visible:N}=this.G(e),B=[],R=m.Iterable.map(f,G=>this.w(G,d,d.visible?1:0,u,B,c)),W=e[e.length-1];let z=0;for(let G=W;G>=0&&G<d.children.length;G--){const Z=d.children[G];if(Z.visible){z=Z.visibleChildIndex;break}}const y=[];let O=0,U=0;for(const G of R)y.push(G),U+=G.renderNodeCount,G.visible&&(G.visibleChildIndex=z+O++);const S=(0,C.$6b)(d.children,W,s,y);$?d.lastDiffIds?(0,C.$6b)(d.lastDiffIds,W,s,y.map(G=>$.getId(G.element).toString())):d.lastDiffIds=d.children.map(G=>$.getId(G.element).toString()):d.lastDiffIds=void 0;let P=0;for(const G of S)G.visible&&P++;if(P!==0)for(let G=W+y.length;G<d.children.length;G++){const Z=d.children[G];Z.visible&&(Z.visibleChildIndex-=P)}if(d.visibleChildrenCount+=O-P,u&&N){const G=S.reduce((Z,ge)=>Z+(ge.visible?ge.renderNodeCount:0),0);this.B(d,U-G),this.p.splice(b,G,B)}if(S.length>0&&a){const G=Z=>{a(Z),Z.children.forEach(G)};S.forEach(G)}this.l.fire({insertedNodes:y,deletedNodes:S});let L=d;for(;L;){if(L.visibility===2){this.m.trigger(()=>this.refilter());break}L=L.parent}}rerender(e){if(e.length===0)throw new E.$9T(this.o,"Invalid tree location");const{node:s,listIndex:f,revealed:c}=this.F(e);s.visible&&c&&this.p.splice(f,1,[s])}updateElementHeight(e,s){if(e.length===0)throw new E.$9T(this.o,"Invalid tree location");const{listIndex:f}=this.F(e);this.p.updateElementHeight(f,s)}has(e){return this.D(e)}getListIndex(e){const{listIndex:s,visible:f,revealed:c}=this.F(e);return f&&c?s:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,s){const f=this.E(e);typeof s>"u"&&(s=!f.collapsible);const c={collapsible:s};return this.d.bufferEvents(()=>this.t(e,c))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,s,f){const c=this.E(e);typeof s>"u"&&(s=!c.collapsed);const a={collapsed:s,recursive:f||!1};return this.d.bufferEvents(()=>this.t(e,a))}t(e,s){const{node:f,listIndex:c,revealed:a}=this.F(e),$=this.u(f,c,a,s);if(f!==this.c&&this.k&&$&&!M(s)&&f.collapsible&&!f.collapsed&&!s.recursive){let d=-1;for(let b=0;b<f.children.length;b++)if(f.children[b].visible)if(d>-1){d=-1;break}else d=b;d>-1&&this.t([...e,d],s)}return $}u(e,s,f,c){const a=this.v(e,c,!1);if(!f||!e.visible||!a)return a;const $=e.renderNodeCount,d=this.x(e),b=$-(s===-1?0:1);return this.p.splice(s+1,b,d.slice(1)),a}v(e,s,f){let c;if(e===this.c?c=!1:(M(s)?(c=e.collapsible!==s.collapsible,e.collapsible=s.collapsible):e.collapsible?(c=e.collapsed!==s.collapsed,e.collapsed=s.collapsed):c=!1,c&&this.f.fire({node:e,deep:f})),!M(s)&&s.recursive)for(const a of e.children)c=this.v(a,s,!0)||c;return c}expandTo(e){this.d.bufferEvents(()=>{let s=this.E(e);for(;s.parent;)s=s.parent,e=e.slice(0,e.length-1),s.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,s=this.z(this.c);this.p.splice(0,e,s),this.m.cancel()}w(e,s,f,c,a,$){const d={parent:s,element:e.element,children:[],depth:s.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.C(d,f);d.visibility=b,c&&a.push(d);const u=e.children||m.Iterable.empty(),N=c&&b!==0&&!d.collapsed;let B=0,R=1;for(const W of u){const z=this.w(W,d,b,N,a,$);d.children.push(z),R+=z.renderNodeCount,z.visible&&(z.visibleChildIndex=B++)}return d.collapsible=d.collapsible||d.children.length>0,d.visibleChildrenCount=B,d.visible=b===2?B>0:b===1,d.visible?d.collapsed||(d.renderNodeCount=R):(d.renderNodeCount=0,c&&a.pop()),$?.(d),d}x(e){const s=e.renderNodeCount,f=[];return this.y(e,f),this.B(e.parent,f.length-s),f}y(e,s){if(e.visible===!1)return 0;if(s.push(e),e.renderNodeCount=1,!e.collapsed)for(const f of e.children)e.renderNodeCount+=this.y(f,s);return this.g.fire(e),e.renderNodeCount}z(e){const s=e.renderNodeCount,f=[];return this.A(e,e.visible?1:0,f),this.B(e.parent,f.length-s),f}A(e,s,f,c=!0){let a;if(e!==this.c){if(a=this.C(e,s),a===0)return e.visible=!1,e.renderNodeCount=0,!1;c&&f.push(e)}const $=f.length;e.renderNodeCount=e===this.c?0:1;let d=!1;if(!e.collapsed||a!==0){let b=0;for(const u of e.children)d=this.A(u,a,f,c&&!e.collapsed)||d,u.visible&&(u.visibleChildIndex=b++);e.visibleChildrenCount=b}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=a===2?d:a===1,e.visibility=a),e.visible?e.collapsed||(e.renderNodeCount+=f.length-$):(e.renderNodeCount=0,c&&f.pop()),this.g.fire(e),e.visible}B(e,s){if(s!==0)for(;e;)e.renderNodeCount+=s,this.g.fire(e),e=e.parent}C(e,s){const f=this.j?this.j.filter(e.element,s):1;return typeof f=="boolean"?(e.filterData=void 0,f?1:0):p(f)?(e.filterData=f.data,v(f.visibility)):(e.filterData=void 0,v(f))}D(e,s=this.c){if(!e||e.length===0)return!0;const[f,...c]=e;return f<0||f>s.children.length?!1:this.D(c,s.children[f])}E(e,s=this.c){if(!e||e.length===0)return s;const[f,...c]=e;if(f<0||f>s.children.length)throw new E.$9T(this.o,"Invalid tree location");return this.E(c,s.children[f])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:s,listIndex:f,revealed:c,visible:a}=this.G(e),$=e[e.length-1];if($<0||$>s.children.length)throw new E.$9T(this.o,"Invalid tree location");const d=s.children[$];return{node:d,listIndex:f,revealed:c,visible:a&&d.visible}}G(e,s=this.c,f=0,c=!0,a=!0){const[$,...d]=e;if($<0||$>s.children.length)throw new E.$9T(this.o,"Invalid tree location");for(let b=0;b<$;b++)f+=s.children[b].renderNodeCount;return c=c&&!s.collapsed,a=a&&s.visible,d.length===0?{parentNode:s,listIndex:f,revealed:c,visible:a}:this.G(d,s.children[$],f+1,c,a)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const s=[];let f=e;for(;f.parent;)s.push(f.parent.children.indexOf(f)),f=f.parent;return s.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const s=this.E(e);if(s.children.length!==0)return s.children[0].element}getLastElementAncestor(e=[]){const s=this.E(e);if(s.children.length!==0)return this.H(s)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.$aU=l}),define($e[123],pe([1,0,58,26,28]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$hU=void 0;class H{get size(){return this.d.size}constructor(k,m,p={}){this.k=k,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new E.$aU(k,m,null,p),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,p.sorter&&(this.j={compare(v,M){return p.sorter.compare(v.element,M.element)}}),this.h=p.identityProvider}setChildren(k,m=n.Iterable.empty(),p={}){const v=this.o(k);this.l(v,this.m(m),p)}l(k,m=n.Iterable.empty(),p){const v=new Set,M=new Set,l=e=>{if(e.element===null)return;const s=e;if(v.add(s.element),this.d.set(s.element,s),this.h){const f=this.h.getId(s.element).toString();M.add(f),this.f.set(f,s)}p.onDidCreateNode?.(s)},h=e=>{if(e.element===null)return;const s=e;if(v.has(s.element)||this.d.delete(s.element),this.h){const f=this.h.getId(s.element).toString();M.has(f)||this.f.delete(f)}p.onDidDeleteNode?.(s)};this.c.splice([...k,0],Number.MAX_VALUE,m,{...p,onDidCreateNode:l,onDidDeleteNode:h})}m(k=n.Iterable.empty()){return this.j&&(k=[...k].sort(this.j.compare.bind(this.j))),n.Iterable.map(k,m=>{let p=this.d.get(m.element);if(!p&&this.h){const l=this.h.getId(m.element).toString();p=this.f.get(l)}if(!p){let l;return typeof m.collapsed>"u"?l=void 0:m.collapsed===C.ObjectTreeElementCollapseState.Collapsed||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?l=!0:m.collapsed===C.ObjectTreeElementCollapseState.Expanded||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?l=!1:l=!!m.collapsed,{...m,children:this.m(m.children),collapsed:l}}const v=typeof m.collapsible=="boolean"?m.collapsible:p.collapsible;let M;return typeof m.collapsed>"u"||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||m.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?M=p.collapsed:m.collapsed===C.ObjectTreeElementCollapseState.Collapsed?M=!0:m.collapsed===C.ObjectTreeElementCollapseState.Expanded?M=!1:M=!!m.collapsed,{...m,collapsible:v,collapsed:M,children:this.m(m.children)}})}rerender(k){const m=this.o(k);this.c.rerender(m)}updateElementHeight(k,m){const p=this.o(k);this.c.updateElementHeight(p,m)}resort(k=null,m=!0){if(!this.j)return;const p=this.o(k),v=this.c.getNode(p);this.l(p,this.n(v,m),{})}n(k,m,p=!0){let v=[...k.children];return(m||p)&&(v=v.sort(this.j.compare.bind(this.j))),n.Iterable.map(v,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,m,!1)}))}getFirstElementChild(k=null){const m=this.o(k);return this.c.getFirstElementChild(m)}getLastElementAncestor(k=null){const m=this.o(k);return this.c.getLastElementAncestor(m)}has(k){return this.d.has(k)}getListIndex(k){const m=this.o(k);return this.c.getListIndex(m)}getListRenderCount(k){const m=this.o(k);return this.c.getListRenderCount(m)}isCollapsible(k){const m=this.o(k);return this.c.isCollapsible(m)}setCollapsible(k,m){const p=this.o(k);return this.c.setCollapsible(p,m)}isCollapsed(k){const m=this.o(k);return this.c.isCollapsed(m)}setCollapsed(k,m,p){const v=this.o(k);return this.c.setCollapsed(v,m,p)}expandTo(k){const m=this.o(k);this.c.expandTo(m)}refilter(){this.c.refilter()}getNode(k=null){if(k===null)return this.c.getNode(this.c.rootRef);const m=this.d.get(k);if(!m)throw new C.$9T(this.k,`Tree element not found: ${k}`);return m}getNodeLocation(k){return k.element}getParentNodeLocation(k){if(k===null)throw new C.$9T(this.k,"Invalid getParentNodeLocation call");const m=this.d.get(k);if(!m)throw new C.$9T(this.k,`Tree element not found: ${k}`);const p=this.c.getNodeLocation(m),v=this.c.getParentNodeLocation(p);return this.c.getNode(v).element}o(k){if(k===null)return[];const m=this.d.get(k);if(!m)throw new C.$9T(this.k,`Tree element not found: ${k}`);return this.c.getNodeLocation(m)}}t.$hU=H}),define($e[20],pe([1,0,2,14,19,25,3]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BR=void 0;class k extends D.$Tc{f(p,v){this.B(E.$ZP(p,E.$TQ.CLICK,M=>v(new n.$RP(E.getWindow(p),M))))}j(p,v){this.B(E.$ZP(p,E.$TQ.MOUSE_DOWN,M=>v(new n.$RP(E.getWindow(p),M))))}m(p,v){this.B(E.$ZP(p,E.$TQ.MOUSE_OVER,M=>v(new n.$RP(E.getWindow(p),M))))}u(p,v){this.B(E.$ZP(p,E.$TQ.MOUSE_LEAVE,M=>v(new n.$RP(E.getWindow(p),M))))}z(p,v){this.B(E.$ZP(p,E.$TQ.KEY_DOWN,M=>v(new C.$WP(M))))}C(p,v){this.B(E.$ZP(p,E.$TQ.KEY_UP,M=>v(new C.$WP(M))))}D(p,v){this.B(E.$ZP(p,E.$TQ.INPUT,v))}F(p,v){this.B(E.$ZP(p,E.$TQ.BLUR,v))}G(p,v){this.B(E.$ZP(p,E.$TQ.FOCUS,v))}H(p,v){this.B(E.$ZP(p,E.$TQ.CHANGE,v))}I(p){return H.$xR.ignoreTarget(p)}}t.$BR=k}),define($e[39],pe([1,0,56,20,9,18,2]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=t.$CR=void 0,t.$CR=11;class k extends C.$BR{constructor(p){super(),this.a=p.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=p.bgWidth+"px",this.bgDomNode.style.height=p.bgHeight+"px",typeof p.top<"u"&&(this.bgDomNode.style.top="0px"),typeof p.left<"u"&&(this.bgDomNode.style.left="0px"),typeof p.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof p.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=p.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(p.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$CR+"px",this.domNode.style.height=t.$CR+"px",typeof p.top<"u"&&(this.domNode.style.top=p.top+"px"),typeof p.left<"u"&&(this.domNode.style.left=p.left+"px"),typeof p.bottom<"u"&&(this.domNode.style.bottom=p.bottom+"px"),typeof p.right<"u"&&(this.domNode.style.right=p.right+"px"),this.g=this.B(new E.$AR),this.B(D.$1P(this.bgDomNode,D.$TQ.POINTER_DOWN,v=>this.h(v))),this.B(D.$1P(this.domNode,D.$TQ.POINTER_DOWN,v=>this.h(v))),this.b=this.B(new D.$_P),this.c=this.B(new n.$fh)}h(p){if(!p.target||!(p.target instanceof Element))return;const v=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,D.getWindow(p))};this.a(),this.b.cancel(),this.c.cancelAndSet(v,200),this.g.startMonitoring(p.target,p.pointerId,p.buttons,M=>{},()=>{this.b.cancel(),this.c.cancel()}),p.preventDefault()}}t.$DR=k}),define($e[59],pe([1,0,2,42,56,39,121,20,5]),function(ne,t,E,C,n,H,D,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GR=void 0;const p=140;class v extends k.$BR{constructor(l){super(),this.g=l.lazyRender,this.a=l.host,this.b=l.scrollable,this.c=l.scrollByPage,this.h=l.scrollbarState,this.n=this.B(new D.$FR(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new n.$AR),this.s=!0,this.domNode=(0,C.$zR)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(E.$ZP(this.domNode.domNode,E.$TQ.POINTER_DOWN,h=>this.M(h)))}t(l){const h=this.B(new H.$DR(l));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(l,h,e,s){this.slider=(0,C.$zR)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof s=="number"&&this.slider.setHeight(s),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(E.$ZP(this.slider.domNode,E.$TQ.POINTER_DOWN,f=>{f.button===0&&(f.preventDefault(),this.O(f))})),this.f(this.slider.domNode,f=>{f.leftButton&&f.stopPropagation()})}y(l){return this.h.setVisibleSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(l){return this.h.setScrollSize(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(l){return this.h.setScrollPosition(l)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(l){l.target===this.domNode.domNode&&this.N(l)}delegatePointerDown(l){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),s=h+this.h.getSliderPosition()+this.h.getSliderSize(),f=this.U(l);e<=f&&f<=s?l.button===0&&(l.preventDefault(),this.O(l)):this.N(l)}N(l){let h,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")h=l.offsetX,e=l.offsetY;else{const f=E.$jQ(this.domNode.domNode);h=l.pageX-f.left,e=l.pageY-f.top}const s=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(s):this.h.getDesiredScrollPositionFromOffset(s)),l.button===0&&(l.preventDefault(),this.O(l))}O(l){if(!l.target||!(l.target instanceof Element))return;const h=this.U(l),e=this.W(l),s=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(l.target,l.pointerId,l.buttons,f=>{const c=this.W(f),a=Math.abs(c-e);if(m.$i&&a>p){this.P(s.getScrollPosition());return}const d=this.U(f)-h;this.P(s.getDesiredScrollPositionFromDelta(d))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(l){const h={};this.writeScrollPosition(h,l),this.b.setScrollPositionNow(h)}updateScrollbarSize(l){this.X(l),this.h.setScrollbarSize(l),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$GR=v}),define($e[124],pe([1,0,19,59,39,43,17]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HR=void 0;class k extends C.$GR{constructor(p,v,M){const l=p.getScrollDimensions(),h=p.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:M,scrollbarState:new H.$ER(v.horizontalHasArrows?v.arrowSize:0,v.horizontal===2?0:v.horizontalScrollbarSize,v.vertical===2?0:v.verticalScrollbarSize,l.width,l.scrollWidth,h.scrollLeft),visibility:v.horizontal,extraScrollbarClassName:"horizontal",scrollable:p,scrollByPage:v.scrollByPage}),v.horizontalHasArrows){const e=(v.arrowSize-n.$CR)/2,s=(v.horizontalScrollbarSize-n.$CR)/2;this.t({className:"scra",icon:D.$bk.scrollbarButtonLeft,top:s,left:e,bottom:void 0,right:void 0,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.$TP(null,1,0))}),this.t({className:"scra",icon:D.$bk.scrollbarButtonRight,top:s,left:void 0,bottom:void 0,right:e,bgWidth:v.arrowSize,bgHeight:v.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new E.$TP(null,-1,0))})}this.w(Math.floor((v.horizontalScrollbarSize-v.horizontalSliderSize)/2),0,void 0,v.horizontalSliderSize)}R(p,v){this.slider.setWidth(p),this.slider.setLeft(v)}Q(p,v){this.domNode.setWidth(p),this.domNode.setHeight(v),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(p){return this.s=this.J(p.scrollWidth)||this.s,this.s=this.L(p.scrollLeft)||this.s,this.s=this.y(p.width)||this.s,this.s}S(p,v){return p}U(p){return p.pageX}W(p){return p.pageY}X(p){this.slider.setHeight(p)}writeScrollPosition(p,v){p.scrollLeft=v}updateOptions(p){this.updateScrollbarSize(p.horizontal===2?0:p.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.n.setVisibility(p.horizontal),this.c=p.scrollByPage}}t.$HR=k}),define($e[125],pe([1,0,19,59,39,43,17]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IR=void 0;class k extends C.$GR{constructor(p,v,M){const l=p.getScrollDimensions(),h=p.getCurrentScrollPosition();if(super({lazyRender:v.lazyRender,host:M,scrollbarState:new H.$ER(v.verticalHasArrows?v.arrowSize:0,v.vertical===2?0:v.verticalScrollbarSize,0,l.height,l.scrollHeight,h.scrollTop),visibility:v.vertical,extraScrollbarClassName:"vertical",scrollable:p,scrollByPage:v.scrollByPage}),v.verticalHasArrows){const e=(v.arrowSize-n.$CR)/2,s=(v.verticalScrollbarSize-n.$CR)/2;this.t({className:"scra",icon:D.$bk.scrollbarButtonUp,top:e,left:s,bottom:void 0,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.$TP(null,0,1))}),this.t({className:"scra",icon:D.$bk.scrollbarButtonDown,top:void 0,left:s,bottom:e,right:void 0,bgWidth:v.verticalScrollbarSize,bgHeight:v.arrowSize,onActivate:()=>this.a.onMouseWheel(new E.$TP(null,0,-1))})}this.w(0,Math.floor((v.verticalScrollbarSize-v.verticalSliderSize)/2),v.verticalSliderSize,void 0)}R(p,v){this.slider.setHeight(p),this.slider.setTop(v)}Q(p,v){this.domNode.setWidth(v),this.domNode.setHeight(p),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(p){return this.s=this.J(p.scrollHeight)||this.s,this.s=this.L(p.scrollTop)||this.s,this.s=this.y(p.height)||this.s,this.s}S(p,v){return v}U(p){return p.pageY}W(p){return p.pageX}X(p){this.slider.setWidth(p)}writeScrollPosition(p,v){p.scrollTop=v}updateOptions(p){this.updateScrollbarSize(p.vertical===2?0:p.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(p.vertical),this.c=p.scrollByPage}}t.$IR=k}),define($e[60],pe([1,0,16,2,42,19,124,125,20,9,4,3,5,48,99]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NR=t.$MR=t.$LR=t.$KR=t.$JR=void 0;const e=500,s=50,f=!0;class c{constructor(R,W,z){this.timestamp=R,this.deltaX=W,this.deltaY=z,this.score=0}}class a{static{this.INSTANCE=new a}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let R=1,W=0,z=1,y=this.d;do{const O=y===this.c?R:Math.pow(2,-z);if(R-=O,W+=this.b[y].score*O,y===this.c)break;y=(this.a+y-1)%this.a,z++}while(!0);return W<=.5}acceptStandardWheelEvent(R){if(E.$HP){const W=C.getWindow(R.browserEvent),z=(0,E.$AP)(W);this.accept(Date.now(),R.deltaX*z,R.deltaY*z)}else this.accept(Date.now(),R.deltaX,R.deltaY)}accept(R,W,z){const y=new c(R,W,z);y.score=this.f(y),this.c===-1&&this.d===-1?(this.b[0]=y,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=y)}f(R){if(Math.abs(R.deltaX)>0&&Math.abs(R.deltaY)>0)return 1;let W=.5;const z=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(R.deltaX)||!this.g(R.deltaY))&&(W+=.25),Math.min(Math.max(W,0),1)}g(R){return Math.abs(Math.round(R)-R)<.01}}t.$JR=a;class $ extends m.$BR{get options(){return this.a}constructor(R,W,z){super(),this.O=this.B(new v.$Wd),this.onScroll=this.O.event,this.P=this.B(new v.$Wd),this.onWillScroll=this.P.event,R.style.overflow="hidden",this.a=N(W),this.b=z,this.B(this.b.onScroll(O=>{this.P.fire(O),this.S(O),this.O.fire(O)}));const y={onMouseWheel:O=>this.R(O),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new k.$IR(this.b,this.a,y)),this.g=this.B(new D.$HR(this.b,this.a,y)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(R),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,n.$zR)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,n.$zR)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,n.$zR)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,O=>this.Z(O)),this.u(this.t,O=>this.Y(O)),this.L=this.B(new p.$fh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,M.$Oc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(R){this.c.delegatePointerDown(R)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(R){this.b.setScrollDimensions(R,!1)}updateClassName(R){this.a.className=R,l.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(R){typeof R.handleMouseWheel<"u"&&(this.a.handleMouseWheel=R.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof R.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=R.mouseWheelScrollSensitivity),typeof R.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=R.fastScrollSensitivity),typeof R.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=R.scrollPredominantAxis),typeof R.horizontal<"u"&&(this.a.horizontal=R.horizontal),typeof R.vertical<"u"&&(this.a.vertical=R.vertical),typeof R.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=R.horizontalScrollbarSize),typeof R.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=R.verticalScrollbarSize),typeof R.scrollByPage<"u"&&(this.a.scrollByPage=R.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(R){this.N=R}delegateScrollFromMouseWheelEvent(R){this.R(new H.$TP(R))}Q(R){if(this.w.length>0!==R&&(this.w=(0,M.$Oc)(this.w),R)){const z=y=>{this.R(new H.$TP(y))};this.w.push(C.$ZP(this.t,C.$TQ.MOUSE_WHEEL,z,{passive:!1}))}}R(R){if(R.browserEvent?.defaultPrevented)return;const W=a.INSTANCE;f&&W.acceptStandardWheelEvent(R);let z=!1;if(R.deltaY||R.deltaX){let O=R.deltaY*this.a.mouseWheelScrollSensitivity,U=R.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&U+O===0?U=O=0:Math.abs(O)>=Math.abs(U)?U=0:O=0),this.a.flipAxes&&([O,U]=[U,O]);const S=!l.$j&&R.browserEvent&&R.browserEvent.shiftKey;(this.a.scrollYToX||S)&&!U&&(U=O,O=0),R.browserEvent&&R.browserEvent.altKey&&(U=U*this.a.fastScrollSensitivity,O=O*this.a.fastScrollSensitivity);const P=this.b.getFutureScrollPosition();let L={};if(O){const G=s*O,Z=P.scrollTop-(G<0?Math.floor(G):Math.ceil(G));this.c.writeScrollPosition(L,Z)}if(U){const G=s*U,Z=P.scrollLeft-(G<0?Math.floor(G):Math.ceil(G));this.g.writeScrollPosition(L,Z)}L=this.b.validateScrollPosition(L),(P.scrollLeft!==L.scrollLeft||P.scrollTop!==L.scrollTop)&&(f&&this.a.mouseWheelSmoothScroll&&W.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(L):this.b.setScrollPositionNow(L),z=!0)}let y=z;!y&&this.a.alwaysConsumeMouseWheel&&(y=!0),!y&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(y=!0),y&&(R.preventDefault(),R.stopPropagation())}S(R){this.M=this.g.onDidScroll(R)||this.M,this.M=this.c.onDidScroll(R)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const R=this.b.getCurrentScrollPosition(),W=R.scrollTop>0,z=R.scrollLeft>0,y=z?" left":"",O=W?" top":"",U=z||W?" top-left-corner":"";this.n.setClassName(`shadow${y}`),this.r.setClassName(`shadow${O}`),this.s.setClassName(`shadow${U}${O}${y}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(R){this.J=!1,this.ab()}Z(R){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$KR=$;class d extends ${constructor(R,W){W=W||{},W.mouseWheelSmoothScroll=!1;const z=new h.$ns({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>C.$0P(C.getWindow(R),y)});super(R,W,z),this.B(z)}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$LR=d;class b extends ${constructor(R,W,z){super(R,W,z)}setScrollPosition(R){R.reuseAnimation?this.b.setScrollPositionSmooth(R,R.reuseAnimation):this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$MR=b;class u extends ${constructor(R,W){W=W||{},W.mouseWheelSmoothScroll=!1;const z=new h.$ns({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:y=>C.$0P(C.getWindow(R),y)});super(R,W,z),this.B(z),this.cb=R,this.B(this.onScroll(y=>{y.scrollTopChanged&&(this.cb.scrollTop=y.scrollTop),y.scrollLeftChanged&&(this.cb.scrollLeft=y.scrollLeft)})),this.scanDomNode()}setScrollPosition(R){this.b.setScrollPositionNow(R)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$NR=u;function N(B){const R={lazyRender:typeof B.lazyRender<"u"?B.lazyRender:!1,className:typeof B.className<"u"?B.className:"",useShadows:typeof B.useShadows<"u"?B.useShadows:!0,handleMouseWheel:typeof B.handleMouseWheel<"u"?B.handleMouseWheel:!0,flipAxes:typeof B.flipAxes<"u"?B.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof B.consumeMouseWheelIfScrollbarIsNeeded<"u"?B.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof B.alwaysConsumeMouseWheel<"u"?B.alwaysConsumeMouseWheel:!1,scrollYToX:typeof B.scrollYToX<"u"?B.scrollYToX:!1,mouseWheelScrollSensitivity:typeof B.mouseWheelScrollSensitivity<"u"?B.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof B.fastScrollSensitivity<"u"?B.fastScrollSensitivity:5,scrollPredominantAxis:typeof B.scrollPredominantAxis<"u"?B.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof B.mouseWheelSmoothScroll<"u"?B.mouseWheelSmoothScroll:!0,arrowSize:typeof B.arrowSize<"u"?B.arrowSize:11,listenOnDomNode:typeof B.listenOnDomNode<"u"?B.listenOnDomNode:null,horizontal:typeof B.horizontal<"u"?B.horizontal:1,horizontalScrollbarSize:typeof B.horizontalScrollbarSize<"u"?B.horizontalScrollbarSize:10,horizontalSliderSize:typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:0,horizontalHasArrows:typeof B.horizontalHasArrows<"u"?B.horizontalHasArrows:!1,vertical:typeof B.vertical<"u"?B.vertical:1,verticalScrollbarSize:typeof B.verticalScrollbarSize<"u"?B.verticalScrollbarSize:10,verticalHasArrows:typeof B.verticalHasArrows<"u"?B.verticalHasArrows:!1,verticalSliderSize:typeof B.verticalSliderSize<"u"?B.verticalSliderSize:0,scrollByPage:typeof B.scrollByPage<"u"?B.scrollByPage:!1};return R.horizontalSliderSize=typeof B.horizontalSliderSize<"u"?B.horizontalSliderSize:R.horizontalScrollbarSize,R.verticalSliderSize=typeof B.verticalSliderSize<"u"?B.verticalSliderSize:R.verticalScrollbarSize,l.$j&&(R.className+=" mac"),R}}),define($e[61],pe([1,0,54,2,22,25,60,12,9,27,4,3,47,48,83,120,6,33]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h,e,s,f,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cS=t.$bS=t.$aS=t.$_R=t.ListViewTargetSector=void 0;const a={CurrentDragAndDropData:void 0};var $;(function(z){z[z.TOP=0]="TOP",z[z.CENTER_TOP=1]="CENTER_TOP",z[z.CENTER_BOTTOM=2]="CENTER_BOTTOM",z[z.BOTTOM=3]="BOTTOM"})($||(t.ListViewTargetSector=$={}));const d={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(z){return[z]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context(y){this.d=y}constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.$_R=b;class u{constructor(y){this.elements=y}update(){}getData(){return this.elements}}t.$aS=u;class N{constructor(){this.types=[],this.files=[]}update(y){if(y.types&&this.types.splice(0,this.types.length,...y.types),y.files){this.files.splice(0,this.files.length);for(let O=0;O<y.files.length;O++){const U=y.files.item(O);U&&(U.size||U.type)&&this.files.push(U)}}}getData(){return{types:this.types,files:this.files}}}t.$bS=N;function B(z,y){return Array.isArray(z)&&Array.isArray(y)?(0,k.$ub)(z,y):z===y}class R{constructor(y){y?.getSetSize?this.getSetSize=y.getSetSize.bind(y):this.getSetSize=(O,U,S)=>S,y?.getPosInSet?this.getPosInSet=y.getPosInSet.bind(y):this.getPosInSet=(O,U)=>U+1,y?.getRole?this.getRole=y.getRole.bind(y):this.getRole=O=>"listitem",y?.isChecked?this.isChecked=y.isChecked.bind(y):this.isChecked=O=>{}}}class W{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q(y){if(y!==this.P){if(y&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=y,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const O of this.d)this.ab(O);this.X(),this.q.setScrollDimensions({width:(0,C.$mQ)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(y,O,U,S=d){if(this.R=O,this.domId=`list_id_${++W.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new m.$5g(50),this.v=!1,this.x=M.$Tc.None,this.y=0,this.G=!1,this.K=M.$Tc.None,this.L=M.$Tc.None,this.M=new M.$Sc,this.N=new v.$Wd,this.O=new v.$Wd,this.onDidChangeContentHeight=v.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=v.Event.latch(this.O.event,void 0,this.M),this.P=!1,S.horizontalScrolling&&S.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(S.paddingTop??0);for(const L of U)this.j.set(L.templateId,L);this.h=this.M.add(new s.$$R(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof S.mouseSupport=="boolean"?S.mouseSupport:!0),this.P=S.horizontalScrolling??d.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof S.paddingBottom>"u"?0:S.paddingBottom,this.D=new R(S.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(S.transformOptimization??d.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$xR.addTarget(this.o)),this.p=this.M.add(new h.$ns({forceIntegerValues:!0,smoothScrollDuration:S.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:L=>(0,C.$0P)((0,C.getWindow)(this.domNode),L)})),this.q=this.M.add(new D.$MR(this.o,{alwaysConsumeMouseWheel:S.alwaysConsumeMouseWheel??d.alwaysConsumeMouseWheel,horizontal:1,vertical:S.verticalScrollMode??d.verticalScrollMode,useShadows:S.useShadows??d.useShadows,mouseWheelScrollSensitivity:S.mouseWheelScrollSensitivity,fastScrollSensitivity:S.fastScrollSensitivity,scrollByPage:S.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),y.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$ZP)(this.o,H.EventType.Change,L=>this.jb(L))),this.M.add((0,C.$ZP)(this.q.getDomNode(),"scroll",L=>L.target.scrollTop=0)),this.M.add((0,C.$ZP)(this.domNode,"dragover",L=>this.lb(this.hb(L)))),this.M.add((0,C.$ZP)(this.domNode,"drop",L=>this.nb(this.hb(L)))),this.M.add((0,C.$ZP)(this.domNode,"dragleave",L=>this.mb(this.hb(L)))),this.M.add((0,C.$ZP)(this.domNode,"dragend",L=>this.ob(L))),this.z=S.setRowLineHeight??d.setRowLineHeight,this.A=S.setRowHeight??d.setRowHeight,this.B=S.supportDynamicHeights??d.supportDynamicHeights,this.F=S.dnd??this.M.add(d.dnd),this.layout(S.initialSize?.height,S.initialSize?.width)}updateOptions(y){y.paddingBottom!==void 0&&(this.C=y.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),y.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(y.smoothScrolling?125:0),y.horizontalScrolling!==void 0&&(this.Q=y.horizontalScrolling);let O;if(y.scrollByPage!==void 0&&(O={...O??{},scrollByPage:y.scrollByPage}),y.mouseWheelScrollSensitivity!==void 0&&(O={...O??{},mouseWheelScrollSensitivity:y.mouseWheelScrollSensitivity}),y.fastScrollSensitivity!==void 0&&(O={...O??{},fastScrollSensitivity:y.fastScrollSensitivity}),O&&this.q.updateOptions(O),y.paddingTop!==void 0&&y.paddingTop!==this.g.paddingTop){const U=this.vb(this.k,this.m),S=y.paddingTop-this.g.paddingTop;this.g.paddingTop=y.paddingTop,this.Y(U,Math.max(0,this.k+S),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent(y){this.q.delegateScrollFromMouseWheelEvent(y)}delegateVerticalScrollbarPointerDown(y){this.q.delegateVerticalScrollbarPointerDown(y)}updateElementHeight(y,O,U){if(y<0||y>=this.d.length)return;const S=this.d[y].size;if(typeof O>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[y].lastDynamicHeightWidth=void 0,O=S+this.xb(y)}if(S===O)return;const P=this.vb(this.k,this.m);let L=0;y<P.start||U!==null&&U>y&&U<P.end?L=O-S:L=0,this.g.splice(y,1,[{size:O}]),this.d[y].size=O,this.Y(P,Math.max(0,this.k+L),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S(y){return new e.$0R(y)}splice(y,O,U=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U(y,O,U)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U(y,O,U=[]){const S=this.vb(this.k,this.m),P={start:y,end:y+O},L=l.Range.intersect(S,P),G=new Map;for(let K=L.end-1;K>=L.start;K--){const ie=this.d[K];if(ie.dragStartDisposable.dispose(),ie.checkedDisposable.dispose(),ie.row){let fe=G.get(ie.templateId);fe||(fe=[],G.set(ie.templateId,fe));const De=this.j.get(ie.templateId);De&&De.disposeElement&&De.disposeElement(ie.element,K,ie.row.templateData,ie.size),fe.push(ie.row)}ie.row=null,ie.stale=!0}const Z={start:y+O,end:this.d.length},ge=l.Range.intersect(Z,S),ue=l.Range.relativeComplement(Z,S),te=U.map(K=>({id:String(this.f++),element:K,templateId:this.R.getTemplateId(K),size:this.R.getHeight(K),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(K),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.$Tc.None,checkedDisposable:M.$Tc.None,stale:!1}));let me;y===0&&O>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,te),me=this.d,this.d=te):(this.g.splice(y,O,te),me=this.d.splice(y,O,...te));const Re=U.length-O,Ne=this.vb(this.k,this.m),Be=(0,e.$8R)(ge,Re),re=l.Range.intersect(Ne,Be);for(let K=re.start;K<re.end;K++)this.bb(this.d[K],K);const J=l.Range.relativeComplement(Be,Ne);for(const K of J)for(let ie=K.start;ie<K.end;ie++)this.db(ie);const ae=ue.map(K=>(0,e.$8R)(K,Re)),Y=[{start:y,end:y+U.length},...ae].map(K=>l.Range.intersect(Ne,K)).reverse();for(const K of Y)for(let ie=K.end-1;ie>=K.start;ie--){const fe=this.d[ie],Te=G.get(fe.templateId)?.pop();this.Z(ie,Te)}for(const K of G.values())for(const ie of K)this.h.release(ie);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),me.map(K=>K.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$0P)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let y=0;for(const O of this.d)typeof O.width<"u"&&(y=Math.max(y,O.width));this.E=y,this.q.setScrollDimensions({scrollWidth:y===0?0:y+10}),this.O.fire(this.E)}updateWidth(y){if(!this.Q||typeof this.E>"u")return;const O=this.d[y];this.ab(O),typeof O.width<"u"&&O.width>this.E&&(this.E=O.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const y of this.d)y.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const y=this.firstVisibleIndex,O=this.g.positionAt(y),U=this.g.positionAt(y+1);return U!==-1&&(U-O)/2+O<this.scrollTop?y+1:y}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element(y){return this.d[y].element}indexOf(y){return this.d.findIndex(O=>O.element===y)}domElement(y){const O=this.d[y].row;return O&&O.domNode}elementHeight(y){return this.d[y].size}elementTop(y){return this.g.positionAt(y)}indexAt(y){return this.g.indexAt(y)}indexAfter(y){return this.g.indexAfter(y)}layout(y,O){const U={height:typeof y=="number"?y:(0,C.$oQ)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,U.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(U),typeof O<"u"&&(this.n=O,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof O=="number"?O:(0,C.$mQ)(this.domNode)})}Y(y,O,U,S,P,L=!1){const G=this.vb(O,U),Z=l.Range.relativeComplement(G,y).reverse(),ge=l.Range.relativeComplement(y,G);if(L){const ue=l.Range.intersect(y,G);for(let te=ue.start;te<ue.end;te++)this.bb(this.d[te],te)}this.h.transact(()=>{for(const ue of ge)for(let te=ue.start;te<ue.end;te++)this.db(te);for(const ue of Z)for(let te=ue.end-1;te>=ue.start;te--)this.Z(te)}),S!==void 0&&(this.o.style.left=`-${S}px`),this.o.style.top=`-${O}px`,this.Q&&P!==void 0&&(this.o.style.width=`${Math.max(P,this.n)}px`),this.k=O,this.m=U}Z(y,O){const U=this.d[y];if(!U.row)if(O)U.row=O,U.stale=!0;else{const Z=this.h.alloc(U.templateId);U.row=Z.row,U.stale||=Z.isReusingConnectedDomNode}const S=this.D.getRole(U.element)||"listitem";U.row.domNode.setAttribute("role",S);const P=this.D.isChecked(U.element);if(typeof P=="boolean")U.row.domNode.setAttribute("aria-checked",String(!!P));else if(P){const Z=ge=>U.row.domNode.setAttribute("aria-checked",String(!!ge));Z(P.value),U.checkedDisposable=P.onDidChange(Z)}if(U.stale||!U.row.domNode.parentElement){const Z=this.d.at(y+1)?.row?.domNode??null;this.o.insertBefore(U.row.domNode,Z),U.stale=!1}this.bb(U,y);const L=this.j.get(U.templateId);if(!L)throw new Error(`No renderer found for template id ${U.templateId}`);L?.renderElement(U.element,y,U.row.templateData,U.size);const G=this.F.getDragURI(U.element);U.dragStartDisposable.dispose(),U.row.domNode.draggable=!!G,G&&(U.dragStartDisposable=(0,C.$ZP)(U.row.domNode,"dragstart",Z=>this.kb(U.element,G,Z))),this.Q&&(this.ab(U),this.W())}ab(y){if(!y.row||!y.row.domNode)return;y.row.domNode.style.width="fit-content",y.width=(0,C.$mQ)(y.row.domNode);const O=(0,C.getWindow)(y.row.domNode).getComputedStyle(y.row.domNode);O.paddingLeft&&(y.width+=parseFloat(O.paddingLeft)),O.paddingRight&&(y.width+=parseFloat(O.paddingRight)),y.row.domNode.style.width=""}bb(y,O){y.row.domNode.style.top=`${this.elementTop(O)}px`,this.A&&(y.row.domNode.style.height=`${y.size}px`),this.z&&(y.row.domNode.style.lineHeight=`${y.size}px`),y.row.domNode.setAttribute("data-index",`${O}`),y.row.domNode.setAttribute("data-last-element",O===this.length-1?"true":"false"),y.row.domNode.setAttribute("data-parity",O%2===0?"even":"odd"),y.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(y.element,O,this.length))),y.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(y.element,O))),y.row.domNode.setAttribute("id",this.getElementDomId(O)),y.row.domNode.classList.toggle("drop-target",y.dropTarget)}db(y){const O=this.d[y];if(O.dragStartDisposable.dispose(),O.checkedDisposable.dispose(),O.row){const U=this.j.get(O.templateId);U&&U.disposeElement&&U.disposeElement(O.element,y,O.row.templateData,O.size),this.h.release(O.row),O.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(y,O){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:y,reuseAnimation:O})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(y){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:y})}get scrollTop(){return this.getScrollTop()}set scrollTop(y){this.setScrollTop(y)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"click")).event,y=>this.eb(y),this.M)}get onMouseDblClick(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"dblclick")).event,y=>this.eb(y),this.M)}get onMouseMiddleClick(){return v.Event.filter(v.Event.map(this.M.add(new n.$2R(this.domNode,"auxclick")).event,y=>this.eb(y),this.M),y=>y.browserEvent.button===1,this.M)}get onMouseUp(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"mouseup")).event,y=>this.eb(y),this.M)}get onMouseDown(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"mousedown")).event,y=>this.eb(y),this.M)}get onMouseOver(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"mouseover")).event,y=>this.eb(y),this.M)}get onMouseMove(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"mousemove")).event,y=>this.eb(y),this.M)}get onMouseOut(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"mouseout")).event,y=>this.eb(y),this.M)}get onContextMenu(){return v.Event.any(v.Event.map(this.M.add(new n.$2R(this.domNode,"contextmenu")).event,y=>this.eb(y),this.M),v.Event.map(this.M.add(new n.$2R(this.domNode,H.EventType.Contextmenu)).event,y=>this.gb(y),this.M))}get onTouchStart(){return v.Event.map(this.M.add(new n.$2R(this.domNode,"touchstart")).event,y=>this.fb(y),this.M)}get onTap(){return v.Event.map(this.M.add(new n.$2R(this.o,H.EventType.Tap)).event,y=>this.gb(y),this.M)}eb(y){const O=this.ub(y.target||null),U=typeof O>"u"?void 0:this.d[O],S=U&&U.element;return{browserEvent:y,index:O,element:S}}fb(y){const O=this.ub(y.target||null),U=typeof O>"u"?void 0:this.d[O],S=U&&U.element;return{browserEvent:y,index:O,element:S}}gb(y){const O=this.ub(y.initialTarget||null),U=typeof O>"u"?void 0:this.d[O],S=U&&U.element;return{browserEvent:y,index:O,element:S}}hb(y){const O=this.ub(y.target||null),U=typeof O>"u"?void 0:this.d[O],S=U&&U.element,P=this.tb(y,O);return{browserEvent:y,index:O,element:S,sector:P}}ib(y){try{const O=this.vb(this.k,this.m);this.Y(O,y.scrollTop,y.height,y.scrollLeft,y.scrollWidth),this.B&&this.wb(y.scrollTop,y.height,y.inSmoothScrolling)}catch(O){throw console.error("Got bad scroll event:",y),O}}jb(y){y.preventDefault(),y.stopPropagation(),this.scrollTop-=y.translationY}kb(y,O,U){if(!U.dataTransfer)return;const S=this.F.getDragElements(y);if(U.dataTransfer.effectAllowed="copyMove",U.dataTransfer.setData(E.$vR.TEXT,O),U.dataTransfer.setDragImage){let P;this.F.getDragLabel&&(P=this.F.getDragLabel(S,U)),typeof P>"u"&&(P=String(S.length));const L=(0,C.$)(".monaco-drag-image");L.textContent=P;const Z=(ge=>{for(;ge&&!ge.classList.contains("monaco-workbench");)ge=ge.parentElement;return ge||this.domNode.ownerDocument})(this.domNode);Z.appendChild(L),U.dataTransfer.setDragImage(L,-10,-10),setTimeout(()=>Z.removeChild(L),0)}this.domNode.classList.add("dragging"),this.H=new b(S),a.CurrentDragAndDropData=new u(S),this.F.onDragStart?.(this.H,U)}lb(y){if(y.browserEvent.preventDefault(),this.L.dispose(),a.CurrentDragAndDropData&&a.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb(y.browserEvent),!y.browserEvent.dataTransfer))return!1;if(!this.H)if(a.CurrentDragAndDropData)this.H=a.CurrentDragAndDropData;else{if(!y.browserEvent.dataTransfer.types)return!1;this.H=new N}const O=this.F.onDragOver(this.H,y.element,y.index,y.sector,y.browserEvent);if(this.G=typeof O=="boolean"?O:O.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;y.browserEvent.dataTransfer.dropEffect=typeof O!="boolean"&&O.effect?.type===0?"copy":"move";let U;typeof O!="boolean"&&O.feedback?U=O.feedback:typeof y.index>"u"?U=[-1]:U=[y.index],U=(0,k.$Mb)(U).filter(P=>P>=-1&&P<this.length).sort((P,L)=>P-L),U=U[0]===-1?[-1]:U;let S=typeof O!="boolean"&&O.effect&&O.effect.position?O.effect.position:"drop-target";if(B(this.I,U)&&this.J===S)return!0;if(this.I=U,this.J=S,this.K.dispose(),U[0]===-1)this.domNode.classList.add(S),this.o.classList.add(S),this.K=(0,M.$Rc)(()=>{this.domNode.classList.remove(S),this.o.classList.remove(S)});else{if(U.length>1&&S!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");S==="drop-target-after"&&U[0]<this.length-1&&(U[0]+=1,S="drop-target-before");for(const P of U){const L=this.d[P];L.dropTarget=!0,L.row?.domNode.classList.add(S)}this.K=(0,M.$Rc)(()=>{for(const P of U){const L=this.d[P];L.dropTarget=!1,L.row?.domNode.classList.remove(S)}})}return!0}mb(y){this.L.dispose(),this.L=(0,m.$0g)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,y.element,y.index,y.browserEvent)}nb(y){if(!this.G)return;const O=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,!(!O||!y.browserEvent.dataTransfer)&&(y.browserEvent.preventDefault(),O.update(y.browserEvent.dataTransfer),this.F.drop(O,y.element,y.index,y.sector,y.browserEvent))}ob(y){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,a.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(y)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=M.$Tc.None}qb(y){if(!this.w){const O=(0,C.$gQ)(this.domNode).top;this.w=(0,C.$dR)((0,C.getWindow)(this.domNode),this.rb.bind(this,O))}this.x.dispose(),this.x=(0,m.$0g)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=y.pageY}rb(y){if(this.y===void 0)return;const O=this.y-y,U=this.renderHeight-35;O<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(O-35))):O>U&&(this.scrollTop+=Math.min(14,Math.floor(.3*(O-U))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb(y,O){if(O===void 0)return;const U=y.offsetY/this.d[O].size,S=Math.floor(U/.25);return(0,c.$9l)(S,0,3)}ub(y){const O=this.q.getDomNode();let U=y;for(;U instanceof HTMLElement&&U!==this.o&&O.contains(U);){const S=U.getAttribute("data-index");if(S){const P=Number(S);if(!isNaN(P))return P}U=U.parentElement}}vb(y,O){return{start:this.g.indexAt(y),end:this.g.indexAfter(y+O-1)}}wb(y,O,U){const S=this.vb(y,O);let P,L;y===this.elementTop(S.start)?(P=S.start,L=0):S.end-S.start>1&&(P=S.start+1,L=this.elementTop(P)-y);let G=0;for(;;){const Z=this.vb(y,O);let ge=!1;for(let ue=Z.start;ue<Z.end;ue++){const te=this.xb(ue);te!==0&&this.g.splice(ue,1,[this.d[ue]]),G+=te,ge=ge||te!==0}if(!ge){G!==0&&this.V();const ue=l.Range.relativeComplement(S,Z);for(const me of ue)for(let Re=me.start;Re<me.end;Re++)this.d[Re].row&&this.db(Re);const te=l.Range.relativeComplement(Z,S).reverse();for(const me of te)for(let Re=me.end-1;Re>=me.start;Re--)this.Z(Re);for(let me=Z.start;me<Z.end;me++)this.d[me].row&&this.bb(this.d[me],me);if(typeof P=="number"){const me=this.p.getFutureScrollPosition().scrollTop-y,Re=this.elementTop(P)-L+me;this.setScrollTop(Re,U)}this.N.fire(this.contentHeight);return}}}xb(y){const O=this.d[y];if(this.R.getDynamicHeight){const L=this.R.getDynamicHeight(O.element);if(L!==null){const G=O.size;return O.size=L,O.lastDynamicHeightWidth=this.n,L-G}}if(!O.hasDynamicHeight||O.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(O.element))return 0;const U=O.size;if(O.row)return O.row.domNode.style.height="",O.size=O.row.domNode.offsetHeight,O.lastDynamicHeightWidth=this.n,O.size-U;const{row:S}=this.h.alloc(O.templateId);S.domNode.style.height="",this.o.appendChild(S.domNode);const P=this.j.get(O.templateId);if(!P)throw new f.$cb("Missing renderer for templateId: "+O.templateId);return P.renderElement(O.element,y,S.templateData,void 0),O.size=S.domNode.offsetHeight,P.disposeElement?.(O.element,y,S.templateData,void 0),this.R.setDynamicHeight?.(O.element,O.size),O.lastDynamicHeightWidth=this.n,this.o.removeChild(S.domNode),this.h.release(S),O.size-U}getElementDomId(y){return`${this.domId}_${y}`}dispose(){for(const y of this.d)if(y.dragStartDisposable.dispose(),y.checkedDisposable.dispose(),y.row){const O=this.j.get(y.row.templateId);O&&(O.disposeElement?.(y.element,-1,y.row.templateData,void 0),O.disposeTemplate(y.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$cS=W,Ye([p.$zh],W.prototype,"onMouseClick",null),Ye([p.$zh],W.prototype,"onMouseDblClick",null),Ye([p.$zh],W.prototype,"onMouseMiddleClick",null),Ye([p.$zh],W.prototype,"onMouseUp",null),Ye([p.$zh],W.prototype,"onMouseDown",null),Ye([p.$zh],W.prototype,"onMouseOver",null),Ye([p.$zh],W.prototype,"onMouseMove",null),Ye([p.$zh],W.prototype,"onMouseOut",null),Ye([p.$zh],W.prototype,"onContextMenu",null),Ye([p.$zh],W.prototype,"onTouchStart",null),Ye([p.$zh],W.prototype,"onTap",null)}),define($e[40],pe([1,0,2,22,14,25,57,71,12,9,74,27,4,35,3,33,5,7,70,61,19,98]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h,e,s,f,c,a,$,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uS=t.$tS=t.$sS=t.$rS=t.$qS=t.$pS=t.$oS=t.TypeNavigationMode=t.$nS=t.$mS=t.$lS=t.$kS=t.$jS=t.$iS=t.$hS=t.$gS=void 0;class b{constructor(g){this.d=g,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(g){return g}renderElement(g,A,F){const r=this.c.findIndex(i=>i.templateData===F);if(r>=0){const i=this.c[r];this.d.unrender(F),i.index=A}else{const i={index:A,templateData:F};this.c.push(i)}this.d.renderIndex(A,F)}splice(g,A,F){const r=[];for(const i of this.c)i.index<g?r.push(i):i.index>=g+A&&r.push({index:i.index+F-A,templateData:i.templateData});this.c=r}renderIndexes(g){for(const{index:A,templateData:F}of this.c)g.indexOf(A)>-1&&this.d.renderIndex(A,F)}disposeTemplate(g){const A=this.c.findIndex(F=>F.templateData===g);A<0||this.c.splice(A,1)}}class u{get name(){return this.g}get renderer(){return new b(this)}constructor(g){this.g=g,this.c=[],this.d=[],this.f=new l.$Wd,this.onChange=this.f.event}splice(g,A,F){const r=F.length-A,i=g+A,o=[];let w=0;for(;w<this.d.length&&this.d[w]<g;)o.push(this.d[w++]);for(let I=0;I<F.length;I++)F[I]&&o.push(I+g);for(;w<this.d.length&&this.d[w]>=i;)o.push(this.d[w++]+r);this.renderer.splice(g,A,F.length),this.h(o,o)}renderIndex(g,A){A.classList.toggle(this.g,this.contains(g))}unrender(g){g.classList.remove(this.g)}set(g,A){return this.h(g,[...g].sort(ie),A)}h(g,A,F){const r=this.c,i=this.d;this.c=g,this.d=A;const o=Y(i,g);return this.renderer.renderIndexes(o),this.f.fire({indexes:g,browserEvent:F}),r}get(){return this.c}contains(g){return(0,m.$wb)(this.d,g,ie)>=0}dispose(){(0,e.$Oc)(this.f)}}Ye([M.$zh],u.prototype,"renderer",null);class N extends u{constructor(g){super("selected"),this.k=g}renderIndex(g,A){super.renderIndex(g,A),this.k&&(this.contains(g)?A.setAttribute("aria-selected","true"):A.setAttribute("aria-selected","false"))}}class B{constructor(g,A,F){this.c=g,this.d=A,this.f=F}splice(g,A,F){if(!this.f)return this.c.splice(g,A,new Array(F.length).fill(!1));const r=this.c.get().map(w=>this.f.getId(this.d.element(w)).toString());if(r.length===0)return this.c.splice(g,A,new Array(F.length).fill(!1));const i=new Set(r),o=F.map(w=>i.has(this.f.getId(w).toString()));this.c.splice(g,A,o)}}function R(_){return _.tagName==="INPUT"||_.tagName==="TEXTAREA"}t.$gS=R;function W(_,g){return _.classList.contains(g)?!0:_.classList.contains("monaco-list")||!_.parentElement?!1:W(_.parentElement,g)}function z(_){return W(_,"monaco-editor")}t.$hS=z;function y(_){return W(_,"monaco-custom-toggle")}t.$iS=y;function O(_){return W(_,"action-item")}t.$jS=O;function U(_){return W(_,"monaco-tl-twistie")}t.$kS=U;function S(_){return W(_,"monaco-tree-sticky-row")}t.$lS=S;function P(_){return _.classList.contains("monaco-tree-sticky-container")}t.$mS=P;function L(_){return _.tagName==="A"&&_.classList.contains("monaco-button")||_.tagName==="DIV"&&_.classList.contains("monaco-button-dropdown")?!0:_.classList.contains("monaco-list")||!_.parentElement?!1:L(_.parentElement)}t.$nS=L;class G{get g(){return l.Event.chain(this.c.add(new C.$2R(this.k.domNode,"keydown")).event,g=>g.filter(A=>!R(A.target)).map(A=>new n.$WP(A)))}constructor(g,A,F){this.h=g,this.k=A,this.c=new e.$Sc,this.d=new e.$Sc,this.f=F.multipleSelectionSupport,this.c.add(this.g(r=>{switch(r.keyCode){case 3:return this.l(r);case 16:return this.o(r);case 18:return this.p(r);case 11:return this.q(r);case 12:return this.s(r);case 9:return this.u(r);case 31:this.f&&(f.$j?r.metaKey:r.ctrlKey)&&this.t(r)}}))}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.f=g.multipleSelectionSupport)}l(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection(this.h.getFocus(),g.browserEvent)}o(g){g.preventDefault(),g.stopPropagation(),this.h.focusPrevious(1,!1,g.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}p(g){g.preventDefault(),g.stopPropagation(),this.h.focusNext(1,!1,g.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}q(g){g.preventDefault(),g.stopPropagation(),this.h.focusPreviousPage(g.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}s(g){g.preventDefault(),g.stopPropagation(),this.h.focusNextPage(g.browserEvent);const A=this.h.getFocus()[0];this.h.setAnchor(A),this.h.reveal(A),this.k.domNode.focus()}t(g){g.preventDefault(),g.stopPropagation(),this.h.setSelection((0,m.$Sb)(this.h.length),g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(g){this.h.getSelection().length&&(g.preventDefault(),g.stopPropagation(),this.h.setSelection([],g.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ye([M.$zh],G.prototype,"g",null);var Z;(function(_){_[_.Automatic=0]="Automatic",_[_.Trigger=1]="Trigger"})(Z||(t.TypeNavigationMode=Z={}));var ge;(function(_){_[_.Idle=0]="Idle",_[_.Typing=1]="Typing"})(ge||(ge={})),t.$oS=new class{mightProducePrintableCharacter(_){return _.ctrlKey||_.metaKey||_.altKey?!1:_.keyCode>=31&&_.keyCode<=56||_.keyCode>=21&&_.keyCode<=30||_.keyCode>=98&&_.keyCode<=107||_.keyCode>=85&&_.keyCode<=95}};class ue{constructor(g,A,F,r,i){this.o=g,this.p=A,this.q=F,this.s=r,this.t=i,this.c=!1,this.d=ge.Idle,this.f=Z.Automatic,this.g=!1,this.h=-1,this.k=new e.$Sc,this.l=new e.$Sc,this.updateOptions(g.options)}updateOptions(g){g.typeNavigationEnabled??!0?this.u():this.v(),this.f=g.typeNavigationMode??Z.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let g=!1;const A=l.Event.chain(this.k.add(new C.$2R(this.p.domNode,"keydown")).event,i=>i.filter(o=>!R(o.target)).filter(()=>this.f===Z.Automatic||this.g).map(o=>new n.$WP(o)).filter(o=>g||this.s(o)).filter(o=>this.t.mightProducePrintableCharacter(o)).forEach(o=>E.$VQ.stop(o,!0)).map(o=>o.browserEvent.key)),F=l.Event.debounce(A,()=>null,800,void 0,void 0,void 0,this.k);l.Event.reduce(l.Event.any(A,F),(i,o)=>o===null?null:(i||"")+o,void 0,this.k)(this.x,this,this.k),F(this.w,this,this.k),A(()=>g=!0,void 0,this.k),F(()=>g=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const g=this.o.getFocus();if(g.length>0&&g[0]===this.h){const A=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(g[0]));A&&(0,D.$4R)(A)}this.h=-1}x(g){if(!g){this.d=ge.Idle,this.g=!1;return}const A=this.o.getFocus(),F=A.length>0?A[0]:0,r=this.d===ge.Idle?1:0;this.d=ge.Typing;for(let i=0;i<this.o.length;i++){const o=(F+i+r)%this.o.length,w=this.q.getKeyboardNavigationLabel(this.p.element(o)),I=w&&w.toString();if(this.o.options.typeNavigationEnabled){if(typeof I<"u"){if((0,h.$Wj)(g,I)){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}const T=(0,h.$4j)(g,I);if(T&&T[0].end-T[0].start>1&&T.length===1){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}}}else if(typeof I>"u"||(0,h.$Wj)(g,I)){this.h=F,this.o.setFocus([o]),this.o.reveal(o);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class te{constructor(g,A){this.d=g,this.f=A,this.c=new e.$Sc;const F=l.Event.chain(this.c.add(new C.$2R(A.domNode,"keydown")).event,i=>i.filter(o=>!R(o.target)).map(o=>new n.$WP(o)));l.Event.chain(F,i=>i.filter(o=>o.keyCode===2&&!o.ctrlKey&&!o.metaKey&&!o.shiftKey&&!o.altKey))(this.g,this,this.c)}g(g){if(g.target!==this.f.domNode)return;const A=this.d.getFocus();if(A.length===0)return;const F=this.f.domElement(A[0]);if(!F)return;const r=F.querySelector("[tabIndex]");if(!r||!(r instanceof HTMLElement)||r.tabIndex===-1)return;const i=(0,E.getWindow)(r).getComputedStyle(r);i.visibility==="hidden"||i.display==="none"||(g.preventDefault(),g.stopPropagation(),r.focus())}dispose(){this.c.dispose()}}function me(_){return f.$j?_.browserEvent.metaKey:_.browserEvent.ctrlKey}t.$pS=me;function Re(_){return _.browserEvent.shiftKey}t.$qS=Re;function Ne(_){return(0,E.$PQ)(_)&&_.button===2}const Be={isSelectionSingleChangeEvent:me,isSelectionRangeChangeEvent:Re};class re{constructor(g){this.k=g,this.f=new e.$Sc,this.g=new l.$Wd,this.onPointer=this.g.event,g.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||Be),this.d=typeof g.options.mouseSupport>"u"||!!g.options.mouseSupport,this.d&&(g.onMouseDown(this.s,this,this.f),g.onContextMenu(this.t,this,this.f),g.onMouseDblClick(this.v,this,this.f),g.onTouchStart(this.s,this,this.f),this.f.add(H.$xR.addTarget(g.getHTMLElement()))),l.Event.any(g.onMouseClick,g.onMouseMiddleClick,g.onTap)(this.u,this,this.f)}updateOptions(g){g.multipleSelectionSupport!==void 0&&(this.c=void 0,g.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||Be))}o(g){return this.c?this.c.isSelectionSingleChangeEvent(g):!1}p(g){return this.c?this.c.isSelectionRangeChangeEvent(g):!1}q(g){return this.o(g)||this.p(g)}s(g){z(g.browserEvent.target)||(0,E.$zQ)()!==g.browserEvent.target&&this.k.domFocus()}t(g){if(R(g.browserEvent.target)||z(g.browserEvent.target))return;const A=typeof g.index>"u"?[]:[g.index];this.k.setFocus(A,g.browserEvent)}u(g){if(!this.d||R(g.browserEvent.target)||z(g.browserEvent.target)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const A=g.index;if(typeof A>"u"){this.k.setFocus([],g.browserEvent),this.k.setSelection([],g.browserEvent),this.k.setAnchor(void 0);return}if(this.q(g))return this.w(g);this.k.setFocus([A],g.browserEvent),this.k.setAnchor(A),Ne(g.browserEvent)||this.k.setSelection([A],g.browserEvent),this.g.fire(g)}v(g){if(R(g.browserEvent.target)||z(g.browserEvent.target)||this.q(g)||g.browserEvent.isHandledByList)return;g.browserEvent.isHandledByList=!0;const A=this.k.getFocus();this.k.setSelection(A,g.browserEvent)}w(g){const A=g.index;let F=this.k.getAnchor();if(this.p(g)){typeof F>"u"&&(F=this.k.getFocus()[0]??A,this.k.setAnchor(F));const r=Math.min(F,A),i=Math.max(F,A),o=(0,m.$Sb)(r,i+1),w=this.k.getSelection(),I=se(Y(w,[F]),F);if(I.length===0)return;const T=Y(o,K(w,I));this.k.setSelection(T,g.browserEvent),this.k.setFocus([A],g.browserEvent)}else if(this.o(g)){const r=this.k.getSelection(),i=r.filter(o=>o!==A);this.k.setFocus([A]),this.k.setAnchor(A),r.length===i.length?this.k.setSelection([...i,A],g.browserEvent):this.k.setSelection(i,g.browserEvent)}}dispose(){this.f.dispose()}}t.$rS=re;class J{constructor(g,A){this.c=g,this.d=A}style(g){const A=this.d&&`.${this.d}`,F=[];g.listBackground&&F.push(`.monaco-list${A} .monaco-list-rows { background: ${g.listBackground}; }`),g.listFocusBackground&&(F.push(`.monaco-list${A}:focus .monaco-list-row.focused { background-color: ${g.listFocusBackground}; }`),F.push(`.monaco-list${A}:focus .monaco-list-row.focused:hover { background-color: ${g.listFocusBackground}; }`)),g.listFocusForeground&&F.push(`.monaco-list${A}:focus .monaco-list-row.focused { color: ${g.listFocusForeground}; }`),g.listActiveSelectionBackground&&(F.push(`.monaco-list${A}:focus .monaco-list-row.selected { background-color: ${g.listActiveSelectionBackground}; }`),F.push(`.monaco-list${A}:focus .monaco-list-row.selected:hover { background-color: ${g.listActiveSelectionBackground}; }`)),g.listActiveSelectionForeground&&F.push(`.monaco-list${A}:focus .monaco-list-row.selected { color: ${g.listActiveSelectionForeground}; }`),g.listActiveSelectionIconForeground&&F.push(`.monaco-list${A}:focus .monaco-list-row.selected .codicon { color: ${g.listActiveSelectionIconForeground}; }`),g.listFocusAndSelectionBackground&&F.push(`
				.monaco-drag-image,
				.monaco-list${A}:focus .monaco-list-row.selected.focused { background-color: ${g.listFocusAndSelectionBackground}; }
			`),g.listFocusAndSelectionForeground&&F.push(`
				.monaco-drag-image,
				.monaco-list${A}:focus .monaco-list-row.selected.focused { color: ${g.listFocusAndSelectionForeground}; }
			`),g.listInactiveFocusForeground&&(F.push(`.monaco-list${A} .monaco-list-row.focused { color:  ${g.listInactiveFocusForeground}; }`),F.push(`.monaco-list${A} .monaco-list-row.focused:hover { color:  ${g.listInactiveFocusForeground}; }`)),g.listInactiveSelectionIconForeground&&F.push(`.monaco-list${A} .monaco-list-row.focused .codicon { color:  ${g.listInactiveSelectionIconForeground}; }`),g.listInactiveFocusBackground&&(F.push(`.monaco-list${A} .monaco-list-row.focused { background-color:  ${g.listInactiveFocusBackground}; }`),F.push(`.monaco-list${A} .monaco-list-row.focused:hover { background-color:  ${g.listInactiveFocusBackground}; }`)),g.listInactiveSelectionBackground&&(F.push(`.monaco-list${A} .monaco-list-row.selected { background-color:  ${g.listInactiveSelectionBackground}; }`),F.push(`.monaco-list${A} .monaco-list-row.selected:hover { background-color:  ${g.listInactiveSelectionBackground}; }`)),g.listInactiveSelectionForeground&&F.push(`.monaco-list${A} .monaco-list-row.selected { color: ${g.listInactiveSelectionForeground}; }`),g.listHoverBackground&&F.push(`.monaco-list${A}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${g.listHoverBackground}; }`),g.listHoverForeground&&F.push(`.monaco-list${A}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${g.listHoverForeground}; }`);const r=(0,E.$gR)(g.listFocusAndSelectionOutline,(0,E.$gR)(g.listSelectionOutline,g.listFocusOutline??""));r&&F.push(`.monaco-list${A}:focus .monaco-list-row.focused.selected { outline: 1px solid ${r}; outline-offset: -1px;}`),g.listFocusOutline&&F.push(`
				.monaco-drag-image,
				.monaco-list${A}:focus .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${A}.last-focused .monaco-list-row.focused { outline: 1px solid ${g.listFocusOutline}; outline-offset: -1px; }
			`);const i=(0,E.$gR)(g.listSelectionOutline,g.listInactiveFocusOutline??"");i&&F.push(`.monaco-list${A} .monaco-list-row.focused.selected { outline: 1px dotted ${i}; outline-offset: -1px; }`),g.listSelectionOutline&&F.push(`.monaco-list${A} .monaco-list-row.selected { outline: 1px dotted ${g.listSelectionOutline}; outline-offset: -1px; }`),g.listInactiveFocusOutline&&F.push(`.monaco-list${A} .monaco-list-row.focused { outline: 1px dotted ${g.listInactiveFocusOutline}; outline-offset: -1px; }`),g.listHoverOutline&&F.push(`.monaco-list${A} .monaco-list-row:hover { outline: 1px dashed ${g.listHoverOutline}; outline-offset: -1px; }`),g.listDropOverBackground&&F.push(`
				.monaco-list${A}.drop-target,
				.monaco-list${A} .monaco-list-rows.drop-target,
				.monaco-list${A} .monaco-list-row.drop-target { background-color: ${g.listDropOverBackground} !important; color: inherit !important; }
			`),g.listDropBetweenBackground&&(F.push(`
			.monaco-list${A} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${A} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`),F.push(`
			.monaco-list${A} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${A} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${g.listDropBetweenBackground};
			}`)),g.tableColumnsBorder&&F.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${g.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),g.tableOddRowsBackgroundColor&&F.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${g.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=F.join(`
`)}}t.$sS=J,t.$tS={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:v.$ot.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:v.$ot.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:v.$ot.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ae={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function se(_,g){const A=_.indexOf(g);if(A===-1)return[];const F=[];let r=A-1;for(;r>=0&&_[r]===g-(A-r);)F.push(_[r--]);for(F.reverse(),r=A;r<_.length&&_[r]===g+(r-A);)F.push(_[r++]);return F}function Y(_,g){const A=[];let F=0,r=0;for(;F<_.length||r<g.length;)if(F>=_.length)A.push(g[r++]);else if(r>=g.length)A.push(_[F++]);else if(_[F]===g[r]){A.push(_[F]),F++,r++;continue}else _[F]<g[r]?A.push(_[F++]):A.push(g[r++]);return A}function K(_,g){const A=[];let F=0,r=0;for(;F<_.length||r<g.length;)if(F>=_.length)A.push(g[r++]);else if(r>=g.length)A.push(_[F++]);else if(_[F]===g[r]){F++,r++;continue}else _[F]<g[r]?A.push(_[F++]):r++;return A}const ie=(_,g)=>_-g;class fe{constructor(g,A){this.c=g,this.d=A}get templateId(){return this.c}renderTemplate(g){return this.d.map(A=>A.renderTemplate(g))}renderElement(g,A,F,r){let i=0;for(const o of this.d)o.renderElement(g,A,F[i++],r)}disposeElement(g,A,F,r){let i=0;for(const o of this.d)o.disposeElement?.(g,A,F[i],r),i+=1}disposeTemplate(g){let A=0;for(const F of this.d)F.disposeTemplate(g[A++])}}class De{constructor(g){this.c=g,this.templateId="a18n"}renderTemplate(g){return g}renderElement(g,A,F){const r=this.c.getAriaLabel(g);r?F.setAttribute("aria-label",r):F.removeAttribute("aria-label");const i=this.c.getAriaLevel&&this.c.getAriaLevel(g);typeof i=="number"?F.setAttribute("aria-level",`${i}`):F.removeAttribute("aria-level")}disposeTemplate(g){}}class Te{constructor(g,A){this.c=g,this.d=A}getDragElements(g){const A=this.c.getSelectedElements();return A.indexOf(g)>-1?A:[g]}getDragURI(g){return this.d.getDragURI(g)}getDragLabel(g,A){if(this.d.getDragLabel)return this.d.getDragLabel(g,A)}onDragStart(g,A){this.d.onDragStart?.(g,A)}onDragOver(g,A,F,r,i){return this.d.onDragOver(g,A,F,r,i)}onDragLeave(g,A,F,r){this.d.onDragLeave?.(g,A,F,r)}onDragEnd(g){this.d.onDragEnd?.(g)}drop(g,A,F,r,i){this.d.drop(g,A,F,r,i)}dispose(){this.d.dispose()}}class Se{get onDidChangeFocus(){return l.Event.map(this.g.wrapEvent(this.c.onChange),g=>this.G(g),this.y)}get onDidChangeSelection(){return l.Event.map(this.g.wrapEvent(this.d.onChange),g=>this.G(g),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let g=!1;const A=l.Event.chain(this.y.add(new C.$2R(this.k.domNode,"keydown")).event,i=>i.map(o=>new n.$WP(o)).filter(o=>g=o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>E.$VQ.stop(o,!0)).filter(()=>!1)),F=l.Event.chain(this.y.add(new C.$2R(this.k.domNode,"keyup")).event,i=>i.forEach(()=>g=!1).map(o=>new n.$WP(o)).filter(o=>o.keyCode===58||o.shiftKey&&o.keyCode===68).map(o=>E.$VQ.stop(o,!0)).map(({browserEvent:o})=>{const w=this.getFocus(),I=w.length?w[0]:void 0,T=typeof I<"u"?this.k.element(I):void 0,j=typeof I<"u"?this.k.domElement(I):this.k.domNode;return{index:I,element:T,anchor:j,browserEvent:o}})),r=l.Event.chain(this.k.onContextMenu,i=>i.filter(o=>!g).map(({element:o,index:w,browserEvent:I})=>({element:o,index:w,anchor:new d.$RP((0,E.getWindow)(this.k.domNode),I),browserEvent:I})));return l.Event.any(A,F,r)}get onKeyDown(){return this.y.add(new C.$2R(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$2R(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$2R(this.k.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.y.add(new C.$2R(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.y.add(new C.$2R(this.k.domNode,"blur",!0)).event)}constructor(g,A,F,r,i=ae){this.A=g,this.B=i,this.c=new u("focused"),this.f=new u("anchor"),this.g=new l.$5d,this.x="",this.y=new e.$Sc,this.z=new l.$Wd,this.onDidDispose=this.z.event;const o=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new N(o!=="listbox");const w=[this.c.renderer,this.d.renderer];this.u=i.accessibilityProvider,this.u&&(w.push(new De(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),r=r.map(T=>new fe(T.templateId,[...w,T]));const I={...i,dnd:i.dnd&&new Te(this,i.dnd)};if(this.k=this.C(A,F,r,I),this.k.domNode.setAttribute("role",o),i.styleController)this.q=i.styleController(this.k.domId);else{const T=(0,E.$IQ)(this.k.domNode);this.q=new J(T,this.k.domId)}if(this.o=new k.$6R([new B(this.c,this.k,i.identityProvider),new B(this.d,this.k,i.identityProvider),new B(this.f,this.k,i.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new te(this,this.k)),(typeof i.keyboardSupport!="boolean"||i.keyboardSupport)&&(this.v=new G(this,this.k,i),this.y.add(this.v)),i.keyboardNavigationLabelProvider){const T=i.keyboardNavigationDelegate||t.$oS;this.t=new ue(this,this.k,i.keyboardNavigationLabelProvider,i.keyboardNavigationEventFilter??(()=>!0),T),this.y.add(this.t)}this.w=this.D(i),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(g,A,F,r){return new $.$cS(g,A,F,r)}D(g){return new re(this)}updateOptions(g={}){this.B={...this.B,...g},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(g),this.v?.updateOptions(g),this.k.updateOptions(g)}get options(){return this.B}splice(g,A,F=[]){if(g<0||g>this.k.length)throw new a.$eS(this.A,`Invalid start index: ${g}`);if(A<0)throw new a.$eS(this.A,`Invalid delete count: ${A}`);A===0&&F.length===0||this.g.bufferEvents(()=>this.o.splice(g,A,F))}updateWidth(g){this.k.updateWidth(g)}updateElementHeight(g,A){this.k.updateElementHeight(g,A,null)}rerender(){this.k.rerender()}element(g){return this.k.element(g)}indexOf(g){return this.k.indexOf(g)}indexAt(g){return this.k.indexAt(g)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(g){this.k.setScrollTop(g)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(g){this.k.setScrollLeft(g)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(g){this.x=g,this.k.domNode.setAttribute("aria-label",g)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(g,A){this.k.layout(g,A)}triggerTypeNavigation(){this.t?.trigger()}setSelection(g,A){for(const F of g)if(F<0||F>=this.length)throw new a.$eS(this.A,`Invalid index ${F}`);this.d.set(g,A)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(g=>this.k.element(g))}setAnchor(g){if(typeof g>"u"){this.f.set([]);return}if(g<0||g>=this.length)throw new a.$eS(this.A,`Invalid index ${g}`);this.f.set([g])}getAnchor(){return(0,m.$Ob)(this.f.get(),void 0)}getAnchorElement(){const g=this.getAnchor();return typeof g>"u"?void 0:this.element(g)}setFocus(g,A){for(const F of g)if(F<0||F>=this.length)throw new a.$eS(this.A,`Invalid index ${F}`);this.c.set(g,A)}focusNext(g=1,A=!1,F,r){if(this.length===0)return;const i=this.c.get(),o=this.E(i.length>0?i[0]+g:0,A,r);o>-1&&this.setFocus([o],F)}focusPrevious(g=1,A=!1,F,r){if(this.length===0)return;const i=this.c.get(),o=this.F(i.length>0?i[0]-g:0,A,r);o>-1&&this.setFocus([o],F)}async focusNextPage(g,A){let F=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);F=F===0?0:F-1;const r=this.getFocus()[0];if(r!==F&&(r===void 0||F>r)){const i=this.F(F,!1,A);i>-1&&r!==i?this.setFocus([i],g):this.setFocus([F],g)}else{const i=this.k.getScrollTop();let o=i+this.k.renderHeight;F>r&&(o-=this.k.elementHeight(F)),this.k.setScrollTop(o),this.k.getScrollTop()!==i&&(this.setFocus([]),await(0,p.$9g)(0),await this.focusNextPage(g,A))}}async focusPreviousPage(g,A,F=()=>0){let r;const i=F(),o=this.k.getScrollTop()+i;o===0?r=this.k.indexAt(o):r=this.k.indexAfter(o-1);const w=this.getFocus()[0];if(w!==r&&(w===void 0||w>=r)){const I=this.E(r,!1,A);I>-1&&w!==I?this.setFocus([I],g):this.setFocus([r],g)}else{const I=o;this.k.setScrollTop(o-this.k.renderHeight-i),this.k.getScrollTop()+F()!==I&&(this.setFocus([]),await(0,p.$9g)(0),await this.focusPreviousPage(g,A,F))}}focusLast(g,A){if(this.length===0)return;const F=this.F(this.length-1,!1,A);F>-1&&this.setFocus([F],g)}focusFirst(g,A){this.focusNth(0,g,A)}focusNth(g,A,F){if(this.length===0)return;const r=this.E(g,!1,F);r>-1&&this.setFocus([r],A)}E(g,A=!1,F){for(let r=0;r<this.length;r++){if(g>=this.length&&!A)return-1;if(g=g%this.length,!F||F(this.element(g)))return g;g++}return-1}F(g,A=!1,F){for(let r=0;r<this.length;r++){if(g<0&&!A)return-1;if(g=(this.length+g%this.length)%this.length,!F||F(this.element(g)))return g;g--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(g=>this.k.element(g))}reveal(g,A,F=0){if(g<0||g>=this.length)throw new a.$eS(this.A,`Invalid index ${g}`);const r=this.k.getScrollTop(),i=this.k.elementTop(g),o=this.k.elementHeight(g);if((0,c.$Nf)(A)){const w=o-this.k.renderHeight+F;this.k.setScrollTop(w*(0,s.$9l)(A,0,1)+i-F)}else{const w=i+o,I=r+this.k.renderHeight;i<r+F&&w>=I||(i<r+F||w>=I&&o>=this.k.renderHeight?this.k.setScrollTop(i-F):w>=I&&this.k.setScrollTop(w-this.k.renderHeight))}}getRelativeTop(g,A=0){if(g<0||g>=this.length)throw new a.$eS(this.A,`Invalid index ${g}`);const F=this.k.getScrollTop(),r=this.k.elementTop(g),i=this.k.elementHeight(g);if(r<F+A||r+i>F+this.k.renderHeight)return null;const o=i-this.k.renderHeight+A;return Math.abs((F+A-r)/o)}isDOMFocused(){return(0,E.$AQ)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(g){return this.k.getElementDomId(g)}getElementTop(g){return this.k.elementTop(g)}style(g){this.q.style(g)}G({indexes:g,browserEvent:A}){return{indexes:g,elements:g.map(F=>this.k.element(F)),browserEvent:A}}H(){const g=this.c.get();this.k.domNode.classList.toggle("element-focused",g.length>0),this.I()}I(){const g=this.c.get();if(g.length>0){let A;this.u?.getActiveDescendantId&&(A=this.u.getActiveDescendantId(this.k.element(g[0]))),this.k.domNode.setAttribute("aria-activedescendant",A||this.k.getElementDomId(g[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const g=this.d.get();this.k.domNode.classList.toggle("selection-none",g.length===0),this.k.domNode.classList.toggle("selection-single",g.length===1),this.k.domNode.classList.toggle("selection-multiple",g.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$uS=Se,Ye([M.$zh],Se.prototype,"onDidChangeFocus",null),Ye([M.$zh],Se.prototype,"onDidChangeSelection",null),Ye([M.$zh],Se.prototype,"onContextMenu",null),Ye([M.$zh],Se.prototype,"onKeyDown",null),Ye([M.$zh],Se.prototype,"onKeyUp",null),Ye([M.$zh],Se.prototype,"onKeyPress",null),Ye([M.$zh],Se.prototype,"onDidFocus",null),Ye([M.$zh],Se.prototype,"onDidBlur",null)}),define($e[62],pe([1,0,6,36,38,10,15]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rk=t.$qk=t.$pk=t.$ok=t.$nk=t.$mk=t.$lk=t.$kk=t.$jk=t.MarkdownStringTextNewlineStyle=void 0;var k;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(k||(t.MarkdownStringTextNewlineStyle=k={}));class m{constructor(a="",$=!1){if(this.value=a,typeof this.value!="string")throw(0,E.$7)("value");typeof $=="boolean"?(this.isTrusted=$,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=$.isTrusted??void 0,this.supportThemeIcons=$.supportThemeIcons??!1,this.supportHtml=$.supportHtml??!1)}appendText(a,$=0){return this.value+=l(this.supportThemeIcons?(0,C.$dk)(a):a).replace(/([ \t]+)/g,(d,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,$===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,$){return this.value+=`
${h($,a)}
`,this}appendLink(a,$,d){return this.value+="[",this.value+=this.c($,"]"),this.value+="](",this.value+=this.c(String(a),")"),d&&(this.value+=` "${this.c(this.c(d,'"'),")")}"`),this.value+=")",this}c(a,$){const d=new RegExp((0,H.$Pe)($),"g");return a.replace(d,(b,u)=>a.charAt(u-1)!=="\\"?`\\${b}`:b)}}t.$jk=m;function p(c){return v(c)?!c.value:Array.isArray(c)?c.every(p):!0}t.$kk=p;function v(c){return c instanceof m?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||typeof c.isTrusted=="object"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}t.$lk=v;function M(c,a){return c===a?!0:!c||!a?!1:c.value===a.value&&c.isTrusted===a.isTrusted&&c.supportThemeIcons===a.supportThemeIcons&&c.supportHtml===a.supportHtml&&(c.baseUri===a.baseUri||!!c.baseUri&&!!a.baseUri&&(0,n.$Bg)(D.URI.from(c.baseUri),D.URI.from(a.baseUri)))}t.$mk=M;function l(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.$nk=l;function h(c,a){const $=c.match(/^`+/gm)?.reduce((b,u)=>b.length>u.length?b:u).length??0,d=$>=3?$+1:3;return[`${"`".repeat(d)}${a}`,c,`${"`".repeat(d)}`].join(`
`)}t.$ok=h;function e(c){return c.replace(/"/g,"&quot;")}t.$pk=e;function s(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.$qk=s;function f(c){const a=[],$=c.split("|").map(b=>b.trim());c=$[0];const d=$[1];if(d){const b=/height=(\d+)/.exec(d),u=/width=(\d+)/.exec(d),N=b?b[1]:"",B=u?u[1]:"",R=isFinite(parseInt(B)),W=isFinite(parseInt(N));R&&a.push(`width="${B}"`),W&&a.push(`height="${N}"`)}return{href:c,dimensions:a}}t.$rk=f}),define($e[126],pe([1,0,2,118,22,55,14,19,119,6,4,62,36,77,23,3,79,53,31,51,38,10,15]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h,e,s,f,c,a,$,d,b,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BS=t.$AS=t.$zS=t.$yS=t.$xS=void 0;const N=Object.freeze({image:(K,ie,fe)=>{let De=[],Te=[];return K&&({href:K,dimensions:De}=(0,M.$rk)(K),Te.push(`src="${(0,M.$pk)(K)}"`)),fe&&Te.push(`alt="${(0,M.$pk)(fe)}"`),ie&&Te.push(`title="${(0,M.$pk)(ie)}"`),De.length&&(Te=Te.concat(De)),"<img "+Te.join(" ")+">"},paragraph:K=>`<p>${K}</p>`,link:(K,ie,fe)=>typeof K!="string"?"":(K===fe&&(fe=(0,M.$qk)(fe)),ie=typeof ie=="string"?(0,M.$pk)((0,M.$qk)(ie)):"",K=(0,M.$qk)(K),K=K.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${K}" title="${ie||K}" draggable="false">${fe}</a>`)});function B(K,ie={},fe={}){const De=new s.$Sc;let Te=!1;const Se=(0,H.$1R)(ie),_=function(T){let j;try{j=(0,c.$Dh)(decodeURIComponent(T))}catch{}return j?(j=(0,$.$An)(j,V=>{if(K.uris&&K.uris[V])return u.URI.revive(K.uris[V])}),encodeURIComponent(JSON.stringify(j))):T},g=function(T,j){const V=K.uris&&K.uris[T];let X=u.URI.revive(V);return j?T.startsWith(a.Schemas.data+":")?T:(X||(X=u.URI.parse(T)),a.$pg.uriToBrowserUri(X).toString(!0)):!X||u.URI.parse(T).toString()===X.toString()?T:(X.query&&(X=X.with({query:_(X.query)})),X.toString())},A=new f.marked.Renderer;A.image=N.image,A.link=N.link,A.paragraph=N.paragraph;const F=[],r=[];if(ie.codeBlockRendererSync?A.code=(T,j)=>{const V=h.$CN.nextId(),X=ie.codeBlockRendererSync(R(j),T);return r.push([V,X]),`<div class="code" data-code="${V}">${(0,b.$Oe)(T)}</div>`}:ie.codeBlockRenderer&&(A.code=(T,j)=>{const V=h.$CN.nextId(),X=ie.codeBlockRenderer(R(j),T);return F.push(X.then(oe=>[V,oe])),`<div class="code" data-code="${V}">${(0,b.$Oe)(T)}</div>`}),ie.actionHandler){const T=function(X){let oe=X.target;if(!(oe.tagName!=="A"&&(oe=oe.parentElement,!oe||oe.tagName!=="A")))try{let be=oe.dataset.href;be&&(K.baseUri&&(be=W(u.URI.from(K.baseUri),be)),ie.actionHandler.callback(be,X))}catch(be){(0,p.$1)(be)}finally{X.preventDefault()}},j=ie.actionHandler.disposables.add(new n.$2R(Se,"click")),V=ie.actionHandler.disposables.add(new n.$2R(Se,"auxclick"));ie.actionHandler.disposables.add(v.Event.any(j.event,V.event)(X=>{const oe=new k.$RP(E.getWindow(Se),X);!oe.leftButton&&!oe.middleButton||T(oe)})),ie.actionHandler.disposables.add(E.$ZP(Se,"keydown",X=>{const oe=new D.$WP(X);!oe.equals(10)&&!oe.equals(3)||T(oe)}))}K.supportHtml||(fe.sanitizer=T=>(K.isTrusted?T.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?T:"",fe.sanitize=!0,fe.silent=!0),fe.renderer=A;let i=K.value??"";i.length>1e5&&(i=`${i.substr(0,1e5)}\u2026`),K.supportThemeIcons&&(i=(0,l.$ek)(i));let o;if(ie.fillInIncompleteTokens){const T={...f.marked.defaults,...fe},j=f.marked.lexer(i,T),V=ge(j);o=f.marked.parser(V,T)}else o=f.marked.parse(i,fe);K.supportThemeIcons&&(o=(0,m.$vS)(o).map(j=>typeof j=="string"?j:j.outerHTML).join(""));const I=new DOMParser().parseFromString(z(K,o),"text/html");if(I.body.querySelectorAll("img").forEach(T=>{const j=T.getAttribute("src");if(j){let V=j;try{K.baseUri&&(V=W(u.URI.from(K.baseUri),V))}catch{}T.src=g(V,!0)}}),I.body.querySelectorAll("a").forEach(T=>{const j=T.getAttribute("href");if(T.setAttribute("href",""),!j||/^data:|javascript:/i.test(j)||/^command:/i.test(j)&&!K.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(j))T.replaceWith(...T.childNodes);else{let V=g(j,!1);K.baseUri&&(V=W(u.URI.from(K.baseUri),j)),T.dataset.href=V}}),Se.innerHTML=z(K,I.body.innerHTML),F.length>0)Promise.all(F).then(T=>{if(Te)return;const j=new Map(T),V=Se.querySelectorAll("div[data-code]");for(const X of V){const oe=j.get(X.dataset.code??"");oe&&E.$3Q(X,oe)}ie.asyncRenderCallback?.()});else if(r.length>0){const T=new Map(r),j=Se.querySelectorAll("div[data-code]");for(const V of j){const X=T.get(V.dataset.code??"");X&&E.$3Q(V,X)}}if(ie.asyncRenderCallback)for(const T of Se.getElementsByTagName("img")){const j=De.add(E.$ZP(T,"load",()=>{j.dispose(),ie.asyncRenderCallback()}))}return{element:Se,dispose:()=>{Te=!0,De.dispose()}}}t.$xS=B;function R(K){if(!K)return"";const ie=K.split(/[\s+|:|,|\{|\?]/,1);return ie.length?ie[0]:K}function W(K,ie){return/^\w[\w\d+.-]*:/.test(ie)?ie:K.path.endsWith("/")?(0,d.$Lg)(K,ie).toString():(0,d.$Lg)((0,d.$Hg)(K),ie).toString()}function z(K,ie){const{config:fe,allowedSchemes:De}=y(K);C.addHook("uponSanitizeAttribute",(Se,_)=>{if(_.attrName==="style"||_.attrName==="class"){if(Se.tagName==="SPAN"){if(_.attrName==="style"){_.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(_.attrValue);return}else if(_.attrName==="class"){_.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(_.attrValue);return}}_.keepAttr=!1;return}else if(Se.tagName==="INPUT"&&Se.attributes.getNamedItem("type")?.value==="checkbox"){if(_.attrName==="type"&&_.attrValue==="checkbox"||_.attrName==="disabled"||_.attrName==="checked"){_.keepAttr=!0;return}_.keepAttr=!1}}),C.addHook("uponSanitizeElement",(Se,_)=>{_.tagName==="input"&&(Se.attributes.getNamedItem("type")?.value==="checkbox"?Se.setAttribute("disabled",""):Se.parentElement?.removeChild(Se))});const Te=E.$kR(De);try{return C.sanitize(ie,{...fe,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),Te.dispose()}}t.$yS=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function y(K){const ie=[a.Schemas.http,a.Schemas.https,a.Schemas.mailto,a.Schemas.data,a.Schemas.file,a.Schemas.vscodeFileResource,a.Schemas.vscodeRemote,a.Schemas.vscodeRemoteResource];return K.isTrusted&&ie.push(a.Schemas.command),{config:{ALLOWED_TAGS:[...E.$lR],ALLOWED_ATTR:t.$yS,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:ie}}function O(K){return typeof K=="string"?K:U(K)}t.$zS=O;function U(K){let ie=K.value??"";ie.length>1e5&&(ie=`${ie.substr(0,1e5)}\u2026`);const fe=f.marked.parse(ie,{renderer:P.value}).replace(/&(#\d+|[a-zA-Z]+);/g,De=>S.get(De)??De);return z({isTrusted:!1},fe).toString()}t.$AS=U;const S=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),P=new e.$V(()=>{const K=new f.marked.Renderer;return K.code=ie=>ie,K.blockquote=ie=>ie,K.html=ie=>"",K.heading=(ie,fe,De)=>ie+`
`,K.hr=()=>"",K.list=(ie,fe)=>ie,K.listitem=ie=>ie+`
`,K.paragraph=ie=>ie+`
`,K.table=(ie,fe)=>ie+fe+`
`,K.tablerow=ie=>ie,K.tablecell=(ie,fe)=>ie+" ",K.strong=ie=>ie,K.em=ie=>ie,K.codespan=ie=>ie,K.br=()=>`
`,K.del=ie=>ie,K.image=(ie,fe,De)=>"",K.text=ie=>ie,K.link=(ie,fe,De)=>De,K});function L(K){let ie="";return K.forEach(fe=>{ie+=fe.raw}),ie}function G(K){for(let ie=0;ie<K.tokens.length;ie++){const fe=K.tokens[ie];if(fe.type==="text"){const De=fe.raw.split(`
`),Te=De[De.length-1];if(Te.includes("`"))return te(K);if(Te.includes("**"))return J(K);if(Te.match(/\*\w/))return me(K);if(Te.match(/(^|\s)__\w/))return ae(K);if(Te.match(/(^|\s)_\w/))return Re(K);if(Te.match(/(^|\s)\[.*\]\(\w*/)){const Se=K.tokens.slice(ie+1);return Se[0]?.type==="link"&&Se[1]?.type==="text"&&Se[1].raw.match(/^ *"[^"]*$/)?Be(K):Ne(K)}else{if(Z(Te))return Ne(K);if(Te.match(/(^|\s)\[\w/)&&!K.tokens.slice(ie+1).some(Se=>Z(Se.raw)))return re(K)}}}}function Z(K){return!!K.match(/^[^\[]*\]\([^\)]*$/)}function ge(K){let ie,fe;for(ie=0;ie<K.length;ie++){const De=K[ie];let Te;if(De.type==="paragraph"&&(Te=De.raw.match(/(\n|^)(````*)/))){const Se=Te[2];fe=ue(K.slice(ie),Se);break}if(De.type==="paragraph"&&De.raw.match(/(\n|^)\|/)){fe=Y(K.slice(ie));break}if(ie===K.length-1&&De.type==="paragraph"){const Se=G(De);if(Se){fe=[Se];break}}}if(fe){const De=[...K.slice(0,ie),...fe];return De.links=K.links,De}return K}t.$BS=ge;function ue(K,ie){const fe=L(K);return f.marked.lexer(fe+`
${ie}`)}function te(K){return se(K,"`")}function me(K){return se(K,"*")}function Re(K){return se(K,"_")}function Ne(K){return se(K,")")}function Be(K){return se(K,'")')}function re(K){return se(K,"](about:blank)")}function J(K){return se(K,"**")}function ae(K){return se(K,"__")}function se(K,ie){const fe=L(Array.isArray(K)?K:[K]);return f.marked.lexer(fe+ie)[0]}function Y(K){const ie=L(K),fe=ie.split(`
`);let De,Te=!1;for(let Se=0;Se<fe.length;Se++){const _=fe[Se].trim();if(typeof De>"u"&&_.match(/^\s*\|/)){const g=_.match(/(\|[^\|]+)(?=\||$)/g);g&&(De=g.length)}else if(typeof De=="number")if(_.match(/^\s*\|/)){if(Se!==fe.length-1)return;Te=!0}else return}if(typeof De=="number"&&De>0){const Se=Te?fe.slice(0,-1).join(`
`):ie,_=!!Se.match(/\|\s*$/),g=Se+(_?"":"|")+`
|${" --- |".repeat(De)}`;return f.marked.lexer(g)}}}),define($e[127],pe([1,0,2,9,29,62,36,3,7,108]),function(ne,t,E,C,n,H,D,k,m,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$SR=t.$RR=void 0;function v(h,e){(0,m.$Jf)(e)?h.title=(0,D.$fk)(e):e?.markdownNotSupportedFallback?h.title=e.markdownNotSupportedFallback:h.removeAttribute("title")}t.$RR=v;class M{constructor(e,s,f){this.c=e,this.d=s,this.f=f}async update(e,s,f){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let c;if(e===void 0||(0,m.$Jf)(e)||e instanceof HTMLElement)c=e;else if(!(0,m.$Xf)(e.markdown))c=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,p.localize)(0,null),s),this.b=new n.$7d;const a=this.b.token;if(c=await e.markdown(a),c===void 0&&(c=e.markdownNotSupportedFallback),this.isDisposed||a.isCancellationRequested)return}this.g(c,s,f)}g(e,s,f){const c=this.a;if(this.h(e)){const a={content:e,target:this.d,appearance:{showPointer:this.c.placement==="element",skipFadeInAnimation:!this.f||!!c},position:{hoverPosition:2},...f};this.a=this.c.showHover(a,s)}c?.dispose()}h(e){return e?(0,H.$lk)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function l(h,e,s,f){let c,a;const $=(U,S)=>{const P=a!==void 0;U&&(a?.dispose(),a=void 0),S&&(c?.dispose(),c=void 0),P&&h.onDidHideHover?.()},d=(U,S,P)=>new C.$fh(async()=>{(!a||a.isDisposed)&&(a=new M(h,P||e,U>0),await a.update(s,S,f))},U);let b=!1;const u=E.$ZP(e,E.$TQ.MOUSE_DOWN,()=>{b=!0,$(!0,!0)},!0),N=E.$ZP(e,E.$TQ.MOUSE_UP,()=>{b=!1},!0),B=E.$ZP(e,E.$TQ.MOUSE_LEAVE,U=>{b=!1,$(!1,U.fromElement===e)},!0),R=()=>{if(c)return;const U=new k.$Sc,S={targetElements:[e],dispose:()=>{}};if(h.placement===void 0||h.placement==="mouse"){const P=L=>{S.x=L.x+10,L.target instanceof HTMLElement&&L.target.classList.contains("action-label")&&$(!0,!0)};U.add(E.$ZP(e,E.$TQ.MOUSE_MOVE,P,!0))}U.add(d(h.delay,!1,S)),c=U},W=E.$ZP(e,E.$TQ.MOUSE_OVER,R,!0),z=()=>{if(b||c)return;const U={targetElements:[e],dispose:()=>{}},S=new k.$Sc,P=()=>$(!0,!0);S.add(E.$ZP(e,E.$TQ.BLUR,P,!0)),S.add(d(h.delay,!1,U)),c=S},y=E.$ZP(e,E.$TQ.FOCUS,z,!0);return{show:U=>{$(!1,!0),d(0,U)},hide:()=>{$(!0,!0)},update:async(U,S)=>{s=U,await a?.update(s,void 0,S)},dispose:()=>{W.dispose(),B.dispose(),u.dispose(),N.dispose(),y.dispose(),$(!0,!0)}}}t.$SR=l}),define($e[128],pe([1,0,2,22,14,126,40,12,4,45,3,5,110,101]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$CS=void 0;const h=E.$,e="selectOption.entry.template";class s{get templateId(){return e}renderTemplate(a){const $=Object.create(null);return $.root=a,$.text=E.$1Q(a,h(".option-text")),$.detail=E.$1Q(a,h(".option-detail")),$.decoratorRight=E.$1Q(a,h(".option-decorator-right")),$}renderElement(a,$,d){const b=d,u=a.text,N=a.detail,B=a.decoratorRight,R=a.isDisabled;b.text.textContent=u,b.detail.textContent=N||"",b.decoratorRight.innerText=B||"",R?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(a){}}class f extends v.$Tc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(a,$,d,b,u){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.M=!1,this.f=!1,this.s=b,this.g=u||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=f.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new m.$Wd,this.B(this.r),this.O(),this.N(d),this.n=$||0,a&&this.setOptions(a,$),this.Q()}getHeight(){return 22}getTemplateId(){return e}N(a){this.u=a,this.w=E.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=E.$1Q(this.w,h(".select-box-details-pane"));const $=E.$1Q(this.w,h(".select-box-dropdown-container-width-control")),d=E.$1Q($,h(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",E.$1Q(d,this.D),this.G=0,this.y=E.$IQ(this.w),this.w.setAttribute("draggable","true"),this.B(E.$ZP(this.w,E.$TQ.DRAG_START,b=>{E.$VQ.stop(b,!0)}))}O(){this.B(E.$1P(this.h,"change",$=>{this.n=$.target.selectedIndex,this.r.fire({index:$.target.selectedIndex,selected:$.target.value}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)})),this.B(E.$ZP(this.h,E.$TQ.CLICK,$=>{E.$VQ.stop($),this.f?this.X(!0):this.W()})),this.B(E.$ZP(this.h,E.$TQ.MOUSE_DOWN,$=>{E.$VQ.stop($)}));let a;this.B(E.$ZP(this.h,"touchstart",$=>{a=this.f})),this.B(E.$ZP(this.h,"touchend",$=>{E.$VQ.stop($),a?this.X(!0):this.W()})),this.B(E.$ZP(this.h,E.$TQ.KEY_DOWN,$=>{const d=new n.$WP($);let b=!1;M.$j?(d.keyCode===18||d.keyCode===16||d.keyCode===10||d.keyCode===3)&&(b=!0):(d.keyCode===18&&d.altKey||d.keyCode===16&&d.altKey||d.keyCode===10||d.keyCode===3)&&(b=!0),b&&(this.W(),E.$VQ.stop($,!0))}))}get onDidSelect(){return this.r.event}setOptions(a,$){k.$ub(this.m,a)||(this.m=a,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((d,b)=>{this.h.add(this.U(d.text,b,d.isDisabled)),typeof d.description=="string"&&(this.H=!0)})),$!==void 0&&(this.select($),this.F=this.n)}P(){this.z?.splice(0,this.z.length,this.m)}select(a){a>=0&&a<this.m.length?this.n=a:a>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)}setAriaLabel(a){this.g.ariaLabel=a,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(a){this.h.tabIndex=a?0:-1}render(a){this.j=a,a.classList.add("select-container"),a.appendChild(this.h),this.R()}Q(){const a=[];this.s.listFocusBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(a.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),a.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&a.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),a.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=a.join(`
`)}R(){const a=this.s.selectBackground??"",$=this.s.selectForeground??"",d=this.s.selectBorder??"";this.h.style.backgroundColor=a,this.h.style.color=$,this.h.style.borderColor=d}S(){const a=this.s.selectBackground??"",$=E.$gR(this.s.selectListBackground,a);this.C.style.backgroundColor=$,this.I.style.backgroundColor=$;const d=this.s.focusBorder??"";this.w.style.outlineColor=d,this.w.style.outlineOffset="-1px",this.z.style(this.s)}U(a,$,d){const b=document.createElement("option");return b.value=a,b.text=a,b.disabled=!!d,b}W(){this.I.innerText="",!(!this.u||this.f)&&(this.cb(this.w),this.P(),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.Y(a,!0),layout:()=>{this.ab()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.X(!1),this.u.showContextView({getAnchor:()=>this.h,render:a=>this.Y(a),layout:()=>this.ab(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}X(a){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),a&&this.h.focus(),this.u.hideContextView())}Y(a,$){return a.appendChild(this.w),this.ab($),{dispose:()=>{try{a.removeChild(this.w)}catch{}}}}Z(){let a=0;return this.m.forEach(($,d)=>{this.hb(d),this.I.offsetHeight>a&&(a=this.I.offsetHeight)}),a}ab(a){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const $=E.getWindow(this.h),d=E.$jQ(this.h),b=E.getWindow(this.h).getComputedStyle(this.h),u=parseFloat(b.getPropertyValue("--dropdown-padding-top"))+parseFloat(b.getPropertyValue("--dropdown-padding-bottom")),N=$.innerHeight-d.top-d.height-(this.g.minBottomMargin||0),B=d.top-f.b,R=this.h.offsetWidth,W=this.bb(this.D),z=Math.max(W,Math.round(R)).toString()+"px";this.w.style.width=z,this.z.getHTMLElement().style.height="",this.z.layout();let y=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.Z());const O=this.H?this.L:0,U=y+u+O,S=Math.floor((N-u-O)/this.getHeight()),P=Math.floor((B-u-O)/this.getHeight());if(a)return d.top+d.height>$.innerHeight-22||d.top<f.b||S<1&&P<1?!1:(S<f.c&&P>S&&this.m.length>S?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(d.top+d.height>$.innerHeight-22||d.top<f.b||this.G===0&&S<1||this.G===1&&P<1)return this.X(!0),!1;if(this.G===0){if(this.f&&S+P<1)return this.X(!0),!1;U>N&&(y=S*this.getHeight())}else U>B&&(y=P*this.getHeight());return this.z.layout(y),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=y+u+"px",this.w.style.height=""):this.w.style.height=y+u+"px",this.hb(this.n),this.w.style.width=z,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}bb(a){let $=0;if(a){let d=0,b=0;this.m.forEach((u,N)=>{const B=u.detail?u.detail.length:0,R=u.decoratorRight?u.decoratorRight.length:0,W=u.text.length+B+R;W>b&&(d=N,b=W)}),a.textContent=this.m[d].text+(this.m[d].decoratorRight?this.m[d].decoratorRight+" ":""),$=E.$lQ(a)}return $}cb(a){if(this.z)return;this.C=E.$1Q(a,h(".select-box-dropdown-list-container")),this.t=new s,this.z=new D.$uS("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let u=b.text;return b.detail&&(u+=`. ${b.detail}`),b.decoratorRight&&(u+=`. ${b.decoratorRight}`),b.description&&(u+=`. ${b.description}`),u},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>M.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const $=this.B(new C.$2R(this.C,"keydown")),d=m.Event.chain($.event,b=>b.filter(()=>this.z.length>0).map(u=>new n.$WP(u)));this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===3))(this.jb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===2))(this.jb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===9))(this.ib,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===16))(this.lb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===18))(this.kb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===12))(this.nb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===11))(this.mb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===14))(this.ob,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode===13))(this.pb,this)),this.B(m.Event.chain(d,b=>b.filter(u=>u.keyCode>=21&&u.keyCode<=56||u.keyCode>=85&&u.keyCode<=113))(this.qb,this)),this.B(E.$ZP(this.z.getHTMLElement(),E.$TQ.POINTER_UP,b=>this.db(b))),this.B(this.z.onMouseOver(b=>typeof b.index<"u"&&this.z.setFocus([b.index]))),this.B(this.z.onDidChangeFocus(b=>this.gb(b))),this.B(E.$ZP(this.w,E.$TQ.FOCUS_OUT,b=>{!this.f||E.$rQ(b.relatedTarget,this.w)||this.eb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.S()}db(a){if(!this.z.length)return;E.$VQ.stop(a);const $=a.target;if(!$||$.classList.contains("slider"))return;const d=$.closest(".monaco-list-row");if(!d)return;const b=Number(d.getAttribute("data-index")),u=d.classList.contains("option-disabled");b>=0&&b<this.m.length&&!u&&(this.n=b,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0))}eb(){this.M||(this.n!==this.F&&this.select(this.F),this.X(!1))}fb(a,$){const d=u=>{for(let N=0;N<u.childNodes.length;N++){const B=u.childNodes.item(N);(B.tagName&&B.tagName.toLowerCase())==="img"?u.removeChild(B):d(B)}},b=(0,H.$xS)({value:a,supportThemeIcons:!0},{actionHandler:$});return b.element.classList.add("select-box-description-markdown"),d(b.element),b.element}gb(a){!this.f||!this.H||this.hb(a.indexes[0])}hb(a){this.I.innerText="";const $=this.m[a],d=$?.description??"",b=$?.descriptionIsMarkdown??!1;if(d){if(b){const u=$.descriptionMarkdownActionHandler;this.I.appendChild(this.fb(d,u))}else this.I.innerText=d;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}ib(a){E.$VQ.stop(a),this.select(this.F),this.X(!0)}jb(a){E.$VQ.stop(a),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&(this.h.title=this.m[this.n].text)),this.X(!0)}kb(a){if(this.n<this.m.length-1){E.$VQ.stop(a,!0);const $=this.m[this.n+1].isDisabled;if($&&this.m.length>this.n+2)this.n+=2;else{if($)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}lb(a){this.n>0&&(E.$VQ.stop(a,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}mb(a){E.$VQ.stop(a),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}nb(a){E.$VQ.stop(a),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}ob(a){E.$VQ.stop(a),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}pb(a){E.$VQ.stop(a),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}qb(a){const $=p.KeyCodeUtils.toString(a.keyCode);let d=-1;for(let b=0;b<this.m.length-1;b++)if(d=(b+this.n+1)%this.m.length,this.m[d].text.charAt(0).toUpperCase()===$&&!this.m[d].isDisabled){this.select(d),this.z.setFocus([d]),this.z.reveal(this.z.getFocus()[0]),E.$VQ.stop(a);break}}dispose(){this.X(!1),super.dispose()}}t.$CS=f}),define($e[129],pe([1,0,40,128,122,20,5,100]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FS=t.$ES=void 0,t.$ES={...E.$tS,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class k extends H.$BR{constructor(p,v,M,l,h){super(),D.$j&&!h?.useCustomDrawn?this.a=new n.$DS(p,v,l,h):this.a=new C.$CS(p,v,M,l,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(p,v){this.a.setOptions(p,v)}select(p){this.a.select(p)}setAriaLabel(p){this.a.setAriaLabel(p)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(p){this.a.setFocusable(p)}render(p){this.a.render(p)}}t.$FS=k}),define($e[63],pe([1,0,16,54,2,25,127,129,37,3,5,7,105,52]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NS=t.$MS=t.$LS=void 0;class h extends p.$Tc{get action(){return this._action}constructor(c,a,$={}){super(),this.m=$,this._context=c||this,this._action=a,a instanceof m.$Mi&&this.B(a.onDidChange(d=>{this.element&&this.t(d)}))}t(c){c.enabled!==void 0&&this.u(),c.checked!==void 0&&this.H(),c.class!==void 0&&this.G(),c.label!==void 0&&(this.w(),this.D()),c.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new m.$Ni)),this.j}set actionRunner(c){this.j=c}isEnabled(){return this._action.enabled}setActionContext(c){this._context=c}render(c){const a=this.element=c;this.B(H.$xR.addTarget(c));const $=this.m&&this.m.draggable;$&&(c.draggable=!0,E.$FP&&this.B((0,n.$ZP)(c,n.$TQ.DRAG_START,d=>d.dataTransfer?.setData(C.$vR.TEXT,this._action.label)))),this.B((0,n.$ZP)(a,H.EventType.Tap,d=>this.onClick(d,!0))),this.B((0,n.$ZP)(a,n.$TQ.MOUSE_DOWN,d=>{$||n.$VQ.stop(d,!0),this._action.enabled&&d.button===0&&a.classList.add("active")})),v.$j&&this.B((0,n.$ZP)(a,n.$TQ.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this.B((0,n.$ZP)(a,n.$TQ.CLICK,d=>{n.$VQ.stop(d,!0),this.m&&this.m.isMenu||this.onClick(d)})),this.B((0,n.$ZP)(a,n.$TQ.DBLCLICK,d=>{n.$VQ.stop(d,!0)})),[n.$TQ.MOUSE_UP,n.$TQ.MOUSE_OUT].forEach(d=>{this.B((0,n.$ZP)(a,d,b=>{n.$VQ.stop(b),a.classList.remove("active")}))})}onClick(c,a=!1){n.$VQ.stop(c,!0);const $=M.$Sf(this._context)?this.m?.useEventAsContext?c:{preserveFocus:a}:this._context;this.actionRunner.run(this._action,$)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(c){this.element&&(this.element.tabIndex=c?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const c=this.C()??"";this.F(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(c):(this.f=(0,D.$SR)(this.m.hoverDelegate,this.element,c),this.q.add(this.f))):this.element.title=c}F(){if(this.element){const c=this.C()??"";this.element.setAttribute("aria-label",c)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$LS=h;class e extends h{constructor(c,a,$){super(c,a,$),this.m=$,this.m.icon=$.icon!==void 0?$.icon:!1,this.m.label=$.label!==void 0?$.label:!0,this.L=""}render(c){super.render(c),M.$Tf(this.element);const a=document.createElement("a");if(a.classList.add("action-label"),a.setAttribute("role",this.M()),this.I=a,this.element.appendChild(a),this.m.label&&this.m.keybinding){const $=document.createElement("span");$.classList.add("keybinding"),$.textContent=this.m.keybinding,this.element.appendChild($)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===m.$Oi.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(c){this.I&&(this.I.tabIndex=c?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let c=null;return this.action.tooltip?c=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(c=this.action.label,this.m.keybinding&&(c=l.localize(0,null,c,this.m.keybinding))),c??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const c=this.C()??"";this.I.setAttribute("aria-label",c)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$MS=e;class s extends h{constructor(c,a,$,d,b,u,N){super(c,a),this.b=new k.$FS($,d,b,u,N),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(c,a){this.b.setOptions(c,a)}select(c){this.b.select(c)}g(){this.B(this.b.onDidSelect(c=>this.n(c.selected,c.index)))}n(c,a){this.actionRunner.run(this._action,this.r(c,a))}r(c,a){return c}setFocusable(c){this.b.setFocusable(c)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(c){this.b.render(c)}}t.$NS=s}),define($e[64],pe([1,0,2,14,63,37,4,3,7,52]),function(ne,t,E,C,n,H,D,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UR=t.$TR=t.ActionsOrientation=void 0;var p;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(p||(t.ActionsOrientation=p={}));class v extends k.$Tc{constructor(h,e={}){super(),this.g=this.B(new k.$Sc),this.r=this.B(new k.$3c),this.w=!1,this.y=!0,this.C=this.B(new D.$Wd),this.onDidBlur=this.C.event,this.D=this.B(new D.$Wd({onWillAddFirstListener:()=>this.F=!0})),this.onDidCancel=this.D.event,this.F=!1,this.G=this.B(new D.$Wd),this.onDidRun=this.G.event,this.H=this.B(new D.$Wd),this.onWillRun=this.H.event,this.b=e,this.j=e.context??null,this.m=this.b.orientation??0,this.n={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new H.$Ni,this.g.add(this.f)),this.g.add(this.f.onDidRun(c=>this.G.fire(c))),this.g.add(this.f.onWillRun(c=>this.H.fire(c))),this.viewItems=[],this.t=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let s,f;switch(this.m){case 0:s=[15],f=[17];break;case 1:s=[16],f=[18],this.domNode.className+=" vertical";break}this.B(E.$ZP(this.domNode,E.$TQ.KEY_DOWN,c=>{const a=new C.$WP(c);let $=!0;const d=typeof this.t=="number"?this.viewItems[this.t]:void 0;s&&(a.equals(s[0])||a.equals(s[1]))?$=this.P():f&&(a.equals(f[0])||a.equals(f[1]))?$=this.O():a.equals(9)&&this.F?this.D.fire():a.equals(14)?$=this.M():a.equals(13)?$=this.N():a.equals(2)&&d instanceof n.$LS&&d.trapsArrowNavigation?$=this.O():this.J(a)?this.n.keyDown?this.R(a):this.w=!0:$=!1,$&&(a.preventDefault(),a.stopPropagation())})),this.B(E.$ZP(this.domNode,E.$TQ.KEY_UP,c=>{const a=new C.$WP(c);this.J(a)?(!this.n.keyDown&&this.w&&(this.w=!1,this.R(a)),a.preventDefault(),a.stopPropagation()):(a.equals(2)||a.equals(1026)||a.equals(16)||a.equals(18)||a.equals(15)||a.equals(17))&&this.L()})),this.u=this.B(E.$YQ(this.domNode)),this.B(this.u.onDidBlur(()=>{(E.$zQ()===this.domNode||!E.$rQ(E.$zQ(),this.domNode))&&(this.C.fire(),this.s=this.t,this.t=void 0,this.w=!1)})),this.B(this.u.onDidFocus(()=>this.L())),this.z=document.createElement("ul"),this.z.className="actions-container",this.b.highlightToggledItems&&this.z.classList.add("highlight-toggled"),this.z.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.z.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.z),h.appendChild(this.domNode)}I(){this.length()>=1?this.z.setAttribute("role",this.b.ariaRole||"toolbar"):this.z.setAttribute("role","presentation")}setAriaLabel(h){h?this.z.setAttribute("aria-label",h):this.z.removeAttribute("aria-label")}setFocusable(h){if(this.y=h,this.y){const e=this.viewItems.find(s=>s instanceof n.$LS&&s.isEnabled());e instanceof n.$LS&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof n.$LS&&e.setFocusable(!1)})}J(h){let e=!1;return this.n.keys.forEach(s=>{e=e||h.equals(s)}),e}L(){for(let h=0;h<this.z.children.length;h++){const e=this.z.children[h];if(E.$rQ(E.$zQ(),e)){this.t=h,this.viewItems[this.t]?.showHover?.();break}}}get context(){return this.j}set context(h){this.j=h,this.viewItems.forEach(e=>e.setActionContext(h))}get actionRunner(){return this.f}set actionRunner(h){this.f=h,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.G.fire(e))),this.g.add(this.f.onWillRun(e=>this.H.fire(e))),this.viewItems.forEach(e=>e.actionRunner=h)}getContainer(){return this.domNode}hasAction(h){return this.viewItems.findIndex(e=>e.action.id===h.id)!==-1}getAction(h){if(typeof h=="number")return this.viewItems[h]?.action;if(h instanceof HTMLElement){for(;h.parentElement!==this.z;){if(!h.parentElement)return;h=h.parentElement}for(let e=0;e<this.z.childNodes.length;e++)if(this.z.childNodes[e]===h)return this.viewItems[e].action}}push(h,e={}){const s=Array.isArray(h)?h:[h];let f=m.$Nf(e.index)?e.index:null;s.forEach(c=>{const a=document.createElement("li");a.className="action-item",a.setAttribute("role","presentation");let $;const d={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&($=this.b.actionViewItemProvider(c,d)),$||($=new n.$MS(this.context,c,d)),this.b.allowContextMenu||this.r.set($,E.$ZP(a,E.$TQ.CONTEXT_MENU,b=>{E.$VQ.stop(b,!0)})),$.actionRunner=this.f,$.setActionContext(this.context),$.render(a),this.y&&$ instanceof n.$LS&&this.viewItems.length===0&&$.setFocusable(!0),f===null||f<0||f>=this.z.children.length?(this.z.appendChild(a),this.viewItems.push($)):(this.z.insertBefore(a,this.z.children[f]),this.viewItems.splice(f,0,$),f++)}),typeof this.t=="number"&&this.focus(this.t),this.I()}getWidth(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientWidth}return 0}getHeight(h){if(h>=0&&h<this.z.children.length){const e=this.z.children.item(h);if(e)return e.clientHeight}return 0}pull(h){h>=0&&h<this.viewItems.length&&(this.z.removeChild(this.z.childNodes[h]),this.r.deleteAndDispose(this.viewItems[h]),(0,k.$Oc)(this.viewItems.splice(h,1)),this.I())}clear(){this.isEmpty()||(this.viewItems=(0,k.$Oc)(this.viewItems),this.r.clearAndDisposeAll(),E.$YP(this.z),this.I())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(h){let e=!1,s;if(h===void 0?e=!0:typeof h=="number"?s=h:typeof h=="boolean"&&(e=h),e&&typeof this.t>"u"){const f=this.viewItems.findIndex(c=>c.isEnabled());this.t=f===-1?void 0:f,this.Q(void 0,void 0,!0)}else s!==void 0&&(this.t=s),this.Q(void 0,void 0,!0)}M(){return this.t=this.length()-1,this.O(!0)}N(){return this.t=0,this.P(!0)}O(h){if(typeof this.t>"u")this.t=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(!h&&this.b.preventLoopNavigation&&this.t+1>=this.viewItems.length)return this.t=e,!1;this.t=(this.t+1)%this.viewItems.length,s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.$Oi.ID));return this.Q(),!0}P(h){if(typeof this.t>"u")this.t=0;else if(this.viewItems.length<=1)return!1;const e=this.t;let s;do{if(this.t=this.t-1,this.t<0){if(!h&&this.b.preventLoopNavigation)return this.t=e,!1;this.t=this.viewItems.length-1}s=this.viewItems[this.t]}while(this.t!==e&&(this.b.focusOnlyEnabledItems&&!s.isEnabled()||s.action.id===H.$Oi.ID));return this.Q(!0),!0}Q(h,e,s=!1){typeof this.t>"u"&&this.z.focus({preventScroll:e}),this.s!==void 0&&this.s!==this.t&&this.viewItems[this.s]?.blur();const f=this.t!==void 0?this.viewItems[this.t]:void 0;if(f){let c=!0;m.$Xf(f.focus)||(c=!1),this.b.focusOnlyEnabledItems&&m.$Xf(f.isEnabled)&&!f.isEnabled()&&(c=!1),f.action.id===H.$Oi.ID&&(c=!1),c?(s||this.s!==this.t)&&(f.focus(h),this.s=this.t):(this.z.focus({preventScroll:e}),this.s=void 0),c&&f.showHover?.()}}R(h){if(typeof this.t>"u")return;const e=this.viewItems[this.t];if(e instanceof n.$LS){const s=e._context===null||e._context===void 0?h:e._context;this.run(e._action,s)}}async run(h,e){await this.f.run(h,e)}dispose(){this.j=void 0,this.viewItems=(0,k.$Oc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$TR=v;function M(l){if(!l.length)return l;let h=-1;for(let s=0;s<l.length;s++)if(l[s].id!==H.$Oi.ID){h=s;break}if(h===-1)return[];l=l.slice(h);for(let s=l.length-1;s>=0&&l[s].id===H.$Oi.ID;s--)l.splice(s,1);let e=!1;for(let s=l.length-1;s>=0;s--){const f=l[s].id===H.$Oi.ID;f&&!e?l.splice(s,1):f?f&&(e=!1):e=!0}return l}t.$UR=M}),define($e[65],pe([1,0,2,22,55,64,57,60,20,4,82,51,109,97]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tT=t.$sT=t.$rT=t.MessageType=void 0;const h=E.$;var e;(function(c){c[c.INFO=1]="INFO",c[c.WARNING=2]="WARNING",c[c.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.$rT={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class s extends m.$BR{constructor(a,$,d){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.O=this.B(new p.$Wd),this.onDidChange=this.O.event,this.P=this.B(new p.$Wd),this.onDidHeightChange=this.P.event,this.a=$,this.g=d,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=E.$1Q(a,h(".monaco-inputbox.idle"));const b=this.g.flexibleHeight?"textarea":"input",u=E.$1Q(this.element,h(".ibwrapper"));if(this.b=E.$1Q(u,h(b+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=E.$1Q(u,h("div.mirror")),this.y.innerText="\xA0",this.N=new k.$LR(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),E.$1Q(a,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(R=>this.b.scrollTop=R.scrollTop));const N=this.B(new C.$2R(a.ownerDocument,"selectionchange")),B=p.Event.filter(N.event,()=>a.ownerDocument.getSelection()?.anchorNode===u);this.B(B(this.S,this)),this.B(this.onDidHeightChange(this.S,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Y()),this.F(this.b,()=>this.Q()),this.G(this.b,()=>this.R()),this.B(this.I(this.b)),setTimeout(()=>this.Z(),0),this.g.actions&&(this.c=this.B(new H.$TR(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.ab()}Q(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}R(){this.W(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(a){this.n=a,this.b.setAttribute("placeholder",a)}setTooltip(a){this.r=a,this.b.title=a}setAriaLabel(a){this.s=a,a?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(a){this.b.value!==a&&(this.b.value=a,this.Y())}get step(){return this.b.step}set step(a){this.b.step=a}get height(){return typeof this.J=="number"?this.J:E.$pQ(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return E.$AQ(this.b)}select(a=null){this.b.select(),a&&(this.b.setSelectionRange(a.start,a.end),a.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.X()}setEnabled(a){a?this.enable():this.disable()}get width(){return E.$lQ(this.b)}set width(a){if(this.g.flexibleHeight&&this.g.flexibleWidth){let $=0;if(this.y){const d=parseFloat(this.y.style.paddingLeft||"")||0,b=parseFloat(this.y.style.paddingRight||"")||0;$=d+b}this.b.style.width=a-$+"px"}else this.b.style.width=a+"px";this.y&&(this.y.style.width=a+"px")}set paddingRight(a){this.b.style.width=`calc(100% - ${a}px)`,this.y&&(this.y.style.paddingRight=a+"px")}S(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const a=this.L,$=this.J,d=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:a,height:$}),this.N.setScrollPosition({scrollTop:d})}showMessage(a,$){if(this.w==="open"&&(0,M.$Cn)(this.h,a))return;this.h=a,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.U(a.type));const d=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${E.$gR(d.border,"transparent")}`,this.h.content&&(this.hasFocus()||$)&&this.W()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.X(),this.ab()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let a=null;return this.t&&(a=this.t(this.value),a?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(a)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),a?.type}stylesForType(a){const $=this.g.inputBoxStyles;switch(a){case 1:return{border:$.inputValidationInfoBorder,background:$.inputValidationInfoBackground,foreground:$.inputValidationInfoForeground};case 2:return{border:$.inputValidationWarningBorder,background:$.inputValidationWarningBackground,foreground:$.inputValidationWarningForeground};default:return{border:$.inputValidationErrorBorder,background:$.inputValidationErrorBackground,foreground:$.inputValidationErrorForeground}}}U(a){switch(a){case 1:return"info";case 2:return"warning";default:return"error"}}W(){if(!this.a||!this.h)return;let a;const $=()=>a.style.width=E.$lQ(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:b=>{if(!this.h)return null;a=E.$1Q(b,h(".monaco-inputbox-container")),$();const u={inline:!0,className:"monaco-inputbox-message"},N=this.h.formatContent?(0,n.$ZR)(this.h.content,u):(0,n.$YR)(this.h.content,u);N.classList.add(this.U(this.h.type));const B=this.stylesForType(this.h.type);return N.style.backgroundColor=B.background??"",N.style.color=B.foreground??"",N.style.border=B.border?`1px solid ${B.border}`:"",E.$1Q(a,N),null},onHide:()=>{this.w="closed"},layout:$});let d;this.h.type===3?d=l.localize(0,null,this.h.content):this.h.type===2?d=l.localize(1,null,this.h.content):d=l.localize(2,null,this.h.content),D.$4R(d),this.w="open"}X(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Y(){this.O.fire(this.value),this.validate(),this.Z(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}Z(){if(!this.y)return;const a=this.value,d=a.charCodeAt(a.length-1)===10?" ":"";(a+d).replace(/\u000c/g,"")?this.y.textContent=a+d:this.y.innerText="\xA0",this.layout()}ab(){const a=this.g.inputBoxStyles,$=a.inputBackground??"",d=a.inputForeground??"",b=a.inputBorder??"";this.element.style.backgroundColor=$,this.element.style.color=d,this.b.style.backgroundColor="inherit",this.b.style.color=d,this.element.style.border=`1px solid ${E.$gR(b,"transparent")}`}layout(){if(!this.y)return;const a=this.L;this.L=E.$pQ(this.y),a!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.P.fire(this.L))}insertAtCursor(a){const $=this.inputElement,d=$.selectionStart,b=$.selectionEnd,u=$.value;d!==null&&b!==null&&(this.value=u.substr(0,d)+a+u.substr(b),$.setSelectionRange(d+1,d+1),this.layout())}dispose(){this.X(),this.h=null,this.c?.dispose(),super.dispose()}}t.$sT=s;class f extends s{constructor(a,$,d){const b=l.localize(3,null,"\u21C5"),u=l.localize(4,null,"\u21C5");super(a,$,d),this.db=this.B(new p.$Wd),this.onDidFocus=this.db.event,this.eb=this.B(new p.$Wd),this.onDidBlur=this.eb.event,this.bb=new v.$pT(d.history,100);const N=()=>{if(d.showHistoryHint&&d.showHistoryHint()&&!this.n.endsWith(b)&&!this.n.endsWith(u)&&this.bb.getHistory().length){const B=this.n.endsWith(")")?b:u,R=this.n+B;d.showPlaceholderOnFocus&&!E.$AQ(this.b)?this.n=R:this.setPlaceHolder(R)}};this.cb=new MutationObserver((B,R)=>{B.forEach(W=>{W.target.textContent||N()})}),this.cb.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>N()),this.F(this.b,()=>{const B=R=>{if(this.n.endsWith(R)){const W=this.n.slice(0,this.n.length-R.length);return d.showPlaceholderOnFocus?this.n=W:this.setPlaceHolder(W),!0}else return!1};B(u)||B(b)})}dispose(){super.dispose(),this.cb&&(this.cb.disconnect(),this.cb=void 0)}addToHistory(a){this.value&&(a||this.value!==this.hb())&&this.bb.add(this.value)}prependHistory(a){const $=this.getHistory();this.clearHistory(),a.forEach(d=>{this.bb.add(d)}),$.forEach(d=>{this.bb.add(d)})}getHistory(){return this.bb.getHistory()}isAtFirstInHistory(){return this.bb.isFirst()}isAtLastInHistory(){return this.bb.isLast()}isNowhereInHistory(){return this.bb.isNowhere()}showNextValue(){this.bb.has(this.value)||this.addToHistory();let a=this.jb();a&&(a=a===this.value?this.jb():a),this.value=a??"",D.$5R(this.value?this.value:l.localize(5,null))}showPreviousValue(){this.bb.has(this.value)||this.addToHistory();let a=this.ib();a&&(a=a===this.value?this.ib():a),a&&(this.value=a,D.$5R(this.value))}clearHistory(){this.bb.clear()}setPlaceHolder(a){super.setPlaceHolder(a),this.setTooltip(a)}Q(){super.Q(),this.eb.fire()}R(){super.R(),this.db.fire()}hb(){let a=this.bb.current();return a||(a=this.bb.last(),this.bb.next()),a}ib(){return this.bb.previous()||this.bb.first()}jb(){return this.bb.next()}}t.$tT=f}),define($e[66],pe([1,0,63,20,17,18,4,2,102]),function(ne,t,E,C,n,H,D,k){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$KS=t.$JS=t.$IS=t.$HS=t.$GS=void 0,t.$GS={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class m extends E.$LS{constructor(h,e,s){super(h,e,s),this.a=this.B(new p({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:s.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:s.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:s.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(h){this.element=h,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.$HS=m;class p extends C.$BR{constructor(h){super(),this.a=this.B(new D.$Wd),this.onChange=this.a.event,this.b=this.B(new D.$Wd),this.onKeyDown=this.b.event,this.c=h,this.s=this.c.isChecked;const e=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,e.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&e.push(...this.c.actionClassName.split(" ")),this.s&&e.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...e),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,s=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),s.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,s=>{if(s.keyCode===10||s.keyCode===3){this.checked=!this.s,this.a.fire(!0),s.preventDefault(),s.stopPropagation();return}this.b.fire(s)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(h){this.s=h,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(h){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=h,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(h){this.domNode.title=h,this.domNode.setAttribute("aria-label",h)}}t.$IS=p;class v extends C.$BR{constructor(h,e,s){super(),this.g=h,this.h=e,this.a=this.B(new D.$Wd),this.onChange=this.a.event,this.b=new p({title:this.g,isChecked:this.h,icon:n.$bk.check,actionClassName:"monaco-checkbox",...t.$GS}),this.domNode=this.b.domNode,this.c=s,this.n(),this.B(this.b.onChange(f=>{this.n(),this.a.fire(f)}))}get checked(){return this.b.checked}set checked(h){this.b.checked=h,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,k.$AQ)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$JS=v;class M extends E.$LS{constructor(h,e,s){super(h,e,s),this.a=this.B(new v(this._action.label,!!this._action.checked,s.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(h){if(this.element=h,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const e=this.element.appendChild((0,k.$)("span.checkbox-label",void 0,this._action.label));this.B((0,k.$ZP)(e,k.$TQ.CLICK,s=>{this.a.checked=!this.a.checked,s.stopPropagation(),s.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(h){this.a.domNode.tabIndex=h?0:-1}}t.$KS=M}),define($e[130],pe([1,0,66,17,107]),function(ne,t,E,C,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$GT=t.$FT=t.$ET=void 0;const H=n.localize(0,null),D=n.localize(1,null),k=n.localize(2,null);class m extends E.$IS{constructor(l){super({icon:C.$bk.caseSensitive,title:H+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$ET=m;class p extends E.$IS{constructor(l){super({icon:C.$bk.wholeWord,title:D+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$FT=p;class v extends E.$IS{constructor(l){super({icon:C.$bk.regex,title:k+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.$GT=v}),define($e[131],pe([1,0,2,130,65,20,4,106,3,96]),function(ne,t,E,C,n,H,D,k,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$HT=void 0;const p=k.localize(0,null);class v extends H.$BR{static{this.OPTION_CHANGE="optionChange"}constructor(l,h,e){super(),this.n=!0,this.s=!1,this.w=this.B(new m.$Uc),this.N=[],this.O=this.B(new D.$Wd),this.onDidOptionChange=this.O.event,this.P=this.B(new D.$Wd),this.onKeyDown=this.P.event,this.Q=this.B(new D.$Wd),this.onMouseDown=this.Q.event,this.R=this.B(new D.$Wd),this.onInput=this.R.event,this.S=this.B(new D.$Wd),this.onKeyUp=this.S.event,this.U=this.B(new D.$Wd),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new D.$Wd),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||p,this.h=!!e.showCommonFindToggles;const s=e.appendCaseSensitiveLabel||"",f=e.appendWholeWordsLabel||"",c=e.appendRegexLabel||"",a=e.history||[],$=!!e.flexibleHeight,d=!!e.flexibleWidth,b=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new n.$tT(this.domNode,h,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:a,showHistoryHint:e.showHistoryHint,flexibleHeight:$,flexibleWidth:d,flexibleMaxHeight:b,inputBoxStyles:e.inputBoxStyles})),this.h){this.J=this.B(new C.$GT({appendTitle:c,isChecked:!1,...e.toggleStyles})),this.B(this.J.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(N=>{this.W.fire(N)})),this.L=this.B(new C.$FT({appendTitle:f,isChecked:!1,...e.toggleStyles})),this.B(this.L.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$ET({appendTitle:s,isChecked:!1,...e.toggleStyles})),this.B(this.M.onChange(N=>{this.O.fire(N),!N&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(N=>{this.U.fire(N)}));const u=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,N=>{if(N.equals(15)||N.equals(17)||N.equals(9)){const B=u.indexOf(this.domNode.ownerDocument.activeElement);if(B>=0){let R=-1;N.equals(17)?R=(B+1)%u.length:N.equals(15)&&(B===0?R=u.length-1:R=B-1),N.equals(9)?(u[B].blur(),this.inputBox.focus()):R>=0&&u[R].focus(),E.$VQ.stop(N,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(e?.additionalToggles),this.y&&this.domNode.appendChild(this.y),l?.appendChild(this.domNode),this.B(E.$ZP(this.inputBox.inputElement,"compositionstart",u=>{this.s=!0})),this.B(E.$ZP(this.inputBox.inputElement,"compositionend",u=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,u=>this.P.fire(u)),this.C(this.inputBox.inputElement,u=>this.S.fire(u)),this.D(this.inputBox.inputElement,u=>this.R.fire()),this.j(this.inputBox.inputElement,u=>this.Q.fire(u))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(l){this.inputBox.layout(),this.X(l.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const l of this.N)l.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const l of this.N)l.disable()}setFocusInputOnOptionClick(l){this.n=l}setEnabled(l){l?this.enable():this.disable()}setAdditionalToggles(l){for(const h of this.N)h.domNode.remove();this.N=[],this.w.value=new m.$Sc;for(const h of l??[])this.w.value.add(h),this.y.appendChild(h.domNode),this.w.value.add(h.onChange(e=>{this.O.fire(e),!e&&this.n&&this.inputBox.focus()})),this.N.push(h);this.N.length>0&&(this.y.style.display=""),this.X()}X(l=!1){l?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((h,e)=>h+e.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(l){this.inputBox.value!==l&&(this.inputBox.value=l)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(l){this.M&&(this.M.checked=l)}getWholeWords(){return this.L?.checked??!1}setWholeWords(l){this.L&&(this.L.checked=l)}getRegex(){return this.J?.checked??!1}setRegex(l){this.J&&(this.J.checked=l,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(l){this.inputBox.showMessage(l)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$HT=v}),define($e[132],pe([1,0,2,22,14,64,131,65,61,40,66,58,26,37,12,9,17,18,32,4,35,3,33,7,111,103]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h,e,s,f,c,a,$,d,b,u,N,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gU=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$fU=t.$eU=t.$dU=t.RenderIndentGuides=t.$cU=t.$bU=void 0;class R extends m.$_R{set context(i){this.c.context=i}get context(){return this.c.context}constructor(i){super(i.elements.map(o=>o.element)),this.c=i}}function W(r){return r instanceof m.$_R?new R(r):r}class z{constructor(i,o){this.d=i,this.f=o,this.b=b.$Tc.None,this.c=new b.$Sc}getDragURI(i){return this.f.getDragURI(i.element)}getDragLabel(i,o){if(this.f.getDragLabel)return this.f.getDragLabel(i.map(w=>w.element),o)}onDragStart(i,o){this.f.onDragStart?.(W(i),o)}onDragOver(i,o,w,I,T,j=!0){const V=this.f.onDragOver(W(i),o&&o.element,w,I,T),X=this.a!==o;if(X&&(this.b.dispose(),this.a=o),typeof o>"u")return V;if(X&&typeof V!="boolean"&&V.autoExpand&&(this.b=(0,s.$0g)(()=>{const Ee=this.d(),ve=Ee.getNodeLocation(o);Ee.isCollapsed(ve)&&Ee.setCollapsed(ve,!1),this.a=void 0},500,this.c)),typeof V=="boolean"||!V.accept||typeof V.bubble>"u"||V.feedback){if(!j){const Ee=typeof V=="boolean"?V:V.accept,ve=typeof V=="boolean"?void 0:V.effect;return{accept:Ee,effect:ve,feedback:[w]}}return V}if(V.bubble===1){const Ee=this.d(),ve=Ee.getNodeLocation(o),Pe=Ee.getParentNodeLocation(ve),Ie=Ee.getNode(Pe),Me=Pe&&Ee.getListIndex(Pe);return this.onDragOver(i,Ie,Me,I,T,!1)}const oe=this.d(),be=oe.getNodeLocation(o),ye=oe.getListIndex(be),we=oe.getListRenderCount(be);return{...V,feedback:(0,e.$Sb)(ye,ye+we)}}drop(i,o,w,I,T){this.b.dispose(),this.a=void 0,this.f.drop(W(i),o&&o.element,w,I,T)}onDragEnd(i){this.f.onDragEnd?.(i)}dispose(){this.c.dispose(),this.f.dispose()}}function y(r,i){return i&&{...i,identityProvider:i.identityProvider&&{getId(o){return i.identityProvider.getId(o.element)}},dnd:i.dnd&&new z(r,i.dnd),multipleSelectionController:i.multipleSelectionController&&{isSelectionSingleChangeEvent(o){return i.multipleSelectionController.isSelectionSingleChangeEvent({...o,element:o.element})},isSelectionRangeChangeEvent(o){return i.multipleSelectionController.isSelectionRangeChangeEvent({...o,element:o.element})}},accessibilityProvider:i.accessibilityProvider&&{...i.accessibilityProvider,getSetSize(o){const w=r(),I=w.getNodeLocation(o),T=w.getParentNodeLocation(I);return w.getNode(T).visibleChildrenCount},getPosInSet(o){return o.visibleChildIndex+1},isChecked:i.accessibilityProvider&&i.accessibilityProvider.isChecked?o=>i.accessibilityProvider.isChecked(o.element):void 0,getRole:i.accessibilityProvider&&i.accessibilityProvider.getRole?o=>i.accessibilityProvider.getRole(o.element):()=>"treeitem",getAriaLabel(o){return i.accessibilityProvider.getAriaLabel(o.element)},getWidgetAriaLabel(){return i.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:i.accessibilityProvider&&i.accessibilityProvider.getWidgetRole?()=>i.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:i.accessibilityProvider&&i.accessibilityProvider.getAriaLevel?o=>i.accessibilityProvider.getAriaLevel(o.element):o=>o.depth,getActiveDescendantId:i.accessibilityProvider.getActiveDescendantId&&(o=>i.accessibilityProvider.getActiveDescendantId(o.element))},keyboardNavigationLabelProvider:i.keyboardNavigationLabelProvider&&{...i.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(o){return i.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(o.element)}}}}class O{constructor(i){this.a=i}getHeight(i){return this.a.getHeight(i.element)}getTemplateId(i){return this.a.getTemplateId(i.element)}hasDynamicHeight(i){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(i.element)}setDynamicHeight(i,o){this.a.setDynamicHeight?.(i.element,o)}}t.$bU=O;class U{static lift(i){return i instanceof U?i:new U(i)}static empty(i=0){return new U({focus:[],selection:[],expanded:Object.create(null),scrollTop:i})}constructor(i){if(this.focus=new Set(i.focus),this.selection=new Set(i.selection),i.expanded instanceof Array){this.expanded=Object.create(null);for(const o of i.expanded)this.expanded[o]=1}else this.expanded=i.expanded;this.expanded=i.expanded,this.scrollTop=i.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$cU=U;var S;(function(r){r.None="none",r.OnHover="onHover",r.Always="always"})(S||(t.RenderIndentGuides=S={}));class P{get elements(){return this.b}constructor(i,o=[]){this.b=o,this.a=new b.$Sc,this.onDidChange=$.Event.forEach(i,w=>this.b=w,this.a)}dispose(){this.a.dispose()}}class L{static{this.a=8}constructor(i,o,w,I,T,j={}){this.o=i,this.p=o,this.q=I,this.s=T,this.b=new Map,this.c=new Map,this.d=L.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Tc.None,this.m=new b.$Sc,this.templateId=i.templateId,this.updateOptions(j),$.Event.map(w,V=>V.node)(this.u,this,this.m),i.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(i={}){if(typeof i.indent<"u"){const o=(0,u.$9l)(i.indent,0,40);if(o!==this.d){this.d=o;for(const[w,I]of this.c)this.v(w,I)}}if(typeof i.renderIndentGuides<"u"){const o=i.renderIndentGuides!==S.None;if(o!==this.g){this.g=o;for(const[w,I]of this.c)this.w(w,I);if(this.k.dispose(),o){const w=new b.$Sc;this.q.onDidChange(this.x,this,w),this.k=w,this.x(this.q.elements)}}}typeof i.hideTwistiesOfChildlessElements<"u"&&(this.f=i.hideTwistiesOfChildlessElements)}renderTemplate(i){const o=(0,E.$1Q)(i,(0,E.$)(".monaco-tl-row")),w=(0,E.$1Q)(o,(0,E.$)(".monaco-tl-indent")),I=(0,E.$1Q)(o,(0,E.$)(".monaco-tl-twistie")),T=(0,E.$1Q)(o,(0,E.$)(".monaco-tl-contents")),j=this.o.renderTemplate(T);return{container:i,indent:w,twistie:I,indentGuidesDisposable:b.$Tc.None,templateData:j}}renderElement(i,o,w,I){this.c.set(i,w),this.b.set(i.element,i),this.v(i,w),this.o.renderElement(i,o,w.templateData,I)}disposeElement(i,o,w,I){w.indentGuidesDisposable.dispose(),this.o.disposeElement?.(i,o,w.templateData,I),typeof I=="number"&&(this.c.delete(i),this.b.delete(i.element))}disposeTemplate(i){this.o.disposeTemplate(i.templateData)}t(i){const o=this.b.get(i);o&&this.u(o)}u(i){const o=this.c.get(i);o&&(this.x(this.q.elements),this.v(i,o))}v(i,o){const w=L.a+(i.depth-1)*this.d;o.twistie.style.paddingLeft=`${w}px`,o.indent.style.width=`${w+this.d-16}px`,i.collapsible?o.container.setAttribute("aria-expanded",String(!i.collapsed)):o.container.removeAttribute("aria-expanded"),o.twistie.classList.remove(...c.ThemeIcon.asClassNameArray(f.$bk.treeItemExpanded));let I=!1;this.o.renderTwistie&&(I=this.o.renderTwistie(i.element,o.twistie)),i.collapsible&&(!this.f||i.visibleChildrenCount>0)?(I||o.twistie.classList.add(...c.ThemeIcon.asClassNameArray(f.$bk.treeItemExpanded)),o.twistie.classList.add("collapsible"),o.twistie.classList.toggle("collapsed",i.collapsed)):o.twistie.classList.remove("collapsible","collapsed"),this.w(i,o)}w(i,o){if((0,E.$YP)(o.indent),o.indentGuidesDisposable.dispose(),!this.g)return;const w=new b.$Sc,I=this.p();for(;;){const T=I.getNodeLocation(i),j=I.getParentNodeLocation(T);if(!j)break;const V=I.getNode(j),X=(0,E.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(V)&&X.classList.add("active"),o.indent.childElementCount===0?o.indent.appendChild(X):o.indent.insertBefore(X,o.indent.firstElementChild),this.s.add(V,X),w.add((0,b.$Rc)(()=>this.s.delete(V,X))),i=V}o.indentGuidesDisposable=w}x(i){if(!this.g)return;const o=new Set,w=this.p();i.forEach(I=>{const T=w.getNodeLocation(I);try{const j=w.getParentNodeLocation(T);I.collapsible&&I.children.length>0&&!I.collapsed?o.add(I):j&&o.add(w.getNode(j))}catch{}}),this.j.forEach(I=>{o.has(I)||this.s.forEach(I,T=>T.classList.remove("active"))}),o.forEach(I=>{this.j.has(I)||this.s.forEach(I,T=>T.classList.add("active"))}),this.j=o}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Oc)(this.m)}}t.$dU=L;class G{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(i){this.c=i,this.d=i.toLowerCase()}constructor(i,o,w){this.g=i,this.j=o,this.k=w,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Sc,i.onWillRefilter(this.m,this,this.f)}filter(i,o){let w=1;if(this.k){const j=this.k.filter(i,o);if(typeof j=="boolean"?w=j?1:0:(0,M.$$T)(j)?w=(0,M.$_T)(j.visibility):w=j,w===0)return!1}if(this.a++,!this.c)return this.b++,{data:d.FuzzyScore.Default,visibility:w};const I=this.j.getKeyboardNavigationLabel(i),T=Array.isArray(I)?I:[I];for(const j of T){const V=j&&j.toString();if(typeof V>"u")return{data:d.FuzzyScore.Default,visibility:w};let X;if(this.g.findMatchType===me.Contiguous){const oe=V.toLowerCase().indexOf(this.d);if(oe>-1){X=[Number.MAX_SAFE_INTEGER,0];for(let be=this.d.length;be>0;be--)X.push(oe+be-1)}}else X=(0,d.$9j)(this.c,this.d,0,V,V.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(X)return this.b++,T.length===1?{data:X,visibility:w}:{data:{label:V,score:X},visibility:w}}return this.g.findMode===te.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(i):2:{data:d.FuzzyScore.Default,visibility:w}}m(){this.a=0,this.b=0}dispose(){(0,b.$Oc)(this.f)}}class Z extends v.$IS{constructor(i){super({icon:f.$bk.listFilter,title:(0,B.localize)(0,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$eU=Z;class ge extends v.$IS{constructor(i){super({icon:f.$bk.searchFuzzy,title:(0,B.localize)(1,null),isChecked:i.isChecked??!1,inputActiveOptionBorder:i.inputActiveOptionBorder,inputActiveOptionForeground:i.inputActiveOptionForeground,inputActiveOptionBackground:i.inputActiveOptionBackground})}}t.$fU=ge;const ue={inputBoxStyles:k.$rT,toggleStyles:v.$GS,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var te;(function(r){r[r.Highlight=0]="Highlight",r[r.Filter=1]="Filter"})(te||(t.TreeFindMode=te={}));var me;(function(r){r[r.Fuzzy=0]="Fuzzy",r[r.Contiguous=1]="Contiguous"})(me||(t.TreeFindMatchType=me={}));class Re extends b.$Tc{set mode(i){this.b.checked=i===te.Filter,this.f.inputBox.setPlaceHolder(i===te.Filter?(0,B.localize)(2,null):(0,B.localize)(3,null))}set matchType(i){this.c.checked=i===me.Fuzzy}get value(){return this.f.inputBox.value}set value(i){this.f.inputBox.value=i}constructor(i,o,w,I,T,j){super(),this.t=o,this.a=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new $.$Wd,this.onDidDisable=this._onDidDisable.event,i.appendChild(this.a.root),this.B((0,b.$Rc)(()=>i.removeChild(this.a.root)));const V=j?.styles??ue;V.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=V.listFilterWidgetBackground),V.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${V.listFilterWidgetShadow}`),this.b=this.B(new Z({...V.toggleStyles,isChecked:I===te.Filter})),this.c=this.B(new ge({...V.toggleStyles,isChecked:T===me.Fuzzy})),this.onDidChangeMode=$.Event.map(this.b.onChange,()=>this.b.checked?te.Filter:te.Highlight,this.q),this.onDidChangeMatchType=$.Event.map(this.c.onChange,()=>this.c.checked?me.Fuzzy:me.Contiguous,this.q),this.f=this.B(new D.$HT(this.a.findInput,w,{label:(0,B.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:V.inputBoxStyles,toggleStyles:V.toggleStyles,history:j?.history})),this.g=this.B(new H.$TR(this.a.actionbar)),this.mode=I;const X=this.B(new C.$2R(this.f.inputBox.inputElement,"keydown")),oe=$.Event.chain(X.event,Ee=>Ee.map(ve=>new n.$WP(ve)));this.B(oe(Ee=>{if(Ee.equals(3)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Ee.equals(18)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Ee.equals(16)){Ee.preventDefault(),Ee.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const be=this.B(new h.$Mi("close",(0,B.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(be,{icon:!0,label:!1});const ye=this.B(new C.$2R(this.a.grab,"mousedown"));this.B(ye.event(Ee=>{const ve=new b.$Sc,Pe=ve.add(new C.$2R((0,E.getWindow)(Ee),"mousemove")),Ie=ve.add(new C.$2R((0,E.getWindow)(Ee),"mouseup")),Me=this.m,Ze=Ee.pageX,et=this.s,xe=Ee.pageY;this.a.grab.classList.add("grabbing");const x=this.a.root.style.transition;this.a.root.style.transition="unset";const le=de=>{const Ae=de.pageX-Ze;this.m=Me-Ae;const Ce=de.pageY-xe;this.s=et+Ce,this.layout()};ve.add(Pe.event(le)),ve.add(Ie.event(de=>{le(de),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=x,ve.dispose()}))}));const we=$.Event.chain(this.B(new C.$2R(this.a.grab,"keydown")).event,Ee=>Ee.map(ve=>new n.$WP(ve)));this.B(we(Ee=>{let ve,Pe;if(Ee.keyCode===15?ve=Number.POSITIVE_INFINITY:Ee.keyCode===17?ve=0:Ee.keyCode===10&&(ve=this.m===0?Number.POSITIVE_INFINITY:0),Ee.keyCode===16?Pe=0:Ee.keyCode===18&&(Pe=Number.POSITIVE_INFINITY),ve!==void 0&&(Ee.preventDefault(),Ee.stopPropagation(),this.m=ve,this.layout()),Pe!==void 0){Ee.preventDefault(),Ee.stopPropagation(),this.s=Pe;const Ie=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Ie},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(i=this.j){this.j=i,this.m=(0,u.$9l)(this.m,0,Math.max(0,i-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,u.$9l)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(i){this.f.showMessage(i)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,s.$9g)(300),super.dispose()}}class Ne{get pattern(){return this.b}get mode(){return this.d}set mode(i){i!==this.d&&(this.d=i,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(i))}get matchType(){return this.f}set matchType(i){i!==this.f&&(this.f=i,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(i))}constructor(i,o,w,I,T,j={}){this.t=i,this.u=w,this.v=I,this.w=T,this.x=j,this.b="",this.c="",this.j=0,this.k=new $.$Wd,this.onDidChangeMode=this.k.event,this.m=new $.$Wd,this.onDidChangeMatchType=this.m.event,this.o=new $.$Wd,this.onDidChangePattern=this.o.event,this.p=new $.$Wd,this.onDidChangeOpenState=this.p.event,this.q=new b.$Sc,this.s=new b.$Sc,this.d=i.options.defaultFindMode??te.Highlight,this.f=i.options.defaultFindMatchType??me.Fuzzy,o.onDidSplice(this.z,this,this.s)}updateOptions(i={}){i.defaultFindMode!==void 0&&(this.mode=i.defaultFindMode),i.defaultFindMatchType!==void 0&&(this.matchType=i.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Re(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(i=>this.mode=i,void 0,this.q),this.g.onDidChangeMatchType(i=>this.matchType=i,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(i){this.b=i,this.o.fire(i),this.v.pattern=i,this.t.refilter(),i&&this.t.focusNext(0,!0,void 0,w=>!d.FuzzyScore.isDefault(w.filterData));const o=this.t.getFocus();if(o.length>0){const w=o[0];this.t.getRelativeTop(w)===null&&this.t.reveal(w,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const i=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&i?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,B.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(i){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!d.FuzzyScore.isDefault(i.filterData)}layout(i){this.j=i,this.g?.layout(i)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function Be(r,i){return r.position===i.position&&re(r,i)}function re(r,i){return r.node.element===i.node.element&&r.startIndex===i.startIndex&&r.height===i.height&&r.endIndex===i.endIndex}class J{constructor(i=[]){this.stickyNodes=i}get count(){return this.stickyNodes.length}equal(i){return(0,e.$ub)(this.stickyNodes,i.stickyNodes,Be)}lastNodePartiallyVisible(){if(this.count===0)return!1;const i=this.stickyNodes[this.count-1];if(this.count===1)return i.position!==0;const o=this.stickyNodes[this.count-2];return o.position+o.height!==i.position}animationStateChanged(i){if(!(0,e.$ub)(this.stickyNodes,i.stickyNodes,re)||this.count===0)return!1;const o=this.stickyNodes[this.count-1],w=i.stickyNodes[i.count-1];return o.position!==w.position}}class ae{constrainStickyScrollNodes(i,o,w){for(let I=0;I<i.length;I++){const T=i[I];if(T.position+T.height>w||I>=o)return i.slice(0,I)}return i}}class se extends b.$Tc{constructor(i,o,w,I,T,j={}){super(),this.g=i,this.j=o,this.m=w,this.s=T,this.c=.4;const V=this.validateStickySettings(j);this.b=V.stickyScrollMaxItemCount,this.a=j.stickyScrollDelegate??new ae,this.f=this.B(new Y(w.getScrollableElement(),w,i,I,T,j.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(w.onDidScroll(()=>this.u())),this.B(w.onDidChangeContentHeight(()=>this.u())),this.B(i.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(i){return this.f.getNode(i)}t(i){let o;if(i===0?o=this.m.firstVisibleIndex:o=this.m.indexAt(i+this.m.scrollTop),!(o<0||o>=this.m.length))return this.m.element(o)}u(){const i=this.t(0);if(!i||this.g.scrollTop===0){this.f.setState(void 0);return}const o=this.w(i);this.f.setState(o)}w(i){const o=[];let w=i,I=0,T=this.z(w,void 0,I);for(;T&&(o.push(T),I+=T.height,!(o.length<=this.b&&(w=this.y(T),!w)));)T=this.z(w,T.node,I);const j=this.H(o);return j.length?new J(j):void 0}y(i){return this.t(i.position+i.height)}z(i,o,w){const I=this.F(i,o);if(I&&!(I===i&&(!this.J(i)||this.C(i,w))))return this.D(I,w)}C(i,o){const w=this.L(i),I=this.m.getElementTop(w),T=o;return this.m.scrollTop===I-T}D(i,o){const w=this.s.getHeight(i),{startIndex:I,endIndex:T}=this.M(i),j=this.G(T,o,w);return{node:i,position:j,height:w,startIndex:I,endIndex:T}}F(i,o=void 0){let w=i,I=this.I(w);for(;I;){if(I===o)return w;w=I,I=this.I(w)}if(o===void 0)return w}G(i,o,w){let I=this.m.getRelativeTop(i);if(I===null&&this.m.firstVisibleIndex===i&&i+1<this.m.length){const oe=this.s.getHeight(this.m.element(i)),be=this.m.getRelativeTop(i+1);I=be?be-oe/this.m.renderHeight:null}if(I===null)return o;const T=this.m.element(i),j=this.s.getHeight(T),X=I*this.m.renderHeight+j;return o+w>X&&o<=X?X-w:o}H(i){if(i.length===0)return[];const o=this.m.renderHeight*this.c,w=i[i.length-1];if(i.length<=this.b&&w.position+w.height<=o)return i;const I=this.a.constrainStickyScrollNodes(i,this.b,o);if(!I.length)return[];const T=I[I.length-1];if(I.length>this.b||T.position+T.height>o)throw new Error("stickyScrollDelegate violates constraints");return I}I(i){const o=this.j.getNodeLocation(i),w=this.j.getParentNodeLocation(o);return w?this.j.getNode(w):void 0}J(i){const o=this.j.getNodeLocation(i);return this.j.getListRenderCount(o)>1}L(i){const o=this.j.getNodeLocation(i);return this.j.getListIndex(o)}M(i){const o=this.j.getNodeLocation(i),w=this.j.getListIndex(o);if(w<0)throw new Error("Node not found in tree");const I=this.j.getListRenderCount(o),T=w+I-1;return{startIndex:w,endIndex:T}}nodePositionTopBelowWidget(i){const o=[];let w=this.I(i);for(;w;)o.push(w),w=this.I(w);let I=0;for(let T=0;T<o.length&&T<this.b;T++)I+=this.s.getHeight(o[T]);return I}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(i={}){if(!i.stickyScrollMaxItemCount)return;const o=this.validateStickySettings(i);this.b!==o.stickyScrollMaxItemCount&&(this.b=o.stickyScrollMaxItemCount,this.u())}validateStickySettings(i){let o=7;return typeof i.stickyScrollMaxItemCount=="number"&&(o=Math.max(i.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:o}}}class Y{constructor(i,o,w,I,T,j){this.g=o,this.j=w,this.k=I,this.m=T,this.o=j,this.c=[],this.d=new b.$Sc,this.a=(0,E.$)(".monaco-tree-sticky-container.empty"),i.appendChild(this.a);const V=(0,E.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(V),this.f=new K(this.a,o),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const i=this.b.stickyNodes[this.b.count-1];return i.position+i.height}get count(){return this.b?.count??0}getNode(i){return this.b?.stickyNodes.find(o=>o.node===i)}setState(i){const o=!!this.b&&this.b.count>0,w=!!i&&i.count>0;if(!o&&!w||o&&w&&this.b.equal(i))return;if(o!==w&&this.s(w),!w){this.b=void 0,this.c=[],this.d.clear();return}const I=i.stickyNodes[i.count-1];if(this.b&&i.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${I.position}px`;else{this.d.clear();const T=Array(i.count);for(let j=i.count-1;j>=0;j--){const V=i.stickyNodes[j],{element:X,disposable:oe}=this.p(V,j,i.count);T[j]=X,this.a.appendChild(X),this.d.add(oe)}this.f.updateElements(T,i),this.c=T}this.b=i,this.a.style.height=`${I.position+I.height}px`}p(i,o,w){const I=i.startIndex,T=document.createElement("div");T.style.top=`${i.position}px`,T.style.height=`${i.height}px`,T.style.lineHeight=`${i.height}px`,T.classList.add("monaco-tree-sticky-row"),T.classList.add("monaco-list-row"),T.setAttribute("data-index",`${I}`),T.setAttribute("data-parity",I%2===0?"even":"odd"),T.setAttribute("id",this.g.getElementID(I)),this.q(T,i.node.element,o,w);const j=this.m.getTemplateId(i.node),V=this.k.find(ye=>ye.templateId===j);if(!V)throw new Error(`No renderer found for template id ${j}`);let X=i.node;X===this.j.getNode(this.j.getNodeLocation(i.node))&&(X=new Proxy(i.node,{}));const oe=V.renderTemplate(T);V.renderElement(X,i.startIndex,oe,i.height);const be=(0,b.$Rc)(()=>{V.disposeElement(X,i.startIndex,oe,i.height),V.disposeTemplate(oe),T.remove()});return{element:T,disposable:be}}q(i,o,w,I){if(!this.o)return;this.o.getSetSize&&i.setAttribute("aria-setsize",String(this.o.getSetSize(o,w,I))),this.o.getPosInSet&&i.setAttribute("aria-posinset",String(this.o.getPosInSet(o,w))),this.o.getRole&&i.setAttribute("role",this.o.getRole(o)??"treeitem");const T=this.o.getAriaLabel(o);T&&i.setAttribute("aria-label",T);const j=this.o.getAriaLevel&&this.o.getAriaLevel(o);typeof j=="number"&&i.setAttribute("aria-level",`${j}`),i.setAttribute("aria-selected",String(!1))}s(i){this.a.classList.toggle("empty",!i),i||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class K extends b.$Tc{get m(){return this.j}set m(i){i!==this.j&&(this.f.fire(i),this.j=i)}constructor(i,o){super(),this.s=i,this.t=o,this.a=-1,this.b=[],this.f=new $.$Wd,this.onDidChangeHasFocus=this.f.event,this.g=new $.$Wd,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.I()),this.s.addEventListener("blur",()=>this.J()),this.B(this.t.onDidFocus(()=>this.H(!1))),this.B(this.t.onKeyDown(w=>this.w(w))),this.B(this.t.onMouseDown(w=>this.y(w))),this.B(this.t.onContextMenu(w=>this.u(w)))}u(i){const o=i.browserEvent.target;if(!(0,p.$mS)(o)&&!(0,p.$lS)(o)){this.focusedLast()&&this.t.domFocus();return}if(!(0,E.$QQ)(i.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const j=this.c.stickyNodes.findIndex(V=>V.node.element===i.element?.element);if(j===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(j);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const I=this.c.stickyNodes[this.a].node.element,T=this.b[this.a];this.g.fire({element:I,anchor:T,browserEvent:i.browserEvent,isStickyScroll:!0})}w(i){if(this.m&&this.c){if(i.key==="ArrowUp")this.z(Math.max(0,this.a-1)),i.preventDefault(),i.stopPropagation();else if(i.key==="ArrowDown"||i.key==="ArrowRight"){if(this.a>=this.c.count-1){const o=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([o]),this.C(o,this.c)}else this.z(this.a+1);i.preventDefault(),i.stopPropagation()}}}y(i){const o=i.browserEvent.target;!(0,p.$mS)(o)&&!(0,p.$lS)(o)||(i.browserEvent.preventDefault(),i.browserEvent.stopPropagation())}updateElements(i,o){if(o&&o.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(o&&o.count!==i.length)throw new Error("Sticky scroll focus received illigel state");const w=this.a;if(this.D(),this.b=i,this.c=o,o){const I=(0,u.$9l)(w,0,o.count-1);this.F(I)}else this.m&&this.t.domFocus();this.s.tabIndex=o?0:-1}z(i){const o=this.c;if(!o)throw new Error("Cannot set focus when state is undefined");if(this.F(i),!(i<o.count-1)&&o.lastNodePartiallyVisible()){const w=o.stickyNodes[i];this.C(w.endIndex+1,o)}}C(i,o){const w=o.stickyNodes[o.count-1],I=o.count>1?o.stickyNodes[o.count-2]:void 0,T=this.t.getElementTop(i),j=I?I.position+I.height+w.height:w.height;this.t.scrollTop=T-j}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(i){if(0>i)throw new Error("addFocus() can not remove focus");if(!this.c&&i>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&i>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const o=this.a;o>=0&&this.G(this.b[o],!1),i>=0&&this.G(this.b[i],!0),this.a=i}G(i,o){i.classList.toggle("focused",o)}H(i){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",i)}I(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.H(!0),this.a===-1&&this.F(0)}J(){this.m=!1}dispose(){this.H(!1),this.f.fire(!1),super.dispose()}}function ie(r){let i=l.TreeMouseEventTarget.Unknown;return(0,E.$vQ)(r.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?i=l.TreeMouseEventTarget.Twistie:(0,E.$vQ)(r.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?i=l.TreeMouseEventTarget.Element:(0,E.$vQ)(r.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(i=l.TreeMouseEventTarget.Filter),{browserEvent:r.browserEvent,element:r.element?r.element.element:null,target:i}}function fe(r){const i=(0,p.$mS)(r.browserEvent.target);return{element:r.element?r.element.element:null,browserEvent:r.browserEvent,anchor:r.anchor,isStickyScroll:i}}function De(r,i){i(r),r.children.forEach(o=>De(o,i))}class Te{get f(){return this.d||(this.d=this.m()),this.d}constructor(i,o){this.g=i,this.j=o,this.a=[],this.c=new $.$Wd,this.onDidChange=this.c.event}set(i,o){!o?.__forceEvent&&(0,e.$ub)(this.a,i)||this.k(i,!1,o)}k(i,o,w){if(this.a=[...i],this.b=void 0,this.d=void 0,!o){const I=this;this.c.fire({get elements(){return I.get()},browserEvent:w})}}get(){return this.b||(this.b=this.a.map(i=>i.element)),[...this.b]}getNodes(){return this.a}has(i){return this.f.has(i)}onDidModelSplice({insertedNodes:i,deletedNodes:o}){if(!this.j){const X=this.m(),oe=be=>X.delete(be);o.forEach(be=>De(be,oe)),this.set([...X.values()]);return}const w=new Set,I=X=>w.add(this.j.getId(X.element).toString());o.forEach(X=>De(X,I));const T=new Map,j=X=>T.set(this.j.getId(X.element).toString(),X);i.forEach(X=>De(X,j));const V=[];for(const X of this.a){const oe=this.j.getId(X.element).toString();if(!w.has(oe))V.push(X);else{const ye=T.get(oe);ye&&ye.visible&&V.push(ye)}}if(this.a.length>0&&V.length===0){const X=this.g();X&&V.push(X)}this.k(V,!0)}m(){const i=new Set;for(const o of this.a)i.add(o);return i}}class Se extends p.$rS{constructor(i,o,w){super(i),this.x=o,this.y=w}u(i){if((0,p.$nS)(i.browserEvent.target)||(0,p.$gS)(i.browserEvent.target)||(0,p.$hS)(i.browserEvent.target)||i.browserEvent.isHandledByList)return;const o=i.element;if(!o)return super.u(i);if(this.p(i)||this.o(i))return super.u(i);const w=i.browserEvent.target,I=w.classList.contains("monaco-tl-twistie")||w.classList.contains("monaco-icon-label")&&w.classList.contains("folder-icon")&&i.browserEvent.offsetX<16,T=(0,p.$lS)(i.browserEvent.target);let j=!1;if(T?j=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?j=this.x.expandOnlyOnTwistieClick(o.element):j=!!this.x.expandOnlyOnTwistieClick,T)this.A(i,o);else{if(j&&!I&&i.browserEvent.detail!==2)return super.u(i);if(!this.x.expandOnDoubleClick&&i.browserEvent.detail===2)return super.u(i)}if(o.collapsible&&(!T||I)){const V=this.x.getNodeLocation(o),X=i.browserEvent.altKey;if(this.x.setFocus([V]),this.x.toggleCollapsed(V,X),j&&I){i.browserEvent.isHandledByList=!0;return}}T||super.u(i)}A(i,o){if((0,p.$iS)(i.browserEvent.target)||(0,p.$jS)(i.browserEvent.target))return;const w=this.y();if(!w)throw new Error("Sticky scroll controller not found");const I=this.k.indexOf(o),T=this.k.getElementTop(I),j=w.nodePositionTopBelowWidget(o);this.x.scrollTop=T-j,this.k.domFocus(),this.k.setFocus([I]),this.k.setSelection([I])}v(i){i.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||i.browserEvent.isHandledByList||super.v(i)}s(i){const o=i.browserEvent.target;if(!(0,p.$mS)(o)&&!(0,p.$lS)(o)){super.s(i);return}}t(i){const o=i.browserEvent.target;if(!(0,p.$mS)(o)&&!(0,p.$lS)(o)){super.t(i);return}}}class _ extends p.$uS{constructor(i,o,w,I,T,j,V,X){super(i,o,w,I,X),this.p=T,this.s=j,this.K=V}D(i){return new Se(this,i.tree,i.stickyScrollProvider)}splice(i,o,w=[]){if(super.splice(i,o,w),w.length===0)return;const I=[],T=[];let j;w.forEach((V,X)=>{this.p.has(V)&&I.push(i+X),this.s.has(V)&&T.push(i+X),this.K.has(V)&&(j=i+X)}),I.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...I])),T.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...T])),typeof j=="number"&&super.setAnchor(j)}setFocus(i,o,w=!1){super.setFocus(i,o),w||this.p.set(i.map(I=>this.element(I)),o)}setSelection(i,o,w=!1){super.setSelection(i,o),w||this.s.set(i.map(I=>this.element(I)),o)}setAnchor(i,o=!1){super.setAnchor(i),o||(typeof i>"u"?this.K.set([]):this.K.set([this.element(i)]))}}var g;(function(r){r[r.Tree=0]="Tree",r[r.StickyScroll=1]="StickyScroll"})(g||(t.AbstractTreePart=g={}));class A{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return $.Event.map(this.j.onMouseClick,ie)}get onMouseDblClick(){return $.Event.filter($.Event.map(this.j.onMouseDblClick,ie),i=>i.target!==l.TreeMouseEventTarget.Filter)}get onContextMenu(){return $.Event.any($.Event.filter($.Event.map(this.j.onContextMenu,fe),i=>!i.isStickyScroll),this.B?.onContextMenu??$.Event.None)}get onTap(){return $.Event.map(this.j.onTap,ie)}get onPointer(){return $.Event.map(this.j.onPointer,ie)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return $.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??te.Highlight}set findMode(i){this.z&&(this.z.mode=i)}get findMatchType(){return this.z?.matchType??me.Fuzzy}set findMatchType(i){this.z&&(this.z.matchType=i)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:$.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(i,o,w,I,T={}){this.G=i,this.H=T,this.y=new $.$5d,this.onDidChangeFindOpenState=$.Event.None,this.onDidChangeStickyScrollFocused=$.Event.None,this.D=new b.$Sc,this.E=new $.$Wd,this.onWillRefilter=this.E.event,this.F=new $.$Wd,this.onDidUpdateOptions=this.F.event,this.p=new O(w);const j=new $.$6d,V=new $.$6d,X=this.D.add(new P(V.event)),oe=new a.$Gc;this.k=I.map(ve=>new L(ve,()=>this.o,j.event,X,oe,T));for(const ve of this.k)this.D.add(ve);let be;T.keyboardNavigationLabelProvider&&(be=new G(this,T.keyboardNavigationLabelProvider,T.filter),T={...T,filter:be},this.D.add(be)),this.q=new Te(()=>this.j.getFocusedElements()[0],T.identityProvider),this.w=new Te(()=>this.j.getSelectedElements()[0],T.identityProvider),this.x=new Te(()=>this.j.getAnchorElement(),T.identityProvider),this.j=new _(i,o,this.p,this.k,this.q,this.w,this.x,{...y(()=>this.o,T),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(i,this.j,T),j.input=this.o.onDidChangeCollapseState;const ye=$.Event.forEach(this.o.onDidSplice,ve=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(ve),this.w.onDidModelSplice(ve)})},this.D);ye(()=>null,null,this.D);const we=this.D.add(new $.$Wd),Ee=this.D.add(new s.$5g(0));if(this.D.add($.Event.any(ye,this.q.onDidChange,this.w.onDidChange)(()=>{Ee.trigger(()=>{const ve=new Set;for(const Pe of this.q.getNodes())ve.add(Pe);for(const Pe of this.w.getNodes())ve.add(Pe);we.fire([...ve.values()])})})),V.input=we.event,T.keyboardSupport!==!1){const ve=$.Event.chain(this.j.onKeyDown,Pe=>Pe.filter(Ie=>!(0,p.$gS)(Ie.target)).map(Ie=>new n.$WP(Ie)));$.Event.chain(ve,Pe=>Pe.filter(Ie=>Ie.keyCode===15))(this.J,this,this.D),$.Event.chain(ve,Pe=>Pe.filter(Ie=>Ie.keyCode===17))(this.K,this,this.D),$.Event.chain(ve,Pe=>Pe.filter(Ie=>Ie.keyCode===10))(this.L,this,this.D)}if((T.findWidgetEnabled??!0)&&T.keyboardNavigationLabelProvider&&T.contextViewProvider){const ve=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new Ne(this,this.o,this.j,be,T.contextViewProvider,ve),this.A=Pe=>this.z.shouldAllowFocus(Pe),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=$.Event.None,this.onDidChangeFindMatchType=$.Event.None;T.enableStickyScroll&&(this.B=new se(this,this.o,this.j,this.k,this.p,T),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,E.$IQ)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===S.Always)}updateOptions(i={}){this.H={...this.H,...i};for(const o of this.k)o.updateOptions(i);this.j.updateOptions(this.H),this.z?.updateOptions(i),this.I(i),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===S.Always)}get options(){return this.H}I(i){!this.B&&this.H.enableStickyScroll?(this.B=new se(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=$.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(i)}updateWidth(i){const o=this.o.getListIndex(i);o!==-1&&this.j.updateWidth(o)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(i){this.j.scrollTop=i}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(i){this.j.scrollLeft=i}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let i=this.j.firstVisibleIndex;return this.B&&(i+=this.B.count),i<0||i>=this.j.length?void 0:this.j.element(i).element}get lastVisibleElement(){const i=this.j.lastVisibleIndex;return this.j.element(i).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(i){this.j.ariaLabel=i}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,E.$AQ)(this.getHTMLElement())}layout(i,o){this.j.layout(i,o),(0,N.$Nf)(o)&&this.z?.layout(o)}style(i){const o=`.${this.j.domId}`,w=[];i.treeIndentGuidesStroke&&(w.push(`.monaco-list${o}:hover .monaco-tl-indent > .indent-guide, .monaco-list${o}.always .monaco-tl-indent > .indent-guide  { border-color: ${i.treeInactiveIndentGuidesStroke}; }`),w.push(`.monaco-list${o} .monaco-tl-indent > .indent-guide.active { border-color: ${i.treeIndentGuidesStroke}; }`)),i.listBackground&&(w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${i.listBackground}; }`),w.push(`.monaco-list${o} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${i.listBackground}; }`)),i.listFocusForeground&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${i.listFocusForeground}; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const I=(0,E.$gR)(i.listFocusAndSelectionOutline,(0,E.$gR)(i.listSelectionOutline,i.listFocusOutline??""));I&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${I}; outline-offset: -1px;}`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),i.listFocusOutline&&(w.push(`.monaco-list${o}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${i.listFocusOutline}; outline-offset: -1px; }`),w.push(`.monaco-list${o}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),w.push(`.monaco-workbench.context-menu-visible .monaco-list${o}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=w.join(`
`),this.j.style(i)}getParentElement(i){const o=this.o.getParentNodeLocation(i);return this.o.getNode(o).element}getFirstElementChild(i){return this.o.getFirstElementChild(i)}getNode(i){return this.o.getNode(i)}getNodeLocation(i){return this.o.getNodeLocation(i)}collapse(i,o=!1){return this.o.setCollapsed(i,!0,o)}expand(i,o=!1){return this.o.setCollapsed(i,!1,o)}toggleCollapsed(i,o=!1){return this.o.setCollapsed(i,void 0,o)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(i){return this.o.isCollapsible(i)}setCollapsible(i,o){return this.o.setCollapsible(i,o)}isCollapsed(i){return this.o.isCollapsed(i)}expandTo(i){this.o.expandTo(i)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(i){if(typeof i>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const o=this.o.getNode(i);this.x.set([o]);const w=this.o.getListIndex(i);w>-1&&this.j.setAnchor(w,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(i,o){this.y.bufferEvents(()=>{const w=i.map(T=>this.o.getNode(T));this.w.set(w,o);const I=i.map(T=>this.o.getListIndex(T)).filter(T=>T>-1);this.j.setSelection(I,o,!0)})}getSelection(){return this.w.get()}setFocus(i,o){this.y.bufferEvents(()=>{const w=i.map(T=>this.o.getNode(T));this.q.set(w,o);const I=i.map(T=>this.o.getListIndex(T)).filter(T=>T>-1);this.j.setFocus(I,o,!0)})}focusNext(i=1,o=!1,w,I=(0,E.$QQ)(w)&&w.altKey?void 0:this.A){this.j.focusNext(i,o,w,I)}focusPrevious(i=1,o=!1,w,I=(0,E.$QQ)(w)&&w.altKey?void 0:this.A){this.j.focusPrevious(i,o,w,I)}focusNextPage(i,o=(0,E.$QQ)(i)&&i.altKey?void 0:this.A){return this.j.focusNextPage(i,o)}focusPreviousPage(i,o=(0,E.$QQ)(i)&&i.altKey?void 0:this.A){return this.j.focusPreviousPage(i,o,()=>this.B?.height??0)}focusLast(i,o=(0,E.$QQ)(i)&&i.altKey?void 0:this.A){this.j.focusLast(i,o)}focusFirst(i,o=(0,E.$QQ)(i)&&i.altKey?void 0:this.A){this.j.focusFirst(i,o)}getFocus(){return this.q.get()}getStickyScrollFocus(){const i=this.B?.getFocus();return i!==void 0?[i]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(i,o){this.o.expandTo(i);const w=this.o.getListIndex(i);if(w!==-1)if(!this.B)this.j.reveal(w,o);else{const I=this.B.nodePositionTopBelowWidget(this.getNode(i));this.j.reveal(w,o,I)}}getRelativeTop(i){const o=this.o.getListIndex(i);if(o===-1)return null;const w=this.B?.getNode(this.getNode(i));return this.j.getRelativeTop(o,w?.position??this.B?.height)}getViewState(i=this.options.identityProvider){if(!i)throw new l.$9T(this.G,"Can't get tree view state without an identity provider");const o=j=>i.getId(j).toString(),w=U.empty(this.scrollTop);for(const j of this.getFocus())w.focus.add(o(j));for(const j of this.getSelection())w.selection.add(o(j));const I=this.o.getNode(),T=[I];for(;T.length>0;){const j=T.shift();j!==I&&j.collapsible&&(w.expanded[o(j.element)]=j.collapsed?0:1),T.push(...j.children)}return w}J(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],I=this.o.getNodeLocation(w);if(!this.o.setCollapsed(I,!0)){const j=this.o.getParentNodeLocation(I);if(!j)return;const V=this.o.getListIndex(j);this.j.reveal(V),this.j.setFocus([V])}}K(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],I=this.o.getNodeLocation(w);if(!this.o.setCollapsed(I,!1)){if(!w.children.some(X=>X.visible))return;const[j]=this.j.getFocus(),V=j+1;this.j.reveal(V),this.j.setFocus([V])}}L(i){i.preventDefault(),i.stopPropagation();const o=this.j.getFocusedElements();if(o.length===0)return;const w=o[0],I=this.o.getNodeLocation(w),T=i.browserEvent.altKey;this.o.setCollapsed(I,void 0,T)}navigate(i){return new F(this.j,this.o,i)}dispose(){(0,b.$Oc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$gU=A;class F{constructor(i,o,w){this.b=i,this.c=o,w?this.a=this.c.getListIndex(w):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define($e[133],pe([1,0,132,123,26,28]),function(ne,t,E,C,n,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rU=void 0;class D extends E.$gU{constructor(m,p,v,M,l,h={}){super(m,p,v,M,h),this.f=m,this.g=l,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(m,p){if(p&&!this.c)throw new n.$9T(this.f,"Can't restore tree view state without an identity provider");if(this.b=m,!m){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!p){this.m(m);return}const v=[],M=[],l=e=>{const s=this.c.getId(e).toString();return!p.expanded[s]},h=e=>{const s=this.c.getId(e.element).toString();p.focus.has(s)&&v.push(e.element),p.selection.has(s)&&M.push(e.element)};this.m(m,l,h),this.setFocus(v),this.setSelection(M),p&&typeof p.scrollTop=="number"&&(this.scrollTop=p.scrollTop)}updateChildren(m=this.b){if(typeof this.b>"u")throw new n.$9T(this.f,"Tree input not set");let p;this.c&&(p=v=>{const M=this.c.getId(v).toString(),l=this.d.get(M);if(l)return l.collapsed}),this.m(m,p)}resort(m=this.b,p=!0){this.o.resort(m===this.b?null:m,p)}refresh(m){if(m===void 0){this.j.rerender();return}this.o.rerender(m)}m(m,p,v){let M;if(this.c){const l=new Set,h=v;v=e=>{const s=this.c.getId(e.element).toString();l.add(s),this.d.set(s,e),h?.(e)},M=e=>{const s=this.c.getId(e.element).toString();l.has(s)||this.d.delete(s)}}this.o.setChildren(m===this.b?null:m,this.s(m,p).elements,{onDidCreateNode:v,onDidDeleteNode:M})}s(m,p){const v=[...this.g.getChildren(m)];return{elements:H.Iterable.map(v,l=>{const{elements:h,size:e}=this.s(l,p),s=this.g.hasChildren?this.g.hasChildren(l):void 0,f=e===0?void 0:p&&p(l);return{element:l,children:h,collapsible:s,collapsed:f}}),size:v.length}}M(m,p,v){return new C.$hU(m,p,v)}}t.$rU=D}),define($e[67],pe([1,0,12,9,34,29,27,6,4,3,53,10,7]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qh=t.ProxyChannel=t.$Ph=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.RequestInitiator=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=void 0;var h;(function(re){re[re.Promise=100]="Promise",re[re.PromiseCancel=101]="PromiseCancel",re[re.EventListen=102]="EventListen",re[re.EventDispose=103]="EventDispose"})(h||(h={}));function e(re){switch(re){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var s;(function(re){re[re.Initialize=200]="Initialize",re[re.PromiseSuccess=201]="PromiseSuccess",re[re.PromiseError=202]="PromiseError",re[re.PromiseErrorObj=203]="PromiseErrorObj",re[re.EventFire=204]="EventFire"})(s||(s={}));function f(re){switch(re){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(re){re[re.Uninitialized=0]="Uninitialized",re[re.Idle=1]="Idle"})(c||(c={}));function a(re){let J=0;for(let ae=0;;ae+=7){const se=re.read(1);if(J|=(se.buffer[0]&127)<<ae,!(se.buffer[0]&128))return J}}const $=B(0);function d(re,J){if(J===0){re.write($);return}let ae=0;for(let Y=J;Y!==0;Y=Y>>>7)ae++;const se=n.$ke.alloc(ae);for(let Y=0;J!==0;Y++)se.buffer[Y]=J&127,J=J>>>7,J>0&&(se.buffer[Y]|=128);re.write(se)}class b{constructor(J){this.b=J,this.a=0}read(J){const ae=this.b.slice(this.a,this.a+J);return this.a+=ae.byteLength,ae}}t.$Fh=b;class u{constructor(){this.a=[]}get buffer(){return n.$ke.concat(this.a)}write(J){this.a.push(J)}}t.$Gh=u;var N;(function(re){re[re.Undefined=0]="Undefined",re[re.String=1]="String",re[re.Buffer=2]="Buffer",re[re.VSBuffer=3]="VSBuffer",re[re.Array=4]="Array",re[re.Object=5]="Object",re[re.Int=6]="Int"})(N||(N={}));function B(re){const J=n.$ke.alloc(1);return J.writeUInt8(re,0),J}const R={Undefined:B(N.Undefined),String:B(N.String),Buffer:B(N.Buffer),VSBuffer:B(N.VSBuffer),Array:B(N.Array),Object:B(N.Object),Uint:B(N.Int)},W=typeof Buffer<"u";function z(re,J){if(typeof J>"u")re.write(R.Undefined);else if(typeof J=="string"){const ae=n.$ke.fromString(J);re.write(R.String),d(re,ae.byteLength),re.write(ae)}else if(W&&Buffer.isBuffer(J)){const ae=n.$ke.wrap(J);re.write(R.Buffer),d(re,ae.byteLength),re.write(ae)}else if(J instanceof n.$ke)re.write(R.VSBuffer),d(re,J.byteLength),re.write(J);else if(Array.isArray(J)){re.write(R.Array),d(re,J.length);for(const ae of J)z(re,ae)}else if(typeof J=="number"&&(J|0)===J)re.write(R.Uint),d(re,J);else{const ae=n.$ke.fromString(JSON.stringify(J));re.write(R.Object),d(re,ae.byteLength),re.write(ae)}}t.$Hh=z;function y(re){switch(re.read(1).readUInt8(0)){case N.Undefined:return;case N.String:return re.read(a(re)).toString();case N.Buffer:return re.read(a(re)).buffer;case N.VSBuffer:return re.read(a(re));case N.Array:{const ae=a(re),se=[];for(let Y=0;Y<ae;Y++)se.push(y(re));return se}case N.Object:return JSON.parse(re.read(a(re)).toString());case N.Int:return a(re)}}t.$Ih=y;class O{constructor(J,ae,se=null,Y=1e3){this.h=J,this.j=ae,this.k=se,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(K=>this.q(K)),this.m({type:200})}registerChannel(J,ae){this.b.set(J,ae),setTimeout(()=>this.w(J),0)}m(J){switch(J.type){case 200:{const ae=this.o([J.type]);this.k?.logOutgoing(ae,0,1,f(J.type));return}case 201:case 202:case 204:case 203:{const ae=this.o([J.type,J.id],J.data);this.k?.logOutgoing(ae,J.id,1,f(J.type),J.data);return}}}o(J,ae=void 0){const se=new u;return z(se,J),z(se,ae),this.p(se.buffer)}p(J){try{return this.h.send(J),J.byteLength}catch{return 0}}q(J){const ae=new b(J),se=y(ae),Y=y(ae),K=se[0];switch(K){case 100:return this.k?.logIncoming(J.byteLength,se[1],1,`${e(K)}: ${se[2]}.${se[3]}`,Y),this.s({type:K,id:se[1],channelName:se[2],name:se[3],arg:Y});case 102:return this.k?.logIncoming(J.byteLength,se[1],1,`${e(K)}: ${se[2]}.${se[3]}`,Y),this.t({type:K,id:se[1],channelName:se[2],name:se[3],arg:Y});case 101:return this.k?.logIncoming(J.byteLength,se[1],1,`${e(K)}`),this.u({type:K,id:se[1]});case 103:return this.k?.logIncoming(J.byteLength,se[1],1,`${e(K)}`),this.u({type:K,id:se[1]})}}s(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const se=new H.$7d;let Y;try{Y=ae.call(this.j,J.name,J.arg,se.token)}catch(fe){Y=Promise.reject(fe)}const K=J.id;Y.then(fe=>{this.m({id:K,data:fe,type:201})},fe=>{fe instanceof Error?this.m({id:K,data:{message:fe.message,name:fe.name,stack:fe.stack?fe.stack.split?fe.stack.split(`
`):fe.stack:void 0},type:202}):this.m({id:K,data:fe,type:203})}).finally(()=>{ie.dispose(),this.d.delete(J.id)});const ie=(0,p.$Rc)(()=>se.cancel());this.d.set(J.id,ie)}t(J){const ae=this.b.get(J.channelName);if(!ae){this.v(J);return}const se=J.id,K=ae.listen(this.j,J.name,J.arg)(ie=>this.m({id:se,data:ie,type:204}));this.d.set(J.id,K)}u(J){const ae=this.d.get(J.id);ae&&(ae.dispose(),this.d.delete(J.id))}v(J){let ae=this.g.get(J.channelName);ae||(ae=[],this.g.set(J.channelName,ae));const se=setTimeout(()=>{console.error(`Unknown channel: ${J.channelName}`),J.type===100&&this.m({id:J.id,data:{name:"Unknown channel",message:`Channel name '${J.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ae.push({request:J,timeoutTimer:se})}w(J){const ae=this.g.get(J);if(ae){for(const se of ae)switch(clearTimeout(se.timeoutTimer),se.request.type){case 100:this.s(se.request);break;case 102:this.t(se.request);break}this.g.delete(J)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}t.$Jh=O;var U;(function(re){re[re.LocalSide=0]="LocalSide",re[re.OtherSide=1]="OtherSide"})(U||(t.RequestInitiator=U={}));class S{constructor(J,ae=null){this.l=J,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new m.$Wd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(se=>this.s(se)),this.j=ae}getChannel(J){const ae=this;return{call(se,Y,K){return ae.a?Promise.reject(new k.$5):ae.m(J,se,Y,K)},listen(se,Y){return ae.a?m.Event.None:ae.o(J,se,Y)}}}m(J,ae,se,Y=H.CancellationToken.None){const K=this.g++,fe={id:K,type:100,channelName:J,name:ae,arg:se};if(Y.isCancellationRequested)return Promise.reject(new k.$5);let De;return new Promise((Se,_)=>{if(Y.isCancellationRequested)return _(new k.$5);const g=()=>{const i=o=>{switch(o.type){case 201:this.f.delete(K),Se(o.data);break;case 202:{this.f.delete(K);const w=new Error(o.data.message);w.stack=Array.isArray(o.data.stack)?o.data.stack.join(`
`):o.data.stack,w.name=o.data.name,_(w);break}case 203:this.f.delete(K),_(o.data);break}};this.f.set(K,i),this.p(fe)};let A=null;this.b===c.Idle?g():(A=(0,C.$Ug)(i=>this.u()),A.then(()=>{A=null,g()}));const F=()=>{A?(A.cancel(),A=null):this.p({id:K,type:101}),_(new k.$5)},r=Y.onCancellationRequested(F);De=(0,p.$Qc)((0,p.$Rc)(F),r),this.d.add(De)}).finally(()=>{De.dispose(),this.d.delete(De)})}o(J,ae,se){const Y=this.g++,ie={id:Y,type:102,channelName:J,name:ae,arg:se};let fe=null;const De=new m.$Wd({onWillAddFirstListener:()=>{fe=(0,C.$Ug)(Se=>this.u()),fe.then(()=>{fe=null,this.d.add(De),this.p(ie)})},onDidRemoveLastListener:()=>{fe?(fe.cancel(),fe=null):(this.d.delete(De),this.p({id:Y,type:103}))}}),Te=Se=>De.fire(Se.data);return this.f.set(Y,Te),De.event}p(J){switch(J.type){case 100:case 102:{const ae=this.q([J.type,J.id,J.channelName,J.name],J.arg);this.j?.logOutgoing(ae,J.id,0,`${e(J.type)}: ${J.channelName}.${J.name}`,J.arg);return}case 101:case 103:{const ae=this.q([J.type,J.id]);this.j?.logOutgoing(ae,J.id,0,e(J.type));return}}}q(J,ae=void 0){const se=new u;return z(se,J),z(se,ae),this.r(se.buffer)}r(J){try{return this.l.send(J),J.byteLength}catch{return 0}}s(J){const ae=new b(J),se=y(ae),Y=y(ae),K=se[0];switch(K){case 200:return this.j?.logIncoming(J.byteLength,0,0,f(K)),this.t({type:se[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(J.byteLength,se[1],0,f(K),Y),this.t({type:se[0],id:se[1],data:Y})}}t(J){if(J.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(J.id)?.(J)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.$Oc)(this.d.values()),this.d.clear()}}t.$Kh=S,Ye([D.$zh],S.prototype,"onDidInitializePromise",null);class P{get connections(){const J=[];return this.f.forEach(ae=>J.push(ae)),J}constructor(J){this.a=new Map,this.f=new Set,this.g=new m.$Wd,this.onDidAddConnection=this.g.event,this.h=new m.$Wd,this.onDidRemoveConnection=this.h.event,this.j=new p.$Sc,this.j.add(J(({protocol:ae,onDidClientDisconnect:se})=>{const Y=m.Event.once(ae.onMessage);this.j.add(Y(K=>{const ie=new b(K),fe=y(ie),De=new O(ae,fe),Te=new S(ae);this.a.forEach((_,g)=>De.registerChannel(g,_));const Se={channelServer:De,channelClient:Te,ctx:fe};this.f.add(Se),this.g.fire(Se),this.j.add(se(()=>{De.dispose(),Te.dispose(),this.f.delete(Se),this.h.fire(Se)}))}))}))}getChannel(J,ae){const se=this;return{call(Y,K,ie){let fe;if((0,l.$Xf)(ae)){const Te=(0,E.$4b)(se.connections.filter(ae));fe=Te?Promise.resolve(Te):m.Event.toPromise(m.Event.filter(se.onDidAddConnection,ae))}else fe=ae.routeCall(se,Y,K);const De=fe.then(Te=>Te.channelClient.getChannel(J));return G(De).call(Y,K,ie)},listen(Y,K){if((0,l.$Xf)(ae))return se.k(J,ae,Y,K);const ie=ae.routeEvent(se,Y,K).then(fe=>fe.channelClient.getChannel(J));return G(ie).listen(Y,K)}}}k(J,ae,se,Y){const K=this;let ie;const fe=new m.$Wd({onWillAddFirstListener:()=>{ie=new p.$Sc;const De=new m.$3d,Te=new Map,Se=g=>{const F=g.channelClient.getChannel(J).listen(se,Y),r=De.add(F);Te.set(g,r)},_=g=>{const A=Te.get(g);A&&(A.dispose(),Te.delete(g))};K.connections.filter(ae).forEach(Se),m.Event.filter(K.onDidAddConnection,ae)(Se,void 0,ie),K.onDidRemoveConnection(_,void 0,ie),De.event(fe.fire,fe,ie),ie.add(De)},onDidRemoveLastListener:()=>{ie?.dispose(),ie=void 0}});return fe.event}registerChannel(J,ae){this.a.set(J,ae);for(const se of this.f)se.channelServer.registerChannel(J,ae)}dispose(){this.j.dispose();for(const J of this.f)J.channelClient.dispose(),J.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$Lh=P;class L{constructor(J,ae,se=null){const Y=new u;z(Y,ae),J.send(Y.buffer),this.a=new S(J,se),this.d=new O(J,ae,se)}getChannel(J){return this.a.getChannel(J)}registerChannel(J,ae){this.d.registerChannel(J,ae)}dispose(){this.a.dispose(),this.d.dispose()}}t.$Mh=L;function G(re){return{call(J,ae,se){return re.then(Y=>Y.call(J,ae,se))},listen(J,ae){const se=new m.$6d;return re.then(Y=>se.input=Y.listen(J,ae)),se.event}}}t.$Nh=G;function Z(re){let J=!1;return{call(ae,se,Y){return J?re.call(ae,se,Y):(0,C.$9g)(0).then(()=>J=!0).then(()=>re.call(ae,se,Y))},listen(ae,se){if(J)return re.listen(ae,se);const Y=new m.$6d;return(0,C.$9g)(0).then(()=>J=!0).then(()=>Y.input=re.listen(ae,se)),Y.event}}}t.$Oh=Z;class ge{constructor(J){this.a=J}routeCall(J){return this.b(J)}routeEvent(J){return this.b(J)}async b(J){for(const ae of J.connections)if(await Promise.resolve(this.a(ae.ctx)))return Promise.resolve(ae);return await m.Event.toPromise(J.onDidAddConnection),await this.b(J)}}t.$Ph=ge;var ue;(function(re){function J(K,ie,fe){const De=K,Te=fe&&fe.disableMarshalling,Se=new Map;for(const _ in De)se(_)&&Se.set(_,m.Event.buffer(De[_],!0,void 0,ie));return new class{listen(_,g,A){const F=Se.get(g);if(F)return F;if(Y(g)){const r=De[g];if(typeof r=="function")return r.call(De,A)}throw new k.$bb(`Event not found: ${g}`)}call(_,g,A){const F=De[g];if(typeof F=="function"){if(!Te&&Array.isArray(A))for(let i=0;i<A.length;i++)A[i]=(0,v.$Eh)(A[i]);let r=F.apply(De,A);return r instanceof Promise||(r=Promise.resolve(r)),r}throw new k.$bb(`Method not found: ${g}`)}}}re.fromService=J;function ae(K,ie){const fe=ie&&ie.disableMarshalling;return new Proxy({},{get(De,Te){if(typeof Te=="string")return ie?.properties?.has(Te)?ie.properties.get(Te):Y(Te)?function(Se){return K.listen(Te,Se)}:se(Te)?K.listen(Te):async function(...Se){let _;ie&&!(0,l.$Sf)(ie.context)?_=[ie.context,...Se]:_=Se;const g=await K.call(Te,_);return fe?g:(0,v.$Eh)(g)};throw new k.$bb(`Property not found: ${String(Te)}`)}})}re.toService=ae;function se(K){return K[0]==="o"&&K[1]==="n"&&M.$_e(K.charCodeAt(2))}function Y(K){return/^onDynamic/.test(K)&&M.$_e(K.charCodeAt(9))}})(ue||(t.ProxyChannel=ue={}));const te=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function me(re){if(Array.isArray(re))return re;if(re&&typeof re=="object"&&typeof re.toString=="function"){const J=re.toString();if(J!=="[object Object]")return J}return re}function Re(re){return Array.isArray(re)?re.map(me):me(re)}function Ne(re,J,ae,se,Y,K,ie){ie=Re(ie);const fe=te[Y],De=fe[se%fe.length];let Te=[`%c[${re}]%c[${String(J).padStart(7," ")}]%c[len: ${String(ae).padStart(5," ")}]%c${String(se).padStart(5," ")} - ${K}`,"color: darkgreen","color: grey","color: grey",`color: ${De}`];/\($/.test(K)?(Te=Te.concat(ie),Te.push(")")):Te.push(ie),console.log.apply(console,Te)}class Be{constructor(J,ae){this.d=J,this.f=ae,this.a=0,this.b=0}logOutgoing(J,ae,se,Y,K){this.b+=J,Ne(this.d,this.b,J,ae,se,Y,K)}logIncoming(J,ae,se,Y,K){this.a+=J,Ne(this.f,this.a,J,ae,se,Y,K)}}t.$Qh=Be}),define($e[134],pe([1,0,34,4,67,90,30]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2U=void 0;class k extends n.$Mh{static f(){const p=C.Event.fromNodeEventEmitter(D.$O,"vscode:message",(v,M)=>E.$ke.wrap(M));return D.$O.send("vscode:hello"),new H.$XU(D.$O,p)}constructor(p){const v=k.f();super(v,p),this.b=v}dispose(){this.b.disconnect(),super.dispose()}}t.$2U=k}),define($e[135],pe([13,11]),function(ne,t){return ne.create("vs/platform/files/common/files",t)}),define($e[136],pe([13,11]),function(ne,t){return ne.create("vs/platform/theme/common/iconRegistry",t)}),define($e[41],pe([1,0]),function(ne,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$9h=t.$8h=t.$7h=t._util=void 0;var E;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function k(m){return m[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=k})(E||(t._util=E={})),t.$7h=n("instantiationService");function C(D,k,m){k[E.DI_TARGET]===k?k[E.DI_DEPENDENCIES].push({id:D,index:m}):(k[E.DI_DEPENDENCIES]=[{id:D,index:m}],k[E.DI_TARGET]=k)}function n(D){if(E.serviceIds.has(D))return E.serviceIds.get(D);const k=function(m,p,v){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(k,m,v)};return k.toString=()=>D,E.serviceIds.set(D,k),k}t.$8h=n;function H(D){return D}t.$9h=H}),define($e[137],pe([1,0,41]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Nm=t.$Mm=t.$Lm=t.ID=void 0,t.ID="diagnosticsService",t.$Lm=(0,E.$8h)(t.ID);function C(H){return!!H.hostName&&!!H.errorMessage}t.$Mm=C;class n{async getPerformanceInfo(D,k){return{}}async getSystemInfo(D,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,k){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}t.$Nm=n}),define($e[138],pe([1,0,88,24,10,7,15,135,41,5,31,23]),function(ne,t,E,C,n,H,D,k,m,p,v,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2k=t.$1k=t.$Zk=t.$Yk=t.$Xk=t.FileKind=t.$Wk=t.$Vk=t.$Uk=t.$Tk=t.$Sk=t.$Rk=t.$Qk=t.FileOperationResult=t.$Pk=t.$Ok=t.$Nk=t.$Mk=t.$Lk=t.FileChangeType=t.$Kk=t.FileOperation=t.$Jk=t.$Ik=t.$Hk=t.$Gk=t.$Fk=t.$Ek=t.FileSystemProviderErrorCode=t.$Dk=t.$Ck=t.$Bk=t.$Ak=t.$zk=t.$yk=t.$xk=t.$wk=t.$vk=t.FileSystemProviderCapabilities=t.$uk=t.FilePermission=t.FileType=t.$tk=t.$sk=void 0,t.$sk=(0,m.$8h)("fileService");function l(Y){return Y.create===!0}t.$tk=l;var h;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(h||(t.FileType=h={}));var e;(function(Y){Y[Y.Readonly=1]="Readonly",Y[Y.Locked=2]="Locked"})(e||(t.FilePermission=e={}));function s(Y){const K=Y;return!!K&&typeof K.onDidChange=="function"}t.$uk=s;var f;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileAtomicWrite=32768]="FileAtomicWrite",Y[Y.FileAtomicDelete=65536]="FileAtomicDelete",Y[Y.FileClone=131072]="FileClone"})(f||(t.FileSystemProviderCapabilities=f={}));function c(Y){return!!(Y.capabilities&2)}t.$vk=c;function a(Y){return!!(Y.capabilities&8)}t.$wk=a;function $(Y){return!!(Y.capabilities&131072)}t.$xk=$;function d(Y){return!!(Y.capabilities&4)}t.$yk=d;function b(Y){return!!(Y.capabilities&16)}t.$zk=b;function u(Y){return c(Y)?!!(Y.capabilities&16384):!1}t.$Ak=u;function N(Y){return c(Y)?!!(Y.capabilities&32768):!1}t.$Bk=N;function B(Y){return!!(Y.capabilities&65536)}t.$Ck=B;function R(Y){return!!(Y.capabilities&2048)}t.$Dk=R;var W;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(W||(t.FileSystemProviderErrorCode=W={}));class z extends Error{static create(K,ie){const fe=new z(K.toString(),ie);return U(fe,ie),fe}constructor(K,ie){super(K),this.code=ie}}t.$Ek=z;function y(Y,K){return z.create(Y,K)}t.$Fk=y;function O(Y){return Y||y((0,k.localize)(0,null),W.Unknown)}t.$Gk=O;function U(Y,K){return Y.name=K?`${K} (FileSystemError)`:"FileSystemError",Y}t.$Hk=U;function S(Y){if(!Y)return W.Unknown;if(Y instanceof z)return Y.code;const K=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!K)return W.Unknown;switch(K[1]){case W.FileExists:return W.FileExists;case W.FileIsADirectory:return W.FileIsADirectory;case W.FileNotADirectory:return W.FileNotADirectory;case W.FileNotFound:return W.FileNotFound;case W.FileTooLarge:return W.FileTooLarge;case W.FileWriteLocked:return W.FileWriteLocked;case W.NoPermissions:return W.NoPermissions;case W.Unavailable:return W.Unavailable}return W.Unknown}t.$Ik=S;function P(Y){if(Y instanceof te)return Y.fileOperationResult;switch(S(Y)){case W.FileNotFound:return 1;case W.FileIsADirectory:return 0;case W.FileNotADirectory:return 9;case W.FileWriteLocked:return 5;case W.NoPermissions:return 6;case W.FileExists:return 4;case W.FileTooLarge:return 7;default:return 10}}t.$Jk=P;var L;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(L||(t.FileOperation=L={}));class G{constructor(K,ie,fe){this.resource=K,this.operation=ie,this.target=fe}isOperation(K){return this.operation===K}}t.$Kk=G;var Z;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(Z||(t.FileChangeType=Z={}));class ge{static{this.a=null}constructor(K,ie){this.c=ie,this.b=void 0,this.d=new M.$V(()=>{const fe=E.$bi.forUris(()=>this.c);return fe.fill(this.rawAdded.map(De=>[De,!0])),fe}),this.f=new M.$V(()=>{const fe=E.$bi.forUris(()=>this.c);return fe.fill(this.rawUpdated.map(De=>[De,!0])),fe}),this.g=new M.$V(()=>{const fe=E.$bi.forUris(()=>this.c);return fe.fill(this.rawDeleted.map(De=>[De,!0])),fe}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const fe of K){switch(fe.type){case 1:this.rawAdded.push(fe.resource);break;case 0:this.rawUpdated.push(fe.resource);break;case 2:this.rawDeleted.push(fe.resource);break}this.b!==ge.a&&(typeof fe.cId=="number"?this.b===void 0?this.b=fe.cId:this.b!==fe.cId&&(this.b=ge.a):this.b!==void 0&&(this.b=ge.a))}}contains(K,...ie){return this.h(K,{includeChildren:!1},...ie)}affects(K,...ie){return this.h(K,{includeChildren:!0},...ie)}h(K,ie,...fe){if(!K)return!1;const De=fe.length>0;return!!((!De||fe.includes(1))&&(this.d.value.get(K)||ie.includeChildren&&this.d.value.findSuperstr(K))||(!De||fe.includes(0))&&(this.f.value.get(K)||ie.includeChildren&&this.f.value.findSuperstr(K))||(!De||fe.includes(2))&&(this.g.value.findSubstr(K)||ie.includeChildren&&this.g.value.findSuperstr(K)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(K){return this.b===K}hasCorrelation(){return typeof this.b=="number"}}t.$Lk=ge;function ue(Y,K,ie){return!Y||!K||Y===K||K.length>Y.length?!1:(K.charAt(K.length-1)!==C.sep&&(K+=C.sep),ie?(0,n.$bf)(Y,K):Y.indexOf(K)===0)}t.$Mk=ue;class te extends Error{constructor(K,ie,fe){super(K),this.fileOperationResult=ie,this.options=fe}}t.$Nk=te;class me extends te{constructor(K,ie,fe,De){super(K,ie,De),this.fileOperationResult=ie,this.size=fe}}t.$Ok=me;class Re extends te{constructor(K,ie,fe){super(K,2,fe),this.stat=ie}}t.$Pk=Re;var Ne;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Ne||(t.FileOperationResult=Ne={})),t.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$Sk="files.associations",t.$Tk="files.exclude",t.$Uk="files.readonlyInclude",t.$Vk="files.readonlyExclude",t.$Wk="files.readonlyFromPermissions";var Be;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(Be||(t.FileKind=Be={})),t.$Xk="";function re(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}t.$Yk=re;async function J(Y,K){if(!K.hasProvider(D.URI.from({scheme:Y.scheme})))return new Promise(ie=>{const fe=K.onDidChangeFileSystemProviderRegistrations(De=>{De.scheme===Y.scheme&&De.added&&(fe.dispose(),ie())})})}t.$Zk=J;class ae{static{this.KB=1024}static{this.MB=ae.KB*ae.KB}static{this.GB=ae.MB*ae.KB}static{this.TB=ae.GB*ae.KB}static formatSize(K){return(0,H.$Nf)(K)||(K=0),K<ae.KB?(0,k.localize)(1,null,K.toFixed(0)):K<ae.MB?(0,k.localize)(2,null,(K/ae.KB).toFixed(2)):K<ae.GB?(0,k.localize)(3,null,(K/ae.MB).toFixed(2)):K<ae.TB?(0,k.localize)(4,null,(K/ae.GB).toFixed(2)):(0,k.localize)(5,null,(K/ae.TB).toFixed(2))}}t.$1k=ae;function se(Y){const K=typeof Y=="string"||Y?.scheme===v.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===v.Schemas.file?1024*ae.MB:K?10*ae.MB:p.$o?50*ae.MB:1024*ae.MB}t.$2k=se}),define($e[139],pe([1,0,41]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$p_b=t.$o_b=void 0,t.$o_b=(0,E.$8h)("mainProcessService");class C{constructor(H,D){this.a=H,this.b=D}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,D){this.a.registerChannel(H,D)}}t.$p_b=C}),define($e[140],pe([1,0,3,134]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$q_b=void 0;class n extends E.$Tc{constructor(D){super(),this.a=this.B(new C.$2U(`window:${D}`))}getChannel(D){return this.a.getChannel(D)}registerChannel(D,k){this.a.registerChannel(D,k)}}t.$q_b=n});var Ei=this&&this.__param||function(ne,t){return function(E,C){t(E,C,ne)}};define($e[141],pe([1,0,67,139]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$u_b=void 0;let n=class{constructor(D,k){return this.windowId=D,E.ProxyChannel.toService(k.getChannel("nativeHost"),{context:D,properties:(()=>{const m=new Map;return m.set("windowId",D),m})()})}};t.$u_b=n,t.$u_b=n=Ye([Ei(1,C.$o_b)],n)}),define($e[68],pe([1,0,76,7]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kn=void 0;class n{constructor(){this.a=new Map}add(D,k){E.ok(C.$Jf(D)),E.ok(C.$Lf(k)),E.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,k)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}t.$Kn=new n}),define($e[142],pe([1,0,4,68]),function(ne,t,E,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ln=void 0,t.$Ln={JSONContribution:"base.contributions.json"};function n(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class H{constructor(){this.b=new E.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,p){this.a[n(m)]=p,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const D=new H;C.$Kn.add(t.$Ln.JSONContribution,D)}),define($e[143],pe([1,0,9,17,18,4,7,15,136,142,68]),function(ne,t,E,C,n,H,D,k,m,p,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gw=t.$Fw=t.$Ew=t.$Dw=t.$Cw=t.$Bw=t.$Aw=t.$zw=t.IconFontDefinition=t.IconContribution=t.$yw=void 0,t.$yw={IconContribution:"base.contributions.icons"};var M;(function(d){function b(u,N){let B=u.defaults;for(;n.ThemeIcon.isThemeIcon(B);){const R=e.getIcon(B.id);if(!R)return;B=R.defaults}return B}d.getDefinition=b})(M||(t.IconContribution=M={}));var l;(function(d){function b(N){return{weight:N.weight,style:N.style,src:N.src.map(B=>({format:B.format,location:B.location.toString()}))}}d.toJSONObject=b;function u(N){const B=R=>(0,D.$Jf)(R)?R:void 0;if(N&&Array.isArray(N.src)&&N.src.every(R=>(0,D.$Jf)(R.format)&&(0,D.$Jf)(R.location)))return{weight:B(N.weight),style:B(N.style),src:N.src.map(R=>({format:R.format,location:k.URI.parse(R.location)}))}}d.fromJSONObject=u})(l||(t.IconFontDefinition=l={}));class h{constructor(){this.a=new H.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,m.localize)(0,null)},fontCharacter:{type:"string",description:(0,m.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${n.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(b,u,N,B){const R=this.b[b];if(R){if(N&&!R.description){R.description=N,this.d.properties[b].markdownDescription=`${N} $(${b})`;const y=this.e.enum.indexOf(b);y!==-1&&(this.e.enumDescriptions[y]=N),this.a.fire()}return R}const W={id:b,description:N,defaults:u,deprecationMessage:B};this.b[b]=W;const z={$ref:"#/definitions/icons"};return B&&(z.deprecationMessage=B),N&&(z.markdownDescription=`${N}: $(${b})`),this.d.properties[b]=z,this.e.enum.push(b),this.e.enumDescriptions.push(N||""),this.a.fire(),{id:b}}deregisterIcon(b){delete this.b[b],delete this.d.properties[b];const u=this.e.enum.indexOf(b);u!==-1&&(this.e.enum.splice(u,1),this.e.enumDescriptions.splice(u,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(b=>this.b[b])}getIcon(b){return this.b[b]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(b,u){const N=this.f[b];return N||(this.f[b]=u,this.a.fire(),u)}deregisterIconFont(b){delete this.f[b]}getIconFont(b){return this.f[b]}toString(){const b=(R,W)=>R.id.localeCompare(W.id),u=R=>{for(;n.ThemeIcon.isThemeIcon(R.defaults);)R=this.b[R.defaults.id];return`codicon codicon-${R?R.id:""}`},N=[];N.push("| preview     | identifier                        | default codicon ID                | description"),N.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const B=Object.keys(this.b).map(R=>this.b[R]);for(const R of B.filter(W=>!!W.description).sort(b))N.push(`|<i class="${u(R)}"></i>|${R.id}|${n.ThemeIcon.isThemeIcon(R.defaults)?R.defaults.id:R.id}|${R.description||""}|`);N.push("| preview     | identifier                        "),N.push("| ----------- | --------------------------------- |");for(const R of B.filter(W=>!n.ThemeIcon.isThemeIcon(W.defaults)).sort(b))N.push(`|<i class="${u(R)}"></i>|${R.id}|`);return N.join(`
`)}}const e=new h;v.$Kn.add(t.$yw.IconContribution,e);function s(d,b,u,N){return e.registerIcon(d,b,u,N)}t.$zw=s;function f(){return e}t.$Aw=f;function c(){const d=(0,C.$_j)();for(const b in d){const u="\\"+d[b].toString(16);e.registerIcon(b,{fontCharacter:u})}}c(),t.$Bw="vscode://schemas/icons";const a=v.$Kn.as(p.$Ln.JSONContribution);a.registerSchema(t.$Bw,e.getIconSchema());const $=new E.$hh(()=>a.notifySchemaChanged(t.$Bw),200);e.onDidChange(()=>{$.isScheduled()||$.schedule()}),t.$Cw=s("widget-close",C.$bk.close,(0,m.localize)(2,null)),t.$Dw=s("goto-previous-location",C.$bk.arrowUp,(0,m.localize)(3,null)),t.$Ew=s("goto-next-location",C.$bk.arrowDown,(0,m.localize)(4,null)),t.$Fw=n.ThemeIcon.modify(C.$bk.sync,"spin"),t.$Gw=n.ThemeIcon.modify(C.$bk.loading,"spin")}),define($e[144],pe([1,0,2,4,3,18,143]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2Fb=t.$1Fb=void 0;function k(p){const v=new n.$Sc,M=v.add(new C.$Wd),l=(0,D.$Aw)();return v.add(l.onDidChange(()=>M.fire())),p&&v.add(p.onDidProductIconThemeChange(()=>M.fire())),{dispose:()=>v.dispose(),onDidChange:M.event,getCSS(){const h=p?p.getProductIconTheme():new m,e={},s=c=>{const a=h.getIcon(c);if(!a)return;const $=a.font;return $?(e[$.id]=$.definition,`.codicon-${c.id}:before { content: '${a.fontCharacter}'; font-family: ${(0,E.$fR)($.id)}; }`):`.codicon-${c.id}:before { content: '${a.fontCharacter}'; }`},f=[];for(const c of l.getIcons()){const a=s(c);a&&f.push(a)}for(const c in e){const a=e[c],$=a.weight?`font-weight: ${a.weight};`:"",d=a.style?`font-style: ${a.style};`:"",b=a.src.map(u=>`${(0,E.$eR)(u.location)} format('${u.format}')`).join(", ");f.push(`@font-face { src: ${b}; font-family: ${(0,E.$fR)(c)};${$}${d} font-display: block; }`)}return f.join(`
`)}}}t.$1Fb=k;class m{getIcon(v){const M=(0,D.$Aw)();let l=v.defaults;for(;H.ThemeIcon.isThemeIcon(l);){const h=M.getIcon(l.id);if(!h)return;l=h.defaults}return l}}t.$2Fb=m}),define($e[145],pe([1,0,5]),function(ne,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$1C=t.$ZC=t.$YC=t.$XC=t.$WC=t.$VC=t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$UC=t.$TC=t.$SC=t.$RC=t.$QC=t.$PC=void 0,t.$PC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(c){return typeof c.parentId=="number"}t.$QC=C;function n(c){return!!c.workspaceUri}t.$RC=n;function H(c){return!!c.folderUri}t.$SC=H;function D(c){return!!c.fileUri}t.$TC=D;function k(c){const a=l(c),$=c.getValue("window.menuBarVisibility");return $==="default"||a&&$==="compact"||E.$j&&E.$m?"classic":$}t.$UC=k;var m;(function(c){c.TITLE_BAR_STYLE="window.titleBarStyle",c.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(m||(t.TitleBarSetting=m={}));var p;(function(c){c.NATIVE="native",c.CUSTOM="custom"})(p||(t.TitlebarStyle=p={}));var v;(function(c){c.AUTO="auto",c.WINDOWED="windowed",c.NEVER="never"})(v||(t.CustomTitleBarVisibility=v={}));function M(c,a){return!0}t.$VC=M;function l(c,a){return a||(a=h(c)),a==="native"}t.$WC=l;function h(c){if(E.$o)return"custom";const a=c.getValue("window");if(a){if(E.$j&&a.nativeTabs===!0||E.$j&&a.nativeFullScreen===!1)return"native";const b=a.titleBarStyle;if(b==="native"||b==="custom")return b}return E.$k?"native":"custom"}t.$XC=h;function e(c){return!(!E.$i||E.$o||l(c))}t.$YC=e;function s(c){const a=c.getValue("window");return!a||typeof a.nativeFullScreen!="boolean"||a.nativeTabs?!0:a.nativeFullScreen!==!1}t.$ZC=s;function f(c=0){return Math.pow(1.2,c)}t.$1C=f}),define($e[146],pe([1,0,16,2,21,30,145]),function(ne,t,E,C,n,H,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$A_b=t.$z_b=t.$y_b=t.$x_b=t.$w_b=t.ApplyZoomTarget=void 0;var k;(function(l){l[l.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",l[l.ALL_WINDOWS=2]="ALL_WINDOWS"})(k||(t.ApplyZoomTarget=k={})),t.$w_b=8,t.$x_b=-8;function m(l,h){l=Math.min(Math.max(l,t.$x_b),t.$w_b);const e=[];h===k.ACTIVE_WINDOW?e.push((0,C.$EQ)()):h===k.ALL_WINDOWS?e.push(...Array.from((0,C.getWindows)()).map(({window:s})=>s)):e.push(h);for(const s of e)p(s)?.webFrame?.setZoomLevel(l),(0,E.$BP)((0,D.$1C)(l),s),(0,E.$xP)(l,s)}t.$y_b=m;function p(l){if(l===n.$sP)return{ipcRenderer:H.$O,webFrame:H.$Q};{const h=l;if(h?.vscode?.ipcRenderer&&h?.vscode?.webFrame)return h.vscode}}function v(l){m((0,E.$yP)(typeof l=="number"?(0,C.$EQ)():l)+1,l)}t.$z_b=v;function M(l){m((0,E.$yP)(typeof l=="number"?(0,C.$EQ)():l)-1,l)}t.$A_b=M}),define($e[147],pe([1,0,11,2,133,9,91,30,137,138,140,141,144,146,14,21,104,95]),function(ne,t,E,C,n,H,D,k,m,p,v,M,l,h,e,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const f=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,c=/\s--inspect-port=(?<port>\d+)/;class a{getHeight(S){return 22}getTemplateId(S){return W(S)?"process":B(S)?"machine":(0,m.$Mm)(S)?"error":R(S)?"header":""}}class ${hasChildren(S){return(0,m.$Mm)(S)?!1:W(S)?!!S.children?.length:!0}getChildren(S){return W(S)?S.children?S.children:[]:(0,m.$Mm)(S)?[]:R(S)?S.processRoots.length>1?S.processRoots:[S.processRoots[0].rootProcess]:B(S)?[S.rootProcess]:[S.processes]}}class d{constructor(){this.templateId="header"}renderTemplate(S){const P=(0,C.$1Q)(S,(0,C.$)(".row")),L=(0,C.$1Q)(P,(0,C.$)(".nameLabel")),G=(0,C.$1Q)(P,(0,C.$)(".cpu")),Z=(0,C.$1Q)(P,(0,C.$)(".memory")),ge=(0,C.$1Q)(P,(0,C.$)(".pid"));return{name:L,CPU:G,memory:Z,PID:ge}}renderElement(S,P,L,G){L.name.textContent=(0,E.localize)(0,null),L.CPU.textContent=(0,E.localize)(1,null),L.PID.textContent=(0,E.localize)(2,null),L.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(S){}}class b{constructor(){this.templateId="machine"}renderTemplate(S){const P=Object.create(null),L=(0,C.$1Q)(S,(0,C.$)(".row"));return P.name=(0,C.$1Q)(L,(0,C.$)(".nameLabel")),P}renderElement(S,P,L,G){L.name.textContent=S.element.name}disposeTemplate(S){}}class u{constructor(){this.templateId="error"}renderTemplate(S){const P=Object.create(null),L=(0,C.$1Q)(S,(0,C.$)(".row"));return P.name=(0,C.$1Q)(L,(0,C.$)(".nameLabel")),P}renderElement(S,P,L,G){L.name.textContent=S.element.errorMessage}disposeTemplate(S){}}class N{constructor(S,P,L){this.a=S,this.b=P,this.c=L,this.templateId="process"}renderTemplate(S){const P=(0,C.$1Q)(S,(0,C.$)(".row")),L=(0,C.$1Q)(P,(0,C.$)(".nameLabel")),G=(0,C.$1Q)(P,(0,C.$)(".cpu")),Z=(0,C.$1Q)(P,(0,C.$)(".memory")),ge=(0,C.$1Q)(P,(0,C.$)(".pid"));return{name:L,CPU:G,PID:ge,memory:Z}}renderElement(S,P,L,G){const{element:Z}=S,ge=Z.pid.toFixed(0);let ue=Z.name;this.c.has(Z.pid)&&(ue=this.c.get(Z.pid)),L.name.textContent=ue,L.name.title=Z.cmd,L.CPU.textContent=Z.load.toFixed(0),L.PID.textContent=ge,L.PID.parentElement.id=`pid-${ge}`;const te=this.a==="win32"?Z.mem:this.b*(Z.mem/100);L.memory.textContent=(te/p.$1k.MB).toFixed(0)}disposeTemplate(S){}}function B(U){return!!U.name&&!!U.rootProcess}function R(U){return!!U.processRoots}function W(U){return!!U.pid}class z{constructor(S,P){this.f=P,this.b=new Map;const L=new v.$q_b(S);this.c=new M.$u_b(S,L),this.k(P.styles),this.g(P),k.$O.on("vscode:pidToNameResponse",(G,Z)=>{this.b.clear();for(const[ge,ue]of Z)this.b.set(ge,ue)}),k.$O.on("vscode:listProcessesResponse",async(G,Z)=>{Z.forEach((ge,ue)=>{W(ge.rootProcess)&&(ge.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:Z}}),this.d.layout(s.$sP.innerHeight,s.$sP.innerWidth)):await this.h(Z),this.m(0)}),this.a=Date.now(),k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")}g(S){s.$sP.document.onkeydown=P=>{const L=S.platform==="darwin"?P.metaKey:P.ctrlKey;L&&P.keyCode===87&&(P.stopPropagation(),P.preventDefault(),k.$O.send("vscode:closeProcessExplorer")),L&&P.keyCode===187&&(0,h.$z_b)(s.$sP),L&&P.keyCode===189&&(0,h.$A_b)(s.$sP)}}async h(S){const P=s.$sP.document.getElementById("process-list");if(!P)return;const{totalmem:L}=await this.c.getOSStatistics(),G=[new N(this.f.platform,L,this.b),new d,new b,new u];this.d=new n.$rU("processExplorer",P,new a,G,new $,{identityProvider:{getId:Z=>W(Z)?Z.pid.toString():(0,m.$Mm)(Z)?Z.hostName:R(Z)?"processes":B(Z)?Z.name:"header"}}),this.d.setInput({processes:{processRoots:S}}),this.d.layout(s.$sP.innerHeight,s.$sP.innerWidth),this.d.onKeyDown(Z=>{const ge=new e.$WP(Z);if(ge.keyCode===35&&ge.altKey){const ue=this.n();Promise.all(ue.map(te=>this.c.killProcess(te,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(Z=>{W(Z.element)&&this.l(Z.element,!0)}),P.style.height=`${s.$sP.innerHeight}px`,s.$sP.addEventListener("resize",()=>{P.style.height=`${s.$sP.innerHeight}px`,this.d?.layout(s.$sP.innerHeight,s.$sP.innerWidth)})}i(S){const P=f.exec(S);return P&&P.groups.port!=="0"||S.indexOf("node ")>=0||S.indexOf("node.exe")>=0}j(S){const P={type:"node",request:"attach",name:`process ${S.pid}`};let L=f.exec(S.cmd);L?P.port=Number(L.groups.port):P.processId=String(S.pid),L=c.exec(S.cmd),L&&(P.port=Number(L.groups.port)),k.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[P]})}k(S){const P=(0,C.$IQ)(),L=[];S.listFocusBackground&&(L.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${S.listFocusBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${S.listFocusBackground}; }`)),S.listFocusForeground&&L.push(`.monaco-list:focus .monaco-list-row.focused { color: ${S.listFocusForeground}; }`),S.listActiveSelectionBackground&&(L.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${S.listActiveSelectionBackground}; }`),L.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${S.listActiveSelectionBackground}; }`)),S.listActiveSelectionForeground&&L.push(`.monaco-list:focus .monaco-list-row.selected { color: ${S.listActiveSelectionForeground}; }`),S.listHoverBackground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${S.listHoverBackground}; }`),S.listHoverForeground&&L.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${S.listHoverForeground}; }`),S.listFocusOutline&&L.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${S.listFocusOutline}; outline-offset: -1px; }`),S.listHoverOutline&&L.push(`.monaco-list-row:hover { outline: 1px dashed ${S.listHoverOutline}; outline-offset: -1px; }`),S.scrollbarShadowColor&&L.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${S.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${S.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${S.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),S.scrollbarSliderBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${S.scrollbarSliderBackgroundColor};
				}
			`),S.scrollbarSliderHoverBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${S.scrollbarSliderHoverBackgroundColor};
				}
			`),S.scrollbarSliderActiveBackgroundColor&&L.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${S.scrollbarSliderActiveBackgroundColor};
				}
			`),P.textContent=L.join(`
`),S.color&&(s.$sP.document.body.style.color=S.color)}l(S,P){const L=[],G=Number(S.pid);P&&(L.push({accelerator:"Alt+E",label:(0,E.localize)(4,null),click:()=>{this.c.killProcess(G,"SIGTERM")}}),L.push({label:(0,E.localize)(5,null),click:()=>{this.c.killProcess(G,"SIGKILL")}}),L.push({type:"separator"})),L.push({label:(0,E.localize)(6,null),click:()=>{const Z=this.n();Z?.includes(G)||(Z.length=0,Z.push(G));const ge=Z?.map(ue=>s.$sP.document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ge){const ue=ge.map(te=>te.innerText).filter(te=>!!te);this.c.writeClipboardText(ue.join(`
`))}}}),L.push({label:(0,E.localize)(7,null),click:()=>{const Z=s.$sP.document.getElementById("process-list");Z&&this.c.writeClipboardText(Z.innerText)}}),S&&P&&this.i(S.cmd)&&(L.push({type:"separator"}),L.push({label:(0,E.localize)(8,null),click:()=>{this.j(S)}})),(0,D.$TU)(L)}m(S){setTimeout(()=>{const P=Date.now(),L=S+P-this.a;this.a=P,L>1e3?(k.$O.send("vscode:pidToNameRequest"),k.$O.send("vscode:listProcesses")):this.m(L)},200)}n(){return this.d?.getSelection()?.map(S=>{if(!(!S||!("pid"in S)))return S.pid}).filter(S=>!!S)}}function y(){const U=(0,C.$IQ)();U.id="codiconStyles";const S=(0,l.$1Fb)(void 0);function P(){U.textContent=S.getCSS()}const L=new H.$hh(P,0);S.onDidChange(()=>L.schedule()),L.schedule()}function O(U){const S=U.data.platform==="win32"?"windows":U.data.platform==="linux"?"linux":"mac";s.$sP.document.body.classList.add(S),y(),(0,h.$y_b)(U.data.zoomLevel,s.$sP),new z(U.windowId,U.data)}t.startup=O})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8fa84589eef3538dbc763ff98dc7d5a8a0c56374/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
