/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Re=["exports","require","vs/base/common/uri","vs/workbench/api/common/extHost.protocol","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/base/common/uuid","vs/base/common/glob","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/base/common/htmlContent","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(me){for(var e=[],S=0,M=me.length;S<M;S++)e[S]=Re[me[S]];return e};define(Re[67],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bh=e.$Ah=e.$zh=void 0;function S(L){return(m,d,y)=>{let A=null,k=null;if(typeof y.value=="function"?(A="value",k=y.value):typeof y.get=="function"&&(A="get",k=y.get),!k)throw new Error("not supported");y[A]=L(k,d)}}function M(L,m,d){let y=null,A=null;if(typeof d.value=="function"?(y="value",A=d.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(y="get",A=d.get),!A)throw new Error("not supported");const k=`$memoize$${m}`;d[y]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,l)}),this[k]}}e.$zh=M;function I(L,m,d){return S((y,A)=>{const k=`$debounce$${A}`,l=`$debounce$result$${A}`;return function(...$){this[l]||(this[l]=d?d():void 0),clearTimeout(this[k]),m&&(this[l]=m(this[l],...$),$=[this[l]]),this[k]=setTimeout(()=>{y.apply(this,$),this[l]=d?d():void 0},L)}})}e.$Ah=I;function R(L,m,d){return S((y,A)=>{const k=`$throttle$timer$${A}`,l=`$throttle$result$${A}`,$=`$throttle$lastRun$${A}`,p=`$throttle$pending$${A}`;return function(...r){if(this[l]||(this[l]=d?d():void 0),(this[$]===null||this[$]===void 0)&&(this[$]=-Number.MAX_VALUE),m&&(this[l]=m(this[l],...r)),this[p])return;const c=this[$]+L;c<=Date.now()?(this[$]=Date.now(),y.apply(this,[this[l]]),this[l]=d?d():void 0):(this[p]=!0,this[k]=setTimeout(()=>{this[p]=!1,this[$]=Date.now(),y.apply(this,[this[l]]),this[l]=d?d():void 0},c-Date.now()))}})}e.$Bh=R}),define(Re[88],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CN=e.$BN=void 0;class S{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.$BN=S,e.$CN=new S("id#")}),define(Re[119],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$on=e.$nn=e.$mn=e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var S;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var I;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function L(t,f=!1){let n=0;const w=t.length;let D="",h=0,b=16,P=0;function g(U){let C=0,F=0;for(;C<U;){const W=t.charCodeAt(n);if(W>=48&&W<=57)F=F*16+W-48;else if(W>=65&&W<=70)F=F*16+W-65+10;else if(W>=97&&W<=102)F=F*16+W-97+10;else break;n++,C++}return C<U&&(F=-1),F}function v(U){n=U,D="",h=0,b=16,P=0}function E(){const U=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&y(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&y(t.charCodeAt(n)))for(n++;n<t.length&&y(t.charCodeAt(n));)n++;else return P=3,t.substring(U,n);let C=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&y(t.charCodeAt(n))){for(n++;n<t.length&&y(t.charCodeAt(n));)n++;C=n}else P=3;return t.substring(U,C)}function T(){let U="",C=n;for(;;){if(n>=w){U+=t.substring(C,n),P=2;break}const F=t.charCodeAt(n);if(F===34){U+=t.substring(C,n),n++;break}if(F===92){if(U+=t.substring(C,n),n++,n>=w){P=2;break}switch(t.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const re=g(4);re>=0?U+=String.fromCharCode(re):P=4;break}default:P=5}C=n;continue}if(F>=0&&F<=31)if(d(F)){U+=t.substring(C,n),P=2;break}else P=6;n++}return U}function N(){if(D="",P=0,h=n,n>=w)return h=w,b=17;let U=t.charCodeAt(n);if(m(U)){do n++,D+=String.fromCharCode(U),U=t.charCodeAt(n);while(m(U));return b=15}if(d(U))return n++,D+=String.fromCharCode(U),U===13&&t.charCodeAt(n)===10&&(n++,D+=`
`),b=14;switch(U){case 123:return n++,b=1;case 125:return n++,b=2;case 91:return n++,b=3;case 93:return n++,b=4;case 58:return n++,b=6;case 44:return n++,b=5;case 34:return n++,D=T(),b=10;case 47:{const C=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<w&&!d(t.charCodeAt(n));)n++;return D=t.substring(C,n),b=12}if(t.charCodeAt(n+1)===42){n+=2;const F=w-1;let W=!1;for(;n<F;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,W=!0;break}n++}return W||(n++,P=1),D=t.substring(C,n),b=13}return D+=String.fromCharCode(U),n++,b=16}case 45:if(D+=String.fromCharCode(U),n++,n===w||!y(t.charCodeAt(n)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return D+=E(),b=11;default:for(;n<w&&J(U);)n++,U=t.charCodeAt(n);if(h!==n){switch(D=t.substring(h,n),D){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return D+=String.fromCharCode(U),n++,b=16}}function J(U){if(m(U)||d(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function q(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:v,getPosition:()=>n,scan:f?q:N,getToken:()=>b,getTokenValue:()=>D,getTokenOffset:()=>h,getTokenLength:()=>n-h,getTokenError:()=>P}}e.$dn=L;function m(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function d(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function k(t,f){const n=[],w=new Object;let D;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function P(g,v,E,T){h.value=g,h.offset=v,h.length=E,h.type=T,h.colonOffset=void 0,D=h}try{o(t,{onObjectBegin:(g,v)=>{if(f<=g)throw w;D=void 0,b=f>g,n.push("")},onObjectProperty:(g,v,E)=>{if(f<v||(P(g,v,E,"property"),n[n.length-1]=g,f<=v+E))throw w},onObjectEnd:(g,v)=>{if(f<=g)throw w;D=void 0,n.pop()},onArrayBegin:(g,v)=>{if(f<=g)throw w;D=void 0,n.push(0)},onArrayEnd:(g,v)=>{if(f<=g)throw w;D=void 0,n.pop()},onLiteralValue:(g,v,E)=>{if(f<v||(P(g,v,E,u(g)),f<=v+E))throw w},onSeparator:(g,v,E)=>{if(f<=v)throw w;if(g===":"&&D&&D.type==="property")D.colonOffset=v,b=!1,D=void 0;else if(g===","){const T=n[n.length-1];typeof T=="number"?n[n.length-1]=T+1:(b=!0,n[n.length-1]=""),D=void 0}}})}catch(g){if(g!==w)throw g}return{path:n,previousNode:D,isAtPropertyKey:b,matches:g=>{let v=0;for(let E=0;v<g.length&&E<n.length;E++)if(g[v]===n[E]||g[v]==="*")v++;else if(g[v]!=="**")return!1;return v===g.length}}}e.$en=k;function l(t,f=[],n=R.DEFAULT){let w=null,D=[];const h=[];function b(g){Array.isArray(D)?D.push(g):w!==null&&(D[w]=g)}return o(t,{onObjectBegin:()=>{const g={};b(g),h.push(D),D=g,w=null},onObjectProperty:g=>{w=g},onObjectEnd:()=>{D=h.pop()},onArrayBegin:()=>{const g=[];b(g),h.push(D),D=g,w=null},onArrayEnd:()=>{D=h.pop()},onLiteralValue:b,onError:(g,v,E)=>{f.push({error:g,offset:v,length:E})}},n),D[0]}e.$fn=l;function $(t,f=[],n=R.DEFAULT){let w={type:"array",offset:-1,length:-1,children:[],parent:void 0};function D(g){w.type==="property"&&(w.length=g-w.offset,w=w.parent)}function h(g){return w.children.push(g),g}o(t,{onObjectBegin:g=>{w=h({type:"object",offset:g,length:-1,parent:w,children:[]})},onObjectProperty:(g,v,E)=>{w=h({type:"property",offset:v,length:-1,parent:w,children:[]}),w.children.push({type:"string",value:g,offset:v,length:E,parent:w})},onObjectEnd:(g,v)=>{w.length=g+v-w.offset,w=w.parent,D(g+v)},onArrayBegin:(g,v)=>{w=h({type:"array",offset:g,length:-1,parent:w,children:[]})},onArrayEnd:(g,v)=>{w.length=g+v-w.offset,w=w.parent,D(g+v)},onLiteralValue:(g,v,E)=>{h({type:u(g),offset:v,length:E,parent:w,value:g}),D(v+E)},onSeparator:(g,v,E)=>{w.type==="property"&&(g===":"?w.colonOffset=v:g===","&&D(v))},onError:(g,v,E)=>{f.push({error:g,offset:v,length:E})}},n);const P=w.children[0];return P&&delete P.parent,P}e.$gn=$;function p(t,f){if(!t)return;let n=t;for(const w of f)if(typeof w=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let D=!1;for(const h of n.children)if(Array.isArray(h.children)&&h.children[0].value===w){n=h.children[1],D=!0;break}if(!D)return}else{const D=w;if(n.type!=="array"||D<0||!Array.isArray(n.children)||D>=n.children.length)return;n=n.children[D]}return n}e.$hn=p;function r(t){if(!t.parent||!t.parent.children)return[];const f=r(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;f.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&f.push(n)}return f}e.$in=r;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const f=Object.create(null);for(const n of t.children){const w=n.children[1];w&&(f[n.children[0].value]=c(w))}return f}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$jn=c;function s(t,f,n=!1){return f>=t.offset&&f<t.offset+t.length||n&&f===t.offset+t.length}e.$kn=s;function i(t,f,n=!1){if(s(t,f,n)){const w=t.children;if(Array.isArray(w))for(let D=0;D<w.length&&w[D].offset<=f;D++){const h=i(w[D],f,n);if(h)return h}return t}}e.$ln=i;function o(t,f,n=R.DEFAULT){const w=L(t,!1);function D(se){return se?()=>se(w.getTokenOffset(),w.getTokenLength()):()=>!0}function h(se){return se?$e=>se($e,w.getTokenOffset(),w.getTokenLength()):()=>!0}const b=D(f.onObjectBegin),P=h(f.onObjectProperty),g=D(f.onObjectEnd),v=D(f.onArrayBegin),E=D(f.onArrayEnd),T=h(f.onLiteralValue),N=h(f.onSeparator),J=D(f.onComment),q=h(f.onError),U=n&&n.disallowComments,C=n&&n.allowTrailingComma;function F(){for(;;){const se=w.scan();switch(w.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:U||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(se){case 12:case 13:U?W(10):J();break;case 16:W(1);break;case 15:case 14:break;default:return se}}}function W(se,$e=[],te=[]){if(q(se),$e.length+te.length>0){let X=w.getToken();for(;X!==17;){if($e.indexOf(X)!==-1){F();break}else if(te.indexOf(X)!==-1)break;X=F()}}}function re(se){const $e=w.getTokenValue();return se?T($e):P($e),F(),!0}function ce(){switch(w.getToken()){case 11:{let se=0;try{se=JSON.parse(w.getTokenValue()),typeof se!="number"&&(W(2),se=0)}catch{W(2)}T(se);break}case 7:T(null);break;case 8:T(!0);break;case 9:T(!1);break;default:return!1}return F(),!0}function we(){return w.getToken()!==10?(W(3,[],[2,5]),!1):(re(!1),w.getToken()===6?(N(":"),F(),ve()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function De(){b(),F();let se=!1;for(;w.getToken()!==2&&w.getToken()!==17;){if(w.getToken()===5){if(se||W(4,[],[]),N(","),F(),w.getToken()===2&&C)break}else se&&W(6,[],[]);we()||W(4,[],[2,5]),se=!0}return g(),w.getToken()!==2?W(7,[2],[]):F(),!0}function le(){v(),F();let se=!1;for(;w.getToken()!==4&&w.getToken()!==17;){if(w.getToken()===5){if(se||W(4,[],[]),N(","),F(),w.getToken()===4&&C)break}else se&&W(6,[],[]);ve()||W(4,[],[4,5]),se=!0}return E(),w.getToken()!==4?W(8,[4],[]):F(),!0}function ve(){switch(w.getToken()){case 3:return le();case 1:return De();case 10:return re(!0);default:return ce()}}return F(),w.getToken()===17?n.allowEmptyContent?!0:(W(4,[],[]),!1):ve()?(w.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.$mn=o;function a(t,f){const n=L(t),w=[];let D,h=0,b;do switch(b=n.getPosition(),D=n.scan(),D){case 12:case 13:case 17:h!==b&&w.push(t.substring(h,b)),f!==void 0&&w.push(n.getTokenValue().replace(/[^\r\n]/g,f)),h=n.getPosition();break}while(D!==17);return w.join("")}e.$nn=a;function u(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$on=u}),function(me,e){typeof define=="function"&&define.amd?define(Re[120],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(me=typeof globalThis<"u"?globalThis:me||self,e(me.marked={}))}(this,function(me){"use strict";function e(Pe,be){for(var ge=0;ge<be.length;ge++){var G=be[ge];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(Pe,G.key,G)}}function S(Pe,be,ge){return be&&e(Pe.prototype,be),ge&&e(Pe,ge),Object.defineProperty(Pe,"prototype",{writable:!1}),Pe}function M(Pe,be){if(Pe){if(typeof Pe=="string")return I(Pe,be);var ge=Object.prototype.toString.call(Pe).slice(8,-1);if(ge==="Object"&&Pe.constructor&&(ge=Pe.constructor.name),ge==="Map"||ge==="Set")return Array.from(Pe);if(ge==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ge))return I(Pe,be)}}function I(Pe,be){(be==null||be>Pe.length)&&(be=Pe.length);for(var ge=0,G=new Array(be);ge<be;ge++)G[ge]=Pe[ge];return G}function R(Pe,be){var ge=typeof Symbol<"u"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ge)return(ge=ge.call(Pe)).next.bind(ge);if(Array.isArray(Pe)||(ge=M(Pe))||be&&Pe&&typeof Pe.length=="number"){ge&&(Pe=ge);var G=0;return function(){return G>=Pe.length?{done:!0}:{done:!1,value:Pe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function L(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}me.defaults=L();function m(Pe){me.defaults=Pe}var d=/[&<>"']/,y=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},$=function(be){return l[be]};function p(Pe,be){if(be){if(d.test(Pe))return Pe.replace(y,$)}else if(A.test(Pe))return Pe.replace(k,$);return Pe}var r=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(Pe){return Pe.replace(r,function(be,ge){return ge=ge.toLowerCase(),ge==="colon"?":":ge.charAt(0)==="#"?ge.charAt(1)==="x"?String.fromCharCode(parseInt(ge.substring(2),16)):String.fromCharCode(+ge.substring(1)):""})}var s=/(^|[^\[])\^/g;function i(Pe,be){Pe=typeof Pe=="string"?Pe:Pe.source,be=be||"";var ge={replace:function(_,ue){return ue=ue.source||ue,ue=ue.replace(s,"$1"),Pe=Pe.replace(_,ue),ge},getRegex:function(){return new RegExp(Pe,be)}};return ge}var o=/[^\w:]/g,a=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(Pe,be,ge){if(Pe){var G;try{G=decodeURIComponent(c(ge)).replace(o,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}be&&!a.test(ge)&&(ge=D(be,ge));try{ge=encodeURI(ge).replace(/%25/g,"%")}catch{return null}return ge}var t={},f=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,w=/^([^:]+:\/*[^/]*)[\s\S]*$/;function D(Pe,be){t[" "+Pe]||(f.test(Pe)?t[" "+Pe]=Pe+"/":t[" "+Pe]=g(Pe,"/",!0)),Pe=t[" "+Pe];var ge=Pe.indexOf(":")===-1;return be.substring(0,2)==="//"?ge?be:Pe.replace(n,"$1")+be:be.charAt(0)==="/"?ge?be:Pe.replace(w,"$1")+be:Pe+be}var h={exec:function(){}};function b(Pe){for(var be=1,ge,G;be<arguments.length;be++){ge=arguments[be];for(G in ge)Object.prototype.hasOwnProperty.call(ge,G)&&(Pe[G]=ge[G])}return Pe}function P(Pe,be){var ge=Pe.replace(/\|/g,function(ue,de,Le){for(var fe=!1,ke=de;--ke>=0&&Le[ke]==="\\";)fe=!fe;return fe?"|":" |"}),G=ge.split(/ \|/),_=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>be)G.splice(be);else for(;G.length<be;)G.push("");for(;_<G.length;_++)G[_]=G[_].trim().replace(/\\\|/g,"|");return G}function g(Pe,be,ge){var G=Pe.length;if(G===0)return"";for(var _=0;_<G;){var ue=Pe.charAt(G-_-1);if(ue===be&&!ge)_++;else if(ue!==be&&ge)_++;else break}return Pe.slice(0,G-_)}function v(Pe,be){if(Pe.indexOf(be[1])===-1)return-1;for(var ge=Pe.length,G=0,_=0;_<ge;_++)if(Pe[_]==="\\")_++;else if(Pe[_]===be[0])G++;else if(Pe[_]===be[1]&&(G--,G<0))return _;return-1}function E(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(Pe,be){if(be<1)return"";for(var ge="";be>1;)be&1&&(ge+=Pe),be>>=1,Pe+=Pe;return ge+Pe}function N(Pe,be,ge,G){var _=be.href,ue=be.title?p(be.title):null,de=Pe[1].replace(/\\([\[\]])/g,"$1");if(Pe[0].charAt(0)!=="!"){G.state.inLink=!0;var Le={type:"link",raw:ge,href:_,title:ue,text:de,tokens:G.inlineTokens(de)};return G.state.inLink=!1,Le}return{type:"image",raw:ge,href:_,title:ue,text:p(de)}}function J(Pe,be){var ge=Pe.match(/^(\s+)(?:```)/);if(ge===null)return be;var G=ge[1];return be.split(`
`).map(function(_){var ue=_.match(/^\s+/);if(ue===null)return _;var de=ue[0];return de.length>=G.length?_.slice(G.length):_}).join(`
`)}var q=function(){function Pe(ge){this.options=ge||me.defaults}var be=Pe.prototype;return be.space=function(G){var _=this.rules.block.newline.exec(G);if(_&&_[0].length>0)return{type:"space",raw:_[0]}},be.code=function(G){var _=this.rules.block.code.exec(G);if(_){var ue=_[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:_[0],codeBlockStyle:"indented",text:this.options.pedantic?ue:g(ue,`
`)}}},be.fences=function(G){var _=this.rules.block.fences.exec(G);if(_){var ue=_[0],de=J(ue,_[3]||"");return{type:"code",raw:ue,lang:_[2]?_[2].trim():_[2],text:de}}},be.heading=function(G){var _=this.rules.block.heading.exec(G);if(_){var ue=_[2].trim();if(/#$/.test(ue)){var de=g(ue,"#");(this.options.pedantic||!de||/ $/.test(de))&&(ue=de.trim())}return{type:"heading",raw:_[0],depth:_[1].length,text:ue,tokens:this.lexer.inline(ue)}}},be.hr=function(G){var _=this.rules.block.hr.exec(G);if(_)return{type:"hr",raw:_[0]}},be.blockquote=function(G){var _=this.rules.block.blockquote.exec(G);if(_){var ue=_[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:_[0],tokens:this.lexer.blockTokens(ue,[]),text:ue}}},be.list=function(G){var _=this.rules.block.list.exec(G);if(_){var ue,de,Le,fe,ke,Ie,O,K,j,H,Z,oe,Ee=_[1].trim(),Be=Ee.length>1,We={type:"list",raw:"",ordered:Be,start:Be?+Ee.slice(0,-1):"",loose:!1,items:[]};Ee=Be?"\\d{1,9}\\"+Ee.slice(-1):"\\"+Ee,this.options.pedantic&&(Ee=Be?Ee:"[*+-]");for(var Ze=new RegExp("^( {0,3}"+Ee+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(oe=!1,!(!(_=Ze.exec(G))||this.rules.block.hr.test(G)));){if(ue=_[0],G=G.substring(ue.length),K=_[2].split(`
`,1)[0],j=G.split(`
`,1)[0],this.options.pedantic?(fe=2,Z=K.trimLeft()):(fe=_[2].search(/[^ ]/),fe=fe>4?1:fe,Z=K.slice(fe),fe+=_[1].length),Ie=!1,!K&&/^ *$/.test(j)&&(ue+=j+`
`,G=G.substring(j.length+1),oe=!0),!oe)for(var _e=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),at=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");G&&(H=G.split(`
`,1)[0],K=H,this.options.pedantic&&(K=K.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(K)||et.test(K)||_e.test(K)||at.test(G)));){if(K.search(/[^ ]/)>=fe||!K.trim())Z+=`
`+K.slice(fe);else if(!Ie)Z+=`
`+K;else break;!Ie&&!K.trim()&&(Ie=!0),ue+=H+`
`,G=G.substring(H.length+1)}We.loose||(O?We.loose=!0:/\n *\n *$/.test(ue)&&(O=!0)),this.options.gfm&&(de=/^\[[ xX]\] /.exec(Z),de&&(Le=de[0]!=="[ ] ",Z=Z.replace(/^\[[ xX]\] +/,""))),We.items.push({type:"list_item",raw:ue,task:!!de,checked:Le,loose:!1,text:Z}),We.raw+=ue}We.items[We.items.length-1].raw=ue.trimRight(),We.items[We.items.length-1].text=Z.trimRight(),We.raw=We.raw.trimRight();var ct=We.items.length;for(ke=0;ke<ct;ke++){this.lexer.state.top=!1,We.items[ke].tokens=this.lexer.blockTokens(We.items[ke].text,[]);var je=We.items[ke].tokens.filter(function(Y){return Y.type==="space"}),vt=je.every(function(Y){for(var x=Y.raw.split(""),pe=0,Ve=R(x),Qe;!(Qe=Ve()).done;){var nt=Qe.value;if(nt===`
`&&(pe+=1),pe>1)return!0}return!1});!We.loose&&je.length&&vt&&(We.loose=!0,We.items[ke].loose=!0)}return We}},be.html=function(G){var _=this.rules.block.html.exec(G);if(_){var ue={type:"html",raw:_[0],pre:!this.options.sanitizer&&(_[1]==="pre"||_[1]==="script"||_[1]==="style"),text:_[0]};if(this.options.sanitize){var de=this.options.sanitizer?this.options.sanitizer(_[0]):p(_[0]);ue.type="paragraph",ue.text=de,ue.tokens=this.lexer.inline(de)}return ue}},be.def=function(G){var _=this.rules.block.def.exec(G);if(_){_[3]&&(_[3]=_[3].substring(1,_[3].length-1));var ue=_[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ue,raw:_[0],href:_[2],title:_[3]}}},be.table=function(G){var _=this.rules.block.table.exec(G);if(_){var ue={type:"table",header:P(_[1]).map(function(O){return{text:O}}),align:_[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:_[3]&&_[3].trim()?_[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ue.header.length===ue.align.length){ue.raw=_[0];var de=ue.align.length,Le,fe,ke,Ie;for(Le=0;Le<de;Le++)/^ *-+: *$/.test(ue.align[Le])?ue.align[Le]="right":/^ *:-+: *$/.test(ue.align[Le])?ue.align[Le]="center":/^ *:-+ *$/.test(ue.align[Le])?ue.align[Le]="left":ue.align[Le]=null;for(de=ue.rows.length,Le=0;Le<de;Le++)ue.rows[Le]=P(ue.rows[Le],ue.header.length).map(function(O){return{text:O}});for(de=ue.header.length,fe=0;fe<de;fe++)ue.header[fe].tokens=this.lexer.inline(ue.header[fe].text);for(de=ue.rows.length,fe=0;fe<de;fe++)for(Ie=ue.rows[fe],ke=0;ke<Ie.length;ke++)Ie[ke].tokens=this.lexer.inline(Ie[ke].text);return ue}}},be.lheading=function(G){var _=this.rules.block.lheading.exec(G);if(_)return{type:"heading",raw:_[0],depth:_[2].charAt(0)==="="?1:2,text:_[1],tokens:this.lexer.inline(_[1])}},be.paragraph=function(G){var _=this.rules.block.paragraph.exec(G);if(_){var ue=_[1].charAt(_[1].length-1)===`
`?_[1].slice(0,-1):_[1];return{type:"paragraph",raw:_[0],text:ue,tokens:this.lexer.inline(ue)}}},be.text=function(G){var _=this.rules.block.text.exec(G);if(_)return{type:"text",raw:_[0],text:_[0],tokens:this.lexer.inline(_[0])}},be.escape=function(G){var _=this.rules.inline.escape.exec(G);if(_)return{type:"escape",raw:_[0],text:p(_[1])}},be.tag=function(G){var _=this.rules.inline.tag.exec(G);if(_)return!this.lexer.state.inLink&&/^<a /i.test(_[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(_[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(_[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(_[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:_[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):p(_[0]):_[0]}},be.link=function(G){var _=this.rules.inline.link.exec(G);if(_){var ue=_[2].trim();if(!this.options.pedantic&&/^</.test(ue)){if(!/>$/.test(ue))return;var de=g(ue.slice(0,-1),"\\");if((ue.length-de.length)%2===0)return}else{var Le=v(_[2],"()");if(Le>-1){var fe=_[0].indexOf("!")===0?5:4,ke=fe+_[1].length+Le;_[2]=_[2].substring(0,Le),_[0]=_[0].substring(0,ke).trim(),_[3]=""}}var Ie=_[2],O="";if(this.options.pedantic){var K=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);K&&(Ie=K[1],O=K[3])}else O=_[3]?_[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(ue)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),N(_,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:O&&O.replace(this.rules.inline._escapes,"$1")},_[0],this.lexer)}},be.reflink=function(G,_){var ue;if((ue=this.rules.inline.reflink.exec(G))||(ue=this.rules.inline.nolink.exec(G))){var de=(ue[2]||ue[1]).replace(/\s+/g," ");if(de=_[de.toLowerCase()],!de||!de.href){var Le=ue[0].charAt(0);return{type:"text",raw:Le,text:Le}}return N(ue,de,ue[0],this.lexer)}},be.emStrong=function(G,_,ue){ue===void 0&&(ue="");var de=this.rules.inline.emStrong.lDelim.exec(G);if(de&&!(de[3]&&ue.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Le=de[1]||de[2]||"";if(!Le||Le&&(ue===""||this.rules.inline.punctuation.exec(ue))){var fe=de[0].length-1,ke,Ie,O=fe,K=0,j=de[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(j.lastIndex=0,_=_.slice(-1*G.length+fe);(de=j.exec(_))!=null;)if(ke=de[1]||de[2]||de[3]||de[4]||de[5]||de[6],!!ke){if(Ie=ke.length,de[3]||de[4]){O+=Ie;continue}else if((de[5]||de[6])&&fe%3&&!((fe+Ie)%3)){K+=Ie;continue}if(O-=Ie,!(O>0)){if(Ie=Math.min(Ie,Ie+O+K),Math.min(fe,Ie)%2){var H=G.slice(1,fe+de.index+Ie);return{type:"em",raw:G.slice(0,fe+de.index+Ie+1),text:H,tokens:this.lexer.inlineTokens(H)}}var Z=G.slice(2,fe+de.index+Ie-1);return{type:"strong",raw:G.slice(0,fe+de.index+Ie+1),text:Z,tokens:this.lexer.inlineTokens(Z)}}}}}},be.codespan=function(G){var _=this.rules.inline.code.exec(G);if(_){var ue=_[2].replace(/\n/g," "),de=/[^ ]/.test(ue),Le=/^ /.test(ue)&&/ $/.test(ue);return de&&Le&&(ue=ue.substring(1,ue.length-1)),ue=p(ue,!0),{type:"codespan",raw:_[0],text:ue}}},be.br=function(G){var _=this.rules.inline.br.exec(G);if(_)return{type:"br",raw:_[0]}},be.del=function(G){var _=this.rules.inline.del.exec(G);if(_)return{type:"del",raw:_[0],text:_[2],tokens:this.lexer.inlineTokens(_[2])}},be.autolink=function(G,_){var ue=this.rules.inline.autolink.exec(G);if(ue){var de,Le;return ue[2]==="@"?(de=p(this.options.mangle?_(ue[1]):ue[1]),Le="mailto:"+de):(de=p(ue[1]),Le=de),{type:"link",raw:ue[0],text:de,href:Le,tokens:[{type:"text",raw:de,text:de}]}}},be.url=function(G,_){var ue;if(ue=this.rules.inline.url.exec(G)){var de,Le;if(ue[2]==="@")de=p(this.options.mangle?_(ue[0]):ue[0]),Le="mailto:"+de;else{var fe;do fe=ue[0],ue[0]=this.rules.inline._backpedal.exec(ue[0])[0];while(fe!==ue[0]);de=p(ue[0]),ue[1]==="www."?Le="http://"+de:Le=de}return{type:"link",raw:ue[0],text:de,href:Le,tokens:[{type:"text",raw:de,text:de}]}}},be.inlineText=function(G,_){var ue=this.rules.inline.text.exec(G);if(ue){var de;return this.lexer.state.inRawBlock?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):p(ue[0]):ue[0]:de=p(this.options.smartypants?_(ue[0]):ue[0]),{type:"text",raw:ue[0],text:de}}},Pe}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:h,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=i(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=i(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=i(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=i(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=i(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=b({},U),U.gfm=b({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=i(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=i(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=b({},U.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:h,paragraph:i(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var C={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:h,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:h,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};C._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",C.punctuation=i(C.punctuation).replace(/punctuation/g,C._punctuation).getRegex(),C.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,C.escapedEmSt=/\\\*|\\_/g,C._comment=i(U._comment).replace("(?:-->|$)","-->").getRegex(),C.emStrong.lDelim=i(C.emStrong.lDelim).replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimAst=i(C.emStrong.rDelimAst,"g").replace(/punct/g,C._punctuation).getRegex(),C.emStrong.rDelimUnd=i(C.emStrong.rDelimUnd,"g").replace(/punct/g,C._punctuation).getRegex(),C._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,C._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,C._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,C.autolink=i(C.autolink).replace("scheme",C._scheme).replace("email",C._email).getRegex(),C._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,C.tag=i(C.tag).replace("comment",C._comment).replace("attribute",C._attribute).getRegex(),C._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,C._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,C._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,C.link=i(C.link).replace("label",C._label).replace("href",C._href).replace("title",C._title).getRegex(),C.reflink=i(C.reflink).replace("label",C._label).replace("ref",U._label).getRegex(),C.nolink=i(C.nolink).replace("ref",U._label).getRegex(),C.reflinkSearch=i(C.reflinkSearch,"g").replace("reflink",C.reflink).replace("nolink",C.nolink).getRegex(),C.normal=b({},C),C.pedantic=b({},C.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",C._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",C._label).getRegex()}),C.gfm=b({},C.normal,{escape:i(C.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),C.gfm.url=i(C.gfm.url,"i").replace("email",C.gfm._extended_email).getRegex(),C.breaks=b({},C.gfm,{br:i(C.br).replace("{2,}","*").getRegex(),text:i(C.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function F(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function W(Pe){var be="",ge,G,_=Pe.length;for(ge=0;ge<_;ge++)G=Pe.charCodeAt(ge),Math.random()>.5&&(G="x"+G.toString(16)),be+="&#"+G+";";return be}var re=function(){function Pe(ge){this.tokens=[],this.tokens.links=Object.create(null),this.options=ge||me.defaults,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:U.normal,inline:C.normal};this.options.pedantic?(G.block=U.pedantic,G.inline=C.pedantic):this.options.gfm&&(G.block=U.gfm,this.options.breaks?G.inline=C.breaks:G.inline=C.gfm),this.tokenizer.rules=G}Pe.lex=function(G,_){var ue=new Pe(_);return ue.lex(G)},Pe.lexInline=function(G,_){var ue=new Pe(_);return ue.inlineTokens(G)};var be=Pe.prototype;return be.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var _;_=this.inlineQueue.shift();)this.inlineTokens(_.src,_.tokens);return this.tokens},be.blockTokens=function(G,_){var ue=this;_===void 0&&(_=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(O,K,j){return K+"    ".repeat(j.length)});for(var de,Le,fe,ke;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(O){return(de=O.call({lexer:ue},G,_))?(G=G.substring(de.raw.length),_.push(de),!0):!1}))){if(de=this.tokenizer.space(G)){G=G.substring(de.raw.length),de.raw.length===1&&_.length>0?_[_.length-1].raw+=`
`:_.push(de);continue}if(de=this.tokenizer.code(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.text,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):_.push(de);continue}if(de=this.tokenizer.fences(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.heading(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.hr(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.blockquote(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.list(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.html(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.def(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&(Le.type==="paragraph"||Le.type==="text")?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.raw,this.inlineQueue[this.inlineQueue.length-1].src=Le.text):this.tokens.links[de.tag]||(this.tokens.links[de.tag]={href:de.href,title:de.title});continue}if(de=this.tokenizer.table(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.lheading(G)){G=G.substring(de.raw.length),_.push(de);continue}if(fe=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var O=1/0,K=G.slice(1),j=void 0;ue.options.extensions.startBlock.forEach(function(H){j=H.call({lexer:this},K),typeof j=="number"&&j>=0&&(O=Math.min(O,j))}),O<1/0&&O>=0&&(fe=G.substring(0,O+1))}(),this.state.top&&(de=this.tokenizer.paragraph(fe))){Le=_[_.length-1],ke&&Le.type==="paragraph"?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):_.push(de),ke=fe.length!==G.length,G=G.substring(de.raw.length);continue}if(de=this.tokenizer.text(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&Le.type==="text"?(Le.raw+=`
`+de.raw,Le.text+=`
`+de.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Le.text):_.push(de);continue}if(G){var Ie="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,_},be.inline=function(G,_){return _===void 0&&(_=[]),this.inlineQueue.push({src:G,tokens:_}),_},be.inlineTokens=function(G,_){var ue=this;_===void 0&&(_=[]);var de,Le,fe,ke=G,Ie,O,K;if(this.tokens.links){var j=Object.keys(this.tokens.links);if(j.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)j.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ie.index)+"["+T("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"["+T("a",Ie[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ie.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(O||(K=""),O=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Z){return(de=Z.call({lexer:ue},G,_))?(G=G.substring(de.raw.length),_.push(de),!0):!1}))){if(de=this.tokenizer.escape(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.tag(G)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&de.type==="text"&&Le.type==="text"?(Le.raw+=de.raw,Le.text+=de.text):_.push(de);continue}if(de=this.tokenizer.link(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(de.raw.length),Le=_[_.length-1],Le&&de.type==="text"&&Le.type==="text"?(Le.raw+=de.raw,Le.text+=de.text):_.push(de);continue}if(de=this.tokenizer.emStrong(G,ke,K)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.codespan(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.br(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.del(G)){G=G.substring(de.raw.length),_.push(de);continue}if(de=this.tokenizer.autolink(G,W)){G=G.substring(de.raw.length),_.push(de);continue}if(!this.state.inLink&&(de=this.tokenizer.url(G,W))){G=G.substring(de.raw.length),_.push(de);continue}if(fe=G,this.options.extensions&&this.options.extensions.startInline&&function(){var Z=1/0,oe=G.slice(1),Ee=void 0;ue.options.extensions.startInline.forEach(function(Be){Ee=Be.call({lexer:this},oe),typeof Ee=="number"&&Ee>=0&&(Z=Math.min(Z,Ee))}),Z<1/0&&Z>=0&&(fe=G.substring(0,Z+1))}(),de=this.tokenizer.inlineText(fe,F)){G=G.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(K=de.raw.slice(-1)),O=!0,Le=_[_.length-1],Le&&Le.type==="text"?(Le.raw+=de.raw,Le.text+=de.text):_.push(de);continue}if(G){var H="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return _},S(Pe,null,[{key:"rules",get:function(){return{block:U,inline:C}}}]),Pe}(),ce=function(){function Pe(ge){this.options=ge||me.defaults}var be=Pe.prototype;return be.code=function(G,_,ue){var de=(_||"").match(/\S*/)[0];if(this.options.highlight){var Le=this.options.highlight(G,de);Le!=null&&Le!==G&&(ue=!0,G=Le)}return G=G.replace(/\n$/,"")+`
`,de?'<pre><code class="'+this.options.langPrefix+p(de,!0)+'">'+(ue?G:p(G,!0))+`</code></pre>
`:"<pre><code>"+(ue?G:p(G,!0))+`</code></pre>
`},be.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},be.html=function(G){return G},be.heading=function(G,_,ue,de){if(this.options.headerIds){var Le=this.options.headerPrefix+de.slug(ue);return"<h"+_+' id="'+Le+'">'+G+"</h"+_+`>
`}return"<h"+_+">"+G+"</h"+_+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(G,_,ue){var de=_?"ol":"ul",Le=_&&ue!==1?' start="'+ue+'"':"";return"<"+de+Le+`>
`+G+"</"+de+`>
`},be.listitem=function(G){return"<li>"+G+`</li>
`},be.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(G){return"<p>"+G+`</p>
`},be.table=function(G,_){return _&&(_="<tbody>"+_+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+_+`</table>
`},be.tablerow=function(G){return`<tr>
`+G+`</tr>
`},be.tablecell=function(G,_){var ue=_.header?"th":"td",de=_.align?"<"+ue+' align="'+_.align+'">':"<"+ue+">";return de+G+("</"+ue+`>
`)},be.strong=function(G){return"<strong>"+G+"</strong>"},be.em=function(G){return"<em>"+G+"</em>"},be.codespan=function(G){return"<code>"+G+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(G){return"<del>"+G+"</del>"},be.link=function(G,_,ue){if(G=u(this.options.sanitize,this.options.baseUrl,G),G===null)return ue;var de='<a href="'+p(G)+'"';return _&&(de+=' title="'+_+'"'),de+=">"+ue+"</a>",de},be.image=function(G,_,ue){if(G=u(this.options.sanitize,this.options.baseUrl,G),G===null)return ue;var de='<img src="'+G+'" alt="'+ue+'"';return _&&(de+=' title="'+_+'"'),de+=this.options.xhtml?"/>":">",de},be.text=function(G){return G},Pe}(),we=function(){function Pe(){}var be=Pe.prototype;return be.strong=function(G){return G},be.em=function(G){return G},be.codespan=function(G){return G},be.del=function(G){return G},be.html=function(G){return G},be.text=function(G){return G},be.link=function(G,_,ue){return""+ue},be.image=function(G,_,ue){return""+ue},be.br=function(){return""},Pe}(),De=function(){function Pe(){this.seen={}}var be=Pe.prototype;return be.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(G,_){var ue=G,de=0;if(this.seen.hasOwnProperty(ue)){de=this.seen[G];do de++,ue=G+"-"+de;while(this.seen.hasOwnProperty(ue))}return _||(this.seen[G]=de,this.seen[ue]=0),ue},be.slug=function(G,_){_===void 0&&(_={});var ue=this.serialize(G);return this.getNextSafeSlug(ue,_.dryrun)},Pe}(),le=function(){function Pe(ge){this.options=ge||me.defaults,this.options.renderer=this.options.renderer||new ce,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new De}Pe.parse=function(G,_){var ue=new Pe(_);return ue.parse(G)},Pe.parseInline=function(G,_){var ue=new Pe(_);return ue.parseInline(G)};var be=Pe.prototype;return be.parse=function(G,_){_===void 0&&(_=!0);var ue="",de,Le,fe,ke,Ie,O,K,j,H,Z,oe,Ee,Be,We,Ze,_e,at,rt,et,ct=G.length;for(de=0;de<ct;de++){if(Z=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Z.type]&&(et=this.options.extensions.renderers[Z.type].call({parser:this},Z),et!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Z.type))){ue+=et||"";continue}switch(Z.type){case"space":continue;case"hr":{ue+=this.renderer.hr();continue}case"heading":{ue+=this.renderer.heading(this.parseInline(Z.tokens),Z.depth,c(this.parseInline(Z.tokens,this.textRenderer)),this.slugger);continue}case"code":{ue+=this.renderer.code(Z.text,Z.lang,Z.escaped);continue}case"table":{for(j="",K="",ke=Z.header.length,Le=0;Le<ke;Le++)K+=this.renderer.tablecell(this.parseInline(Z.header[Le].tokens),{header:!0,align:Z.align[Le]});for(j+=this.renderer.tablerow(K),H="",ke=Z.rows.length,Le=0;Le<ke;Le++){for(O=Z.rows[Le],K="",Ie=O.length,fe=0;fe<Ie;fe++)K+=this.renderer.tablecell(this.parseInline(O[fe].tokens),{header:!1,align:Z.align[fe]});H+=this.renderer.tablerow(K)}ue+=this.renderer.table(j,H);continue}case"blockquote":{H=this.parse(Z.tokens),ue+=this.renderer.blockquote(H);continue}case"list":{for(oe=Z.ordered,Ee=Z.start,Be=Z.loose,ke=Z.items.length,H="",Le=0;Le<ke;Le++)Ze=Z.items[Le],_e=Ze.checked,at=Ze.task,We="",Ze.task&&(rt=this.renderer.checkbox(_e),Be?Ze.tokens.length>0&&Ze.tokens[0].type==="paragraph"?(Ze.tokens[0].text=rt+" "+Ze.tokens[0].text,Ze.tokens[0].tokens&&Ze.tokens[0].tokens.length>0&&Ze.tokens[0].tokens[0].type==="text"&&(Ze.tokens[0].tokens[0].text=rt+" "+Ze.tokens[0].tokens[0].text)):Ze.tokens.unshift({type:"text",text:rt}):We+=rt),We+=this.parse(Ze.tokens,Be),H+=this.renderer.listitem(We,at,_e);ue+=this.renderer.list(H,oe,Ee);continue}case"html":{ue+=this.renderer.html(Z.text);continue}case"paragraph":{ue+=this.renderer.paragraph(this.parseInline(Z.tokens));continue}case"text":{for(H=Z.tokens?this.parseInline(Z.tokens):Z.text;de+1<ct&&G[de+1].type==="text";)Z=G[++de],H+=`
`+(Z.tokens?this.parseInline(Z.tokens):Z.text);ue+=_?this.renderer.paragraph(H):H;continue}default:{var je='Token with "'+Z.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ue},be.parseInline=function(G,_){_=_||this.renderer;var ue="",de,Le,fe,ke=G.length;for(de=0;de<ke;de++){if(Le=G[de],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Le.type]&&(fe=this.options.extensions.renderers[Le.type].call({parser:this},Le),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Le.type))){ue+=fe||"";continue}switch(Le.type){case"escape":{ue+=_.text(Le.text);break}case"html":{ue+=_.html(Le.text);break}case"link":{ue+=_.link(Le.href,Le.title,this.parseInline(Le.tokens,_));break}case"image":{ue+=_.image(Le.href,Le.title,Le.text);break}case"strong":{ue+=_.strong(this.parseInline(Le.tokens,_));break}case"em":{ue+=_.em(this.parseInline(Le.tokens,_));break}case"codespan":{ue+=_.codespan(Le.text);break}case"br":{ue+=_.br();break}case"del":{ue+=_.del(this.parseInline(Le.tokens,_));break}case"text":{ue+=_.text(Le.text);break}default:{var Ie='Token with "'+Le.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return ue},Pe}();function ve(Pe,be,ge){if(typeof Pe>"u"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof be=="function"&&(ge=be,be=null),be=b({},ve.defaults,be||{}),E(be),ge){var G=be.highlight,_;try{_=re.lex(Pe,be)}catch(ke){return ge(ke)}var ue=function(Ie){var O;if(!Ie)try{be.walkTokens&&ve.walkTokens(_,be.walkTokens),O=le.parse(_,be)}catch(K){Ie=K}return be.highlight=G,Ie?ge(Ie):ge(null,O)};if(!G||G.length<3||(delete be.highlight,!_.length))return ue();var de=0;ve.walkTokens(_,function(ke){ke.type==="code"&&(de++,setTimeout(function(){G(ke.text,ke.lang,function(Ie,O){if(Ie)return ue(Ie);O!=null&&O!==ke.text&&(ke.text=O,ke.escaped=!0),de--,de===0&&ue()})},0))}),de===0&&ue();return}function Le(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(ke.message+"",!0)+"</pre>";throw ke}try{var fe=re.lex(Pe,be);if(be.walkTokens){if(be.async)return Promise.all(ve.walkTokens(fe,be.walkTokens)).then(function(){return le.parse(fe,be)}).catch(Le);ve.walkTokens(fe,be.walkTokens)}return le.parse(fe,be)}catch(ke){Le(ke)}}ve.options=ve.setOptions=function(Pe){return b(ve.defaults,Pe),m(ve.defaults),ve},ve.getDefaults=L,ve.defaults=me.defaults,ve.use=function(){for(var Pe=arguments.length,be=new Array(Pe),ge=0;ge<Pe;ge++)be[ge]=arguments[ge];var G=b.apply(void 0,[{}].concat(be)),_=ve.defaults.extensions||{renderers:{},childTokens:{}},ue;be.forEach(function(de){if(de.extensions&&(ue=!0,de.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var ke=_.renderers?_.renderers[fe.name]:null;ke?_.renderers[fe.name]=function(){for(var Ie=arguments.length,O=new Array(Ie),K=0;K<Ie;K++)O[K]=arguments[K];var j=fe.renderer.apply(this,O);return j===!1&&(j=ke.apply(this,O)),j}:_.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");_[fe.level]?_[fe.level].unshift(fe.tokenizer):_[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?_.startBlock?_.startBlock.push(fe.start):_.startBlock=[fe.start]:fe.level==="inline"&&(_.startInline?_.startInline.push(fe.start):_.startInline=[fe.start]))}fe.childTokens&&(_.childTokens[fe.name]=fe.childTokens)})),de.renderer&&function(){var fe=ve.defaults.renderer||new ce,ke=function(K){var j=fe[K];fe[K]=function(){for(var H=arguments.length,Z=new Array(H),oe=0;oe<H;oe++)Z[oe]=arguments[oe];var Ee=de.renderer[K].apply(fe,Z);return Ee===!1&&(Ee=j.apply(fe,Z)),Ee}};for(var Ie in de.renderer)ke(Ie);G.renderer=fe}(),de.tokenizer&&function(){var fe=ve.defaults.tokenizer||new q,ke=function(K){var j=fe[K];fe[K]=function(){for(var H=arguments.length,Z=new Array(H),oe=0;oe<H;oe++)Z[oe]=arguments[oe];var Ee=de.tokenizer[K].apply(fe,Z);return Ee===!1&&(Ee=j.apply(fe,Z)),Ee}};for(var Ie in de.tokenizer)ke(Ie);G.tokenizer=fe}(),de.walkTokens){var Le=ve.defaults.walkTokens;G.walkTokens=function(fe){var ke=[];return ke.push(de.walkTokens.call(this,fe)),Le&&(ke=ke.concat(Le.call(this,fe))),ke}}ue&&(G.extensions=_),ve.setOptions(G)})},ve.walkTokens=function(Pe,be){for(var ge=[],G=function(){var Le=ue.value;switch(ge=ge.concat(be.call(ve,Le)),Le.type){case"table":{for(var fe=R(Le.header),ke;!(ke=fe()).done;){var Ie=ke.value;ge=ge.concat(ve.walkTokens(Ie.tokens,be))}for(var O=R(Le.rows),K;!(K=O()).done;)for(var j=K.value,H=R(j),Z;!(Z=H()).done;){var oe=Z.value;ge=ge.concat(ve.walkTokens(oe.tokens,be))}break}case"list":{ge=ge.concat(ve.walkTokens(Le.items,be));break}default:ve.defaults.extensions&&ve.defaults.extensions.childTokens&&ve.defaults.extensions.childTokens[Le.type]?ve.defaults.extensions.childTokens[Le.type].forEach(function(Ee){ge=ge.concat(ve.walkTokens(Le[Ee],be))}):Le.tokens&&(ge=ge.concat(ve.walkTokens(Le.tokens,be)))}},_=R(Pe),ue;!(ue=_()).done;)G();return ge},ve.parseInline=function(Pe,be){if(typeof Pe>"u"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");be=b({},ve.defaults,be||{}),E(be);try{var ge=re.lexInline(Pe,be);return be.walkTokens&&ve.walkTokens(ge,be.walkTokens),le.parseInline(ge,be)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(G.message+"",!0)+"</pre>";throw G}},ve.Parser=le,ve.parser=le.parse,ve.Renderer=ce,ve.TextRenderer=we,ve.Lexer=re,ve.lexer=re.lex,ve.Tokenizer=q,ve.Slugger=De,ve.parse=ve;var se=ve.options,$e=ve.setOptions,te=ve.use,X=ve.walkTokens,V=ve.parseInline,ie=ve,Ce=le.parse,Te=re.lex;me.Lexer=re,me.Parser=le,me.Renderer=ce,me.Slugger=De,me.TextRenderer=we,me.Tokenizer=q,me.getDefaults=L,me.lexer=Te,me.marked=ve,me.options=se,me.parse=ie,me.parseInline=V,me.parser=Ce,me.setOptions=$e,me.use=te,me.walkTokens=X,Object.defineProperty(me,"__esModule",{value:!0})}),define(Re[121],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tj=void 0;function S(r){const c=R(r);if(c&&c.length>0)return new Uint32Array(c)}e.$Tj=S;let M=0;const I=new Uint32Array(10);function R(r){if(M=0,L(r,k,4352),M>0||(L(r,l,4449),M>0)||(L(r,$,4520),M>0)||(L(r,p,12593),M))return I.subarray(0,M);if(r>=44032&&r<=55203){const c=r-44032,s=c%588,i=Math.floor(c/588),o=Math.floor(s/28),a=s%28-1;if(i<k.length?L(i,k,0):4352+i-12593<p.length&&L(4352+i,p,12593),o<l.length?L(o,l,0):4449+o-12593<p.length&&L(4449+o-12593,p,12593),a>=0&&(a<$.length?L(a,$,0):4520+a-12593<p.length&&L(4520+a-12593,p,12593)),M>0)return I.subarray(0,M)}}function L(r,c,s){r>=s&&r<s+c.length&&m(c[r-s])}function m(r){r!==0&&(I[M++]=r&255,r>>8&&(I[M++]=r>>8&255),r>>16&&(I[M++]=r>>16&255))}var d;(function(r){r[r.InitialConsonant=4352]="InitialConsonant",r[r.Vowel=4449]="Vowel",r[r.FinalConsonant=4520]="FinalConsonant",r[r.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var y;(function(r){r[r.NUL=0]="NUL",r[r.A=65]="A",r[r.B=66]="B",r[r.C=67]="C",r[r.D=68]="D",r[r.E=69]="E",r[r.F=70]="F",r[r.G=71]="G",r[r.H=72]="H",r[r.I=73]="I",r[r.J=74]="J",r[r.K=75]="K",r[r.L=76]="L",r[r.M=77]="M",r[r.N=78]="N",r[r.O=79]="O",r[r.P=80]="P",r[r.Q=81]="Q",r[r.R=82]="R",r[r.S=83]="S",r[r.T=84]="T",r[r.U=85]="U",r[r.V=86]="V",r[r.W=87]="W",r[r.X=88]="X",r[r.Y=89]="Y",r[r.Z=90]="Z",r[r.a=97]="a",r[r.b=98]="b",r[r.c=99]="c",r[r.d=100]="d",r[r.e=101]="e",r[r.f=102]="f",r[r.g=103]="g",r[r.h=104]="h",r[r.i=105]="i",r[r.j=106]="j",r[r.k=107]="k",r[r.l=108]="l",r[r.m=109]="m",r[r.n=110]="n",r[r.o=111]="o",r[r.p=112]="p",r[r.q=113]="q",r[r.r=114]="r",r[r.s=115]="s",r[r.t=116]="t",r[r.u=117]="u",r[r.v=118]="v",r[r.w=119]="w",r[r.x=120]="x",r[r.y=121]="y",r[r.z=122]="z"})(y||(y={}));var A;(function(r){r[r.fa=24934]="fa",r[r.fg=26470]="fg",r[r.fq=29030]="fq",r[r.fr=29286]="fr",r[r.ft=29798]="ft",r[r.fv=30310]="fv",r[r.fx=30822]="fx",r[r.hk=27496]="hk",r[r.hl=27752]="hl",r[r.ho=28520]="ho",r[r.ml=27757]="ml",r[r.nj=27246]="nj",r[r.nl=27758]="nl",r[r.np=28782]="np",r[r.qt=29809]="qt",r[r.rt=29810]="rt",r[r.sg=26483]="sg",r[r.sw=30579]="sw"})(A||(A={}));const k=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),$=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),p=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Re[122],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$am=e.$_l=e.$$l=e.rot=e.$9l=void 0;function S(m,d,y){return Math.min(Math.max(m,d),y)}e.$9l=S;function M(m,d){return(d+m%d)%d}e.rot=M;class I{constructor(){this.a=0}getNext(){return this.a++}}e.$$l=I;class R{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$_l=R;class L{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const y=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=y,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$am=L}),function(){function me(I){const R=[];typeof I=="number"&&R.push("code/timeOrigin",I);function L(d){R.push(d,Date.now())}function m(){const d=[];for(let y=0;y<R.length;y+=2)d.push({name:R[y],startTime:R[y+1]});return d}return{mark:L,getMarks:m}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?me():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const L of performance.getEntriesByType("mark"))R.push({name:L.name,startTime:Math.round(I+L.startTime)});return R}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return me(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),me()}function S(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=S(M))}(),function(me,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var M in S)(typeof exports=="object"?exports:me)[M]=S[M]}}(typeof self<"u"?self:this,function(){return function(me){var e={};function S(M){if(e[M])return e[M].exports;var I=e[M]={i:M,l:!1,exports:{}};return me[M].call(I.exports,I,I.exports,S),I.l=!0,I.exports}return S.m=me,S.c=e,S.d=function(M,I,R){S.o(M,I)||Object.defineProperty(M,I,{enumerable:!0,get:R})},S.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},S.t=function(M,I){if(1&I&&(M=S(M)),8&I||4&I&&typeof M=="object"&&M&&M.__esModule)return M;var R=Object.create(null);if(S.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:M}),2&I&&typeof M!="string")for(var L in M)S.d(R,L,function(m){return M[m]}.bind(null,L));return R},S.n=function(M){var I=M&&M.__esModule?function(){return M.default}:function(){return M};return S.d(I,"a",I),I},S.o=function(M,I){return Object.prototype.hasOwnProperty.call(M,I)},S.p="",S(S.s=0)}([function(me,e,S){(function(M){var I;e=me.exports=te,I=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var j=Array.prototype.slice.call(arguments,0);j.unshift("SEMVER"),console.log.apply(console,j)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,L=Number.MAX_SAFE_INTEGER||9007199254740991,m=e.re=[],d=e.src=[],y=0,A=y++;d[A]="0|[1-9]\\d*";var k=y++;d[k]="[0-9]+";var l=y++;d[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var $=y++;d[$]="("+d[A]+")\\.("+d[A]+")\\.("+d[A]+")";var p=y++;d[p]="("+d[k]+")\\.("+d[k]+")\\.("+d[k]+")";var r=y++;d[r]="(?:"+d[A]+"|"+d[l]+")";var c=y++;d[c]="(?:"+d[k]+"|"+d[l]+")";var s=y++;d[s]="(?:-("+d[r]+"(?:\\."+d[r]+")*))";var i=y++;d[i]="(?:-?("+d[c]+"(?:\\."+d[c]+")*))";var o=y++;d[o]="[0-9A-Za-z-]+";var a=y++;d[a]="(?:\\+("+d[o]+"(?:\\."+d[o]+")*))";var u=y++,t="v?"+d[$]+d[s]+"?"+d[a]+"?";d[u]="^"+t+"$";var f="[v=\\s]*"+d[p]+d[i]+"?"+d[a]+"?",n=y++;d[n]="^"+f+"$";var w=y++;d[w]="((?:<|>)?=?)";var D=y++;d[D]=d[k]+"|x|X|\\*";var h=y++;d[h]=d[A]+"|x|X|\\*";var b=y++;d[b]="[v=\\s]*("+d[h]+")(?:\\.("+d[h]+")(?:\\.("+d[h]+")(?:"+d[s]+")?"+d[a]+"?)?)?";var P=y++;d[P]="[v=\\s]*("+d[D]+")(?:\\.("+d[D]+")(?:\\.("+d[D]+")(?:"+d[i]+")?"+d[a]+"?)?)?";var g=y++;d[g]="^"+d[w]+"\\s*"+d[b]+"$";var v=y++;d[v]="^"+d[w]+"\\s*"+d[P]+"$";var E=y++;d[E]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var T=y++;d[T]="(?:~>?)";var N=y++;d[N]="(\\s*)"+d[T]+"\\s+",m[N]=new RegExp(d[N],"g");var J=y++;d[J]="^"+d[T]+d[b]+"$";var q=y++;d[q]="^"+d[T]+d[P]+"$";var U=y++;d[U]="(?:\\^)";var C=y++;d[C]="(\\s*)"+d[U]+"\\s+",m[C]=new RegExp(d[C],"g");var F=y++;d[F]="^"+d[U]+d[b]+"$";var W=y++;d[W]="^"+d[U]+d[P]+"$";var re=y++;d[re]="^"+d[w]+"\\s*("+f+")$|^$";var ce=y++;d[ce]="^"+d[w]+"\\s*("+t+")$|^$";var we=y++;d[we]="(\\s*)"+d[w]+"\\s*("+f+"|"+d[b]+")",m[we]=new RegExp(d[we],"g");var De=y++;d[De]="^\\s*("+d[b]+")\\s+-\\s+("+d[b]+")\\s*$";var le=y++;d[le]="^\\s*("+d[P]+")\\s+-\\s+("+d[P]+")\\s*$";var ve=y++;d[ve]="(<|>)?=?\\s*\\*";for(var se=0;se<35;se++)I(se,d[se]),m[se]||(m[se]=new RegExp(d[se]));function $e(j,H){if(j instanceof te)return j;if(typeof j!="string"||j.length>R||!(H?m[n]:m[u]).test(j))return null;try{return new te(j,H)}catch{return null}}function te(j,H){if(j instanceof te){if(j.loose===H)return j;j=j.version}else if(typeof j!="string")throw new TypeError("Invalid Version: "+j);if(j.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof te))return new te(j,H);I("SemVer",j,H),this.loose=H;var Z=j.trim().match(H?m[n]:m[u]);if(!Z)throw new TypeError("Invalid Version: "+j);if(this.raw=j,this.major=+Z[1],this.minor=+Z[2],this.patch=+Z[3],this.major>L||this.major<0)throw new TypeError("Invalid major version");if(this.minor>L||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>L||this.patch<0)throw new TypeError("Invalid patch version");Z[4]?this.prerelease=Z[4].split(".").map(function(oe){if(/^[0-9]+$/.test(oe)){var Ee=+oe;if(Ee>=0&&Ee<L)return Ee}return oe}):this.prerelease=[],this.build=Z[5]?Z[5].split("."):[],this.format()}e.parse=$e,e.valid=function(j,H){var Z=$e(j,H);return Z?Z.version:null},e.clean=function(j,H){var Z=$e(j.trim().replace(/^[=v]+/,""),H);return Z?Z.version:null},e.SemVer=te,te.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},te.prototype.toString=function(){return this.version},te.prototype.compare=function(j){return I("SemVer.compare",this.version,this.loose,j),j instanceof te||(j=new te(j,this.loose)),this.compareMain(j)||this.comparePre(j)},te.prototype.compareMain=function(j){return j instanceof te||(j=new te(j,this.loose)),V(this.major,j.major)||V(this.minor,j.minor)||V(this.patch,j.patch)},te.prototype.comparePre=function(j){if(j instanceof te||(j=new te(j,this.loose)),this.prerelease.length&&!j.prerelease.length)return-1;if(!this.prerelease.length&&j.prerelease.length)return 1;if(!this.prerelease.length&&!j.prerelease.length)return 0;var H=0;do{var Z=this.prerelease[H],oe=j.prerelease[H];if(I("prerelease compare",H,Z,oe),Z===void 0&&oe===void 0)return 0;if(oe===void 0)return 1;if(Z===void 0)return-1;if(Z!==oe)return V(Z,oe)}while(++H)},te.prototype.inc=function(j,H){switch(j){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Z=this.prerelease.length;--Z>=0;)typeof this.prerelease[Z]=="number"&&(this.prerelease[Z]++,Z=-2);Z===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+j)}return this.format(),this.raw=this.version,this},e.inc=function(j,H,Z,oe){typeof Z=="string"&&(oe=Z,Z=void 0);try{return new te(j,Z).inc(H,oe).version}catch{return null}},e.diff=function(j,H){if(Pe(j,H))return null;var Z=$e(j),oe=$e(H);if(Z.prerelease.length||oe.prerelease.length){for(var Ee in Z)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Z[Ee]!==oe[Ee])return"pre"+Ee;return"prerelease"}for(var Ee in Z)if((Ee==="major"||Ee==="minor"||Ee==="patch")&&Z[Ee]!==oe[Ee])return Ee},e.compareIdentifiers=V;var X=/^[0-9]+$/;function V(j,H){var Z=X.test(j),oe=X.test(H);return Z&&oe&&(j=+j,H=+H),Z&&!oe?-1:oe&&!Z?1:j<H?-1:j>H?1:0}function ie(j,H,Z){return new te(j,Z).compare(new te(H,Z))}function Ce(j,H,Z){return ie(j,H,Z)>0}function Te(j,H,Z){return ie(j,H,Z)<0}function Pe(j,H,Z){return ie(j,H,Z)===0}function be(j,H,Z){return ie(j,H,Z)!==0}function ge(j,H,Z){return ie(j,H,Z)>=0}function G(j,H,Z){return ie(j,H,Z)<=0}function _(j,H,Z,oe){var Ee;switch(H){case"===":typeof j=="object"&&(j=j.version),typeof Z=="object"&&(Z=Z.version),Ee=j===Z;break;case"!==":typeof j=="object"&&(j=j.version),typeof Z=="object"&&(Z=Z.version),Ee=j!==Z;break;case"":case"=":case"==":Ee=Pe(j,Z,oe);break;case"!=":Ee=be(j,Z,oe);break;case">":Ee=Ce(j,Z,oe);break;case">=":Ee=ge(j,Z,oe);break;case"<":Ee=Te(j,Z,oe);break;case"<=":Ee=G(j,Z,oe);break;default:throw new TypeError("Invalid operator: "+H)}return Ee}function ue(j,H){if(j instanceof ue){if(j.loose===H)return j;j=j.value}if(!(this instanceof ue))return new ue(j,H);I("comparator",j,H),this.loose=H,this.parse(j),this.semver===de?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(j,H){return V(H,j)},e.major=function(j,H){return new te(j,H).major},e.minor=function(j,H){return new te(j,H).minor},e.patch=function(j,H){return new te(j,H).patch},e.compare=ie,e.compareLoose=function(j,H){return ie(j,H,!0)},e.rcompare=function(j,H,Z){return ie(H,j,Z)},e.sort=function(j,H){return j.sort(function(Z,oe){return e.compare(Z,oe,H)})},e.rsort=function(j,H){return j.sort(function(Z,oe){return e.rcompare(Z,oe,H)})},e.gt=Ce,e.lt=Te,e.eq=Pe,e.neq=be,e.gte=ge,e.lte=G,e.cmp=_,e.Comparator=ue;var de={};function Le(j,H){if(j instanceof Le)return j.loose===H?j:new Le(j.raw,H);if(j instanceof ue)return new Le(j.value,H);if(!(this instanceof Le))return new Le(j,H);if(this.loose=H,this.raw=j,this.set=j.split(/\s*\|\|\s*/).map(function(Z){return this.parseRange(Z.trim())},this).filter(function(Z){return Z.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+j);this.format()}function fe(j){return!j||j.toLowerCase()==="x"||j==="*"}function ke(j,H,Z,oe,Ee,Be,We,Ze,_e,at,rt,et,ct){return((H=fe(Z)?"":fe(oe)?">="+Z+".0.0":fe(Ee)?">="+Z+"."+oe+".0":">="+H)+" "+(Ze=fe(_e)?"":fe(at)?"<"+(+_e+1)+".0.0":fe(rt)?"<"+_e+"."+(+at+1)+".0":et?"<="+_e+"."+at+"."+rt+"-"+et:"<="+Ze)).trim()}function Ie(j,H){for(var Z=0;Z<j.length;Z++)if(!j[Z].test(H))return!1;if(H.prerelease.length){for(Z=0;Z<j.length;Z++)if(I(j[Z].semver),j[Z].semver!==de&&j[Z].semver.prerelease.length>0){var oe=j[Z].semver;if(oe.major===H.major&&oe.minor===H.minor&&oe.patch===H.patch)return!0}return!1}return!0}function O(j,H,Z){try{H=new Le(H,Z)}catch{return!1}return H.test(j)}function K(j,H,Z,oe){var Ee,Be,We,Ze,_e;switch(j=new te(j,oe),H=new Le(H,oe),Z){case">":Ee=Ce,Be=G,We=Te,Ze=">",_e=">=";break;case"<":Ee=Te,Be=ge,We=Ce,Ze="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(O(j,H,oe))return!1;for(var at=0;at<H.set.length;++at){var rt=H.set[at],et=null,ct=null;if(rt.forEach(function(je){je.semver===de&&(je=new ue(">=0.0.0")),et=et||je,ct=ct||je,Ee(je.semver,et.semver,oe)?et=je:We(je.semver,ct.semver,oe)&&(ct=je)}),et.operator===Ze||et.operator===_e||(!ct.operator||ct.operator===Ze)&&Be(j,ct.semver)||ct.operator===_e&&We(j,ct.semver))return!1}return!0}ue.prototype.parse=function(j){var H=this.loose?m[re]:m[ce],Z=j.match(H);if(!Z)throw new TypeError("Invalid comparator: "+j);this.operator=Z[1],this.operator==="="&&(this.operator=""),Z[2]?this.semver=new te(Z[2],this.loose):this.semver=de},ue.prototype.toString=function(){return this.value},ue.prototype.test=function(j){return I("Comparator.test",j,this.loose),this.semver===de||(typeof j=="string"&&(j=new te(j,this.loose)),_(j,this.operator,this.semver,this.loose))},ue.prototype.intersects=function(j,H){if(!(j instanceof ue))throw new TypeError("a Comparator is required");var Z;if(this.operator==="")return Z=new Le(j.value,H),O(this.value,Z,H);if(j.operator==="")return Z=new Le(this.value,H),O(j.semver,Z,H);var oe=!(this.operator!==">="&&this.operator!==">"||j.operator!==">="&&j.operator!==">"),Ee=!(this.operator!=="<="&&this.operator!=="<"||j.operator!=="<="&&j.operator!=="<"),Be=this.semver.version===j.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||j.operator!==">="&&j.operator!=="<="),Ze=_(this.semver,"<",j.semver,H)&&(this.operator===">="||this.operator===">")&&(j.operator==="<="||j.operator==="<"),_e=_(this.semver,">",j.semver,H)&&(this.operator==="<="||this.operator==="<")&&(j.operator===">="||j.operator===">");return oe||Ee||Be&&We||Ze||_e},e.Range=Le,Le.prototype.format=function(){return this.range=this.set.map(function(j){return j.join(" ").trim()}).join("||").trim(),this.range},Le.prototype.toString=function(){return this.range},Le.prototype.parseRange=function(j){var H=this.loose;j=j.trim(),I("range",j,H);var Z=H?m[le]:m[De];j=j.replace(Z,ke),I("hyphen replace",j),j=j.replace(m[we],"$1$2$3"),I("comparator trim",j,m[we]),j=(j=(j=j.replace(m[N],"$1~")).replace(m[C],"$1^")).split(/\s+/).join(" ");var oe=H?m[re]:m[ce],Ee=j.split(" ").map(function(Be){return function(We,Ze){return I("comp",We),We=function(_e,at){return _e.trim().split(/\s+/).map(function(rt){return function(et,ct){I("caret",et,ct);var je=ct?m[W]:m[F];return et.replace(je,function(vt,Y,x,pe,Ve){var Qe;return I("caret",et,vt,Y,x,pe,Ve),fe(Y)?Qe="":fe(x)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":fe(pe)?Qe=Y==="0"?">="+Y+"."+x+".0 <"+Y+"."+(+x+1)+".0":">="+Y+"."+x+".0 <"+(+Y+1)+".0.0":Ve?(I("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Qe=Y==="0"?x==="0"?">="+Y+"."+x+"."+pe+Ve+" <"+Y+"."+x+"."+(+pe+1):">="+Y+"."+x+"."+pe+Ve+" <"+Y+"."+(+x+1)+".0":">="+Y+"."+x+"."+pe+Ve+" <"+(+Y+1)+".0.0"):(I("no pr"),Qe=Y==="0"?x==="0"?">="+Y+"."+x+"."+pe+" <"+Y+"."+x+"."+(+pe+1):">="+Y+"."+x+"."+pe+" <"+Y+"."+(+x+1)+".0":">="+Y+"."+x+"."+pe+" <"+(+Y+1)+".0.0"),I("caret return",Qe),Qe})}(rt,at)}).join(" ")}(We,Ze),I("caret",We),We=function(_e,at){return _e.trim().split(/\s+/).map(function(rt){return function(et,ct){var je=ct?m[q]:m[J];return et.replace(je,function(vt,Y,x,pe,Ve){var Qe;return I("tilde",et,vt,Y,x,pe,Ve),fe(Y)?Qe="":fe(x)?Qe=">="+Y+".0.0 <"+(+Y+1)+".0.0":fe(pe)?Qe=">="+Y+"."+x+".0 <"+Y+"."+(+x+1)+".0":Ve?(I("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),Qe=">="+Y+"."+x+"."+pe+Ve+" <"+Y+"."+(+x+1)+".0"):Qe=">="+Y+"."+x+"."+pe+" <"+Y+"."+(+x+1)+".0",I("tilde return",Qe),Qe})}(rt,at)}).join(" ")}(We,Ze),I("tildes",We),We=function(_e,at){return I("replaceXRanges",_e,at),_e.split(/\s+/).map(function(rt){return function(et,ct){et=et.trim();var je=ct?m[v]:m[g];return et.replace(je,function(vt,Y,x,pe,Ve,Qe){I("xRange",et,vt,Y,x,pe,Ve,Qe);var nt=fe(x),st=nt||fe(pe),Ne=st||fe(Ve);return Y==="="&&Ne&&(Y=""),nt?vt=Y===">"||Y==="<"?"<0.0.0":"*":Y&&Ne?(st&&(pe=0),Ne&&(Ve=0),Y===">"?(Y=">=",st?(x=+x+1,pe=0,Ve=0):Ne&&(pe=+pe+1,Ve=0)):Y==="<="&&(Y="<",st?x=+x+1:pe=+pe+1),vt=Y+x+"."+pe+"."+Ve):st?vt=">="+x+".0.0 <"+(+x+1)+".0.0":Ne&&(vt=">="+x+"."+pe+".0 <"+x+"."+(+pe+1)+".0"),I("xRange return",vt),vt})}(rt,at)}).join(" ")}(We,Ze),I("xrange",We),We=function(_e,at){return I("replaceStars",_e,at),_e.trim().replace(m[ve],"")}(We,Ze),I("stars",We),We}(Be,H)}).join(" ").split(/\s+/);return this.loose&&(Ee=Ee.filter(function(Be){return!!Be.match(oe)})),Ee=Ee.map(function(Be){return new ue(Be,H)})},Le.prototype.intersects=function(j,H){if(!(j instanceof Le))throw new TypeError("a Range is required");return this.set.some(function(Z){return Z.every(function(oe){return j.set.some(function(Ee){return Ee.every(function(Be){return oe.intersects(Be,H)})})})})},e.toComparators=function(j,H){return new Le(j,H).set.map(function(Z){return Z.map(function(oe){return oe.value}).join(" ").trim().split(" ")})},Le.prototype.test=function(j){if(!j)return!1;typeof j=="string"&&(j=new te(j,this.loose));for(var H=0;H<this.set.length;H++)if(Ie(this.set[H],j))return!0;return!1},e.satisfies=O,e.maxSatisfying=function(j,H,Z){var oe=null,Ee=null;try{var Be=new Le(H,Z)}catch{return null}return j.forEach(function(We){Be.test(We)&&(oe&&Ee.compare(We)!==-1||(Ee=new te(oe=We,Z)))}),oe},e.minSatisfying=function(j,H,Z){var oe=null,Ee=null;try{var Be=new Le(H,Z)}catch{return null}return j.forEach(function(We){Be.test(We)&&(oe&&Ee.compare(We)!==1||(Ee=new te(oe=We,Z)))}),oe},e.validRange=function(j,H){try{return new Le(j,H).range||"*"}catch{return null}},e.ltr=function(j,H,Z){return K(j,H,"<",Z)},e.gtr=function(j,H,Z){return K(j,H,">",Z)},e.outside=K,e.prerelease=function(j,H){var Z=$e(j,H);return Z&&Z.prerelease.length?Z.prerelease:null},e.intersects=function(j,H,Z){return j=new Le(j,Z),H=new Le(H,Z),j.intersects(H)},e.coerce=function(j){if(j instanceof te)return j;if(typeof j!="string")return null;var H=j.match(m[E]);return H==null?null:$e((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(me,e){var S,M,I=me.exports={};function R(){throw new Error("setTimeout has not been defined")}function L(){throw new Error("clearTimeout has not been defined")}function m(c){if(S===setTimeout)return setTimeout(c,0);if((S===R||!S)&&setTimeout)return S=setTimeout,setTimeout(c,0);try{return S(c,0)}catch{try{return S.call(null,c,0)}catch{return S.call(this,c,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:R}catch{S=R}try{M=typeof clearTimeout=="function"?clearTimeout:L}catch{M=L}})();var d,y=[],A=!1,k=-1;function l(){A&&d&&(A=!1,d.length?y=d.concat(y):k=-1,y.length&&$())}function $(){if(!A){var c=m(l);A=!0;for(var s=y.length;s;){for(d=y,y=[];++k<s;)d&&d[k].run();k=-1,s=y.length}d=null,A=!1,function(i){if(M===clearTimeout)return clearTimeout(i);if((M===L||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(i);try{M(i)}catch{try{return M.call(null,i)}catch{return M.call(this,i)}}}(c)}}function p(c,s){this.fun=c,this.array=s}function r(){}I.nextTick=function(c){var s=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)s[i-1]=arguments[i];y.push(new p(c,s)),y.length!==1||A||m($)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=r,I.addListener=r,I.once=r,I.off=r,I.removeListener=r,I.removeAllListeners=r,I.emit=r,I.prependListener=r,I.prependOnceListener=r,I.listeners=function(c){return[]},I.binding=function(c){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(c){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Re[123],Ae([1,0,15,6]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=void 0;function I(a){const u=a;return u?typeof u.read=="function":!1}e.$8d=I;function R(a){const u=a;return u?[u.on,u.pause,u.resume,u.destroy].every(t=>typeof t=="function"):!1}e.$9d=R;function L(a){const u=a;return u?R(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.$0d=L;function m(a,u){return new d(a,u)}e.$$d=m;class d{constructor(u,t){this.e=u,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(t=>t(u))}h(u){this.c.error.length===0?(0,S.$1)(u):this.c.error.slice(0).forEach(t=>t(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,t){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(u,t){if(this.a.destroyed)return;let f;switch(u){case"data":f=this.c.data;break;case"end":f=this.c.end;break;case"error":f=this.c.error;break}if(f){const n=f.indexOf(t);n>=0&&f.splice(n,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(f=>f())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function y(a,u){const t=[];let f;for(;(f=a.read())!==null;)t.push(f);return u(t)}e.$_d=y;function A(a,u,t){const f=[];let n;for(;(n=a.read())!==null&&f.length<t;)f.push(n);return n===null&&f.length>0?u(f):{read:()=>{if(f.length>0)return f.shift();if(typeof n<"u"){const w=n;return n=void 0,w}return a.read()}}}e.$ae=A;function k(a,u){return new Promise((t,f)=>{const n=[];l(a,{onData:w=>{u&&n.push(w)},onError:w=>{u?f(w):t(void 0)},onEnd:()=>{t(u?u(n):void 0)}})})}e.$be=k;function l(a,u,t){a.on("error",f=>{t?.isCancellationRequested||u.onError(f)}),a.on("end",()=>{t?.isCancellationRequested||u.onEnd()}),a.on("data",f=>{t?.isCancellationRequested||u.onData(f)})}e.$ce=l;function $(a,u){return new Promise((t,f)=>{const n=new M.$Sc,w=[],D=P=>{if(w.push(P),w.length>u)return n.dispose(),a.pause(),t({stream:a,buffer:w,ended:!1})},h=P=>(n.dispose(),f(P)),b=()=>(n.dispose(),t({stream:a,buffer:w,ended:!0}));n.add((0,M.$Rc)(()=>a.removeListener("error",h))),a.on("error",h),n.add((0,M.$Rc)(()=>a.removeListener("end",b))),a.on("end",b),n.add((0,M.$Rc)(()=>a.removeListener("data",D))),a.on("data",D)})}e.$de=$;function p(a,u){const t=m(u);return t.end(a),t}e.$ee=p;function r(){const a=m(()=>{throw new Error("not supported")});return a.end(),a}e.$fe=r;function c(a){let u=!1;return{read:()=>u?null:(u=!0,a)}}e.$ge=c;function s(a,u,t){const f=m(t);return l(a,{onData:n=>f.write(u.data(n)),onError:n=>f.error(u.error?u.error(n):n),onEnd:()=>f.end()}),f}e.$he=s;function i(a,u,t){let f=!1;return{read:()=>{const n=u.read();return f?n:(f=!0,n!==null?t([a,n]):a)}}}e.$ie=i;function o(a,u,t){let f=!1;const n=m(t);return l(u,{onData:w=>f?n.write(w):(f=!0,n.write(t([a,w]))),onError:w=>n.error(w),onEnd:()=>{f||(f=!0,n.write(a)),n.end()}}),n}e.$je=o}),define(Re[23],Ae([1,0,39,123]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ee=e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=void 0;const I=typeof Buffer<"u",R=new S.$V(()=>new Uint8Array(256));let L,m;class d{static alloc(E){return I?new d(Buffer.allocUnsafe(E)):new d(new Uint8Array(E))}static wrap(E){return I&&!Buffer.isBuffer(E)&&(E=Buffer.from(E.buffer,E.byteOffset,E.byteLength)),new d(E)}static fromString(E,T){return!(T?.dontUseNodeBuffer||!1)&&I?new d(Buffer.from(E)):(L||(L=new TextEncoder),new d(L.encode(E)))}static fromByteArray(E){const T=d.alloc(E.length);for(let N=0,J=E.length;N<J;N++)T.buffer[N]=E[N];return T}static concat(E,T){if(typeof T>"u"){T=0;for(let q=0,U=E.length;q<U;q++)T+=E[q].byteLength}const N=d.alloc(T);let J=0;for(let q=0,U=E.length;q<U;q++){const C=E[q];N.set(C,J),J+=C.byteLength}return N}constructor(E){this.buffer=E,this.byteLength=this.buffer.byteLength}clone(){const E=d.alloc(this.byteLength);return E.set(this),E}toString(){return I?this.buffer.toString():(m||(m=new TextDecoder),m.decode(this.buffer))}slice(E,T){return new d(this.buffer.subarray(E,T))}set(E,T){if(E instanceof d)this.buffer.set(E.buffer,T);else if(E instanceof Uint8Array)this.buffer.set(E,T);else if(E instanceof ArrayBuffer)this.buffer.set(new Uint8Array(E),T);else if(ArrayBuffer.isView(E))this.buffer.set(new Uint8Array(E.buffer,E.byteOffset,E.byteLength),T);else throw new Error("Unknown argument 'array'")}readUInt32BE(E){return l(this.buffer,E)}writeUInt32BE(E,T){$(this.buffer,E,T)}readUInt32LE(E){return p(this.buffer,E)}writeUInt32LE(E,T){r(this.buffer,E,T)}readUInt8(E){return c(this.buffer,E)}writeUInt8(E,T){s(this.buffer,E,T)}indexOf(E,T=0){return y(this.buffer,E instanceof d?E.buffer:E,T)}}e.$ke=d;function y(v,E,T=0){const N=E.byteLength,J=v.byteLength;if(N===0)return 0;if(N===1)return v.indexOf(E[0]);if(N>J-T)return-1;const q=R.value;q.fill(E.length);for(let W=0;W<E.length;W++)q[E[W]]=E.length-W-1;let U=T+E.length-1,C=U,F=-1;for(;U<J;)if(v[U]===E[C]){if(C===0){F=U;break}U--,C--}else U+=Math.max(E.length-C,q[v[U]]),C=E.length-1;return F}e.$le=y;function A(v,E){return v[E+0]<<0>>>0|v[E+1]<<8>>>0}e.$me=A;function k(v,E,T){v[T+0]=E&255,E=E>>>8,v[T+1]=E&255}e.$ne=k;function l(v,E){return v[E]*2**24+v[E+1]*2**16+v[E+2]*2**8+v[E+3]}e.$oe=l;function $(v,E,T){v[T+3]=E,E=E>>>8,v[T+2]=E,E=E>>>8,v[T+1]=E,E=E>>>8,v[T]=E}e.$pe=$;function p(v,E){return v[E+0]<<0>>>0|v[E+1]<<8>>>0|v[E+2]<<16>>>0|v[E+3]<<24>>>0}e.$qe=p;function r(v,E,T){v[T+0]=E&255,E=E>>>8,v[T+1]=E&255,E=E>>>8,v[T+2]=E&255,E=E>>>8,v[T+3]=E&255}e.$re=r;function c(v,E){return v[E]}e.$se=c;function s(v,E,T){v[T]=E}e.$te=s;function i(v){return M.$_d(v,E=>d.concat(E))}e.$ue=i;function o(v){return M.$ge(v)}e.$ve=o;function a(v){return M.$be(v,E=>d.concat(E))}e.$we=a;async function u(v){return v.ended?d.concat(v.buffer):d.concat([...v.buffer,await a(v.stream)])}e.$xe=u;function t(v){return M.$ee(v,E=>d.concat(E))}e.$ye=t;function f(v){return M.$he(v,{data:E=>typeof E=="string"?d.fromString(E):d.wrap(E)},E=>d.concat(E))}e.$ze=f;function n(v){return M.$$d(E=>d.concat(E),v)}e.$Ae=n;function w(v,E){return M.$ie(v,E,T=>d.concat(T))}e.$Be=w;function D(v,E){return M.$je(v,E,T=>d.concat(T))}e.$Ce=D;function h(v){let E=0,T=0,N=0;const J=new Uint8Array(Math.floor(v.length/4*3)),q=C=>{switch(T){case 3:J[N++]=E|C,T=0;break;case 2:J[N++]=E|C>>>2,E=C<<6,T=3;break;case 1:J[N++]=E|C>>>4,E=C<<4,T=2;break;default:E=C<<2,T=1}};for(let C=0;C<v.length;C++){const F=v.charCodeAt(C);if(F>=65&&F<=90)q(F-65);else if(F>=97&&F<=122)q(F-97+26);else if(F>=48&&F<=57)q(F-48+52);else if(F===43||F===45)q(62);else if(F===47||F===95)q(63);else{if(F===61)break;throw new SyntaxError(`Unexpected base64 character ${v[C]}`)}}const U=N;for(;T>0;)q(0);return d.wrap(J).slice(0,U)}e.$De=h;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",P="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:v},E=!0,T=!1){const N=T?P:b;let J="";const q=v.byteLength%3;let U=0;for(;U<v.byteLength-q;U+=3){const C=v[U+0],F=v[U+1],W=v[U+2];J+=N[C>>>2],J+=N[(C<<4|F>>>4)&63],J+=N[(F<<2|W>>>6)&63],J+=N[W&63]}if(q===1){const C=v[U+0];J+=N[C>>>2],J+=N[C<<4&63],E&&(J+="==")}else if(q===2){const C=v[U+0],F=v[U+1];J+=N[C>>>2],J+=N[(C<<4|F>>>4)&63],J+=N[F<<2&63],E&&(J+="=")}return J}e.$Ee=g}),define(Re[124],Ae([1,0,28,121,14]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$j=e.$0j=e.$9j=e.$8j=e.FuzzyScore=e.$7j=e.$6j=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.or=void 0;function R(...fe){return function(ke,Ie){for(let O=0,K=fe.length;O<K;O++){const j=fe[O](ke,Ie);if(j)return j}return null}}e.or=R,e.$Vj=L.bind(void 0,!1),e.$Wj=L.bind(void 0,!0);function L(fe,ke,Ie){if(!Ie||Ie.length<ke.length)return null;let O;return fe?O=I.$bf(Ie,ke):O=Ie.indexOf(ke)===0,O?ke.length>0?[{start:0,end:ke.length}]:[]:null}function m(fe,ke){const Ie=ke.toLowerCase().indexOf(fe.toLowerCase());return Ie===-1?null:[{start:Ie,end:Ie+fe.length}]}e.$Xj=m;function d(fe,ke){return y(fe.toLowerCase(),ke.toLowerCase(),0,0)}e.$Yj=d;function y(fe,ke,Ie,O){if(Ie===fe.length)return[];if(O===ke.length)return null;if(fe[Ie]===ke[O]){let K=null;return(K=y(fe,ke,Ie+1,O+1))?a({start:O,end:O+1},K):null}return y(fe,ke,Ie,O+1)}function A(fe){return 97<=fe&&fe<=122}function k(fe){return 65<=fe&&fe<=90}e.$Zj=k;function l(fe){return 48<=fe&&fe<=57}function $(fe){return fe===32||fe===9||fe===10||fe===13}const p=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>p.add(fe.charCodeAt(0)));function r(fe){return $(fe)||p.has(fe)}function c(fe,ke){return fe===ke||r(fe)&&r(ke)}const s=new Map;function i(fe){if(s.has(fe))return s.get(fe);let ke;const Ie=(0,M.$Tj)(fe);return Ie&&(ke=Ie),s.set(fe,ke),ke}function o(fe){return A(fe)||k(fe)||l(fe)}function a(fe,ke){return ke.length===0?ke=[fe]:fe.end===ke[0].start?ke[0].start=fe.start:ke.unshift(fe),ke}function u(fe,ke){for(let Ie=ke;Ie<fe.length;Ie++){const O=fe.charCodeAt(Ie);if(k(O)||l(O)||Ie>0&&!o(fe.charCodeAt(Ie-1)))return Ie}return fe.length}function t(fe,ke,Ie,O){if(Ie===fe.length)return[];if(O===ke.length)return null;if(fe[Ie]!==ke[O].toLowerCase())return null;{let K=null,j=O+1;for(K=t(fe,ke,Ie+1,O+1);!K&&(j=u(ke,j))<ke.length;)K=t(fe,ke,Ie+1,j),j++;return K===null?null:a({start:O,end:O+1},K)}}function f(fe){let ke=0,Ie=0,O=0,K=0,j=0;for(let Be=0;Be<fe.length;Be++)j=fe.charCodeAt(Be),k(j)&&ke++,A(j)&&Ie++,o(j)&&O++,l(j)&&K++;const H=ke/fe.length,Z=Ie/fe.length,oe=O/fe.length,Ee=K/fe.length;return{upperPercent:H,lowerPercent:Z,alphaPercent:oe,numericPercent:Ee}}function n(fe){const{upperPercent:ke,lowerPercent:Ie}=fe;return Ie===0&&ke>.6}function w(fe){const{upperPercent:ke,lowerPercent:Ie,alphaPercent:O,numericPercent:K}=fe;return Ie>.2&&ke<.8&&O>.6&&K<.2}function D(fe){let ke=0,Ie=0,O=0,K=0;for(let j=0;j<fe.length;j++)O=fe.charCodeAt(j),k(O)&&ke++,A(O)&&Ie++,$(O)&&K++;return(ke===0||Ie===0)&&K===0?fe.length<=30:ke<=5}function h(fe,ke){if(!ke||(ke=ke.trim(),ke.length===0)||!D(fe)||ke.length>60)return null;const Ie=f(ke);if(!w(Ie)){if(!n(Ie))return null;ke=ke.toLowerCase()}let O=null,K=0;for(fe=fe.toLowerCase();K<ke.length&&(O=t(fe,ke,0,K))===null;)K=u(ke,K+1);return O}e.$1j=h;function b(fe,ke,Ie=!1){if(!ke||ke.length===0)return null;let O=null,K=0;for(fe=fe.toLowerCase(),ke=ke.toLowerCase();K<ke.length&&(O=P(fe,ke,0,K,Ie),O===null);)K=g(ke,K+1);return O}e.$2j=b;function P(fe,ke,Ie,O,K){let j=0;if(Ie===fe.length)return[];if(O===ke.length)return null;if(!c(fe.charCodeAt(Ie),ke.charCodeAt(O))){const oe=i(fe.charCodeAt(Ie));if(!oe)return null;for(let Ee=0;Ee<oe.length;Ee++)if(!c(oe[Ee],ke.charCodeAt(O+Ee)))return null;j+=oe.length-1}let H=null,Z=O+j+1;if(H=P(fe,ke,Ie+1,Z,K),!K)for(;!H&&(Z=g(ke,Z))<ke.length;)H=P(fe,ke,Ie+1,Z,K),Z++;if(!H)return null;if(fe.charCodeAt(Ie)!==ke.charCodeAt(O)){const oe=i(fe.charCodeAt(Ie));if(!oe)return H;for(let Ee=0;Ee<oe.length;Ee++)if(oe[Ee]!==ke.charCodeAt(O+Ee))return H}return a({start:O,end:O+j+1},H)}function g(fe,ke){for(let Ie=ke;Ie<fe.length;Ie++)if(r(fe.charCodeAt(Ie))||Ie>0&&r(fe.charCodeAt(Ie-1)))return Ie;return fe.length}const v=R(e.$Wj,h,m),E=R(e.$Wj,h,d),T=new S.$Dc(1e4);function N(fe,ke,Ie=!1){if(typeof fe!="string"||typeof ke!="string")return null;let O=T.get(fe);O||(O=new RegExp(I.$We(fe),"i"),T.set(fe,O));const K=O.exec(ke);return K?[{start:K.index,end:K.index+K[0].length}]:Ie?E(fe,ke):v(fe,ke)}e.$3j=N;function J(fe,ke){const Ie=be(fe,fe.toLowerCase(),0,ke,ke.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ie?U(Ie):null}e.$4j=J;function q(fe,ke,Ie,O,K,j){const H=Math.min(13,fe.length);for(;Ie<H;Ie++){const Z=be(fe,ke,Ie,O,K,j,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Z)return Z}return[0,j]}e.$5j=q;function U(fe){if(typeof fe>"u")return[];const ke=[],Ie=fe[1];for(let O=fe.length-1;O>1;O--){const K=fe[O]+Ie,j=ke[ke.length-1];j&&j.end===K?j.end=K+1:ke.push({start:K,end:K+1})}return ke}e.$6j=U;const C=128;function F(){const fe=[],ke=[];for(let Ie=0;Ie<=C;Ie++)ke[Ie]=0;for(let Ie=0;Ie<=C;Ie++)fe.push(ke.slice(0));return fe}function W(fe){const ke=[];for(let Ie=0;Ie<=fe;Ie++)ke[Ie]=0;return ke}const re=W(2*C),ce=W(2*C),we=F(),De=F(),le=F(),ve=!1;function se(fe,ke,Ie,O,K){function j(Z,oe,Ee=" "){for(;Z.length<oe;)Z=Ee+Z;return Z}let H=` |   |${O.split("").map(Z=>j(Z,3)).join("|")}
`;for(let Z=0;Z<=Ie;Z++)Z===0?H+=" |":H+=`${ke[Z-1]}|`,H+=fe[Z].slice(0,K+1).map(oe=>j(oe.toString(),3)).join("|")+`
`;return H}function $e(fe,ke,Ie,O){fe=fe.substr(ke),Ie=Ie.substr(O),console.log(se(De,fe,fe.length,Ie,Ie.length)),console.log(se(le,fe,fe.length,Ie,Ie.length)),console.log(se(we,fe,fe.length,Ie,Ie.length))}function te(fe,ke){if(ke<0||ke>=fe.length)return!1;const Ie=fe.codePointAt(ke);switch(Ie){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!I.$tf(Ie)}}function X(fe,ke){if(ke<0||ke>=fe.length)return!1;switch(fe.charCodeAt(ke)){case 32:case 9:return!0;default:return!1}}function V(fe,ke,Ie){return ke[fe]!==Ie[fe]}function ie(fe,ke,Ie,O,K,j,H=!1){for(;ke<Ie&&K<j;)fe[ke]===O[K]&&(H&&(re[ke]=K),ke+=1),K+=1;return ke===Ie}e.$7j=ie;var Ce;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(Ce||(Ce={}));var Te;(function(fe){fe.Default=[-100,0];function ke(Ie){return!Ie||Ie.length===2&&Ie[0]===-100&&Ie[1]===0}fe.isDefault=ke})(Te||(e.FuzzyScore=Te={}));class Pe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(ke,Ie){this.firstMatchCanBeWeak=ke,this.boostFullMatch=Ie}}e.$8j=Pe;function be(fe,ke,Ie,O,K,j,H=Pe.default){const Z=fe.length>C?C:fe.length,oe=O.length>C?C:O.length;if(Ie>=Z||j>=oe||Z-Ie>oe-j||!ie(ke,Ie,Z,K,j,oe,!0))return;ge(Z,oe,Ie,j,ke,K);let Ee=1,Be=1,We=Ie,Ze=j;const _e=[!1];for(Ee=1,We=Ie;We<Z;Ee++,We++){const je=re[We],vt=ce[We],Y=We+1<Z?ce[We+1]:oe;for(Be=je-j+1,Ze=je;Ze<Y;Be++,Ze++){let x=Number.MIN_SAFE_INTEGER,pe=!1;Ze<=vt&&(x=G(fe,ke,We,Ie,O,K,Ze,oe,j,we[Ee-1][Be-1]===0,_e));let Ve=0;x!==Number.MAX_SAFE_INTEGER&&(pe=!0,Ve=x+De[Ee-1][Be-1]);const Qe=Ze>je,nt=Qe?De[Ee][Be-1]+(we[Ee][Be-1]>0?-5:0):0,st=Ze>je+1&&we[Ee][Be-1]>0,Ne=st?De[Ee][Be-2]+(we[Ee][Be-2]>0?-5:0):0;if(st&&(!Qe||Ne>=nt)&&(!pe||Ne>=Ve))De[Ee][Be]=Ne,le[Ee][Be]=3,we[Ee][Be]=0;else if(Qe&&(!pe||nt>=Ve))De[Ee][Be]=nt,le[Ee][Be]=2,we[Ee][Be]=0;else if(pe)De[Ee][Be]=Ve,le[Ee][Be]=1,we[Ee][Be]=we[Ee-1][Be-1]+1;else throw new Error("not possible")}}if(ve&&$e(fe,Ie,O,j),!_e[0]&&!H.firstMatchCanBeWeak)return;Ee--,Be--;const at=[De[Ee][Be],j];let rt=0,et=0;for(;Ee>=1;){let je=Be;do{const vt=le[Ee][je];if(vt===3)je=je-2;else if(vt===2)je=je-1;else break}while(je>=1);rt>1&&ke[Ie+Ee-1]===K[j+Be-1]&&!V(je+j-1,O,K)&&rt+1>we[Ee][je]&&(je=Be),je===Be?rt++:rt=1,et||(et=je),Ee--,Be=je-1,at.push(Be)}oe===Z&&H.boostFullMatch&&(at[0]+=2);const ct=et-Z;return at[0]-=ct,at}e.$9j=be;function ge(fe,ke,Ie,O,K,j){let H=fe-1,Z=ke-1;for(;H>=Ie&&Z>=O;)K[H]===j[Z]&&(ce[H]=Z,H--),Z--}function G(fe,ke,Ie,O,K,j,H,Z,oe,Ee,Be){if(ke[Ie]!==j[H])return Number.MIN_SAFE_INTEGER;let We=1,Ze=!1;return H===Ie-O?We=fe[Ie]===K[H]?7:5:V(H,K,j)&&(H===0||!V(H-1,K,j))?(We=fe[Ie]===K[H]?7:5,Ze=!0):te(j,H)&&(H===0||!te(j,H-1))?We=5:(te(j,H-1)||X(j,H-1))&&(We=5,Ze=!0),We>1&&Ie===O&&(Be[0]=!0),Ze||(Ze=V(H,K,j)||te(j,H-1)||X(j,H-1)),Ie===O?H>oe&&(We-=Ze?3:5):Ee?We+=Ze?2:0:We+=Ze?0:1,H+1===Z&&(We-=Ze?3:5),We}function _(fe,ke,Ie,O,K,j,H){return de(fe,ke,Ie,O,K,j,!0,H)}e.$0j=_;function ue(fe,ke,Ie,O,K,j,H){return de(fe,ke,Ie,O,K,j,!1,H)}e.$$j=ue;function de(fe,ke,Ie,O,K,j,H,Z){let oe=be(fe,ke,Ie,O,K,j,Z);if(oe&&!H)return oe;if(fe.length>=3){const Ee=Math.min(7,fe.length-1);for(let Be=Ie+1;Be<Ee;Be++){const We=Le(fe,Be);if(We){const Ze=be(We,We.toLowerCase(),Ie,O,K,j,Z);Ze&&(Ze[0]-=3,(!oe||Ze[0]>oe[0])&&(oe=Ze))}}}return oe}function Le(fe,ke){if(ke+1>=fe.length)return;const Ie=fe[ke],O=fe[ke+1];if(Ie!==O)return fe.slice(0,ke)+O+Ie+fe.slice(ke+2)}}),define(Re[32],Ae([1,0,14]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(M||(M={})),function(I){const R="error",L="warning",m="warn",d="info",y="ignore";function A(l){return l?S.$af(R,l)?I.Error:S.$af(L,l)||S.$af(m,l)?I.Warning:S.$af(d,l)?I.Info:I.Ignore:I.Ignore}I.fromValue=A;function k(l){switch(l){case I.Error:return R;case I.Warning:return L;case I.Info:return d;default:return y}}I.toString=k}(M||(M={})),e.default=M}),define(Re[125],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Td=void 0,e.$Td=Symbol("MicrotaskDelay")}),define(Re[51],Ae([1,0,18,14]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=e.$_h=e.$$h=e.$0h=void 0;class I{constructor(){this.b="",this.c=0}reset($){return this.b=$,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp($){const p=$.charCodeAt(0),r=this.b.charCodeAt(this.c);return p-r}value(){return this.b[this.c]}}e.$0h=I;class R{constructor($=!0){this.e=$}reset($){return this.b=$,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let $=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if($)this.c++;else break;else $=!1;return this}cmp($){return this.e?(0,M.$7e)($,this.b,0,$.length,this.c,this.d):(0,M.$9e)($,this.b,0,$.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$$h=R;class L{constructor($=!0,p=!0){this.f=$,this.g=p}reset($){this.d=0,this.e=0,this.b=$,this.c=$.length;for(let p=$.length-1;p>=0;p--,this.c--){const r=this.b.charCodeAt(p);if(!(r===47||this.f&&r===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let $=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if($)this.d++;else break;else $=!1}return this}cmp($){return this.g?(0,M.$7e)($,this.b,0,$.length,this.d,this.e):(0,M.$9e)($,this.b,0,$.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$_h=L;var m;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(m||(m={}));class d{constructor($,p){this.f=$,this.g=p,this.d=[],this.e=0}reset($){return this.c=$,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new L(!1,!this.f($)),this.b.reset($.path),this.b.value()&&this.d.push(3)),this.g($)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp($){if(this.d[this.e]===1)return(0,M.$8e)($,this.c.scheme);if(this.d[this.e]===2)return(0,M.$8e)($,this.c.authority);if(this.d[this.e]===3)return this.b.cmp($);if(this.d[this.e]===4)return(0,M.$6e)($,this.c.query);if(this.d[this.e]===5)return(0,M.$6e)($,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$ai=d;class y{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const $=this.right;return this.right=$.left,$.left=this,this.updateHeight(),$.updateHeight(),$}rotateRight(){const $=this.left;return this.left=$.right,$.right=this,this.updateHeight(),$.updateHeight(),$}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(A||(A={}));class k{static forUris($=()=>!1,p=()=>!1){return new k(new d($,p))}static forPaths($=!1){return new k(new L(void 0,!$))}static forStrings(){return new k(new I)}static forConfigKeys(){return new k(new R)}constructor($){this.b=$}clear(){this.c=void 0}fill($,p){if(p){const r=p.slice(0);(0,S.$Xb)(r);for(const c of r)this.set(c,$)}else{const r=$.slice(0);(0,S.$Xb)(r);for(const c of r)this.set(c[0],c[1])}}set($,p){const r=this.b.reset($);let c;this.c||(this.c=new y,this.c.segment=r.value());const s=[];for(c=this.c;;){const o=r.cmp(c.segment);if(o>0)c.left||(c.left=new y,c.left.segment=r.value()),s.push([-1,c]),c=c.left;else if(o<0)c.right||(c.right=new y,c.right.segment=r.value()),s.push([1,c]),c=c.right;else if(r.hasNext())r.next(),c.mid||(c.mid=new y,c.mid.segment=r.value()),s.push([0,c]),c=c.mid;else break}const i=c.value;c.value=p,c.key=$;for(let o=s.length-1;o>=0;o--){const a=s[o][1];a.updateHeight();const u=a.balanceFactor();if(u<-1||u>1){const t=s[o][0],f=s[o+1][0];if(t===1&&f===1)s[o][1]=a.rotateLeft();else if(t===-1&&f===-1)s[o][1]=a.rotateRight();else if(t===1&&f===-1)a.right=s[o+1][1]=s[o+1][1].rotateRight(),s[o][1]=a.rotateLeft();else if(t===-1&&f===1)a.left=s[o+1][1]=s[o+1][1].rotateLeft(),s[o][1]=a.rotateRight();else throw new Error;if(o>0)switch(s[o-1][0]){case-1:s[o-1][1].left=s[o][1];break;case 1:s[o-1][1].right=s[o][1];break;case 0:s[o-1][1].mid=s[o][1];break}else this.c=s[0][1]}}return i}get($){return this.d($)?.value}d($){const p=this.b.reset($);let r=this.c;for(;r;){const c=p.cmp(r.segment);if(c>0)r=r.left;else if(c<0)r=r.right;else if(p.hasNext())p.next(),r=r.mid;else break}return r}has($){const p=this.d($);return!(p?.value===void 0&&p?.mid===void 0)}delete($){return this.e($,!1)}deleteSuperstr($){return this.e($,!0)}e($,p){const r=this.b.reset($),c=[];let s=this.c;for(;s;){const i=r.cmp(s.segment);if(i>0)c.push([-1,s]),s=s.left;else if(i<0)c.push([1,s]),s=s.right;else if(r.hasNext())r.next(),c.push([0,s]),s=s.mid;else break}if(s){if(p?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const i=this.f(s.right);if(i.key){const{key:o,value:a,segment:u}=i;this.e(i.key,!1),s.key=o,s.value=a,s.segment=u}}else{const i=s.left??s.right;if(c.length>0){const[o,a]=c[c.length-1];switch(o){case-1:a.left=i;break;case 0:a.mid=i;break;case 1:a.right=i;break}}else this.c=i}for(let i=c.length-1;i>=0;i--){const o=c[i][1];o.updateHeight();const a=o.balanceFactor();if(a>1?(o.right.balanceFactor()>=0||(o.right=o.right.rotateRight()),c[i][1]=o.rotateLeft()):a<-1&&(o.left.balanceFactor()<=0||(o.left=o.left.rotateLeft()),c[i][1]=o.rotateRight()),i>0)switch(c[i-1][0]){case-1:c[i-1][1].left=c[i][1];break;case 1:c[i-1][1].right=c[i][1];break;case 0:c[i-1][1].mid=c[i][1];break}else this.c=c[0][1]}}}f($){for(;$.left;)$=$.left;return $}findSubstr($){const p=this.b.reset($);let r=this.c,c;for(;r;){const s=p.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(p.hasNext())p.next(),c=r.value||c,r=r.mid;else break}return r&&r.value||c}findSuperstr($){return this.g($,!1)}g($,p){const r=this.b.reset($);let c=this.c;for(;c;){const s=r.cmp(c.segment);if(s>0)c=c.left;else if(s<0)c=c.right;else if(r.hasNext())r.next(),c=c.mid;else return c.mid?this.h(c.mid):p?c.value:void 0}}hasElementOrSubtree($){return this.g($,!0)!==void 0}forEach($){for(const[p,r]of this)$(r,p)}*[Symbol.iterator](){yield*this.h(this.c)}h($){const p=[];return this.j($,p),p[Symbol.iterator]()}j($,p){$&&($.left&&this.j($.left,p),$.value&&p.push([$.key,$.value]),$.mid&&this.j($.mid,p),$.right&&this.j($.right,p))}_isBalanced(){const $=p=>{if(!p)return!0;const r=p.balanceFactor();return r<-1||r>1?!1:$(p.left)&&$(p.right)};return $(this.c)}}e.$bi=k}),define(Re[40],Ae([1,0,89]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ck=e.ThemeColor=void 0;var M;(function(L){function m(d){return d&&typeof d=="object"&&typeof d.id=="string"}L.isThemeColor=m})(M||(e.ThemeColor=M={}));function I(L){return{id:L}}e.$ck=I;var R;(function(L){L.iconNameSegment="[A-Za-z0-9]+",L.iconNameExpression="[A-Za-z0-9-]+",L.iconModifierExpression="~[A-Za-z]+",L.iconNameCharacter="[A-Za-z0-9~-]";const m=new RegExp(`^(${L.iconNameExpression})(${L.iconModifierExpression})?$`);function d(i){const o=m.exec(i.id);if(!o)return d(S.$bk.error);const[,a,u]=o,t=["codicon","codicon-"+a];return u&&t.push("codicon-modifier-"+u.substring(1)),t}L.asClassNameArray=d;function y(i){return d(i).join(" ")}L.asClassName=y;function A(i){return"."+d(i).join(".")}L.asCSSSelector=A;function k(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||M.isThemeColor(i.color))}L.isThemeIcon=k;const l=new RegExp(`^\\$\\((${L.iconNameExpression}(?:${L.iconModifierExpression})?)\\)$`);function $(i){const o=l.exec(i);if(!o)return;const[,a]=o;return{id:a}}L.fromString=$;function p(i){return{id:i}}L.fromId=p;function r(i,o){let a=i.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),o&&(a=`${a}~${o}`),{id:a}}L.modify=r;function c(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}L.getModifier=c;function s(i,o){return i.id===o.id&&i.color?.id===o.color?.id}L.isEqual=s})(R||(e.ThemeIcon=R={}))}),define(Re[126],Ae([1,0,124,14,40]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ik=e.$hk=e.$gk=e.$fk=e.$ek=e.$dk=void 0;const R="$(",L=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),m=new RegExp(`(\\\\)?${L.source}`,"g");function d(s){return s.replace(m,(i,o)=>o?i:`\\${i}`)}e.$dk=d;const y=new RegExp(`\\\\${L.source}`,"g");function A(s){return s.replace(y,i=>`\\${i}`)}e.$ek=A;const k=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function l(s){return s.indexOf(R)===-1?s:s.replace(k,(i,o,a,u)=>a?i:o||u||"")}e.$fk=l;function $(s){return s?s.replace(/\$\((.*?)\)/g,(i,o)=>` ${o} `).trim():""}e.$gk=$;const p=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function r(s){p.lastIndex=0;let i="";const o=[];let a=0;for(;;){const u=p.lastIndex,t=p.exec(s),f=s.substring(u,t?.index);if(f.length>0){i+=f;for(let n=0;n<f.length;n++)o.push(a)}if(!t)break;a+=t[0].length}return{text:i,iconOffsets:o}}e.$hk=r;function c(s,i,o=!1){const{text:a,iconOffsets:u}=i;if(!u||u.length===0)return(0,S.$3j)(s,a,o);const t=(0,M.$Ue)(a," "),f=a.length-t.length,n=(0,S.$3j)(s,t,o);if(n)for(const w of n){const D=u[w.start+f]+f;w.start+=D,w.end+=D}return n}e.$ik=c}),define(Re[33],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rg=e.$qg=void 0;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(I){return S.test(I)}e.$qg=M,e.$rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let d=0;d<m.length;d++)m[d]=Math.floor(Math.random()*256);return m};const R=new Uint8Array(16),L=[];for(let m=0;m<256;m++)L.push(m.toString(16).padStart(2,"0"));return function(){I(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let d=0,y="";return y+=L[R[d++]],y+=L[R[d++]],y+=L[R[d++]],y+=L[R[d++]],y+="-",y+=L[R[d++]],y+=L[R[d++]],y+="-",y+=L[R[d++]],y+=L[R[d++]],y+="-",y+=L[R[d++]],y+=L[R[d++]],y+="-",y+=L[R[d++]],y+=L[R[d++]],y+=L[R[d++]],y+=L[R[d++]],y+=L[R[d++]],y+=L[R[d++]],y}}()}),define(Re[127],Ae([1,0,18,68,33]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=e.$st=e.$rt=e.$qt=e.$pt=void 0;function R(k){return{asString:async()=>k,asFile:()=>{},value:typeof k=="string"?k:void 0}}e.$pt=R;function L(k,l,$){const p={id:(0,I.$rg)(),name:k,uri:l,data:$};return{asString:async()=>"",asFile:()=>p,value:void 0}}e.$qt=L;class m{constructor(){this.a=new Map}get size(){let l=0;for(const $ of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const $=[...this.a.keys()];return M.Iterable.some(this,([p,r])=>r.asFile())&&$.push("files"),A(d(l),$)}get(l){return this.a.get(this.b(l))?.[0]}append(l,$){const p=this.a.get(l);p?p.push($):this.a.set(this.b(l),[$])}replace(l,$){this.a.set(this.b(l),[$])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,$]of this.a)for(const p of $)yield[l,p]}b(l){return d(l)}}e.$rt=m;function d(k){return k.toLowerCase()}function y(k,l){return A(d(k),l.map(d))}e.$st=y;function A(k,l){if(k==="*/*")return l.length>0;if(l.includes(k))return!0;const $=k.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!$)return!1;const[p,r,c]=$;return c==="*"?l.some(s=>s.startsWith(r+"/")):!1}e.$tt=Object.freeze({create:k=>(0,S.$Mb)(k.map(l=>l.toString())).join(`\r
`),split:k=>k.split(`\r
`),parse:k=>e.$tt.split(k).filter(l=>!l.startsWith("#"))})}),define(Re[128],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wt=e.StringEOL=void 0;var S;(function(I){I[I.Unknown=0]="Unknown",I[I.Invalid=3]="Invalid",I[I.LF=1]="LF",I[I.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function M(I){let R=0,L=0,m=0,d=0;for(let y=0,A=I.length;y<A;y++){const k=I.charCodeAt(y);k===13?(R===0&&(L=y),R++,y+1<A&&I.charCodeAt(y+1)===10?(d|=2,y++):d|=3,m=y+1):k===10&&(d|=1,R===0&&(L=y),R++,m=y+1)}return R===0&&(L=I.length),[R,L,I.length-m,d]}e.$wt=M}),define(Re[129],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=void 0,e.$us={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Re[130],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ut=e.$Tt=e.IndentAction=void 0;var S;(function(L){L[L.None=0]="None",L[L.Indent=1]="Indent",L[L.IndentOutdent=2]="IndentOutdent",L[L.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class M{constructor(m){if(this.e=null,this.f=!1,this.open=m.open,this.close=m.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(m.notIn))for(let d=0,y=m.notIn.length;d<y;d++)switch(m.notIn[d]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(m){switch(m){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(m,d){if(m.getTokenCount()===0)return!0;const y=m.findTokenIndexAtOffset(d-2),A=m.getStandardTokenType(y);return this.isOK(A)}g(m,d){for(let y=m;y<=d;y++){const A=String.fromCharCode(y);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Tt=M;class I{constructor(m){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const d of m)R(this.autoClosingPairsOpenByStart,d.open.charAt(0),d),R(this.autoClosingPairsOpenByEnd,d.open.charAt(d.open.length-1),d),R(this.autoClosingPairsCloseByStart,d.close.charAt(0),d),R(this.autoClosingPairsCloseByEnd,d.close.charAt(d.close.length-1),d),d.close.length===1&&d.open.length===1&&R(this.autoClosingPairsCloseSingleChar,d.close,d)}}e.$Ut=I;function R(L,m,d){L.has(m)?L.get(m).push(d):L.set(m,[d])}}),define(Re[131],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4B=e.$3B=e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.NodeColor=e.$UB=void 0;class S{constructor(c,s){this.piece=c,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$VB)return I(this.right);let c=this;for(;c.parent!==e.$VB&&c.parent.left!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}prev(){if(this.left!==e.$VB)return R(this.left);let c=this;for(;c.parent!==e.$VB&&c.parent.right!==c;)c=c.parent;return c.parent===e.$VB?e.$VB:c.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$UB=S;var M;(function(r){r[r.Black=0]="Black",r[r.Red=1]="Red"})(M||(e.NodeColor=M={})),e.$VB=new S(null,0),e.$VB.parent=e.$VB,e.$VB.left=e.$VB,e.$VB.right=e.$VB,e.$VB.color=0;function I(r){for(;r.left!==e.$VB;)r=r.left;return r}e.$WB=I;function R(r){for(;r.right!==e.$VB;)r=r.right;return r}e.$XB=R;function L(r){return r===e.$VB?0:r.size_left+r.piece.length+L(r.right)}function m(r){return r===e.$VB?0:r.lf_left+r.piece.lineFeedCnt+m(r.right)}function d(){e.$VB.parent=e.$VB}function y(r,c){const s=c.right;s.size_left+=c.size_left+(c.piece?c.piece.length:0),s.lf_left+=c.lf_left+(c.piece?c.piece.lineFeedCnt:0),c.right=s.left,s.left!==e.$VB&&(s.left.parent=c),s.parent=c.parent,c.parent===e.$VB?r.root=s:c.parent.left===c?c.parent.left=s:c.parent.right=s,s.left=c,c.parent=s}e.$YB=y;function A(r,c){const s=c.left;c.left=s.right,s.right!==e.$VB&&(s.right.parent=c),s.parent=c.parent,c.size_left-=s.size_left+(s.piece?s.piece.length:0),c.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),c.parent===e.$VB?r.root=s:c===c.parent.right?c.parent.right=s:c.parent.left=s,s.right=c,c.parent=s}e.$ZB=A;function k(r,c){let s,i;if(c.left===e.$VB?(i=c,s=i.right):c.right===e.$VB?(i=c,s=i.left):(i=I(c.right),s=i.right),i===r.root){r.root=s,s.color=0,c.detach(),d(),r.root.parent=e.$VB;return}const o=i.color===1;if(i===i.parent.left?i.parent.left=s:i.parent.right=s,i===c?(s.parent=i.parent,p(r,s)):(i.parent===c?s.parent=i:s.parent=i.parent,p(r,s),i.left=c.left,i.right=c.right,i.parent=c.parent,i.color=c.color,c===r.root?r.root=i:c===c.parent.left?c.parent.left=i:c.parent.right=i,i.left!==e.$VB&&(i.left.parent=i),i.right!==e.$VB&&(i.right.parent=i),i.size_left=c.size_left,i.lf_left=c.lf_left,p(r,i)),c.detach(),s.parent.left===s){const u=L(s),t=m(s);if(u!==s.parent.size_left||t!==s.parent.lf_left){const f=u-s.parent.size_left,n=t-s.parent.lf_left;s.parent.size_left=u,s.parent.lf_left=t,$(r,s.parent,f,n)}}if(p(r,s.parent),o){d();return}let a;for(;s!==r.root&&s.color===0;)s===s.parent.left?(a=s.parent.right,a.color===1&&(a.color=0,s.parent.color=1,y(r,s.parent),a=s.parent.right),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.right.color===0&&(a.left.color=0,a.color=1,A(r,a),a=s.parent.right),a.color=s.parent.color,s.parent.color=0,a.right.color=0,y(r,s.parent),s=r.root)):(a=s.parent.left,a.color===1&&(a.color=0,s.parent.color=1,A(r,s.parent),a=s.parent.left),a.left.color===0&&a.right.color===0?(a.color=1,s=s.parent):(a.left.color===0&&(a.right.color=0,a.color=1,y(r,a),a=s.parent.left),a.color=s.parent.color,s.parent.color=0,a.left.color=0,A(r,s.parent),s=r.root));s.color=0,d()}e.$1B=k;function l(r,c){for(p(r,c);c!==r.root&&c.parent.color===1;)if(c.parent===c.parent.parent.left){const s=c.parent.parent.right;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.right&&(c=c.parent,y(r,c)),c.parent.color=0,c.parent.parent.color=1,A(r,c.parent.parent))}else{const s=c.parent.parent.left;s.color===1?(c.parent.color=0,s.color=0,c.parent.parent.color=1,c=c.parent.parent):(c===c.parent.left&&(c=c.parent,A(r,c)),c.parent.color=0,c.parent.parent.color=1,y(r,c.parent.parent))}r.root.color=0}e.$2B=l;function $(r,c,s,i){for(;c!==r.root&&c!==e.$VB;)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}e.$3B=$;function p(r,c){let s=0,i=0;if(c!==r.root){for(;c!==r.root&&c===c.parent.right;)c=c.parent;if(c!==r.root)for(c=c.parent,s=L(c.left)-c.size_left,i=m(c.left)-c.lf_left,c.size_left+=s,c.lf_left+=i;c!==r.root&&(s!==0||i!==0);)c.parent.left===c&&(c.parent.size_left+=s,c.parent.lf_left+=i),c=c.parent}}e.$4B=p}),define(Re[90],Ae([1,0,91,29,92,131,93]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=e.$bC=e.$aC=e.$_B=e.$$B=void 0;const m=65535;function d(s){let i;return s[s.length-1]<65536?i=new Uint16Array(s.length):i=new Uint32Array(s.length),i.set(s,0),i}class y{constructor(i,o,a,u,t){this.lineStarts=i,this.cr=o,this.lf=a,this.crlf=u,this.isBasicASCII=t}}function A(s,i=!0){const o=[0];let a=1;for(let u=0,t=s.length;u<t;u++){const f=s.charCodeAt(u);f===13?u+1<t&&s.charCodeAt(u+1)===10?(o[a++]=u+2,u++):o[a++]=u+1:f===10&&(o[a++]=u+1)}return i?d(o):o}e.$$B=A;function k(s,i){s.length=0,s[0]=0;let o=1,a=0,u=0,t=0,f=!0;for(let w=0,D=i.length;w<D;w++){const h=i.charCodeAt(w);h===13?w+1<D&&i.charCodeAt(w+1)===10?(t++,s[o++]=w+2,w++):(a++,s[o++]=w+1):h===10?(u++,s[o++]=w+1):f&&h!==9&&(h<32||h>126)&&(f=!1)}const n=new y(d(s),a,u,t,f);return s.length=0,n}e.$_B=k;class l{constructor(i,o,a,u,t){this.bufferIndex=i,this.start=o,this.end=a,this.lineFeedCnt=u,this.length=t}}e.$aC=l;class ${constructor(i,o){this.buffer=i,this.lineStarts=o}}e.$bC=$;class p{constructor(i,o){this.a=[],this.c=i,this.d=o,this.b=0,i.root!==R.$VB&&i.iterate(i.root,a=>(a!==R.$VB&&this.a.push(a.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class r{constructor(i){this.a=i,this.b=[]}get(i){for(let o=this.b.length-1;o>=0;o--){const a=this.b[o];if(a.nodeStartOffset<=i&&a.nodeStartOffset+a.node.piece.length>=i)return a}return null}get2(i){for(let o=this.b.length-1;o>=0;o--){const a=this.b[o];if(a.nodeStartLineNumber&&a.nodeStartLineNumber<i&&a.nodeStartLineNumber+a.node.piece.lineFeedCnt>=i)return a}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let o=!1;const a=this.b;for(let u=0;u<a.length;u++){const t=a[u];if(t.node.parent===null||t.nodeStartOffset>=i){a[u]=null,o=!0;continue}}if(o){const u=[];for(const t of a)t!==null&&u.push(t);this.b=u}}}class c{constructor(i,o,a){this.create(i,o,a)}create(i,o,a){this.a=[new $("",[0])],this.g={line:0,column:0},this.root=R.$VB,this.b=1,this.c=0,this.d=o,this.e=o.length,this.f=a;let u=null;for(let t=0,f=i.length;t<f;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const n=new l(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),u=this.S(u,n)}this.h=new r(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const o=m,a=o-Math.floor(o/3),u=a*2;let t="",f=0;const n=[];if(this.iterate(this.root,w=>{const D=this.R(w),h=D.length;if(f<=a||f+h<u)return t+=D,f+=h,!0;const b=t.replace(/\r\n|\r|\n/g,i);return n.push(new $(b,A(b))),t=D,f=h,!0}),f>0){const w=t.replace(/\r\n|\r|\n/g,i);n.push(new $(w,A(w)))}this.create(n,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new p(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let o=0;return this.iterate(this.root,u=>{if(u===R.$VB)return!0;const t=this.R(u),f=t.length,n=i.G(o),w=i.G(o+f),D=i.getValueInRange2(n,w);return o+=f,t===D})}getOffsetAt(i,o){let a=0,u=this.root;for(;u!==R.$VB;)if(u.left!==R.$VB&&u.lf_left+1>=i)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=i){a+=u.size_left;const t=this.B(u,i-u.lf_left-2);return a+=t+o-1}else i-=u.lf_left+u.piece.lineFeedCnt,a+=u.size_left+u.piece.length,u=u.right;return a}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let o=this.root,a=0;const u=i;for(;o!==R.$VB;)if(o.size_left!==0&&o.size_left>=i)o=o.left;else if(o.size_left+o.piece.length>=i){const t=this.A(o,i-o.size_left);if(a+=o.lf_left+t.index,t.index===0){const f=this.getOffsetAt(a+1,1),n=u-f;return new S.$Vs(a+1,n+1)}return new S.$Vs(a+1,t.remainder+1)}else if(i-=o.size_left+o.piece.length,a+=o.lf_left+o.piece.lineFeedCnt,o.right===R.$VB){const t=this.getOffsetAt(a+1,1),f=u-i-t;return new S.$Vs(a+1,f+1)}else o=o.right;return new S.$Vs(1,1)}getValueInRange(i,o){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const a=this.H(i.startLineNumber,i.startColumn),u=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(a,u);return o?o!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,o):o===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,o):t}getValueInRange2(i,o){if(i.node===o.node){const n=i.node,w=this.a[n.piece.bufferIndex].buffer,D=this.u(n.piece.bufferIndex,n.piece.start);return w.substring(D+i.remainder,D+o.remainder)}let a=i.node;const u=this.a[a.piece.bufferIndex].buffer,t=this.u(a.piece.bufferIndex,a.piece.start);let f=u.substring(t+i.remainder,t+a.piece.length);for(a=a.next();a!==R.$VB;){const n=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);if(a===o.node){f+=n.substring(w,w+o.remainder);break}else f+=n.substr(w,a.piece.length);a=a.next()}return f}getLinesContent(){const i=[];let o=0,a="",u=!1;return this.iterate(this.root,t=>{if(t===R.$VB)return!0;const f=t.piece;let n=f.length;if(n===0)return!0;const w=this.a[f.bufferIndex].buffer,D=this.a[f.bufferIndex].lineStarts,h=f.start.line,b=f.end.line;let P=D[h]+f.start.column;if(u&&(w.charCodeAt(P)===10&&(P++,n--),i[o++]=a,a="",u=!1,n===0))return!0;if(h===b)return!this.f&&w.charCodeAt(P+n-1)===13?(u=!0,a+=w.substr(P,n-1)):a+=w.substr(P,n),!0;a+=this.f?w.substring(P,Math.max(P,D[h+1]-this.e)):w.substring(P,D[h+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=a;for(let g=h+1;g<b;g++)a=this.f?w.substring(D[g],D[g+1]-this.e):w.substring(D[g],D[g+1]).replace(/(\r\n|\r|\n)$/,""),i[o++]=a;return!this.f&&w.charCodeAt(D[b]+f.end.column-1)===13?(u=!0,f.end.column===0?o--:a=w.substr(D[b],f.end.column-1)):a=w.substr(D[b],f.end.column),!0}),u&&(i[o++]=a,a=""),i[o++]=a,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const o=i.node.next();if(!o)return 0;const a=this.a[o.piece.bufferIndex],u=this.u(o.piece.bufferIndex,o.piece.start);return a.buffer.charCodeAt(u)}else{const o=this.a[i.node.piece.bufferIndex],u=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return o.buffer.charCodeAt(u)}}getLineCharCode(i,o){const a=this.H(i,o+1);return this.l(a)}getLineLength(i){if(i===this.getLineCount()){const o=this.getOffsetAt(i,1);return this.getLength()-o}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const o=this.G(i);return this.l(o)}findMatchesInNode(i,o,a,u,t,f,n,w,D,h,b){const P=this.a[i.piece.bufferIndex],g=this.u(i.piece.bufferIndex,i.piece.start),v=this.u(i.piece.bufferIndex,t),E=this.u(i.piece.bufferIndex,f);let T;const N={line:0,column:0};let J,q;o._wordSeparators?(J=P.buffer.substring(v,E),q=U=>U+v,o.reset(0)):(J=P.buffer,q=U=>U,o.reset(v));do if(T=o.next(J),T){if(q(T.index)>=E)return h;this.s(i,q(T.index)-g,N);const U=this.t(i.piece.bufferIndex,t,N),C=N.line===t.line?N.column-t.column+u:N.column+1,F=C+T[0].length;if(b[h++]=(0,L.$7B)(new M.$Ws(a+U,C,a+U,F),T,w),q(T.index)+T[0].length>=E||h>=D)return h}while(T);return h}findMatchesLineByLine(i,o,a,u){const t=[];let f=0;const n=new L.$0B(o.wordSeparators,o.regex);let w=this.H(i.startLineNumber,i.startColumn);if(w===null)return[];const D=this.H(i.endLineNumber,i.endColumn);if(D===null)return[];let h=this.s(w.node,w.remainder);const b=this.s(D.node,D.remainder);if(w.node===D.node)return this.findMatchesInNode(w.node,n,i.startLineNumber,i.startColumn,h,b,o,a,u,f,t),t;let P=i.startLineNumber,g=w.node;for(;g!==D.node;){const E=this.t(g.piece.bufferIndex,h,g.piece.end);if(E>=1){const N=this.a[g.piece.bufferIndex].lineStarts,J=this.u(g.piece.bufferIndex,g.piece.start),q=N[h.line+E],U=P===i.startLineNumber?i.startColumn:1;if(f=this.findMatchesInNode(g,n,P,U,h,this.s(g,q-J),o,a,u,f,t),f>=u)return t;P+=E}const T=P===i.startLineNumber?i.startColumn-1:0;if(P===i.endLineNumber){const N=this.getLineContent(P).substring(T,i.endColumn-1);return f=this.n(o,n,N,i.endLineNumber,T,f,t,a,u),t}if(f=this.n(o,n,this.getLineContent(P).substr(T),P,T,f,t,a,u),f>=u)return t;P++,w=this.H(P,1),g=w.node,h=this.s(w.node,w.remainder)}if(P===i.endLineNumber){const E=P===i.startLineNumber?i.startColumn-1:0,T=this.getLineContent(P).substring(E,i.endColumn-1);return f=this.n(o,n,T,i.endLineNumber,E,f,t,a,u),t}const v=P===i.startLineNumber?i.startColumn:1;return f=this.findMatchesInNode(D.node,n,P,v,h,b,o,a,u,f,t),t}n(i,o,a,u,t,f,n,w,D){const h=i.wordSeparators;if(!w&&i.simpleSearch){const P=i.simpleSearch,g=P.length,v=a.length;let E=-g;for(;(E=a.indexOf(P,E+g))!==-1;)if((!h||(0,L.$9B)(h,a,v,E,g))&&(n[f++]=new I.$cv(new M.$Ws(u,E+1+t,u,E+1+g+t),null),f>=D))return f;return f}let b;o.reset(0);do if(b=o.next(a),b&&(n[f++]=(0,L.$7B)(new M.$Ws(u,b.index+1+t,u,b.index+1+b[0].length+t),b,w),f>=D))return f;while(b);return f}insert(i,o,a=!1){if(this.f=this.f&&a,this.j.lineNumber=0,this.j.value="",this.root!==R.$VB){const{node:u,remainder:t,nodeStartOffset:f}=this.G(i),n=u.piece,w=n.bufferIndex,D=this.s(u,t);if(u.piece.bufferIndex===0&&n.end.line===this.g.line&&n.end.column===this.g.column&&f+n.length===i&&o.length<m){this.F(u,o),this.y();return}if(f===i)this.o(o,u),this.h.validate(i);else if(f+u.piece.length>i){const h=[];let b=new l(n.bufferIndex,D,n.end,this.t(n.bufferIndex,D,n.end),this.u(w,n.end)-this.u(w,D));if(this.K()&&this.M(o)&&this.I(u,t)===10){const E={line:b.start.line+1,column:0};b=new l(b.bufferIndex,E,b.end,this.t(b.bufferIndex,E,b.end),b.length-1),o+=`
`}if(this.K()&&this.L(o))if(this.I(u,t-1)===13){const E=this.s(u,t-1);this.C(u,E),o="\r"+o,u.piece.length===0&&h.push(u)}else this.C(u,D);else this.C(u,D);const P=this.w(o);b.length>0&&this.S(u,b);let g=u;for(let v=0;v<P.length;v++)g=this.S(g,P[v]);this.v(h)}else this.q(o,u)}else{const u=this.w(o);let t=this.T(null,u[0]);for(let f=1;f<u.length;f++)t=this.S(t,u[f])}this.y()}delete(i,o){if(this.j.lineNumber=0,this.j.value="",o<=0||this.root===R.$VB)return;const a=this.G(i),u=this.G(i+o),t=a.node,f=u.node;if(t===f){const P=this.s(t,a.remainder),g=this.s(t,u.remainder);if(a.nodeStartOffset===i){if(o===t.piece.length){const v=t.next();(0,R.$1B)(this,t),this.N(v),this.y();return}this.D(t,g),this.h.validate(i),this.N(t),this.y();return}if(a.nodeStartOffset+t.piece.length===i+o){this.C(t,P),this.O(t),this.y();return}this.E(t,P,g),this.y();return}const n=[],w=this.s(t,a.remainder);this.C(t,w),this.h.validate(i),t.piece.length===0&&n.push(t);const D=this.s(f,u.remainder);this.D(f,D),f.piece.length===0&&n.push(f);const h=t.next();for(let P=h;P!==R.$VB&&P!==f;P=P.next())n.push(P);const b=t.piece.length===0?t.prev():t;this.v(n),this.O(b),this.y()}o(i,o){const a=[];if(this.K()&&this.M(i)&&this.L(o)){const f=o.piece,n={line:f.start.line+1,column:0},w=new l(f.bufferIndex,n,f.end,this.t(f.bufferIndex,n,f.end),f.length-1);o.piece=w,i+=`
`,(0,R.$3B)(this,o,-1,-1),o.piece.length===0&&a.push(o)}const u=this.w(i);let t=this.T(o,u[u.length-1]);for(let f=u.length-2;f>=0;f--)t=this.T(t,u[f]);this.N(t),this.v(a)}q(i,o){this.Q(i,o)&&(i+=`
`);const a=this.w(i),u=this.S(o,a[0]);let t=u;for(let f=1;f<a.length;f++)t=this.S(t,a[f]);this.N(u)}s(i,o,a){const u=i.piece,t=i.piece.bufferIndex,f=this.a[t].lineStarts,w=f[u.start.line]+u.start.column+o;let D=u.start.line,h=u.end.line,b=0,P=0,g=0;for(;D<=h&&(b=D+(h-D)/2|0,g=f[b],b!==h);)if(P=f[b+1],w<g)h=b-1;else if(w>=P)D=b+1;else break;return a?(a.line=b,a.column=w-g,null):{line:b,column:w-g}}t(i,o,a){if(a.column===0)return a.line-o.line;const u=this.a[i].lineStarts;if(a.line===u.length-1)return a.line-o.line;const t=u[a.line+1],f=u[a.line]+a.column;if(t>f+1)return a.line-o.line;const n=f-1;return this.a[i].buffer.charCodeAt(n)===13?a.line-o.line+1:a.line-o.line}u(i,o){return this.a[i].lineStarts[o.line]+o.column}v(i){for(let o=0;o<i.length;o++)(0,R.$1B)(this,i[o])}w(i){if(i.length>m){const h=[];for(;i.length>m;){const P=i.charCodeAt(m-1);let g;P===13||P>=55296&&P<=56319?(g=i.substring(0,m-1),i=i.substring(m-1)):(g=i.substring(0,m),i=i.substring(m));const v=A(g);h.push(new l(this.a.length,{line:0,column:0},{line:v.length-1,column:g.length-v[v.length-1]},v.length-1,g.length)),this.a.push(new $(g,v))}const b=A(i);return h.push(new l(this.a.length,{line:0,column:0},{line:b.length-1,column:i.length-b[b.length-1]},b.length-1,i.length)),this.a.push(new $(i,b)),h}let o=this.a[0].buffer.length;const a=A(i,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===o&&o!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let h=0;h<a.length;h++)a[h]+=o+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+="_"+i,o+=1}else{if(o!==0)for(let h=0;h<a.length;h++)a[h]+=o;this.a[0].lineStarts=this.a[0].lineStarts.concat(a.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,f=this.a[0].lineStarts.length-1,n=t-this.a[0].lineStarts[f],w={line:f,column:n},D=new l(0,u,w,this.t(0,u,w),t-o);return this.g=w,[D]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,o=0){let a=this.root,u="";const t=this.h.get2(i);if(t){a=t.node;const f=this.B(a,i-t.nodeStartLineNumber-1),n=this.a[a.piece.bufferIndex].buffer,w=this.u(a.piece.bufferIndex,a.piece.start);if(t.nodeStartLineNumber+a.piece.lineFeedCnt===i)u=n.substring(w+f,w+a.piece.length);else{const D=this.B(a,i-t.nodeStartLineNumber);return n.substring(w+f,w+D-o)}}else{let f=0;const n=i;for(;a!==R.$VB;)if(a.left!==R.$VB&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const w=this.B(a,i-a.lf_left-2),D=this.B(a,i-a.lf_left-1),h=this.a[a.piece.bufferIndex].buffer,b=this.u(a.piece.bufferIndex,a.piece.start);return f+=a.size_left,this.h.set({node:a,nodeStartOffset:f,nodeStartLineNumber:n-(i-1-a.lf_left)}),h.substring(b+w,b+D-o)}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const w=this.B(a,i-a.lf_left-2),D=this.a[a.piece.bufferIndex].buffer,h=this.u(a.piece.bufferIndex,a.piece.start);u=D.substring(h+w,h+a.piece.length);break}else i-=a.lf_left+a.piece.lineFeedCnt,f+=a.size_left+a.piece.length,a=a.right}for(a=a.next();a!==R.$VB;){const f=this.a[a.piece.bufferIndex].buffer;if(a.piece.lineFeedCnt>0){const n=this.B(a,0),w=this.u(a.piece.bufferIndex,a.piece.start);return u+=f.substring(w,w+n-o),u}else{const n=this.u(a.piece.bufferIndex,a.piece.start);u+=f.substr(n,a.piece.length)}a=a.next()}return u}y(){let i=this.root,o=1,a=0;for(;i!==R.$VB;)o+=i.lf_left+i.piece.lineFeedCnt,a+=i.size_left+i.piece.length,i=i.right;this.b=o,this.c=a,this.h.validate(this.c)}A(i,o){const a=i.piece,u=this.s(i,o),t=u.line-a.start.line;if(this.u(a.bufferIndex,a.end)-this.u(a.bufferIndex,a.start)===o){const f=this.t(i.piece.bufferIndex,a.start,u);if(f!==t)return{index:f,remainder:0}}return{index:t,remainder:u.column}}B(i,o){if(o<0)return 0;const a=i.piece,u=this.a[a.bufferIndex].lineStarts,t=a.start.line+o+1;return t>a.end.line?u[a.end.line]+a.end.column-u[a.start.line]-a.start.column:u[t]-u[a.start.line]-a.start.column}C(i,o){const a=i.piece,u=a.lineFeedCnt,t=this.u(a.bufferIndex,a.end),f=o,n=this.u(a.bufferIndex,f),w=this.t(a.bufferIndex,a.start,f),D=w-u,h=n-t,b=a.length+h;i.piece=new l(a.bufferIndex,a.start,f,w,b),(0,R.$3B)(this,i,h,D)}D(i,o){const a=i.piece,u=a.lineFeedCnt,t=this.u(a.bufferIndex,a.start),f=o,n=this.t(a.bufferIndex,f,a.end),w=this.u(a.bufferIndex,f),D=n-u,h=t-w,b=a.length+h;i.piece=new l(a.bufferIndex,f,a.end,n,b),(0,R.$3B)(this,i,h,D)}E(i,o,a){const u=i.piece,t=u.start,f=u.end,n=u.length,w=u.lineFeedCnt,D=o,h=this.t(u.bufferIndex,u.start,D),b=this.u(u.bufferIndex,o)-this.u(u.bufferIndex,t);i.piece=new l(u.bufferIndex,u.start,D,h,b),(0,R.$3B)(this,i,b-n,h-w);const P=new l(u.bufferIndex,a,f,this.t(u.bufferIndex,a,f),this.u(u.bufferIndex,f)-this.u(u.bufferIndex,a)),g=this.S(i,P);this.N(g)}F(i,o){this.Q(o,i)&&(o+=`
`);const a=this.K()&&this.L(o)&&this.M(i),u=this.a[0].buffer.length;this.a[0].buffer+=o;const t=A(o,!1);for(let g=0;g<t.length;g++)t[g]+=u;if(a){const g=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-g}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const f=this.a[0].lineStarts.length-1,n=this.a[0].buffer.length-this.a[0].lineStarts[f],w={line:f,column:n},D=i.piece.length+o.length,h=i.piece.lineFeedCnt,b=this.t(0,i.piece.start,w),P=b-h;i.piece=new l(i.piece.bufferIndex,i.piece.start,w,b,D),this.g=w,(0,R.$3B)(this,i,o.length,P)}G(i){let o=this.root;const a=this.h.get(i);if(a)return{node:a.node,nodeStartOffset:a.nodeStartOffset,remainder:i-a.nodeStartOffset};let u=0;for(;o!==R.$VB;)if(o.size_left>i)o=o.left;else if(o.size_left+o.piece.length>=i){u+=o.size_left;const t={node:o,remainder:i-o.size_left,nodeStartOffset:u};return this.h.set(t),t}else i-=o.size_left+o.piece.length,u+=o.size_left+o.piece.length,o=o.right;return null}H(i,o){let a=this.root,u=0;for(;a!==R.$VB;)if(a.left!==R.$VB&&a.lf_left>=i-1)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt>i-1){const t=this.B(a,i-a.lf_left-2),f=this.B(a,i-a.lf_left-1);return u+=a.size_left,{node:a,remainder:Math.min(t+o-1,f),nodeStartOffset:u}}else if(a.lf_left+a.piece.lineFeedCnt===i-1){const t=this.B(a,i-a.lf_left-2);if(t+o-1<=a.piece.length)return{node:a,remainder:t+o-1,nodeStartOffset:u};o-=a.piece.length-t;break}else i-=a.lf_left+a.piece.lineFeedCnt,u+=a.size_left+a.piece.length,a=a.right;for(a=a.next();a!==R.$VB;){if(a.piece.lineFeedCnt>0){const t=this.B(a,0),f=this.J(a);return{node:a,remainder:Math.min(o-1,t),nodeStartOffset:f}}else if(a.piece.length>=o-1){const t=this.J(a);return{node:a,remainder:o-1,nodeStartOffset:t}}else o-=a.piece.length;a=a.next()}return null}I(i,o){if(i.piece.lineFeedCnt<1)return-1;const a=this.a[i.piece.bufferIndex],u=this.u(i.piece.bufferIndex,i.piece.start)+o;return a.buffer.charCodeAt(u)}J(i){if(!i)return 0;let o=i.size_left;for(;i!==this.root;)i.parent.right===i&&(o+=i.parent.size_left+i.parent.piece.length),i=i.parent;return o}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===R.$VB||i.piece.lineFeedCnt===0)return!1;const o=i.piece,a=this.a[o.bufferIndex].lineStarts,u=o.start.line,t=a[u]+o.start.column;return u===a.length-1||a[u+1]>t+1?!1:this.a[o.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===R.$VB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const o=i.prev();this.M(o)&&this.P(o,i)}}O(i){if(this.K()&&this.M(i)){const o=i.next();this.L(o)&&this.P(i,o)}}P(i,o){const a=[],u=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:u[i.piece.end.line]-u[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const f=i.piece.length-1,n=i.piece.lineFeedCnt-1;i.piece=new l(i.piece.bufferIndex,i.piece.start,t,n,f),(0,R.$3B)(this,i,-1,-1),i.piece.length===0&&a.push(i);const w={line:o.piece.start.line+1,column:0},D=o.piece.length-1,h=this.t(o.piece.bufferIndex,w,o.piece.end);o.piece=new l(o.piece.bufferIndex,w,o.piece.end,h,D),(0,R.$3B)(this,o,-1,-1),o.piece.length===0&&a.push(o);const b=this.w(`\r
`);this.S(i,b[0]);for(let P=0;P<a.length;P++)(0,R.$1B)(this,a[P])}Q(i,o){if(this.K()&&this.M(i)){const a=o.next();if(this.L(a)){if(i+=`
`,a.piece.length===1)(0,R.$1B)(this,a);else{const u=a.piece,t={line:u.start.line+1,column:0},f=u.length-1,n=this.t(u.bufferIndex,t,u.end);a.piece=new l(u.bufferIndex,t,u.end,n,f),(0,R.$3B)(this,a,-1,-1)}return!0}}return!1}iterate(i,o){if(i===R.$VB)return o(R.$VB);const a=this.iterate(i.left,o);return a&&o(i)&&this.iterate(i.right,o)}R(i){if(i===R.$VB)return"";const o=this.a[i.piece.bufferIndex],a=i.piece,u=this.u(a.bufferIndex,a.start),t=this.u(a.bufferIndex,a.end);return o.buffer.substring(u,t)}getPieceContent(i){const o=this.a[i.bufferIndex],a=this.u(i.bufferIndex,i.start),u=this.u(i.bufferIndex,i.end);return o.buffer.substring(a,u)}S(i,o){const a=new R.$UB(o,1);if(a.left=R.$VB,a.right=R.$VB,a.parent=R.$VB,a.size_left=0,a.lf_left=0,this.root===R.$VB)this.root=a,a.color=0;else if(i.right===R.$VB)i.right=a,a.parent=i;else{const t=(0,R.$WB)(i.right);t.left=a,a.parent=t}return(0,R.$2B)(this,a),a}T(i,o){const a=new R.$UB(o,1);if(a.left=R.$VB,a.right=R.$VB,a.parent=R.$VB,a.size_left=0,a.lf_left=0,this.root===R.$VB)this.root=a,a.color=0;else if(i.left===R.$VB)i.left=a,a.parent=i;else{const u=(0,R.$XB)(i.left);u.right=a,a.parent=u}return(0,R.$2B)(this,a),a}U(i){let o="";return this.iterate(i,a=>(o+=this.R(a),!0)),o}}e.$cC=c}),define(Re[132],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P8=e.$O8=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(R){if(R&&this.a.has(R)){const L=this.a.get(R);return this.a.delete(R),L}}addDragOperationTransfer(R,L){this.a.set(R,L)}}e.$O8=S;class M{constructor(R){this.identifier=R}}e.$P8=M}),define(Re[133],Ae([9,10]),function(me,e){return me.create("vs/base/common/actions",e)}),define(Re[134],Ae([1,0,5,6,133]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ri=e.$Qi=e.$Pi=e.$Oi=e.$Ni=e.$Mi=void 0;class R extends M.$Tc{constructor(l,$="",p="",r=!0,c){super(),this.h=this.B(new S.$Wd),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=$,this.u=p,this.w=r,this.C=c}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,$){this.C&&await this.C(l)}}e.$Mi=R;class L extends M.$Tc{constructor(){super(...arguments),this.f=this.B(new S.$Wd),this.onWillRun=this.f.event,this.m=this.B(new S.$Wd),this.onDidRun=this.m.event}async run(l,$){if(!l.enabled)return;this.f.fire({action:l});let p;try{await this.u(l,$)}catch(r){p=r}this.m.fire({action:l,error:p})}async u(l,$){await l.run($)}}e.$Ni=L;class m{constructor(){this.id=m.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let $=[];for(const p of l)p.length&&($.length?$=[...$,new m,...p]:$=p);return $}static{this.ID="vs.actions.separator"}async run(){}}e.$Oi=m;class d{get actions(){return this.a}constructor(l,$,p,r){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=$,this.class=r,this.a=p}async run(){}}e.$Pi=d;class y extends R{static{this.ID="vs.actions.empty"}constructor(){super(y.ID,I.localize(0,null),void 0,!1)}}e.$Qi=y;function A(k){return{id:k.id,label:k.label,class:k.class,enabled:k.enabled??!0,checked:k.checked,run:async(...l)=>k.run(...l),tooltip:k.label}}e.$Ri=A}),define(Re[135],Ae([9,10]),function(me,e){return me.create("vs/base/common/date",e)}),define(Re[136],Ae([1,0,135]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zm=e.$ym=e.$xm=void 0;const M=60,I=M*60,R=I*24,L=R*7,m=R*30,d=R*365;function y(l,$,p,r){typeof l!="number"&&(l=l.getTime());const c=Math.round((new Date().getTime()-l)/1e3);if(c<-30)return(0,S.localize)(0,null,y(new Date().getTime()+c*1e3,!1));if(!r&&c<30)return(0,S.localize)(1,null);let s;return c<M?(s=c,$?s===1?p?(0,S.localize)(2,null,s):(0,S.localize)(3,null,s):p?(0,S.localize)(4,null,s):(0,S.localize)(5,null,s):s===1?p?(0,S.localize)(6,null,s):(0,S.localize)(7,null,s):p?(0,S.localize)(8,null,s):(0,S.localize)(9,null,s)):c<I?(s=Math.floor(c/M),$?s===1?p?(0,S.localize)(10,null,s):(0,S.localize)(11,null,s):p?(0,S.localize)(12,null,s):(0,S.localize)(13,null,s):s===1?p?(0,S.localize)(14,null,s):(0,S.localize)(15,null,s):p?(0,S.localize)(16,null,s):(0,S.localize)(17,null,s)):c<R?(s=Math.floor(c/I),$?s===1?p?(0,S.localize)(18,null,s):(0,S.localize)(19,null,s):p?(0,S.localize)(20,null,s):(0,S.localize)(21,null,s):s===1?p?(0,S.localize)(22,null,s):(0,S.localize)(23,null,s):p?(0,S.localize)(24,null,s):(0,S.localize)(25,null,s)):c<L?(s=Math.floor(c/R),$?s===1?(0,S.localize)(26,null,s):(0,S.localize)(27,null,s):s===1?(0,S.localize)(28,null,s):(0,S.localize)(29,null,s)):c<m?(s=Math.floor(c/L),$?s===1?p?(0,S.localize)(30,null,s):(0,S.localize)(31,null,s):p?(0,S.localize)(32,null,s):(0,S.localize)(33,null,s):s===1?p?(0,S.localize)(34,null,s):(0,S.localize)(35,null,s):p?(0,S.localize)(36,null,s):(0,S.localize)(37,null,s)):c<d?(s=Math.floor(c/m),$?s===1?p?(0,S.localize)(38,null,s):(0,S.localize)(39,null,s):p?(0,S.localize)(40,null,s):(0,S.localize)(41,null,s):s===1?p?(0,S.localize)(42,null,s):(0,S.localize)(43,null,s):p?(0,S.localize)(44,null,s):(0,S.localize)(45,null,s)):(s=Math.floor(c/d),$?s===1?p?(0,S.localize)(46,null,s):(0,S.localize)(47,null,s):p?(0,S.localize)(48,null,s):(0,S.localize)(49,null,s):s===1?p?(0,S.localize)(50,null,s):(0,S.localize)(51,null,s):p?(0,S.localize)(52,null,s):(0,S.localize)(53,null,s))}e.$xm=y;function A(l,$){const p=Math.abs(l/1e3);return p<1?$?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):p<M?$?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):p<I?$?(0,S.localize)(58,null,Math.round(l/(1e3*M))):(0,S.localize)(59,null,Math.round(l/(1e3*M))):p<R?$?(0,S.localize)(60,null,Math.round(l/(1e3*I))):(0,S.localize)(61,null,Math.round(l/(1e3*I))):(0,S.localize)(62,null,Math.round(l/(1e3*R)))}e.$ym=A;function k(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$zm=k}),define(Re[137],Ae([9,10]),function(me,e){return me.create("vs/base/common/errorMessage",e)}),define(Re[41],Ae([1,0,18,16,137]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ui=e.$Ti=e.$Si=void 0;function R(k,l){return l&&(k.stack||k.stacktrace)?I.localize(0,null,m(k),L(k.stack)||L(k.stacktrace)):m(k)}function L(k){return Array.isArray(k)?k.join(`
`):k}function m(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?I.localize(1,null,k.message):k.message||I.localize(2,null)}function d(k=null,l=!1){if(!k)return I.localize(3,null);if(Array.isArray(k)){const $=S.$Hb(k),p=d($[0],l);return $.length>1?I.localize(4,null,p,$.length):p}if(M.$Jf(k))return k;if(k.detail){const $=k.detail;if($.error)return R($.error,l);if($.exception)return R($.exception,l)}return k.stack?R(k,l):k.message?k.message:I.localize(5,null)}e.$Si=d;function y(k){const l=k;return l instanceof Error&&Array.isArray(l.actions)}e.$Ti=y;function A(k,l){let $;return typeof k=="string"?$=new Error(k):$=k,$.actions=l,$}e.$Ui=A}),define(Re[138],Ae([1,0,39,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wq=e.$Vq=e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=void 0;const I=new S.$V(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),R=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),L=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function m(P,g,v=!1){const E=P||"",T=g||"",N=I.value.collator.compare(E,T);return I.value.collatorIsNumeric&&N===0&&E!==T?E<T?-1:1:N}e.$Kq=m;function d(P,g){const v=R.value.collator;return P=P||"",g=g||"",a(v,P,g)}e.$Lq=d;function y(P,g){const v=R.value.collator;return P=P||"",g=g||"",n(P,g)||a(v,P,g)}e.$Mq=y;function A(P,g){const v=R.value.collator;return P=P||"",g=g||"",f(P,g)||a(v,P,g)}e.$Nq=A;function k(P,g){return P=P||"",g=g||"",P===g?0:P<g?-1:1}e.$Oq=k;function l(P,g){const[v,E]=i(P),[T,N]=i(g);let J=I.value.collator.compare(E,N);if(J===0){if(I.value.collatorIsNumeric&&E!==N)return E<N?-1:1;if(J=I.value.collator.compare(v,T),I.value.collatorIsNumeric&&J===0&&v!==T)return v<T?-1:1}return J}e.$Pq=l;function $(P,g){P=P||"",g=g||"";const v=o(P),E=o(g),T=R.value.collator,N=L.value.collator;return a(N,v,E)||a(T,P,g)}e.$Qq=$;function p(P,g){P=P||"",g=g||"";const v=o(P),E=o(g),T=R.value.collator,N=L.value.collator;return a(N,v,E)||n(P,g)||a(T,P,g)}e.$Rq=p;function r(P,g){P=P||"",g=g||"";const v=o(P),E=o(g),T=R.value.collator,N=L.value.collator;return a(N,v,E)||f(P,g)||a(T,P,g)}e.$Sq=r;function c(P,g){P=P||"",g=g||"";const v=o(P).toLowerCase(),E=o(g).toLowerCase();return v!==E?v<E?-1:1:P!==g?P<g?-1:1:0}e.$Tq=c;const s=/^(.*?)(\.([^.]*))?$/;function i(P,g=!1){const v=P?s.exec(P):[];let E=[v&&v[1]||"",v&&v[3]||""];return g&&(!E[0]&&E[1]||E[0]&&E[0].charAt(0)===".")&&(E=[E[0]+"."+E[1],""]),E}function o(P){const g=P?s.exec(P):[];return g&&g[1]&&g[1].charAt(0)!=="."&&g[3]||""}function a(P,g,v){const E=P.compare(g,v);return E!==0?E:g.length!==v.length?g.length<v.length?-1:1:0}function u(P){const g=P.charAt(0);return g.toLocaleUpperCase()!==g}function t(P){const g=P.charAt(0);return g.toLocaleLowerCase()!==g}function f(P,g){return u(P)&&t(g)?-1:t(P)&&u(g)?1:0}function n(P,g){return t(P)&&u(g)?-1:u(P)&&t(g)?1:0}function w(P,g,v=!1){return v||(P=P&&P.toLowerCase(),g=g&&g.toLowerCase()),P===g?0:P<g?-1:1}function D(P,g,v=!1){const E=P.split(M.sep),T=g.split(M.sep),N=E.length-1,J=T.length-1;let q,U;for(let C=0;;C++){if(q=N===C,U=J===C,q&&U)return m(E[C],T[C],v);if(q)return-1;if(U)return 1;const F=w(E[C],T[C],v);if(F!==0)return F}}e.$Uq=D;function h(P,g,v){const E=P.toLowerCase(),T=g.toLowerCase(),N=b(P,g,v);if(N)return N;const J=E.endsWith(v),q=T.endsWith(v);if(J!==q)return J?-1:1;const U=m(E,T);return U!==0?U:E.localeCompare(T)}e.$Vq=h;function b(P,g,v){const E=P.toLowerCase(),T=g.toLowerCase(),N=E.startsWith(v),J=T.startsWith(v);if(N!==J)return N?-1:1;if(N&&J){if(E.length<T.length)return-1;if(E.length>T.length)return 1}return 0}e.$Wq=b}),define(Re[45],Ae([1,0,19,20,14,16]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eg=e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=void 0;function L(h){return h===47||h===92}e.$2f=L;function m(h){return h.replace(/[\\/]/g,S.$gc.sep)}e.$3f=m;function d(h){return h.indexOf("/")===-1&&(h=m(h)),/^[a-zA-Z]:(\/|$)/.test(h)&&(h="/"+h),h}e.$4f=d;function y(h,b=S.$gc.sep){if(!h)return"";const P=h.length,g=h.charCodeAt(0);if(L(g)){if(L(h.charCodeAt(1))&&!L(h.charCodeAt(2))){let E=3;const T=E;for(;E<P&&!L(h.charCodeAt(E));E++);if(T!==E&&!L(h.charCodeAt(E+1))){for(E+=1;E<P;E++)if(L(h.charCodeAt(E)))return h.slice(0,E+1).replace(/[\\/]/g,b)}}return b}else if(s(g)&&h.charCodeAt(1)===58)return L(h.charCodeAt(2))?h.slice(0,2)+b:h.slice(0,2);let v=h.indexOf("://");if(v!==-1){for(v+=3;v<P;v++)if(L(h.charCodeAt(v)))return h.slice(0,v+1)}return""}e.$5f=y;function A(h){if(!M.$i||!h||h.length<5)return!1;let b=h.charCodeAt(0);if(b!==92||(b=h.charCodeAt(1),b!==92))return!1;let P=2;const g=P;for(;P<h.length&&(b=h.charCodeAt(P),b!==92);P++);return!(g===P||(b=h.charCodeAt(P+1),isNaN(b)||b===92))}e.$6f=A;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,$=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(h,b=M.$i){const P=b?k:l;return!(!h||h.length===0||/^\s+$/.test(h)||(P.lastIndex=0,P.test(h))||b&&$.test(h)||h==="."||h===".."||b&&h[h.length-1]==="."||b&&h.length!==h.trim().length||h.length>255)}e.$7f=p;function r(h,b,P){const g=h===b;return!P||g?g:!h||!b?!1:(0,I.$af)(h,b)}e.$8f=r;function c(h,b,P,g=S.sep){if(h===b)return!0;if(!h||!b||b.length>h.length)return!1;if(P){if(!(0,I.$bf)(h,b))return!1;if(b.length===h.length)return!0;let E=b.length;return b.charAt(b.length-1)===g&&E--,h.charAt(E)===g}return b.charAt(b.length-1)!==g&&(b+=g),h.indexOf(b)===0}e.$9f=c;function s(h){return h>=65&&h<=90||h>=97&&h<=122}e.$0f=s;function i(h,b){return M.$i&&h.endsWith(":")&&(h+=S.sep),(0,S.$ic)(h)||(h=(0,S.$jc)(b,h)),h=(0,S.$hc)(h),M.$i?(h=(0,I.$Ve)(h,S.sep),h.endsWith(":")&&(h+=S.sep)):(h=(0,I.$Ve)(h,S.sep),h||(h=S.sep)),h}e.$$f=i;function o(h){const b=(0,S.$hc)(h);return M.$i?h.length>3?!1:a(b)&&(h.length===2||b.charCodeAt(2)===92):b===S.$gc.sep}e.$_f=o;function a(h,b=M.$i){return b?s(h.charCodeAt(0))&&h.charCodeAt(1)===58:!1}e.$ag=a;function u(h,b=M.$i){return a(h,b)?h[0]:void 0}e.$bg=u;function t(h,b,P){return b.length>h.length?-1:h===b?0:(P&&(h=h.toLowerCase(),b=b.toLowerCase()),h.indexOf(b))}e.$cg=t;function f(h){const b=h.split(":");let P,g,v;for(const E of b){const T=Number(E);(0,R.$Nf)(T)?g===void 0?g=T:v===void 0&&(v=T):P=P?[P,E].join(":"):E}if(!P)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:P,line:g!==void 0?g:void 0,column:v!==void 0?v:g!==void 0?1:void 0}}e.$dg=f;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",w="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(h,b,P=8){let g="";for(let E=0;E<P;E++){let T;E===0&&M.$i&&!b&&(P===3||P===4)?T=w:T=n,g+=T.charAt(Math.floor(Math.random()*T.length))}let v;return b?v=`${b}-${g}`:v=g,h?(0,S.$jc)(h,v):v}e.$eg=D}),define(Re[69],Ae([1,0,19]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ls=e.$ks=e.$js=e.$is=e.$hs=void 0,e.$hs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(A){const k=(0,S.$oc)(A),l=M[k.toLowerCase()];return l!==void 0?l:L(A)}e.$is=R;function L(A){const k=(0,S.$oc)(A);return I[k.toLowerCase()]}e.$js=L;function m(A){for(const k in I)if(I[k]===A)return k}e.$ks=m;const d=/^(.+)\/(.+?)(;.+)?$/;function y(A,k){const l=d.exec(A);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:k?void 0:A}e.$ls=y}),define(Re[52],Ae([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eh=e.$Dh=e.$Ch=void 0;function I(d){return JSON.stringify(d,L)}e.$Ch=I;function R(d){let y=JSON.parse(d);return y=m(y),y}e.$Dh=R;function L(d,y){return y instanceof RegExp?{$mid:2,source:y.source,flags:y.flags}:y}function m(d,y=0){if(!d||y>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return M.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof S.$ke||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let A=0;A<d.length;++A)d[A]=m(d[A],y+1);else for(const A in d)Object.hasOwnProperty.call(d,A)&&(d[A]=m(d[A],y+1))}return d}e.$Eh=m}),define(Re[12],Ae([1,0,15,20,14,2]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$pg=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.Schemas=void 0;var L;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeManagedRemoteResource="vscode-managed-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeChatCodeBlock="vscode-chat-code-block",l.vscodeChatSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={}));function m(l,$){return R.URI.isUri(l)?(0,I.$af)(l.scheme,$):(0,I.$bf)(l,$+":")}e.$fg=m;function d(l,...$){return $.some(p=>m(l,p))}e.$gg=d,e.$hg="vscode-tkn",e.$ig="tkn";class y{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema($){this.d=$}setDelegate($){this.e=$}setServerRootPath($){this.f=`${$}/${L.vscodeRemoteResource}`}set($,p,r){this.a[$]=p,this.b[$]=r}setConnectionToken($,p){this.c[$]=p}getPreferredWebSchema(){return this.d}rewrite($){if(this.e)try{return this.e($)}catch(o){return S.$1(o),$}const p=$.authority;let r=this.a[p];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const c=this.b[p],s=this.c[p];let i=`path=${encodeURIComponent($.path)}`;return typeof s=="string"&&(i+=`&${e.$ig}=${encodeURIComponent(s)}`),R.URI.from({scheme:M.$o?this.d:L.vscodeRemoteResource,authority:`${r}:${c}`,path:this.f,query:i})}}e.$jg=new y,e.$kg="vs/../../extensions",e.$lg="vs/../../node_modules",e.$mg="vs/../../node_modules.asar",e.$ng="vs/../../node_modules.asar.unpacked",e.$og="vscode-app";class A{static{this.a=e.$og}asBrowserUri($){const p=this.b($,me);return this.uriToBrowserUri(p)}uriToBrowserUri($){return $.scheme===L.vscodeRemote?e.$jg.rewrite($):$.scheme===L.file&&(M.$m||M.$q===`${L.vscodeFileResource}://${A.a}`)?$.with({scheme:L.vscodeFileResource,authority:$.authority||A.a,query:null,fragment:null}):$}asFileUri($){const p=this.b($,me);return this.uriToFileUri(p)}uriToFileUri($){return $.scheme===L.vscodeFileResource?$.with({scheme:L.file,authority:$.authority!==A.a?$.authority:null,query:null,fragment:null}):$}b($,p){return R.URI.isUri($)?$:R.URI.parse(p.toUrl($))}}e.$pg=new A;var k;(function(l){const $=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze($.get("3"));const p="vscode-coi";function r(s){let i;typeof s=="string"?i=new URL(s).searchParams:s instanceof URL?i=s.searchParams:R.URI.isUri(s)&&(i=new URL(s.toString(!0)).searchParams);const o=i?.get(p);if(o)return $.get(o)}l.getHeadersFromQuery=r;function c(s,i,o){if(!globalThis.crossOriginIsolated)return;const a=i&&o?"3":o?"2":"1";s instanceof URLSearchParams?s.set(p,a):s[p]=a}l.addSearchParam=c})(k||(e.COI=k={}))}),define(Re[24],Ae([1,0,45,12,19,20,14,2]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sg=e.DataUri=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=void 0;function d($){return(0,m.$wc)($,!0)}e.$wg=d;class y{constructor(p){this.a=p}compare(p,r,c=!1){return p===r?0:(0,L.$6e)(this.getComparisonKey(p,c),this.getComparisonKey(r,c))}isEqual(p,r,c=!1){return p===r?!0:!p||!r?!1:this.getComparisonKey(p,c)===this.getComparisonKey(r,c)}getComparisonKey(p,r=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:r?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,r,c=!1){if(p.scheme===r.scheme){if(p.scheme===M.Schemas.file)return S.$9f(d(p),d(r),this.a(p))&&p.query===r.query&&(c||p.fragment===r.fragment);if((0,e.$Ng)(p.authority,r.authority))return S.$9f(p.path,r.path,this.a(p),"/")&&p.query===r.query&&(c||p.fragment===r.fragment)}return!1}joinPath(p,...r){return m.URI.joinPath(p,...r)}basenameOrAuthority(p){return(0,e.$Fg)(p)||p.authority}basename(p){return I.$gc.basename(p.path)}extname(p){return I.$gc.extname(p.path)}dirname(p){if(p.path.length===0)return p;let r;return p.scheme===M.Schemas.file?r=m.URI.file(I.$mc(d(p))).path:(r=I.$gc.dirname(p.path),p.authority&&r.length&&r.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),r="/")),p.with({path:r})}normalizePath(p){if(!p.path.length)return p;let r;return p.scheme===M.Schemas.file?r=m.URI.file(I.$hc(d(p))).path:r=I.$gc.normalize(p.path),p.with({path:r})}relativePath(p,r){if(p.scheme!==r.scheme||!(0,e.$Ng)(p.authority,r.authority))return;if(p.scheme===M.Schemas.file){const i=I.$lc(d(p),d(r));return R.$i?S.$3f(i):i}let c=p.path||"/";const s=r.path||"/";if(this.a(p)){let i=0;for(const o=Math.min(c.length,s.length);i<o&&!(c.charCodeAt(i)!==s.charCodeAt(i)&&c.charAt(i).toLowerCase()!==s.charAt(i).toLowerCase());i++);c=s.substr(0,i)+c.substr(i)}return I.$gc.relative(c,s)}resolvePath(p,r){if(p.scheme===M.Schemas.file){const c=m.URI.file(I.$kc(d(p),r));return p.with({authority:c.authority,path:c.path})}return r=S.$4f(r),p.with({path:I.$gc.resolve(p.path,r)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,r){return p===r||p!==void 0&&r!==void 0&&(0,L.$af)(p,r)}hasTrailingPathSeparator(p,r=I.sep){if(p.scheme===M.Schemas.file){const c=d(p);return c.length>S.$5f(c).length&&c[c.length-1]===r}else{const c=p.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,r=I.sep){return(0,e.$Og)(p,r)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,r=I.sep){let c=!1;if(p.scheme===M.Schemas.file){const s=d(p);c=s!==void 0&&s.length===S.$5f(s).length&&s[s.length-1]===r}else{r="/";const s=p.path;c=s.length===1&&s.charCodeAt(s.length-1)===47}return!c&&!(0,e.$Og)(p,r)?p.with({path:p.path+"/"}):p}}e.$xg=y,e.$yg=new y(()=>!1),e.$zg=new y($=>$.scheme===M.Schemas.file?!R.$k:!0),e.$Ag=new y($=>!0),e.$Bg=e.$yg.isEqual.bind(e.$yg),e.$Cg=e.$yg.isEqualOrParent.bind(e.$yg),e.$Dg=e.$yg.getComparisonKey.bind(e.$yg),e.$Eg=e.$yg.basenameOrAuthority.bind(e.$yg),e.$Fg=e.$yg.basename.bind(e.$yg),e.$Gg=e.$yg.extname.bind(e.$yg),e.$Hg=e.$yg.dirname.bind(e.$yg),e.$Ig=e.$yg.joinPath.bind(e.$yg),e.$Jg=e.$yg.normalizePath.bind(e.$yg),e.$Kg=e.$yg.relativePath.bind(e.$yg),e.$Lg=e.$yg.resolvePath.bind(e.$yg),e.$Mg=e.$yg.isAbsolutePath.bind(e.$yg),e.$Ng=e.$yg.isEqualAuthority.bind(e.$yg),e.$Og=e.$yg.hasTrailingPathSeparator.bind(e.$yg),e.$Pg=e.$yg.removeTrailingPathSeparator.bind(e.$yg),e.$Qg=e.$yg.addTrailingPathSeparator.bind(e.$yg);function A($,p){const r=[];for(let c=0;c<$.length;c++){const s=p($[c]);$.some((i,o)=>o===c?!1:(0,e.$Cg)(s,p(i)))||r.push($[c])}return r}e.$Rg=A;var k;(function($){$.META_DATA_LABEL="label",$.META_DATA_DESCRIPTION="description",$.META_DATA_SIZE="size",$.META_DATA_MIME="mime";function p(r){const c=new Map;r.path.substring(r.path.indexOf(";")+1,r.path.lastIndexOf(";")).split(";").forEach(o=>{const[a,u]=o.split(":");a&&u&&c.set(a,u)});const i=r.path.substring(0,r.path.indexOf(";"));return i&&c.set($.META_DATA_MIME,i),c}$.parseMetaData=p})(k||(e.DataUri=k={}));function l($,p,r){if(p){let c=$.path;return c&&c[0]!==I.$gc.sep&&(c=I.$gc.sep+c),$.with({scheme:r,authority:p,path:c})}return $.with({scheme:r})}e.$Sg=l}),define(Re[11],Ae([1,0,21,15,5,6,24,20,125,39]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.Promises=e.$sh=e.$rh=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=void 0;function A(ge){return!!ge&&typeof ge.then=="function"}e.$Tg=A;function k(ge){const G=new S.$7d,_=ge(G.token),ue=new Promise((de,Le)=>{const fe=G.token.onCancellationRequested(()=>{fe.dispose(),Le(new M.$5)});Promise.resolve(_).then(ke=>{fe.dispose(),G.dispose(),de(ke)},ke=>{fe.dispose(),G.dispose(),Le(ke)})});return new class{cancel(){G.cancel(),G.dispose()}then(de,Le){return ue.then(de,Le)}catch(de){return this.then(void 0,de)}finally(de){return ue.finally(de)}}}e.$Ug=k;function l(ge,G,_){return new Promise((ue,de)=>{const Le=G.onCancellationRequested(()=>{Le.dispose(),ue(_)});ge.then(ue,de).finally(()=>Le.dispose())})}e.$Vg=l;function $(ge,G){return new Promise((_,ue)=>{const de=G.onCancellationRequested(()=>{de.dispose(),ue(new M.$5)});ge.then(_,ue).finally(()=>de.dispose())})}e.$Wg=$;async function p(ge){let G=-1;const _=ge.map((ue,de)=>ue.then(Le=>(G=de,Le)));try{return await Promise.race(_)}finally{ge.forEach((ue,de)=>{de!==G&&ue.cancel()})}}e.$Xg=p;function r(ge,G,_){let ue;const de=setTimeout(()=>{ue?.(void 0),_?.()},G);return Promise.race([ge.finally(()=>clearTimeout(de)),new Promise(Le=>ue=Le)])}e.$Yg=r;function c(ge){return new Promise((G,_)=>{const ue=ge();A(ue)?ue.then(G,_):G(ue)})}e.$Zg=c;function s(){let ge,G;return{promise:new Promise((ue,de)=>{ge=ue,G=de}),resolve:ge,reject:G}}e.$1g=s;class i{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(G){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=G,!this.b){const _=()=>{if(this.b=null,this.f)return;const ue=this.queue(this.d);return this.d=null,ue};this.b=new Promise(ue=>{this.a.then(_,_).then(ue)})}return new Promise((_,ue)=>{this.b.then(_,ue)})}return this.a=G(),new Promise((_,ue)=>{this.a.then(de=>{this.a=null,_(de)},de=>{this.a=null,ue(de)})})}dispose(){this.f=!0}}e.$2g=i;class o{constructor(){this.a=Promise.resolve(null)}queue(G){return this.a=this.a.then(()=>G(),()=>G())}}e.$3g=o;class a{constructor(){this.a=new Map}queue(G,_){const de=(this.a.get(G)??Promise.resolve()).catch(()=>{}).then(_).finally(()=>{this.a.get(G)===de&&this.a.delete(G)});return this.a.set(G,de),de}}e.$4g=a;const u=(ge,G)=>{let _=!0;const ue=setTimeout(()=>{_=!1,G()},ge);return{isTriggered:()=>_,dispose:()=>{clearTimeout(ue),_=!1}}},t=ge=>{let G=!0;return queueMicrotask(()=>{G&&(G=!1,ge())}),{isTriggered:()=>G,dispose:()=>{G=!1}}};class f{constructor(G){this.defaultDelay=G,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(G,_=this.defaultDelay){this.g=G,this.h(),this.b||(this.b=new Promise((de,Le)=>{this.d=de,this.f=Le}).then(()=>{if(this.b=null,this.d=null,this.g){const de=this.g;return this.g=null,de()}}));const ue=()=>{this.a=null,this.d?.(null)};return this.a=_===d.$Td?t(ue):u(_,ue),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$5g=f;class n{constructor(G){this.a=new f(G),this.b=new i}trigger(G,_){return this.a.trigger(()=>this.b.queue(G),_)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$6g=n;class w{constructor(){this.a=!1,this.b=new Promise((G,_)=>{this.d=G})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$7g=w;class D extends w{constructor(G){super(),this.f=setTimeout(()=>this.open(),G)}open(){clearTimeout(this.f),super.open()}}e.$8g=D;function h(ge,G){return G?new Promise((_,ue)=>{const de=setTimeout(()=>{Le.dispose(),_()},ge),Le=G.onCancellationRequested(()=>{clearTimeout(de),Le.dispose(),ue(new M.$5)})}):k(_=>h(ge,_))}e.$9g=h;function b(ge,G=0,_){const ue=setTimeout(()=>{ge(),_&&de.dispose()},G),de=(0,R.$Rc)(()=>{clearTimeout(ue),_?.deleteAndLeak(de)});return _?.add(de),de}e.$0g=b;function P(ge){const G=[];let _=0;const ue=ge.length;function de(){return _<ue?ge[_++]():null}function Le(fe){fe!=null&&G.push(fe);const ke=de();return ke?ke.then(Le):Promise.resolve(G)}return Promise.resolve(null).then(Le)}e.$$g=P;function g(ge,G=ue=>!!ue,_=null){let ue=0;const de=ge.length,Le=()=>{if(ue>=de)return Promise.resolve(_);const fe=ge[ue++];return Promise.resolve(fe()).then(Ie=>G(Ie)?Promise.resolve(Ie):Le())};return Le()}e.$_g=g;function v(ge,G=ue=>!!ue,_=null){if(ge.length===0)return Promise.resolve(_);let ue=ge.length;const de=()=>{ue=-1;for(const Le of ge)Le.cancel?.()};return new Promise((Le,fe)=>{for(const ke of ge)ke.then(Ie=>{--ue>=0&&G(Ie)?(de(),Le(Ie)):ue===0&&Le(_)}).catch(Ie=>{--ue>=0&&(de(),fe(Ie))})})}e.$ah=v;class E{constructor(G){this.a=0,this.b=!1,this.f=G,this.g=[],this.d=0,this.h=new I.$Wd}whenIdle(){return this.size>0?I.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(G){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((_,ue)=>{this.g.push({factory:G,c:_,e:ue}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const G=this.g.shift();this.d++;const _=G.factory();_.then(G.c,G.e),_.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$bh=E;class T extends E{constructor(){super(1)}}e.$ch=T;class N{constructor(){this.a=new le,this.b=0}queue(G){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,G())):this.a.run(this.b++,G())}}e.$dh=N;class J{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const G=new $e;return this.b.add(G),G.p}g(){for(const[,G]of this.a)if(G.size>0)return!1;return!0}queueSize(G,_=L.$yg){const ue=_.getComparisonKey(G);return this.a.get(ue)?.size??0}queueFor(G,_,ue=L.$yg){const de=ue.getComparisonKey(G);let Le=this.a.get(de);if(!Le){Le=new T;const fe=this.f++,ke=I.Event.once(Le.onDrained)(()=>{Le?.dispose(),this.a.delete(de),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$3c),this.d.set(fe,ke),this.a.set(de,Le)}return Le.queue(_)}h(){this.g()&&this.j()}j(){for(const G of this.b)G.complete();this.b.clear()}dispose(){for(const[,G]of this.a)G.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$eh=J;class q{constructor(G,_){this.a=-1,typeof G=="function"&&typeof _=="number"&&this.setIfNotSet(G,_)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(G,_){this.cancel(),this.a=setTimeout(()=>{this.a=-1,G()},_)}setIfNotSet(G,_){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,G()},_))}}e.$fh=q;class U{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(G,_,ue=globalThis){this.cancel();const de=ue.setInterval(()=>{G()},_);this.d=(0,R.$Rc)(()=>{ue.clearInterval(de),this.d=void 0})}dispose(){this.cancel()}}e.$gh=U;class C{constructor(G,_){this.b=-1,this.a=G,this.d=_,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(G=this.d){this.cancel(),this.b=setTimeout(this.f,G)}get delay(){return this.d}set delay(G){this.d=G}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$hh=C;class F{constructor(G,_){_%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.a=G,this.b=_,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(G=this.b){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(G/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$ih=F;class W extends C{constructor(G,_){super(G,_),this.j=[]}work(G){this.j.push(G),this.isScheduled()||this.schedule()}h(){const G=this.j;this.j=[],this.a?.(G)}dispose(){this.j=[],super.dispose()}}e.$jh=W;class re extends R.$Tc{constructor(G,_){super(),this.g=G,this.h=_,this.a=[],this.b=this.B(new R.$Uc),this.f=!1}get pending(){return this.a.length}work(G){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+G.length>this.g.maxBufferedWork)return!1}else if(this.pending+G.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const _ of G)this.a.push(_);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new C(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$kh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$mh=(ge,G)=>{(0,m.$B)(()=>{if(_)return;const ue=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ue-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.$mh=(ge,G,_)=>{const ue=ge.requestIdleCallback(G,typeof _=="number"?{timeout:_}:void 0);let de=!1;return{dispose(){de||(de=!0,ge.cancelIdleCallback(ue))}}},e.$lh=ge=>(0,e.$mh)(globalThis,ge)}();class ce{constructor(G,_){this.g=!1,this.d=()=>{try{this.j=_()}catch(ue){this.l=ue}finally{this.g=!0}},this.f=(0,e.$mh)(G,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$nh=ce;class we extends ce{constructor(G){super(globalThis,G)}}e.$oh=we;async function De(ge,G,_){let ue;for(let de=0;de<_;de++)try{return await ge()}catch(Le){ue=Le,await h(G)}throw ue}e.$ph=De;class le{isRunning(G){return typeof G=="number"?this.a?.taskId===G:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(G,_,ue){return this.a={taskId:G,cancel:()=>ue?.(),promise:_},_.then(()=>this.d(G),()=>this.d(G)),_}d(G){this.a&&G===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const G=this.b;this.b=void 0,G.run().then(G.promiseResolve,G.promiseReject)}}queue(G){if(this.b)this.b.run=G;else{const{promise:_,resolve:ue,reject:de}=s();this.b={run:G,promise:_,promiseResolve:ue,promiseReject:de}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$qh=le;class ve{constructor(G,_=()=>Date.now()){this.d=G,this.f=_,this.a=0,this.b=0}increment(){const G=this.f();return G-this.a>this.d&&(this.a=G,this.b=0),this.b++,this.b}}e.$rh=ve;var se;(function(ge){ge[ge.Resolved=0]="Resolved",ge[ge.Rejected=1]="Rejected"})(se||(se={}));class $e{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((G,_)=>{this.a=G,this.b=_})}complete(G){return new Promise(_=>{this.a(G),this.d={outcome:0,value:G},_()})}error(G){return new Promise(_=>{this.b(G),this.d={outcome:1,value:G},_()})}cancel(){return this.error(new M.$5)}}e.$sh=$e;var te;(function(ge){async function G(ue){let de;const Le=await Promise.all(ue.map(fe=>fe.then(ke=>ke,ke=>{de||(de=ke)})));if(typeof de<"u")throw de;return Le}ge.settled=G;function _(ue){return new Promise(async(de,Le)=>{try{await ue(de,Le)}catch(fe){Le(fe)}})}ge.withAsyncBody=_})(te||(e.Promises=te={}));class X{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(G){this.a=void 0,this.b=void 0,this.d=!1,this.promise=G.then(_=>(this.a=_,this.d=!0,_),_=>{throw this.b=_,this.d=!0,_})}requireValue(){if(!this.d)throw new M.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$th=X;class V{constructor(G){this.b=G,this.a=new y.$V(()=>new X(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$uh=V;var ie;(function(ge){ge[ge.Initial=0]="Initial",ge[ge.DoneOK=1]="DoneOK",ge[ge.DoneError=2]="DoneError"})(ie||(ie={}));class Ce{static fromArray(G){return new Ce(_=>{_.emitMany(G)})}static fromPromise(G){return new Ce(async _=>{_.emitMany(await G)})}static fromPromises(G){return new Ce(async _=>{await Promise.all(G.map(async ue=>_.emitOne(await ue)))})}static merge(G){return new Ce(async _=>{await Promise.all(G.map(async ue=>{for await(const de of ue)_.emitOne(de)}))})}static{this.EMPTY=Ce.fromArray([])}constructor(G){this.a=0,this.b=[],this.d=null,this.f=new I.$Wd,queueMicrotask(async()=>{const _={emitOne:ue=>this.g(ue),emitMany:ue=>this.h(ue),reject:ue=>this.k(ue)};try{await Promise.resolve(G(_)),this.j()}catch(ue){this.k(ue)}finally{_.emitOne=void 0,_.emitMany=void 0,_.reject=void 0}})}[Symbol.asyncIterator](){let G=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(G<this.b.length)return{done:!1,value:this.b[G++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(G,_){return new Ce(async ue=>{for await(const de of G)ue.emitOne(_(de))})}map(G){return Ce.map(this,G)}static filter(G,_){return new Ce(async ue=>{for await(const de of G)_(de)&&ue.emitOne(de)})}filter(G){return Ce.filter(this,G)}static coalesce(G){return Ce.filter(G,_=>!!_)}coalesce(){return Ce.coalesce(this)}static async toPromise(G){const _=[];for await(const ue of G)_.push(ue);return _}toPromise(){return Ce.toPromise(this)}g(G){this.a===0&&(this.b.push(G),this.f.fire())}h(G){this.a===0&&(this.b=this.b.concat(G),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(G){this.a===0&&(this.a=2,this.d=G,this.f.fire())}}e.$vh=Ce;class Te extends Ce{constructor(G,_){super(_),this.l=G}cancel(){this.l.cancel()}}e.$wh=Te;function Pe(ge){const G=new S.$7d,_=ge(G.token);return new Te(G,async ue=>{const de=G.token.onCancellationRequested(()=>{de.dispose(),G.dispose(),ue.reject(new M.$5)});try{for await(const Le of _){if(G.token.isCancellationRequested)return;ue.emitOne(Le)}de.dispose(),G.dispose()}catch(Le){de.dispose(),G.dispose(),ue.reject(Le)}})}e.$xh=Pe;class be{constructor(){this.a=new $e,this.b=new Ce(ue=>{if(G){ue.reject(G);return}return _&&ue.emitMany(_),this.d=de=>ue.reject(de),this.f=de=>ue.emitOne(de),this.a.p});let G,_;this.f=ue=>{_||(_=[]),_.push(ue)},this.d=ue=>{G||(G=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(G){this.d(G),this.a.complete()}emitOne(G){this.f(G)}}e.$yh=be}),define(Re[34],Ae([1,0,18,11,45,28,19,20,14]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sj=e.$Rj=e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=void 0;function y(){return Object.create(null)}e.$Jj=y,e.$Kj="**",e.$Lj="/";const A="[/\\\\]",k="[^/\\\\]",l=/\//g;function $(ce,we){switch(ce){case 0:return"";case 1:return`${k}*?`;default:return`(?:${A}|${k}+${A}${we?`|${A}${k}+`:""})*?`}}function p(ce,we){if(!ce)return[];const De=[];let le=!1,ve=!1,se="";for(const $e of ce){switch($e){case we:if(!le&&!ve){De.push(se),se="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ve=!0;break;case"]":ve=!1;break}se+=$e}return se&&De.push(se),De}e.$Mj=p;function r(ce){if(!ce)return"";let we="";const De=p(ce,e.$Lj);if(De.every(le=>le===e.$Kj))we=".*";else{let le=!1;De.forEach((ve,se)=>{if(ve===e.$Kj){if(le)return;we+=$(2,se===De.length-1)}else{let $e=!1,te="",X=!1,V="";for(const ie of ve){if(ie!=="}"&&$e){te+=ie;continue}if(X&&(ie!=="]"||!V)){let Ce;ie==="-"?Ce=ie:(ie==="^"||ie==="!")&&!V?Ce="^":ie===e.$Lj?Ce="":Ce=(0,d.$Pe)(ie),V+=Ce;continue}switch(ie){case"{":$e=!0;continue;case"[":X=!0;continue;case"}":{const Te=`(?:${p(te,",").map(Pe=>r(Pe)).join("|")})`;we+=Te,$e=!1,te="";break}case"]":{we+="["+V+"]",X=!1,V="";break}case"?":we+=k;continue;case"*":we+=$(1);continue;default:we+=(0,d.$Pe)(ie)}}se<De.length-1&&(De[se+1]!==e.$Kj||se+2<De.length)&&(we+=A)}le=ve===e.$Kj})}return we}const c=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,o=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Dc(1e4),f=function(){return!1},n=function(){return null};function w(ce,we){if(!ce)return n;let De;typeof ce!="string"?De=ce.pattern:De=ce,De=De.trim();const le=`${De}_${!!we.trimForExclusions}`;let ve=t.get(le);if(ve)return D(ve,ce);let se;return c.test(De)?ve=b(De.substr(4),De):(se=s.exec(h(De,we)))?ve=P(se[1],De):(we.trimForExclusions?o:i).test(De)?ve=g(De,we):(se=a.exec(h(De,we)))?ve=v(se[1].substr(1),De,!0):(se=u.exec(h(De,we)))?ve=v(se[1],De,!1):ve=E(De),t.set(le,ve),D(ve,ce)}function D(ce,we){if(typeof we=="string")return ce;const De=function(le,ve){return(0,I.$9f)(le,we.base,!m.$k)?ce((0,d.$Ue)(le.substr(we.base.length),L.sep),ve):null};return De.allBasenames=ce.allBasenames,De.allPaths=ce.allPaths,De.basenames=ce.basenames,De.patterns=ce.patterns,De}function h(ce,we){return we.trimForExclusions&&ce.endsWith("/**")?ce.substr(0,ce.length-2):ce}function b(ce,we){return function(De,le){return typeof De=="string"&&De.endsWith(ce)?we:null}}function P(ce,we){const De=`/${ce}`,le=`\\${ce}`,ve=function($e,te){return typeof $e!="string"?null:te?te===ce?we:null:$e===ce||$e.endsWith(De)||$e.endsWith(le)?we:null},se=[ce];return ve.basenames=se,ve.patterns=[we],ve.allBasenames=se,ve}function g(ce,we){const De=W(ce.slice(1,-1).split(",").map(te=>w(te,we)).filter(te=>te!==n),ce),le=De.length;if(!le)return n;if(le===1)return De[0];const ve=function(te,X){for(let V=0,ie=De.length;V<ie;V++)if(De[V](te,X))return ce;return null},se=De.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function v(ce,we,De){const le=L.sep===L.$gc.sep,ve=le?ce:ce.replace(l,L.sep),se=L.sep+ve,$e=L.$gc.sep+ce;let te;return De?te=function(X,V){return typeof X=="string"&&(X===ve||X.endsWith(se)||!le&&(X===ce||X.endsWith($e)))?we:null}:te=function(X,V){return typeof X=="string"&&(X===ve||!le&&X===ce)?we:null},te.allPaths=[(De?"*/":"./")+ce],te}function E(ce){try{const we=new RegExp(`^${r(ce)}$`);return function(De){return we.lastIndex=0,typeof De=="string"&&we.test(De)?ce:null}}catch{return n}}function T(ce,we,De){return!ce||typeof we!="string"?!1:N(ce)(we,void 0,De)}e.$Nj=T;function N(ce,we={}){if(!ce)return f;if(typeof ce=="string"||J(ce)){const De=w(ce,we);if(De===n)return f;const le=function(ve,se){return!!De(ve,se)};return De.allBasenames&&(le.allBasenames=De.allBasenames),De.allPaths&&(le.allPaths=De.allPaths),le}return C(ce,we)}e.$Oj=N;function J(ce){const we=ce;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}e.$Pj=J;function q(ce){return ce.allBasenames||[]}e.$Qj=q;function U(ce){return ce.allPaths||[]}e.$Rj=U;function C(ce,we){const De=W(Object.getOwnPropertyNames(ce).map(te=>F(te,ce[te],we)).filter(te=>te!==n)),le=De.length;if(!le)return n;if(!De.some(te=>!!te.requiresSiblings)){if(le===1)return De[0];const te=function(ie,Ce){let Te;for(let Pe=0,be=De.length;Pe<be;Pe++){const ge=De[Pe](ie,Ce);if(typeof ge=="string")return ge;(0,M.$Tg)(ge)&&(Te||(Te=[]),Te.push(ge))}return Te?(async()=>{for(const Pe of Te){const be=await Pe;if(typeof be=="string")return be}return null})():null},X=De.find(ie=>!!ie.allBasenames);X&&(te.allBasenames=X.allBasenames);const V=De.reduce((ie,Ce)=>Ce.allPaths?ie.concat(Ce.allPaths):ie,[]);return V.length&&(te.allPaths=V),te}const ve=function(te,X,V){let ie,Ce;for(let Te=0,Pe=De.length;Te<Pe;Te++){const be=De[Te];be.requiresSiblings&&V&&(X||(X=(0,L.$nc)(te)),ie||(ie=X.substr(0,X.length-(0,L.$oc)(te).length)));const ge=be(te,X,ie,V);if(typeof ge=="string")return ge;(0,M.$Tg)(ge)&&(Ce||(Ce=[]),Ce.push(ge))}return Ce?(async()=>{for(const Te of Ce){const Pe=await Te;if(typeof Pe=="string")return Pe}return null})():null},se=De.find(te=>!!te.allBasenames);se&&(ve.allBasenames=se.allBasenames);const $e=De.reduce((te,X)=>X.allPaths?te.concat(X.allPaths):te,[]);return $e.length&&(ve.allPaths=$e),ve}function F(ce,we,De){if(we===!1)return n;const le=w(ce,De);if(le===n)return n;if(typeof we=="boolean")return le;if(we){const ve=we.when;if(typeof ve=="string"){const se=($e,te,X,V)=>{if(!V||!le($e,te))return null;const ie=ve.replace("$(basename)",()=>X),Ce=V(ie);return(0,M.$Tg)(Ce)?Ce.then(Te=>Te?ce:null):Ce?ce:null};return se.requiresSiblings=!0,se}}return le}function W(ce,we){const De=ce.filter(te=>!!te.basenames);if(De.length<2)return ce;const le=De.reduce((te,X)=>{const V=X.basenames;return V?te.concat(V):te},[]);let ve;if(we){ve=[];for(let te=0,X=le.length;te<X;te++)ve.push(we)}else ve=De.reduce((te,X)=>{const V=X.patterns;return V?te.concat(V):te},[]);const se=function(te,X){if(typeof te!="string")return null;if(!X){let ie;for(ie=te.length;ie>0;ie--){const Ce=te.charCodeAt(ie-1);if(Ce===47||Ce===92)break}X=te.substr(ie)}const V=le.indexOf(X);return V!==-1?ve[V]:null};se.basenames=le,se.patterns=ve,se.allBasenames=le;const $e=ce.filter(te=>!te.basenames);return $e.push(se),$e}function re(ce,we){return(0,S.$ub)(ce,we,(De,le)=>typeof De=="string"&&typeof le=="string"?De===le:typeof De!="string"&&typeof le!="string"?De.base===le.base&&De.pattern===le.pattern:!1)}e.$Sj=re}),define(Re[46],Ae([1,0,15,126,24,14,2]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rk=e.$qk=e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.MarkdownStringTextNewlineStyle=void 0;var m;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(m||(e.MarkdownStringTextNewlineStyle=m={}));class d{constructor(i="",o=!1){if(this.value=i,typeof this.value!="string")throw(0,S.$7)("value");typeof o=="boolean"?(this.isTrusted=o,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=o.isTrusted??void 0,this.supportThemeIcons=o.supportThemeIcons??!1,this.supportHtml=o.supportHtml??!1)}appendText(i,o=0){return this.value+=l(this.supportThemeIcons?(0,M.$dk)(i):i).replace(/([ \t]+)/g,(a,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,o===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,o){return this.value+=`
${$(o,i)}
`,this}appendLink(i,o,a){return this.value+="[",this.value+=this.c(o,"]"),this.value+="](",this.value+=this.c(String(i),")"),a&&(this.value+=` "${this.c(this.c(a,'"'),")")}"`),this.value+=")",this}c(i,o){const a=new RegExp((0,R.$Pe)(o),"g");return i.replace(a,(u,t)=>i.charAt(t-1)!=="\\"?`\\${u}`:u)}}e.$jk=d;function y(s){return A(s)?!s.value:Array.isArray(s)?s.every(y):!0}e.$kk=y;function A(s){return s instanceof d?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}e.$lk=A;function k(s,i){return s===i?!0:!s||!i?!1:s.value===i.value&&s.isTrusted===i.isTrusted&&s.supportThemeIcons===i.supportThemeIcons&&s.supportHtml===i.supportHtml&&(s.baseUri===i.baseUri||!!s.baseUri&&!!i.baseUri&&(0,I.$Bg)(L.URI.from(s.baseUri),L.URI.from(i.baseUri)))}e.$mk=k;function l(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$nk=l;function $(s,i){const o=s.match(/^`+/gm)?.reduce((u,t)=>u.length>t.length?u:t).length??0,a=o>=3?o+1:3;return[`${"`".repeat(a)}${i}`,s,`${"`".repeat(a)}`].join(`
`)}e.$ok=$;function p(s){return s.replace(/"/g,"&quot;")}e.$pk=p;function r(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$qk=r;function c(s){const i=[],o=s.split("|").map(u=>u.trim());s=o[0];const a=o[1];if(a){const u=/height=(\d+)/.exec(a),t=/width=(\d+)/.exec(a),f=u?u[1]:"",n=t?t[1]:"",w=isFinite(parseInt(n)),D=isFinite(parseInt(f));w&&i.push(`width="${n}"`),D&&i.push(`height="${f}"`)}return{href:s,dimensions:i}}e.$rk=c}),define(Re[94],Ae([1,0,18,45,19,20,24,14]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7v=e.$6v=e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=void 0;function d(w,D){const{os:h,tildify:b,relative:P}=D;if(P){const E=y(w,P,h);if(typeof E=="string")return E}let g=w.fsPath;if(h===1&&!R.$i?g=g.replace(/\//g,"\\"):h!==1&&R.$i&&(g=g.replace(/\\/g,"/")),h!==1&&b?.userHome){const E=b.userHome.fsPath;let T;w.scheme!==b.userHome.scheme&&w.path[0]===I.$gc.sep&&w.path[1]!==I.$gc.sep?T=b.userHome.with({path:w.path}).fsPath:T=g,g=l(T,E,h)}return(h===1?I.$fc:I.$gc).normalize(A(g,h===1))}e.$Xv=d;function y(w,D,h){const b=h===1?I.$fc:I.$gc,P=h===3?L.$yg:L.$Ag,g=D.getWorkspace(),v=(0,S.$Ob)(g.folders);if(!v)return;w.scheme!==v.uri.scheme&&w.path[0]===I.$gc.sep&&w.path[1]!==I.$gc.sep&&(w=v.uri.with({path:w.path}));const E=D.getWorkspaceFolder(w);if(!E)return;let T;if(P.isEqual(E.uri,w)?T="":T=P.relativePath(E.uri,w)??"",T&&(T=b.normalize(T)),g.folders.length>1&&!D.noPrefix){const N=E.name?E.name:P.basenameOrAuthority(E.uri);T=T?`${N} \u2022 ${T}`:N}return T}function A(w,D=R.$i){return(0,M.$ag)(w,D)?w.charAt(0).toUpperCase()+w.slice(1):w}e.$Yv=A;let k=Object.create(null);function l(w,D,h=R.OS){if(h===1||!w||!D)return w;let b=k.original===D?k.normalized:void 0;b||(b=D,R.$i&&(b=(0,M.$3f)(b)),b=`${(0,m.$Ve)(b,I.$gc.sep)}${I.$gc.sep}`,k={original:D,normalized:b});let P=w;return R.$i&&(P=(0,M.$3f)(P)),(h===3?P.startsWith(b):(0,m.$bf)(P,b))?`~/${P.substr(b.length)}`:w}e.$Zv=l;function $(w,D){return w.replace(/^~($|\/|\\)/,`${D}$1`)}e.$1v=$;const p="\u2026",r="\\\\",c="~";function s(w,D=I.sep){const h=new Array(w.length);let b=!1;for(let P=0;P<w.length;P++){const g=w[P];if(g===""){h[P]=`.${D}`;continue}if(!g){h[P]=g;continue}b=!0;let v="",E=g;E.indexOf(r)===0?(v=E.substr(0,E.indexOf(r)+r.length),E=E.substr(E.indexOf(r)+r.length)):E.indexOf(D)===0?(v=E.substr(0,E.indexOf(D)+D.length),E=E.substr(E.indexOf(D)+D.length)):E.indexOf(c)===0&&(v=E.substr(0,E.indexOf(c)+c.length),E=E.substr(E.indexOf(c)+c.length));const T=E.split(D);for(let N=1;b&&N<=T.length;N++)for(let J=T.length-N;b&&J>=0;J--){b=!1;let q=T.slice(J,J+N).join(D);for(let U=0;!b&&U<w.length;U++)if(U!==P&&w[U]&&w[U].indexOf(q)>-1){const C=J+N===T.length,F=J>0&&w[U].indexOf(D)>-1?D+q:q,W=w[U].endsWith(F);b=!C||W}if(!b){let U="";(T[0].endsWith(":")||v!=="")&&(J===1&&(J=0,N++,q=T[0]+D+q),J>0&&(U=T[0]+D),U=v+U),J>0&&(U=U+p+D),U=U+q,J+N<T.length&&(U=U+D+p),h[P]=U}}b&&(h[P]=g)}return h}e.$2v=s;var i;(function(w){w[w.TEXT=0]="TEXT",w[w.VARIABLE=1]="VARIABLE",w[w.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function o(w,D=Object.create(null)){const h=[];let b=!1,P="";for(const g of w)if(g==="$"||b&&g==="{")P&&h.push({value:P,type:i.TEXT}),P="",b=!0;else if(g==="}"&&b){const v=D[P];if(typeof v=="string")v.length&&h.push({value:v,type:i.VARIABLE});else if(v){const E=h[h.length-1];(!E||E.type!==i.SEPARATOR)&&h.push({value:v.label,type:i.SEPARATOR})}P="",b=!1}else P+=g;return P&&!b&&h.push({value:P,type:i.TEXT}),h.filter((g,v)=>{if(g.type===i.SEPARATOR){const E=h[v-1],T=h[v+1];return[E,T].every(N=>N&&(N.type===i.VARIABLE||N.type===i.TEXT)&&N.value.length>0)}return!0}).map(g=>g.value).join("")}e.$3v=o;function a(w,D){return R.$j||D?w.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):w.replace(/&&|&/g,h=>h==="&"?"&&":"&")}e.$4v=a;function u(w,D){return R.$j||D?w.replace(/\(&&\w\)|&&/g,""):R.$i?w.replace(/&&|&/g,h=>h==="&"?"&&":"&"):w.replace(/&&/g,"_")}e.$5v=u;function t(w){return w.replace(/&/g,"&&")}e.$6v=t;function f(w){if(w.endsWith("]")){const D=w.lastIndexOf(" [",w.length-2);if(D!==-1){const h=n(w.substring(0,D)),b=w.substring(D);return{name:h.name+b,parentPath:h.parentPath}}}return n(w)}e.$7v=f;function n(w){const D=w.indexOf("/")!==-1?I.$gc:I.$fc,h=D.basename(w),b=D.dirname(w);return h.length?{name:h,parentPath:b}:{name:b,parentPath:""}}}),define(Re[139],Ae([1,0,23,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=e.$0m=e.$9m=e.$8m=e.$7m=void 0;function I(k){return k.toJSON()}class R{constructor(l){this.a=l}transformIncoming(l){const $=this.a.transformIncoming(l);return $===l?l:I(M.URI.from($))}transformOutgoing(l){const $=this.a.transformOutgoing(l);return $===l?l:I(M.URI.from($))}transformOutgoingURI(l){const $=this.a.transformOutgoing(l);return $===l?l:M.URI.from($)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$7m=R,e.$8m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function L(k,l,$){if(!k||$>200)return null;if(typeof k=="object"){if(k instanceof M.URI)return l.transformOutgoing(k);for(const p in k)if(Object.hasOwnProperty.call(k,p)){const r=L(k[p],l,$+1);r!==null&&(k[p]=r)}}return null}function m(k,l){const $=L(k,l,0);return $===null?k:$}e.$9m=m;function d(k,l,$,p){if(!k||p>200)return null;if(typeof k=="object"){if(k.$mid===1)return $?M.URI.revive(l.transformIncoming(k)):l.transformIncoming(k);if(k instanceof S.$ke)return null;for(const r in k)if(Object.hasOwnProperty.call(k,r)){const c=d(k[r],l,$,p+1);c!==null&&(k[r]=c)}}return null}function y(k,l){const $=d(k,l,!1,0);return $===null?k:$}e.$0m=y;function A(k,l){const $=d(k,l,!0,0);return $===null?k:$}e.$$m=A}),define(Re[140],Ae([1,0,14,20,23]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=e.$ct=void 0;let R;function L(){return R||(R=new TextDecoder("UTF-16LE")),R}let m;function d(){return m||(m=new TextDecoder("UTF-16BE")),m}let y;function A(){return y||(y=M.$D()?L():d()),y}e.$ct=A;function k(p,r,c){const s=new Uint16Array(p.buffer,r,c);return c>0&&(s[0]===65279||s[0]===65534)?l(p,r,c):L().decode(s)}e.$dt=k;function l(p,r,c){const s=[];let i=0;for(let o=0;o<c;o++){const a=I.$me(p,r);r+=2,s[i++]=String.fromCharCode(a)}return s.join("")}class ${constructor(r){this.a=r|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const r=new Uint16Array(this.b.buffer,0,this.d);return A().decode(r)}f(){const r=this.e();this.d=0,this.c===null?this.c=[r]:this.c[this.c.length]=r}appendCharCode(r){const c=this.a-this.d;c<=1&&(c===0||S.$ef(r))&&this.f(),this.b[this.d++]=r}appendASCIICharCode(r){this.d===this.a&&this.f(),this.b[this.d++]=r}appendString(r){const c=r.length;if(this.d+c>=this.a){this.f(),this.c[this.c.length]=r;return}for(let s=0;s<c;s++)this.b[this.d++]=r.charCodeAt(s)}}e.$et=$}),define(Re[141],Ae([1,0,23,140]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;function I(d){return d.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class R{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(y,A,k,l){this.oldPosition=y,this.oldText=A,this.newPosition=k,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${I(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${I(this.oldText)}")`:`(replace@${this.oldPosition} "${I(this.oldText)}" with "${I(this.newText)}")`}static a(y){return 4+2*y.length}static c(y,A,k){const l=A.length;S.$pe(y,l,k),k+=4;for(let $=0;$<l;$++)S.$ne(y,A.charCodeAt($),k),k+=2;return k}static d(y,A){const k=S.$oe(y,A);return A+=4,(0,M.$dt)(y,A,k)}writeSize(){return 8+R.a(this.oldText)+R.a(this.newText)}write(y,A){return S.$pe(y,this.oldPosition,A),A+=4,S.$pe(y,this.newPosition,A),A+=4,A=R.c(y,this.oldText,A),A=R.c(y,this.newText,A),A}static read(y,A,k){const l=S.$oe(y,A);A+=4;const $=S.$oe(y,A);A+=4;const p=R.d(y,A);A+=R.a(p);const r=R.d(y,A);return A+=R.a(r),k.push(new R(l,p,$,r)),A}}e.$ft=R;function L(d,y){return d===null||d.length===0?y:new m(d,y).compress()}e.$gt=L;class m{constructor(y,A){this.a=y,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let y=0,A=0,k=this.n(y),l=this.l(A);for(;y<this.f||A<this.h;){if(k===null){this.k(l),l=this.l(++A);continue}if(l===null){this.m(k),k=this.n(++y);continue}if(l.oldEnd<=k.newPosition){this.k(l),l=this.l(++A);continue}if(k.newEnd<=l.oldPosition){this.m(k),k=this.n(++y);continue}if(l.oldPosition<k.newPosition){const[s,i]=m.r(l,k.newPosition-l.oldPosition);this.k(s),l=i;continue}if(k.newPosition<l.oldPosition){const[s,i]=m.q(k,l.oldPosition-k.newPosition);this.m(s),k=i;continue}let r,c;if(l.oldEnd===k.newEnd)r=k,c=l,k=this.n(++y),l=this.l(++A);else if(l.oldEnd<k.newEnd){const[s,i]=m.q(k,l.oldLength);r=s,c=l,k=i,l=this.l(++A)}else{const[s,i]=m.r(l,k.newLength);r=k,c=s,k=this.n(++y),l=i}this.d[this.e++]=new R(r.oldPosition,r.oldText,c.newPosition,c.newText),this.g+=r.newLength-r.oldLength,this.j+=c.newLength-c.oldLength}const $=m.s(this.d);return m.t($)}k(y){this.d[this.e++]=m.o(this.g,y),this.j+=y.newLength-y.oldLength}l(y){return y<this.h?this.c[y]:null}m(y){this.d[this.e++]=m.p(this.j,y),this.g+=y.newLength-y.oldLength}n(y){return y<this.f?this.a[y]:null}static o(y,A){return new R(A.oldPosition-y,A.oldText,A.newPosition,A.newText)}static p(y,A){return new R(A.oldPosition,A.oldText,A.newPosition+y,A.newText)}static q(y,A){const k=y.newText.substr(0,A),l=y.newText.substr(A);return[new R(y.oldPosition,y.oldText,y.newPosition,k),new R(y.oldEnd,"",y.newPosition+A,l)]}static r(y,A){const k=y.oldText.substr(0,A),l=y.oldText.substr(A);return[new R(y.oldPosition,k,y.newPosition,y.newText),new R(y.oldPosition+A,l,y.newEnd,"")]}static s(y){if(y.length===0)return y;const A=[];let k=0,l=y[0];for(let $=1;$<y.length;$++){const p=y[$];l.oldEnd===p.oldPosition?l=new R(l.oldPosition,l.oldText+p.oldText,l.newPosition,l.newText+p.newText):(A[k++]=l,l=p)}return A[k++]=l,A}static t(y){if(y.length===0)return y;const A=[];let k=0;for(let l=0;l<y.length;l++){const $=y[l];$.oldText!==$.newText&&(A[k++]=$)}return A}}}),define(Re[142],Ae([1,0,34,19]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dt=void 0;function I(R,L,m,d,y,A){if(Array.isArray(R)){let k=0;for(const l of R){const $=I(l,L,m,d,y,A);if($===10)return $;$>k&&(k=$)}return k}else{if(typeof R=="string")return d?R==="*"?5:R===m?10:0:0;if(R){const{language:k,pattern:l,scheme:$,hasAccessToAllModels:p,notebookType:r}=R;if(!d&&!p)return 0;r&&y&&(L=y);let c=0;if($)if($===L.scheme)c=10;else if($==="*")c=5;else return 0;if(k)if(k===m)c=10;else if(k==="*")c=Math.max(c,5);else return 0;if(r)if(r===A)c=10;else if(r==="*"&&A!==void 0)c=Math.max(c,5);else return 0;if(l){let s;if(typeof l=="string"?s=l:s={...l,base:(0,M.$hc)(l.base)},s===L.fsPath||(0,S.$Nj)(s,L.fsPath))c=10;else return 0}return c}else return 0}}e.$Dt=I}),define(Re[143],Ae([1,0,5,14,29,92,90,128,141,6]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dC=void 0;class A extends y.$Tc{constructor(l,$,p,r,c,s,i){super(),this.m=this.B(new S.$Wd),this.onDidChangeContent=this.m.event,this.f=$,this.j=!s,this.g=r,this.h=c,this.c=new L.$cC(l,p,i)}equals(l){return!(l instanceof A)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,$){return this.c.getOffsetAt(l,$)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,$){const p=l+$,r=this.getPositionAt(l),c=this.getPositionAt(p);return new I.$Ws(r.lineNumber,r.column,c.lineNumber,c.column)}getValueInRange(l,$=0){if(l.isEmpty())return"";const p=this.n($);return this.c.getValueInRange(l,p)}getValueLengthInRange(l,$=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const p=this.getOffsetAt(l.startLineNumber,l.startColumn),r=this.getOffsetAt(l.endLineNumber,l.endColumn);let c=0;const s=this.n($),i=this.getEOL();if(s.length!==i.length){const o=s.length-i.length,a=l.endLineNumber-l.startLineNumber;c=o*a}return r-p+c}getCharacterCountInRange(l,$=0){if(this.j){let p=0;const r=l.startLineNumber,c=l.endLineNumber;for(let s=r;s<=c;s++){const i=this.getLineContent(s),o=s===r?l.startColumn-1:0,a=s===c?l.endColumn-1:i.length;for(let u=o;u<a;u++)M.$ef(i.charCodeAt(u))?(p=p+1,u=u+1):p=p+1}return p+=this.n($).length*(c-r),p}return this.getValueLengthInRange(l,$)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,$){return this.c.getLineCharCode(l,$)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const $=M.$2e(this.getLineContent(l));return $===-1?0:$+1}getLineLastNonWhitespaceColumn(l){const $=M.$4e(this.getLineContent(l));return $===-1?0:$+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,$,p){let r=this.g,c=this.h,s=this.j,i=!0,o=[];for(let D=0;D<l.length;D++){const h=l[D];i&&h._isTracked&&(i=!1);const b=h.range;if(h.text){let T=!0;s||(T=!M.$pf(h.text),s=T),!r&&T&&(r=M.$of(h.text)),!c&&T&&(c=M.$rf(h.text))}let P="",g=0,v=0,E=0;if(h.text){let T;[g,v,E,T]=(0,m.$wt)(h.text);const N=this.getEOL();T===0||T===(N===`\r
`?2:1)?P=h.text:P=h.text.replace(/\r\n|\r|\n/g,N)}o[D]={sortIndex:D,identifier:h.identifier||null,range:b,rangeOffset:this.getOffsetAt(b.startLineNumber,b.startColumn),rangeLength:this.getValueLengthInRange(b),text:P,eolCount:g,firstLineLength:v,lastLineLength:E,forceMoveMarkers:!!h.forceMoveMarkers,isAutoWhitespaceEdit:h.isAutoWhitespaceEdit||!1}}o.sort(A.u);let a=!1;for(let D=0,h=o.length-1;D<h;D++){const b=o[D].range.getEndPosition(),P=o[D+1].range.getStartPosition();if(P.isBeforeOrEqual(b)){if(P.isBefore(b))throw new Error("Overlapping ranges are not allowed!");a=!0}}i&&(o=this.s(o));const u=p||$?A._getInverseEditRanges(o):[],t=[];if($)for(let D=0;D<o.length;D++){const h=o[D],b=u[D];if(h.isAutoWhitespaceEdit&&h.range.isEmpty())for(let P=b.startLineNumber;P<=b.endLineNumber;P++){let g="";P===b.startLineNumber&&(g=this.getLineContent(h.range.startLineNumber),M.$2e(g)!==-1)||t.push({lineNumber:P,oldContent:g})}}let f=null;if(p){let D=0;f=[];for(let h=0;h<o.length;h++){const b=o[h],P=u[h],g=this.getValueInRange(b.range),v=b.rangeOffset+D;D+=b.text.length-g.length,f[h]={sortIndex:b.sortIndex,identifier:b.identifier,range:P,text:g,textChange:new d.$ft(b.rangeOffset,g,v,b.text)}}a||f.sort((h,b)=>h.sortIndex-b.sortIndex)}this.g=r,this.h=c,this.j=s;const n=this.t(o);let w=null;if($&&t.length>0){t.sort((D,h)=>h.lineNumber-D.lineNumber),w=[];for(let D=0,h=t.length;D<h;D++){const b=t[D].lineNumber;if(D>0&&t[D-1].lineNumber===b)continue;const P=t[D].oldContent,g=this.getLineContent(b);g.length===0||g===P||M.$2e(g)!==-1||w.push(b)}}return this.m.fire(),new R.$gv(f,n,w)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let $=!1;const p=l[0].range,r=l[l.length-1].range,c=new I.$Ws(p.startLineNumber,p.startColumn,r.endLineNumber,r.endColumn);let s=p.startLineNumber,i=p.startColumn;const o=[];for(let n=0,w=l.length;n<w;n++){const D=l[n],h=D.range;$=$||D.forceMoveMarkers,o.push(this.getValueInRange(new I.$Ws(s,i,h.startLineNumber,h.startColumn))),D.text.length>0&&o.push(D.text),s=h.endLineNumber,i=h.endColumn}const a=o.join(""),[u,t,f]=(0,m.$wt)(a);return{sortIndex:0,identifier:l[0].identifier,range:c,rangeOffset:this.getOffsetAt(c.startLineNumber,c.startColumn),rangeLength:this.getValueLengthInRange(c,0),text:a,eolCount:u,firstLineLength:t,lastLineLength:f,forceMoveMarkers:$,isAutoWhitespaceEdit:!1}}t(l){l.sort(A.w);const $=[];for(let p=0;p<l.length;p++){const r=l[p],c=r.range.startLineNumber,s=r.range.startColumn,i=r.range.endLineNumber,o=r.range.endColumn;if(c===i&&s===o&&r.text.length===0)continue;r.text?(this.c.delete(r.rangeOffset,r.rangeLength),this.c.insert(r.rangeOffset,r.text,!0)):this.c.delete(r.rangeOffset,r.rangeLength);const a=new I.$Ws(c,s,i,o);$.push({range:a,rangeLength:r.rangeLength,text:r.text,rangeOffset:r.rangeOffset,forceMoveMarkers:r.forceMoveMarkers})}return $}findMatchesLineByLine(l,$,p,r){return this.c.findMatchesLineByLine(l,$,p,r)}getPieceTree(){return this.c}static _getInverseEditRange(l,$){const p=l.startLineNumber,r=l.startColumn,[c,s,i]=(0,m.$wt)($);let o;if($.length>0){const a=c+1;a===1?o=new I.$Ws(p,r,p,r+s):o=new I.$Ws(p,r,p+a-1,i+1)}else o=new I.$Ws(p,r,p,r);return o}static _getInverseEditRanges(l){const $=[];let p=0,r=0,c=null;for(let s=0,i=l.length;s<i;s++){const o=l[s];let a,u;c?c.range.endLineNumber===o.range.startLineNumber?(a=p,u=r+(o.range.startColumn-c.range.endColumn)):(a=p+(o.range.startLineNumber-c.range.endLineNumber),u=o.range.startColumn):(a=o.range.startLineNumber,u=o.range.startColumn);let t;if(o.text.length>0){const f=o.eolCount+1;f===1?t=new I.$Ws(a,u,a,u+o.firstLineLength):t=new I.$Ws(a,u,a+f-1,o.lastLineLength+1)}else t=new I.$Ws(a,u,a,u);p=t.endLineNumber,r=t.endColumn,$.push(t),c=o}return $}static u(l,$){const p=I.$Ws.compareRangesUsingEnds(l.range,$.range);return p===0?l.sortIndex-$.sortIndex:p}static w(l,$){const p=I.$Ws.compareRangesUsingEnds(l.range,$.range);return p===0?$.sortIndex-l.sortIndex:-p}}e.$dC=A}),define(Re[144],Ae([1,0,14,90,143]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eC=void 0;class R{constructor(d,y,A,k,l,$,p,r,c){this.a=d,this.b=y,this.c=A,this.d=k,this.e=l,this.f=$,this.g=p,this.h=r,this.j=c}k(d){const y=this.c+this.d+this.e,A=this.c+this.e;return y===0?d===1?`
`:`\r
`:A>y/2?`\r
`:`
`}create(d){const y=this.k(d),A=this.a;if(this.j&&(y===`\r
`&&(this.c>0||this.d>0)||y===`
`&&(this.c>0||this.e>0)))for(let l=0,$=A.length;l<$;l++){const p=A[l].buffer.replace(/\r\n|\r|\n/g,y),r=(0,M.$$B)(p);A[l]=new M.$bC(p,r)}const k=new I.$dC(A,this.b,y,this.f,this.g,this.h,this.j);return{textBuffer:k,disposable:k}}getFirstLineText(d){return this.a[0].buffer.substr(0,d).split(/\r\n|\r|\n/)[0]}}class L{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(d){if(d.length===0)return;this.a.length===0&&S.$xf(d)&&(this.b=S.$wf,d=d.substr(1));const y=d.charCodeAt(d.length-1);y===13||y>=55296&&y<=56319?(this.m(d.substr(0,d.length-1),!1),this.c=!0,this.d=y):(this.m(d,!1),this.c=!1,this.d=y)}m(d,y){!y&&d.length===0||(this.c?this.n(String.fromCharCode(this.d)+d):this.n(d))}n(d){const y=(0,M.$_B)(this.e,d);this.a.push(new M.$bC(d,y.lineStarts)),this.f+=y.cr,this.g+=y.lf,this.h+=y.crlf,y.isBasicASCII||(this.l=!1,this.j||(this.j=S.$of(d)),this.k||(this.k=S.$rf(d)))}finish(d=!0){return this.o(),new R(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,d)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const d=this.a[this.a.length-1];d.buffer+=String.fromCharCode(this.d);const y=(0,M.$$B)(d.buffer);d.lineStarts=y,this.d===13&&this.f++}}}e.$eC=L}),define(Re[95],Ae([1,0,23,20]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z$=e.$Y$=void 0;var I;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(I||(I={}));function R(k){for(let l=0,$=k.length;l<$;l+=4){const p=k[l+0],r=k[l+1],c=k[l+2],s=k[l+3];k[l+0]=s,k[l+1]=c,k[l+2]=r,k[l+3]=p}}function L(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return M.$D()||R(l),S.$ke.wrap(l)}function m(k){const l=k.buffer;if(M.$D()||R(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const $=new Uint8Array(l.byteLength);return $.set(l),new Uint32Array($.buffer,$.byteOffset,$.length/4)}}function d(k){const l=new Uint32Array(y(k));let $=0;if(l[$++]=k.id,k.type==="full")l[$++]=1,l[$++]=k.data.length,l.set(k.data,$),$+=k.data.length;else{l[$++]=2,l[$++]=k.deltas.length;for(const p of k.deltas)l[$++]=p.start,l[$++]=p.deleteCount,p.data?(l[$++]=p.data.length,l.set(p.data,$),$+=p.data.length):l[$++]=0}return L(l)}e.$Y$=d;function y(k){let l=0;if(l+=2,k.type==="full")l+=1+k.data.length;else{l+=1,l+=3*k.deltas.length;for(const $ of k.deltas)$.data&&(l+=$.data.length)}return l}function A(k){const l=m(k);let $=0;const p=l[$++];if(l[$++]===1){const i=l[$++],o=l.subarray($,$+i);return $+=i,{id:p,type:"full",data:o}}const c=l[$++],s=[];for(let i=0;i<c;i++){const o=l[$++],a=l[$++],u=l[$++];let t;u>0&&(t=l.subarray($,$+u),$+=u),s[i]={start:o,deleteCount:a,data:t}}return{id:p,type:"delta",deltas:s}}e.$Z$=A}),define(Re[145],Ae([9,10]),function(me,e){return me.create("vs/editor/common/config/editorOptions",e)}),define(Re[146],Ae([1,0,18,26,20,129,147,145]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var d;(function(Y){Y[Y.None=0]="None",Y[Y.Keep=1]="Keep",Y[Y.Brackets=2]="Brackets",Y[Y.Advanced=3]="Advanced",Y[Y.Full=4]="Full"})(d||(e.EditorAutoIndentStrategy=d={})),e.MINIMAP_GUTTER_WIDTH=8;class y{constructor(x){this.c=x}hasChanged(x){return this.c[x]}}e.ConfigurationChangedEvent=y;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class k{constructor(x,pe,Ve,Qe){this.id=x,this.name=pe,this.defaultValue=Ve,this.schema=Qe}applyUpdate(x,pe){return $(x,pe)}compute(x,pe,Ve){return Ve}}class l{constructor(x,pe){this.newValue=x,this.didChange=pe}}e.ApplyUpdateResult=l;function $(Y,x){if(typeof Y!="object"||typeof x!="object"||!Y||!x)return new l(x,Y!==x);if(Array.isArray(Y)||Array.isArray(x)){const Ve=Array.isArray(Y)&&Array.isArray(x)&&S.$ub(Y,x);return new l(x,!Ve)}let pe=!1;for(const Ve in x)if(x.hasOwnProperty(Ve)){const Qe=$(Y[Ve],x[Ve]);Qe.didChange&&(Y[Ve]=Qe.newValue,pe=!0)}return new l(Y,pe)}class p{constructor(x){this.schema=void 0,this.id=x,this.name="_never_",this.defaultValue=void 0}applyUpdate(x,pe){return $(x,pe)}validate(x){return this.defaultValue}}class r{constructor(x,pe,Ve,Qe){this.id=x,this.name=pe,this.defaultValue=Ve,this.schema=Qe}applyUpdate(x,pe){return $(x,pe)}validate(x){return typeof x>"u"?this.defaultValue:x}compute(x,pe,Ve){return Ve}}function c(Y,x){return typeof Y>"u"?x:Y==="false"?!1:!!Y}e.boolean=c;class s extends r{constructor(x,pe,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="boolean",Qe.default=Ve),super(x,pe,Ve,Qe)}validate(x){return c(x,this.defaultValue)}}function i(Y,x,pe,Ve){if(typeof Y>"u")return x;let Qe=parseInt(Y,10);return isNaN(Qe)?x:(Qe=Math.max(pe,Qe),Qe=Math.min(Ve,Qe),Qe|0)}e.clampedInt=i;class o extends r{static clampedInt(x,pe,Ve,Qe){return i(x,pe,Ve,Qe)}constructor(x,pe,Ve,Qe,nt,st=void 0){typeof st<"u"&&(st.type="integer",st.default=Ve,st.minimum=Qe,st.maximum=nt),super(x,pe,Ve,st),this.minimum=Qe,this.maximum=nt}validate(x){return o.clampedInt(x,this.defaultValue,this.minimum,this.maximum)}}function a(Y,x,pe,Ve){if(typeof Y>"u")return x;const Qe=u.float(Y,x);return u.clamp(Qe,pe,Ve)}e.clampedFloat=a;class u extends r{static clamp(x,pe,Ve){return x<pe?pe:x>Ve?Ve:x}static float(x,pe){if(typeof x=="number")return x;if(typeof x>"u")return pe;const Ve=parseFloat(x);return isNaN(Ve)?pe:Ve}constructor(x,pe,Ve,Qe,nt){typeof nt<"u"&&(nt.type="number",nt.default=Ve),super(x,pe,Ve,nt),this.validationFn=Qe}validate(x){return this.validationFn(u.float(x,this.defaultValue))}}class t extends r{static string(x,pe){return typeof x!="string"?pe:x}constructor(x,pe,Ve,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.default=Ve),super(x,pe,Ve,Qe)}validate(x){return t.string(x,this.defaultValue)}}function f(Y,x,pe,Ve){return typeof Y!="string"?x:Ve&&Y in Ve?Ve[Y]:pe.indexOf(Y)===-1?x:Y}e.stringSet=f;class n extends r{constructor(x,pe,Ve,Qe,nt=void 0){typeof nt<"u"&&(nt.type="string",nt.enum=Qe,nt.default=Ve),super(x,pe,Ve,nt),this.c=Qe}validate(x){return f(x,this.defaultValue,this.c)}}class w extends k{constructor(x,pe,Ve,Qe,nt,st,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.enum=nt,Ne.default=Qe),super(x,pe,Ve,Ne),this.c=nt,this.d=st}validate(x){return typeof x!="string"?this.defaultValue:this.c.indexOf(x)===-1?this.defaultValue:this.d(x)}}function D(Y){switch(Y){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[m.localize(0,null),m.localize(1,null),m.localize(2,null)],default:"auto",tags:["accessibility"],description:m.localize(3,null)})}validate(x){switch(x){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(x,pe,Ve){return Ve===0?x.accessibilitySupport:Ve}}class b extends k{constructor(){const x={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",x,{"editor.comments.insertSpace":{type:"boolean",default:x.insertSpace,description:m.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:x.ignoreEmptyLines,description:m.localize(5,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertSpace:c(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:c(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var P;(function(Y){Y[Y.Hidden=0]="Hidden",Y[Y.Blink=1]="Blink",Y[Y.Smooth=2]="Smooth",Y[Y.Phase=3]="Phase",Y[Y.Expand=4]="Expand",Y[Y.Solid=5]="Solid"})(P||(e.TextEditorCursorBlinkingStyle=P={}));function g(Y){switch(Y){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var v;(function(Y){Y[Y.Line=1]="Line",Y[Y.Block=2]="Block",Y[Y.Underline=3]="Underline",Y[Y.LineThin=4]="LineThin",Y[Y.BlockOutline=5]="BlockOutline",Y[Y.UnderlineThin=6]="UnderlineThin"})(v||(e.TextEditorCursorStyle=v={}));function E(Y){switch(Y){case v.Line:return"line";case v.Block:return"block";case v.Underline:return"underline";case v.LineThin:return"line-thin";case v.BlockOutline:return"block-outline";case v.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function T(Y){switch(Y){case"line":return v.Line;case"block":return v.Block;case"underline":return v.Underline;case"line-thin":return v.LineThin;case"block-outline":return v.BlockOutline;case"underline-thin":return v.UnderlineThin}}class N extends p{constructor(){super(140)}compute(x,pe,Ve){const Qe=["monaco-editor"];return pe.get(39)&&Qe.push(pe.get(39)),x.extraEditorClassName&&Qe.push(x.extraEditorClassName),pe.get(73)==="default"?Qe.push("mouse-default"):pe.get(73)==="copy"&&Qe.push("mouse-copy"),pe.get(110)&&Qe.push("showUnused"),pe.get(138)&&Qe.push("showDeprecated"),Qe.join(" ")}}class J extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:m.localize(6,null)})}compute(x,pe,Ve){return Ve&&x.emptySelectionClipboard}}class q extends k{constructor(){const x={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",x,{"editor.find.cursorMoveOnType":{type:"boolean",default:x.cursorMoveOnType,description:m.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:x.seedSearchStringFromSelection,enumDescriptions:[m.localize(8,null),m.localize(9,null),m.localize(10,null)],description:m.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:x.autoFindInSelection,enumDescriptions:[m.localize(12,null),m.localize(13,null),m.localize(14,null)],description:m.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:x.globalFindClipboard,description:m.localize(16,null),included:I.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:x.addExtraSpaceOnTop,description:m.localize(17,null)},"editor.find.loop":{type:"boolean",default:x.loop,description:m.localize(18,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{cursorMoveOnType:c(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof x.seedSearchStringFromSelection=="boolean"?x.seedSearchStringFromSelection?"always":"never":f(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof x.autoFindInSelection=="boolean"?x.autoFindInSelection?"always":"never":f(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:c(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:c(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:c(pe.loop,this.defaultValue.loop)}}}class U extends k{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:m.localize(19,null)},{type:"string",description:m.localize(20,null)}],description:m.localize(21,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"||x.length===0?U.OFF:x==="true"?U.ON:x:x?U.ON:U.OFF}}e.EditorFontLigatures=U;class C extends k{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",C.OFF,{anyOf:[{type:"boolean",description:m.localize(22,null)},{type:"string",description:m.localize(23,null)}],description:m.localize(24,null),default:!1})}validate(x){return typeof x>"u"?this.defaultValue:typeof x=="string"?x==="false"?C.OFF:x==="true"?C.TRANSLATE:x:x?C.TRANSLATE:C.OFF}compute(x,pe,Ve){return x.fontInfo.fontVariationSettings}}e.EditorFontVariations=C;class F extends p{constructor(){super(50)}compute(x,pe,Ve){return x.fontInfo}}class W extends r{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:m.localize(25,null)})}validate(x){const pe=u.float(x,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp(pe,6,100)}compute(x,pe,Ve){return x.fontInfo.fontSize}}class re extends k{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:m.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:m.localize(27,null)})}validate(x){return x==="normal"||x==="bold"?x:String(o.clampedInt(x,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ce extends k{constructor(){const x={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:x.multiple,enumDescriptions:[m.localize(28,null),m.localize(29,null),m.localize(30,null)]},Ve=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",x,{"editor.gotoLocation.multiple":{deprecationMessage:m.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:m.localize(32,null),...pe},"editor.gotoLocation.multipleTypeDefinitions":{description:m.localize(33,null),...pe},"editor.gotoLocation.multipleDeclarations":{description:m.localize(34,null),...pe},"editor.gotoLocation.multipleImplementations":{description:m.localize(35,null),...pe},"editor.gotoLocation.multipleReferences":{description:m.localize(36,null),...pe},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:x.alternativeDefinitionCommand,enum:Ve,description:m.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:x.alternativeTypeDefinitionCommand,enum:Ve,description:m.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:x.alternativeDeclarationCommand,enum:Ve,description:m.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:x.alternativeImplementationCommand,enum:Ve,description:m.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:x.alternativeReferenceCommand,enum:Ve,description:m.localize(41,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{multiple:f(pe.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:pe.multipleDefinitions??f(pe.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:pe.multipleTypeDefinitions??f(pe.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:pe.multipleDeclarations??f(pe.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:pe.multipleImplementations??f(pe.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:pe.multipleReferences??f(pe.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(pe.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(pe.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(pe.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(pe.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(pe.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends k{constructor(){const x={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",x,{"editor.hover.enabled":{type:"boolean",default:x.enabled,description:m.localize(42,null)},"editor.hover.delay":{type:"number",default:x.delay,minimum:0,maximum:1e4,description:m.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:x.sticky,description:m.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:x.hidingDelay,description:m.localize(45,null)},"editor.hover.above":{type:"boolean",default:x.above,description:m.localize(46,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:c(pe.sticky,this.defaultValue.sticky),hidingDelay:o.clampedInt(pe.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:c(pe.above,this.defaultValue.above)}}}var De;(function(Y){Y[Y.None=0]="None",Y[Y.Text=1]="Text",Y[Y.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class le extends p{constructor(){super(143)}compute(x,pe,Ve){return le.computeLayout(pe,{memory:x.memory,outerWidth:x.outerWidth,outerHeight:x.outerHeight,isDominatedByLongLines:x.isDominatedByLongLines,lineHeight:x.fontInfo.lineHeight,viewLineCount:x.viewLineCount,lineNumbersDigitCount:x.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:x.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:x.fontInfo.maxDigitWidth,pixelRatio:x.pixelRatio,glyphMarginDecorationLaneCount:x.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(x){const pe=x.height/x.lineHeight,Ve=Math.floor(x.paddingTop/x.lineHeight);let Qe=Math.floor(x.paddingBottom/x.lineHeight);x.scrollBeyondLastLine&&(Qe=Math.max(Qe,pe-1));const nt=(Ve+x.viewLineCount+Qe)/(x.pixelRatio*x.height),st=Math.floor(x.viewLineCount/nt);return{typicalViewportLineCount:pe,extraLinesBeforeFirstLine:Ve,extraLinesBeyondLastLine:Qe,desiredRatio:nt,minimapLineCount:st}}static c(x,pe){const Ve=x.outerWidth,Qe=x.outerHeight,nt=x.pixelRatio;if(!x.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(nt*Qe),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Qe};const st=pe.stableMinimapLayoutInput,Ne=st&&x.outerHeight===st.outerHeight&&x.lineHeight===st.lineHeight&&x.typicalHalfwidthCharacterWidth===st.typicalHalfwidthCharacterWidth&&x.pixelRatio===st.pixelRatio&&x.scrollBeyondLastLine===st.scrollBeyondLastLine&&x.paddingTop===st.paddingTop&&x.paddingBottom===st.paddingBottom&&x.minimap.enabled===st.minimap.enabled&&x.minimap.side===st.minimap.side&&x.minimap.size===st.minimap.size&&x.minimap.showSlider===st.minimap.showSlider&&x.minimap.renderCharacters===st.minimap.renderCharacters&&x.minimap.maxColumn===st.minimap.maxColumn&&x.minimap.scale===st.minimap.scale&&x.verticalScrollbarWidth===st.verticalScrollbarWidth&&x.isViewportWrapping===st.isViewportWrapping,Mt=x.lineHeight,Qt=x.typicalHalfwidthCharacterWidth,_t=x.scrollBeyondLastLine,jt=x.minimap.renderCharacters;let yt=nt>=2?Math.round(x.minimap.scale*2):x.minimap.scale;const ei=x.minimap.maxColumn,Bt=x.minimap.size,ni=x.minimap.side,Zt=x.verticalScrollbarWidth,Yt=x.viewLineCount,Xe=x.remainingWidth,Wt=x.isViewportWrapping,ti=jt?2:3;let ht=Math.floor(nt*Qe);const mt=ht/nt;let Kt=!1,ii=!1,Ct=ti*yt,dt=yt/nt,Lt=1;if(Bt==="fill"||Bt==="fit"){const{typicalViewportLineCount:ft,extraLinesBeforeFirstLine:Tt,extraLinesBeyondLastLine:It,desiredRatio:Nt,minimapLineCount:qt}=le.computeContainedMinimapLineCount({viewLineCount:Yt,scrollBeyondLastLine:_t,paddingTop:x.paddingTop,paddingBottom:x.paddingBottom,height:Qe,lineHeight:Mt,pixelRatio:nt});if(Yt/qt>1)Kt=!0,ii=!0,yt=1,Ct=1,dt=yt/nt;else{let Dt=!1,Gt=yt+1;if(Bt==="fit"){const Et=Math.ceil((Tt+Yt+It)*Ct);Wt&&Ne&&Xe<=pe.stableFitRemainingWidth?(Dt=!0,Gt=pe.stableFitMaxMinimapScale):Dt=Et>ht}if(Bt==="fill"||Dt){Kt=!0;const Et=yt;Ct=Math.min(Mt*nt,Math.max(1,Math.floor(1/Nt))),Wt&&Ne&&Xe<=pe.stableFitRemainingWidth&&(Gt=pe.stableFitMaxMinimapScale),yt=Math.min(Gt,Math.max(1,Math.floor(Ct/ti))),yt>Et&&(Lt=Math.min(2,yt/Et)),dt=yt/nt/Lt,ht=Math.ceil(Math.max(ft,Tt+Yt+It)*Ct),Wt?(pe.stableMinimapLayoutInput=x,pe.stableFitRemainingWidth=Xe,pe.stableFitMaxMinimapScale=yt):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0)}}}const ri=Math.floor(ei*dt),Rt=Math.min(ri,Math.max(0,Math.floor((Xe-Zt-2)*dt/(Qt+dt)))+e.MINIMAP_GUTTER_WIDTH);let He=Math.floor(nt*Rt);const Ft=He/nt;He=Math.floor(He*Lt);const Vt=jt?1:2,Xt=ni==="left"?0:Ve-Rt-Zt;return{renderMinimap:Vt,minimapLeft:Xt,minimapWidth:Rt,minimapHeightIsEditorHeight:Kt,minimapIsSampling:ii,minimapScale:yt,minimapLineHeight:Ct,minimapCanvasInnerWidth:He,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Ft,minimapCanvasOuterHeight:mt}}static computeLayout(x,pe){const Ve=pe.outerWidth|0,Qe=pe.outerHeight|0,nt=pe.lineHeight|0,st=pe.lineNumbersDigitCount|0,Ne=pe.typicalHalfwidthCharacterWidth,Mt=pe.maxDigitWidth,Qt=pe.pixelRatio,_t=pe.viewLineCount,jt=x.get(135),yt=jt==="inherit"?x.get(134):jt,ei=yt==="inherit"?x.get(130):yt,Bt=x.get(133),ni=pe.isDominatedByLongLines,Zt=x.get(57),Yt=x.get(67).renderType!==0,Xe=x.get(68),Wt=x.get(104),ti=x.get(83),ht=x.get(72),mt=x.get(102),Kt=mt.verticalScrollbarSize,ii=mt.verticalHasArrows,Ct=mt.arrowSize,dt=mt.horizontalScrollbarSize,Lt=x.get(43),ri=x.get(109)!=="never";let Rt=x.get(65);Lt&&ri&&(Rt+=16);let He=0;if(Yt){const St=Math.max(st,Xe);He=Math.round(St*Mt)}let Ft=0;Zt&&(Ft=nt*pe.glyphMarginDecorationLaneCount);let Vt=0,Xt=Vt+Ft,ft=Xt+He,Tt=ft+Rt;const It=Ve-Ft-He-Rt;let Nt=!1,qt=!1,Ot=-1;yt==="inherit"&&ni?(Nt=!0,qt=!0):ei==="on"||ei==="bounded"?qt=!0:ei==="wordWrapColumn"&&(Ot=Bt);const Dt=le.c({outerWidth:Ve,outerHeight:Qe,lineHeight:nt,typicalHalfwidthCharacterWidth:Ne,pixelRatio:Qt,scrollBeyondLastLine:Wt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:ht,verticalScrollbarWidth:Kt,viewLineCount:_t,remainingWidth:It,isViewportWrapping:qt},pe.memory||new A);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(Vt+=Dt.minimapWidth,Xt+=Dt.minimapWidth,ft+=Dt.minimapWidth,Tt+=Dt.minimapWidth);const Gt=It-Dt.minimapWidth,Et=Math.max(1,Math.floor((Gt-Kt-2)/Ne)),wt=ii?Ct:0;return qt&&(Ot=Math.max(1,Et),ei==="bounded"&&(Ot=Math.min(Ot,Bt))),{width:Ve,height:Qe,glyphMarginLeft:Vt,glyphMarginWidth:Ft,glyphMarginDecorationLaneCount:pe.glyphMarginDecorationLaneCount,lineNumbersLeft:Xt,lineNumbersWidth:He,decorationsLeft:ft,decorationsWidth:Rt,contentLeft:Tt,contentWidth:Gt,minimap:Dt,viewportColumn:Et,isWordWrapMinified:Nt,isViewportWrapping:qt,wrappingColumn:Ot,verticalScrollbarWidth:Kt,horizontalScrollbarHeight:dt,overviewRuler:{top:wt,width:Kt,height:Qe-2*wt,right:0}}}}e.EditorLayoutInfoComputer=le;class ve extends k{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[m.localize(47,null),m.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:m.localize(49,null)}})}validate(x){return f(x,"simple",["simple","advanced"])}compute(x,pe,Ve){return pe.get(2)===2?"advanced":Ve}}var se;(function(Y){Y.Off="off",Y.OnCode="onCode",Y.On="on"})(se||(e.ShowLightbulbIconMode=se={}));class $e extends k{constructor(){const x={enabled:se.OnCode};super(64,"lightbulb",x,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[se.Off,se.OnCode,se.On],default:x.enabled,enumDescriptions:[m.localize(50,null),m.localize(51,null),m.localize(52,null)],description:m.localize(53,null)}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{enabled:f(x.enabled,this.defaultValue.enabled,[se.Off,se.OnCode,se.On])}}}class te extends k{constructor(){const x={enabled:!1,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",x,{"editor.stickyScroll.enabled":{type:"boolean",default:x.enabled,description:m.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:x.maxLineCount,minimum:1,maximum:10,description:m.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:x.defaultModel,description:m.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:x.scrollWithEditor,description:m.localize(57,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),maxLineCount:o.clampedInt(pe.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:f(pe.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:c(pe.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class X extends k{constructor(){const x={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",x,{"editor.inlayHints.enabled":{type:"string",default:x.enabled,description:m.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[m.localize(59,null),m.localize(60,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(61,null,I.$j?"Ctrl+Option":"Ctrl+Alt"),m.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:x.fontSize,markdownDescription:m.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:x.fontFamily,markdownDescription:m.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:x.padding,description:m.localize(65,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return typeof pe.enabled=="boolean"&&(pe.enabled=pe.enabled?"on":"off"),{enabled:f(pe.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily),padding:c(pe.padding,this.defaultValue.padding)}}}class V extends k{constructor(){super(65,"lineDecorationsWidth",10)}validate(x){return typeof x=="string"&&/^\d+(\.\d+)?ch$/.test(x)?-parseFloat(x.substring(0,x.length-2)):o.clampedInt(x,this.defaultValue,0,1e3)}compute(x,pe,Ve){return Ve<0?o.clampedInt(-Ve*x.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ve}}class ie extends u{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,x=>u.clamp(x,0,150),{markdownDescription:m.localize(66,null)})}compute(x,pe,Ve){return x.fontInfo.lineHeight}}class Ce extends k{constructor(){const x={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",x,{"editor.minimap.enabled":{type:"boolean",default:x.enabled,description:m.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:x.autohide,description:m.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[m.localize(69,null),m.localize(70,null),m.localize(71,null)],default:x.size,description:m.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:x.side,description:m.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:x.showSlider,description:m.localize(74,null)},"editor.minimap.scale":{type:"number",default:x.scale,minimum:1,maximum:3,enum:[1,2,3],description:m.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:x.renderCharacters,description:m.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:x.maxColumn,description:m.localize(77,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),autohide:c(pe.autohide,this.defaultValue.autohide),size:f(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(pe.side,this.defaultValue.side,["right","left"]),showSlider:f(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:c(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function Te(Y){return Y==="ctrlCmd"?I.$j?"metaKey":"ctrlKey":"altKey"}class Pe extends k{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:m.localize(79,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class be extends k{constructor(){const x={enabled:!0,cycle:!0};super(85,"parameterHints",x,{"editor.parameterHints.enabled":{type:"boolean",default:x.enabled,description:m.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:x.cycle,description:m.localize(81,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),cycle:c(pe.cycle,this.defaultValue.cycle)}}}class ge extends p{constructor(){super(141)}compute(x,pe,Ve){return x.pixelRatio}}class G extends k{constructor(){const x={other:"on",comments:"off",strings:"off"},pe=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[m.localize(82,null),m.localize(83,null),m.localize(84,null)]}];super(88,"quickSuggestions",x,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:pe,default:x.strings,description:m.localize(85,null)},comments:{anyOf:pe,default:x.comments,description:m.localize(86,null)},other:{anyOf:pe,default:x.other,description:m.localize(87,null)}},default:x,markdownDescription:m.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=x}validate(x){if(typeof x=="boolean"){const Qt=x?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!x||typeof x!="object")return this.defaultValue;const{other:pe,comments:Ve,strings:Qe}=x,nt=["on","inline","off"];let st,Ne,Mt;return typeof pe=="boolean"?st=pe?"on":"off":st=f(pe,this.defaultValue.other,nt),typeof Ve=="boolean"?Ne=Ve?"on":"off":Ne=f(Ve,this.defaultValue.comments,nt),typeof Qe=="boolean"?Mt=Qe?"on":"off":Mt=f(Qe,this.defaultValue.strings,nt),{other:st,comments:Ne,strings:Mt}}}var _;(function(Y){Y[Y.Off=0]="Off",Y[Y.On=1]="On",Y[Y.Relative=2]="Relative",Y[Y.Interval=3]="Interval",Y[Y.Custom=4]="Custom"})(_||(e.RenderLineNumbersType=_={}));class ue extends k{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[m.localize(89,null),m.localize(90,null),m.localize(91,null),m.localize(92,null)],default:"on",description:m.localize(93,null)})}validate(x){let pe=this.defaultValue.renderType,Ve=this.defaultValue.renderFn;return typeof x<"u"&&(typeof x=="function"?(pe=4,Ve=x):x==="interval"?pe=3:x==="relative"?pe=2:x==="on"?pe=1:pe=0),{renderType:pe,renderFn:Ve}}}function de(Y){const x=Y.get(97);return x==="editable"?Y.get(90):x!=="on"}e.filterValidationDecorations=de;class Le extends k{constructor(){const x=[],pe={type:"number",description:m.localize(94,null)};super(101,"rulers",x,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:m.localize(95,null),format:"color-hex"}}}]},default:x,description:m.localize(96,null)})}validate(x){if(Array.isArray(x)){const pe=[];for(const Ve of x)if(typeof Ve=="number")pe.push({column:o.clampedInt(Ve,0,0,1e4),color:null});else if(Ve&&typeof Ve=="object"){const Qe=Ve;pe.push({column:o.clampedInt(Qe.column,0,0,1e4),color:Qe.color})}return pe.sort((Ve,Qe)=>Ve.column-Qe.column),pe}return this.defaultValue}}class fe extends k{constructor(){super(91,"readOnlyMessage",void 0)}validate(x){return!x||typeof x!="object"?this.defaultValue:x}}function ke(Y,x){if(typeof Y!="string")return x;switch(Y){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ie extends k{constructor(){const x={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",x,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(97,null),m.localize(98,null),m.localize(99,null)],default:"auto",description:m.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[m.localize(101,null),m.localize(102,null),m.localize(103,null)],default:"auto",description:m.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:x.verticalScrollbarSize,description:m.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:x.horizontalScrollbarSize,description:m.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:x.scrollByPage,description:m.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:x.ignoreHorizontalScrollbarInContentHeight,description:m.localize(108,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x,Ve=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Qe=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ke(pe.vertical,this.defaultValue.vertical),horizontal:ke(pe.horizontal,this.defaultValue.horizontal),useShadows:c(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:c(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:c(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:c(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:c(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ve,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,Ve,0,1e3),verticalScrollbarSize:Qe,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,Qe,0,1e3),scrollByPage:c(pe.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:c(pe.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class O extends k{constructor(){const x={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",x,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.nonBasicASCII,description:m.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:x.invisibleCharacters,description:m.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:x.ambiguousCharacters,description:m.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeComments,description:m.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:x.includeStrings,description:m.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:x.allowedCharacters,description:m.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:x.allowedLocales,description:m.localize(115,null)}})}applyUpdate(x,pe){let Ve=!1;pe.allowedCharacters&&x&&(M.$Cn(x.allowedCharacters,pe.allowedCharacters)||(x={...x,allowedCharacters:pe.allowedCharacters},Ve=!0)),pe.allowedLocales&&x&&(M.$Cn(x.allowedLocales,pe.allowedLocales)||(x={...x,allowedLocales:pe.allowedLocales},Ve=!0));const Qe=super.applyUpdate(x,pe);return Ve?new l(Qe.newValue,!0):Qe}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{nonBasicASCII:Z(pe.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:c(pe.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:c(pe.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Z(pe.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Z(pe.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(x.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(x.allowedLocales,this.defaultValue.allowedLocales)}}c(x,pe){if(typeof x!="object"||!x)return pe;const Ve={};for(const[Qe,nt]of Object.entries(x))nt===!0&&(Ve[Qe]=!0);return Ve}}class K extends k{constructor(){const x={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",x,{"editor.inlineSuggest.enabled":{type:"boolean",default:x.enabled,description:m.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:x.showToolbar,enum:["always","onHover","never"],enumDescriptions:[m.localize(117,null),m.localize(118,null),m.localize(119,null)],description:m.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:x.suppressSuggestions,description:m.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:x.fontFamily,description:m.localize(122,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),mode:f(pe.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:f(pe.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:c(pe.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:c(pe.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class j extends k{constructor(){const x={enabled:R.$us.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:R.$us.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",x,{"editor.bracketPairColorization.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:x.independentColorPoolPerBracketType,description:m.localize(124,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:c(pe.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class H extends k{constructor(){const x={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",x,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(125,null),m.localize(126,null),m.localize(127,null)],default:x.bracketPairs,description:m.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[m.localize(129,null),m.localize(130,null),m.localize(131,null)],default:x.bracketPairsHorizontal,description:m.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:x.highlightActiveBracketPair,description:m.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:x.indentation,description:m.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[m.localize(135,null),m.localize(136,null),m.localize(137,null)],default:x.highlightActiveIndentation,description:m.localize(138,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{bracketPairs:Z(pe.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Z(pe.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:c(pe.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:c(pe.indentation,this.defaultValue.indentation),highlightActiveIndentation:Z(pe.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Z(Y,x,pe){const Ve=pe.indexOf(Y);return Ve===-1?x:pe[Ve]}class oe extends k{constructor(){const x={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",x,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[m.localize(139,null),m.localize(140,null)],default:x.insertMode,description:m.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:x.filterGraceful,description:m.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:x.localityBonus,description:m.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:x.shareSuggestSelections,markdownDescription:m.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[m.localize(145,null),m.localize(146,null),m.localize(147,null),m.localize(148,null)],default:x.selectionMode,markdownDescription:m.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:x.snippetsPreventQuickSuggestions,description:m.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:x.showIcons,description:m.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:x.showStatusBar,description:m.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:x.preview,description:m.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:x.showInlineDetails,description:m.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:m.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:m.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:m.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:m.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:m.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:m.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:m.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:m.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:m.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:m.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:m.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:m.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:m.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:m.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:m.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:m.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:m.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:m.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:m.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:m.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:m.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:m.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:m.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:m.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:m.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:m.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:m.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:m.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:m.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:m.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:m.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:m.localize(186,null)}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{insertMode:f(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:c(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:c(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:c(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:c(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:f(pe.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:c(pe.showIcons,this.defaultValue.showIcons),showStatusBar:c(pe.showStatusBar,this.defaultValue.showStatusBar),preview:c(pe.preview,this.defaultValue.preview),previewMode:f(pe.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:c(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:c(pe.showMethods,this.defaultValue.showMethods),showFunctions:c(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:c(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:c(pe.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:c(pe.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:c(pe.showFields,this.defaultValue.showFields),showVariables:c(pe.showVariables,this.defaultValue.showVariables),showClasses:c(pe.showClasses,this.defaultValue.showClasses),showStructs:c(pe.showStructs,this.defaultValue.showStructs),showInterfaces:c(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:c(pe.showModules,this.defaultValue.showModules),showProperties:c(pe.showProperties,this.defaultValue.showProperties),showEvents:c(pe.showEvents,this.defaultValue.showEvents),showOperators:c(pe.showOperators,this.defaultValue.showOperators),showUnits:c(pe.showUnits,this.defaultValue.showUnits),showValues:c(pe.showValues,this.defaultValue.showValues),showConstants:c(pe.showConstants,this.defaultValue.showConstants),showEnums:c(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:c(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:c(pe.showKeywords,this.defaultValue.showKeywords),showWords:c(pe.showWords,this.defaultValue.showWords),showColors:c(pe.showColors,this.defaultValue.showColors),showFiles:c(pe.showFiles,this.defaultValue.showFiles),showReferences:c(pe.showReferences,this.defaultValue.showReferences),showFolders:c(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:c(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:c(pe.showSnippets,this.defaultValue.showSnippets),showUsers:c(pe.showUsers,this.defaultValue.showUsers),showIssues:c(pe.showIssues,this.defaultValue.showIssues)}}}class Ee extends k{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:m.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:m.localize(188,null),default:!0,type:"boolean"}})}validate(x){return!x||typeof x!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:c(x.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:c(x.selectSubwords,this.defaultValue.selectSubwords)}}}var Be;(function(Y){Y[Y.None=0]="None",Y[Y.Same=1]="Same",Y[Y.Indent=2]="Indent",Y[Y.DeepIndent=3]="DeepIndent"})(Be||(e.WrappingIndent=Be={}));class We extends k{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[m.localize(189,null),m.localize(190,null),m.localize(191,null),m.localize(192,null)],description:m.localize(193,null),default:"same"}})}validate(x){switch(x){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(x,pe,Ve){return pe.get(2)===2?0:Ve}}class Ze extends p{constructor(){super(144)}compute(x,pe,Ve){const Qe=pe.get(143);return{isDominatedByLongLines:x.isDominatedByLongLines,isWordWrapMinified:Qe.isWordWrapMinified,isViewportWrapping:Qe.isViewportWrapping,wrappingColumn:Qe.wrappingColumn}}}class _e extends k{constructor(){const x={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",x,{"editor.dropIntoEditor.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:m.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[m.localize(196,null),m.localize(197,null)],default:"afterDrop"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),showDropSelector:f(pe.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class at extends k{constructor(){const x={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",x,{"editor.pasteAs.enabled":{type:"boolean",default:x.enabled,markdownDescription:m.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:m.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[m.localize(200,null),m.localize(201,null)],default:"afterPaste"}})}validate(x){if(!x||typeof x!="object")return this.defaultValue;const pe=x;return{enabled:c(pe.enabled,this.defaultValue.enabled),showPasteSelector:f(pe.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",et="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:I.$j?et:I.$k?ct:rt,fontWeight:"normal",fontSize:I.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Y){return e.editorOptionsRegistry[Y.id]=Y,Y}var vt;(function(Y){Y[Y.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Y[Y.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Y[Y.accessibilitySupport=2]="accessibilitySupport",Y[Y.accessibilityPageSize=3]="accessibilityPageSize",Y[Y.ariaLabel=4]="ariaLabel",Y[Y.ariaRequired=5]="ariaRequired",Y[Y.autoClosingBrackets=6]="autoClosingBrackets",Y[Y.autoClosingComments=7]="autoClosingComments",Y[Y.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Y[Y.autoClosingDelete=9]="autoClosingDelete",Y[Y.autoClosingOvertype=10]="autoClosingOvertype",Y[Y.autoClosingQuotes=11]="autoClosingQuotes",Y[Y.autoIndent=12]="autoIndent",Y[Y.automaticLayout=13]="automaticLayout",Y[Y.autoSurround=14]="autoSurround",Y[Y.bracketPairColorization=15]="bracketPairColorization",Y[Y.guides=16]="guides",Y[Y.codeLens=17]="codeLens",Y[Y.codeLensFontFamily=18]="codeLensFontFamily",Y[Y.codeLensFontSize=19]="codeLensFontSize",Y[Y.colorDecorators=20]="colorDecorators",Y[Y.colorDecoratorsLimit=21]="colorDecoratorsLimit",Y[Y.columnSelection=22]="columnSelection",Y[Y.comments=23]="comments",Y[Y.contextmenu=24]="contextmenu",Y[Y.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Y[Y.cursorBlinking=26]="cursorBlinking",Y[Y.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Y[Y.cursorStyle=28]="cursorStyle",Y[Y.cursorSurroundingLines=29]="cursorSurroundingLines",Y[Y.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Y[Y.cursorWidth=31]="cursorWidth",Y[Y.disableLayerHinting=32]="disableLayerHinting",Y[Y.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Y[Y.domReadOnly=34]="domReadOnly",Y[Y.dragAndDrop=35]="dragAndDrop",Y[Y.dropIntoEditor=36]="dropIntoEditor",Y[Y.emptySelectionClipboard=37]="emptySelectionClipboard",Y[Y.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Y[Y.extraEditorClassName=39]="extraEditorClassName",Y[Y.fastScrollSensitivity=40]="fastScrollSensitivity",Y[Y.find=41]="find",Y[Y.fixedOverflowWidgets=42]="fixedOverflowWidgets",Y[Y.folding=43]="folding",Y[Y.foldingStrategy=44]="foldingStrategy",Y[Y.foldingHighlight=45]="foldingHighlight",Y[Y.foldingImportsByDefault=46]="foldingImportsByDefault",Y[Y.foldingMaximumRegions=47]="foldingMaximumRegions",Y[Y.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Y[Y.fontFamily=49]="fontFamily",Y[Y.fontInfo=50]="fontInfo",Y[Y.fontLigatures=51]="fontLigatures",Y[Y.fontSize=52]="fontSize",Y[Y.fontWeight=53]="fontWeight",Y[Y.fontVariations=54]="fontVariations",Y[Y.formatOnPaste=55]="formatOnPaste",Y[Y.formatOnType=56]="formatOnType",Y[Y.glyphMargin=57]="glyphMargin",Y[Y.gotoLocation=58]="gotoLocation",Y[Y.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Y[Y.hover=60]="hover",Y[Y.inDiffEditor=61]="inDiffEditor",Y[Y.inlineSuggest=62]="inlineSuggest",Y[Y.letterSpacing=63]="letterSpacing",Y[Y.lightbulb=64]="lightbulb",Y[Y.lineDecorationsWidth=65]="lineDecorationsWidth",Y[Y.lineHeight=66]="lineHeight",Y[Y.lineNumbers=67]="lineNumbers",Y[Y.lineNumbersMinChars=68]="lineNumbersMinChars",Y[Y.linkedEditing=69]="linkedEditing",Y[Y.links=70]="links",Y[Y.matchBrackets=71]="matchBrackets",Y[Y.minimap=72]="minimap",Y[Y.mouseStyle=73]="mouseStyle",Y[Y.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",Y[Y.mouseWheelZoom=75]="mouseWheelZoom",Y[Y.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",Y[Y.multiCursorModifier=77]="multiCursorModifier",Y[Y.multiCursorPaste=78]="multiCursorPaste",Y[Y.multiCursorLimit=79]="multiCursorLimit",Y[Y.occurrencesHighlight=80]="occurrencesHighlight",Y[Y.overviewRulerBorder=81]="overviewRulerBorder",Y[Y.overviewRulerLanes=82]="overviewRulerLanes",Y[Y.padding=83]="padding",Y[Y.pasteAs=84]="pasteAs",Y[Y.parameterHints=85]="parameterHints",Y[Y.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",Y[Y.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",Y[Y.quickSuggestions=88]="quickSuggestions",Y[Y.quickSuggestionsDelay=89]="quickSuggestionsDelay",Y[Y.readOnly=90]="readOnly",Y[Y.readOnlyMessage=91]="readOnlyMessage",Y[Y.renameOnType=92]="renameOnType",Y[Y.renderControlCharacters=93]="renderControlCharacters",Y[Y.renderFinalNewline=94]="renderFinalNewline",Y[Y.renderLineHighlight=95]="renderLineHighlight",Y[Y.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",Y[Y.renderValidationDecorations=97]="renderValidationDecorations",Y[Y.renderWhitespace=98]="renderWhitespace",Y[Y.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",Y[Y.roundedSelection=100]="roundedSelection",Y[Y.rulers=101]="rulers",Y[Y.scrollbar=102]="scrollbar",Y[Y.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",Y[Y.scrollBeyondLastLine=104]="scrollBeyondLastLine",Y[Y.scrollPredominantAxis=105]="scrollPredominantAxis",Y[Y.selectionClipboard=106]="selectionClipboard",Y[Y.selectionHighlight=107]="selectionHighlight",Y[Y.selectOnLineNumbers=108]="selectOnLineNumbers",Y[Y.showFoldingControls=109]="showFoldingControls",Y[Y.showUnused=110]="showUnused",Y[Y.snippetSuggestions=111]="snippetSuggestions",Y[Y.smartSelect=112]="smartSelect",Y[Y.smoothScrolling=113]="smoothScrolling",Y[Y.stickyScroll=114]="stickyScroll",Y[Y.stickyTabStops=115]="stickyTabStops",Y[Y.stopRenderingLineAfter=116]="stopRenderingLineAfter",Y[Y.suggest=117]="suggest",Y[Y.suggestFontSize=118]="suggestFontSize",Y[Y.suggestLineHeight=119]="suggestLineHeight",Y[Y.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",Y[Y.suggestSelection=121]="suggestSelection",Y[Y.tabCompletion=122]="tabCompletion",Y[Y.tabIndex=123]="tabIndex",Y[Y.unicodeHighlighting=124]="unicodeHighlighting",Y[Y.unusualLineTerminators=125]="unusualLineTerminators",Y[Y.useShadowDOM=126]="useShadowDOM",Y[Y.useTabStops=127]="useTabStops",Y[Y.wordBreak=128]="wordBreak",Y[Y.wordSeparators=129]="wordSeparators",Y[Y.wordWrap=130]="wordWrap",Y[Y.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",Y[Y.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",Y[Y.wordWrapColumn=133]="wordWrapColumn",Y[Y.wordWrapOverride1=134]="wordWrapOverride1",Y[Y.wordWrapOverride2=135]="wordWrapOverride2",Y[Y.wrappingIndent=136]="wrappingIndent",Y[Y.wrappingStrategy=137]="wrappingStrategy",Y[Y.showDeprecated=138]="showDeprecated",Y[Y.inlayHints=139]="inlayHints",Y[Y.editorClassName=140]="editorClassName",Y[Y.pixelRatio=141]="pixelRatio",Y[Y.tabFocusMode=142]="tabFocusMode",Y[Y.layoutInfo=143]="layoutInfo",Y[Y.wrappingInfo=144]="wrappingInfo",Y[Y.defaultColorDecorators=145]="defaultColorDecorators",Y[Y.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",Y[Y.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(vt||(e.EditorOption=vt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:m.localize(202,null)})),acceptSuggestionOnEnter:je(new n(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",m.localize(203,null),""],markdownDescription:m.localize(204,null)})),accessibilitySupport:je(new h),accessibilityPageSize:je(new o(3,"accessibilityPageSize",10,1,1073741824,{description:m.localize(205,null),tags:["accessibility"]})),ariaLabel:je(new t(4,"ariaLabel",m.localize(206,null))),ariaRequired:je(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:m.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:je(new n(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(208,null),m.localize(209,null),""],description:m.localize(210,null)})),autoClosingComments:je(new n(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(211,null),m.localize(212,null),""],description:m.localize(213,null)})),autoClosingDelete:je(new n(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",m.localize(214,null),""],description:m.localize(215,null)})),autoClosingOvertype:je(new n(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",m.localize(216,null),""],description:m.localize(217,null)})),autoClosingQuotes:je(new n(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",m.localize(218,null),m.localize(219,null),""],description:m.localize(220,null)})),autoIndent:je(new w(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],D,{enumDescriptions:[m.localize(221,null),m.localize(222,null),m.localize(223,null),m.localize(224,null),m.localize(225,null)],description:m.localize(226,null)})),automaticLayout:je(new s(13,"automaticLayout",!1)),autoSurround:je(new n(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[m.localize(227,null),m.localize(228,null),m.localize(229,null),""],description:m.localize(230,null)})),bracketPairColorization:je(new j),bracketPairGuides:je(new H),stickyTabStops:je(new s(115,"stickyTabStops",!1,{description:m.localize(231,null)})),codeLens:je(new s(17,"codeLens",!0,{description:m.localize(232,null)})),codeLensFontFamily:je(new t(18,"codeLensFontFamily","",{description:m.localize(233,null)})),codeLensFontSize:je(new o(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:m.localize(234,null)})),colorDecorators:je(new s(20,"colorDecorators",!0,{description:m.localize(235,null)})),colorDecoratorActivatedOn:je(new n(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[m.localize(236,null),m.localize(237,null),m.localize(238,null)],description:m.localize(239,null)})),colorDecoratorsLimit:je(new o(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:m.localize(240,null)})),columnSelection:je(new s(22,"columnSelection",!1,{description:m.localize(241,null)})),comments:je(new b),contextmenu:je(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new s(25,"copyWithSyntaxHighlighting",!0,{description:m.localize(242,null)})),cursorBlinking:je(new w(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],g,{description:m.localize(243,null)})),cursorSmoothCaretAnimation:je(new n(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[m.localize(244,null),m.localize(245,null),m.localize(246,null)],description:m.localize(247,null)})),cursorStyle:je(new w(28,"cursorStyle",v.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],T,{description:m.localize(248,null)})),cursorSurroundingLines:je(new o(29,"cursorSurroundingLines",0,0,1073741824,{description:m.localize(249,null)})),cursorSurroundingLinesStyle:je(new n(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[m.localize(250,null),m.localize(251,null)],markdownDescription:m.localize(252,null)})),cursorWidth:je(new o(31,"cursorWidth",0,0,1073741824,{markdownDescription:m.localize(253,null)})),disableLayerHinting:je(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new s(34,"domReadOnly",!1)),dragAndDrop:je(new s(35,"dragAndDrop",!0,{description:m.localize(254,null)})),emptySelectionClipboard:je(new J),dropIntoEditor:je(new _e),stickyScroll:je(new te),experimentalWhitespaceRendering:je(new n(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[m.localize(255,null),m.localize(256,null),m.localize(257,null)],description:m.localize(258,null)})),extraEditorClassName:je(new t(39,"extraEditorClassName","")),fastScrollSensitivity:je(new u(40,"fastScrollSensitivity",5,Y=>Y<=0?5:Y,{markdownDescription:m.localize(259,null)})),find:je(new q),fixedOverflowWidgets:je(new s(42,"fixedOverflowWidgets",!1)),folding:je(new s(43,"folding",!0,{description:m.localize(260,null)})),foldingStrategy:je(new n(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[m.localize(261,null),m.localize(262,null)],description:m.localize(263,null)})),foldingHighlight:je(new s(45,"foldingHighlight",!0,{description:m.localize(264,null)})),foldingImportsByDefault:je(new s(46,"foldingImportsByDefault",!1,{description:m.localize(265,null)})),foldingMaximumRegions:je(new o(47,"foldingMaximumRegions",5e3,10,65e3,{description:m.localize(266,null)})),unfoldOnClickAfterEndOfLine:je(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:m.localize(267,null)})),fontFamily:je(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:m.localize(268,null)})),fontInfo:je(new F),fontLigatures2:je(new U),fontSize:je(new W),fontWeight:je(new re),fontVariations:je(new C),formatOnPaste:je(new s(55,"formatOnPaste",!1,{description:m.localize(269,null)})),formatOnType:je(new s(56,"formatOnType",!1,{description:m.localize(270,null)})),glyphMargin:je(new s(57,"glyphMargin",!0,{description:m.localize(271,null)})),gotoLocation:je(new ce),hideCursorInOverviewRuler:je(new s(59,"hideCursorInOverviewRuler",!1,{description:m.localize(272,null)})),hover:je(new we),inDiffEditor:je(new s(61,"inDiffEditor",!1)),letterSpacing:je(new u(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Y=>u.clamp(Y,-5,20),{description:m.localize(273,null)})),lightbulb:je(new $e),lineDecorationsWidth:je(new V),lineHeight:je(new ie),lineNumbers:je(new ue),lineNumbersMinChars:je(new o(68,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new s(69,"linkedEditing",!1,{description:m.localize(274,null)})),links:je(new s(70,"links",!0,{description:m.localize(275,null)})),matchBrackets:je(new n(71,"matchBrackets","always",["always","near","never"],{description:m.localize(276,null)})),minimap:je(new Ce),mouseStyle:je(new n(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new u(74,"mouseWheelScrollSensitivity",1,Y=>Y===0?1:Y,{markdownDescription:m.localize(277,null)})),mouseWheelZoom:je(new s(75,"mouseWheelZoom",!1,{markdownDescription:I.$j?m.localize(278,null):m.localize(279,null)})),multiCursorMergeOverlapping:je(new s(76,"multiCursorMergeOverlapping",!0,{description:m.localize(280,null)})),multiCursorModifier:je(new w(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Te,{markdownEnumDescriptions:[m.localize(281,null),m.localize(282,null)],markdownDescription:m.localize(283,null)})),multiCursorPaste:je(new n(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[m.localize(284,null),m.localize(285,null)],markdownDescription:m.localize(286,null)})),multiCursorLimit:je(new o(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:m.localize(287,null)})),occurrencesHighlight:je(new n(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[m.localize(288,null),m.localize(289,null),m.localize(290,null)],markdownDescription:m.localize(291,null)})),overviewRulerBorder:je(new s(81,"overviewRulerBorder",!0,{description:m.localize(292,null)})),overviewRulerLanes:je(new o(82,"overviewRulerLanes",3,0,3)),padding:je(new Pe),pasteAs:je(new at),parameterHints:je(new be),peekWidgetDefaultFocus:je(new n(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[m.localize(293,null),m.localize(294,null)],description:m.localize(295,null)})),definitionLinkOpensInPeek:je(new s(87,"definitionLinkOpensInPeek",!1,{description:m.localize(296,null)})),quickSuggestions:je(new G),quickSuggestionsDelay:je(new o(89,"quickSuggestionsDelay",10,0,1073741824,{description:m.localize(297,null)})),readOnly:je(new s(90,"readOnly",!1)),readOnlyMessage:je(new fe),renameOnType:je(new s(92,"renameOnType",!1,{description:m.localize(298,null),markdownDeprecationMessage:m.localize(299,null)})),renderControlCharacters:je(new s(93,"renderControlCharacters",!0,{description:m.localize(300,null),restricted:!0})),renderFinalNewline:je(new n(94,"renderFinalNewline",I.$k?"dimmed":"on",["off","on","dimmed"],{description:m.localize(301,null)})),renderLineHighlight:je(new n(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",m.localize(302,null)],description:m.localize(303,null)})),renderLineHighlightOnlyWhenFocus:je(new s(96,"renderLineHighlightOnlyWhenFocus",!1,{description:m.localize(304,null)})),renderValidationDecorations:je(new n(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new n(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",m.localize(305,null),m.localize(306,null),m.localize(307,null),""],description:m.localize(308,null)})),revealHorizontalRightPadding:je(new o(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new s(100,"roundedSelection",!0,{description:m.localize(309,null)})),rulers:je(new Le),scrollbar:je(new Ie),scrollBeyondLastColumn:je(new o(103,"scrollBeyondLastColumn",4,0,1073741824,{description:m.localize(310,null)})),scrollBeyondLastLine:je(new s(104,"scrollBeyondLastLine",!0,{description:m.localize(311,null)})),scrollPredominantAxis:je(new s(105,"scrollPredominantAxis",!0,{description:m.localize(312,null)})),selectionClipboard:je(new s(106,"selectionClipboard",!0,{description:m.localize(313,null),included:I.$k})),selectionHighlight:je(new s(107,"selectionHighlight",!0,{description:m.localize(314,null)})),selectOnLineNumbers:je(new s(108,"selectOnLineNumbers",!0)),showFoldingControls:je(new n(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[m.localize(315,null),m.localize(316,null),m.localize(317,null)],description:m.localize(318,null)})),showUnused:je(new s(110,"showUnused",!0,{description:m.localize(319,null)})),showDeprecated:je(new s(138,"showDeprecated",!0,{description:m.localize(320,null)})),inlayHints:je(new X),snippetSuggestions:je(new n(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[m.localize(321,null),m.localize(322,null),m.localize(323,null),m.localize(324,null)],description:m.localize(325,null)})),smartSelect:je(new Ee),smoothScrolling:je(new s(113,"smoothScrolling",!1,{description:m.localize(326,null)})),stopRenderingLineAfter:je(new o(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new oe),inlineSuggest:je(new K),inlineCompletionsAccessibilityVerbose:je(new s(147,"inlineCompletionsAccessibilityVerbose",!1,{description:m.localize(327,null)})),suggestFontSize:je(new o(118,"suggestFontSize",0,0,1e3,{markdownDescription:m.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new o(119,"suggestLineHeight",0,0,1e3,{markdownDescription:m.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new s(120,"suggestOnTriggerCharacters",!0,{description:m.localize(330,null)})),suggestSelection:je(new n(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[m.localize(331,null),m.localize(332,null),m.localize(333,null)],description:m.localize(334,null)})),tabCompletion:je(new n(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[m.localize(335,null),m.localize(336,null),m.localize(337,null)],description:m.localize(338,null)})),tabIndex:je(new o(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new O),unusualLineTerminators:je(new n(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[m.localize(339,null),m.localize(340,null),m.localize(341,null)],description:m.localize(342,null)})),useShadowDOM:je(new s(126,"useShadowDOM",!0)),useTabStops:je(new s(127,"useTabStops",!0,{description:m.localize(343,null)})),wordBreak:je(new n(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[m.localize(344,null),m.localize(345,null)],description:m.localize(346,null)})),wordSeparators:je(new t(129,"wordSeparators",L.$vs,{description:m.localize(347,null)})),wordWrap:je(new n(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[m.localize(348,null),m.localize(349,null),m.localize(350,null),m.localize(351,null)],description:m.localize(352,null)})),wordWrapBreakAfterCharacters:je(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new o(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:m.localize(353,null)})),wordWrapOverride1:je(new n(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new n(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new N),defaultColorDecorators:je(new s(145,"defaultColorDecorators",!1,{markdownDescription:m.localize(354,null)})),pixelRatio:je(new ge),tabFocusMode:je(new s(142,"tabFocusMode",!1,{markdownDescription:m.localize(355,null)})),layoutInfo:je(new le),wrappingInfo:je(new Ze),wrappingIndent:je(new We),wrappingStrategy:je(new ve)}}),define(Re[148],Ae([9,10]),function(me,e){return me.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Re[149],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/contextkey",e)}),define(Re[150],Ae([9,10]),function(me,e){return me.create("vs/platform/contextkey/common/scanner",e)}),define(Re[151],Ae([9,10]),function(me,e){return me.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Re[152],Ae([9,10]),function(me,e){return me.create("vs/platform/extensions/common/extensionValidator",e)}),define(Re[153],Ae([9,10]),function(me,e){return me.create("vs/platform/files/common/files",e)}),define(Re[154],Ae([9,10]),function(me,e){return me.create("vs/platform/markers/common/markers",e)}),define(Re[155],Ae([9,10]),function(me,e){return me.create("vs/platform/theme/common/iconRegistry",e)}),define(Re[156],Ae([9,10]),function(me,e){return me.create("vs/platform/workspace/common/workspace",e)}),define(Re[157],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(Re[158],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Re[159],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Re[160],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Re[161],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostLogService",e)}),define(Re[162],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostNotebook",e)}),define(Re[163],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Re[164],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Re[165],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Re[166],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Re[167],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Re[168],Ae([9,10]),function(me,e){return me.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Re[169],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/configuration",e)}),define(Re[170],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/editor",e)}),define(Re[171],Ae([9,10]),function(me,e){return me.create("vs/workbench/common/views",e)}),define(Re[172],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Re[173],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/debug/common/debug",e)}),define(Re[174],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Re[175],Ae([9,10]),function(me,e){return me.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Re[176],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Re[177],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Re[178],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Re[179],Ae([9,10]),function(me,e){return me.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Re[180],Ae([1,0,15,150]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3i=e.TokenType=void 0;var I;(function(y){y[y.LParen=0]="LParen",y[y.RParen=1]="RParen",y[y.Neg=2]="Neg",y[y.Eq=3]="Eq",y[y.NotEq=4]="NotEq",y[y.Lt=5]="Lt",y[y.LtEq=6]="LtEq",y[y.Gt=7]="Gt",y[y.GtEq=8]="GtEq",y[y.RegexOp=9]="RegexOp",y[y.RegexStr=10]="RegexStr",y[y.True=11]="True",y[y.False=12]="False",y[y.In=13]="In",y[y.Not=14]="Not",y[y.And=15]="And",y[y.Or=16]="Or",y[y.Str=17]="Str",y[y.QuotedStr=18]="QuotedStr",y[y.Error=19]="Error",y[y.EOF=20]="EOF"})(I||(e.TokenType=I={}));function R(...y){switch(y.length){case 1:return(0,M.localize)(0,null,y[0]);case 2:return(0,M.localize)(1,null,y[0],y[1]);case 3:return(0,M.localize)(2,null,y[0],y[1],y[2]);default:return}}const L=(0,M.localize)(3,null),m=(0,M.localize)(4,null);class d{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const k=this.d,l=this.c.substring(this.d,this.e),$={type:19,offset:this.d,lexeme:l};this.g.push({offset:k,lexeme:l,additionalInfo:A}),this.f.push($)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const k=this.c.substring(this.d,this.e),l=d.b.get(k);l?this.k(l):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(L);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,k=!1,l=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(m);return}const p=this.c.charCodeAt(A);if(k)k=!1;else if(p===47&&!l){A++;break}else p===91?l=!0:p===92?k=!0:p===93&&(l=!1);A++}for(;A<this.c.length&&d.a.has(this.c.charCodeAt(A));)A++;this.e=A;const $=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:$,offset:this.d})}r(){return this.e>=this.c.length}}e.$3i=d}),define(Re[181],Ae([1,0,24,32,152,295]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,m=/^-(\d{4})(\d{2})(\d{2})$/;function d(s){return s=s.trim(),s==="*"||L.test(s)}e.$cp=d;function y(s){if(!d(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=s.match(L);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$dp=y;function A(s){if(!s)return null;const i=s.majorBase,o=s.majorMustEqual,a=s.minorBase;let u=s.minorMustEqual;const t=s.patchBase;let f=s.patchMustEqual;s.hasCaret&&(i===0||(u=!1),f=!1);let n=0;if(s.preRelease){const w=m.exec(s.preRelease);if(w){const[,D,h,b]=w;n=Date.UTC(Number(D),Number(h)-1,Number(b))}}return{majorBase:i,majorMustEqual:o,minorBase:a,minorMustEqual:u,patchBase:t,patchMustEqual:f,isMinimum:s.hasGreaterEquals,notBefore:n}}e.$ep=A;function k(s,i,o){let a;typeof s=="string"?a=A(y(s)):a=s;let u;i instanceof Date?u=i.getTime():typeof i=="string"&&(u=new Date(i).getTime());let t;if(typeof o=="string"?t=A(y(o)):t=o,!a||!t)return!1;const f=a.majorBase,n=a.minorBase,w=a.patchBase;let D=t.majorBase,h=t.minorBase,b=t.patchBase;const P=t.notBefore;let g=t.majorMustEqual,v=t.minorMustEqual,E=t.patchMustEqual;return t.isMinimum?f>D?!0:f<D?!1:n>h?!0:n<h||u&&u<P?!1:w>=b:(f===1&&D===0&&(!g||!v||!E)&&(D=1,h=0,b=0,g=!0,v=!1,E=!1),f<D?!1:f>D?!g:n<h?!1:n>h?!v:w<b?!1:w>b?!E:!(u&&u<P))}e.$fp=k;function l(s,i,o,a,u){const t=[];if(typeof a.publisher<"u"&&typeof a.publisher!="string")return t.push([M.default.Error,I.localize(0,null)]),t;if(typeof a.name!="string")return t.push([M.default.Error,I.localize(1,null,"name")]),t;if(typeof a.version!="string")return t.push([M.default.Error,I.localize(2,null,"version")]),t;if(!a.engines)return t.push([M.default.Error,I.localize(3,null,"engines")]),t;if(typeof a.engines.vscode!="string")return t.push([M.default.Error,I.localize(4,null,"engines.vscode")]),t;if(typeof a.extensionDependencies<"u"&&!c(a.extensionDependencies))return t.push([M.default.Error,I.localize(5,null,"extensionDependencies")]),t;if(typeof a.activationEvents<"u"){if(!c(a.activationEvents))return t.push([M.default.Error,I.localize(6,null,"activationEvents")]),t;if(typeof a.main>"u"&&typeof a.browser>"u")return t.push([M.default.Error,I.localize(7,null,"activationEvents","main","browser")]),t}if(typeof a.extensionKind<"u"&&typeof a.main>"u"&&t.push([M.default.Warning,I.localize(8,null,"extensionKind")]),typeof a.main<"u"){if(typeof a.main!="string")return t.push([M.default.Error,I.localize(9,null,"main")]),t;{const w=(0,S.$Ig)(o,a.main);(0,S.$Cg)(w,o)||t.push([M.default.Warning,I.localize(10,null,w.path,o.path)])}}if(typeof a.browser<"u"){if(typeof a.browser!="string")return t.push([M.default.Error,I.localize(11,null,"browser")]),t;{const w=(0,S.$Ig)(o,a.browser);(0,S.$Cg)(w,o)||t.push([M.default.Warning,I.localize(12,null,w.path,o.path)])}}if(!R.valid(a.version))return t.push([M.default.Error,I.localize(13,null)]),t;const f=[];if(!$(s,i,a,u,f))for(const w of f)t.push([M.default.Error,w]);return t}e.$gp=l;function $(s,i,o,a,u){return a||typeof o.main>"u"&&typeof o.browser>"u"?!0:r(s,i,o.engines.vscode,u)}e.$hp=$;function p(s,i,o){return s==="*"||r(i,o,s)}e.$ip=p;function r(s,i,o,a=[]){const u=A(y(o));if(!u)return a.push(I.localize(14,null,o)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return a.push(I.localize(15,null,o)),!1}else if(!u.majorMustEqual)return a.push(I.localize(16,null,o)),!1;return k(s,i,u)?!0:(a.push(I.localize(17,null,s,o)),!1)}function c(s){if(!Array.isArray(s))return!1;for(let i=0,o=s.length;i<o;i++)if(typeof s[i]!="string")return!1;return!0}}),define(Re[70],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5h=void 0;class S{constructor(I,R=[],L=!1){this.ctor=I,this.staticArguments=R,this.supportsDelayedInstantiation=L}}e.$5h=S}),define(Re[53],Ae([1,0,70]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=e.$1r=e.InstantiationType=void 0;const M=[];var I;(function(m){m[m.Eager=0]="Eager",m[m.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function R(m,d,y){d instanceof S.$5h||(d=new S.$5h(d,[],!!y)),M.push([m,d])}e.$1r=R;function L(){return M}e.$2r=L}),define(Re[182],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;class S{constructor(R,L){this.key=R,this.data=L,this.incoming=new Map,this.outgoing=new Map}}e.$Eq=S;class M{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const L of this.a.values())L.outgoing.size===0&&R.push(L);return R}insertEdge(R,L){const m=this.lookupOrInsertNode(R),d=this.lookupOrInsertNode(L);m.outgoing.set(d.key,d),d.incoming.set(m.key,m)}removeNode(R){const L=this.b(R);this.a.delete(L);for(const m of this.a.values())m.outgoing.delete(L),m.incoming.delete(L)}lookupOrInsertNode(R){const L=this.b(R);let m=this.a.get(L);return m||(m=new S(L,R),this.a.set(L,m)),m}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[L,m]of this.a)R.push(`${L}
	(-> incoming)[${[...m.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...m.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,L]of this.a){const m=new Set([R]),d=this.c(L,m);if(d)return d}}c(R,L){for(const[m,d]of R.outgoing){if(L.has(m))return[...L,m].join(" -> ");L.add(m);const y=this.c(d,L);if(y)return y;L.delete(m)}}}e.$Fq=M}),define(Re[4],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9h=e.$8h=e.$7h=e._util=void 0;var S;(function(L){L.serviceIds=new Map,L.DI_TARGET="$di$target",L.DI_DEPENDENCIES="$di$dependencies";function m(d){return d[L.DI_DEPENDENCIES]||[]}L.getServiceDependencies=m})(S||(e._util=S={})),e.$7h=I("instantiationService");function M(L,m,d){m[S.DI_TARGET]===m?m[S.DI_DEPENDENCIES].push({id:L,index:d}):(m[S.DI_DEPENDENCIES]=[{id:L,index:d}],m[S.DI_TARGET]=m)}function I(L){if(S.serviceIds.has(L))return S.serviceIds.get(L);const m=function(d,y,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(m,d,A)};return m.toString=()=>L,S.serviceIds.set(L,m),m}e.$8h=I;function R(L){return L}e.$9h=R}),define(Re[47],Ae([1,0,16,2,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Li=e.$Ki=e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.ConfigurationTarget=e.$Di=e.$Ci=e.$Bi=void 0,e.$Bi=(0,I.$8h)("configurationService");function R(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof M.URI)}e.$Ci=R;function L(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof M.URI)}e.$Di=L;var m;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(m||(e.ConfigurationTarget=m={}));function d(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ei=d;function y(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}e.$Fi=y;function A(s,i){const o=Object.create(null);for(const a in s)k(o,a,s[a],i);return o}e.$Gi=A;function k(s,i,o,a){const u=i.split("."),t=u.pop();let f=s;for(let n=0;n<u.length;n++){const w=u[n];let D=f[w];switch(typeof D){case"undefined":D=f[w]=Object.create(null);break;case"object":break;default:a(`Ignoring ${i} as ${u.slice(0,n+1).join(".")} is ${JSON.stringify(D)}`);return}f=D}if(typeof f=="object"&&f!==null)try{f[t]=o}catch{a(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}else a(`Ignoring ${i} as ${u.join(".")} is ${JSON.stringify(f)}`)}e.$Hi=k;function l(s,i){const o=i.split(".");$(s,o)}e.$Ii=l;function $(s,i){const o=i.shift();if(i.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const a=s[o];typeof a=="object"&&!Array.isArray(a)&&($(a,i),Object.keys(a).length===0&&delete s[o])}}function p(s,i,o){function a(f,n){let w=f;for(const D of n){if(typeof w!="object"||w===null)return;w=w[D]}return w}const u=i.split("."),t=a(s,u);return typeof t>"u"?o:t}e.$Ji=p;function r(s,i,o){Object.keys(i).forEach(a=>{a!=="__proto__"&&(a in s?S.$Lf(s[a])&&S.$Lf(i[a])?r(s[a],i[a],o):o&&(s[a]=i[a]):s[a]=i[a])})}e.$Ki=r;function c(s){return s.replace(/[\[\]]/g,"")}e.$Li=c}),define(Re[35],Ae([1,0,20,14,180,4,149,15]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oj=e.$nj=e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.ContextKeyExprType=e.$4i=void 0;const d=new Map;d.set("false",!1),d.set("true",!0),d.set("isMac",S.$j),d.set("isLinux",S.$k),d.set("isWindows",S.$i),d.set("isWeb",S.$o),d.set("isMacNative",S.$j&&!S.$o),d.set("isEdge",S.$H),d.set("isFirefox",S.$F),d.set("isChrome",S.$E),d.set("isSafari",S.$G);function y(X,V){if(d.get(X)!==void 0)throw(0,m.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");d.set(X,V)}e.$4i=y;const A=Object.prototype.hasOwnProperty;var k;(function(X){X[X.False=0]="False",X[X.True=1]="True",X[X.Defined=2]="Defined",X[X.Not=3]="Not",X[X.Equals=4]="Equals",X[X.NotEquals=5]="NotEquals",X[X.And=6]="And",X[X.Regex=7]="Regex",X[X.NotRegex=8]="NotRegex",X[X.Or=9]="Or",X[X.In=10]="In",X[X.NotIn=11]="NotIn",X[X.Greater=12]="Greater",X[X.GreaterEquals=13]="GreaterEquals",X[X.Smaller=14]="Smaller",X[X.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const l={regexParsingWithErrorRecovery:!0},$=(0,L.localize)(0,null),p=(0,L.localize)(1,null),r=(0,L.localize)(2,null),c=(0,L.localize)(3,null),s=(0,L.localize)(4,null),i=(0,L.localize)(5,null),o=(0,L.localize)(6,null),a=(0,L.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=l){this.k=V,this.d=new I.$3i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:$,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const Ce=this.D(),Te=Ce.type===17?i:void 0;throw this.h.push({message:s,offset:Ce.offset,lexeme:I.$3i.getLexeme(Ce),additionalInfo:Te}),u.c}return ie}catch(ie){if(ie!==u.c)throw ie;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ie=this.o();V.push(ie)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ie=this.s();V.push(ie)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),D.INSTANCE;case 12:return this.z(),h.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,c),ie?.negate()}case 17:return this.z(),T.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,c),ie}case 17:{const ie=V.lexeme;if(this.z(),this.y(9)){const Te=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Te.type!==10)throw this.B("REGEX",Te);const Pe=Te.lexeme,be=Pe.lastIndexOf("/"),ge=be===Pe.length-1?void 0:this.w(Pe.substring(be+1));let G;try{G=new RegExp(Pe.substring(1,be),ge)}catch{throw this.B("REGEX",Te)}return F.create(ie,G)}switch(Te.type){case 10:case 19:{const Pe=[Te.lexeme];this.z();let be=this.D(),ge=0;for(let Le=0;Le<Te.lexeme.length;Le++)Te.lexeme.charCodeAt(Le)===40?ge++:Te.lexeme.charCodeAt(Le)===41&&ge--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ge++;break;case 1:ge--;break;case 10:case 18:for(let Le=0;Le<be.lexeme.length;Le++)be.lexeme.charCodeAt(Le)===40?ge++:Te.lexeme.charCodeAt(Le)===41&&ge--}if(ge<0)break;Pe.push(I.$3i.getLexeme(be)),this.z(),be=this.D()}const G=Pe.join(""),_=G.lastIndexOf("/"),ue=_===G.length-1?void 0:this.w(G.substring(_+1));let de;try{de=new RegExp(G.substring(1,_),ue)}catch{throw this.B("REGEX",Te)}return t.regex(ie,de)}case 18:{const Pe=Te.lexeme;this.z();let be=null;if(!(0,M.$Ke)(Pe)){const ge=Pe.indexOf("/"),G=Pe.lastIndexOf("/");if(ge!==G&&ge>=0){const _=Pe.slice(ge+1,G),ue=Pe[G+1]==="i"?"i":"";try{be=new RegExp(_,ue)}catch{throw this.B("REGEX",Te)}}}if(be===null)throw this.B("REGEX",Te);return F.create(ie,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,r);const Te=this.u();return t.notIn(ie,Te)}switch(this.D().type){case 3:{this.z();const Te=this.u();if(this.x().type===18)return t.equals(ie,Te);switch(Te){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,Te)}}case 4:{this.z();const Te=this.u();if(this.x().type===18)return t.notEquals(ie,Te);switch(Te){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,Te)}}case 5:return this.z(),U.create(ie,this.u());case 6:return this.z(),C.create(ie,this.u());case 7:return this.z(),J.create(ie,this.u());case 8:return this.z(),q.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:o,offset:V.offset,lexeme:"",additionalInfo:a}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ie){if(this.C(V))return this.z();throw this.B(ie,this.D())}B(V,ie,Ce){const Te=(0,L.localize)(8,null,V,I.$3i.getLexeme(ie)),Pe=ie.offset,be=I.$3i.getLexeme(ie);return this.h.push({message:Te,offset:Pe,lexeme:be,additionalInfo:Ce}),u.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$5i=u;class t{static false(){return D.INSTANCE}static true(){return h.INSTANCE}static has(V){return b.create(V)}static equals(V,ie){return P.create(V,ie)}static notEquals(V,ie){return E.create(V,ie)}static regex(V,ie){return F.create(V,ie)}static in(V,ie){return g.create(V,ie)}static notIn(V,ie){return v.create(V,ie)}static not(V){return T.create(V)}static and(...V){return ce.create(V,null,!0)}static or(...V){return we.create(V,null,!0)}static greater(V,ie){return J.create(V,ie)}static greaterEquals(V,ie){return q.create(V,ie)}static smaller(V,ie){return U.create(V,ie)}static smallerEquals(V,ie){return C.create(V,ie)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$6i=t;function f(X){const V=new u({regexParsingWithErrorRecovery:!1});return X.map(ie=>(V.parse(ie),V.lexingErrors.length>0?V.lexingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?(0,L.localize)(9,null,Ce.additionalInfo):(0,L.localize)(10,null),offset:Ce.offset,length:Ce.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(Ce=>({errorMessage:Ce.additionalInfo?`${Ce.message}. ${Ce.additionalInfo}`:Ce.message,offset:Ce.offset,length:Ce.lexeme.length})):[]))}e.$7i=f;function n(X,V){const ie=X?X.substituteConstants():void 0,Ce=V?V.substituteConstants():void 0;return!ie&&!Ce?!0:!ie||!Ce?!1:ie.equals(Ce)}e.$8i=n;function w(X,V){return X.cmp(V)}class D{static{this.INSTANCE=new D}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return h.INSTANCE}}e.$9i=D;class h{static{this.INSTANCE=new h}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return D.INSTANCE}}e.$0i=h;class b{static create(V,ie=null){const Ce=d.get(V);return typeof Ce=="boolean"?Ce?h.INSTANCE:D.INSTANCE:new b(V,ie)}constructor(V,ie){this.key=V,this.c=ie,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:le(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=d.get(this.key);return typeof V=="boolean"?V?h.INSTANCE:D.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=T.create(this.key,this)),this.c}}e.$$i=b;class P{static create(V,ie,Ce=null){if(typeof ie=="boolean")return ie?b.create(V,Ce):T.create(V,Ce);const Te=d.get(V);return typeof Te=="boolean"?ie===(Te?"true":"false")?h.INSTANCE:D.INSTANCE:new P(V,ie,Ce)}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=d.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?h.INSTANCE:D.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$_i=P;class g{static create(V,ie){return new g(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.f),Ce=V.getValue(this.d);return Array.isArray(ie)?ie.includes(Ce):typeof Ce=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,Ce):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=v.create(this.d,this.f)),this.c}}e.$aj=g;class v{static create(V,ie){return new v(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=11,this.c=g.create(V,ie)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$bj=v;class E{static create(V,ie,Ce=null){if(typeof ie=="boolean")return ie?T.create(V,Ce):b.create(V,Ce);const Te=d.get(V);return typeof Te=="boolean"?ie===(Te?"true":"false")?D.INSTANCE:h.INSTANCE:new E(V,ie,Ce)}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=d.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?D.INSTANCE:h.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.$cj=E;class T{static create(V,ie=null){const Ce=d.get(V);return typeof Ce=="boolean"?Ce?D.INSTANCE:h.INSTANCE:new T(V,ie)}constructor(V,ie){this.c=V,this.d=ie,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=d.get(this.c);return typeof V=="boolean"?V?D.INSTANCE:h.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$dj=T;function N(X,V){if(typeof X=="string"){const ie=parseFloat(X);isNaN(ie)||(X=ie)}return typeof X=="string"||typeof X=="number"?V(X):D.INSTANCE}class J{static create(V,ie,Ce=null){return N(ie,Te=>new J(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$ej=J;class q{static create(V,ie,Ce=null){return N(ie,Te=>new q(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$fj=q;class U{static create(V,ie,Ce=null){return N(ie,Te=>new U(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$gj=U;class C{static create(V,ie,Ce=null){return N(ie,Te=>new C(V,Te,Ce))}constructor(V,ie,Ce){this.c=V,this.d=ie,this.f=Ce,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:ve(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$hj=C;class F{static create(V,ie){return new F(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ie=this.f?this.f.source:"",Ce=V.f?V.f.source:"";return ie<Ce?-1:ie>Ce?1:0}equals(V){if(V.type===this.type){const ie=this.f?this.f.source:"",Ce=V.f?V.f.source:"";return this.d===V.d&&ie===Ce}return!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=W.create(this)),this.c}}e.$ij=F;class W{static create(V){return new W(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new W(this.c.map(V))}negate(){return this.c}}e.$jj=W;function re(X){let V=null;for(let ie=0,Ce=X.length;ie<Ce;ie++){const Te=X[ie].substituteConstants();if(X[ie]!==Te&&V===null){V=[];for(let Pe=0;Pe<ie;Pe++)V[Pe]=X[Pe]}V!==null&&(V[ie]=Te)}return V===null?X:V}class ce{static create(V,ie,Ce){return ce.d(V,ie,Ce)}constructor(V,ie){this.expr=V,this.c=ie,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++){const Te=w(this.expr[ie],V.expr[ie]);if(Te!==0)return Te}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:ce.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(!this.expr[ie].evaluate(V))return!1;return!0}static d(V,ie,Ce){const Te=[];let Pe=!1;for(const be of V)if(be){if(be.type===1){Pe=!0;continue}if(be.type===0)return D.INSTANCE;if(be.type===6){Te.push(...be.expr);continue}Te.push(be)}if(Te.length===0&&Pe)return h.INSTANCE;if(Te.length!==0){if(Te.length===1)return Te[0];Te.sort(w);for(let be=1;be<Te.length;be++)Te[be-1].equals(Te[be])&&(Te.splice(be,1),be--);if(Te.length===1)return Te[0];for(;Te.length>1;){const be=Te[Te.length-1];if(be.type!==9)break;Te.pop();const ge=Te.pop(),G=Te.length===0,_=we.create(be.expr.map(ue=>ce.create([ue,ge],null,Ce)),null,G);_&&(Te.push(_),Te.sort(w))}if(Te.length===1)return Te[0];if(Ce){for(let be=0;be<Te.length;be++)for(let ge=be+1;ge<Te.length;ge++)if(Te[be].negate().equals(Te[ge]))return D.INSTANCE;if(Te.length===1)return Te[0]}return new ce(Te,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new ce(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());this.c=we.create(V,this,!0)}return this.c}}e.$kj=ce;class we{static create(V,ie,Ce){return we.d(V,ie,Ce)}constructor(V,ie){this.expr=V,this.c=ie,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++){const Te=w(this.expr[ie],V.expr[ie]);if(Te!==0)return Te}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=re(this.expr);return V===this.expr?this:we.create(V,this.c,!1)}evaluate(V){for(let ie=0,Ce=this.expr.length;ie<Ce;ie++)if(this.expr[ie].evaluate(V))return!0;return!1}static d(V,ie,Ce){let Te=[],Pe=!1;if(V){for(let be=0,ge=V.length;be<ge;be++){const G=V[be];if(G){if(G.type===0){Pe=!0;continue}if(G.type===1)return h.INSTANCE;if(G.type===9){Te=Te.concat(G.expr);continue}Te.push(G)}}if(Te.length===0&&Pe)return D.INSTANCE;Te.sort(w)}if(Te.length!==0){if(Te.length===1)return Te[0];for(let be=1;be<Te.length;be++)Te[be-1].equals(Te[be])&&(Te.splice(be,1),be--);if(Te.length===1)return Te[0];if(Ce){for(let be=0;be<Te.length;be++)for(let ge=be+1;ge<Te.length;ge++)if(Te[be].negate().equals(Te[ge]))return h.INSTANCE;if(Te.length===1)return Te[0]}return new we(Te,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new we(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());for(;V.length>1;){const ie=V.shift(),Ce=V.shift(),Te=[];for(const Pe of te(ie))for(const be of te(Ce))Te.push(ce.create([Pe,be],null,!1));V.unshift(we.create(Te,null,!1))}this.c=we.create(V,this,!0)}return this.c}}e.$lj=we;class De extends b{static{this.d=[]}static all(){return De.d.values()}constructor(V,ie,Ce){super(V,null),this.f=ie,typeof Ce=="object"?De.d.push({...Ce,key:V}):Ce!==!0&&De.d.push({key:V,description:Ce,type:ie!=null?typeof ie:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return P.create(this.key,V)}notEqualsTo(V){return E.create(this.key,V)}}e.$mj=De,e.$nj=(0,R.$8h)("contextKeyService");function le(X,V){return X<V?-1:X>V?1:0}function ve(X,V,ie,Ce){return X<ie?-1:X>ie?1:V<Ce?-1:V>Ce?1:0}function se(X,V){if(X.type===0||V.type===1)return!0;if(X.type===9)return V.type===9?$e(X.expr,V.expr):!1;if(V.type===9){for(const ie of V.expr)if(se(X,ie))return!0;return!1}if(X.type===6){if(V.type===6)return $e(V.expr,X.expr);for(const ie of X.expr)if(se(ie,V))return!0;return!1}return X.equals(V)}e.$oj=se;function $e(X,V){let ie=0,Ce=0;for(;ie<X.length&&Ce<V.length;){const Te=X[ie].cmp(V[Ce]);if(Te<0)return!1;Te===0&&ie++,Ce++}return ie===X.length}function te(X){return X.type===9?X.expr:[X]}}),define(Re[183],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$di=e.$ci=void 0,e.$ci=(0,S.$8h)("environmentService"),e.$di=(0,S.$9h)(e.$ci)}),define(Re[96],Ae([1,0,151,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.ExtensionGalleryErrorCode=e.$Co=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$Bo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Ao=e.$zo=e.$yo=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=void 0,e.$po="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$qo=new RegExp(e.$po),e.$ro="__web_extension",e.$so="skipWalkthrough",e.$to="extensionsSync",e.$uo="dependecyOrPackExtensionInstall";function I(o){switch(o){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$vo=I;function R(o){switch(o){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$wo=R;function L(o,a){switch(o){case 3:return a==="x64"?"win32-x64":a==="arm64"?"win32-arm64":"unknown";case 2:return a==="x64"?"linux-x64":a==="arm64"?"linux-arm64":a==="arm"?"linux-armhf":"unknown";case"alpine":return a==="x64"?"alpine-x64":a==="arm64"?"alpine-arm64":"unknown";case 1:return a==="x64"?"darwin-x64":a==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$xo=L;function m(o,a){return a==="web"&&!o.includes("web")}e.$yo=m;function d(o,a,u){return m(a,u)?!1:o==="undefined"||o==="universal"?!0:o==="unknown"?!1:o===u}e.$zo=d;function y(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(!o.uuid||typeof o.uuid=="string")}e.$Ao=y;var A;(function(o){o[o.NoneOrRelevance=0]="NoneOrRelevance",o[o.LastUpdatedDate=1]="LastUpdatedDate",o[o.Title=2]="Title",o[o.PublisherName=3]="PublisherName",o[o.InstallCount=4]="InstallCount",o[o.PublishedDate=10]="PublishedDate",o[o.AverageRating=6]="AverageRating",o[o.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var k;(function(o){o[o.Default=0]="Default",o[o.Ascending=1]="Ascending",o[o.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var l;(function(o){o.Install="install",o.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var $;(function(o){o[o.None=1]="None",o[o.Install=2]="Install",o[o.Update=3]="Update",o[o.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$Bo=(0,M.$8h)("extensionGalleryService");var p;(function(o){o.Unsupported="Unsupported",o.Deprecated="Deprecated",o.Malicious="Malicious",o.Incompatible="Incompatible",o.IncompatibleTargetPlatform="IncompatibleTargetPlatform",o.ReleaseVersionNotFound="ReleaseVersionNotFound",o.Invalid="Invalid",o.Download="Download",o.DownloadSignature="DownloadSignature",o.UpdateMetadata="UpdateMetadata",o.Extract="Extract",o.Scanning="Scanning",o.Delete="Delete",o.Rename="Rename",o.CorruptZip="CorruptZip",o.IncompleteZip="IncompleteZip",o.Signature="Signature",o.NotAllowed="NotAllowed",o.Gallery="Gallery",o.Unknown="Unknown",o.Internal="Internal"})(p||(e.ExtensionManagementErrorCode=p={}));var r;(function(o){o.UnknownError="UnknownError",o.PackageIsInvalidZip="PackageIsInvalidZip",o.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class c extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Co=c;var s;(function(o){o.Timeout="Timeout",o.Cancelled="Cancelled",o.Failed="Failed"})(s||(e.ExtensionGalleryErrorCode=s={}));class i extends Error{constructor(a,u){super(a),this.code=u,this.name=u}}e.$Do=i,e.$Eo=(0,M.$8h)("extensionManagementService"),e.$Fo="extensionsIdentifiers/disabled",e.$Go="extensionsIdentifiers/enabled",e.$Ho=(0,M.$8h)("IGlobalExtensionEnablementService"),e.$Io=(0,M.$8h)("IExtensionTipsService"),e.$Jo=(0,S.localize2)(0,"Extensions"),e.$Ko=(0,S.localize2)(1,"Preferences")}),define(Re[42],Ae([1,0,51,19,14,16,2,153,4,20,12,39]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2k=e.$1k=e.$Zk=e.$Yk=e.$Xk=e.FileKind=e.$Wk=e.$Vk=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.FileOperationResult=e.$Pk=e.$Ok=e.$Nk=e.$Mk=e.$Lk=e.FileChangeType=e.$Kk=e.FileOperation=e.$Jk=e.$Ik=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.FileSystemProviderErrorCode=e.$Dk=e.$Ck=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.FileSystemProviderCapabilities=e.$uk=e.FilePermission=e.FileType=e.$tk=e.$sk=void 0,e.$sk=(0,d.$8h)("fileService");function l(se){return se.create===!0}e.$tk=l;var $;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})($||(e.FileType=$={}));var p;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(p||(e.FilePermission=p={}));function r(se){const $e=se;return!!$e&&typeof $e.onDidChange=="function"}e.$uk=r;var c;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(c||(e.FileSystemProviderCapabilities=c={}));function s(se){return!!(se.capabilities&2)}e.$vk=s;function i(se){return!!(se.capabilities&8)}e.$wk=i;function o(se){return!!(se.capabilities&131072)}e.$xk=o;function a(se){return!!(se.capabilities&4)}e.$yk=a;function u(se){return!!(se.capabilities&16)}e.$zk=u;function t(se){return s(se)?!!(se.capabilities&16384):!1}e.$Ak=t;function f(se){return s(se)?!!(se.capabilities&32768):!1}e.$Bk=f;function n(se){return!!(se.capabilities&65536)}e.$Ck=n;function w(se){return!!(se.capabilities&2048)}e.$Dk=w;var D;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class h extends Error{static create($e,te){const X=new h($e.toString(),te);return g(X,te),X}constructor($e,te){super($e),this.code=te}}e.$Ek=h;function b(se,$e){return h.create(se,$e)}e.$Fk=b;function P(se){return se||b((0,m.localize)(0,null),D.Unknown)}e.$Gk=P;function g(se,$e){return se.name=$e?`${$e} (FileSystemError)`:"FileSystemError",se}e.$Hk=g;function v(se){if(!se)return D.Unknown;if(se instanceof h)return se.code;const $e=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!$e)return D.Unknown;switch($e[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.$Ik=v;function E(se){if(se instanceof C)return se.fileOperationResult;switch(v(se)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 9;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileTooLarge:return 7;default:return 10}}e.$Jk=E;var T;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(T||(e.FileOperation=T={}));class N{constructor($e,te,X){this.resource=$e,this.operation=te,this.target=X}isOperation($e){return this.operation===$e}}e.$Kk=N;var J;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(J||(e.FileChangeType=J={}));class q{static{this.a=null}constructor($e,te){this.c=te,this.b=void 0,this.d=new k.$V(()=>{const X=S.$bi.forUris(()=>this.c);return X.fill(this.rawAdded.map(V=>[V,!0])),X}),this.f=new k.$V(()=>{const X=S.$bi.forUris(()=>this.c);return X.fill(this.rawUpdated.map(V=>[V,!0])),X}),this.g=new k.$V(()=>{const X=S.$bi.forUris(()=>this.c);return X.fill(this.rawDeleted.map(V=>[V,!0])),X}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const X of $e){switch(X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}this.b!==q.a&&(typeof X.cId=="number"?this.b===void 0?this.b=X.cId:this.b!==X.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains($e,...te){return this.h($e,{includeChildren:!1},...te)}affects($e,...te){return this.h($e,{includeChildren:!0},...te)}h($e,te,...X){if(!$e)return!1;const V=X.length>0;return!!((!V||X.includes(1))&&(this.d.value.get($e)||te.includeChildren&&this.d.value.findSuperstr($e))||(!V||X.includes(0))&&(this.f.value.get($e)||te.includeChildren&&this.f.value.findSuperstr($e))||(!V||X.includes(2))&&(this.g.value.findSubstr($e)||te.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Lk=q;function U(se,$e,te){return!se||!$e||se===$e||$e.length>se.length?!1:($e.charAt($e.length-1)!==M.sep&&($e+=M.sep),te?(0,I.$bf)(se,$e):se.indexOf($e)===0)}e.$Mk=U;class C extends Error{constructor($e,te,X){super($e),this.fileOperationResult=te,this.options=X}}e.$Nk=C;class F extends C{constructor($e,te,X,V){super($e,te,V),this.fileOperationResult=te,this.size=X}}e.$Ok=F;class W extends C{constructor($e,te,X){super($e,2,X),this.stat=te}}e.$Pk=W;var re;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(re||(e.FileOperationResult=re={})),e.$Qk={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Rk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Sk="files.associations",e.$Tk="files.exclude",e.$Uk="files.readonlyInclude",e.$Vk="files.readonlyExclude",e.$Wk="files.readonlyFromPermissions";var ce;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce||(e.FileKind=ce={})),e.$Xk="";function we(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}e.$Yk=we;async function De(se,$e){if(!$e.hasProvider(L.URI.from({scheme:se.scheme})))return new Promise(te=>{const X=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===se.scheme&&V.added&&(X.dispose(),te())})})}e.$Zk=De;class le{static{this.KB=1024}static{this.MB=le.KB*le.KB}static{this.GB=le.MB*le.KB}static{this.TB=le.GB*le.KB}static formatSize($e){return(0,R.$Nf)($e)||($e=0),$e<le.KB?(0,m.localize)(1,null,$e.toFixed(0)):$e<le.MB?(0,m.localize)(2,null,($e/le.KB).toFixed(2)):$e<le.GB?(0,m.localize)(3,null,($e/le.MB).toFixed(2)):$e<le.TB?(0,m.localize)(4,null,($e/le.GB).toFixed(2)):(0,m.localize)(5,null,($e/le.TB).toFixed(2))}}e.$1k=le;function ve(se){const $e=typeof se=="string"||se?.scheme===A.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===A.Schemas.file?1024*le.MB:$e?10*le.MB:y.$o?50*le.MB:1024*le.MB}e.$2k=ve}),define(Re[71],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=void 0;class S{constructor(...I){this.a=new Map;for(const[R,L]of I)this.set(R,L)}set(I,R){const L=this.a.get(I);return this.a.set(I,R),L}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$6h=S}),define(Re[184],Ae([1,0,11,15,6,70,182,4,71,185]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=e.$Gq=void 0;const A=!1;class k extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class l{constructor(c=new d.$6h,s=!1,i,o=A){this.f=c,this.g=s,this.h=i,this.i=o,this.o=new Set,this.f.set(m.$7h,this),this._globalGraph=o?i?._globalGraph??new L.$Fq(a=>a):void 0}createChild(c){return new l(c,this.g,this,this.i)}invokeFunction(c,...s){const i=p.traceInvocation(this.i,c);let o=!1;try{return c({get:u=>{if(o)throw(0,M.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(u,i);if(!t)throw new Error(`[invokeFunction] unknown service '${u}'`);return t}},...s)}finally{o=!0,i.stop()}}createInstance(c,...s){let i,o;return c instanceof R.$5h?(i=p.traceCreation(this.i,c.ctor),o=this.j(c.ctor,c.staticArguments.concat(s),i)):(i=p.traceCreation(this.i,c),o=this.j(c,s,i)),i.stop(),o}j(c,s=[],i){const o=m._util.getServiceDependencies(c).sort((t,f)=>t.index-f.index),a=[];for(const t of o){const f=this.m(t.id,i);f||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),a.push(f)}const u=o.length>0?o[0].index:s.length;if(s.length!==u){console.trace(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${s.length} static arguments`);const t=u-s.length;t>0?s=s.concat(new Array(t)):s=s.slice(0,u)}return Reflect.construct(c,s.concat(a))}k(c,s){if(this.f.get(c)instanceof R.$5h)this.f.set(c,s);else if(this.h)this.h.k(c,s);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const s=this.f.get(c);return!s&&this.h?this.h.l(c):s}m(c,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const i=this.l(c);return i instanceof R.$5h?this.q(c,i,s.branch(c,!0)):(s.branch(c,!1),i)}q(c,s,i){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,s,i)}finally{this.o.delete(c)}}r(c,s,i){const o=new L.$Fq(t=>t.id.toString());let a=0;const u=[{id:c,desc:s,_trace:i}];for(;u.length;){const t=u.pop();if(o.lookupOrInsertNode(t),a++>1e3)throw new k(o);for(const f of m._util.getServiceDependencies(t.desc.ctor)){const n=this.l(f.id);if(n||this.u(`[createInstance] ${c} depends on ${f.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(f.id)),n instanceof R.$5h){const w={id:f.id,desc:n,_trace:t._trace.branch(f.id,!0)};o.insertEdge(t,w),u.push(w)}}}for(;;){const t=o.roots();if(t.length===0){if(!o.isEmpty())throw new k(o);break}for(const{data:f}of t){if(this.l(f.id)instanceof R.$5h){const w=this.s(f.id,f.desc.ctor,f.desc.staticArguments,f.desc.supportsDelayedInstantiation,f._trace);this.k(f.id,w)}o.removeNode(f)}}return this.l(c)}s(c,s,i=[],o,a){if(this.f.get(c)instanceof R.$5h)return this.t(c,s,i,o,a);if(this.h)return this.h.s(c,s,i,o,a);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}t(c,s,i=[],o,a){if(o){const u=new l(void 0,this.g,this,this.i);u.c=String(c);const t=new Map,f=new S.$oh(()=>{const n=u.j(s,i,a);for(const[w,D]of t){const h=n[w];if(typeof h=="function")for(const b of D)b.disposable=h.apply(n,b.listener)}return t.clear(),n});return new Proxy(Object.create(null),{get(n,w){if(!f.isInitialized&&typeof w=="string"&&(w.startsWith("onDid")||w.startsWith("onWill"))){let b=t.get(w);return b||(b=new y.$4c,t.set(w,b)),(g,v,E)=>{if(f.isInitialized)return f.value[w](g,v,E);{const T={listener:[g,v,E],disposable:void 0},N=b.push(T);return(0,I.$Rc)(()=>{N(),T.disposable?.dispose()})}}}if(w in n)return n[w];const D=f.value;let h=D[w];return typeof h!="function"||(h=h.bind(D),n[w]=h),h},set(n,w,D){return f.value[w]=D,!0},getPrototypeOf(n){return s.prototype}})}else return this.j(s,i,a)}u(c,s){if(s&&console.warn(c),this.g)throw new Error(c)}}e.$Gq=l;var $;(function(r){r[r.None=0]="None",r[r.Creation=1]="Creation",r[r.Invocation=2]="Invocation",r[r.Branch=3]="Branch"})($||($={}));class p{static{this.all=new Set}static{this.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(c,s){return c?new p(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(c,s){return c?new p(1,s.name):p.c}static{this.f=0}constructor(c,s){this.type=c,this.name=s,this.g=Date.now(),this.h=[]}branch(c,s){const i=new p(3,c.toString());return this.h.push([c,s,i]),i}stop(){const c=Date.now()-this.g;p.f+=c;let s=!1;function i(a,u){const t=[],f=new Array(a+1).join("	");for(const[n,w,D]of u.h)if(w&&D){s=!0,t.push(`${f}CREATES -> ${n}`);const h=i(a+1,D);h&&t.push(h)}else t.push(`${f}uses -> ${n}`);return t.join(`
`)}const o=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(c>2||s)&&p.all.add(o.join(`
`))}}e.$Hq=p}),define(Re[13],Ae([1,0,41,5,97,6,28,20,24,16,2,35,4]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.log=e.$sj=e.LogLevel=e.$rj=e.$qj=e.$pj=void 0,e.$pj=(0,l.$8h)("logService"),e.$qj=(0,l.$8h)("loggerService");function $(){return new Date().toISOString()}function p(g){return(0,y.$Nf)(g)}e.$rj=p;var r;(function(g){g[g.Off=0]="Off",g[g.Trace=1]="Trace",g[g.Debug=2]="Debug",g[g.Info=3]="Info",g[g.Warning=4]="Warning",g[g.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$sj=r.Info;function c(g,v,E){switch(v){case r.Trace:g.trace(E);break;case r.Debug:g.debug(E);break;case r.Info:g.info(E);break;case r.Warning:g.warn(E);break;case r.Error:g.error(E);break;case r.Off:break;default:throw new Error(`Invalid log level ${v}`)}}e.log=c;function s(g,v=!1){let E="";for(let T=0;T<g.length;T++){let N=g[T];if(N instanceof Error&&(N=(0,S.$Si)(N,v)),typeof N=="object")try{N=JSON.stringify(N)}catch{}E+=(T>0?" ":"")+N}return E}class i extends R.$Tc{constructor(){super(...arguments),this.b=e.$sj,this.c=this.B(new M.$Wd),this.onDidChangeLogLevel=this.c.event}setLevel(v){this.b!==v&&(this.b=v,this.c.fire(this.b))}getLevel(){return this.b}f(v){return this.b!==r.Off&&this.b<=v}}e.$uj=i;class o extends i{constructor(v){super(),this.h=v}f(v){return this.h||super.f(v)}trace(v,...E){this.f(r.Trace)&&this.g(r.Trace,s([v,...E],!0))}debug(v,...E){this.f(r.Debug)&&this.g(r.Debug,s([v,...E]))}info(v,...E){this.f(r.Info)&&this.g(r.Info,s([v,...E]))}warn(v,...E){this.f(r.Warning)&&this.g(r.Warning,s([v,...E]))}error(v,...E){if(this.f(r.Error))if(v instanceof Error){const T=Array.prototype.slice.call(arguments);T[0]=v.stack,this.g(r.Error,s(T))}else this.g(r.Error,s([v,...E]))}flush(){}}e.$vj=o;class a extends i{constructor(v=e.$sj){super(),this.setLevel(v),this.g=!m.$i}trace(v,...E){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...E):console.log(`[main ${$()}]`,v,...E))}debug(v,...E){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...E):console.log(`[main ${$()}]`,v,...E))}info(v,...E){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,v,...E):console.log(`[main ${$()}]`,v,...E))}warn(v,...E){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,v,...E):console.warn(`[main ${$()}]`,v,...E))}error(v,...E){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,v,...E):console.error(`[main ${$()}]`,v,...E))}flush(){}}e.$wj=a;class u extends i{constructor(v=e.$sj,E=!0){super(),this.g=E,this.setLevel(v)}trace(v,...E){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",v,...E):console.log(v,...E))}debug(v,...E){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",v,...E):console.log(v,...E))}info(v,...E){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",v,...E):console.log(v,...E))}warn(v,...E){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",v,...E):console.log(v,...E))}error(v,...E){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",v,...E):console.error(v,...E))}flush(){}}e.$xj=u;class t extends i{constructor(v,E=e.$sj){super(),this.g=v,this.setLevel(E)}trace(v,...E){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(v),...E])}debug(v,...E){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(v),...E])}info(v,...E){this.f(r.Info)&&this.g.log(r.Info,[this.h(v),...E])}warn(v,...E){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(v),...E])}error(v,...E){this.f(r.Error)&&this.g.log(r.Error,[this.h(v),...E])}h(v){return typeof v=="string"?v:(0,S.$Si)(v,this.f(r.Trace))}flush(){}}e.$yj=t;class f extends i{constructor(v){super(),this.g=v,v.length&&this.setLevel(v[0].getLevel())}setLevel(v){for(const E of this.g)E.setLevel(v);super.setLevel(v)}trace(v,...E){for(const T of this.g)T.trace(v,...E)}debug(v,...E){for(const T of this.g)T.debug(v,...E)}info(v,...E){for(const T of this.g)T.info(v,...E)}warn(v,...E){for(const T of this.g)T.warn(v,...E)}error(v,...E){for(const T of this.g)T.error(v,...E)}flush(){for(const v of this.g)v.flush()}dispose(){for(const v of this.g)v.dispose();super.dispose()}}e.$zj=f;class n extends R.$Tc{constructor(v,E,T){if(super(),this.h=v,this.j=E,this.b=new L.$Ac,this.c=this.B(new M.$Wd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$Wd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$Wd),this.onDidChangeVisibility=this.g.event,T)for(const N of T)this.b.set(N.resource,{logger:void 0,info:N})}m(v){return(0,y.$Jf)(v)?[...this.b.values()].find(E=>E.info.id===v):this.b.get(v)}getLogger(v){return this.m(v)?.logger}createLogger(v,E){const T=this.n(v),N=(0,y.$Jf)(v)?v:E?.id??(0,I.$Vi)(T.toString()).toString(16);let J=this.b.get(T)?.logger;const q=E?.logLevel==="always"?r.Trace:E?.logLevel;J||(J=this.s(T,q??this.getLogLevel(T)??this.h,{...E,id:N}));const U={logger:J,info:{resource:T,id:N,logLevel:q,name:E?.name,hidden:E?.hidden,extensionId:E?.extensionId,when:E?.when}};return this.registerLogger(U.info),this.b.set(T,U),J}n(v){return(0,y.$Jf)(v)?(0,d.$Ig)(this.j,`${v}.log`):v}setLogLevel(v,E){if(A.URI.isUri(v)){const T=v,N=E,J=this.b.get(T);J&&N!==J.info.logLevel&&(J.info.logLevel=N===this.h?void 0:N,J.logger?.setLevel(N),this.b.set(J.info.resource,J),this.f.fire([T,N]))}else{this.h=v;for(const[T,N]of this.b.entries())this.b.get(T)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(v,E){const T=this.m(v);T&&E!==!T.info.hidden&&(T.info.hidden=!E,this.b.set(T.info.resource,T),this.g.fire([T.info.resource,E]))}getLogLevel(v){let E;return v&&(E=this.b.get(v)?.info.logLevel),E??this.h}registerLogger(v){const E=this.b.get(v.resource);E?E.info.hidden!==v.hidden&&this.setVisibility(v.resource,!v.hidden):(this.b.set(v.resource,{info:v,logger:void 0}),this.c.fire({added:[v],removed:[]}))}deregisterLogger(v){const E=this.b.get(v);E&&(E.logger&&E.logger.dispose(),this.b.delete(v),this.c.fire({added:[],removed:[E.info]}))}*getRegisteredLoggers(){for(const v of this.b.values())yield v.info}getRegisteredLogger(v){return this.b.get(v)?.info}dispose(){this.b.forEach(v=>v.logger?.dispose()),this.b.clear(),super.dispose()}}e.$Aj=n;class w{constructor(){this.onDidChangeLogLevel=new M.$Wd().event}setLevel(v){}getLevel(){return r.Info}trace(v,...E){}debug(v,...E){}info(v,...E){}warn(v,...E){}error(v,...E){}critical(v,...E){}dispose(){}flush(){}}e.$Bj=w;class D extends w{}e.$Cj=D;function h(g){if(g.verbose)return r.Trace;if(typeof g.logLevel=="string"){const v=P(g.logLevel.toLowerCase());if(v!==void 0)return v}return e.$sj}e.$Dj=h;function b(g){switch(g){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}e.$Ej=b;function P(g){switch(g){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$Fj=P,e.$Gj=new k.$mj("logLevel",b(r.Info))}),define(Re[186],Ae([1,0,6,13]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=void 0;class I extends S.$Tc{constructor(L,m=[]){super(),this.a=new M.$zj([L,...m]),this.B(L.onDidChangeLogLevel(d=>this.setLevel(d)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(L){this.a.setLevel(L)}getLevel(){return this.a.getLevel()}trace(L,...m){this.a.trace(L,...m)}debug(L,...m){this.a.debug(L,...m)}info(L,...m){this.a.info(L,...m)}warn(L,...m){this.a.warn(L,...m)}error(L,...m){this.a.error(L,...m)}flush(){this.a.flush()}}e.$TO=I}),define(Re[98],Ae([1,0,32,154,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ct=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(d){d[d.Unnecessary=1]="Unnecessary",d[d.Deprecated=2]="Deprecated"})(R||(e.MarkerTag=R={}));var L;(function(d){d[d.Hint=1]="Hint",d[d.Info=2]="Info",d[d.Warning=4]="Warning",d[d.Error=8]="Error"})(L||(e.MarkerSeverity=L={})),function(d){function y(p,r){return r-p}d.compare=y;const A=Object.create(null);A[d.Error]=(0,M.localize)(0,null),A[d.Warning]=(0,M.localize)(1,null),A[d.Info]=(0,M.localize)(2,null);function k(p){return A[p]||""}d.toString=k;function l(p){switch(p){case S.default.Error:return d.Error;case S.default.Warning:return d.Warning;case S.default.Info:return d.Info;case S.default.Ignore:return d.Hint}}d.fromSeverity=l;function $(p){switch(p){case d.Error:return S.default.Error;case d.Warning:return S.default.Warning;case d.Info:return S.default.Info;case d.Hint:return S.default.Ignore}}d.toSeverity=$}(L||(e.MarkerSeverity=L={}));var m;(function(d){const y="";function A(l){return k(l,!0)}d.makeKey=A;function k(l,$){const p=[y];return l.source?p.push(l.source.replace("\xA6","\\\xA6")):p.push(y),l.code?typeof l.code=="string"?p.push(l.code.replace("\xA6","\\\xA6")):p.push(l.code.value.replace("\xA6","\\\xA6")):p.push(y),l.severity!==void 0&&l.severity!==null?p.push(L.toString(l.severity)):p.push(y),l.message&&$?p.push(l.message.replace("\xA6","\\\xA6")):p.push(y),l.startLineNumber!==void 0&&l.startLineNumber!==null?p.push(l.startLineNumber.toString()):p.push(y),l.startColumn!==void 0&&l.startColumn!==null?p.push(l.startColumn.toString()):p.push(y),l.endLineNumber!==void 0&&l.endLineNumber!==null?p.push(l.endLineNumber.toString()):p.push(y),l.endColumn!==void 0&&l.endColumn!==null?p.push(l.endColumn.toString()):p.push(y),p.push(y),p.join("\xA6")}d.makeKeyOptionalMessage=k})(m||(e.IMarkerData=m={})),e.$Ct=(0,I.$8h)("markerService")}),define(Re[187],Ae([1,0,5,32,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uv=e.$tv=e.NotificationsFilter=e.$sv=e.NeverShowAgainScope=e.NotificationPriority=e.$rv=e.Severity=void 0,e.Severity=M.default,e.$rv=(0,I.$8h)("notificationService");var R;(function(k){k[k.DEFAULT=0]="DEFAULT",k[k.SILENT=1]="SILENT",k[k.URGENT=2]="URGENT"})(R||(e.NotificationPriority=R={}));var L;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.PROFILE=1]="PROFILE",k[k.APPLICATION=2]="APPLICATION"})(L||(e.NeverShowAgainScope=L={}));function m(k){if(k){const l=k;return typeof l.id=="string"&&typeof l.label=="string"}return!1}e.$sv=m;var d;(function(k){k[k.OFF=0]="OFF",k[k.ERROR=1]="ERROR"})(d||(e.NotificationsFilter=d={}));class y{constructor(){this.progress=new A,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$tv=y;class A{infinite(){}done(){}total(l){}worked(l){}}e.$uv=A}),define(Re[188],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ij=e.$Hj=void 0,e.$Hj=(0,S.$8h)("productService"),e.$Ij="vscode://schemas/vscode-product"});var Ge=this&&this.__decorate||function(me,e,S,M){var I=arguments.length,R=I<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,S):M,L;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(me,e,S,M);else for(var m=me.length-1;m>=0;m--)(L=me[m])&&(R=(I<3?L(R):I>3?L(e,S,R):L(e,S))||R);return I>3&&R&&Object.defineProperty(e,S,R),R},qe=this&&this.__param||function(me,e){return function(S,M){e(S,M,me)}};define(Re[99],Ae([1,0,11,21,6,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bv=e.$Av=e.$zv=e.$yv=e.$xv=e.$wv=e.ProgressLocation=e.$vv=void 0,e.$vv=(0,R.$8h)("progressService");var L;(function(k){k[k.Explorer=1]="Explorer",k[k.Scm=3]="Scm",k[k.Extensions=5]="Extensions",k[k.Window=10]="Window",k[k.Notification=15]="Notification",k[k.Dialog=20]="Dialog"})(L||(e.ProgressLocation=L={})),e.$wv=Object.freeze({total(){},worked(){},done(){}});class m{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$xv=m;class d{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const $=this.d;this.d=()=>{$?.(),l()}}):Promise.resolve()}}e.$yv=d;let y=class extends I.$Tc{constructor(l,$){super(),this.a=new S.$sh,$.withProgress(l,p=>(this.b=p,this.c&&p.report(this.c),this.a.p)),this.B((0,I.$Rc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$zv=y,e.$zv=y=Ge([qe(1,e.$vv)],y);class A extends I.$Tc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new I.$Sc)}start(l){this.stop();const $=++this.a,p=new M.$7d;return this.f=setTimeout(()=>{$===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,I.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,I.$Rc)(()=>p.cancel())),this.b.add((0,I.$Rc)(()=>this.c?this.c.done():void 0)),{id:$,token:p.token,stop:()=>this.h($),isCurrent:()=>this.a===$}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$Av=A,e.$Bv=(0,R.$8h)("editorProgressService")}),define(Re[30],Ae([1,0,54,16]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kn=void 0;class I{constructor(){this.a=new Map}add(L,m){S.ok(M.$Jf(L)),S.ok(M.$Lf(m)),S.ok(!this.a.has(L),"There is already an extension with this id"),this.a.set(L,m)}knows(L){return this.a.has(L)}as(L){return this.a.get(L)||null}}e.$Kn=new I}),define(Re[72],Ae([1,0,5,30]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=void 0,e.$Ln={JSONContribution:"base.contributions.json"};function I(m){return m.length>0&&m.charAt(m.length-1)==="#"?m.substring(0,m.length-1):m}class R{constructor(){this.b=new S.$Wd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,y){this.a[I(d)]=y,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const L=new R;M.$Kn.add(e.$Ln.JSONContribution,L)}),define(Re[55],Ae([1,0,18,5,16,148,47,72,30]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=e.$4n=e.$3n=e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.ConfigurationScope=e.$Pn=e.EditPresentationTypes=void 0;var y;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(y||(e.EditPresentationTypes=y={})),e.$Pn={Configuration:"base.contributions.configuration"};var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn={properties:{},patternProperties:{}},e.$Un={properties:{},patternProperties:{}},e.$Vn={properties:{},patternProperties:{}},e.$Wn="vscode://schemas/settings/resourceLanguage",e.$Xn="vscode://schemas/settings/configurationDefaults";const k=d.$Kn.as(m.$Ln.JSONContribution);class l{constructor(){this.h=new Set,this.i=new M.$Wd,this.onDidSchemaChange=this.i.event,this.j=new M.$Wd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Wn,this.g),this.v()}registerConfiguration(t,f=!0){this.registerConfigurations([t],f)}registerConfigurations(t,f=!0){const n=new Set;this.n(t,f,n),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(t){const f=new Set;this.o(t,f),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:f})}updateConfigurations({add:t,remove:f}){const n=new Set;this.o(f,n),this.n(t,!1,n),k.registerSchema(e.$Wn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(t){const f=new Set;this.k(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}k(t,f){const n=[];for(const{overrides:w,source:D}of t)for(const h in w)if(f.add(h),e.$Zn.test(h)){const b=this.a.get(h),P=b?.valuesSources??new Map;if(D)for(const T of Object.keys(w[h]))P.set(T,D);const g={...b?.value||{},...w[h]};this.a.set(h,{source:D,value:g,valuesSources:P});const v=(0,L.$Li)(h),E={type:"object",default:g,description:R.localize(1,null,v),$ref:e.$Wn,defaultDefaultValue:g,source:I.$Jf(D)?void 0:D,defaultValueSource:D};n.push(...r(h)),this.d[h]=E,this.b.properties[h]=E}else{this.a.set(h,{value:w[h],source:D});const b=this.d[h];b&&(this.w(h,b),this.r(h,b))}this.m(n)}deregisterDefaultConfigurations(t){const f=new Set;this.l(t,f),this.i.fire(),this.j.fire({properties:f,defaultsOverrides:!0})}l(t,f){for(const{overrides:n,source:w}of t)for(const D in n){const h=this.a.get(D),b=I.$Jf(w)?w:w?.id,P=I.$Jf(h?.source)?h?.source:h?.source?.id;if(b===P)if(f.add(D),this.a.delete(D),e.$Zn.test(D))delete this.d[D],delete this.b.properties[D];else{const g=this.d[D];g&&(this.w(D,g),this.r(D,g))}}this.u()}deltaConfiguration(t){let f=!1;const n=new Set;t.removedDefaults&&(this.l(t.removedDefaults,n),f=!0),t.addedDefaults&&(this.k(t.addedDefaults,n),f=!0),t.removedConfigurations&&this.o(t.removedConfigurations,n),t.addedConfigurations&&this.n(t.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:f})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const f of t)this.h.add(f);this.u()}n(t,f,n){t.forEach(w=>{this.p(w,f,w.extensionInfo,w.restrictedProperties,void 0,n),this.c.push(w),this.q(w)})}o(t,f){const n=w=>{if(w.properties)for(const D in w.properties){f.add(D);const h=this.d[D];h?.policy?.name&&this.e.delete(h.policy.name),delete this.d[D],this.s(D,w.properties[D])}w.allOf?.forEach(D=>n(D))};for(const w of t){n(w);const D=this.c.indexOf(w);D!==-1&&this.c.splice(D,1)}}p(t,f=!0,n,w,D=3,h){D=I.$Sf(t.scope)?D:t.scope;const b=t.properties;if(b)for(const g in b){const v=b[g];if(f&&o(g,v)){delete b[g];continue}if(v.source=n,v.defaultDefaultValue=b[g].default,this.w(g,v),e.$Zn.test(g)?v.scope=void 0:(v.scope=I.$Sf(v.scope)?D:v.scope,v.restricted=I.$Sf(v.restricted)?!!w?.includes(g):v.restricted),b[g].hasOwnProperty("included")&&!b[g].included){this.f[g]=b[g],delete b[g];continue}else this.d[g]=b[g],b[g].policy?.name&&this.e.set(b[g].policy.name,g);!b[g].deprecationMessage&&b[g].markdownDeprecationMessage&&(b[g].deprecationMessage=b[g].markdownDeprecationMessage),h.add(g)}const P=t.allOf;if(P)for(const g of P)this.p(g,f,n,w,D,h)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const f=n=>{const w=n.properties;if(w)for(const h in w)this.r(h,w[h]);n.allOf?.forEach(f)};f(t)}r(t,f){switch(e.$Qn.properties[t]=f,f.scope){case 1:e.$Rn.properties[t]=f;break;case 2:e.$Sn.properties[t]=f;break;case 6:e.$Tn.properties[t]=f;break;case 3:e.$Un.properties[t]=f;break;case 4:e.$Vn.properties[t]=f;break;case 5:e.$Vn.properties[t]=f,this.g.properties[t]=f;break}}s(t,f){switch(delete e.$Qn.properties[t],f.scope){case 1:delete e.$Rn.properties[t];break;case 2:delete e.$Sn.properties[t];break;case 6:delete e.$Tn.properties[t];break;case 3:delete e.$Un.properties[t];break;case 4:case 5:delete e.$Vn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const f=`[${t}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$Wn};this.w(f,n),e.$Qn.properties[f]=n,e.$Rn.properties[f]=n,e.$Sn.properties[f]=n,e.$Tn.properties[f]=n,e.$Un.properties[f]=n,e.$Vn.properties[f]=n}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$Wn};e.$Qn.patternProperties[e.$Yn]=t,e.$Rn.patternProperties[e.$Yn]=t,e.$Sn.patternProperties[e.$Yn]=t,e.$Tn.patternProperties[e.$Yn]=t,e.$Un.patternProperties[e.$Yn]=t,e.$Vn.patternProperties[e.$Yn]=t,this.i.fire()}w(t,f){const n=this.a.get(t);let w=n?.value,D=n?.source;I.$Qf(w)&&(w=f.defaultDefaultValue,D=void 0),I.$Qf(w)&&(w=s(f.type)),f.default=w,f.defaultValueSource=D}}const $="\\[([^\\]]+)\\]",p=new RegExp($,"g");e.$Yn=`^(${$})+$`,e.$Zn=new RegExp(e.$Yn);function r(u){const t=[];if(e.$Zn.test(u)){let f=p.exec(u);for(;f?.length;){const n=f[1].trim();n&&t.push(n),f=p.exec(u)}}return(0,S.$Mb)(t)}e.$1n=r;function c(u){return u.reduce((t,f)=>`${t}[${f}]`,"")}e.$2n=c;function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$3n=s;const i=new l;d.$Kn.add(e.$Pn.Configuration,i);function o(u,t){return u.trim()?e.$Zn.test(u)?R.localize(7,null,u):i.getConfigurationProperties()[u]!==void 0?R.localize(8,null,u):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,u,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}e.$4n=o;function a(){const u=[],t=i.getConfigurationProperties();for(const f of Object.keys(t))u.push([f,t[f].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.$5n=a}),define(Re[189],Ae([1,0,18,5,119,6,28,26,16,2,47,55,30]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=e.$8n=e.$7n=e.$6n=void 0;function $(f){return Object.isFrozen(f)?f:m.$zn(f)}class p{constructor(n={},w=[],D=[],h){this.b=n,this.c=w,this.d=D,this.raw=h,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(w=>{if(w instanceof p)return w;const D=new r("");return D.parseRaw(w),D.configurationModel});this.f=n.reduce((w,D)=>D===w?D:w.merge(D),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,A.$Ji)(this.contents,n):this.contents}inspect(n,w){const D=this;return{get value(){return $(D.rawConfiguration.getValue(n))},get override(){return w?$(D.rawConfiguration.getOverrideValue(n,w)):void 0},get merged(){return $(w?D.rawConfiguration.override(w).getValue(n):D.rawConfiguration.getValue(n))},get overrides(){const h=[];for(const{contents:b,identifiers:P,keys:g}of D.rawConfiguration.overrides){const v=new p(b,g).getValue(n);v!==void 0&&h.push({identifiers:P,value:v})}return h.length?$(h):void 0}}}getOverrideValue(n,w){const D=this.i(w);return D?n?(0,A.$Ji)(D,n):D:void 0}getKeysForOverrideIdentifier(n){const w=[];for(const D of this.overrides)D.identifiers.includes(n)&&w.push(...D.keys);return S.$Mb(w)}getAllOverrideIdentifiers(){const n=[];for(const w of this.overrides)n.push(...w.identifiers);return S.$Mb(n)}override(n){let w=this.a.get(n);return w||(w=this.g(n),this.a.set(n,w)),w}merge(...n){const w=m.$yn(this.contents),D=m.$yn(this.overrides),h=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const P of n)if(b.push(...P.raw?.length?P.raw:[P]),!P.isEmpty()){this.h(w,P.contents);for(const g of P.overrides){const[v]=D.filter(E=>S.$ub(E.identifiers,g.identifiers));v?(this.h(v.contents,g.contents),v.keys.push(...g.keys),v.keys=S.$Mb(v.keys)):D.push(m.$yn(g))}for(const g of P.keys)h.indexOf(g)===-1&&h.push(g)}return new p(w,h,D,b.every(P=>P instanceof p)?void 0:b)}g(n){const w=this.i(n);if(!w||typeof w!="object"||!Object.keys(w).length)return this;const D={};for(const h of S.$Mb([...Object.keys(this.contents),...Object.keys(w)])){let b=this.contents[h];const P=w[h];P&&(typeof b=="object"&&typeof P=="object"?(b=m.$yn(b),this.h(b,P)):b=P),D[h]=b}return new p(D,this.keys,this.overrides)}h(n,w){for(const D of Object.keys(w)){if(D in n&&d.$Lf(n[D])&&d.$Lf(w[D])){this.h(n[D],w[D]);continue}n[D]=m.$yn(w[D])}}i(n){let w=null,D=null;const h=b=>{b&&(D?this.h(D,b):D=m.$yn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===n?w=b.contents:b.identifiers.includes(n)&&h(b.contents);return h(w),D}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,w){this.j(n,w,!0)}setValue(n,w){this.j(n,w,!1)}removeValue(n){const w=this.keys.indexOf(n);w!==-1&&(this.keys.splice(w,1),(0,A.$Ii)(this.contents,n),k.$Zn.test(n)&&this.overrides.splice(this.overrides.findIndex(D=>S.$ub(D.identifiers,(0,k.$1n)(n))),1))}j(n,w,D){(0,A.$Hi)(this.contents,n,w,h=>console.error(h)),D=D||this.keys.indexOf(n)===-1,D&&this.keys.push(n),k.$Zn.test(n)&&this.overrides.push({identifiers:(0,k.$1n)(n),keys:Object.keys(this.contents[n]),contents:(0,A.$Gi)(this.contents[n],h=>console.error(h))})}}e.$6n=p;class r{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,w){if(!d.$Sf(n)){const D=this.g(n);this.parseRaw(D,w)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,w){this.a=n;const{contents:D,keys:h,overrides:b,restricted:P,hasExcludedProperties:g}=this.h(n,w);this.b=new p(D,h,b,g?[n]:void 0),this.c=P||[]}g(n){let w={},D=null,h=[];const b=[],P=[];function g(E){Array.isArray(h)?h.push(E):D!==null&&(h[D]=E)}const v={onObjectBegin:()=>{const E={};g(E),b.push(h),h=E,D=null},onObjectProperty:E=>{D=E},onObjectEnd:()=>{h=b.pop()},onArrayBegin:()=>{const E=[];g(E),b.push(h),h=E,D=null},onArrayEnd:()=>{h=b.pop()},onLiteralValue:g,onError:(E,T,N)=>{P.push({error:E,offset:T,length:N})}};if(n)try{I.$mn(n,v),w=h[0]||{}}catch(E){console.error(`Error while parsing settings file ${this.f}: ${E}`),this.d=[E]}return w}h(n,w){const D=l.$Kn.as(k.$Pn.Configuration).getConfigurationProperties(),h=this.i(n,D,!0,w);n=h.raw;const b=(0,A.$Gi)(n,v=>console.error(`Conflict in settings file ${this.f}: ${v}`)),P=Object.keys(n),g=this.j(n,v=>console.error(`Conflict in settings file ${this.f}: ${v}`));return{contents:b,keys:P,overrides:g,restricted:h.restricted,hasExcludedProperties:h.hasExcludedProperties}}i(n,w,D,h){let b=!1;if(!h?.scopes&&!h?.skipRestricted&&!h?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:b};const P={},g=[];for(const v in n)if(k.$Zn.test(v)&&D){const E=this.i(n[v],w,!1,h);P[v]=E.raw,b=b||E.hasExcludedProperties,g.push(...E.restricted)}else{const E=w[v],T=E?typeof E.scope<"u"?E.scope:3:void 0;E?.restricted&&g.push(v),!h.exclude?.includes(v)&&(h.include?.includes(v)||(T===void 0||h.scopes===void 0||h.scopes.includes(T))&&!(h.skipRestricted&&E?.restricted))?P[v]=n[v]:b=!0}return{raw:P,restricted:g,hasExcludedProperties:b}}j(n,w){const D=[];for(const h of Object.keys(n))if(k.$Zn.test(h)){const b={};for(const P in n[h])b[P]=n[h][P];D.push({identifiers:(0,k.$1n)(h),keys:Object.keys(b),contents:(0,A.$Gi)(b,w)})}return D}}e.$7n=r;class c extends R.$Tc{constructor(n,w,D,h){super(),this.c=n,this.f=w,this.g=h,this.b=this.B(new M.$Wd),this.onDidChange=this.b.event,this.a=new r(this.c.toString()),this.B(this.g.watch(D.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(M.Event.any(M.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),M.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&D.isEqual(b.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new p}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$8n=c;class s{constructor(n,w,D,h,b,P,g,v,E,T,N,J,q){this.a=n,this.b=w,this.c=D,this.overrideIdentifiers=h,this.d=b,this.f=P,this.g=g,this.h=v,this.i=E,this.j=T,this.k=N,this.l=J,this.m=q}get value(){return $(this.c)}n(n){return n?.value!==void 0||n?.override!==void 0||n?.overrides!==void 0?n:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class i{constructor(n,w,D,h,b=new p,P=new p,g=new L.$Ac,v=new p,E=new L.$Ac){this.c=n,this.d=w,this.f=D,this.g=h,this.h=b,this.i=P,this.j=g,this.l=v,this.m=E,this.a=null,this.b=new L.$Ac,this.n=null}getValue(n,w,D){return this.p(n,w,D).getValue(n)}updateValue(n,w,D={}){let h;D.resource?(h=this.m.get(D.resource),h||(h=new p,this.m.set(D.resource,h))):h=this.l,w===void 0?h.removeValue(n):h.setValue(n,w),D.resource||(this.a=null)}inspect(n,w,D){const h=this.p(n,w,D),b=this.t(w.resource,D),P=w.resource?this.m.get(w.resource)||this.l:this.l,g=new Set;for(const v of h.overrides)for(const E of v.identifiers)h.getOverrideValue(n,E)!==void 0&&g.add(E);return new s(n,w,h.getValue(n),g.size?[...g]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,D?this.i:void 0,b||void 0,P)}keys(n){const w=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:w?w.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,w){this.j.set(n,w),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,w){const D=[];if(!w){const{added:h,updated:b,removed:P}=u(this.c,n);w=[...h,...b,...P]}for(const h of w)for(const b of(0,k.$1n)(h)){const P=this.c.getKeysForOverrideIdentifier(b),g=n.getKeysForOverrideIdentifier(b),v=[...g.filter(E=>P.indexOf(E)===-1),...P.filter(E=>g.indexOf(E)===-1),...P.filter(E=>!m.$Cn(this.c.override(b).getValue(E),n.override(b).getValue(E)))];D.push([b,v])}return this.updateDefaultConfiguration(n),{keys:w,overrides:D}}compareAndUpdatePolicyConfiguration(n){const{added:w,updated:D,removed:h}=u(this.d,n),b=[...w,...D,...h];return b.length&&this.updatePolicyConfiguration(n),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:w,updated:D,removed:h,overrides:b}=u(this.applicationConfiguration,n),P=[...w,...D,...h];return P.length&&this.updateApplicationConfiguration(n),{keys:P,overrides:b}}compareAndUpdateLocalUserConfiguration(n){const{added:w,updated:D,removed:h,overrides:b}=u(this.localUserConfiguration,n),P=[...w,...D,...h];return P.length&&this.updateLocalUserConfiguration(n),{keys:P,overrides:b}}compareAndUpdateRemoteUserConfiguration(n){const{added:w,updated:D,removed:h,overrides:b}=u(this.remoteUserConfiguration,n),P=[...w,...D,...h];return P.length&&this.updateRemoteUserConfiguration(n),{keys:P,overrides:b}}compareAndUpdateWorkspaceConfiguration(n){const{added:w,updated:D,removed:h,overrides:b}=u(this.workspaceConfiguration,n),P=[...w,...D,...h];return P.length&&this.updateWorkspaceConfiguration(n),{keys:P,overrides:b}}compareAndUpdateFolderConfiguration(n,w){const D=this.folderConfigurations.get(n),{added:h,updated:b,removed:P,overrides:g}=u(D,w),v=[...h,...b,...P];return(v.length||!D)&&this.updateFolderConfiguration(n,w),{keys:v,overrides:g}}compareAndDeleteFolderConfiguration(n){const w=this.folderConfigurations.get(n);if(!w)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:D,updated:h,removed:b,overrides:P}=u(w,void 0);return{keys:[...D,...h,...b],overrides:P}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,w,D){let h=this.q(w,D);return w.overrideIdentifier&&(h=h.override(w.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(h=h.merge(this.d)),h}q({resource:n},w){let D=this.r();if(w&&n){const h=w.getFolder(n);h&&(D=this.s(h.uri)||D);const b=this.m.get(n);b&&(D=D.merge(b))}return D}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let w=this.b.get(n);if(!w){const D=this.r(),h=this.j.get(n);h?(w=D.merge(h),this.b.set(n,w)):w=D}return w}t(n,w){if(w&&n){const D=w.getFolder(n);if(D)return this.j.get(D.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,w)=>{const{contents:D,overrides:h,keys:b}=this.j.get(w);return n.push([w,{contents:D,overrides:h,keys:b}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(w=>n.add(w)),this.userConfiguration.keys.forEach(w=>n.add(w)),this.i.keys.forEach(w=>n.add(w)),this.j.forEach(w=>w.keys.forEach(D=>n.add(D))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(w=>n.add(w)),this.userConfiguration.getAllOverrideIdentifiers().forEach(w=>n.add(w)),this.i.getAllOverrideIdentifiers().forEach(w=>n.add(w)),this.j.forEach(w=>w.getAllOverrideIdentifiers().forEach(D=>n.add(D))),[...n.values()]}v(n){const w=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(D=>w.add(D)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(D=>w.add(D)),this.i.getKeysForOverrideIdentifier(n).forEach(D=>w.add(D)),this.j.forEach(D=>D.getKeysForOverrideIdentifier(n).forEach(h=>w.add(h))),[...w.values()]}static parse(n){const w=this.w(n.defaults),D=this.w(n.policy),h=this.w(n.application),b=this.w(n.user),P=this.w(n.workspace),g=n.folders.reduce((v,E)=>(v.set(y.URI.revive(E[0]),this.w(E[1])),v),new L.$Ac);return new i(w,D,h,b,new p,P,g,new p,new L.$Ac)}static w(n){return new p(n.contents,n.keys,n.overrides)}}e.$9n=i;function o(...f){if(f.length===0)return{keys:[],overrides:[]};if(f.length===1)return f[0];const n=new Set,w=new Map;for(const h of f)h.keys.forEach(b=>n.add(b)),h.overrides.forEach(([b,P])=>{const g=(0,L.$xc)(w,b,new Set);P.forEach(v=>g.add(v))});const D=[];return w.forEach((h,b)=>D.push([b,[...h.values()]])),{keys:[...n.values()],overrides:D}}e.$0n=o;class a{constructor(n,w,D,h){this.change=n,this.f=w,this.g=D,this.h=h,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.i=void 0;for(const b of n.keys)this.affectedKeys.add(b);for(const[,b]of n.overrides)for(const P of b)this.affectedKeys.add(P);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(n,w){const D=this.a+n,h=this.d.indexOf(D);if(h<0)return!1;const b=h+D.length;if(b>=this.d.length)return!1;const P=this.d.charCodeAt(b);if(P!==this.b&&P!==this.c)return!1;if(w){const g=this.previousConfiguration?this.previousConfiguration.getValue(n,w,this.f?.workspace):void 0,v=this.g.getValue(n,w,this.h);return!m.$Cn(g,v)}return!0}}e.$$n=a;function u(f,n){const{added:w,removed:D,updated:h}=t(n?.rawConfiguration,f?.rawConfiguration),b=[],P=f?.getAllOverrideIdentifiers()||[],g=n?.getAllOverrideIdentifiers()||[];if(n){const v=g.filter(E=>!P.includes(E));for(const E of v)b.push([E,n.getKeysForOverrideIdentifier(E)])}if(f){const v=P.filter(E=>!g.includes(E));for(const E of v)b.push([E,f.getKeysForOverrideIdentifier(E)])}if(n&&f){for(const v of P)if(g.includes(v)){const E=t({contents:f.getOverrideValue(void 0,v)||{},keys:f.getKeysForOverrideIdentifier(v)},{contents:n.getOverrideValue(void 0,v)||{},keys:n.getKeysForOverrideIdentifier(v)});b.push([v,[...E.added,...E.removed,...E.updated]])}}return{added:w,removed:D,updated:h,overrides:b}}function t(f,n){const w=f?n?f.keys.filter(b=>n.keys.indexOf(b)===-1):[...f.keys]:[],D=n?f?n.keys.filter(b=>f.keys.indexOf(b)===-1):[...n.keys]:[],h=[];if(f&&n){for(const b of n.keys)if(f.keys.indexOf(b)!==-1){const P=(0,A.$Ji)(n.contents,b),g=(0,A.$Ji)(f.contents,b);m.$Cn(P,g)||h.push(b)}}return{added:w,removed:D,updated:h}}}),define(Re[100],Ae([1,0,15,4]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bl=e.$al=e.RemoteAuthorityResolverErrorCode=e.$_k=e.$$k=e.RemoteConnectionType=e.$0k=void 0,e.$0k=(0,M.$8h)("remoteAuthorityResolverService");var I;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(I||(e.RemoteConnectionType=I={}));class R{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$$k=R;class L{constructor(k,l){this.host=k,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$_k=L;var m;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(m||(e.RemoteAuthorityResolverErrorCode=m={}));class d extends S.$bb{static isNotAvailable(k){return k instanceof d&&k._code===m.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof d&&k._code===m.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof d&&k._code===m.NoResolverFound}static isInvalidAuthority(k){return k instanceof d&&k._code===m.InvalidAuthority}static isHandled(k){return k instanceof d&&k.isHandled}constructor(k,l=m.Unknown,$){super(k),this._message=k,this._code=l,this._detail=$,this.isHandled=l===m.NotAvailable&&$===!0,Object.setPrototypeOf(this,d.prototype)}}e.$al=d;function y(A){const k=A.indexOf("+");return k===-1?A:A.substring(0,k)}e.$bl=y}),define(Re[56],Ae([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=e.$el=e.$dl=e.$cl=void 0;function M(y){return y.scheme===S.Schemas.vscodeRemote?y.authority:void 0}e.$cl=M;function I(y){if(!y)return;const A=y.indexOf("+");return A<0?y:y.substr(0,A)}e.$dl=I;function R(y){return`/${y.quality??"oss"}-${y.commit??"dev"}`}e.$el=R;function L(y){const{host:A,port:k}=d(y);if(typeof k>"u")throw new Error(`Invalid remote authority: ${y}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:k}}e.$fl=L;function m(y,A){let{host:k,port:l}=d(y);return typeof l>"u"&&(l=A),{host:k,port:l}}e.$gl=m;function d(y){const A=y.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const k=y.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const l=y.match(/(.*):(\d+)$/);return l?{host:l[1],port:parseInt(l[2],10)}:{host:y,port:void 0}}}),define(Re[22],Ae([1,0,14,4,56]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$um=e.$tm=e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.TargetPlatform=e.ExtensionType=e.$mm=e.$lm=e.$km=e.$jm=e.$im=e.$hm=void 0,e.$hm="extensions.user.cache",e.$im="extensions.builtin.cache",e.$jm="undefined_publisher",e.$km=["ui","workspace","web"];function R(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.$lm=R,e.$mm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var L;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(L||(e.ExtensionType=L={}));var m;(function(r){r.WIN32_X64="win32-x64",r.WIN32_ARM64="win32-arm64",r.LINUX_X64="linux-x64",r.LINUX_ARM64="linux-arm64",r.LINUX_ARMHF="linux-armhf",r.ALPINE_X64="alpine-x64",r.ALPINE_ARM64="alpine-arm64",r.DARWIN_X64="darwin-x64",r.DARWIN_ARM64="darwin-arm64",r.WEB="web",r.UNIVERSAL="universal",r.UNKNOWN="unknown",r.UNDEFINED="undefined"})(m||(e.TargetPlatform=m={}));class d{constructor(c){this.value=c,this._lower=c.toLowerCase()}static equals(c,s){if(typeof c>"u"||c===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof c=="string"||typeof s=="string"){const i=typeof c=="string"?c:c.value,o=typeof s=="string"?s:s.value;return S.$af(i,o)}return c._lower===s._lower}static toKey(c){return typeof c=="string"?c.toLowerCase():c._lower}}e.$nm=d;class y{get size(){return this.c.size}constructor(c){if(this.c=new Set,c)for(const s of c)this.add(s)}add(c){this.c.add(d.toKey(c))}delete(c){return this.c.delete(d.toKey(c))}has(c){return this.c.has(d.toKey(c))}}e.$om=y;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(c){this.c.delete(d.toKey(c))}get(c){return this.c.get(d.toKey(c))}has(c){return this.c.has(d.toKey(c))}set(c,s){this.c.set(d.toKey(c),s)}values(){return this.c.values()}forEach(c){this.c.forEach(c)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$pm=A;function k(r){return l(r)}e.$qm=k;function l(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.$rm=l;function $(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.$sm=$;function p(r,c){if(c){const s=`onResolveRemoteAuthority:${(0,I.$dl)(c)}`;return!!r.activationEvents?.includes(s)}return!1}e.$tm=p,e.$um=(0,M.$8h)("IBuiltinExtensionsScannerService")}),define(Re[101],Ae([1,0,15,22]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qF=e.$pF=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(L,m){this.a.set(L,m)}readActivationEvents(L){return this.b.has(L)||this.b.set(L,this.c(L)),this.b.get(L)}createActivationEventsMap(L){const m=Object.create(null);for(const d of L){const y=this.readActivationEvents(d);y.length>0&&(m[M.$nm.toKey(d.identifier)]=y)}return m}c(L){if(typeof L.main>"u"&&typeof L.browser>"u")return[];const m=Array.isArray(L.activationEvents)?L.activationEvents.slice(0):[];for(let d=0;d<m.length;d++)m[d]==="onUri"&&(m[d]=`onUri:${M.$nm.toKey(L.identifier)}`);if(!L.contributes)return m;for(const d in L.contributes){const y=this.a.get(d);if(!y)continue;const A=L.contributes[d],k=Array.isArray(A)?A:[A];try{y(k,m)}catch(l){(0,S.$1)(l)}}return m}}e.$pF=I,e.$qF=new I}),define(Re[190],Ae([1,0,20,73,33]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mo=e.$Lo=void 0;function R(d){if(S.$u===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}function L(d,y,A,k,l,$,p,r,c){const s=Object.create(null);s["common.machineId"]=$,s["common.sqmId"]=p,s.sessionID=(0,I.$rg)()+Date.now(),s.commitHash=k,s.version=l,s["common.platformVersion"]=(d||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,S.$h)(S.$u),s["common.nodePlatform"]=M.$dc,s["common.nodeArch"]=A,s["common.product"]=c||"desktop",r&&(s["common.msftInternal"]=r);let i=0;const o=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-o,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),S.$l&&(s["common.snap"]="true");const a=R(y);return a&&(s["common.platformDetail"]=a),s}e.$Lo=L;function m(d){const y=M.env.USERDNSDOMAIN;if(!y)return!1;const A=y.toLowerCase();return d.some(k=>A===k)}e.$Mo=m}),define(Re[191],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$Gl=e.$Fl=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=void 0,e.$wl=(0,S.$8h)("telemetryService"),e.$xl=(0,S.$8h)("customEndpointTelemetryService"),e.$yl="telemetry.currentSessionDate",e.$zl="telemetry.firstSessionDate",e.$Al="telemetry.lastSessionDate",e.$Bl="telemetry.machineId",e.$Cl="telemetry.sqmId",e.$Dl="telemetry",e.$El="telemetry.telemetryLevel",e.$Fl="telemetry.enableCrashReporter",e.$Gl="telemetry.enableTelemetry";var M;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var I;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Re[57],Ae([1,0,26,16,56,190,191]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=void 0;class m{constructor(f){this.value=f,this.isTrustedTelemetryValue=!0}}e.$No=m;class d{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Oo=d,e.$Po=new d;class y{async publicLog(f,n,w){}async publicLogError(f,n,w){}}e.$Qo=y,e.$Ro="telemetry",e.$So="extensionTelemetryLog",e.$To={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,f){return!f.isBuilt&&!f.disableTelemetry?!0:!(f.disableTelemetry||!t.enableTelemetry)}e.$Uo=A;function k(t,f){return f.extensionTestsLocationURI?!0:!(f.isBuilt||f.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$Vo=k;function l(t){const f=t.getValue(L.$El),n=t.getValue(L.$Fl);if(t.getValue(L.$Gl)===!1||n===!1)return 0;switch(f??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Wo=l;function $(t){const f={},n={},w={};c(t,w);for(let D in w){D=D.length>150?D.substr(D.length-149):D;const h=w[D];typeof h=="number"?n[D]=h:typeof h=="boolean"?n[D]=h?1:0:typeof h=="string"?(h.length>8192&&console.warn(`Telemetry property: ${D} has been trimmed to 8192, the original length is ${h.length}`),f[D]=h.substring(0,8191)):typeof h<"u"&&h!==null&&(f[D]=h)}return{properties:f,measurements:n}}e.$Xo=$;const p=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function r(t){if(!t)return"none";const f=(0,I.$dl)(t);return p.has(f)?f:"other"}e.$Yo=r;function c(t,f,n=0,w){if(t)for(const D of Object.getOwnPropertyNames(t)){const h=t[D],b=w?w+D:D;Array.isArray(h)?f[b]=(0,S.$Dn)(h):h instanceof Date?f[b]=h.toISOString():(0,M.$Lf)(h)?n<2?c(h,f,n+1,b+"."):f[b]=(0,S.$Dn)(h):f[b]=h}}function s(t,f){const n=t.msftInternalDomains||[],w=f.getValue("telemetry.internalTesting");return(0,R.$Mo)(n)||w}e.$Zo=s;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$1o=i;function o(t,f){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let n=t;const w=[];for(const P of f)for(;;){const g=P.exec(t);if(!g)break;w.push([g.index,P.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(n="";;){const P=h.exec(t);if(!P)break;const g=w.some(([v,E])=>P.index<E&&v<h.lastIndex);!D.test(P[0])&&!g&&(n+=t.substring(b,P.index)+"<REDACTED: user-file-path>",b=h.lastIndex)}return b<t.length&&(n+=t.substr(b)),n}function a(t){if(!t)return t;const f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of f)if(n.regex.test(t))return`<REDACTED: ${n.label}>`;return t}function u(t,f){return(0,S.$An)(t,n=>{if(n instanceof m||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let w=n.replaceAll("%20"," ");w=o(w,f);for(const D of f)w=w.replace(D,"");return w=a(w),w}})}e.$2o=u}),define(Re[192],Ae([1,0,14,96,22,20,2,15,73,57]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=void 0;function A(n,w){return n.uuid&&w.uuid?n.uuid===w.uuid:n.id===w.id?!0:(0,S.$8e)(n.id,w.id)===0}e.$3o=A;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(w){const D=w.manifest?w.manifest.version:w.version,h=w.manifest?w.targetPlatform:w.properties.targetPlatform;return new l(w.identifier,D,h)}static parse(w){const D=k.exec(w);return D&&D[1]&&D[2]?new l({id:D[1]},D[2],D[4]||void 0):null}constructor(w,D,h="undefined"){this.version=D,this.targetPlatform=h,this.id=w.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(w){return w instanceof l?A(this,w)&&this.version===w.version&&this.targetPlatform===w.targetPlatform:!1}}e.$4o=l;const $=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(n){const w=$.exec(n);return w&&w[1]?[c(w[1]),w[2]]:[c(n),void 0]}e.$5o=p;function r(n,w){return`${n}.${w}`}e.$6o=r;function c(n){return n.toLowerCase()}e.$7o=c;function s(n,w){return c(r(n??I.$jm,w))}e.$8o=s;function i(n,w){const D=[],h=b=>{for(const P of D)if(P.some(g=>A(w(g),w(b))))return P;return null};for(const b of n){const P=h(b);P?P.push(b):D.push([b])}return D}e.$9o=i;function o(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$0o=o;function a(n){return{id:new y.$No(n.identifier.id),name:new y.$No(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$$o=a,e.$_o=new I.$nm("pprice.better-merge");function u(n,w){const D=[],h=w.manifest.extensionDependencies?.slice(0)??[];for(;h.length;){const b=h.shift();if(b&&D.every(P=>!A(P.identifier,{id:b}))){const P=n.filter(g=>A(g.identifier,{id:b}));P.length===1&&(D.push(P[0]),h.push(...P[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.$ap=u;async function t(n,w){if(!R.$k)return!1;let D;try{D=(await n.readFile(L.URI.file("/etc/os-release"))).value.toString()}catch{try{D=(await n.readFile(L.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){w.debug("Error while getting the os-release file.",(0,m.$0)(b))}}return!!D&&(D.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function f(n,w){const D=await t(n,w),h=(0,M.$xo)(D?"alpine":R.$u,d.$ec);return w.debug("ComputeTargetPlatform:",h),h}e.$bp=f}),define(Re[193],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tr=e.$Sr=e.$Rr=e.$Qr=e.$Pr=e.$Or=void 0;function S(d){return[...d.entries()]}e.$Or=S;function M(d){return d?[...d.entries()]:[]}e.$Pr=M;function I(d){return new Map(d)}e.$Qr=I;function R(d){return new Map(d??[])}e.$Rr=R;function L(d){return Array.from(d.entries()).map(y=>[y[0],S(y[1].map),M(y[1].descriptionMap)])}e.$Sr=L;function m(d){return new Map(d.map(y=>[y[0],{map:I(y[1]),descriptionMap:R(y[2])}]))}e.$Tr=m}),define(Re[194],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Msb=void 0;class S{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,R,L=5){const m=R(d=>{const y=typeof d=="string"?d:d.data;let A=this.a.get(I);if(A){A.data.push(y);return}const k=setTimeout(()=>this.flushBuffer(I),L);A={data:[y],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(I),m.dispose()}},this.a.set(I,A)});return m}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const R=this.a.get(I);R&&(this.a.delete(I),this.b(I,R.data.join("")))}}e.$Msb=S}),define(Re[195],Ae([1,0,11,89,40,5,16,2,155,72,30]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Fw=e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.IconFontDefinition=e.IconContribution=e.$yw=void 0,e.$yw={IconContribution:"base.contributions.icons"};var k;(function(a){function u(t,f){let n=t.defaults;for(;I.ThemeIcon.isThemeIcon(n);){const w=p.getIcon(n.id);if(!w)return;n=w.defaults}return n}a.getDefinition=u})(k||(e.IconContribution=k={}));var l;(function(a){function u(f){return{weight:f.weight,style:f.style,src:f.src.map(n=>({format:n.format,location:n.location.toString()}))}}a.toJSONObject=u;function t(f){const n=w=>(0,L.$Jf)(w)?w:void 0;if(f&&Array.isArray(f.src)&&f.src.every(w=>(0,L.$Jf)(w.format)&&(0,L.$Jf)(w.location)))return{weight:n(f.weight),style:n(f.style),src:f.src.map(w=>({format:w.format,location:m.URI.parse(w.location)}))}}a.fromJSONObject=t})(l||(e.IconFontDefinition=l={}));class ${constructor(){this.a=new R.$Wd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,d.localize)(0,null)},fontCharacter:{type:"string",description:(0,d.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(u,t,f,n){const w=this.b[u];if(w){if(f&&!w.description){w.description=f,this.d.properties[u].markdownDescription=`${f} $(${u})`;const b=this.e.enum.indexOf(u);b!==-1&&(this.e.enumDescriptions[b]=f),this.a.fire()}return w}const D={id:u,description:f,defaults:t,deprecationMessage:n};this.b[u]=D;const h={$ref:"#/definitions/icons"};return n&&(h.deprecationMessage=n),f&&(h.markdownDescription=`${f}: $(${u})`),this.d.properties[u]=h,this.e.enum.push(u),this.e.enumDescriptions.push(f||""),this.a.fire(),{id:u}}deregisterIcon(u){delete this.b[u],delete this.d.properties[u];const t=this.e.enum.indexOf(u);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(u=>this.b[u])}getIcon(u){return this.b[u]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(u,t){const f=this.f[u];return f||(this.f[u]=t,this.a.fire(),t)}deregisterIconFont(u){delete this.f[u]}getIconFont(u){return this.f[u]}toString(){const u=(w,D)=>w.id.localeCompare(D.id),t=w=>{for(;I.ThemeIcon.isThemeIcon(w.defaults);)w=this.b[w.defaults.id];return`codicon codicon-${w?w.id:""}`},f=[];f.push("| preview     | identifier                        | default codicon ID                | description"),f.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const n=Object.keys(this.b).map(w=>this.b[w]);for(const w of n.filter(D=>!!D.description).sort(u))f.push(`|<i class="${t(w)}"></i>|${w.id}|${I.ThemeIcon.isThemeIcon(w.defaults)?w.defaults.id:w.id}|${w.description||""}|`);f.push("| preview     | identifier                        "),f.push("| ----------- | --------------------------------- |");for(const w of n.filter(D=>!I.ThemeIcon.isThemeIcon(D.defaults)).sort(u))f.push(`|<i class="${t(w)}"></i>|${w.id}|`);return f.join(`
`)}}const p=new $;A.$Kn.add(e.$yw.IconContribution,p);function r(a,u,t,f){return p.registerIcon(a,u,t,f)}e.$zw=r;function c(){return p}e.$Aw=c;function s(){const a=(0,M.$_j)();for(const u in a){const t="\\"+a[u].toString(16);p.registerIcon(u,{fontCharacter:t})}}s(),e.$Bw="vscode://schemas/icons";const i=A.$Kn.as(y.$Ln.JSONContribution);i.registerSchema(e.$Bw,p.getIconSchema());const o=new S.$hh(()=>i.notifySchemaChanged(e.$Bw),200);p.onDidChange(()=>{o.isScheduled()||o.schedule()}),e.$Cw=r("widget-close",M.$bk.close,(0,d.localize)(2,null)),e.$Dw=r("goto-previous-location",M.$bk.arrowUp,(0,d.localize)(3,null)),e.$Ew=r("goto-next-location",M.$bk.arrowDown,(0,d.localize)(4,null)),e.$Fw=I.ThemeIcon.modify(M.$bk.sync,"spin"),e.$Gw=I.ThemeIcon.modify(M.$bk.loading,"spin")}),define(Re[196],Ae([1,0,5,2,47,4,13]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mv=e.$Lv=e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.ProvidedOnAutoForward=e.$Ev=e.TunnelPrivacyId=e.TunnelProtocol=e.$Dv=e.$Cv=void 0,e.$Cv=(0,R.$8h)("tunnelService"),e.$Dv=(0,R.$8h)("sharedTunnelsService");var m;(function(s){s.Http="http",s.Https="https"})(m||(e.TunnelProtocol=m={}));var d;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(d||(e.TunnelPrivacyId=d={}));function y(s){return!!s.forwardPort}e.$Ev=y;var A;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(A||(e.ProvidedOnAutoForward=A={}));function k(s,{checkQuery:i=!0}={}){if(s.scheme!=="http"&&s.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(o)return{address:o[1],port:+o[2]};if(!s.query||!i)return;const a=s.query.split("&");for(const u of a){const t=u.split("=")[1];if(/^https?:/.exec(t)){const f=k(M.URI.parse(t));if(f)return f}}}e.$Fv=k,e.$Gv=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function l(s){return e.$Gv.indexOf(s)>=0}e.$Hv=l,e.$Iv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function $(s){return e.$Iv.indexOf(s)>=0}e.$Jv=$;function p(s,i,o,a){if(o===1)return!1;if(o===2&&$(i)){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(u?.length===4&&parseInt(u[1])>=18)return!1}return s<1024}e.$Kv=p;class r{constructor(i,o,a){this.remoteAddress=i,this.localAddress=o,this.b=a,this.a=new S.$Wd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Lv=r;let c=class{constructor(i,o){this.k=i,this.l=o,this.a=new S.$Wd,this.onTunnelOpened=this.a.event,this.b=new S.$Wd,this.onTunnelClosed=this.b.event,this.c=new S.$Wd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const i=this.l.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.f=i,i?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.g=i.elevation,this.i=i.privacyOptions,this.h=i.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const i=[],o=Array.from(this.e.values());for(const a of o){const u=Array.from(a.values());for(const t of u){const f=await t.value;f&&typeof f!="string"&&i.push(f)}}return i}async dispose(){for(const i of this.e.values()){for(const{value:o}of i.values())await o.then(a=>typeof a!="string"?a?.dispose():void 0);i.clear()}this.e.clear()}setEnvironmentTunnel(i,o,a,u,t){this.q(i,o,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:o,localAddress:a,privacy:u,protocol:t,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,o){($(i)||l(i))&&(i=e.$Gv[0]);const a=this.s(i,o);if(a)return++a.refcount,a.value}openTunnel(i,o,a,u,t,f=!1,n,w){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${a} on local port ${t}.`);const D=this.f??i;if(!D)return;if(o||(o="localhost"),u||(u=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const h=this.t(D,o,a,u,t,f,n,w);return h?h.then(b=>{if(b){if(typeof b=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(o,a),b}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(o,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const P=this.o(b);return(b.tunnelRemoteHost!==o||b.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),n&&b.privacy!==n&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(P),P}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),h)}o(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const o=this.e.get(i.tunnelRemoteHost);if(o){const a=o.get(i.tunnelRemotePort);a&&(a.refcount--,await this.p(i.tunnelRemoteHost,i.tunnelRemotePort,a))}}}}async p(i,o,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${o}.`);const u=a.value.then(async t=>{t&&typeof t!="string"&&(await t.dispose(!0),this.b.fire({host:t.tunnelRemoteHost,port:t.tunnelRemotePort}))});return this.e.has(i)&&this.e.get(i).delete(o),u}}async closeTunnel(i,o){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${o} `);const a=this.e.get(i);if(a&&a.has(o)){const u=a.get(o);u.refcount=0,await this.p(i,o,u)}}q(i,o,a){this.e.has(i)||this.e.set(i,new Map),this.e.get(i).set(o,{refcount:1,value:a})}async r(i,o){const a=this.e.get(i);if(a){const u=a.get(o),t=u?await u.value:void 0;(!t||typeof t=="string")&&a.delete(o),a.size===0&&this.e.delete(i)}}s(i,o){const a=[i];l(i)?(a.push(...e.$Gv),a.push(...e.$Iv)):$(i)&&a.push(...e.$Iv);const u=a.map(t=>this.e.get(t));for(const t of u){const f=t?.get(o);if(f)return f}}canTunnel(i){return!!k(i)}u(i,o,a,u,t,f,n){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${a} on local port ${u}.`);const w=a;this.j.add(w);const D=u===void 0?a:u,h={elevationRequired:t?this.isPortPrivileged(D):!1},b={remoteAddress:{host:o,port:a},localAddressPort:u,privacy:f,public:f?f!==d.Private:void 0,protocol:n},P=i.forwardPort(b,h);return P?(this.q(o,a,P),P.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(w)})):this.j.delete(w),P}};e.$Mv=c,e.$Mv=c=Ge([qe(0,L.$pj),qe(1,I.$Bi)],c)}),define(Re[197],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Nv=void 0,e.$Nv=(0,S.$8h)("editSessionIdentityService");var M;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(M||(e.EditSessionIdentityMatch=M={}))}),define(Re[198],Ae([1,0,12]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YK=e.$XK=e.$WK=e.$VK=e.$UK=void 0;function M(d){return d.scheme!==S.Schemas.file&&d.scheme!==S.Schemas.vscodeRemote}e.$UK=M;function I(d){if(d.folders.length)return d.folders.every(y=>M(y.uri))?d.folders[0].uri:void 0;if(d.configuration&&M(d.configuration))return d.configuration}e.$VK=I;function R(d){return I(d)?.scheme}e.$WK=R;function L(d){return I(d)?.authority}e.$XK=L;function m(d){return I(d)!==void 0}e.$YK=m}),define(Re[48],Ae([1,0,156,19,51,24,2,4,12]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ai=e.$zi=e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.WorkbenchState=e.$li=e.$ki=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=void 0,e.$ei=(0,m.$8h)("contextService");function y(w){const D=w;return typeof D?.id=="string"&&L.URI.isUri(D.uri)}e.$fi=y;function A(w){return typeof w?.id=="string"&&!y(w)&&!l(w)}e.$gi=A,e.$hi={id:"ext-dev"},e.$ii={id:"empty-window"};function k(w,D){if(typeof w=="string"||typeof w>"u")return typeof w=="string"?{id:(0,M.$nc)(w)}:D?e.$hi:e.$ii;const h=w;return h.configuration?{id:h.id,configPath:h.configuration}:h.folders.length===1?{id:h.id,uri:h.folders[0].uri}:{id:h.id}}e.$ji=k;function l(w){const D=w;return typeof D?.id=="string"&&L.URI.isUri(D.configPath)}e.$ki=l;function $(w){const D=w;if(D?.uri)return{id:D.id,uri:L.URI.revive(D.uri)};const h=w;if(h?.configPath)return{id:h.id,configPath:L.URI.revive(h.configPath)};if(w?.id)return{id:w.id}}e.$li=$;var p;(function(w){w[w.EMPTY=1]="EMPTY",w[w.FOLDER=2]="FOLDER",w[w.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function r(w){const D=w;return!!(D&&typeof D=="object"&&typeof D.id=="string"&&Array.isArray(D.folders))}e.$mi=r;function c(w){const D=w;return!!(D&&typeof D=="object"&&L.URI.isUri(D.uri)&&typeof D.name=="string"&&typeof D.toResource=="function")}e.$ni=c;class s{constructor(D,h,b,P,g){this.h=D,this.j=b,this.k=P,this.l=g,this.c=I.$bi.forUris(this.l,()=>!0),this.folders=h}update(D){this.h=D.id,this.k=D.configuration,this.j=D.transient,this.l=D.l,this.folders=D.folders}get folders(){return this.g}set folders(D){this.g=D,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(D){this.k=D}getFolder(D){return D&&this.c.findSubstr(D)||null}n(){this.c=I.$bi.forUris(this.l,()=>!0);for(const D of this.folders)this.c.set(D.uri,D)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$oi=s;class i{constructor(D,h){this.raw=h,this.uri=D.uri,this.index=D.index,this.name=D.name}toResource(D){return(0,R.$Ig)(this.uri,D)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$pi=i;function o(w){return new i({uri:w,index:0,name:(0,R.$Eg)(w)},{uri:w.toString()})}e.$qi=o,e.$ri="code-workspace",e.$si=`.${e.$ri}`,e.$ti=[{name:(0,S.localize)(0,null),extensions:[e.$ri]}],e.$ui="workspace.json";function a(w,D){return R.$zg.isEqualOrParent(w,D.untitledWorkspacesHome)}e.$vi=a;function u(w){let D;return L.URI.isUri(w)?D=w:D=w.configuration,D?.scheme===d.Schemas.tmp}e.$wi=u,e.$xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(w){return w.id===e.$xi}e.$yi=t;function f(w,D){return!a(w,D)&&!u(w)}e.$zi=f;function n(w){return(typeof w=="string"?(0,M.$oc)(w):(0,R.$Gg)(w))===e.$si}e.$Ai=n}),define(Re[74],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mgc=void 0;class S{static{this.a=!1}constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const R=this.c++;return this.b.set(R,I),this.e(),R}get(I,R){return this.b.has(I)?this.b.get(I)[R]:void 0}delete(I){this.b.delete(I),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$mgc=S}),define(Re[43],Ae([1,0,12,24,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qgc=e.$pgc=void 0;class R{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new M.$xg(m=>{const d=this.b.get(m.scheme);return!(d===void 0||d&1024)})}$acceptProviderInfos(m,d){d===null?this.b.delete(m.scheme):this.b.set(m.scheme,d)}isFreeScheme(m){return!this.b.has(m)&&!this.a.has(m)}getCapabilities(m){return this.b.get(m)}}e.$pgc=R,e.$qgc=(0,I.$8h)("IExtHostFileSystemInfo")}),define(Re[27],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MN=void 0,e.$MN=(0,S.$8h)("IExtHostInitDataService")}),define(Re[199],Ae([1,0,161,13,186,27]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wic=void 0;let L=class extends I.$TO{constructor(d,y,A){const k=A.remote.isRemote?"remoteexthost":d?"workerexthost":"exthost",l=A.remote.isRemote?(0,S.localize)(0,null):d?(0,S.localize)(1,null):(0,S.localize)(2,null);super(y.createLogger(k,{name:l}))}};e.$wic=L,e.$wic=L=Ge([qe(1,M.$qj),qe(2,R.$MN)],L)}),define(Re[200],Ae([1,0,11]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_gc=e.$$gc=void 0;class M{constructor(L,m,d){this.h=new Map,this.a=L,this.b=m,this.c=d,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(y=>(this.f=y,this)),this.g=this.c.onDidChangeStorage(y=>{y.shared===this.b&&y.key===this.a&&(this.f=y.value)}),this.i=new S.$hh(()=>{const y=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of y.values())A.complete()}catch(A){for(const k of y.values())k.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,L])=>L!==void 0).map(([L])=>L)}get whenReady(){return this.d}get(L,m){let d=this.f[L];return typeof d>"u"&&(d=m),d}update(L,m){this.f[L]=m;const d=this.h.get(L);if(d!==void 0)return d.p;const y=new S.$sh;return this.h.set(L,y),this.i.isScheduled()||this.i.schedule(),y.p}dispose(){this.g.dispose()}}e.$$gc=M;class I extends M{setKeysForSync(L){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},L)}constructor(L,m){super(L.identifier.value,!0,m),this.j=L}}e.$_gc=I}),define(Re[201],Ae([1,0,5,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yhc=void 0;class I{constructor(L){this.c=L,this.a=new S.$Wd,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$Wd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(L,m,d,y){const k=this.c.getNotebookDocument(M.URI.revive(L)).acceptModelChanged(m.value,d,y);this.b.fire(k)}$acceptDirtyStateChanged(L,m){this.c.getNotebookDocument(M.URI.revive(L)).acceptDirty(m)}$acceptModelSaved(L){const m=this.c.getNotebookDocument(M.URI.revive(L));this.a.fire(m.apiNotebook)}}e.$Yhc=I}),define(Re[17],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xN=e.$wN=void 0,e.$wN=(0,S.$8h)("IExtHostRpcService");class M{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.$xN=M}),define(Re[202],Ae([1,0,22,5]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ghc=void 0;class I{#e;constructor(L,m){this.b=new M.$Wd,this.onDidChange=this.b.event,this.a=S.$nm.toKey(L.identifier),this.#e=m,this.#e.onDidChangePassword(d=>{d.extensionId===this.a&&this.b.fire({key:d.key})})}get(L){return this.#e.get(this.a,L)}store(L,m){return this.#e.store(this.a,L,m)}delete(L){return this.#e.delete(this.a,L)}}e.$ghc=I}),define(Re[58],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jgc=e.$Igc=void 0,e.$Igc=(0,S.$8h)("IURITransformerService");class M{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=L=>L,this.transformOutgoing=L=>L,this.transformOutgoingURI=L=>L,this.transformOutgoingScheme=L=>L)}}e.$Jgc=M}),define(Re[203],Ae([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ulb=e.$Tlb=void 0;class M{constructor(){this.buffers=[]}add(d){let y=this.buffers.indexOf(d);return y<0&&(y=this.buffers.length,this.buffers.push(d)),y}}function I(m,d){if(d.serializeBuffersForPostMessage){const y=new M,k=JSON.stringify(m,($,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:y.add(p)};if(ArrayBuffer.isView(p)){const r=R(p);if(r)return{$$vscode_array_buffer_reference$$:!0,index:y.add(p.buffer),view:{type:r,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),l=y.buffers.map($=>{const p=new Uint8Array($);return S.$ke.wrap(p)});return{message:k,buffers:l}}else return{message:JSON.stringify(m),buffers:[]}}e.$Tlb=I;function R(m){switch(m.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function L(m,d){const y=d.map(l=>{const $=new ArrayBuffer(l.byteLength);return new Uint8Array($).set(l.buffer),$}),A=d.length?(l,$)=>{if($&&typeof $=="object"&&$.$$vscode_array_buffer_reference$$){const p=$,{index:r}=p,c=y[r];if(p.view)switch(p.view.type){case 1:return new Int8Array(c,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(c,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(c,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(c,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(c,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(c,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(c,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(c,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(c,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(c,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(c,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return c}return $}:void 0;return{message:JSON.parse(m,A),arrayBuffers:y}}e.$Ulb=L}),define(Re[102],Ae([1,0,170,16,2,6,4,30,42,12,41,134,32]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9E=e.$8E=e.$7E=e.EditorsOrder=e.$6E=e.CloseDirection=e.$5E=e.$4E=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$3E=e.$2E=e.$1E=e.$ZE=e.$YE=e.$XE=e.$WE=e.$VE=e.EditorInputCapabilities=e.$UE=e.SaveReason=e.Verbosity=e.$TE=e.$SE=e.$RE=e.$QE=e.$PE=e.$OE=e.$NE=e.$ME=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$LE=e.$KE=e.$JE=e.$IE=e.$HE=void 0,e.$HE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$IE={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$JE="workbench.editor.sidebysideEditor",e.$KE="workbench.editors.textDiffEditor",e.$LE="workbench.editors.binaryResourceDiffEditor";var $;(function(te){te[te.PROGRAMMATIC=1]="PROGRAMMATIC",te[te.USER=2]="USER",te[te.EDIT=3]="EDIT",te[te.NAVIGATION=4]="NAVIGATION",te[te.JUMP=5]="JUMP"})($||(e.EditorPaneSelectionChangeReason=$={}));var p;(function(te){te[te.IDENTICAL=1]="IDENTICAL",te[te.SIMILAR=2]="SIMILAR",te[te.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function r(te){const X=te;return!!X&&typeof X.getSelection=="function"&&!!X.onDidChangeSelection}e.$ME=r;function c(te,X,V){for(const ie of V.visibleEditorPanes)if(ie.group.id===X&&te.matches(ie.input))return ie.getViewState()}e.$NE=c;function s(te){if(b(te))return!1;const X=te;return I.URI.isUri(X?.resource)}e.$OE=s;function i(te){if(b(te))return!1;const X=te;return X?.original!==void 0&&X.modified!==void 0}e.$PE=i;function o(te){if(b(te))return!1;const X=te;return!X||X.resources&&!Array.isArray(X.resources)?!1:!!X.resources||!!X.multiDiffSource}e.$QE=o;function a(te){if(b(te)||i(te))return!1;const X=te;return X?.primary!==void 0&&X.secondary!==void 0}e.$RE=a;function u(te){if(b(te))return!1;const X=te;return X?X.resource===void 0||X.resource.scheme===y.Schemas.untitled||X.forceUntitled===!0:!1}e.$SE=u;function t(te){if(b(te))return!1;const X=te;return I.URI.isUri(X?.base?.resource)&&I.URI.isUri(X?.input1?.resource)&&I.URI.isUri(X?.input2?.resource)&&I.URI.isUri(X?.result?.resource)}e.$TE=t;var f;(function(te){te[te.SHORT=0]="SHORT",te[te.MEDIUM=1]="MEDIUM",te[te.LONG=2]="LONG"})(f||(e.Verbosity=f={}));var n;(function(te){te[te.EXPLICIT=1]="EXPLICIT",te[te.AUTO=2]="AUTO",te[te.FOCUS_CHANGE=3]="FOCUS_CHANGE",te[te.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n||(e.SaveReason=n={}));class w{constructor(){this.a=new Map}registerSource(X,V){let ie=this.a.get(X);return ie||(ie={source:X,label:V},this.a.set(X,ie)),ie.source}getSourceLabel(X){return this.a.get(X)?.label??X}}e.$UE=new w;var D;(function(te){te[te.None=0]="None",te[te.Readonly=2]="Readonly",te[te.Untitled=4]="Untitled",te[te.Singleton=8]="Singleton",te[te.RequiresTrust=16]="RequiresTrust",te[te.CanSplitInGroup=32]="CanSplitInGroup",te[te.ForceDescription=64]="ForceDescription",te[te.CanDropIntoEditor=128]="CanDropIntoEditor",te[te.MultipleEditors=256]="MultipleEditors",te[te.Scratchpad=512]="Scratchpad",te[te.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(D||(e.EditorInputCapabilities=D={}));class h extends R.$Tc{}e.$VE=h;function b(te){return te instanceof h}e.$WE=b;function P(te){const X=te;return I.URI.isUri(X?.preferredResource)}function g(te){const X=te;return b(X?.primary)&&b(X?.secondary)}e.$XE=g;function v(te){const X=te;return b(X?.modified)&&b(X?.original)}e.$YE=v;function E(te,X,V,ie,Ce){return $e(ie,[(0,k.$Ri)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Te={...V,limits:{size:Number.MAX_VALUE}};te.openEditor(X,Te)}}),(0,k.$Ri)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Ce.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}e.$ZE=E;function T(te){return b(te?.editor)}e.$1E=T;function N(te){const X=te;return T(te)&&X?.group!==void 0}e.$2E=N;function J(te){const X=te;return typeof X?.groupId=="number"&&b(X.editor)}e.$3E=J;var q;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.REPLACE=1]="REPLACE",te[te.MOVE=2]="MOVE",te[te.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var U;(function(te){te[te.GROUP_ACTIVE=0]="GROUP_ACTIVE",te[te.GROUP_INDEX=1]="GROUP_INDEX",te[te.GROUP_LABEL=2]="GROUP_LABEL",te[te.GROUP_LOCKED=3]="GROUP_LOCKED",te[te.EDITOR_OPEN=4]="EDITOR_OPEN",te[te.EDITOR_CLOSE=5]="EDITOR_CLOSE",te[te.EDITOR_MOVE=6]="EDITOR_MOVE",te[te.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",te[te.EDITOR_LABEL=8]="EDITOR_LABEL",te[te.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",te[te.EDITOR_PIN=10]="EDITOR_PIN",te[te.EDITOR_STICKY=11]="EDITOR_STICKY",te[te.EDITOR_DIRTY=12]="EDITOR_DIRTY",te[te.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(U||(e.GroupModelChangeKind=U={}));var C;(function(te){te[te.PRIMARY=1]="PRIMARY",te[te.SECONDARY=2]="SECONDARY",te[te.BOTH=3]="BOTH",te[te.ANY=4]="ANY"})(C||(e.SideBySideEditor=C={}));class F{getOriginalUri(X,V){if(!X)return;if(t(X))return e.$5E.getOriginalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ce,secondary:Te}=this.a(X);if(Ce&&Te){if(V?.supportSideBySide===C.BOTH)return{primary:this.getOriginalUri(Ce,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(Te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getOriginalUri(Ce,{filterByScheme:V.filterByScheme})??this.getOriginalUri(Te,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ce:Te}}if(i(X)||o(X)||a(X)||t(X))return;const ie=P(X)?X.preferredResource:X.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}a(X){return g(X)||a(X)?{primary:X.primary,secondary:X.secondary}:v(X)||i(X)?{primary:X.modified,secondary:X.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(X,V){if(!X)return;if(t(X))return e.$5E.getCanonicalUri(X.result,V);if(V?.supportSideBySide){const{primary:Ce,secondary:Te}=this.a(X);if(Ce&&Te){if(V?.supportSideBySide===C.BOTH)return{primary:this.getCanonicalUri(Ce,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(Te,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===C.ANY)return this.getCanonicalUri(Ce,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(Te,{filterByScheme:V.filterByScheme});X=V.supportSideBySide===C.PRIMARY?Ce:Te}}if(i(X)||o(X)||a(X)||t(X))return;const ie=X.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}b(X,V){if(Array.isArray(V)){if(V.some(ie=>X.scheme===ie))return X}else if(V===X.scheme)return X}}var W;(function(te){te[te.UNKNOWN=0]="UNKNOWN",te[te.KEYBOARD=1]="KEYBOARD",te[te.MOUSE=2]="MOUSE"})(W||(e.EditorCloseMethod=W={}));function re(te,X,V,ie){if(!te.isSticky(X))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return V===W.MOUSE||V===W.KEYBOARD;case"mouse":return V===W.MOUSE;case"keyboard":return V===W.KEYBOARD}return!1}e.$4E=re,e.$5E=new F;var ce;(function(te){te[te.LEFT=0]="LEFT",te[te.RIGHT=1]="RIGHT"})(ce||(e.CloseDirection=ce={}));class we{constructor(){this.c=new Map,this.d=new Map}start(X){const V=this.a=X.get(L.$7h);for(const[ie,Ce]of this.c)this.e(ie,Ce,V);this.c.clear()}e(X,V,ie){const Ce=ie.createInstance(V);this.d.set(X,Ce)}registerFileEditorFactory(X){if(this.b)throw new Error("Can only register one file editor factory.");this.b=X}getFileEditorFactory(){return(0,M.$Uf)(this.b)}registerEditorSerializer(X,V){if(this.c.has(X)||this.d.has(X))throw new Error(`A editor serializer with type ID '${X}' was already registered.`);return this.a?this.e(X,V,this.a):this.c.set(X,V),(0,R.$Rc)(()=>{this.c.delete(X),this.d.delete(X)})}getEditorSerializer(X){return this.d.get(typeof X=="string"?X:X.typeId)}}m.$Kn.add(e.$HE.EditorFactory,new we);async function De(te,X,V){return!te||!te.length?[]:await Promise.all(te.map(async ie=>{const Ce=I.URI.revive(ie.fileUri);if(!Ce){V.info("Cannot resolve the path because it is not valid.",ie);return}if(!await X.canHandleResource(Ce)){V.info("Cannot resolve the path because it cannot be handled",ie);return}let Pe=ie.exists,be=ie.type;if(typeof Pe!="boolean"||typeof be!="number")try{be=(await X.stat(Ce)).isDirectory?d.FileType.Directory:d.FileType.Unknown,Pe=!0}catch(G){V.error(G),Pe=!1}if(!Pe&&ie.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ie);return}if(be===d.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ie);return}const ge={...ie.options,pinned:!0};return Pe?{resource:Ce,options:ge}:{resource:Ce,options:ge,forceUntitled:!0}}))}e.$6E=De;var le;(function(te){te[te.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",te[te.SEQUENTIAL=1]="SEQUENTIAL"})(le||(e.EditorsOrder=le={}));function ve(te){const X=te;if(!X)return!1;const V=X;if(V.modified)return ve(V.modified);const ie=X;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$7E=ve;function se(te){return(0,A.$Ti)(te)}e.$8E=se;function $e(te,X,V){const ie=(0,A.$Ui)(te,X);return ie.forceMessage=V?.forceMessage,ie.forceSeverity=V?.forceSeverity,ie.allowDialog=V?.allowDialog,ie}e.$9E=$e}),define(Re[204],Ae([1,0,5,171,4,6,28,30,18,26,89,195]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eF=e.$dF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$cF=e.ViewContentGroups=e.$bF=e.$aF=e.ViewContainerLocation=e.Extensions=e.$_E=e.$$E=e.$0E=void 0,e.$0E="views",e.$$E=(0,M.localize)(0,null),e.$_E=(0,k.$zw)("default-view-icon",A.$bk.window,(0,M.localize)(1,null));var l;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var $;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel",f[f.AuxiliaryBar=2]="AuxiliaryBar"})($||(e.ViewContainerLocation=$={})),e.$aF=[0,1,2];function p(f){switch(f){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$bF=p;class r extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onDidRegister=this.c.event,this.f=this.B(new S.$Wd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,d.$Rb)([...this.g.values()])}registerViewContainer(n,w,D){const h=this.get(n.id);if(h)return h;const b=n;return b.openCommandActionDescriptor=D?.doNotRegisterOpenCommand?void 0:b.openCommandActionDescriptor??{id:b.id},(0,L.$xc)(this.g,w,[]).push(b),D?.isDefault&&this.h.push(b),this.c.fire({viewContainer:b,viewContainerLocation:w}),b}deregisterViewContainer(n){for(const w of this.g.keys()){const D=this.g.get(w),h=D?.indexOf(n);if(h!==-1){D?.splice(h,1),D.length===0&&this.g.delete(w),this.f.fire({viewContainer:n,viewContainerLocation:w});return}}}get(n){return this.all.filter(w=>w.id===n)[0]}getViewContainers(n){return[...this.g.get(n)||[]]}getViewContainerLocation(n){return[...this.g.keys()].filter(w=>this.getViewContainers(w).filter(D=>D?.id===n.id).length>0)[0]}getDefaultViewContainer(n){return this.h.find(w=>this.getViewContainerLocation(w)===n)}}m.$Kn.add(l.ViewContainersRegistry,new r);var c;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(c||(e.ViewContentGroups=c={}));function s(f,n){const w=f.group??c.More,D=n.group??c.More;return w!==D?w.localeCompare(D):(f.order??5)-(n.order??5)}class i extends R.$Tc{constructor(){super(...arguments),this.c=this.B(new S.$Wd),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$Wd),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$Wd),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$Wd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new L.$Gc}registerViews(n,w){this.registerViews2([{views:n,viewContainer:w}])}registerViews2(n){n.forEach(({views:w,viewContainer:D})=>this.r(w,D)),this.c.fire(n)}deregisterViews(n,w){const D=this.s(n,w);D.length&&this.f.fire({views:D,viewContainer:w})}moveViews(n,w){for(const D of this.m.keys())if(D!==w){const h=this.s(n,D);h.length&&(this.r(h,w),this.g.fire({views:h,from:D,to:w}))}}getViews(n){return this.m.get(n)||[]}getView(n){for(const w of this.j){const D=(this.m.get(w)||[]).filter(h=>h.id===n)[0];if(D)return D}return null}getViewContainer(n){for(const w of this.j)if((this.m.get(w)||[]).filter(h=>h.id===n)[0])return w;return null}registerViewWelcomeContent(n,w){return this.n.add(n,w),this.h.fire(n),(0,R.$Rc)(()=>{this.n.delete(n,w),this.h.fire(n)})}registerViewWelcomeContent2(n,w){const D=new Map;for(const[h,b]of w)this.n.add(n,b),D.set(h,(0,R.$Rc)(()=>{this.n.delete(n,b),this.h.fire(n)}));return this.h.fire(n),D}getViewWelcomeContent(n){const w=[];return this.n.forEach(n,D=>w.push(D)),w.sort(s)}r(n,w){let D=this.m.get(w);D||(D=[],this.m.set(w,D),this.j.push(w));for(const h of n){if(this.getView(h.id)!==null)throw new Error((0,M.localize)(2,null,h.id));D.push(h)}}s(n,w){const D=this.m.get(w);if(!D)return[];const h=[],b=[];for(const P of D)n.includes(P)?h.push(P):b.push(P);return h.length&&(b.length?this.m.set(w,b):(this.m.delete(w),this.j.splice(this.j.indexOf(w),1))),h}}m.$Kn.add(l.ViewsRegistry,new i),e.$cF=(0,I.$8h)("viewDescriptorService");var o;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(o||(e.ViewVisibilityState=o={}));var a;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(a||(e.TreeItemCollapsibleState=a={}));class u{constructor(n,w){this.c=!1,this.d=!1,(0,y.$Bn)(this,n),this.d=!!w,this.resolve=async D=>{if(w&&!this.c){const h=await w(D);h&&(this.tooltip=this.tooltip??h.tooltip,this.command=this.command??h.command)}D.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$dF=u;class t extends Error{constructor(n){super((0,M.localize)(3,null,n)),this.name="NoTreeViewError"}static is(n){return n.name==="NoTreeViewError"}}e.$eF=t}),define(Re[205],Ae([1,0,2,29,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oF=e.$nF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$mF=e.$lF=void 0;function R(y){return!!y&&typeof y=="object"&&"uri"in y&&y.uri instanceof S.URI&&"version"in y&&typeof y.version=="number"&&"ranges"in y&&Array.isArray(y.ranges)&&y.ranges.every(M.$Ws.isIRange)}e.$lF=R;function L(y){return!!y&&typeof y=="object"&&"documents"in y&&Array.isArray(y.documents)&&y.documents.every(R)}e.$mF=L;var m;(function(y){y[y.Down=0]="Down",y[y.Up=1]="Up"})(m||(e.InteractiveSessionVoteDirection=m={}));var d;(function(y){y[y.Action=1]="Action",y[y.Toolbar=2]="Toolbar"})(d||(e.ChatAgentCopyKind=d={})),e.$nF=(0,I.$8h)("IChatService"),e.$oF="accessibility.voice.keywordActivation"}),define(Re[206],Ae([1,0,5,11,172]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmb=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new S.$Wd,this.n=new S.$Wd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(m){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=m}onEvent(m){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=m}onRequest(m){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=m}sendResponse(m){m.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${m.command}`)):this.s("response",m)}sendRequest(m,d,y,A){const k={command:m};if(d&&Object.keys(d).length>0&&(k.arguments=d),this.s("request",k),typeof A=="number"){const l=setTimeout(()=>{clearTimeout(l);const $=this.f.get(k.seq);if($){this.f.delete(k.seq);const p={type:"response",seq:0,request_seq:k.seq,success:!1,command:m,message:(0,I.localize)(0,null,A,m)};$(p)}},A)}return y&&this.f.set(k.seq,y),k.seq}acceptMessage(m){this.j?this.j(m):(this.k.push(m),this.k.length===1&&this.q())}o(m,d){return m.type!=="event"||d.type!=="event"}async q(){let m;for(;this.k.length;){if((!m||this.o(this.k[0],m))&&await(0,M.$9g)(0),m=this.k.shift(),!m)return;switch(m.type){case"event":this.i?.(m);break;case"request":this.g?.(m);break;case"response":{const d=m,y=this.f.get(d.request_seq);y&&(this.f.delete(d.request_seq),y(d));break}}}}s(m,d){d.type=m,d.seq=this.d++,this.sendMessage(d)}async u(){if(this.f.size===0)return Promise.resolve();const m=new Map;this.f.forEach((d,y)=>m.set(y,d)),await(0,M.$9g)(500),m.forEach((d,y)=>{d({type:"response",seq:0,request_seq:y,success:!1,command:"canceled",message:"canceled"}),this.f.delete(y)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$nmb=R}),define(Re[207],Ae([1,0,2,173,35,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$WH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$VH=e.MemoryRangeType=e.$UH=e.State=e.$TH=e.$SH=e.$RH=e.$QH=e.$PH=e.$OH=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=void 0,e.$OG="workbench.view.debug",e.$PG="workbench.debug.variablesView",e.$QG="workbench.debug.watchExpressionsView",e.$RG="workbench.debug.callStackView",e.$SG="workbench.debug.loadedScriptsView",e.$TG="workbench.debug.breakPointsView",e.$UG="workbench.debug.disassemblyView",e.$VG="workbench.panel.repl",e.$WG="workbench.panel.repl.view",e.$XG=new I.$mj("debugType",void 0,{type:"string",description:M.localize(0,null)}),e.$YG=new I.$mj("debugConfigurationType",void 0,{type:"string",description:M.localize(1,null)}),e.$ZG=new I.$mj("debugState","inactive",{type:"string",description:M.localize(2,null)}),e.$1G="debugUx",e.$2G=new I.$mj(e.$1G,"default",{type:"string",description:M.localize(3,null)}),e.$3G=new I.$mj("hasDebugged",!1,{type:"boolean",description:M.localize(4,null)}),e.$4G=new I.$mj("inDebugMode",!1,{type:"boolean",description:M.localize(5,null)}),e.$5G=new I.$mj("inDebugRepl",!1,{type:"boolean",description:M.localize(6,null)}),e.$6G=new I.$mj("breakpointWidgetVisible",!1,{type:"boolean",description:M.localize(7,null)}),e.$7G=new I.$mj("inBreakpointWidget",!1,{type:"boolean",description:M.localize(8,null)}),e.$8G=new I.$mj("breakpointsFocused",!0,{type:"boolean",description:M.localize(9,null)}),e.$9G=new I.$mj("watchExpressionsFocused",!0,{type:"boolean",description:M.localize(10,null)}),e.$0G=new I.$mj("watchExpressionsExist",!1,{type:"boolean",description:M.localize(11,null)}),e.$$G=new I.$mj("variablesFocused",!0,{type:"boolean",description:M.localize(12,null)}),e.$_G=new I.$mj("expressionSelected",!1,{type:"boolean",description:M.localize(13,null)}),e.$aH=new I.$mj("breakpointInputFocused",!1,{type:"boolean",description:M.localize(14,null)}),e.$bH=new I.$mj("callStackItemType",void 0,{type:"string",description:M.localize(15,null)}),e.$cH=new I.$mj("callStackSessionIsAttach",!1,{type:"boolean",description:M.localize(16,null)}),e.$dH=new I.$mj("callStackItemStopped",!1,{type:"boolean",description:M.localize(17,null)}),e.$eH=new I.$mj("callStackSessionHasOneThread",!1,{type:"boolean",description:M.localize(18,null)}),e.$fH=new I.$mj("watchItemType",void 0,{type:"string",description:M.localize(19,null)}),e.$gH=new I.$mj("canViewMemory",void 0,{type:"boolean",description:M.localize(20,null)}),e.$hH=new I.$mj("breakpointItemType",void 0,{type:"string",description:M.localize(21,null)}),e.$iH=new I.$mj("breakpointSupportsCondition",!1,{type:"boolean",description:M.localize(22,null)}),e.$jH=new I.$mj("loadedScriptsSupported",!1,{type:"boolean",description:M.localize(23,null)}),e.$kH=new I.$mj("loadedScriptsItemType",void 0,{type:"string",description:M.localize(24,null)}),e.$lH=new I.$mj("focusedSessionIsAttach",!1,{type:"boolean",description:M.localize(25,null)}),e.$mH=new I.$mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:M.localize(26,null)}),e.$nH=new I.$mj("stepBackSupported",!1,{type:"boolean",description:M.localize(27,null)}),e.$oH=new I.$mj("restartFrameSupported",!1,{type:"boolean",description:M.localize(28,null)}),e.$pH=new I.$mj("stackFrameSupportsRestart",!1,{type:"boolean",description:M.localize(29,null)}),e.$qH=new I.$mj("jumpToCursorSupported",!1,{type:"boolean",description:M.localize(30,null)}),e.$rH=new I.$mj("stepIntoTargetsSupported",!1,{type:"boolean",description:M.localize(31,null)}),e.$sH=new I.$mj("breakpointsExist",!1,{type:"boolean",description:M.localize(32,null)}),e.$tH=new I.$mj("debuggersAvailable",!1,{type:"boolean",description:M.localize(33,null)}),e.$uH=new I.$mj("debugExtensionAvailable",!0,{type:"boolean",description:M.localize(34,null)}),e.$vH=new I.$mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:M.localize(35,null)}),e.$wH=new I.$mj("debugSetVariableSupported",!1,{type:"boolean",description:M.localize(36,null)}),e.$xH=new I.$mj("debugSetExpressionSupported",!1,{type:"boolean",description:M.localize(37,null)}),e.$yH=new I.$mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:M.localize(38,null)}),e.$zH=new I.$mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:M.localize(39,null)}),e.$AH=new I.$mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:M.localize(40,null)}),e.$BH=new I.$mj("terminateDebuggeeSupported",!1,{type:"boolean",description:M.localize(41,null)}),e.$CH=new I.$mj("suspendDebuggeeSupported",!1,{type:"boolean",description:M.localize(42,null)}),e.$DH=new I.$mj("variableEvaluateNamePresent",!1,{type:"boolean",description:M.localize(43,null)}),e.$EH=new I.$mj("variableIsReadonly",!1,{type:"boolean",description:M.localize(44,null)}),e.$FH=new I.$mj("variableValue",!1,{type:"string",description:M.localize(45,null)}),e.$GH=new I.$mj("variableType",!1,{type:"string",description:M.localize(46,null)}),e.$HH=new I.$mj("variableName",!1,{type:"string",description:M.localize(47,null)}),e.$IH=new I.$mj("exceptionWidgetVisible",!1,{type:"boolean",description:M.localize(48,null)}),e.$JH=new I.$mj("multiSessionRepl",!1,{type:"boolean",description:M.localize(49,null)}),e.$KH=new I.$mj("multiSessionDebug",!1,{type:"boolean",description:M.localize(50,null)}),e.$LH=new I.$mj("disassembleRequestSupported",!1,{type:"boolean",description:M.localize(51,null)}),e.$MH=new I.$mj("disassemblyViewFocus",!1,{type:"boolean",description:M.localize(52,null)}),e.$NH=new I.$mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:M.localize(53,null)}),e.$OH=new I.$mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:M.localize(54,null)});const L=r=>M.localize(55,null,r);e.$PH=L,e.$QH="editor.contrib.debug",e.$RH="editor.contrib.breakpoint",e.$SH="debug",e.$TH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:M.localize(56,null)};var m;(function(r){r[r.Inactive=0]="Inactive",r[r.Initializing=1]="Initializing",r[r.Stopped=2]="Stopped",r[r.Running=3]="Running"})(m||(e.State=m={}));function d(r){switch(r){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$UH=d;var y;(function(r){r[r.Valid=0]="Valid",r[r.Unreadable=1]="Unreadable",r[r.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.$VH="vscode-debug-memory";var A;(function(r){r[r.Initial=1]="Initial",r[r.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var k;(function(r){r.UnverifiedBreakpoints="unverifiedBreakpoints"})(k||(e.DebuggerString=k={})),e.$WH=(0,R.$8h)("debugService");var l;(function(r){r[r.CONDITION=0]="CONDITION",r[r.HIT_COUNT=1]="HIT_COUNT",r[r.LOG_MESSAGE=2]="LOG_MESSAGE",r[r.TRIGGER_POINT=3]="TRIGGER_POINT"})(l||(e.BreakpointWidgetContext=l={}));var $;(function(r){r[r.Command=0]="Command",r[r.Tree=1]="Tree"})($||(e.DebugVisualizationType=$={}));var p;(function(r){r.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:S.URI.revive(c.iconPath.light),dark:S.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),r.serialize=c=>c})(p||(e.IDebugVisualization=p={}))}),define(Re[208],Ae([1,0,14,2,19,26,12,29,21,18]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=void 0;const A=/{([^}]+)}/g;function k(P,g,v){return P.replace(A,function(E,T){return g&&T.length>0&&T[0]!=="_"?E:v&&v.hasOwnProperty(T)?v[T]:E})}e.$dG=k;function l(P){const g={};for(const v of Object.keys(P))v.startsWith("!")||(g[v]=P[v]);return g}e.$eG=l;function $(P){return P.configuration.request==="attach"&&!p(P)&&(!P.parentSession||$(P.parentSession))}e.$fG=$;function p(P){let g=P.configuration.type;if(g)return g==="vslsShare"&&(g=P.configuration.adapterProxy.configuration.type),(0,S.$af)(g,"extensionhost")||(0,S.$af)(g,"pwa-extensionhost")?P:P.parentSession?p(P.parentSession):void 0}e.$gG=p;function r(P){return P.type&&(P.label||P.program||P.runtime)}e.$hG=r;function c(P,g,v){let E,T=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let J=null;for(;J=N.exec(P);){const q=J.index+1,U=q+J[0].length;if(q<=g&&U>=v){E=J[0],T=q;break}}if(E){const q=/\w+/g;let U=null;for(;(U=q.exec(E))&&!(U.index+1+T+U[0].length>=v););U&&(E=E.substring(0,q.lastIndex))}return E?{start:T,end:T+E.length-1}:{start:0,end:0}}e.$iG=c;async function s(P,g,v,E){if(P.evaluatableExpressionProvider.has(g)){const T=P.evaluatableExpressionProvider.ordered(g),N=(0,y.$Hb)(await Promise.all(T.map(async J=>{try{return await J.provideEvaluatableExpression(g,v,E??d.CancellationToken.None)}catch{return}})));if(N.length>0){let J=N[0].expression;const q=N[0].range;return J||(J=g.getLineContent(v.lineNumber).substring(q.startColumn-1,q.endColumn-1)),{range:q,matchingExpression:J}}}else{const T=g.getLineContent(v.lineNumber),{start:N,end:J}=c(T,v.column,v.column),q=T.substring(N-1,J);return{matchingExpression:q,range:new m.$Ws(v.lineNumber,N,v.lineNumber,N+q.length)}}return null}e.$jG=s;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function o(P){return!!(P&&P.match(i))}e.$kG=o;function a(P){if(typeof P.path=="string"&&!(typeof P.sourceReference=="number"&&P.sourceReference>0)){if(o(P.path))return M.URI.parse(P.path);if((0,I.$ic)(P.path))return M.URI.file(P.path)}return P.path}function u(P){if(typeof P.path=="object"){const g=M.URI.revive(P.path);if(g)return g.scheme===L.Schemas.file?g.fsPath:g.toString()}return P.path}function t(P,g){const v=g?a:u,E=(0,R.$yn)(P);return n(E,(T,N)=>{T&&N&&(N.path=v(N))}),E}e.$lG=t;function f(P,g){const v=g?a:u,E=(0,R.$yn)(P);return n(E,(T,N)=>{!T&&N&&(N.path=v(N))}),E}e.$mG=f;function n(P,g){switch(P.type){case"event":{const v=P;switch(v.event){case"output":g(!1,v.body.source);break;case"loadedSource":g(!1,v.body.source);break;case"breakpoint":g(!1,v.body.breakpoint.source);break;default:break}break}case"request":{const v=P;switch(v.command){case"setBreakpoints":g(!0,v.arguments.source);break;case"breakpointLocations":g(!0,v.arguments.source);break;case"source":g(!0,v.arguments.source);break;case"gotoTargets":g(!0,v.arguments.source);break;case"launchVSCode":v.arguments.args.forEach(E=>g(!1,E));break;default:break}break}case"response":{const v=P;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(E=>g(!1,E.source));break;case"loadedSources":v.body.sources.forEach(E=>g(!1,E));break;case"scopes":v.body.scopes.forEach(E=>g(!1,E.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(E=>g(!1,E.source));break;case"setBreakpoints":v.body.breakpoints.forEach(E=>g(!1,E.source));break;case"disassemble":v.body?.instructions.forEach(T=>g(!1,T.location));break;default:break}break}}}function w(P){return P.filter(g=>!g.presentation?.hidden).sort((g,v)=>g.presentation?v.presentation?g.presentation.group?v.presentation.group?g.presentation.group!==v.presentation.group?g.presentation.group.localeCompare(v.presentation.group):D(g.presentation.order,v.presentation.order):-1:v.presentation.group?1:D(g.presentation.order,v.presentation.order):-1:v.presentation?1:0)}e.$nG=w;function D(P,g){return typeof P!="number"?typeof g!="number"?0:1:typeof g!="number"?-1:P-g}async function h(P,g){const v=P.getValue("debug.saveBeforeStart",{overrideIdentifier:g.activeTextEditorLanguageId});if(v!=="none"&&(await g.saveAll(),v==="allEditorsInActiveGroup")){const E=g.activeEditorPane;E&&E.input.resource?.scheme===L.Schemas.untitled&&await g.save({editor:E.input,groupId:E.group.id})}await P.reloadConfiguration()}e.$oG=h;const b=(P,g)=>!P||!g?P===g:P.name===g.name&&P.path===g.path&&P.sourceReference===g.sourceReference;e.$pG=b}),define(Re[209],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sJ=e.CellExecutionUpdateType=void 0;var M;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(M||(e.CellExecutionUpdateType=M={})),e.$sJ=(0,S.$8h)("INotebookExecutionService")}),define(Re[210],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pfb=e.$Ofb=e.ProxyKernelState=e.$Nfb=void 0,e.$Nfb=100;var M;(function(I){I[I.Disconnected=1]="Disconnected",I[I.Connected=2]="Connected",I[I.Initializing=3]="Initializing"})(M||(e.ProxyKernelState=M={})),e.$Ofb=(0,S.$8h)("INotebookKernelService"),e.$Pfb=(0,S.$8h)("INotebookKernelHistoryService")}),define(Re[211],Ae([1,0,6,29,144,93]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WRb=void 0;class L extends S.$Tc{constructor(d,y,A){super(),this._source=d,this.b=y,this.c=A,this.a=void 0}f(d){const y=d.getLineCount();return new M.$Ws(1,1,y,this.g(d,y))}g(d,y){if(y<1||y>d.getLineCount())throw new Error("Illegal value for lineNumber");return d.getLineLength(y)+1}get inputTextBuffer(){if(!this.b){const d=new I.$eC;d.acceptChunk(this._source);const y=d.finish(!0),{textBuffer:A,disposable:k}=y.create(1);this.b=A,this.B(k)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(d=>{const y=new I.$eC;y.acceptChunk(d);const A=y.finish(!0),{textBuffer:k,disposable:l}=A.create(1);return this.B(l),k})),this.a}findInInputs(d){const A=new R.$5B(d,!1,!1,null).parseSearchRequest();if(!A)return[];const k=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(k,A,!0,5e3)}findInOutputs(d){const A=new R.$5B(d,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(k=>{const l=k.findMatchesLineByLine(this.f(k),A,!0,5e3);if(l.length!==0)return{textBuffer:k,matches:l}}).filter(k=>!!k):[]}}e.$WRb=L}),define(Re[49],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dK=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(R){R.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var M;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(M||(e.TestPosition=M={}));class I{static fromExtHostTestItem(L,m,d=L.parent){if(L._isRoot)return new I([m]);const y=[L.id];for(let A=d;A&&A.id!==m;A=A.parent)y.push(A.id);return y.push(m),new I(y.reverse())}static isRoot(L){return!L.includes("\0")}static root(L){const m=L.indexOf("\0");return m===-1?L:L.slice(0,m)}static fromString(L){return new I(L.split("\0"))}static join(L,m){return new I([...L.path,m])}static joinToString(L,m){return L.toString()+"\0"+m}static parentId(L){const m=L.lastIndexOf("\0");return m===-1?void 0:L.slice(0,m)}static localId(L){const m=L.lastIndexOf("\0");return m===-1?L:L.slice(m+1)}static isChild(L,m){return m.startsWith(L)&&m[L.length]==="\0"}static compare(L,m){return L===m?0:I.isChild(L,m)?2:I.isChild(m,L)?3:1}constructor(L,m=L.length){if(this.path=L,this.d=m,L.length===0||m<1)throw new Error("cannot create test with empty path")}get rootId(){return new I(this.path,1)}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let L=1;L<=this.d;L++)yield new I(this.path,L)}*idsToRoot(){for(let L=this.d;L>0;L--)yield new I(this.path,L)}compare(L){if(typeof L=="string")return I.compare(this.toString(),L);for(let m=0;m<L.d&&m<this.d;m++)if(L.path[m]!==this.path[m])return 1;return L.d>this.d?2:L.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let L=1;L<this.d;L++)this.c+="\0",this.c+=this.path[L]}return this.c}}e.$dK=I}),define(Re[59],Ae([1,0,2,91,29,49]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$kK=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$jK=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$iK=e.$hK=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$gK=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$fK=e.$eK=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(C){C[C.Unset=0]="Unset",C[C.Queued=1]="Queued",C[C.Running=2]="Running",C[C.Passed=3]="Passed",C[C.Failed=4]="Failed",C[C.Skipped=5]="Skipped",C[C.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var m;(function(C){C[C.Run=1]="Run",C[C.Debug=2]="Debug",C[C.Coverage=3]="Coverage"})(m||(e.ExtTestRunProfileKind=m={}));var d;(function(C){C[C.Run=2]="Run",C[C.Debug=4]="Debug",C[C.Coverage=8]="Coverage",C[C.HasNonDefaultProfile=16]="HasNonDefaultProfile",C[C.HasConfigurable=32]="HasConfigurable",C[C.SupportsContinuousRun=64]="SupportsContinuousRun"})(d||(e.TestRunProfileBitset=d={})),e.$eK=[2,4,8,16,32,64];const y=C=>"runId"in C;e.$fK=y;var A;(function(C){C.serialize=F=>({range:F.range.toJSON(),uri:F.uri.toJSON()}),C.deserialize=(F,W)=>({range:I.$Ws.lift(W.range),uri:F.asCanonicalUri(S.URI.revive(W.uri))})})(A||(e.IRichLocation=A={}));var k;(function(C){C[C.Error=0]="Error",C[C.Output=1]="Output"})(k||(e.TestMessageType=k={}));var l;(function(C){C.serialize=F=>({message:F.message,type:0,expected:F.expected,actual:F.actual,contextValue:F.contextValue,location:F.location&&A.serialize(F.location)}),C.deserialize=(F,W)=>({message:W.message,type:0,expected:W.expected,actual:W.actual,contextValue:W.contextValue,location:W.location&&A.deserialize(F,W.location)})})(l||(e.ITestErrorMessage=l={}));const $=(C,F)=>`${F?"s":"e"}${C}`;e.$gK=$;var p;(function(C){C.serialize=F=>({message:F.message,type:1,offset:F.offset,length:F.length,location:F.location&&A.serialize(F.location)}),C.deserialize=(F,W)=>({message:W.message,type:1,offset:W.offset,length:W.length,location:W.location&&A.deserialize(F,W.location)})})(p||(e.ITestOutputMessage=p={}));var r;(function(C){C.serialize=F=>F.type===0?l.serialize(F):p.serialize(F),C.deserialize=(F,W)=>W.type===0?l.deserialize(F,W):p.deserialize(F,W)})(r||(e.ITestMessage=r={}));var c;(function(C){C.serializeWithoutMessages=F=>({state:F.state,duration:F.duration,messages:[]}),C.serialize=F=>({state:F.state,duration:F.duration,messages:F.messages.map(r.serialize)}),C.deserialize=(F,W)=>({state:W.state,duration:W.duration,messages:W.messages.map(re=>r.deserialize(F,re))})})(c||(e.ITestTaskState=c={}));const s="\0",i=(C,F)=>C+s+F;e.$hK=i;const o=C=>{const F=C.indexOf(s);return{ctrlId:C.slice(0,F),tagId:C.slice(F+1)}};e.$iK=o;var a;(function(C){C.serialize=F=>({extId:F.extId,label:F.label,tags:F.tags,busy:F.busy,children:void 0,uri:F.uri?.toJSON(),range:F.range?.toJSON()||null,description:F.description,error:F.error,sortText:F.sortText}),C.deserialize=(F,W)=>({extId:W.extId,label:W.label,tags:W.tags,busy:W.busy,children:void 0,uri:W.uri?F.asCanonicalUri(S.URI.revive(W.uri)):void 0,range:W.range?I.$Ws.lift(W.range):null,description:W.description,error:W.error,sortText:W.sortText})})(a||(e.ITestItem=a={}));var u;(function(C){C[C.NotExpandable=0]="NotExpandable",C[C.Expandable=1]="Expandable",C[C.BusyExpanding=2]="BusyExpanding",C[C.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var t;(function(C){C.serialize=F=>({expand:F.expand,item:a.serialize(F.item)}),C.deserialize=(F,W)=>({controllerId:R.$dK.root(W.item.extId),expand:W.expand,item:a.deserialize(F,W.item)})})(t||(e.InternalTestItem=t={}));var f;(function(C){C.serialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.uri!==void 0&&(W.uri=F.item.uri?.toJSON()),F.item.range!==void 0&&(W.range=F.item.range?.toJSON()),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}},C.deserialize=F=>{let W;return F.item&&(W={},F.item.label!==void 0&&(W.label=F.item.label),F.item.tags!==void 0&&(W.tags=F.item.tags),F.item.busy!==void 0&&(W.busy=F.item.busy),F.item.range!==void 0&&(W.range=F.item.range?I.$Ws.lift(F.item.range):null),F.item.description!==void 0&&(W.description=F.item.description),F.item.error!==void 0&&(W.error=F.item.error),F.item.sortText!==void 0&&(W.sortText=F.item.sortText)),{extId:F.extId,expand:F.expand,item:W}}})(f||(e.ITestItemUpdate=f={}));const n=(C,F)=>{F.expand!==void 0&&(C.expand=F.expand),F.item!==void 0&&(C.item=C.item?Object.assign(C.item,F.item):F.item)};e.$jK=n;var w;(function(C){C.serializeWithoutMessages=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(c.serializeWithoutMessages)}),C.serialize=F=>({...t.serialize(F),ownComputedState:F.ownComputedState,computedState:F.computedState,tasks:F.tasks.map(c.serialize)}),C.deserialize=(F,W)=>({...t.deserialize(F,W),ownComputedState:W.ownComputedState,computedState:W.computedState,tasks:W.tasks.map(re=>c.deserialize(F,re)),retired:!0})})(w||(e.TestResultItem=w={}));var D;(function(C){C.empty=()=>({covered:0,total:0}),C.sum=(F,W)=>{F.covered+=W.covered,F.total+=W.total}})(D||(e.ICoveredCount=D={}));var h;(function(C){C.serialize=F=>({statement:F.statement,branch:F.branch,declaration:F.declaration,details:F.details?.map(v.serialize),uri:F.uri.toJSON()}),C.deserialize=(F,W)=>({statement:W.statement,branch:W.branch,declaration:W.declaration,details:W.details?.map(v.deserialize),uri:F.asCanonicalUri(S.URI.revive(W.uri))})})(h||(e.IFileCoverage=h={}));function b(C){return{...C,location:C.location?.toJSON()}}function P(C){return C.location=C.location?M.$Vs.isIPosition(C.location)?M.$Vs.lift(C.location):I.$Ws.lift(C.location):void 0,C}e.$kK=3;var g;(function(C){C[C.Declaration=0]="Declaration",C[C.Statement=1]="Statement",C[C.Branch=2]="Branch"})(g||(e.DetailType=g={}));var v;(function(C){C.serialize=F=>F.type===0?T.serialize(F):N.serialize(F),C.deserialize=F=>F.type===0?T.deserialize(F):N.deserialize(F)})(v||(e.CoverageDetails=v={}));var E;(function(C){C.serialize=b,C.deserialize=P})(E||(e.IBranchCoverage=E={}));var T;(function(C){C.serialize=b,C.deserialize=P})(T||(e.IDeclarationCoverage=T={}));var N;(function(C){C.serialize=F=>({...b(F),branches:F.branches?.map(E.serialize)}),C.deserialize=F=>({...P(F),branches:F.branches?.map(E.deserialize)})})(N||(e.IStatementCoverage=N={}));var J;(function(C){C[C.Add=0]="Add",C[C.Update=1]="Update",C[C.DocumentSynced=2]="DocumentSynced",C[C.Remove=3]="Remove",C[C.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",C[C.Retire=5]="Retire",C[C.AddTag=6]="AddTag",C[C.RemoveTag=7]="RemoveTag"})(J||(e.TestDiffOpType=J={}));var q;(function(C){C.deserialize=(F,W)=>W.op===0?{op:W.op,item:t.deserialize(F,W.item)}:W.op===1?{op:W.op,item:f.deserialize(W.item)}:W.op===2?{op:W.op,uri:F.asCanonicalUri(S.URI.revive(W.uri)),docv:W.docv}:W,C.serialize=F=>F.op===0?{op:F.op,item:t.serialize(F.item)}:F.op===1?{op:F.op,item:f.serialize(F.item)}:F})(q||(e.TestsDiffOp=q={}));class U{constructor(F){this.k=F,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(F){const W=this.v();for(const re of F)switch(re.op){case 0:this.l(t.deserialize(this.k,re.item),W);break;case 1:this.o(f.deserialize(re.item),W);break;case 3:this.p(re.itemId,W);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}W.complete?.()}l(F,W){const re=R.$dK.parentId(F.item.extId)?.toString();let ce;if(!re)ce=this.w(F),this.g.add(ce),this.f.set(F.item.extId,ce);else if(this.f.has(re)){const we=this.f.get(re);we.children.add(F.item.extId),ce=this.w(F,we),this.f.set(F.item.extId,ce)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(F)}`);return}return W.add?.(ce),F.expand===2&&this.h++,ce}o(F,W){const re=this.f.get(F.extId);if(re)return F.expand!==void 0&&(re.expand===2&&this.h--,F.expand===2&&this.h++),(0,e.$jK)(re,F),W.update?.(re),re}p(F,W){const re=this.f.get(F);if(!re)return;const ce=R.$dK.parentId(re.item.extId)?.toString();ce?this.f.get(ce).children.delete(re.item.extId):this.g.delete(re);const we=[[F]];for(;we.length;)for(const De of we.pop()){const le=this.f.get(De);le&&(we.push(le.children),this.f.delete(De),W.remove?.(le,le!==re),le.expand===2&&this.h--)}}q(F){}updatePendingRoots(F){this.j+=F}v(){return{}}}e.$lK=U}),define(Re[75],Ae([1,0,11,5,6,54,59,49]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=e.$oN=e.$nN=e.$mN=e.TestItemEventOp=void 0;var d;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})(d||(e.TestItemEventOp=d={}));const y=(i,o)=>i===o,k=Object.entries({range:(i,o)=>i===o?!0:!i||!o?!1:i.equalsRange(o),busy:y,label:y,description:y,error:y,sortText:y,tags:(i,o)=>!(i.length!==o.length||i.some(a=>!o.includes(a)))}),l=(i,o)=>{let a;for(const[u,t]of k)t(i[u],o[u])||(a?a[u]=o[u]:a={[u]:o[u]});return a};class $ extends I.$Tc{get root(){return this.s.root}constructor(o){super(),this.s=o,this.f=this.B(new S.$hh(()=>this.flushDiff(),200)),this.g=this.B(new M.$Wd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(o){this.h=o;for(const a of this.tree.values())this.J(a)}get resolveHandler(){return this.h}collectDiff(){const o=this.m;return this.m=[],o}pushDiff(o){switch(o.op){case 2:{for(const a of this.m)if(a.op===2&&a.uri===o.uri){a.docv=o.docv;return}break}case 1:{const a=this.m[this.m.length-1];if(a){if(a.op===1&&a.item.extId===o.item.extId){(0,L.$jK)(a.item,o.item);return}if(a.op===0&&a.item.item.extId===o.item.extId){(0,L.$jK)(a.item,o.item);return}}break}}this.m.push(o),this.f.isScheduled()||this.f.schedule()}expand(o,a){const u=this.tree.get(o);if(u){if((u.expandLevels===void 0||a>u.expandLevels)&&(u.expandLevels=a),u.expand===1){const t=this.M(u);return t.isOpen()?this.L(u,a-1):t.wait().then(()=>this.L(u,a-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,a-1)):this.L(u,a-1)}}dispose(){for(const o of this.tree.values())this.s.getApiFor(o.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(o,a){switch(a.op){case 3:this.O(m.$dK.joinToString(o.fullId,a.id));break;case 0:this.z(a.item,o);break;case 5:for(const u of a.ops)this.w(o,u);break;case 1:this.C(a.new,a.old,o.fullId.toString());break;case 2:this.J(o);break;case 4:this.pushDiff({op:1,item:{extId:o.fullId.toString(),item:a.update}});break;case 6:this.y(o.actual.uri);break;default:(0,R.$6c)(a)}}y(o){o&&this.pushDiff({op:2,uri:o,docv:this.s.getDocumentVersion(o)})}z(o,a){const u=m.$dK.fromExtHostTestItem(o,this.root.id,a?.actual),t=this.s.getApiFor(o);t.parent&&t.parent!==a?.actual&&this.s.getChildren(t.parent).delete(o.id);let f=this.tree.get(u.toString());if(!f){f={fullId:u,actual:o,expandLevels:a?.expandLevels?a.expandLevels-1:void 0,expand:0},o.tags.forEach(this.D,this),this.tree.set(f.fullId.toString(),f),this.G(o,a),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:f.expand,item:this.s.toITestItem(o)}}),this.I(o,f,a);return}if(f.actual===o){this.H(o,f,a);return}if(f.actual.uri?.toString()!==o.uri?.toString())return this.O(u.toString()),this.z(o,a);const n=this.s.getChildren(f.actual),w=f.actual,D=l(this.s.toITestItem(w),this.s.toITestItem(o));this.s.getApiFor(w).listener=void 0,f.actual=o,f.expand=0,D&&(D.hasOwnProperty("tags")&&(this.C(o.tags,w.tags,u.toString()),delete D.tags),this.w(f,{op:4,update:D})),this.I(o,f,a);for(const[h,b]of n)this.s.getChildren(o).get(b.id)||this.O(m.$dK.joinToString(u,b.id));this.y(f.actual.uri)}C(o,a,u){const t=new Set(a.map(f=>f.id));for(const f of o)t.delete(f.id)||this.D(f);this.pushDiff({op:1,item:{extId:u,item:{tags:o.map(f=>(0,L.$hK)(this.s.controllerId,f.id))}}}),t.forEach(this.F,this)}D(o){const a=this.j.get(o.id);a?a.refCount++:(this.j.set(o.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,L.$hK)(this.s.controllerId,o.id)}}))}F(o){const a=this.j.get(o);a&&!--a.refCount&&(this.j.delete(o),this.pushDiff({op:7,id:(0,L.$hK)(this.s.controllerId,o)}))}G(o,a){this.s.getApiFor(o).parent=a&&a.actual!==this.root?a.actual:void 0}H(o,a,u){this.G(o,u);const t=this.s.getApiFor(o);t.parent=u?.actual,t.listener=f=>this.w(a,f),this.J(a)}I(o,a,u){this.H(o,a,u);for(const[t,f]of this.s.getChildren(o))this.z(f,a)}J(o){let a;this.h?o.resolveBarrier?a=o.resolveBarrier.isOpen()?3:2:a=o.actual.canResolveChildren?1:0:a=0,a!==o.expand&&(o.expand=a,this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:a}}),a===1&&o.expandLevels!==void 0&&this.M(o))}L(o,a){if(a<0)return;const u=[];for(const[t,f]of this.s.getChildren(o.actual)){const n=this.expand(m.$dK.joinToString(o.fullId,f.id),a);(0,S.$Tg)(n)&&u.push(n)}if(u.length)return Promise.all(u).then(()=>{})}M(o){if(o.resolveBarrier)return o.resolveBarrier;if(!this.h){const f=new S.$7g;return f.open(),f}o.expand=2,this.N(o);const a=o.resolveBarrier=new S.$7g,u=f=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,f)};let t;try{t=this.h(o.actual===this.root?void 0:o.actual)}catch(f){u(f)}return(0,S.$Tg)(t)?t.catch(u).then(()=>{a.open(),this.J(o)}):(a.open(),this.J(o)),o.resolveBarrier}N(o){this.pushDiff({op:1,item:{extId:o.fullId.toString(),expand:o.expand}})}O(o){const a=this.tree.get(o);if(!a)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:o});const u=[a];for(;u.length;){const t=u.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const f of t.actual.tags)this.F(f.id);this.tree.delete(t.fullId.toString());for(const[f,n]of this.s.getChildren(t.actual))u.push(this.tree.get(m.$dK.joinToString(t.fullId,n.id)))}}}flushDiff(){const o=this.collectDiff();o.length&&this.g.fire(o)}}e.$mN=$;class p extends Error{constructor(o){super(`Attempted to insert a duplicate test item ID ${o}`)}}e.$nN=p;class r extends Error{constructor(o){super(`TestItem with ID "${o}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$oN=r;class c extends Error{constructor(o,a,u){super(`TestItem with ID "${o}" is from controller "${a}" and cannot be added as a child of an item from controller "${u}".`)}}e.$pN=c;const s=(i,o,a)=>{let u=new Map;return{get size(){return u.size},forEach(t,f){for(const n of u.values())t.call(f,n,this)},[Symbol.iterator](){return u.entries()},replace(t){const f=new Map,n=new Set(u.keys()),w={op:5,ops:[]};for(const D of t){if(!(D instanceof a))throw new r(D.id);const h=o(D).controllerId;if(h!==i.controllerId)throw new c(D.id,h,i.controllerId);if(f.has(D.id))throw new p(D.id);f.set(D.id,D),n.delete(D.id),w.ops.push({op:0,item:D})}for(const D of n.keys())w.ops.push({op:3,id:D});i.listener?.(w),u=f},add(t){if(!(t instanceof a))throw new r(t.id);u.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){u.delete(t)&&i.listener?.({op:3,id:t})},get(t){return u.get(t)},toJSON(){return Array.from(u.values())}}};e.$qN=s}),define(Re[103],Ae([1,0,75]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sN=e.$rN=void 0;const M=new WeakMap,I=(L,m)=>{const d={controllerId:m};return M.set(L,d),d};e.$rN=I;const R=L=>{const m=M.get(L);if(!m)throw new S.$oN(L?.id||"<unknown>");return m};e.$sN=R}),define(Re[76],Ae([1,0,12,2]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dwb=e.$Cwb=e.$Bwb=e.$Awb=e.$zwb=void 0,e.$zwb="vscode-cdn.net",e.$Awb=`vscode-resource.${e.$zwb}`,e.$Bwb=`'self' https://*.${e.$zwb}`;function I(m,d){return m.scheme===S.Schemas.http||m.scheme===S.Schemas.https?m:(d&&d.authority&&d.isRemote&&m.scheme===S.Schemas.file&&(m=M.URI.from({scheme:S.Schemas.vscodeRemote,authority:d.authority,path:m.path})),M.URI.from({scheme:S.Schemas.https,authority:`${m.scheme}+${R(m.authority)}.${e.$Awb}`,path:m.path,fragment:m.fragment,query:m.query}))}e.$Cwb=I;function R(m){return m.replace(/./g,d=>{const y=d.charCodeAt(0);return y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57?d:"-"+y.toString(16).padStart(4,"0")})}function L(m){return m.replace(/-([0-9a-f]{4})/g,(d,y)=>String.fromCharCode(parseInt(y,16)))}e.$Dwb=L}),define(Re[212],Ae([1,0,5,6,76]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class R{constructor(m,d,y){this.d=m,this.e=d,this.f=y,this.a=0,this.b=new M.$Sc,this.c=new Map,this.b.add(d.onDidChangeVisibleTextEditors(()=>{const A=d.getVisibleTextEditors();for(const k of this.c.values())A.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(m=>m.inset.dispose()),this.b.dispose()}createWebviewEditorInset(m,d,y,A,k){let l;for(const o of this.e.getVisibleTextEditors(!0))if(o.value===m){l=o;break}if(!l)throw new Error("not a visible editor");const $=this,p=this.a++,r=new S.$Wd,c=new S.$Wd,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(o){return(0,I.$Cwb)(o,$.f)}get cspSource(){return I.$Bwb}set options(o){this.b=o,$.d.$setOptions(p,o)}get options(){return this.b}set html(o){this.a=o,$.d.$setHtml(p,o)}get html(){return this.a}get onDidReceiveMessage(){return r.event}postMessage(o){return $.d.$postMessage(p,o)}},i=new class{constructor(){this.editor=m,this.line=d,this.height=y,this.webview=s,this.onDidDispose=c.event}dispose(){$.c.has(p)&&($.c.delete(p),$.d.$disposeEditorInset(p),c.fire(),c.dispose(),r.dispose())}};return this.d.$createEditorInset(p,l.id,l.value.document.uri,d+1,y,A||{},k.identifier,k.extensionLocation),this.c.set(p,{editor:m,inset:i,onDidReceiveMessage:r}),i}$onDidDispose(m){const d=this.c.get(m);d&&d.inset.dispose()}$onDidReceiveMessage(m,d){this.c.get(m)?.onDidReceiveMessage.fire(d)}}e.$Ggc=R}),define(Re[213],Ae([1,0,4]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jO=e.VariableKind=e.$iO=void 0,e.$iO=(0,S.$8h)("configurationResolverService");var M;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator",R.PathSeparatorAlias="/"})(M||(e.VariableKind=M={}));class I extends Error{constructor(L,m){super(m),this.variable=L}}e.$jO=I}),define(Re[214],Ae([1,0,19,73,16,26,20,94,176,213,14]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=void 0;class k{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor($,p,r,c){this.h=new Map,this.a=$,this.b=p,this.g=r,c&&(this.c=c.then(s=>this.i(s)))}i($){if(L.$i){const p=Object.create(null);return Object.keys($).forEach(r=>{p[r.toLowerCase()]=$[r]}),p}return $}resolveWithEnvironment($,p,r){return this.l({env:this.i($),userHome:void 0},p?p.uri:void 0,r)}async resolveAsync($,p){const r={env:await this.c,userHome:await this.g};return this.l(r,$?$.uri:void 0,p)}async j($,p,r,c){const s=R.$yn(p);L.$i&&s.windows?Object.keys(s.windows).forEach(o=>s[o]=s.windows[o]):L.$j&&s.osx?Object.keys(s.osx).forEach(o=>s[o]=s.osx[o]):L.$k&&s.linux&&Object.keys(s.linux).forEach(o=>s[o]=s.linux[o]),delete s.windows,delete s.osx,delete s.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,$?$.uri:void 0,s,r,c)}async resolveAnyAsync($,p,r){return this.j($,p,r)}async resolveAnyMap($,p,r){const c=new Map;return{newConfig:await this.j($,p,r,c),resolvedVariables:c}}resolveWithInteractionReplace($,p,r,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction($,p,r,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable($,p){if(this.h.has($))throw new Error("Variable "+$+" is contributed twice.");this.h.set($,p)}async l($,p,r,c,s){if(I.$Jf(r))return this.m($,p,r,c,s);if(Array.isArray(r))return Promise.all(r.map(i=>this.l($,p,i,c,s)));if(I.$Lf(r)){const i=Object.create(null),o=await Promise.all(Object.keys(r).map(async a=>[await this.m($,p,a,c,s),await this.l($,p,r[a],c,s)]));for(const[a,u]of o)i[a]=u;return i}return r}m($,p,r,c,s){return(0,A.$5e)(r,k.VARIABLE_REGEXP,async(i,o)=>{if(o.includes(k.VARIABLE_LHS))return i;let a=await this.o($,i,o,p,c);return s?.set(o,a),a!==i&&I.$Jf(a)&&a.match(k.VARIABLE_REGEXP)&&(a=await this.m($,p,a,c,s)),a})}n($){return this.b?this.b.getUriLabel($,{noPrefix:!0}):$.fsPath}async o($,p,r,c,s){let i;const o=r.split(":");o.length>1&&(r=o[0],i=o[1]);const a=f=>{const n=this.a.getFilePath();if(n)return(0,m.$Yv)(n);throw new y.$jO(f,(0,d.localize)(0,null,p))},u=f=>{const n=a(f);if(this.a.getWorkspaceFolderPathForFile){const w=this.a.getWorkspaceFolderPathForFile();if(w)return(0,m.$Yv)(w)}throw new y.$jO(f,(0,d.localize)(1,null,p,S.$nc(n)))},t=f=>{if(i){const n=this.a.getFolderUri(i);if(n)return n;throw new y.$jO(f,(0,d.localize)(2,null,p,i))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new y.$jO(f,(0,d.localize)(3,null,p)):new y.$jO(f,(0,d.localize)(4,null,p))};switch(r){case"env":if(i){if($.env){const f=$.env[L.$i?i.toLowerCase():i];if(I.$Jf(f))return f}return""}throw new y.$jO(y.VariableKind.Env,(0,d.localize)(5,null,p));case"config":if(i){const f=this.a.getConfigurationValue(c,i);if(I.$Sf(f))throw new y.$jO(y.VariableKind.Config,(0,d.localize)(6,null,p,i));if(I.$Lf(f))throw new y.$jO(y.VariableKind.Config,(0,d.localize)(7,null,p,i));return f}throw new y.$jO(y.VariableKind.Config,(0,d.localize)(8,null,p));case"command":return this.p(y.VariableKind.Command,p,i,s,"command");case"input":return this.p(y.VariableKind.Input,p,i,s,"input");case"extensionInstallFolder":if(i){const f=await this.a.getExtension(i);if(!f)throw new y.$jO(y.VariableKind.ExtensionInstallFolder,(0,d.localize)(9,null,p,i));return this.n(f.extensionLocation)}throw new y.$jO(y.VariableKind.ExtensionInstallFolder,(0,d.localize)(10,null,p));default:switch(r){case"workspaceRoot":case"workspaceFolder":return(0,m.$Yv)(this.n(t(y.VariableKind.WorkspaceFolder)));case"cwd":return c||i?(0,m.$Yv)(this.n(t(y.VariableKind.Cwd))):M.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,m.$Yv)(S.$nc(this.n(t(y.VariableKind.WorkspaceFolderBasename))));case"userHome":{if($.userHome)return $.userHome;throw new y.$jO(y.VariableKind.UserHome,(0,d.localize)(11,null,p))}case"lineNumber":{const f=this.a.getLineNumber();if(f)return f;throw new y.$jO(y.VariableKind.LineNumber,(0,d.localize)(12,null,p))}case"selectedText":{const f=this.a.getSelectedText();if(f)return f;throw new y.$jO(y.VariableKind.SelectedText,(0,d.localize)(13,null,p))}case"file":return a(y.VariableKind.File);case"fileWorkspaceFolder":return u(y.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$nc(u(y.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return c||i?S.$lc(this.n(t(y.VariableKind.RelativeFile)),a(y.VariableKind.RelativeFile)):a(y.VariableKind.RelativeFile);case"relativeFileDirname":{const f=S.$mc(a(y.VariableKind.RelativeFileDirname));if(c||i){const n=S.$lc(this.n(t(y.VariableKind.RelativeFileDirname)),f);return n.length===0?".":n}return f}case"fileDirname":return S.$mc(a(y.VariableKind.FileDirname));case"fileExtname":return S.$oc(a(y.VariableKind.FileExtname));case"fileBasename":return S.$nc(a(y.VariableKind.FileBasename));case"fileBasenameNoExtension":{const f=S.$nc(a(y.VariableKind.FileBasenameNoExtension));return f.slice(0,f.length-S.$oc(f).length)}case"fileDirnameBasename":return S.$nc(S.$mc(a(y.VariableKind.FileDirnameBasename)));case"execPath":{const f=this.a.getExecPath();return f||p}case"execInstallFolder":{const f=this.a.getAppRoot();return f||p}case"pathSeparator":case"/":return S.sep;default:try{const f=i?`${r}:${i}`:r;return this.p(y.VariableKind.Unknown,p,f,s,void 0)}catch{return p}}}}p($,p,r,c,s){if(r&&c){const i=s===void 0?c[r]:c[s+":"+r];if(typeof i=="string")return i;throw new y.$jO($,(0,d.localize)(14,null,p))}return p}}e.$xO=k}),define(Re[104],Ae([1,0,4,102]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dD=e.$cD=e.OpenEditorContext=e.GroupsOrder=e.$bD=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$aD=void 0,e.$aD=(0,S.$8h)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var R;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(R||(e.GroupOrientation=R={}));var L;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(L||(e.GroupLocation=L={}));var m;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EXPAND=1]="EXPAND",p[p.EVEN=2]="EVEN"})(m||(e.GroupsArrangement=m={}));var d;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(d||(e.MergeGroupMode=d={}));function y(p){const r=p;return(0,M.$WE)(r?.editor)&&(0,M.$WE)(r?.replacement)}e.$bD=y;var A;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var k;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function l(p){const r=p;return!!r&&typeof r.id=="number"&&Array.isArray(r.editors)}e.$cD=l;function $(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$dD=$}),define(Re[215],Ae([1,0,4,104]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iD=e.$hD=e.$gD=e.$fD=e.$eD=void 0,e.$eD=(0,S.$8h)("editorService"),e.$fD=-1,e.$gD=-2,e.$hD=-3;function I(R){const L=R;return typeof R=="number"||(0,M.$cD)(L)}e.$iD=I}),define(Re[216],Ae([1,0,4,183]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=void 0,e.$IK=(0,S.$9h)(M.$ci)}),define(Re[105],Ae([1,0,22,5,19,6,11]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8b=e.$s8b=e.$r8b=e.$q8b=e.$p8b=void 0;class m{constructor(i,o){this.versionId=i,this.removedDueToLooping=o}}e.$p8b=m;class d{static isHostExtension(i,o,a){if(o.getExtensionDescription(i))return!1;const u=a.getExtensionDescription(i);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(i,o){this.j=i,this.c=new M.$Wd,this.onDidChange=this.c.event,this.d=0,this.e=o,this.k()}k(){this.e.sort(r),this.f=new S.$pm,this.g=[],this.h=new Map;for(const i of this.e){if(this.f.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.f.set(i.identifier,i),this.g.push(i);const o=this.j.readActivationEvents(i);for(const a of o)this.h.has(a)||this.h.set(a,[]),this.h.get(a).push(i)}}set(i){return this.e=i,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(i,o){this.e=c(this.e,o),this.e=this.e.concat(i);const a=d.l(this.e);return this.e=c(this.e,a.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new m(this.d,a)}static l(i){const o=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(n){this.d.has(n)||(this.d.add(n),this.e.push(n))}addArc(n,w){this.addNode(n),this.addNode(w),this.c.has(n)?this.c.get(n).push(w):this.c.set(n,[w])}getArcs(n){return this.c.has(n)?this.c.get(n):[]}hasOnlyGoodArcs(n,w){const D=o.getArcs(n);for(let h=0;h<D.length;h++)if(!w.has(D[h]))return!1;return!0}getNodes(){return this.e}},a=new S.$pm;for(const n of i)if(a.set(n.identifier,n),n.extensionDependencies)for(const w of n.extensionDependencies)o.addArc(S.$nm.toKey(n.identifier),S.$nm.toKey(w));const u=new Set;o.getNodes().filter(n=>o.getArcs(n).length===0).forEach(n=>u.add(n));const t=o.getNodes().filter(n=>!u.has(n));let f;do{f=!1;for(let n=0;n<t.length;n++){const w=t[n];o.hasOnlyGoodArcs(w,u)&&(t.splice(n,1),n--,u.add(w),f=!0)}}while(f);return t.map(n=>a.get(n))}containsActivationEvent(i){return this.h.has(i)}containsExtension(i){return this.f.has(i)}getExtensionDescriptionsForActivationEvent(i){const o=this.h.get(i);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new y(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(i){const o=this.f.get(i);return o||void 0}getExtensionDescriptionByUUID(i){for(const o of this.g)if(o.uuid===i)return o}getExtensionDescriptionByIdOrUUID(i,o){return this.getExtensionDescription(i)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.$q8b=d;class y{constructor(i,o){this.versionId=i,this.extensions=o}}e.$r8b=y;class A{constructor(i){this.d=new $,this.c=new d(i,[])}async acquireLock(i){const o=await this.d.acquire(i);return new k(this,o)}deltaExtensions(i,o,a){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(o,a)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,o){return this.c.getExtensionDescriptionByIdOrUUID(i,o)}}e.$s8b=A;class k extends R.$Tc{constructor(i,o){super(),this.f=i,this.c=!1,this.B(o)}isAcquiredFor(i){return!this.c&&this.f===i}}e.$t8b=k;class l{constructor(i){this.name=i;const o=(0,L.$1g)();this.promise=o.promise,this.c=o.resolve}resolve(i){this.c(i)}}class ${constructor(){this.c=[],this.d=!1}async acquire(i){const o=new l(i);return this.c.push(o),this.e(),o.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let o=!0;const a=setTimeout(()=>{o&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{o&&(clearTimeout(a),o=!1,this.d=!1,this.e())};i.resolve((0,R.$Rc)(u))}}var p;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(p||(p={}));function r(s,i){const o=s.isBuiltin?0:s.isUnderDevelopment?2:1,a=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(o!==a)return o-a;const u=I.$gc.basename(s.extensionLocation.path),t=I.$gc.basename(i.extensionLocation.path);return u<t?-1:u>t?1:0}function c(s,i){const o=new S.$om(i);return s.filter(a=>!o.has(a.identifier))}}),define(Re[77],Ae([1,0,23]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$wm=e.$vm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var M;(function(y){y[y.Desktop=1]="Desktop",y[y.Web=2]="Web"})(M||(e.UIKind=M={}));var I;(function(y){y[y.VersionMismatch=55]="VersionMismatch",y[y.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var R;(function(y){y[y.Initialized=0]="Initialized",y[y.Ready=1]="Ready",y[y.Terminate=2]="Terminate"})(R||(e.MessageType=R={}));function L(y){const A=S.$ke.alloc(1);switch(y){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$vm=L;function m(y,A){if(y.byteLength!==1)return!1;switch(y.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$wm=m;var d;(function(y){y.Start="START_NATIVE_LOG",y.End="END_NATIVE_LOG"})(d||(e.NativeLogMarkers=d={}))}),define(Re[60],Ae([1,0,4,5,13,27,77,56,57,26,2,6,164]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QN=e.$PN=e.$ON=e.$NN=void 0;let $=class extends k.$Tc{constructor(s,i){super(),this.s=s,this.t=i,this.a=this.B(new M.$Wd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new M.$Wd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:d.$So,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(o=>{(0,I.$rj)(o)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,i,o){const a=this.getTelemetryDetails(),u=new p(i,o,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}),t=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...t,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(s,i,o){this.f=s,this.g=i,this.c=o??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const i=Object.create(null);switch(i["common.extname"]=`${s.publisher}.${s.name}`,i["common.extversion"]=s.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=r(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case L.UIKind.Web:i["common.uikind"]="web";break;case L.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,m.$dl)((0,d.$Yo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const i=this.getTelemetryDetails();this.r.forEach((o,a)=>{const u=o.filter(t=>!t.isDisposed);u.length===0?this.r.delete(a):this.r.set(a,u)}),this.r.forEach(o=>{for(const a of o)a.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,i){const a=this.r.get(s.value)?.filter(t=>!t.isDisposed);if(!a)return this.r.delete(s.value),!1;let u=!1;for(const t of a)t.ignoreUnhandledExtHostErrors||(t.logError(i),u=!0);return u}};e.$NN=$,e.$NN=$=Ge([qe(0,R.$MN),qe(1,I.$qj)],$);class p{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,i,o,a,u,t,f){this.g=o,this.h=a,this.i=u,this.j=t,this.a=new M.$Wd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:f.isUsageEnabled,isErrorsEnabled:f.isErrorsEnabled}}updateTelemetryEnablements(s,i){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let i="properties"in s?s.properties??{}:s;return i=(0,d.$2o)(i,[]),this.c&&(i=(0,y.$Bn)(i,this.c)),this.b||(i=(0,y.$Bn)(i,this.j)),"properties"in s?s.properties=i:s=i,s}k(s,i){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(s,i),this.h.trace(s,i))}logUsage(s,i){this.d.isUsageEnabled&&this.k(s,i)}logError(s,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,i);else{const o={name:s.name,message:s.message,stack:s.stack,cause:s.cause},a=(0,d.$2o)(o,[]),u=new Error(a.message,{cause:a.cause});u.stack=a.stack,u.name=a.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(u,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const s=this,i={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$ON=p;function r(c){const s=Date.now()-new Date(c).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$PN=r,e.$QN=(0,S.$8h)("IExtHostTelemetry")}),define(Re[25],Ae([1,0,5,2,192,101,22,4]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QF=e.$PF=e.$OF=e.ActivationKind=e.$NF=e.$MF=e.$LF=e.$KF=e.$JF=e.ExtensionHostStartup=e.$IF=e.$HF=e.$GF=e.$FF=void 0,e.$FF=Object.freeze({identifier:new L.$nm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:M.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$GF="extensions.webWorker",e.$HF=(0,m.$8h)("extensionService");class d{constructor(u){this.dependency=u}}e.$IF=d;var y;(function(a){a[a.EagerAutoStart=1]="EagerAutoStart",a[a.EagerManualStart=2]="EagerManualStart",a[a.Lazy=3]="Lazy"})(y||(e.ExtensionHostStartup=y={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,t,f){this.c=u,this.d=t.slice(0),this.e=f.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:R.$qF.createActivationEventsMap(this.d)}}set(u,t,f){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const n=[],w=[],D=[],h=[],b=k(this.d),P=k(t),g=(J,q)=>J.extensionLocation.toString()===q.extensionLocation.toString()||J.isBuiltin===q.isBuiltin||J.isUserBuiltin===q.isUserBuiltin||J.isUnderDevelopment===q.isUnderDevelopment;for(const J of this.d){const q=P.get(J.identifier);if(!q){n.push(J.identifier),b.delete(J.identifier);continue}if(!g(J,q)){n.push(J.identifier),b.delete(J.identifier);continue}}for(const J of t){const q=b.get(J.identifier);if(!q){w.push(J);continue}if(!g(q,J)){n.push(q.identifier),b.delete(q.identifier);continue}}const v=new L.$om(this.e),E=new L.$om(f);for(const J of this.e)E.has(J)||D.push(J);for(const J of f)v.has(J)||h.push(J);const T=R.$qF.createActivationEventsMap(w),N={versionId:u,toRemove:n,toAdd:w,addActivationEvents:T,myToRemove:D,myToAdd:h};return this.delta(N),N}delta(u){if(this.c>=u.versionId)return null;const{toRemove:t,toAdd:f,myToRemove:n,myToAdd:w}=u,D=new L.$om(t),h=new L.$om(n);for(let b=0;b<this.d.length;b++)D.has(this.d[b].identifier)&&(this.d.splice(b,1),b--);for(let b=0;b<this.e.length;b++)h.has(this.e[b])&&(this.e.splice(b,1),b--);for(const b of f)this.d.push(b);for(const b of w)this.e.push(b);return this.f=null,u}containsExtension(u){for(const t of this.e)if(L.$nm.equals(t,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const f=R.$qF.readActivationEvents(t);for(const n of f)u.add(n)}return u}}e.$JF=A;function k(a){const u=new L.$pm;for(const t of a)u.set(t.identifier,t);return u}function l(a,u){return a.enabledApiProposals?a.enabledApiProposals.includes(u):!1}e.$KF=l;function $(a,u){if(!l(a,u))throw new Error(`Extension '${a.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${a.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${a.identifier.value}`)}e.$LF=$;class p{constructor(u,t,f,n){this.codeLoadingTime=u,this.activateCallTime=t,this.activateResolvedTime=f,this.activationReason=n}}e.$MF=p;class r{constructor(u,t){this.description=u,this.value=t}}e.$NF=r;var c;(function(a){a[a.Normal=0]="Normal",a[a.Immediate=1]="Immediate"})(c||(e.ActivationKind=c={}));function s(a){return{type:a.isBuiltin?0:1,isBuiltin:a.isBuiltin||a.isUserBuiltin,identifier:{id:(0,I.$8o)(a.publisher,a.name),uuid:a.uuid},manifest:a,location:a.extensionLocation,targetPlatform:a.targetPlatform,validations:[],isValid:!0}}e.$OF=s;function i(a,u){return{identifier:new L.$nm((0,I.$6o)(a.manifest.publisher,a.manifest.name)),isBuiltin:a.type===0,isUserBuiltin:a.type===1&&a.isBuiltin,isUnderDevelopment:!!u,extensionLocation:a.location,...a.manifest,uuid:a.identifier.uuid,targetPlatform:a.targetPlatform}}e.$PF=i;class o{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,t){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$QF=o}),define(Re[217],Ae([1,0,15,105,22,25,13,11]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8gc=e.$7gc=e.$6gc=e.$5gc=e.$4gc=e.$3gc=void 0;class d{static{this.NONE=new d(!1,-1,-1,-1)}constructor(s,i,o,a){this.startup=s,this.codeLoadingTime=i,this.activateCallTime=o,this.activateResolvedTime=a}}e.$3gc=d;class y{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,i){return s===-1||i===-1?-1:i-s}build(){return new d(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$4gc=y;class A{constructor(s,i,o,a,u,t){this.activationFailed=s,this.activationFailedError=i,this.activationTimes=o,this.module=a,this.exports=u,this.subscriptions=t}}e.$5gc=A;class k extends A{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$6gc=k;class l extends A{constructor(){super(!1,null,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$7gc=l;class $ extends A{constructor(s){super(!0,s,d.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=class{constructor(s,i,o,a){this.g=a,this.a=s,this.b=i,this.c=o,this.d=new I.$pm,this.f=Object.create(null)}dispose(){for(const[s,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const s=[];for(const[i,o]of this.d)s.push(o.wait());await Promise.all(s)}isActivated(s){const i=this.d.get(s);return!!(i&&i.value)}getActivatedExtension(s){const i=this.d.get(s);if(!i||!i.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return i.value}async activateByEvent(s,i){if(this.f[s])return;const o=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(o.map(a=>({id:a.identifier,reason:{startup:i,extensionId:a.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,i){const o=this.a.getExtensionDescription(s);if(!o)throw new Error(`Extension '${s}' is not known`);return this.h([{id:o.identifier,reason:i}])}async h(s){const i=s.filter(o=>!this.isActivated(o.id)).map(o=>this.j(o));await Promise.all(i.map(o=>o.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const i=this.a.getExtensionDescription(s.id);if(!i){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),t=this.k(s,null,[],new $(u));return this.c.onExtensionActivationError(s.id,u,new R.$IF(s.id.value)),t}const o=[],a=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const u of a){if(this.m(u))continue;const t=this.d.get(u);if(t){o.push(t);continue}if(this.l(u)){o.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:s.reason}));continue}const f=this.a.getExtensionDescription(u);if(f){if(!f.main&&!f.browser)continue;o.push(this.j({id:f.identifier,reason:s.reason}));continue}const n=i.displayName||i.identifier.value,w=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${u}'`),D=this.k(s,i.displayName,[],new $(w));return this.c.onExtensionActivationError(i.identifier,w,new R.$IF(u)),D}return this.k(s,i.displayName,o,null)}k(s,i,o,a){const u=new r(s.id,i,s.reason,o,a,this.c,this.g);return this.d.set(s.id,u),u}l(s){return M.$q8b.isHostExtension(s,this.a,this.b)}m(s){const i=this.b.getExtensionDescription(s);return i?!i.main&&!i.browser:!1}};e.$8gc=p,e.$8gc=p=Ge([qe(3,L.$pj)],p);let r=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,i,o,a,u,t,f){this.c=s,this.d=i,this.f=o,this.g=a,this.h=u,this.j=t,this.k=f,this.a=new m.$7g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const i=this.g[s];if(i.value&&!i.value.activationFailed){this.g.splice(s,1),s--;continue}if(i.value&&i.value.activationFailed){const o=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);o.detail=i.value.activationFailedError,this.h=new $(o),this.j.onExtensionActivationError(this.c,o,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const i=new Error;if(s&&s.name&&(i.name=s.name),s&&s.message?i.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(i.stack=s.stack),this.h=new $(i),this.b&&S.$4(s))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};r=Ge([qe(6,L.$pj)],r)}),define(Re[218],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Re[219],Ae([1,0,178,15,32,96,72,30,22,218,188,101]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EF=e.$DF=e.$CF=e.$BF=e.$AF=e.$zF=void 0;const l=m.$Kn.as(L.$Ln.JSONContribution);class ${constructor(u,t,f){this.a=u,this.b=t,this.c=f}d(u,t){this.a({type:u,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(I.default.Error,u)}warn(u){this.d(I.default.Warning,u)}info(u){this.d(I.default.Info,u)}}e.$zF=$;class p{static a(u){const t=new d.$om;for(let f=0,n=u.length;f<n;f++)t.add(u[f].description.identifier);return t}static compute(u,t){if(!u||!u.length)return new p(t,[]);if(!t||!t.length)return new p([],u);const f=this.a(u),n=this.a(t),w=t.filter(h=>!f.has(h.description.identifier)),D=u.filter(h=>!n.has(h.description.identifier));return new p(w,D)}constructor(u,t){this.added=u,this.removed=t}}e.$AF=p;class r{constructor(u,t){this.name=u,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=p.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,M.$1)(u)}}}e.$BF=r;const c={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$CF={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:d.$mm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$po}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.$po}},extensionKind:{description:S.localize(52,null),type:"array",items:c,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const t=new r(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,t),u.activationEventsGenerator&&k.$qF.register(u.extensionPoint,u.activationEventsGenerator),e.$CF.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,l.registerSchema(s,e.$CF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$DF=i;const o={ExtensionsRegistry:"ExtensionsRegistry"};m.$Kn.add(o.ExtensionsRegistry,new i),e.$EF=m.$Kn.as(o.ExtensionsRegistry),l.registerSchema(s,e.$CF),l.registerSchema(A.$Ij,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(y.allApiProposals),markdownEnumDescriptions:Object.values(y.allApiProposals)}}]}}}})}),define(Re[220],Ae([1,0,174,16,26,219,35,5]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DG=void 0;const d={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var y;(function(l){function $(p,r,c){if(!p)return;const s=M.$Jf(p.type)?p.type:void 0;if(!s||s.length===0){c.error(S.localize(3,null));return}const i=[];if(Array.isArray(p.required))for(const o of p.required)M.$Jf(o)&&i.push(o);return{extensionId:r.value,taskType:s,required:i,properties:p.properties?I.$yn(p.properties):{},when:p.when?L.$6i.deserialize(p.when):void 0}}l.from=$})(y||(y={}));const A=R.$EF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,$)=>{for(const p of l)p.type&&$.push(`onTaskType:${p.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:d}});class k{constructor(){this.d=new m.$Wd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise(($,p)=>{A.setHandler((r,c)=>{this.c=void 0;try{for(const s of c.removed){const i=s.value;for(const o of i)this.a&&o.type&&this.a[o.type]&&delete this.a[o.type]}for(const s of c.added){const i=s.value;for(const o of i){const a=y.from(o,s.description.identifier,s.collector);a&&(this.a[a.taskType]=a)}}(c.removed.length>0||c.added.length>0)&&this.d.fire()}catch{}$(void 0)})})}onReady(){return this.b}get($){return this.a[$]}all(){return Object.keys(this.a).map($=>this.a[$])}getJsonSchema(){if(this.c===void 0){const $=[];for(const p of this.all()){const r={type:"object",additionalProperties:!1};p.required.length>0&&(r.required=p.required.slice(0)),p.properties!==void 0?r.properties=I.$yn(p.properties):r.properties=Object.create(null),r.properties.type={type:"string",enum:[p.taskType]},$.push(r)}this.c={oneOf:$}}return this.c}}e.$DG=new k}),define(Re[221],Ae([1,0,175,16,24,26,35,220]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$NG=e.JsonSchemaVersion=e.ExecutionEngine=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$HG=e.ShellQuoting=e.$GG=e.$FG=e.$EG=void 0,e.$EG="settings",e.$FG=new L.$mj("taskRunning",!1,S.localize(0,null)),e.$GG=S.localize2(2,"Tasks");var d;(function(C){C[C.Escape=1]="Escape",C[C.Strong=2]="Strong",C[C.Weak=3]="Weak"})(d||(e.ShellQuoting=d={})),e.$HG="$customized",function(C){function F(W){if(!W)return C.Strong;switch(W.toLowerCase()){case"escape":return C.Escape;case"strong":return C.Strong;case"weak":return C.Weak;default:return C.Strong}}C.from=F}(d||(e.ShellQuoting=d={}));var y;(function(C){C.defaults={cwd:"${workspaceFolder}"}})(y||(e.CommandOptions=y={}));var A;(function(C){C[C.Always=1]="Always",C[C.Silent=2]="Silent",C[C.Never=3]="Never"})(A||(e.RevealKind=A={})),function(C){function F(W){switch(W.toLowerCase()){case"always":return C.Always;case"silent":return C.Silent;case"never":return C.Never;default:return C.Always}}C.fromString=F}(A||(e.RevealKind=A={}));var k;(function(C){C[C.Never=1]="Never",C[C.OnProblem=2]="OnProblem",C[C.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(C){function F(W){switch(W.toLowerCase()){case"always":return C.Always;case"never":return C.Never;case"onproblem":return C.OnProblem;default:return C.OnProblem}}C.fromString=F}(k||(e.RevealProblemKind=k={}));var l;(function(C){C[C.Shared=1]="Shared",C[C.Dedicated=2]="Dedicated",C[C.New=3]="New"})(l||(e.PanelKind=l={})),function(C){function F(W){switch(W.toLowerCase()){case"shared":return C.Shared;case"dedicated":return C.Dedicated;case"new":return C.New;default:return C.Shared}}C.fromString=F}(l||(e.PanelKind=l={}));var $;(function(C){C.defaults={echo:!0,reveal:A.Always,revealProblems:k.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})($||(e.PresentationOptions=$={}));var p;(function(C){C[C.Shell=1]="Shell",C[C.Process=2]="Process",C[C.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(C){function F(re){switch(re.toLowerCase()){case"shell":return C.Shell;case"process":return C.Process;case"customExecution":return C.CustomExecution;default:return C.Process}}C.fromString=F;function W(re){switch(re){case C.Shell:return"shell";case C.Process:return"process";case C.CustomExecution:return"customExecution";default:return"process"}}C.toString=W}(p||(e.RuntimeType=p={}));var r;(function(C){function F(W){return M.$Jf(W)?W:W.value}C.value=F})(r||(e.CommandString=r={}));var c;(function(C){C.Clean={_id:"clean",isDefault:!1},C.Build={_id:"build",isDefault:!1},C.Rebuild={_id:"rebuild",isDefault:!1},C.Test={_id:"test",isDefault:!1};function F(re){return re===C.Clean._id||re===C.Build._id||re===C.Rebuild._id||re===C.Test._id}C.is=F;function W(re){if(re!==void 0)return M.$Jf(re)?F(re)?{_id:re,isDefault:!1}:void 0:re}C.from=W})(c||(e.TaskGroup=c={}));var s;(function(C){C[C.Global=1]="Global",C[C.Workspace=2]="Workspace",C[C.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var i;(function(C){C.Workspace="workspace",C.Extension="extension",C.InMemory="inMemory",C.WorkspaceFile="workspaceFile",C.User="user";function F(W){switch(W){case C.User:return 2;case C.WorkspaceFile:return 5;default:return 6}}C.toConfigurationTarget=F})(i||(e.TaskSourceKind=i={}));var o;(function(C){C.parallel="parallel",C.sequence="sequence"})(o||(e.DependsOrder=o={}));var a;(function(C){C[C.default=1]="default",C[C.folderOpen=2]="folderOpen"})(a||(e.RunOnOptions=a={}));var u;(function(C){C.defaults={reevaluateOnRerun:!0,runOn:a.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class t{constructor(F,W,re,ce,we,De){this._label="",this._id=F,W&&(this._label=W),re&&(this.type=re),this.runOptions=ce,this.configurationProperties=we,this._source=De}getDefinition(F){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const F={folder:this.d(),id:this._id};return JSON.stringify(F)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(F,W=!1){if(F===void 0)return!1;if(M.$Jf(F))return F===this._label||F===this.configurationProperties.identifier||W&&F===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===F._key}getQualifiedLabel(){const F=this.getWorkspaceFolder();return F?`${this._label} (${F.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(F){this.c===void 0&&(this.c=[]),F&&(this.c=this.c.concat(F))}get taskLoadMessages(){return this.c}}e.$IG=t;class f extends t{constructor(F,W,re,ce,we,De,le,ve){super(F,re,void 0,le,ve,W),this.command={},this._source=W,this.hasDefinedMatchers=De,we&&(this.command=we)}clone(){return new f(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(F=!1){if(F&&this._source.customizes!==void 0)return this._source.customizes;{let W;switch(this.command?this.command.runtime:void 0){case p.Shell:W="shell";break;case p.Process:W="process";break;case p.CustomExecution:W="customExecution";break;case void 0:W="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:W,_key:this._id,id:this._id}}}static is(F){return F instanceof f}getMapKey(){const F=this._source.config.workspaceFolder;return F?`${F.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$EG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const re={type:e.$HG,folder:F,id:W};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(F){return new f(F._id,F._source,F._label,F.type,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$JG=f;class n extends t{constructor(F,W,re,ce,we,De,le){super(F,re,ce,De,le,W),this._source=W,this.configures=we}static is(F){return F instanceof n}f(F){return F}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.$Fg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$EG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const F=this.d();if(!F)return;let W=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(W+=this._source.kind);const re={type:e.$HG,folder:F,id:W};return JSON.stringify(re)}}e.$KG=n;class w extends t{constructor(F,W,re,ce,we,De,le,ve,se){super(F,re,ce,ve,se,W),this.defines=we,this.hasDefinedMatchers=le,this.command=De,this.icon=se.icon,this.hide=se.hide}clone(){return new w(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(F){return F instanceof w}getMapKey(){const F=this._source.workspaceFolder;return F?`${this._source.scope.toString()}|${F.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const F={type:"contributed",scope:this._source.scope,id:this._id};return F.folder=this.d(),JSON.stringify(F)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(F){return new w(F._id,F._source,F._label,F.type,F.defines,F.command,F.hasDefinedMatchers,F.runOptions,F.configurationProperties)}}e.$LG=w;class D extends t{constructor(F,W,re,ce,we,De){super(F,re,ce,we,De,W),this._source=W}clone(){return new D(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(F){return F instanceof D}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(F){return new D(F._id,F._source,F._label,F.type,F.runOptions,F.configurationProperties)}}e.$MG=D;var h;(function(C){C[C.Process=1]="Process",C[C.Terminal=2]="Terminal"})(h||(e.ExecutionEngine=h={})),function(C){C._default=C.Terminal}(h||(e.ExecutionEngine=h={}));var b;(function(C){C[C.V0_1_0=1]="V0_1_0",C[C.V2_0_0=2]="V2_0_0"})(b||(e.JsonSchemaVersion=b={}));class P{constructor(F){this.c=new Map;for(let W=0;W<F.length;W++)this.c.set(F[W].uri.toString(),W)}compare(F,W){const re=F.getWorkspaceFolder(),ce=W.getWorkspaceFolder();if(re&&ce){let we=this.c.get(re.uri.toString());we=we===void 0?0:we+1;let De=this.c.get(ce.uri.toString());return De=De===void 0?0:De+1,we===De?F._label.localeCompare(W._label):we-De}else return!re&&ce?-1:re&&!ce?1:0}}e.$NG=P;var g;(function(C){C.DependsOnStarted="dependsOnStarted",C.AcquiredInput="acquiredInput",C.Start="start",C.ProcessStarted="processStarted",C.Active="active",C.Inactive="inactive",C.Changed="changed",C.Terminated="terminated",C.ProcessEnded="processEnded",C.End="end"})(g||(e.TaskEventKind=g={}));var v;(function(C){C.SingleRun="singleRun",C.Background="background"})(v||(e.TaskRunType=v={}));var E;(function(C){C[C.System=0]="System",C[C.User=1]="User",C[C.FolderOpen=2]="FolderOpen",C[C.ConfigurationChange=3]="ConfigurationChange",C[C.Reconnect=4]="Reconnect"})(E||(e.TaskRunSource=E={}));var T;(function(C){function F(ve){return{taskId:ve._id,taskName:ve.configurationProperties.name,runType:ve.configurationProperties.isBackground?"background":"singleRun",group:ve.configurationProperties.group,__task:ve}}function W(ve,se,$e){return{...F(ve),kind:"start",terminalId:se,resolvedVariables:$e}}C.start=W;function re(ve,se,$e){return{...F(ve),kind:"processStarted",terminalId:se,processId:$e}}C.processStarted=re;function ce(ve,se,$e){return{...F(ve),kind:"processEnded",terminalId:se,exitCode:$e}}C.processEnded=ce;function we(ve,se,$e){return{...F(ve),kind:"terminated",exitReason:$e,terminalId:se}}C.terminated=we;function De(ve,se,$e){return{...F(se),kind:ve,terminalId:$e}}C.general=De;function le(){return{kind:"changed"}}C.changed=le})(T||(e.TaskEvent=T={}));var N;(function(C){function F(re){const ce=Object.keys(re).sort();let we="";for(const De of ce){let le=re[De];le instanceof Object?le=F(le):typeof le=="string"&&(le=le.replace(/,/g,",,")),we+=De+","+le+","}return we}function W(re){const we={_key:F(re),type:re.taskType};return Object.assign(we,re),we}C.create=W})(N||(e.KeyedTaskIdentifier=N={}));var J;(function(C){C.AutoDetect="task.autoDetect",C.SaveBeforeRun="task.saveBeforeRun",C.ShowDecorations="task.showDecorations",C.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",C.SlowProviderWarning="task.slowProviderWarning",C.QuickOpenHistory="task.quickOpen.history",C.QuickOpenDetail="task.quickOpen.detail",C.QuickOpenSkip="task.quickOpen.skip",C.QuickOpenShowAll="task.quickOpen.showAll",C.AllowAutomaticTasks="task.allowAutomaticTasks",C.Reconnection="task.reconnection",C.VerboseLogging="task.verboseLogging"})(J||(e.TaskSettingId=J={}));var q;(function(C){C.Tasks="tasks",C.SuppressTaskName="tasks.suppressTaskName",C.Windows="tasks.windows",C.Osx="tasks.osx",C.Linux="tasks.linux",C.ShowOutput="tasks.showOutput",C.IsShellCommand="tasks.isShellCommand",C.ServiceTestSetting="tasks.service.testSetting"})(q||(e.TasksSchemaProperties=q={}));var U;(function(C){function F(W,re){const ce=m.$DG.get(W.type);if(ce===void 0){const ve=R.$yn(W);return delete ve._key,N.create(ve)}const we=Object.create(null);we.type=ce.taskType;const De=new Set;ce.required.forEach(ve=>De.add(ve));const le=ce.properties;for(const ve of Object.keys(le)){const se=W[ve];if(se!=null)we[ve]=se;else if(De.has(ve)){const $e=le[ve];if($e.default!==void 0)we[ve]=R.$yn($e.default);else switch($e.type){case"boolean":we[ve]=!1;break;case"number":case"integer":we[ve]=0;break;case"string":we[ve]="";break;default:re.error(S.localize(1,null,JSON.stringify(W,void 0,0),ve));return}}}return N.create(we)}C.createTaskIdentifier=F})(U||(e.TaskDefinition=U={}))}),define(Re[222],Ae([1,0,15]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v8b=e.$u8b=void 0;class M{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((L,m)=>{this.b=L,this.d=m,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(L){this.f||this.h||(this.f=!0,this.g=L,this.a&&this.b(L))}resolveErr(L){this.f||this.h||(this.h=!0,this.i=L,this.a?this.d(L):(0,S.$1)(L))}then(L,m){return this.j().then(L,m)}catch(L){return this.j().then(void 0,L)}finally(L){return this.j().finally(L)}}e.$u8b=M;class I extends M{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$v8b=I}),define(Re[50],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vv=e.$Uv=e.$Tv=e.$Sv=void 0;class S{static{this.count=0}constructor(d){this._proxyIdentifierBrand=void 0,this.sid=d,this.nid=++S.count}}e.$Sv=S;const M=[];function I(m){const d=new S(m);return M[d.nid]=d,d}e.$Tv=I;function R(m){return M[m].sid}e.$Uv=R;class L{constructor(d){this.value=d}}e.$Vv=L}),define(Re[3],Ae([1,0,50]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mL=e.$lL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$kL=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var M;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(M||(e.TextEditorRevealType=M={}));var I;(function(r){r[r.UnknownInput=0]="UnknownInput",r[r.TextInput=1]="TextInput",r[r.TextDiffInput=2]="TextDiffInput",r[r.TextMergeInput=3]="TextMergeInput",r[r.NotebookInput=4]="NotebookInput",r[r.NotebookDiffInput=5]="NotebookDiffInput",r[r.CustomEditorInput=6]="CustomEditorInput",r[r.WebviewEditorInput=7]="WebviewEditorInput",r[r.TerminalEditorInput=8]="TerminalEditorInput",r[r.InteractiveEditorInput=9]="InteractiveEditorInput",r[r.ChatEditorInput=10]="ChatEditorInput"})(I||(e.TabInputKind=I={}));var R;(function(r){r[r.TAB_OPEN=0]="TAB_OPEN",r[r.TAB_CLOSE=1]="TAB_CLOSE",r[r.TAB_UPDATE=2]="TAB_UPDATE",r[r.TAB_MOVE=3]="TAB_MOVE"})(R||(e.TabModelOperationKind=R={}));var L;(function(r){r[r.Editable=0]="Editable",r[r.SupportsHotExit=1]="SupportsHotExit"})(L||(e.WebviewEditorCapabilities=L={}));var m;(function(r){r[r.Int8Array=1]="Int8Array",r[r.Uint8Array=2]="Uint8Array",r[r.Uint8ClampedArray=3]="Uint8ClampedArray",r[r.Int16Array=4]="Int16Array",r[r.Uint16Array=5]="Uint16Array",r[r.Int32Array=6]="Int32Array",r[r.Uint32Array=7]="Uint32Array",r[r.Float32Array=8]="Float32Array",r[r.Float64Array=9]="Float64Array",r[r.BigInt64Array=10]="BigInt64Array",r[r.BigUint64Array=11]="BigUint64Array"})(m||(e.WebviewMessageArrayBufferViewType=m={}));var d;(function(r){r[r.Text=1]="Text",r[r.Error=2]="Error",r[r.Rich=3]="Rich"})(d||(e.CellOutputKind=d={}));var y;(function(r){r[r.Default=0]="Default",r[r.InCenter=1]="InCenter",r[r.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",r[r.AtTop=3]="AtTop"})(y||(e.NotebookEditorRevealType=y={}));var A;(function(r){r[r.None=0]="None",r[r.Process=1]="Process",r[r.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class k{static{this.a=0}static mixin(c){return c._id=k.a++,c}}e.$kL=k;var l;(function(r){r.label="a",r.kind="b",r.detail="c",r.documentation="d",r.sortText="e",r.filterText="f",r.preselect="g",r.insertText="h",r.insertTextRules="i",r.range="j",r.commitCharacters="k",r.additionalTextEdits="l",r.kindModifier="m",r.commandIdent="n",r.commandId="o",r.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var $;(function(r){r.defaultRanges="a",r.completions="b",r.isIncomplete="c",r.duration="d"})($||(e.ISuggestResultDtoField=$={}));var p;(function(r){r[r.Workspace=0]="Workspace",r[r.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.$lL={MainThreadAuthentication:(0,S.$Tv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$Tv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,S.$Tv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,S.$Tv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$Tv)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$Tv)("MainThreadClipboard"),MainThreadCommands:(0,S.$Tv)("MainThreadCommands"),MainThreadComments:(0,S.$Tv)("MainThreadComments"),MainThreadConfiguration:(0,S.$Tv)("MainThreadConfiguration"),MainThreadConsole:(0,S.$Tv)("MainThreadConsole"),MainThreadDebugService:(0,S.$Tv)("MainThreadDebugService"),MainThreadDecorations:(0,S.$Tv)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$Tv)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$Tv)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$Tv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$Tv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$Tv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$Tv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$Tv)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$Tv)("MainThreadErrors"),MainThreadTreeViews:(0,S.$Tv)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$Tv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$Tv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$Tv)("MainThreadLanguages"),MainThreadLogger:(0,S.$Tv)("MainThreadLogger"),MainThreadMessageService:(0,S.$Tv)("MainThreadMessageService"),MainThreadOutputService:(0,S.$Tv)("MainThreadOutputService"),MainThreadProgress:(0,S.$Tv)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$Tv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$Tv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$Tv)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$Tv)("MainThreadSecretState"),MainThreadStorage:(0,S.$Tv)("MainThreadStorage"),MainThreadSpeech:(0,S.$Tv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$Tv)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$Tv)("MainThreadTerminalService"),MainThreadWebviews:(0,S.$Tv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$Tv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$Tv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$Tv)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$Tv)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$Tv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$Tv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$Tv)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$Tv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$Tv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$Tv)("MainThreadExtensionService"),MainThreadSCM:(0,S.$Tv)("MainThreadSCM"),MainThreadSearch:(0,S.$Tv)("MainThreadSearch"),MainThreadShare:(0,S.$Tv)("MainThreadShare"),MainThreadTask:(0,S.$Tv)("MainThreadTask"),MainThreadWindow:(0,S.$Tv)("MainThreadWindow"),MainThreadLabelService:(0,S.$Tv)("MainThreadLabelService"),MainThreadNotebook:(0,S.$Tv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$Tv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$Tv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$Tv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$Tv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$Tv)("MainThreadInteractive"),MainThreadChat:(0,S.$Tv)("MainThreadChat"),MainThreadInlineChat:(0,S.$Tv)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$Tv)("MainThreadTheming"),MainThreadTunnelService:(0,S.$Tv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$Tv)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$Tv)("MainThreadTimeline"),MainThreadTesting:(0,S.$Tv)("MainThreadTesting"),MainThreadLocalization:(0,S.$Tv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$Tv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$Tv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,S.$Tv)("MainThreadIssueReporter")},e.$mL={ExtHostCommands:(0,S.$Tv)("ExtHostCommands"),ExtHostConfiguration:(0,S.$Tv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$Tv)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$Tv)("ExtHostDebugService"),ExtHostDecorations:(0,S.$Tv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$Tv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$Tv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$Tv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$Tv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$Tv)("ExtHostEditors"),ExtHostTreeViews:(0,S.$Tv)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$Tv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$Tv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$Tv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$Tv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$Tv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$Tv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$Tv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$Tv)("ExtHostStatusBar"),ExtHostShare:(0,S.$Tv)("ExtHostShare"),ExtHostExtensionService:(0,S.$Tv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$Tv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$Tv)("ExtHostTerminalService"),ExtHostSCM:(0,S.$Tv)("ExtHostSCM"),ExtHostSearch:(0,S.$Tv)("ExtHostSearch"),ExtHostTask:(0,S.$Tv)("ExtHostTask"),ExtHostWorkspace:(0,S.$Tv)("ExtHostWorkspace"),ExtHostWindow:(0,S.$Tv)("ExtHostWindow"),ExtHostWebviews:(0,S.$Tv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$Tv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$Tv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$Tv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$Tv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$Tv)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$Tv)("ExtHostProgress"),ExtHostComments:(0,S.$Tv)("ExtHostComments"),ExtHostSecretState:(0,S.$Tv)("ExtHostSecretState"),ExtHostStorage:(0,S.$Tv)("ExtHostStorage"),ExtHostUrls:(0,S.$Tv)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$Tv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$Tv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$Tv)("ExtHostOutputService"),ExtHostLabelService:(0,S.$Tv)("ExtHostLabelService"),ExtHostNotebook:(0,S.$Tv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$Tv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$Tv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$Tv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$Tv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$Tv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$Tv)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$Tv)("ExtHostInlineChatShape"),ExtHostChat:(0,S.$Tv)("ExtHostChat"),ExtHostChatAgents2:(0,S.$Tv)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$Tv)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$Tv)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$Tv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$Tv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$Tv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$Tv)("ExtHostTheming"),ExtHostTunnelService:(0,S.$Tv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$Tv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$Tv)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$Tv)("ExtHostTimeline"),ExtHostTesting:(0,S.$Tv)("ExtHostTesting"),ExtHostTelemetry:(0,S.$Tv)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$Tv)("ExtHostLocalization"),ExtHostIssueReporter:(0,S.$Tv)("ExtHostIssueReporter")}}),define(Re[78],Ae([1,0,4,13,3,17]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vgc=e.$ugc=e.$tgc=void 0,e.$tgc=(0,S.$8h)("IExtHostApiDeprecationService");let L=class{constructor(d,y){this.c=y,this.a=new Set,this.b=d.getProxy(I.$lL.MainThreadTelemetry)}report(d,y,A){const k=this.d(d,y);this.a.has(k)||(this.a.add(k),y.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${d}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:y.identifier.value,apiId:d}))}d(d,y){return`${d}-${y.identifier.value}`}};e.$ugc=L,e.$ugc=L=Ge([qe(0,R.$wN),qe(1,M.$pj)],L),e.$vgc=Object.freeze(new class{report(m,d,y){}})}),define(Re[223],Ae([1,0,68,6,3]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Agc=void 0;class R{static{this.a=0}constructor(d,y){this.extension=d,this.provider=y,this.handle=R.a++}}class L{static{this.a=0}constructor(d){this.b=new Map,this.c=new Map,this.d=d.getProxy(I.$lL.MainThreadChat)}registerChatProvider(d,y,A){const k=new R(d,A);return this.b.set(k.handle,k),this.d.$registerChatProvider(k.handle,y),(0,M.$Rc)(()=>{this.d.$unregisterChatProvider(k.handle),this.b.delete(k.handle)})}transferChatSession(d,y){const A=S.Iterable.find(this.c.keys(),k=>this.c.get(k)===d)??0;typeof A=="number"&&this.d.$transferChatSession(A,y)}sendInteractiveRequestToProvider(d,y){this.d.$sendRequestToProvider(d,y)}async $prepareChat(d,y){const A=this.b.get(d);if(!A)return;const k=await A.provider.prepareSession(y);if(!k)return;const l=L.a++;return this.c.set(l,k),{id:l,requesterUsername:k.requester?.name,requesterAvatarIconUri:k.requester?.icon,responderUsername:k.responder?.name,responderAvatarIconUri:k.responder?.icon,inputPlaceholder:k.inputPlaceholder}}$releaseSession(d){this.c.delete(d)}}e.$Agc=L}),define(Re[224],Ae([1,0,3]),function(me,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class M{constructor(R){const L=R.getProxy(S.$lL.MainThreadClipboard);this.value=Object.freeze({readText(){return L.$readText()},writeText(m){return L.$writeText(m)}})}}e.$Egc=M}),define(Re[225],Ae([1,0,26,3,27,17]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vic=void 0;let L=class{constructor(A,k){this.a=A.getProxy(M.$lL.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,k){const l=this,$=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){l.e(A,k,$,arguments)}})}e(A,k,l,$){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:d($,this.b)}),this.c&&this.f(A,l,$)}};e.$vic=L,e.$vic=L=Ge([qe(0,R.$wN),qe(1,I.$MN)],L);const m=1e5;function d(y,A){const k=[];if(y.length)for(let l=0;l<y.length;l++){let $=y[l];if(typeof $>"u")$="undefined";else if($ instanceof Error){const p=$;p.stack?$=p.stack:$=p.toString()}k.push($)}if(A){const l=new Error().stack;l&&k.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$Dn)(k);return l.length>m?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Re[226],Ae([1,0,2,3,25]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zhc=void 0;class R{constructor(m){this.a=m.getProxy(M.$lL.MainThreadDialogs)}showOpenDialog(m,d){return d?.allowUIResources&&(0,I.$LF)(m,"showLocal"),this.a.$showOpenDialog(d).then(y=>y?y.map(A=>S.URI.revive(A)):void 0)}showSaveDialog(m){return this.a.$showSaveDialog(m).then(d=>d?S.URI.revive(d):void 0)}}e.$zhc=R}),define(Re[227],Ae([1,0,6,3]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class I{constructor(L){this.b=0,this.a=L.getProxy(M.$lL.MainThreadLabelService)}$registerResourceLabelFormatter(L){const m=this.b++;return this.a.$registerResourceLabelFormatter(m,L),(0,S.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(m)})}}e.$Uhc=I}),define(Re[79],Ae([1,0,20,14,2,4,13,3,27,17]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ihc=e.$hhc=void 0;let A=class{constructor(l,$,p){this.f=p,this.d=new Map,this.a=$.getProxy(m.$lL.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,$){const{message:p,args:r,comment:c}=$;if(this.c)return(0,M.$Me)(p,r??{});let s=p;c&&c.length>0&&(s+=`/${Array.isArray(c)?c.join(""):c}`);const i=this.d.get(l)?.contents[s];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,M.$Me)(i??p,r??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let $;const p=await this.g(l);if(!p){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const r=await this.a.$fetchBundleContents(p),c=JSON.parse(r);$=l.isBuiltin?c.contents?.bundle:c}catch(r){this.f.error(`Failed to load translations for ${l.identifier.value} from ${p}: ${r.message}`);return}$&&this.d.set(l.identifier.value,{contents:$,uri:p})}async g(l){if(l.isBuiltin){const $=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return I.URI.revive($)}return l.l10n?I.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$hhc=A,e.$hhc=A=Ge([qe(0,d.$MN),qe(1,y.$wN),qe(2,L.$pj)],A),e.$ihc=(0,R.$8h)("IExtHostLocalizationService")}),define(Re[228],Ae([1,0,13,3,27,17,2,52]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=void 0;let d=class extends S.$Aj{constructor(k,l){super(l.logLevel,l.logsLocation,l.loggers.map($=>(0,m.$Eh)($))),this.r=k.getProxy(M.$lL.MainThreadLogger)}$setLogLevel(k,l){l?this.setLogLevel(L.URI.revive(l),k):this.setLogLevel(k)}setVisibility(k,l){super.setVisibility(k,l),this.r.$setVisibility(k,l)}s(k,l,$){return new y(this.r,k,l,$)}};e.$uic=d,e.$uic=d=Ge([qe(0,R.$wN),qe(1,I.$MN)],d);class y extends S.$vj{constructor(k,l,$,p){super(p?.logLevel==="always"),this.r=k,this.s=l,this.m=!1,this.n=[],this.setLevel($),this.r.$createLogger(l,p).then(()=>{this.u(this.n),this.m=!0})}g(k,l){const $=[[k,l]];this.m?this.u($):this.n.push(...$)}u(k){this.r.$log(this.s,k)}flush(){this.r.$flush(this.s)}}}),define(Re[80],Ae([1,0,3,4,6,17,23]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$khc=e.$jhc=void 0,e.$jhc=(0,M.$8h)("IExtHostManagedSockets");let m=class{constructor(k){this.b=0,this.c=null,this.d=new Map,this.a=k.getProxy(S.$lL.MainThreadManagedSockets)}setFactory(k,l){for(const $ of this.d.values())$.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new d(k,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(k){if(!this.c||this.c.socketFactoryId!==k)throw new Error(`No socket factory with id ${k}`);const l=++this.b,$=await this.c.makeConnection(),p=new I.$Sc;return this.d.set(l,new y(l,$,p)),p.add((0,I.$Rc)(()=>this.d.delete(l))),p.add($.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),p.dispose()})),p.add($.onDidClose(r=>{this.a.$onDidManagedSocketClose(l,r?.stack??r?.message),p.dispose()})),p.add($.onDidReceiveMessage(r=>this.a.$onDidManagedSocketHaveData(l,L.$ke.wrap(r)))),l}$remoteSocketWrite(k,l){this.d.get(k)?.actual.send(l.buffer)}$remoteSocketEnd(k){const l=this.d.get(k);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(k){await this.d.get(k)?.actual.drain?.()}};e.$khc=m,e.$khc=m=Ge([qe(0,R.$wN)],m);class d{constructor(k,l){this.socketFactoryId=k,this.makeConnection=l}}class y extends I.$Tc{constructor(k,l,$){super(),this.socketId=k,this.actual=l,this.B($)}}}),define(Re[229],Ae([1,0,3,13,25]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;function R(m){return m&&m.title}let L=class{constructor(d,y){this.b=y,this.a=d.getProxy(S.$lL.MainThreadMessageService)}showMessage(d,y,A,k,l){const $={source:{identifier:d.identifier,label:d.displayName||d.name}};let p;typeof k=="string"||R(k)?p=[k,...l]:($.modal=k?.modal,$.useCustom=k?.useCustom,$.detail=k?.detail,p=l),$.useCustom&&(0,I.$LF)(d,"resolvers");const r=[];let c=!1;for(let s=0;s<p.length;s++){const i=p[s];if(typeof i=="string")r.push({title:i,handle:s,isCloseAffordance:!1});else if(typeof i=="object"){const{title:o,isCloseAffordance:a}=i;r.push({title:o,isCloseAffordance:!!a,handle:s}),a&&(c?this.b.warn(`[${d.identifier}] Only one message item can have 'isCloseAffordance':`,i):c=!0)}else this.b.warn(`[${d.identifier}] Invalid message item:`,i)}return this.a.$showMessage(y,A,$,r).then(s=>{if(typeof s=="number")return p[s]})}};e.$Whc=L,e.$Whc=L=Ge([qe(1,M.$pj)],L)}),define(Re[230],Ae([1,0,6,16,2,25,3]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=void 0;class m{constructor(y){this.b=new Map,this.a=y.getProxy(L.$lL.MainThreadProfileContentHandlers)}registerProfileContentHandler(y,A,k){if((0,R.$LF)(y,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,k),this.a.$registerProfileContentHandler(A,k.name,k.description,y.identifier.value),(0,S.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(y,A,k,l){const $=this.b.get(y);if(!$)throw new Error(`Unknown handler with id: ${y}`);return $.saveProfile(A,k,l)}async $readProfile(y,A,k){const l=this.b.get(y);if(!l)throw new Error(`Unknown handler with id: ${y}`);return l.readProfile((0,M.$Jf)(A)?A:I.URI.revive(A),k)}}e.$6hc=m}),define(Re[81],Ae([1,0,3,5,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=e.$ehc=void 0;class R{constructor(m){this.b=new M.$Wd,this.onDidChangePassword=this.b.event,this.a=m.getProxy(S.$lL.MainThreadSecretState)}async $onDidChangePassword(m){this.b.fire(m)}get(m,d){return this.a.$getPassword(m,d)}store(m,d,y){return this.a.$setPassword(m,d,y)}delete(m,d){return this.a.$deletePassword(m,d)}}e.$ehc=R,e.$fhc=(0,I.$8h)("IExtHostSecretState")}),define(Re[231],Ae([1,0,21,6,3]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class R{static{this.a=1}constructor(m){this.c=new Map,this.d=new Map,this.b=m.getProxy(I.$lL.MainThreadSpeech)}async $createSpeechToTextSession(m,d){const y=this.c.get(m);if(!y)return;const A=new M.$Sc,k=new S.$7d;this.d.set(d,k);const l=A.add(y.provideSpeechToTextSession(k.token));A.add(l.onDidChange($=>{k.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(d,$)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}async $createKeywordRecognitionSession(m,d){const y=this.c.get(m);if(!y)return;const A=new M.$Sc,k=new S.$7d;this.d.set(d,k);const l=A.add(y.provideKeywordRecognitionSession(k.token));A.add(l.onDidChange($=>{k.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(d,$)})),A.add(k.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(m){this.d.get(m)?.dispose(!0),this.d.delete(m)}registerProvider(m,d,y){const A=R.a++;return this.c.set(A,y),this.b.$registerProvider(A,d,{extension:m,displayName:m.value}),(0,M.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$aic=R}),define(Re[82],Ae([1,0,3,5,4]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0gc=e.$9gc=void 0;class R{constructor(m,d){this.c=d,this.b=new M.$Wd,this.onDidChangeStorage=this.b.event,this.a=m.getProxy(S.$lL.MainThreadStorage)}registerExtensionStorageKeysToSync(m,d){this.a.$registerExtensionStorageKeysToSync(m,d)}async initializeExtensionStorage(m,d,y){const A=await this.a.$initializeExtensionStorage(m,d);let k;return A&&(k=this.d(m,d,A)),k||y}setValue(m,d,y){return this.a.$setValue(m,d,y)}$acceptValue(m,d,y){const A=this.d(m,d,y);A&&this.b.fire({shared:m,key:d,value:A})}d(m,d,y){try{return JSON.parse(y)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${d}, global: ${m}): ${A}`)}}}e.$9gc=R,e.$0gc=(0,I.$8h)("IExtHostStorage")}),define(Re[232],Ae([1,0,6,12,2,3]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;class L{static{this.a=new Set([M.Schemas.http,M.Schemas.https])}constructor(d){this.c=new Map,this.b=d.getProxy(R.$lL.MainThreadUriOpeners)}registerExternalUriOpener(d,y,A,k){if(this.c.has(y))throw new Error(`Opener with id '${y}' already registered`);const l=k.schemes.find($=>!L.a.has($));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(y,A),this.b.$registerUriOpener(y,k.schemes,d,k.label),(0,S.$Rc)(()=>{this.c.delete(y),this.b.$unregisterUriOpener(y)})}async $canOpenUri(d,y,A){const k=this.c.get(d);if(!k)throw new Error(`Unknown opener with id: ${d}`);const l=I.URI.revive(y);return k.canOpenExternalUri(l,A)}async $openUri(d,y,A){const k=this.c.get(d);if(!k)throw new Error(`Unknown opener id: '${d}'`);return k.openExternalUri(I.URI.revive(y.resolvedUri),{sourceUri:I.URI.revive(y.sourceUri)},A)}}e.$oic=L}),define(Re[233],Ae([1,0,3,2,6,15,22]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pic=void 0;class m{static{this.a=0}constructor(y){this.c=new L.$om,this.d=new Map,this.b=y.getProxy(S.$lL.MainThreadUrls)}registerUriHandler(y,A){const k=y.identifier;if(this.c.has(k))throw new Error(`Protocol handler already registered for extension ${k}`);const l=m.a++;return this.c.add(k),this.d.set(l,A),this.b.$registerUriHandler(l,k,y.displayName||y.name),(0,I.$Rc)(()=>{this.c.delete(k),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(y,A){const k=this.d.get(y);if(!k)return Promise.resolve(void 0);try{k.handleUri(M.URI.revive(A))}catch(l){(0,R.$1)(l)}return Promise.resolve(void 0)}async createAppUri(y){return M.URI.revive(await this.b.$createAppUri(y))}}e.$pic=m}),define(Re[61],Ae([1,0,5,6,12,26,2,181,203,76,3]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=e.$Wgc=e.$Vgc=e.$Ugc=e.$Tgc=void 0;class k{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(a,u,t,f,n,w,D){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$Wd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$Wd,this._onDidDispose=this.#h.event,this.#e=a,this.#t=u,this.#o=t,this.#n=f,this.#s=n,this.#r=w,this.#l=l(w),this.#d=$(w),this.#i=D}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(a){return this.#u=!0,(0,y.$Cwb)(a,this.#n)}get cspSource(){const a=this.#r.extensionLocation;if(a.scheme===I.Schemas.https||a.scheme===I.Schemas.http){let u=a.toString();return u.endsWith("/")||(u+="/"),u+" "+y.$Bwb}return y.$Bwb}get html(){return this.a(),this.#a}set html(a){this.a(),this.#a!==a&&(this.#a=a,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(a)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(a)))}get options(){return this.a(),this.#o}set options(a){this.a(),R.$Cn(this.#o,a)||this.#t.$setOptions(this.#e,c(this.#r,this.#s,a)),this.#o=a}async postMessage(a){if(this.#c)return!1;const u=(0,d.$Tlb)(a,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(a){if(!this.#d)return a;const u=this.#r.extensionLocation?.scheme===I.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===I.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return a.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,n,w,D,h,b)=>{const P=L.URI.from({scheme:D||"file",path:decodeURIComponent(h)}),g=(0,y.$Cwb)(P,{isRemote:u,authority:t}).toString();return`${n}${g}${b}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(f,n,w,D,h,b)=>{const P=L.URI.from({scheme:D||"file",path:decodeURIComponent(h)}),g=(0,y.$Cwb)(P,{isRemote:u,authority:t}).toString();return`${n}${g}${b}`})}}e.$Tgc=k;function l(o){try{const a=(0,m.$ep)((0,m.$dp)(o.engines.vscode));return!!a&&a.majorBase>=1&&a.minorBase>=57}catch{return!1}}e.$Ugc=l;function $(o){try{const a=(0,m.$ep)((0,m.$dp)(o.engines.vscode));return a?a.majorBase<1||a.majorBase===1&&a.minorBase<60:!1}catch{return!1}}class p extends M.$Tc{constructor(a,u,t,f,n){super(),this.c=u,this.f=t,this.g=f,this.h=n,this.b=new Map,this.a=a.getProxy(A.$lL.MainThreadWebviews)}dispose(){super.dispose();for(const a of this.b.values())a.dispose();this.b.clear()}$onMessage(a,u,t){const f=this.j(a);if(f){const{message:n}=(0,d.$Ulb)(u,t.value);f._onMessageEmitter.fire(n)}}$onMissingCsp(a,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(a,u,t){const f=new k(a,this.a,s(u),this.c,this.f,t,this.h);this.b.set(a,f);const n=f._onDidDispose(()=>{n.dispose(),this.deleteWebview(a)});return f}deleteWebview(a){this.b.delete(a)}j(a){return this.b.get(a)}}e.$Vgc=p;function r(o){return{id:o.identifier,location:o.extensionLocation}}e.$Wgc=r;function c(o,a,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||i(o,a)}}e.$Xgc=c;function s(o){return{enableCommandUris:o.enableCommandUris,enableScripts:o.enableScripts,enableForms:o.enableForms,portMapping:o.portMapping,localResourceRoots:o.localResourceRoots?.map(a=>L.URI.from(a))}}function i(o,a){return[...(a?.getWorkspaceFolders()||[]).map(u=>u.uri),o.extensionLocation]}}),define(Re[106],Ae([1,0,5,3,2,12,14,4,17,25]),function(me,e,S,M,I,R,L,m,d,y){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=e.$ric=void 0;let k=class{static{A=this}static{this.a={focused:!0,active:!0}}getState($){const p=this.d;return{get focused(){return p.focused},get active(){return(0,y.$LF)($,"windowActivity"),p.active}}}constructor($){this.c=new S.$Wd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=$.getProxy(M.$lL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:p,isActive:r})=>{this.onDidChangeWindowProperty("focused",p),this.onDidChangeWindowProperty("active",r)})}$onDidChangeWindowFocus($){this.onDidChangeWindowProperty("focused",$)}$onDidChangeWindowActive($){this.onDidChangeWindowProperty("active",$)}onDidChangeWindowProperty($,p){p!==this.d[$]&&(this.d={...this.d,[$]:p},this.c.fire(this.d))}openUri($,p){let r;if(typeof $=="string"){r=$;try{$=I.URI.parse($)}catch{return Promise.reject(`Invalid uri - '${$}'`)}}return(0,L.$Ke)($.scheme)?Promise.reject("Invalid scheme - cannot be empty"):$.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${$.scheme}'`):this.b.$openUri($,r,p)}async asExternalUri($,p){if((0,L.$Ke)($.scheme))return Promise.reject("Invalid scheme - cannot be empty");const r=await this.b.$asExternalUri($,p);return I.URI.from(r)}};e.$ric=k,e.$ric=k=A=Ge([qe(0,d.$wN)],k),e.$sic=(0,m.$8h)("IExtHostWindow")}),define(Re[234],Ae([1,0,225,27,17]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ekc=void 0;let R=class extends S.$vic{constructor(m,d){super(m,d)}f(m,d,y){d.apply(console,y)}};e.$Ekc=R,e.$Ekc=R=Ge([qe(0,I.$wN),qe(1,M.$MN)],R)}),define(Re[235],Ae([1,0,11,23,21,15,5,6,139,222,50]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.$y8b=e.ResponsiveState=e.RequestInitiator=e.$x8b=e.$w8b=void 0;function l(E,T){try{return JSON.stringify(E,T)}catch{return"null"}}const $="$$ref$$",p={[$]:-1};class r{constructor(T,N){this.jsonString=T,this.referencedBuffers=N}}function c(E,T=null,N=!1){const J=[];return{jsonString:(N?l:JSON.stringify)(E,(U,C)=>{if(typeof C>"u")return p;if(typeof C=="object"){if(C instanceof M.$ke){const F=J.push(C)-1;return{[$]:F}}if(T)return T(U,C)}return C}),referencedBuffers:J}}e.$w8b=c;function s(E,T,N){return JSON.parse(E,(J,q)=>{if(q){const U=q[$];if(typeof U=="number")return T[U];if(N&&q.$mid===1)return N.transformIncoming(q)}return q})}e.$x8b=s;function i(E,T){return JSON.stringify(E,T)}function o(E){return E?(T,N)=>N&&N.$mid===1?E.transformOutgoing(N):N:null}var a;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(a||(e.RequestInitiator=a={}));var u;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const t=()=>{},f=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class w extends m.$Tc{static{k=f}static{this.a=3*1e3}constructor(T,N=null,J=null){super(),this[k]=!0,this.b=this.B(new L.$Wd),this.onDidChangeResponsiveState=this.b.event,this.c=T,this.f=N,this.g=J,this.h=o(this.g),this.j=!1,this.m=[],this.s=[];for(let q=0,U=A.$Sv.count;q<U;q++)this.m[q]=null,this.s[q]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$hh(()=>this.H(),1e3)),this.c.onMessage(q=>this.L(q))}dispose(){this.j=!0,Object.keys(this.w).forEach(T=>{const N=this.w[T];delete this.w[T],N.resolveErr(R.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(T){this.z===0&&(this.C=Date.now()+w.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(T){this.C=Date.now()+w.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(T){this.y!==T&&(this.y=T,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(T){return this.g?(0,d.$0m)(T,this.g):T}getProxy(T){const{nid:N,sid:J}=T;return this.s[N]||(this.s[N]=this.J(N,J)),this.s[N]}J(T,N){const J={get:(q,U)=>(typeof U=="string"&&!q[U]&&U.charCodeAt(0)===36&&(q[U]=(...C)=>this.U(T,U,C)),U===n?N:q[U])};return new Proxy(Object.create(null),J)}set(T,N){return this.m[T.nid]=N,N}assertRegistered(T){for(let N=0,J=T.length;N<J;N++){const q=T[N];if(!this.m[q.nid])throw new Error(`Missing proxy instance ${q.sid}`)}}L(T){if(this.j)return;const N=T.byteLength,J=h.read(T,0),q=J.readUInt8(),U=J.readUInt32();switch(q){case 1:case 2:{let{rpcId:C,method:F,args:W}=P.deserializeRequestJSONArgs(J);this.g&&(W=(0,d.$0m)(W,this.g)),this.M(N,U,C,F,W,q===2);break}case 3:case 4:{let{rpcId:C,method:F,args:W}=P.deserializeRequestMixedArgs(J);this.g&&(W=(0,d.$0m)(W,this.g)),this.M(N,U,C,F,W,q===4);break}case 5:{this.f?.logIncoming(N,U,0,"ack"),this.G(U);break}case 6:{this.N(N,U);break}case 7:{this.O(N,U,void 0);break}case 9:{let C=P.deserializeReplyOKJSON(J);this.g&&(C=(0,d.$0m)(C,this.g)),this.O(N,U,C);break}case 10:{const C=P.deserializeReplyOKJSONWithBuffers(J,this.g);this.O(N,U,C);break}case 8:{const C=P.deserializeReplyOKVSBuffer(J);this.O(N,U,C);break}case 11:{let C=P.deserializeReplyErrError(J);this.g&&(C=(0,d.$0m)(C,this.g)),this.P(N,U,C);break}case 12:{this.P(N,U,void 0);break}default:console.error("received unexpected message"),console.error(T)}}M(T,N,J,q,U,C){this.f?.logIncoming(T,N,1,`receiveRequest ${(0,A.$Uv)(J)}.${q}(`,U);const F=String(N);let W,re;if(C){const we=new I.$7d;U.push(we.token),W=this.Q(J,q,U),re=()=>we.cancel()}else W=this.Q(J,q,U),re=t;this.u[F]=re;const ce=P.serializeAcknowledged(N);this.f?.logOutgoing(ce.byteLength,N,1,"ack"),this.c.send(ce),W.then(we=>{delete this.u[F];const De=P.serializeReplyOK(N,we,this.h);this.f?.logOutgoing(De.byteLength,N,1,"reply:",we),this.c.send(De)},we=>{delete this.u[F];const De=P.serializeReplyErr(N,we);this.f?.logOutgoing(De.byteLength,N,1,"replyErr:",we),this.c.send(De)})}N(T,N){this.f?.logIncoming(T,N,1,"receiveCancel");const J=String(N);this.u[J]?.()}O(T,N,J){this.f?.logIncoming(T,N,0,"receiveReply:",J);const q=String(N);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q],U.resolveOk(J)}P(T,N,J){this.f?.logIncoming(T,N,0,"receiveReplyErr:",J);const q=String(N);if(!this.w.hasOwnProperty(q))return;const U=this.w[q];delete this.w[q];let C;J&&(J.$isError?(C=new Error,C.name=J.name,C.message=J.message,C.stack=J.stack):C=J),U.resolveErr(C)}Q(T,N,J){try{return Promise.resolve(this.S(T,N,J))}catch(q){return Promise.reject(q)}}S(T,N,J){const q=this.m[T];if(!q)throw new Error("Unknown actor "+(0,A.$Uv)(T));const U=q[N];if(typeof U!="function")throw new Error("Unknown method "+N+" on actor "+(0,A.$Uv)(T));return U.apply(q,J)}U(T,N,J){if(this.j)return new y.$v8b;let q=null;if(J.length>0&&I.CancellationToken.isCancellationToken(J[J.length-1])&&(q=J.pop()),q&&q.isCancellationRequested)return Promise.reject(R.$6());const U=P.serializeRequestArguments(J,this.h),C=++this.t,F=String(C),W=new y.$u8b,re=new m.$Sc;q&&re.add(q.onCancellationRequested(()=>{const we=P.serializeCancel(C);this.f?.logOutgoing(we.byteLength,C,0,"cancel"),this.c.send(P.serializeCancel(C))})),this.w[F]=new D(W,re),this.F(C);const ce=P.serializeRequest(C,T,N,U,!!q);return this.f?.logOutgoing(ce.byteLength,C,0,`request: ${(0,A.$Uv)(T)}.${N}(`,J),this.c.send(ce),W}}e.$y8b=w;class D{constructor(T,N){this.a=T,this.b=N}resolveOk(T){this.a.resolveOk(T),this.b.dispose()}resolveErr(T){this.a.resolveErr(T),this.b.dispose()}}class h{static alloc(T,N,J){const q=new h(M.$ke.alloc(J+1+4),0);return q.writeUInt8(T),q.writeUInt32(N),q}static read(T,N){return new h(T,N)}get buffer(){return this.a}constructor(T,N){this.a=T,this.b=N}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(T){this.a.writeUInt8(T,this.b),this.b+=1}readUInt8(){const T=this.a.readUInt8(this.b);return this.b+=1,T}writeUInt32(T){this.a.writeUInt32BE(T,this.b),this.b+=4}readUInt32(){const T=this.a.readUInt32BE(this.b);return this.b+=4,T}static sizeShortString(T){return 1+T.byteLength}writeShortString(T){this.a.writeUInt8(T.byteLength,this.b),this.b+=1,this.a.set(T,this.b),this.b+=T.byteLength}readShortString(){const T=this.a.readUInt8(this.b);this.b+=1;const J=this.a.slice(this.b,this.b+T).toString();return this.b+=T,J}static sizeLongString(T){return 4+T.byteLength}writeLongString(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readLongString(){const T=this.a.readUInt32BE(this.b);this.b+=4;const J=this.a.slice(this.b,this.b+T).toString();return this.b+=T,J}writeBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}static sizeVSBuffer(T){return 4+T.byteLength}writeVSBuffer(T){this.a.writeUInt32BE(T.byteLength,this.b),this.b+=4,this.a.set(T,this.b),this.b+=T.byteLength}readVSBuffer(){const T=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+T);return this.b+=T,N}static sizeMixedArray(T){let N=0;N+=1;for(let J=0,q=T.length;J<q;J++){const U=T[J];switch(N+=1,U.type){case 1:N+=this.sizeLongString(U.value);break;case 2:N+=this.sizeVSBuffer(U.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(U.value);for(let C=0;C<U.buffers.length;++C)N+=this.sizeVSBuffer(U.buffers[C]);break;case 4:break}}return N}writeMixedArray(T){this.a.writeUInt8(T.length,this.b),this.b+=1;for(let N=0,J=T.length;N<J;N++){const q=T[N];switch(q.type){case 1:this.writeUInt8(1),this.writeLongString(q.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(q.value);break;case 3:this.writeUInt8(3),this.writeUInt32(q.buffers.length),this.writeLongString(q.value);for(let U=0;U<q.buffers.length;++U)this.writeBuffer(q.buffers[U]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const T=this.a.readUInt8(this.b);this.b+=1;const N=new Array(T);for(let J=0;J<T;J++)switch(this.readUInt8()){case 1:N[J]=this.readLongString();break;case 2:N[J]=this.readVSBuffer();break;case 3:{const U=this.readUInt32(),C=this.readLongString(),F=[];for(let W=0;W<U;++W)F.push(this.readVSBuffer());N[J]=new A.$Vv(s(C,F,null));break}case 4:N[J]=void 0;break}return N}}var b;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(b||(b={}));class P{static a(T){for(let N=0,J=T.length;N<J;N++)if(T[N]instanceof M.$ke||T[N]instanceof A.$Vv||typeof T[N]>"u")return!0;return!1}static serializeRequestArguments(T,N){if(this.a(T)){const J=[];for(let q=0,U=T.length;q<U;q++){const C=T[q];if(C instanceof M.$ke)J[q]={type:2,value:C};else if(typeof C>"u")J[q]={type:4};else if(C instanceof A.$Vv){const{jsonString:F,referencedBuffers:W}=c(C.value,N);J[q]={type:3,value:M.$ke.fromString(F),buffers:W}}else J[q]={type:1,value:M.$ke.fromString(i(C,N))}}return{type:1,args:J}}return{type:0,args:i(T,N)}}static serializeRequest(T,N,J,q,U){switch(q.type){case 0:return this.b(T,N,J,q.args,U);case 1:return this.c(T,N,J,q.args,U)}}static b(T,N,J,q,U){const C=M.$ke.fromString(J),F=M.$ke.fromString(q);let W=0;W+=h.sizeUInt8(),W+=h.sizeShortString(C),W+=h.sizeLongString(F);const re=h.alloc(U?2:1,T,W);return re.writeUInt8(N),re.writeShortString(C),re.writeLongString(F),re.buffer}static deserializeRequestJSONArgs(T){const N=T.readUInt8(),J=T.readShortString(),q=T.readLongString();return{rpcId:N,method:J,args:JSON.parse(q)}}static c(T,N,J,q,U){const C=M.$ke.fromString(J);let F=0;F+=h.sizeUInt8(),F+=h.sizeShortString(C),F+=h.sizeMixedArray(q);const W=h.alloc(U?4:3,T,F);return W.writeUInt8(N),W.writeShortString(C),W.writeMixedArray(q),W.buffer}static deserializeRequestMixedArgs(T){const N=T.readUInt8(),J=T.readShortString(),q=T.readMixedArray(),U=new Array(q.length);for(let C=0,F=q.length;C<F;C++){const W=q[C];typeof W=="string"?U[C]=JSON.parse(W):U[C]=W}return{rpcId:N,method:J,args:U}}static serializeAcknowledged(T){return h.alloc(5,T,0).buffer}static serializeCancel(T){return h.alloc(6,T,0).buffer}static serializeReplyOK(T,N,J){if(typeof N>"u")return this.d(T);if(N instanceof M.$ke)return this.e(T,N);if(N instanceof A.$Vv){const{jsonString:q,referencedBuffers:U}=c(N.value,J,!0);return this.g(T,q,U)}else return this.f(T,l(N,J))}static d(T){return h.alloc(7,T,0).buffer}static e(T,N){let J=0;J+=h.sizeVSBuffer(N);const q=h.alloc(8,T,J);return q.writeVSBuffer(N),q.buffer}static deserializeReplyOKVSBuffer(T){return T.readVSBuffer()}static f(T,N){const J=M.$ke.fromString(N);let q=0;q+=h.sizeLongString(J);const U=h.alloc(9,T,q);return U.writeLongString(J),U.buffer}static g(T,N,J){const q=M.$ke.fromString(N);let U=0;U+=h.sizeUInt32,U+=h.sizeLongString(q);for(const F of J)U+=h.sizeVSBuffer(F);const C=h.alloc(10,T,U);C.writeUInt32(J.length),C.writeLongString(q);for(const F of J)C.writeBuffer(F);return C.buffer}static deserializeReplyOKJSON(T){const N=T.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(T,N){const J=T.readUInt32(),q=T.readLongString(),U=[];for(let C=0;C<J;++C)U.push(T.readVSBuffer());return new A.$Vv(s(q,U,N))}static serializeReplyErr(T,N){const J=N?l(R.$3(N),null):void 0;if(typeof J!="string")return this.h(T);const q=M.$ke.fromString(J);let U=0;U+=h.sizeLongString(q);const C=h.alloc(11,T,U);return C.writeLongString(q),C.buffer}static deserializeReplyErrError(T){const N=T.readLongString();return JSON.parse(N)}static h(T){return h.alloc(12,T,0).buffer}}var g;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(g||(g={}));var v;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(v||(v={}))}),define(Re[236],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gkc=void 0;const S=function(R){const L=m=>{globalThis.removeEventListener("message",L);const d=m.data;Object.defineProperties(globalThis,{postMessage:{value(y,A){d.postMessage(y,A)}},onmessage:{get(){return d.onmessage},set(y){d.onmessage=y}}}),d.addEventListener("message",y=>{globalThis.dispatchEvent(new MessageEvent("message",{data:y.data,ports:y.ports?[...y.ports]:void 0}))}),d.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(R)};globalThis.addEventListener("message",L)}.toString();class M extends EventTarget{constructor(R,L,m){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const d=`((${S})('${L}'))`,y=new Blob([d],{type:"application/javascript"}),A=URL.createObjectURL(y),k=new MessageChannel,l=A,$={type:"_newWorker",id:l,port:k.port2,url:A,options:m};R($,[k.port2]),this.postMessage=k.port1.postMessage.bind(k.port1),this.terminate=()=>{R({type:"_terminateWorker",id:l}),URL.revokeObjectURL(A),k.port1.close(),k.port2.close()},Object.defineProperties(this,{onmessage:{get(){return k.port1.onmessage},set(p){k.port1.onmessage=p}},onmessageerror:{get(){return k.port1.onmessageerror},set(p){k.port1.onmessageerror=p}}}),k.port1.addEventListener("messageerror",p=>{const r=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(r)}),k.port1.addEventListener("message",p=>{const r=new MessageEvent("message",{data:p.data});this.dispatchEvent(r)}),k.port1.start()}}e.$Gkc=M}),define(Re[237],Ae([1,0,23,28,12,53,4]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$I=e.$0I=e.$9I=e.$8I=void 0,e.$8I=(0,L.$8h)("notebookDocumentService");const m=["W","X","Y","Z","a","b","c","d","e","f"],d=new RegExp(`^[${m.join("")}]+`),y=7;function A($){if($.scheme!==I.Schemas.vscodeNotebookCell)return;const p=$.fragment.indexOf("s");if(p<0)return;const r=parseInt($.fragment.substring(0,p).replace(d,""),y),c=(0,S.$De)($.fragment.substring(p+1)).toString();if(!isNaN(r))return{handle:r,notebook:$.with({scheme:c,fragment:null})}}e.$9I=A;function k($,p){const r=p.toString(y),s=`${r.length<m.length?m[r.length-1]:"z"}${r}s${(0,S.$Ee)(S.$ke.fromString($.scheme),!0,!0)}`;return $.with({scheme:I.Schemas.vscodeNotebookCell,fragment:s})}e.$0I=k;class l{constructor(){this.a=new M.$Ac}getNotebook(p){if(p.scheme===I.Schemas.vscodeNotebookCell){const r=A(p);if(r){const c=this.a.get(r.notebook);if(c)return c}}return this.a.get(p)}addNotebookDocument(p){this.a.set(p.uri,p)}removeNotebookDocument(p){this.a.delete(p.uri)}}e.$$I=l,(0,R.$1r)(e.$8I,l,1)}),define(Re[83],Ae([1,0,23,34,68,69,12,19,20,35,237]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.CellStatusbarAlignment=e.$mJ=e.$lJ=e.$kJ=e.NotebookEditorPriority=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.CellKind=e.$bJ=e.$aJ=e.$_I=void 0,e.$_I="workbench.editor.notebook",e.$aJ="workbench.editor.notebookTextDiffEditor",e.$bJ="workbench.editor.interactive";var k;(function(W){W[W.Markup=1]="Markup",W[W.Code=2]="Code"})(k||(e.CellKind=k={})),e.$cJ=["application/json","application/javascript","text/html","image/svg+xml",R.$hs.latex,R.$hs.markdown,"image/png","image/jpeg",R.$hs.text],e.$dJ=[R.$hs.latex,R.$hs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",R.$hs.text],e.$eJ=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$fJ="_notAvailable";var l;(function(W){W[W.Running=1]="Running",W[W.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var $;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})($||(e.NotebookCellExecutionState=$={}));var p;(function(W){W[W.Unconfirmed=1]="Unconfirmed",W[W.Pending=2]="Pending",W[W.Executing=3]="Executing"})(p||(e.NotebookExecutionState=p={}));var r;(function(W){W[W.WithHardKernelDependency=0]="WithHardKernelDependency",W[W.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",W[W.Pure=2]="Pure",W[W.Never=3]="Never"})(r||(e.NotebookRendererMatch=r={}));var c;(function(W){W.Always="always",W.Never="never",W.Optional="optional"})(c||(e.RendererMessagingSpec=c={}));var s;(function(W){W[W.ModelChange=1]="ModelChange",W[W.Move=2]="Move",W[W.ChangeCellLanguage=5]="ChangeCellLanguage",W[W.Initialize=6]="Initialize",W[W.ChangeCellMetadata=7]="ChangeCellMetadata",W[W.Output=8]="Output",W[W.OutputItem=9]="OutputItem",W[W.ChangeCellContent=10]="ChangeCellContent",W[W.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",W[W.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",W[W.ChangeCellMime=13]="ChangeCellMime",W[W.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var i;(function(W){W[W.Handle=0]="Handle",W[W.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var o;(function(W){W[W.Replace=1]="Replace",W[W.Output=2]="Output",W[W.Metadata=3]="Metadata",W[W.CellLanguage=4]="CellLanguage",W[W.DocumentMetadata=5]="DocumentMetadata",W[W.Move=6]="Move",W[W.OutputItems=7]="OutputItems",W[W.PartialMetadata=8]="PartialMetadata",W[W.PartialInternalMetadata=9]="PartialInternalMetadata"})(o||(e.CellEditType=o={}));var a;(function(W){W.scheme=L.Schemas.vscodeNotebookCell;function re(se,$e){return(0,A.$0I)(se,$e)}W.generate=re;function ce(se){return(0,A.$9I)(se)}W.parse=ce;function we(se,$e){return se.with({scheme:L.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${se.scheme!==L.Schemas.file?se.scheme:""}`})}W.generateCellOutputUri=we;function De(se){if(se.scheme!==L.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(se.fragment);if(!$e)return;const te=$e[1]&&$e[1]!==""?$e[1]:void 0,X=$e[2];return{outputId:te,notebook:se.with({scheme:X||L.Schemas.file,fragment:null})}}W.parseCellOutputUri=De;function le(se,$e,te){return W.generate(se,$e).with({scheme:te})}W.generateCellPropertyUri=le;function ve(se,$e){if(se.scheme===$e)return W.parse(se.with({scheme:W.scheme}))}W.parseCellPropertyUri=ve})(a||(e.CellUri=a={}));const u=W=>d.$i?W.replace(/\//g,"\\"):W;class t{constructor(re=[],ce=e.$cJ){this.e=ce,this.d=[...new Set(re)].map(we=>({pattern:we,matches:M.$Oj(u(we))}))}sort(re){const ce=new Map(I.Iterable.map(re,De=>[De,u(De)]));let we=[];for(const{matches:De}of this.d)for(const[le,ve]of ce)if(De(ve)){we.push(le),ce.delete(le);break}return ce.size&&(we=we.concat([...ce.keys()].sort((De,le)=>this.e.indexOf(De)-this.e.indexOf(le)))),we}prioritize(re,ce){const we=this.f(re);if(we===-1){this.d.unshift({pattern:re,matches:M.$Oj(u(re))});return}const De=new Set(ce.map(ve=>this.f(ve,we)));De.delete(-1);const le=Array.from(De).sort();this.d.splice(we+1,0,...le.map(ve=>this.d[ve]));for(let ve=le.length-1;ve>=0;ve--)this.d.splice(le[ve],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ce=this.d.length){const we=u(re);for(let De=0;De<ce;De++)if(this.d[De].matches(we))return De;return-1}}e.$gJ=t;function f(W,re,ce,we=(De,le)=>De===le){const De=[];function le($e,te,X){if(te===0&&X.length===0)return;const V=De[De.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=te,V.toInsert.push(...X)):De.push({start:$e,deleteCount:te,toInsert:X})}let ve=0,se=0;for(;;){if(ve===W.length){le(ve,0,re.slice(se));break}if(se===re.length){le(ve,W.length-ve,[]);break}const $e=W[ve],te=re[se];if(we($e,te)){ve+=1,se+=1;continue}ce(te)?(le(ve,1,[]),ve+=1):(le(ve,0,[te]),se+=1)}return De}e.$hJ=f,e.$iJ=new y.$mj("notebookEditorCursorAtBoundary","none"),e.$jJ=new y.$mj("notebookEditorCursorAtLineBoundary","none");var n;(function(W){W.default="default",W.option="option"})(n||(e.NotebookEditorPriority=n={}));function w(W){const re=W;return!!((typeof re.include=="string"||M.$Pj(re.include))&&(typeof re.exclude=="string"||M.$Pj(re.exclude)))}e.$kJ=w;function D(W,re,ce){if(Array.isArray(W.viewType)&&W.viewType.indexOf(re)>=0||W.viewType===re)return!0;if(W.filenamePattern){const we=w(W.filenamePattern)?W.filenamePattern.include:W.filenamePattern,De=w(W.filenamePattern)?W.filenamePattern.exclude:void 0;if(M.$Nj(we,(0,m.$nc)(ce.fsPath).toLowerCase()))return!(De&&M.$Nj(De,(0,m.$nc)(ce.fsPath).toLowerCase()))}return!1}e.$lJ=D,e.$mJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView"};var h;(function(W){W[W.Left=1]="Left",W[W.Right=2]="Right"})(h||(e.CellStatusbarAlignment=h={}));class b{static{this.d="notebook/"}static create(re){return`${b.d}${re}`}static parse(re){if(re.startsWith(b.d))return re.substring(b.d.length)}}e.$nJ=b;function P(W){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(W)}e.$oJ=P;const g=new TextDecoder;function v(W){const re=[];let ce=!1;for(const ve of W)(re.length===0||ce)&&(re.push(ve),ce=!0);let we=N(re);const De=S.$ke.concat(re.map(ve=>S.$ke.wrap(ve))),le=F(De);return we=we||le.byteLength!==De.byteLength,{data:le,didCompression:we}}e.$pJ=v,e.$qJ="\x1B[A";const E=e.$qJ.split("").map(W=>W.charCodeAt(0)),T=10;function N(W){let re=!1;return W.forEach((ce,we)=>{if(we===0||ce.length<e.$qJ.length)return;const De=W[we-1],le=ce.subarray(0,e.$qJ.length);if(le[0]===E[0]&&le[1]===E[1]&&le[2]===E[2]){const ve=De.lastIndexOf(T);if(ve===-1)return;re=!0,W[we-1]=De.subarray(0,ve),W[we]=ce.subarray(e.$qJ.length)}}),re}function J(W){let re=W;do W=re,re=W.replace(/[^\n]\x08/gm,"");while(re.length<W.length);return W}function q(W){for(W=W.replace(/\r+\n/gm,`
`);W.search(/\r[^$]/g)>-1;){const re=W.match(/^(.*)\r+/m)[1];let ce=W.match(/\r+(.*)$/m)[1];ce=ce+re.slice(ce.length,re.length),W=W.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ce)}return W}const U=8,C=13;function F(W){return!W.buffer.includes(U)&&!W.buffer.includes(C)?W:S.$ke.fromString(q(J(g.decode(W.buffer))))}}),define(Re[7],Ae([1,0,18,15,46,28,69,14,16,2,33,22,42,100,83]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p){"use strict";var r,c,s,i,o,a,u,t,f,n,w,D,h,b,P,g,v;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$lN=e.$kN=e.$jN=e.$iN=e.$hN=e.$gN=e.ChatAgentResultFeedbackKind=e.$fN=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$eN=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$dN=e.$cN=e.$bN=e.$aN=e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.$7M=e.$6M=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.TestRunProfileKind=e.TestResultState=e.$WM=e.$VM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$UM=e.NotebookVariablesRequestKind=e.$TM=e.$SM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$RM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.ColorThemeKind=e.$LM=e.$KM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$JM=e.$IM=e.DebugConsoleMode=e.$HM=e.$GM=e.$FM=e.$EM=e.$DM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$CM=e.$BM=e.FileChangeType=e.$AM=e.$zM=e.$yM=e.$xM=e.InlineCompletionTriggerKind=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.$mM=e.$lM=e.$kM=e.ConfigurationTarget=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$aM=e.ViewBadge=e.ProgressLocation=e.$_L=e.$$L=e.TaskScope=e.ShellQuoting=e.$0L=e.$9L=e.$8L=e.TaskPanelKind=e.TaskRevealKind=e.$7L=e.TerminalLocation=e.$6L=e.$5L=e.$4L=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$3L=e.$2L=e.$1L=e.$ZL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$YL=e.StatusBarAlignment=e.ViewColumn=e.$XL=e.$WL=e.$VL=e.$UL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$TL=e.$SL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$RL=e.$QL=e.$PL=e.$OL=e.$NL=e.LanguageStatusSeverity=e.$ML=e.$LL=e.$KL=e.$JL=e.$IL=e.$HL=e.CodeActionTriggerKind=e.$GL=e.$FL=e.SymbolTag=e.SymbolKind=e.$EL=e.$DL=e.DocumentHighlightKind=e.$CL=e.$BL=e.$AL=e.$zL=e.DiagnosticSeverity=e.DiagnosticTag=e.$yL=e.$xL=e.FileEditType=e.$wL=e.$vL=e.$uL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$tL=e.$sL=e.$rL=e.$qL=e.$pL=e.$oL=e.$nL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function E(B){return Object.assign(B,{apply:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const Se=ne.length===1?[]:ne[1];return Reflect.construct(B,Se,ne[0].constructor)}},call:function(...ne){if(ne.length===0)return Reflect.construct(B,[]);{const[Se,...Je]=ne;return Reflect.construct(B,Je,Se.constructor)}}})}var T;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(T||(e.TerminalOutputAnchor=T={}));var N;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(N||(e.TerminalQuickFixType=N={}));let J=r=class{static from(...z){let ne=z;return new r(function(){if(ne){for(const Se of ne)Se&&typeof Se.dispose=="function"&&Se.dispose();ne=void 0}})}#e;constructor(z){this.#e=z}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$nL=J,e.$nL=J=r=Ge([E],J);let q=c=class{static Min(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isBefore(ne)&&(ne=Je)}return ne}static Max(...z){if(z.length===0)throw new TypeError;let ne=z[0];for(let Se=1;Se<z.length;Se++){const Je=z[Se];Je.isAfter(ne)&&(ne=Je)}return ne}static isPosition(z){if(!z)return!1;if(z instanceof c)return!0;const{line:ne,character:Se}=z;return typeof ne=="number"&&typeof Se=="number"}static of(z){if(z instanceof c)return z;if(this.isPosition(z))return new c(z.line,z.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(z,ne){if(z<0)throw(0,M.$7)("line must be non-negative");if(ne<0)throw(0,M.$7)("character must be non-negative");this.c=z,this.e=ne}isBefore(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<z.e}isBeforeOrEqual(z){return this.c<z.c?!0:z.c<this.c?!1:this.e<=z.e}isAfter(z){return!this.isBeforeOrEqual(z)}isAfterOrEqual(z){return!this.isBefore(z)}isEqual(z){return this.c===z.c&&this.e===z.e}compareTo(z){return this.c<z.c?-1:this.c>z.line?1:this.e<z.e?-1:this.e>z.e?1:0}translate(z,ne=0){if(z===null||ne===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=0:typeof z=="number"?Se=z:(Se=typeof z.lineDelta=="number"?z.lineDelta:0,ne=typeof z.characterDelta=="number"?z.characterDelta:0),Se===0&&ne===0?this:new c(this.line+Se,this.character+ne)}with(z,ne=this.character){if(z===null||ne===null)throw(0,M.$7)();let Se;return typeof z>"u"?Se=this.line:typeof z=="number"?Se=z:(Se=typeof z.line=="number"?z.line:this.line,ne=typeof z.character=="number"?z.character:this.character),Se===this.line&&ne===this.character?this:new c(Se,ne)}toJSON(){return{line:this.line,character:this.character}}};e.$oL=q,e.$oL=q=c=Ge([E],q);let U=s=class{static isRange(z){return z instanceof s?!0:z?q.isPosition(z.start)&&q.isPosition(z.end):!1}static of(z){if(z instanceof s)return z;if(this.isRange(z))return new s(z.start,z.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(z,ne,Se,Je){let xe,ut;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(xe=new q(z,ne),ut=new q(Se,Je)):q.isPosition(z)&&q.isPosition(ne)&&(xe=q.of(z),ut=q.of(ne)),!xe||!ut)throw new Error("Invalid arguments");xe.isBefore(ut)?(this.c=xe,this.e=ut):(this.c=ut,this.e=xe)}contains(z){return s.isRange(z)?this.contains(z.start)&&this.contains(z.end):q.isPosition(z)?!(q.of(z).isBefore(this.c)||this.e.isBefore(z)):!1}isEqual(z){return this.c.isEqual(z.c)&&this.e.isEqual(z.e)}intersection(z){const ne=q.Max(z.start,this.c),Se=q.Min(z.end,this.e);if(!ne.isAfter(Se))return new s(ne,Se)}union(z){if(this.contains(z))return this;if(z.contains(this))return z;const ne=q.Min(z.start,this.c),Se=q.Max(z.end,this.end);return new s(ne,Se)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(z,ne=this.end){if(z===null||ne===null)throw(0,M.$7)();let Se;return z?q.isPosition(z)?Se=z:(Se=z.start||this.start,ne=z.end||this.end):Se=this.start,Se.isEqual(this.c)&&ne.isEqual(this.end)?this:new s(Se,ne)}toJSON(){return[this.start,this.end]}};e.$pL=U,e.$pL=U=s=Ge([E],U);let C=i=class extends U{static isSelection(z){return z instanceof i?!0:z?U.isRange(z)&&q.isPosition(z.anchor)&&q.isPosition(z.active)&&typeof z.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(z,ne,Se,Je){let xe,ut;if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"?(xe=new q(z,ne),ut=new q(Se,Je)):q.isPosition(z)&&q.isPosition(ne)&&(xe=q.of(z),ut=q.of(ne)),!xe||!ut)throw new Error("Invalid arguments");super(xe,ut),this.f=xe,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$qL=C,e.$qL=C=i=Ge([E],C);const F=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,M.$7)("connectionToken")};class W{static isResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.host=="string"&&typeof z.port=="number"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne,Se){if(typeof z!="string"||z.length===0)throw(0,M.$7)("host");if(typeof ne!="number"||ne===0||Math.round(ne)!==ne)throw(0,M.$7)("port");typeof Se<"u"&&F(Se),this.host=z,this.port=Math.round(ne),this.connectionToken=Se}}e.$rL=W;class re{static isManagedResolvedAuthority(z){return z&&typeof z=="object"&&typeof z.makeConnection=="function"&&(z.connectionToken===void 0||typeof z.connectionToken=="string")}constructor(z,ne){this.makeConnection=z,this.connectionToken=ne,typeof ne<"u"&&F(ne)}}e.$sL=re;class ce extends Error{static NotAvailable(z,ne){return new ce(z,$.RemoteAuthorityResolverErrorCode.NotAvailable,ne)}static TemporarilyNotAvailable(z){return new ce(z,$.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(z,ne=$.RemoteAuthorityResolverErrorCode.Unknown,Se){super(z),this._message=z,this._code=ne,this._detail=Se,Object.setPrototypeOf(this,ce.prototype)}}e.$tL=ce;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var De;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let le=o=class{static isTextEdit(z){return z instanceof o?!0:z?U.isRange(z)&&typeof z.newText=="string":!1}static replace(z,ne){return new o(z,ne)}static insert(z,ne){return o.replace(new U(z,z),ne)}static delete(z){return o.replace(z,"")}static setEndOfLine(z){const ne=new o(new U(new q(0,0),new q(0,0)),"");return ne.newEol=z,ne}get range(){return this.c}set range(z){if(z&&!U.isRange(z))throw(0,M.$7)("range");this.c=z}get newText(){return this.e||""}set newText(z){if(z&&typeof z!="string")throw(0,M.$7)("newText");this.e=z}get newEol(){return this.f}set newEol(z){if(z&&typeof z!="number")throw(0,M.$7)("newEol");this.f=z}constructor(z,ne){this.c=z,this.e=ne}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$uL=le,e.$uL=le=o=Ge([E],le);let ve=a=class{static isNotebookCellEdit(z){return z instanceof a?!0:z?li.isNotebookRange(z)&&Array.isArray(z.newCells):!1}static replaceCells(z,ne){return new a(z,ne)}static insertCells(z,ne){return new a(new li(z,z),ne)}static deleteCells(z){return new a(z,[])}static updateCellMetadata(z,ne){const Se=new a(new li(z,z),[]);return Se.newCellMetadata=ne,Se}static updateNotebookMetadata(z){const ne=new a(new li(0,0),[]);return ne.newNotebookMetadata=z,ne}constructor(z,ne){this.range=z,this.newCells=ne}};e.$vL=ve,e.$vL=ve=a=Ge([E],ve);class se{static isSnippetTextEdit(z){return z instanceof se?!0:z?U.isRange(z.range)&&X.isSnippetString(z.snippet):!1}static replace(z,ne){return new se(z,ne)}static insert(z,ne){return se.replace(new U(z,z),ne)}constructor(z,ne){this.range=z,this.snippet=ne}}e.$wL=se;var $e;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(z,ne,Se,Je){this.c.push({_type:1,from:z,to:ne,options:Se,metadata:Je})}createFile(z,ne,Se){this.c.push({_type:1,from:void 0,to:z,options:ne,metadata:Se})}deleteFile(z,ne,Se){this.c.push({_type:1,from:z,to:void 0,options:ne,metadata:Se})}e(z,ne,Se){this.c.push({_type:3,metadata:Se,uri:z,edit:{editType:5,metadata:ne},notebookMetadata:ne})}f(z,ne,Se,Je){const xe=ne.start,ut=ne.end;(xe!==ut||Se.length>0)&&this.c.push({_type:5,uri:z,index:xe,count:ut-xe,cells:Se,metadata:Je})}g(z,ne,Se,Je){this.c.push({_type:3,metadata:Je,uri:z,edit:{editType:3,index:ne,metadata:Se}})}replace(z,ne,Se,Je){this.c.push({_type:2,uri:z,edit:new le(ne,Se),metadata:Je})}insert(z,ne,Se,Je){this.replace(z,new U(ne,ne),Se,Je)}delete(z,ne,Se){this.replace(z,ne,"",Se)}has(z){return this.c.some(ne=>ne._type===2&&ne.uri.toString()===z.toString())}set(z,ne){if(ne)for(const Se of ne){if(!Se)continue;let Je,xe;Array.isArray(Se)?(Je=Se[0],xe=Se[1]):Je=Se,ve.isNotebookCellEdit(Je)?Je.newCellMetadata?this.g(z,Je.range.start,Je.newCellMetadata,xe):Je.newNotebookMetadata?this.e(z,Je.newNotebookMetadata,xe):this.f(z,Je.range,Je.newCells,xe):se.isSnippetTextEdit(Je)?this.c.push({_type:6,uri:z,range:Je.range,edit:Je.snippet,metadata:xe}):this.c.push({_type:2,uri:z,edit:Je,metadata:xe})}else{for(let Se=0;Se<this.c.length;Se++){const Je=this.c[Se];switch(Je._type){case 2:case 6:case 3:case 5:Je.uri.toString()===z.toString()&&(this.c[Se]=void 0);break}}(0,S.$Ib)(this.c)}}get(z){const ne=[];for(const Se of this.c)Se._type===2&&Se.uri.toString()===z.toString()&&ne.push(Se.edit);return ne}entries(){const z=new R.$Ac;for(const ne of this.c)if(ne._type===2){let Se=z.get(ne.uri);Se||(Se=[ne.uri,[]],z.set(ne.uri,Se)),Se[1].push(ne.edit)}return[...z.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$xL=te,e.$xL=te=Ge([E],te);let X=u=class{static isSnippetString(z){return z instanceof u?!0:z?typeof z.value=="string":!1}static c(z){return z.replace(/\$|}|\\/g,"\\$&")}constructor(z){this.e=1,this.value=z||""}appendText(z){return this.value+=u.c(z),this}appendTabstop(z=this.e++){return this.value+="$",this.value+=z,this}appendPlaceholder(z,ne=this.e++){if(typeof z=="function"){const Se=new u;Se.e=this.e,z(Se),this.e=Se.e,z=Se.value}else z=u.c(z);return this.value+="${",this.value+=ne,this.value+=":",this.value+=z,this.value+="}",this}appendChoice(z,ne=this.e++){const Se=z.map(Je=>Je.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ne,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(z,ne){if(typeof ne=="function"){const Se=new u;Se.e=this.e,ne(Se),this.e=Se.e,ne=Se.value}else typeof ne=="string"&&(ne=ne.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=z,ne&&(this.value+=":",this.value+=ne),this.value+="}",this}};e.$yL=X,e.$yL=X=u=Ge([E],X);var V;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ie;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let Ce=t=class{static isLocation(z){return z instanceof t?!0:z?U.isRange(z.range)&&y.URI.isUri(z.uri):!1}constructor(z,ne){if(this.uri=z,ne)if(U.isRange(ne))this.range=U.of(ne);else if(q.isPosition(ne))this.range=new U(ne,ne);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$zL=Ce,e.$zL=Ce=t=Ge([E],Ce);let Te=class{static is(z){return z?typeof z.message=="string"&&z.location&&U.isRange(z.location.range)&&y.URI.isUri(z.location.uri):!1}constructor(z,ne){this.location=z,this.message=ne}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.location.range.isEqual(ne.location.range)&&z.location.uri.toString()===ne.location.uri.toString()}};e.$AL=Te,e.$AL=Te=Ge([E],Te);let Pe=class{constructor(z,ne,Se=ie.Error){if(!U.isRange(z))throw new TypeError("range must be set");if(!ne)throw new TypeError("message must be set");this.range=z,this.message=ne,this.severity=Se}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(z,ne){return z===ne?!0:!z||!ne?!1:z.message===ne.message&&z.severity===ne.severity&&z.code===ne.code&&z.severity===ne.severity&&z.source===ne.source&&z.range.isEqual(ne.range)&&(0,S.$ub)(z.tags,ne.tags)&&(0,S.$ub)(z.relatedInformation,ne.relatedInformation,Te.isEqual)}};e.$BL=Pe,e.$BL=Pe=Ge([E],Pe);let be=class{constructor(z,ne){if(!z)throw new Error("Illegal argument, contents must be defined");Array.isArray(z)?this.contents=z:this.contents=[z],this.range=ne}};e.$CL=be,e.$CL=be=Ge([E],be);var ge;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(ge||(e.DocumentHighlightKind=ge={}));let G=class{constructor(z,ne=ge.Text){this.range=z,this.kind=ne}toJSON(){return{range:this.range,kind:ge[this.kind]}}};e.$DL=G,e.$DL=G=Ge([E],G);let _=class{constructor(z,ne){this.uri=z,this.highlights=ne}toJSON(){return{uri:this.uri,highlights:this.highlights.map(z=>z.toJSON())}}};e.$EL=_,e.$EL=_=Ge([E],_);var ue;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(ue||(e.SymbolKind=ue={}));var de;(function(B){B[B.Deprecated=1]="Deprecated"})(de||(e.SymbolTag=de={}));let Le=f=class{static validate(z){if(!z.name)throw new Error("name must not be falsy")}constructor(z,ne,Se,Je,xe){this.name=z,this.kind=ne,this.containerName=xe,typeof Se=="string"&&(this.containerName=Se),Je instanceof Ce?this.location=Je:Se instanceof U&&(this.location=new Ce(Je,Se)),f.validate(this)}toJSON(){return{name:this.name,kind:ue[this.kind],location:this.location,containerName:this.containerName}}};e.$FL=Le,e.$FL=Le=f=Ge([E],Le);let fe=n=class{static validate(z){if(!z.name)throw new Error("name must not be falsy");if(!z.range.contains(z.selectionRange))throw new Error("selectionRange must be contained in fullRange");z.children?.forEach(n.validate)}constructor(z,ne,Se,Je,xe){this.name=z,this.detail=ne,this.kind=Se,this.range=Je,this.selectionRange=xe,this.children=[],n.validate(this)}};e.$GL=fe,e.$GL=fe=n=Ge([E],fe);var ke;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(ke||(e.CodeActionTriggerKind=ke={}));let Ie=class{constructor(z,ne){this.title=z,this.kind=ne}};e.$HL=Ie,e.$HL=Ie=Ge([E],Ie);let O=class{static{w=this}static{this.c="."}constructor(z){this.value=z}append(z){return new w(this.value?this.value+w.c+z:z)}intersects(z){return this.contains(z)||z.contains(this)}contains(z){return this.value===z.value||z.value.startsWith(this.value+w.c)}};e.$IL=O,e.$IL=O=w=Ge([E],O),O.Empty=new O(""),O.QuickFix=O.Empty.append("quickfix"),O.Refactor=O.Empty.append("refactor"),O.RefactorExtract=O.Refactor.append("extract"),O.RefactorInline=O.Refactor.append("inline"),O.RefactorMove=O.Refactor.append("move"),O.RefactorRewrite=O.Refactor.append("rewrite"),O.Source=O.Empty.append("source"),O.SourceOrganizeImports=O.Source.append("organizeImports"),O.SourceFixAll=O.Source.append("fixAll"),O.Notebook=O.Empty.append("notebook");let K=class{constructor(z,ne){if(this.range=z,this.parent=ne,ne&&!ne.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$JL=K,e.$JL=K=Ge([E],K);class j{constructor(z,ne,Se,Je,xe,ut){this.kind=z,this.name=ne,this.detail=Se,this.uri=Je,this.range=xe,this.selectionRange=ut}}e.$KL=j;class H{constructor(z,ne){this.fromRanges=ne,this.from=z}}e.$LL=H;class Z{constructor(z,ne){this.fromRanges=ne,this.to=z}}e.$ML=Z;var oe;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(oe||(e.LanguageStatusSeverity=oe={}));let Ee=class{constructor(z,ne){this.range=z,this.command=ne}get isResolved(){return!!this.command}};e.$NL=Ee,e.$NL=Ee=Ge([E],Ee);let Be=D=class{#e;static isMarkdownString(z){return z instanceof D?!0:z&&z.appendCodeblock&&z.appendMarkdown&&z.appendText&&z.value!==void 0}constructor(z,ne=!1){this.#e=new I.$jk(z,{supportThemeIcons:ne})}get value(){return this.#e.value}set value(z){this.#e.value=z}get isTrusted(){return this.#e.isTrusted}set isTrusted(z){this.#e.isTrusted=z}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(z){this.#e.supportThemeIcons=z}get supportHtml(){return this.#e.supportHtml}set supportHtml(z){this.#e.supportHtml=z}get baseUri(){return this.#e.baseUri}set baseUri(z){this.#e.baseUri=z}appendText(z){return this.#e.appendText(z),this}appendMarkdown(z){return this.#e.appendMarkdown(z),this}appendCodeblock(z,ne){return this.#e.appendCodeblock(ne??"",z),this}};e.$OL=Be,e.$OL=Be=D=Ge([E],Be);let We=class{constructor(z,ne){this.label=z,this.documentation=ne}};e.$PL=We,e.$PL=We=Ge([E],We);let Ze=class{constructor(z,ne){this.label=z,this.documentation=ne,this.parameters=[]}};e.$QL=Ze,e.$QL=Ze=Ge([E],Ze);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$RL=_e,e.$RL=_e=Ge([E],_e);var at;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(at||(e.SignatureHelpTriggerKind=at={}));var rt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let et=class{constructor(z){this.value=z}};e.$SL=et,e.$SL=et=Ge([E],et);let ct=class{constructor(z,ne,Se){this.position=z,this.label=ne,this.kind=Se}};e.$TL=ct,e.$TL=ct=Ge([E],ct);var je;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var vt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(vt||(e.CompletionItemKind=vt={}));var Y;(function(B){B[B.Deprecated=1]="Deprecated"})(Y||(e.CompletionItemTag=Y={}));let x=class{constructor(z,ne){this.label=z,this.kind=ne}toJSON(){return{label:this.label,kind:this.kind&&vt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$UL=x,e.$UL=x=Ge([E],x);let pe=class{constructor(z=[],ne=!1){this.items=z,this.isIncomplete=ne}};e.$VL=pe,e.$VL=pe=Ge([E],pe);let Ve=class{constructor(z,ne,Se){this.insertText=z,this.range=ne,this.command=Se}};e.$WL=Ve,e.$WL=Ve=Ge([E],Ve);let Qe=class{constructor(z){this.commands=void 0,this.suppressSuggestions=void 0,this.items=z}};e.$XL=Qe,e.$XL=Qe=Ge([E],Qe);var nt;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(nt||(e.ViewColumn=nt={}));var st;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(st||(e.StatusBarAlignment=st={}));function Ne(B,z){return`${k.$nm.toKey(B)}.${z}`}e.$YL=Ne;var Mt;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(Mt||(e.TextEditorLineNumbersStyle=Mt={}));var Qt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Qt||(e.TextDocumentSaveReason=Qt={}));var _t;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(_t||(e.TextEditorRevealType=_t={}));var jt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(jt||(e.TextEditorSelectionChangeKind=jt={}));var yt;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(yt||(e.TextDocumentChangeReason=yt={}));var ei;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(ei||(e.DecorationRangeBehavior=ei={})),function(B){function z(ne){switch(ne){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=z}(jt||(e.TextEditorSelectionChangeKind=jt={}));var Bt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Bt||(e.SyntaxTokenType=Bt={})),function(B){function z(ne){switch(ne){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=z}(Bt||(e.SyntaxTokenType=Bt={}));let ni=class{constructor(z,ne){if(ne&&!y.URI.isUri(ne))throw(0,M.$7)("target");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.target=ne}};e.$ZL=ni,e.$ZL=ni=Ge([E],ni);let Zt=class{constructor(z,ne,Se,Je){this.red=z,this.green=ne,this.blue=Se,this.alpha=Je}};e.$1L=Zt,e.$1L=Zt=Ge([E],Zt);let Yt=class{constructor(z,ne){if(ne&&!(ne instanceof Zt))throw(0,M.$7)("color");if(!U.isRange(z)||z.isEmpty)throw(0,M.$7)("range");this.range=z,this.color=ne}};e.$2L=Yt,e.$2L=Yt=Ge([E],Yt);let Xe=class{constructor(z){if(!z||typeof z!="string")throw(0,M.$7)("label");this.label=z}};e.$3L=Xe,e.$3L=Xe=Ge([E],Xe);var Wt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(Wt||(e.ColorFormat=Wt={}));var ti;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(ti||(e.SourceControlInputBoxValidationType=ti={}));var ht;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class mt{constructor(z,ne,Se){if(this.startIndex=z,this.length=ne,this.tooltip=Se,typeof z!="number"||z<0)throw(0,M.$7)("startIndex");if(typeof ne!="number"||ne<1)throw(0,M.$7)("length");if(Se!==void 0&&typeof Se!="string")throw(0,M.$7)("tooltip")}}e.$4L=mt;class Kt{constructor(z){this.uri=z}}e.$5L=Kt;class ii{constructor(z){this.terminalCommand=z}}e.$6L=ii;var Ct;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Ct||(e.TerminalLocation=Ct={}));class dt{constructor(z){if(this.options=z,typeof z!="object")throw(0,M.$7)("options")}}e.$7L=dt;var Lt;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(Lt||(e.TaskRevealKind=Lt={}));var ri;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ri||(e.TaskPanelKind=ri={}));let Rt=class{static{h=this}static{this.Clean=new h("clean","Clean")}static{this.Build=new h("build","Build")}static{this.Rebuild=new h("rebuild","Rebuild")}static{this.Test=new h("test","Test")}static from(z){switch(z){case"clean":return h.Clean;case"build":return h.Build;case"rebuild":return h.Rebuild;case"test":return h.Test;default:return}}constructor(z,ne){if(this.label=ne,typeof z!="string"||typeof ne!="string")throw(0,M.$7)("name");this.c=z}get id(){return this.c}};e.$8L=Rt,e.$8L=Rt=h=Ge([E],Rt);function He(B){let z="";for(let ne=0;ne<B.length;ne++)z+=B[ne].replace(/,/g,",,")+",";return z}let Ft=class{constructor(z,ne,Se){if(typeof z!="string")throw(0,M.$7)("process");this.e=[],this.c=z,ne!==void 0&&(Array.isArray(ne)?(this.e=ne,this.f=Se):this.f=ne)}get process(){return this.c}set process(z){if(typeof z!="string")throw(0,M.$7)("process");this.c=z}get args(){return this.e}set args(z){Array.isArray(z)||(z=[]),this.e=z}get options(){return this.f}set options(z){this.f=z}computeId(){const z=[];if(z.push("process"),this.c!==void 0&&z.push(this.c),this.e&&this.e.length>0)for(const ne of this.e)z.push(ne);return He(z)}};e.$9L=Ft,e.$9L=Ft=Ge([E],Ft);let Vt=class{constructor(z,ne,Se){if(this.f=[],Array.isArray(ne)){if(!z)throw(0,M.$7)("command can't be undefined or null");if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z,this.f=ne,this.g=Se}else{if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z,this.g=ne}}get commandLine(){return this.c}set commandLine(z){if(typeof z!="string")throw(0,M.$7)("commandLine");this.c=z}get command(){return this.e?this.e:""}set command(z){if(typeof z!="string"&&typeof z.value!="string")throw(0,M.$7)("command");this.e=z}get args(){return this.f}set args(z){this.f=z||[]}get options(){return this.g}set options(z){this.g=z}computeId(){const z=[];if(z.push("shell"),this.c!==void 0&&z.push(this.c),this.e!==void 0&&z.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ne of this.f)z.push(typeof ne=="string"?ne:ne.value);return He(z)}};e.$0L=Vt,e.$0L=Vt=Ge([E],Vt);var Xt;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Xt||(e.ShellQuoting=Xt={}));var ft;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(ft||(e.TaskScope=ft={}));class Tt{constructor(z){this.c=z}computeId(){return"customExecution"+(0,A.$rg)()}set callback(z){this.c=z}get callback(){return this.c}}e.$$L=Tt;let It=class{static{b=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(z,ne,Se,Je,xe,ut){this.k=!1,this.l=this.definition=z;let gt;typeof ne=="string"?(this.o=this.name=ne,this.w=this.source=Se,this.execution=Je,gt=xe,this.k=!0):ne===ft.Global||ne===ft.Workspace?(this.target=ne,this.o=this.name=Se,this.w=this.source=Je,this.execution=xe,gt=ut):(this.target=ne,this.o=this.name=Se,this.w=this.source=Je,this.execution=xe,gt=ut),typeof gt=="string"?(this.r=[gt],this.t=!0):Array.isArray(gt)?(this.r=gt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(z){this.j=z}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Ft?this.l={type:b.e,id:this.q.computeId()}:this.q instanceof Vt?this.l={type:b.f,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:b.c,id:this.q.computeId()}:this.l={type:b.g,id:(0,A.$rg)()}}get definition(){return this.l}set definition(z){if(z==null)throw(0,M.$7)("Kind can't be undefined or null");this.B(),this.l=z}get scope(){return this.m}set target(z){this.B(),this.m=z}get name(){return this.o}set name(z){if(typeof z!="string")throw(0,M.$7)("name");this.B(),this.o=z}get execution(){return this.q}set execution(z){z===null&&(z=void 0),this.B(),this.q=z;const ne=this.l.type;(b.g===ne||b.e===ne||b.f===ne||b.c===ne)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(z){if(Array.isArray(z))this.B(),this.r=z,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(z){z!==!0&&z!==!1&&(z=!1),this.B(),this.u=z}get source(){return this.w}set source(z){if(typeof z!="string"||z.length===0)throw(0,M.$7)("source must be a string of length > 0");this.B(),this.w=z}get group(){return this.x}set group(z){z===null&&(z=void 0),this.B(),this.x=z}get detail(){return this.A}set detail(z){z===null&&(z=void 0),this.A=z}get presentationOptions(){return this.y}set presentationOptions(z){z==null&&(z=Object.create(null)),this.B(),this.y=z}get runOptions(){return this.z}set runOptions(z){z==null&&(z=Object.create(null)),this.B(),this.z=z}};e.$_L=It,e.$_L=It=b=Ge([E],It);var Nt;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(Nt||(e.ProgressLocation=Nt={}));var qt;(function(B){function z(ne){const Se=ne;return(0,d.$Nf)(Se.value)?Se.tooltip&&!(0,d.$Jf)(Se.tooltip)?(console.log("INVALID view badge, invalid tooltip",Se.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Se.value),!1)}B.isViewBadge=z})(qt||(e.ViewBadge=qt={}));let Ot=P=class{static isTreeItem(z,ne){const Se=z;if(Se.checkboxState!==void 0){const Je=(0,d.$Nf)(Se.checkboxState)?Se.checkboxState:(0,d.$Lf)(Se.checkboxState)&&(0,d.$Nf)(Se.checkboxState.state)?Se.checkboxState.state:void 0,xe=!(0,d.$Nf)(Se.checkboxState)&&(0,d.$Lf)(Se.checkboxState)?Se.checkboxState.tooltip:void 0;if(Je===void 0||Je!==Gt.Checked&&Je!==Gt.Unchecked||xe!==void 0&&!(0,d.$Jf)(xe))return console.log("INVALID tree item, invalid checkboxState",Se.checkboxState),!1}if(z instanceof P)return!0;if(Se.label!==void 0&&!(0,d.$Jf)(Se.label)&&!Se.label?.label)return console.log("INVALID tree item, invalid label",Se.label),!1;if(Se.id!==void 0&&!(0,d.$Jf)(Se.id))return console.log("INVALID tree item, invalid id",Se.id),!1;if(Se.iconPath!==void 0&&!(0,d.$Jf)(Se.iconPath)&&!y.URI.isUri(Se.iconPath)&&(!Se.iconPath||!(0,d.$Jf)(Se.iconPath.id))){const Je=Se.iconPath;if(!Je||!(0,d.$Jf)(Je.light)&&!y.URI.isUri(Je.light)&&!(0,d.$Jf)(Je.dark)&&!y.URI.isUri(Je.dark))return console.log("INVALID tree item, invalid iconPath",Se.iconPath),!1}return Se.description!==void 0&&!(0,d.$Jf)(Se.description)&&typeof Se.description!="boolean"?(console.log("INVALID tree item, invalid description",Se.description),!1):Se.resourceUri!==void 0&&!y.URI.isUri(Se.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Se.resourceUri),!1):Se.tooltip!==void 0&&!(0,d.$Jf)(Se.tooltip)&&!(Se.tooltip instanceof Be)?(console.log("INVALID tree item, invalid tooltip",Se.tooltip),!1):Se.command!==void 0&&!Se.command.command?(console.log("INVALID tree item, invalid command",Se.command),!1):Se.collapsibleState!==void 0&&Se.collapsibleState<Dt.None&&Se.collapsibleState>Dt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Se.collapsibleState),!1):Se.contextValue!==void 0&&!(0,d.$Jf)(Se.contextValue)?(console.log("INVALID tree item, invalid contextValue",Se.contextValue),!1):Se.accessibilityInformation!==void 0&&!Se.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Se.accessibilityInformation),!1):!0}constructor(z,ne=Dt.None){this.collapsibleState=ne,y.URI.isUri(z)?this.resourceUri=z:this.label=z}};e.$aM=Ot,e.$aM=Ot=P=Ge([E],Ot);var Dt;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Dt||(e.TreeItemCollapsibleState=Dt={}));var Gt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Gt||(e.TreeItemCheckboxState=Gt={}));let Et=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(z){this.value=z}};e.$bM=Et,e.$bM=Et=Ge([E],Et);class wt extends Et{}e.$cM=wt;class St extends wt{#e;constructor(z){super(""),this.#e=z}asFile(){return this.#e}}e.$dM=St;class kt{constructor(z,ne,Se,Je){this.name=z,this.uri=ne,this._itemId=Se,this.c=Je}data(){return this.c()}}e.$eM=kt;let ye=class{#e=new Map;constructor(z){for(const[ne,Se]of z??[]){const Je=this.#e.get(this.#t(ne));Je?Je.push(Se):this.#e.set(this.#t(ne),[Se])}}get(z){return this.#e.get(this.#t(z))?.[0]}set(z,ne){this.#e.set(this.#t(z),[ne])}forEach(z,ne){for(const[Se,Je]of this.#e)for(const xe of Je)z.call(ne,xe,Se,this)}*[Symbol.iterator](){for(const[z,ne]of this.#e)for(const Se of ne)yield[z,Se]}#t(z){return z.toLowerCase()}};e.$fM=ye,e.$fM=ye=Ge([E],ye);let Fe=class{constructor(z){this.insertText=z}};e.$gM=Fe,e.$gM=Fe=Ge([E],Fe);let he=class{constructor(z,ne){this.label=ne,this.insertText=z}};e.$hM=he,e.$hM=he=Ge([E],he);let Q=class{constructor(z,ne){this.id=z,this.color=ne}static isThemeIcon(z){return typeof z.id!="string"?(console.log("INVALID ThemeIcon, invalid id",z.id),!1):!0}};e.$iM=Q,e.$iM=Q=Ge([E],Q),Q.File=new Q("file"),Q.Folder=new Q("folder");let Me=class{constructor(z){this.id=z}};e.$jM=Me,e.$jM=Me=Ge([E],Me);var Ue;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Ue||(e.ConfigurationTarget=Ue={}));let Ye=class{get base(){return this.c}set base(z){this.c=z,this.e=y.URI.file(z)}get baseUri(){return this.e}set baseUri(z){this.e=z,this.c=z.fsPath}constructor(z,ne){if(typeof z!="string"&&(!z||!y.URI.isUri(z)&&!y.URI.isUri(z.uri)))throw(0,M.$7)("base");if(typeof ne!="string")throw(0,M.$7)("pattern");typeof z=="string"?this.baseUri=y.URI.file(z):y.URI.isUri(z)?this.baseUri=z:this.baseUri=z.uri,this.pattern=ne}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$kM=Ye,e.$kM=Ye=Ge([E],Ye);const Ke=new WeakMap;function tt(B,z){Ke.set(B,z)}e.$lM=tt;let pt=class{constructor(z,ne,Se,Je){this.enabled=typeof z=="boolean"?z:!0,typeof ne=="string"&&(this.condition=ne),typeof Se=="string"&&(this.hitCondition=Se),typeof Je=="string"&&(this.logMessage=Je)}get id(){return this.c||(this.c=Ke.get(this)??(0,A.$rg)()),this.c}};e.$mM=pt,e.$mM=pt=Ge([E],pt);let zt=class extends pt{constructor(z,ne,Se,Je,xe){if(super(ne,Se,Je,xe),z===null)throw(0,M.$7)("location");this.location=z}};e.$nM=zt,e.$nM=zt=Ge([E],zt);let Ut=class extends pt{constructor(z,ne,Se,Je,xe){super(ne,Se,Je,xe),this.functionName=z}};e.$oM=Ut,e.$oM=Ut=Ge([E],Ut);let Pt=class extends pt{constructor(z,ne,Se,Je,xe,ut,gt){if(super(Je,xe,ut,gt),!ne)throw(0,M.$7)("dataId");this.label=z,this.dataId=ne,this.canPersist=Se}};e.$pM=Pt,e.$pM=Pt=Ge([E],Pt);let Jt=class{constructor(z,ne,Se){this.command=z,this.args=ne||[],this.options=Se}};e.$qM=Jt,e.$qM=Jt=Ge([E],Jt);let Ht=class{constructor(z,ne){this.port=z,this.host=ne}};e.$rM=Ht,e.$rM=Ht=Ge([E],Ht);let yi=class{constructor(z){this.path=z}};e.$sM=yi,e.$sM=yi=Ge([E],yi);let Li=class{constructor(z){this.implementation=z}};e.$tM=Li,e.$tM=Li=Ge([E],Li);let mi=class{constructor(z,ne,Se){this.session=z,this.threadId=ne,this.frameId=Se}};e.$uM=mi,e.$uM=mi=Ge([E],mi);let $i=class{constructor(z,ne){this.session=z,this.threadId=ne}};e.$vM=$i,e.$vM=$i=Ge([E],$i);let lt=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$wM=lt,e.$wM=lt=Ge([E],lt);var Qi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(Qi||(e.InlineCompletionTriggerKind=Qi={}));let ai=class{constructor(z,ne){this.range=z,this.text=ne}};e.$xM=ai,e.$xM=ai=Ge([E],ai);let di=class{constructor(z,ne,Se=!0){this.range=z,this.variableName=ne,this.caseSensitiveLookup=Se}};e.$yM=di,e.$yM=di=Ge([E],di);let Ei=class{constructor(z,ne){this.range=z,this.expression=ne}};e.$zM=Ei,e.$zM=Ei=Ge([E],Ei);let Ri=class{constructor(z,ne){this.frameId=z,this.stoppedLocation=ne}};e.$AM=Ri,e.$AM=Ri=Ge([E],Ri);var Zi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Zi||(e.FileChangeType=Zi={}));let Ai=g=class extends Error{static FileExists(z){return new g(z,l.FileSystemProviderErrorCode.FileExists,g.FileExists)}static FileNotFound(z){return new g(z,l.FileSystemProviderErrorCode.FileNotFound,g.FileNotFound)}static FileNotADirectory(z){return new g(z,l.FileSystemProviderErrorCode.FileNotADirectory,g.FileNotADirectory)}static FileIsADirectory(z){return new g(z,l.FileSystemProviderErrorCode.FileIsADirectory,g.FileIsADirectory)}static NoPermissions(z){return new g(z,l.FileSystemProviderErrorCode.NoPermissions,g.NoPermissions)}static Unavailable(z){return new g(z,l.FileSystemProviderErrorCode.Unavailable,g.Unavailable)}constructor(z,ne=l.FileSystemProviderErrorCode.Unknown,Se){super(y.URI.isUri(z)?z.toString(!0):z),this.code=Se?.name??"Unknown",(0,l.$Hk)(this,ne),Object.setPrototypeOf(this,g.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}};e.$BM=Ai,e.$BM=Ai=g=Ge([E],Ai);let Di=class{constructor(z,ne,Se){this.start=z,this.end=ne,this.kind=Se}};e.$CM=Di,e.$CM=Di=Ge([E],Di);var Yi;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Mi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Mi||(e.CommentThreadCollapsibleState=Mi={}));var pi;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(pi||(e.CommentMode=pi={}));var Xi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(Xi||(e.CommentState=Xi={}));var ki;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(ki||(e.CommentThreadState=ki={}));class Fi{constructor(z,ne=[]){this.tokenTypes=z,this.tokenModifiers=ne}}e.$DM=Fi;function ln(B){return typeof B>"u"||(0,d.$Kf)(B)}class Ti{constructor(z){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,z){this.m=!0;for(let ne=0,Se=z.tokenTypes.length;ne<Se;ne++)this.k.set(z.tokenTypes[ne],ne);for(let ne=0,Se=z.tokenModifiers.length;ne<Se;ne++)this.l.set(z.tokenModifiers[ne],ne)}}push(z,ne,Se,Je,xe){if(typeof z=="number"&&typeof ne=="number"&&typeof Se=="number"&&typeof Je=="number"&&(typeof xe=="number"||typeof xe>"u"))return typeof xe>"u"&&(xe=0),this.q(z,ne,Se,Je,xe);if(U.isRange(z)&&typeof ne=="string"&&ln(Se))return this.o(z,ne,Se);throw(0,M.$7)()}o(z,ne,Se){if(!this.m)throw new Error("Legend must be provided in constructor");if(z.start.line!==z.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ne))throw new Error("`tokenType` is not in the provided legend");const Je=z.start.line,xe=z.start.character,ut=z.end.character-z.start.character,gt=this.k.get(ne);let xt=0;if(Se)for(const oi of Se){if(!this.l.has(oi))throw new Error("`tokenModifier` is not in the provided legend");const ui=this.l.get(oi);xt|=1<<ui>>>0}this.q(Je,xe,ut,gt,xt)}q(z,ne,Se,Je,xe){if(this.f&&(z<this.c||z===this.c&&ne<this.e)){this.f=!1;const xt=this.g.length/5|0;let oi=0,ui=0;for(let hi=0;hi<xt;hi++){let gi=this.g[5*hi],Gi=this.g[5*hi+1];gi===0?(gi=oi,Gi+=ui):gi+=oi,this.g[5*hi]=gi,this.g[5*hi+1]=Gi,oi=gi,ui=Gi}}let ut=z,gt=ne;this.f&&this.j>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.j++]=ut,this.g[this.j++]=gt,this.g[this.j++]=Se,this.g[this.j++]=Je,this.g[this.j++]=xe,this.c=z,this.e=ne}static r(z){const ne=[],Se=z.length/5|0;for(let gt=0;gt<Se;gt++)ne[gt]=gt;ne.sort((gt,xt)=>{const oi=z[5*gt],ui=z[5*xt];if(oi===ui){const hi=z[5*gt+1],gi=z[5*xt+1];return hi-gi}return oi-ui});const Je=new Uint32Array(z.length);let xe=0,ut=0;for(let gt=0;gt<Se;gt++){const xt=5*ne[gt],oi=z[xt+0],ui=z[xt+1],hi=z[xt+2],gi=z[xt+3],Gi=z[xt+4],Cn=oi-xe,Kn=Cn===0?ui-ut:ui,Ji=5*gt;Je[Ji+0]=Cn,Je[Ji+1]=Kn,Je[Ji+2]=hi,Je[Ji+3]=gi,Je[Ji+4]=Gi,xe=oi,ut=ui}return Je}build(z){return this.f?new fi(new Uint32Array(this.g),z):new fi(Ti.r(this.g),z)}}e.$EM=Ti;class fi{constructor(z,ne){this.resultId=ne,this.data=z}}e.$FM=fi;class hn{constructor(z,ne,Se){this.start=z,this.deleteCount=ne,this.data=Se}}e.$GM=hn;class dn{constructor(z,ne){this.resultId=ne,this.edits=z}}e.$HM=dn;var xi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(xi||(e.DebugConsoleMode=xi={}));class wi{constructor(z){this.name=z}}e.$IM=wi;let Ni=class{static{this.Back={iconPath:new Q("arrow-left")}}constructor(){}};e.$JM=Ni,e.$JM=Ni=Ge([E],Ni);var _i;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(_i||(e.QuickPickItemKind=_i={}));var Si;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Si||(e.InputBoxValidationSeverity=Si={}));var Oi;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(Oi||(e.ExtensionKind=Oi={}));class fn{static validate(z){if(typeof z.badge=="string"){let ne=(0,m.$kf)(z.badge,0);if(ne<z.badge.length&&(ne+=(0,m.$kf)(z.badge,ne)),z.badge.length>ne)throw new Error("The 'badge'-property must be undefined or a short character")}else if(z.badge&&!Q.isThemeIcon(z.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!z.color&&!z.badge&&!z.tooltip)throw new Error("The decoration is empty");return!0}constructor(z,ne,Se){this.badge=z,this.tooltip=ne,this.color=Se}}e.$KM=fn;let Ii=class{constructor(z){this.kind=z}};e.$LM=Ii,e.$LM=Ii=Ge([E],Ii);var zi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(zi||(e.ColorThemeKind=zi={}));class li{static isNotebookRange(z){return z instanceof li?!0:z?typeof z.start=="number"&&typeof z.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(z,ne){if(z<0)throw(0,M.$7)("start must be positive");if(ne<0)throw(0,M.$7)("end must be positive");z<=ne?(this.c=z,this.e=ne):(this.c=ne,this.e=z)}with(z){let ne=this.c,Se=this.e;return z.start!==void 0&&(ne=z.start),z.end!==void 0&&(Se=z.end),ne===this.c&&Se===this.e?this:new li(ne,Se)}}e.$MM=li;class Ci{static validate(z){if(typeof z.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof z.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof z.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(z){return Array.isArray(z)&&z.every(ne=>Ci.isNotebookCellData(ne))}static isNotebookCellData(z){return!0}constructor(z,ne,Se,Je,xe,ut,gt){this.kind=z,this.value=ne,this.languageId=Se,this.mime=Je,this.outputs=xe??[],this.metadata=ut,this.executionSummary=gt,Ci.validate(this)}}e.$NM=Ci;class gn{constructor(z){this.cells=z}}e.$OM=gn;class si{static isNotebookCellOutputItem(z){return z instanceof si?!0:z?typeof z.mime=="string"&&z.data instanceof Uint8Array:!1}static error(z){const ne={name:z.name,message:z.message,stack:z.stack};return si.json(ne,"application/vnd.code.notebook.error")}static stdout(z){return si.text(z,"application/vnd.code.notebook.stdout")}static stderr(z){return si.text(z,"application/vnd.code.notebook.stderr")}static bytes(z,ne="application/octet-stream"){return new si(z,ne)}static#e=new TextEncoder;static text(z,ne=L.$hs.text){const Se=si.#e.encode(String(z));return new si(Se,ne)}static json(z,ne="text/x-json"){const Se=JSON.stringify(z,void 0,"	");return si.text(Se,ne)}constructor(z,ne){this.data=z,this.mime=ne;const Se=(0,L.$ls)(ne,!0);if(!Se)throw new Error(`INVALID mime type: ${ne}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Se}}e.$PM=si;class vi{static isNotebookCellOutput(z){return z instanceof vi?!0:!z||typeof z!="object"?!1:typeof z.id=="string"&&Array.isArray(z.items)}static ensureUniqueMimeTypes(z,ne=!1){const Se=new Set,Je=new Set;for(let xe=0;xe<z.length;xe++){const ut=z[xe],gt=(0,L.$ls)(ut.mime);if(!Se.has(gt)||(0,p.$oJ)(gt)){Se.add(gt);continue}Je.add(xe),ne&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Je.size===0?z:z.filter((xe,ut)=>!Je.has(ut))}constructor(z,ne,Se){this.items=vi.ensureUniqueMimeTypes(z,!0),typeof ne=="string"?(this.id=ne,this.metadata=Se):(this.id=(0,A.$rg)(),this.metadata=ne??Se)}}e.$QM=vi;var Ui;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Ui||(e.NotebookCellKind=Ui={}));var ze;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(ze||(e.NotebookCellExecutionState=ze={}));var ci;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ci||(e.NotebookCellStatusBarAlignment=ci={}));var ji;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(ji||(e.NotebookEditorRevealType=ji={}));class it{constructor(z,ne){this.text=z,this.alignment=ne}}e.$RM=it;var $t;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})($t||(e.NotebookControllerAffinity=$t={}));var en;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(en||(e.NotebookControllerAffinity2=en={}));class mn{constructor(z,ne=[]){this.uri=z,this.provides=(0,S.$3b)(ne)}}e.$SM=mn;class tn{constructor(z){this.label=z}}e.$TM=tn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let bi=class{constructor(z,ne){this.label=z,this.timestamp=ne}};e.$UM=bi,e.$UM=bi=Ge([E],bi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class an{constructor(z,ne){this.ranges=z,this.wordPattern=ne}}e.$VM=an;class $n{constructor(z){this.c=z}get autoForwardAction(){return this.c}}e.$WM=$n;var cn;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(cn||(e.TestResultState=cn={}));var un;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(un||(e.TestRunProfileKind=un={}));let Bi=class{constructor(z=void 0,ne=void 0,Se=void 0,Je=!1){this.include=z,this.exclude=ne,this.profile=Se,this.continuous=Je}};e.$XM=Bi,e.$XM=Bi=Ge([E],Bi);let Wi=v=class{static diff(z,ne,Se){const Je=new v(z);return Je.expectedOutput=ne,Je.actualOutput=Se,Je}constructor(z){this.message=z}};e.$YM=Wi,e.$YM=Wi=v=Ge([E],Wi);let Vi=class{constructor(z){this.id=z}};e.$ZM=Vi,e.$ZM=Vi=Ge([E],Vi);class Pi{constructor(z,ne){this.covered=z,this.total=ne}}e.$1M=Pi;const qi=B=>{if(B&&B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`)};class Hi{static fromDetails(z,ne){const Se=new Pi(0,0),Je=new Pi(0,0),xe=new Pi(0,0);for(const gt of ne)if("branches"in gt){Se.total+=1,Se.covered+=gt.executed?1:0;for(const xt of gt.branches)Je.total+=1,Je.covered+=xt.executed?1:0}else xe.total+=1,xe.covered+=gt.executed?1:0;const ut=new Hi(z,Se,Je.total>0?Je:void 0,xe.total>0?xe:void 0);return ut.detailedCoverage=ne,ut}constructor(z,ne,Se,Je){this.uri=z,this.statementCoverage=ne,this.branchCoverage=Se,this.declarationCoverage=Je,qi(ne),qi(Se),qi(Je)}}e.$2M=Hi;class pn{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se=[]){this.executed=z,this.location=ne,this.branches=Se}}e.$3M=pn;class ee{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.executed=z,this.location=ne,this.label=Se}}e.$4M=ee;class ae{get executionCount(){return+this.executed}set executionCount(z){this.executed=z}constructor(z,ne,Se){this.name=z,this.executed=ne,this.location=Se}}e.$5M=ae;var Oe;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Oe||(e.ExternalUriOpenerPriority=Oe={}));var ot;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(ot||(e.WorkspaceTrustState=ot={}));var bt;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(bt||(e.PortAutoForwardAction=bt={}));class At{constructor(z,ne,Se,Je,xe,ut){this.kind=z,this.name=ne,this.detail=Se,this.uri=Je,this.range=xe,this.selectionRange=ut}}e.$6M=At;class Ki{constructor(z){this.uri=z}}e.$7M=Ki;class Pn{constructor(z,ne){this.original=z,this.modified=ne}}e.$8M=Pn;class Ln{constructor(z,ne,Se,Je){this.base=z,this.input1=ne,this.input2=Se,this.result=Je}}e.$9M=Ln;class Rn{constructor(z,ne){this.uri=z,this.viewType=ne}}e.$0M=Rn;class An{constructor(z){this.viewType=z}}e.$$M=An;class Mn{constructor(z,ne){this.uri=z,this.notebookType=ne}}e.$_M=Mn;class Fn{constructor(z,ne,Se){this.original=z,this.modified=ne,this.notebookType=Se}}e.$aN=Fn;class Tn{constructor(){}}e.$bN=Tn;class Nn{constructor(z,ne){this.uri=z,this.inputBoxUri=ne}}e.$cN=Nn;class On{constructor(z){this.providerId=z}}e.$dN=On;var vn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(vn||(e.InteractiveSessionVoteDirection=vn={}));var bn;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(bn||(e.ChatAgentCopyKind=bn={}));var wn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(wn||(e.ChatVariableLevel=wn={}));class zn{constructor(z,ne){this.label=z,this.values=ne}}e.$eN=zn;var yn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.Assistant=2]="Assistant"})(En||(e.ChatMessageRole=En={}));class Un{constructor(z,ne){this.role=z,this.content=ne}}e.$fN=Un;var Dn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Dn||(e.ChatAgentResultFeedbackKind=Dn={}));class jn{constructor(z){this.value=z}}e.$gN=jn;class Bn{constructor(z){this.value=typeof z=="string"?new Be(z):z}}e.$hN=Bn;class Wn{constructor(z,ne){this.value=z,this.baseUri=ne}}e.$iN=Wn;class Vn{constructor(z,ne){this.value=z,this.title=ne}}e.$jN=Vn;class qn{constructor(z){this.value=z}}e.$kN=qn;class Hn{constructor(z){this.value=z}}e.$lN=Hn;var kn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(kn||(e.RelatedInformationType=kn={}));var Sn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped"})(Sn||(e.SpeechToTextStatus=Sn={}));var In;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(In||(e.KeywordRecognitionStatus=In={}))}),define(Re[238],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ngc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(S.$lL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(L,m,d){if(this.a.size===0)throw new Error("No related information providers registered");const y=this.a.get(L);if(!y)throw new Error("related information provider not found");return await y.provideRelatedInformation(m,d)??[]}getRelatedInformation(L,m,d){return this.c.$getAiRelatedInformation(m,d)}registerRelatedInformationProvider(L,m,d){const y=this.b;return this.b++,this.a.set(y,d),this.c.$registerAiRelatedInformationProvider(y,m),new M.$nL(()=>{this.c.$unregisterAiRelatedInformationProvider(y),this.a.delete(y)})}}e.$ngc=I}),define(Re[239],Ae([1,0,5,3,7,22]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ygc=void 0;class L{constructor(y){this.b=new Map,this.c=new S.$Wd,this.onDidChangeSessions=this.c.event,this.d=new m,this.f=new m,this.a=y.getProxy(M.$lL.MainThreadAuthentication)}async getSession(y,A,k,l={}){const $=R.$nm.toKey(y.identifier),p=[...k].sort().join(" ");return await this.d.getOrCreate(`${$} ${A} ${p}`,async()=>{await this.a.$ensureProvider(A);const r=y.displayName||y.name;return this.a.$getSession(A,k,$,r,l)})}async getSessions(y,A,k){const l=R.$nm.toKey(y.identifier),$=[...k].sort().join(" ");return await this.f.getOrCreate(`${l} ${$}`,async()=>{await this.a.$ensureProvider(A);const p=y.displayName||y.name;return this.a.$getSessions(A,k,l,p)})}async removeSession(y,A){const k=this.b.get(y);return k?k.provider.removeSession(A):this.a.$removeSession(y,A)}registerAuthenticationProvider(y,A,k,l){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:A,provider:k,options:l??{supportsMultipleAccounts:!1}});const $=k.onDidChangeSessions(p=>this.a.$sendDidChangeSessions(y,p));return this.a.$registerAuthenticationProvider(y,A,l?.supportsMultipleAccounts??!1),new I.$nL(()=>{$.dispose(),this.b.delete(y),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,A,k){const l=this.b.get(y);if(l)return Promise.resolve(l.provider.createSession(A,k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,A){const k=this.b.get(y);if(k)return Promise.resolve(k.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,A){const k=this.b.get(y);if(k)return Promise.resolve(k.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,A){return this.c.fire({provider:{id:y,label:A}}),Promise.resolve()}}e.$ygc=L;class m{constructor(){this.a=new Map}getOrCreate(y,A){const k=this.a.get(y);if(k)return k;const l=A().finally(()=>this.a.delete(y));return this.a.set(y,l),l}}}),define(Re[107],Ae([1,0,2,3,7,4,17,13,18,14,19,25]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=e.$xhc=void 0;let $=class{static{l=this}static{this.c=0}static{this.d=250}constructor(r,c){this.h=c,this.f=new Map,this.g=r.getProxy(M.$lL.MainThreadDecorations)}registerFileDecorationProvider(r,c){const s=l.c++;this.f.set(s,{provider:r,extensionDescription:c}),this.g.$registerDecorationProvider(s,c.identifier.value);const i=r.onDidChangeFileDecorations&&r.onDidChangeFileDecorations(o=>{if(!o){this.g.$onDidChange(s,null);return}const a=(0,d.$3b)(o);if(a.length<=l.d){this.g.$onDidChange(s,a);return}this.h.warn("[Decorations] CAPPING events from decorations provider",c.identifier.value,a.length);const u=a.map(n=>({uri:n,rank:(0,y.$Qe)(n.path,"/")})),t=(0,d.$zb)(u,(n,w)=>n.rank-w.rank||(0,y.$6e)(n.uri.path,w.uri.path)),f=[];e:for(const n of t){let w;for(const D of n){const h=(0,A.$mc)(D.uri.path);if(w!==h&&(w=h,f.push(D.uri)>=l.d))break e}}this.g.$onDidChange(s,f)});return new I.$nL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(r,c,s){if(!this.f.has(r))return Object.create(null);const i=Object.create(null),{provider:o,extensionDescription:a}=this.f.get(r);return await Promise.all(c.map(async u=>{try{const{uri:t,id:f}=u,n=await Promise.resolve(o.provideFileDecoration(S.URI.revive(t),s));if(!n)return;try{I.$KM.validate(n),n.badge&&typeof n.badge!="string"&&(0,k.$LF)(a,"codiconDecoration"),i[f]=[n.propagate,n.tooltip,n.badge,n.color]}catch(w){this.h.warn(`INVALID decoration from extension '${a.identifier.value}': ${w}`)}}catch(t){this.h.error(t)}})),i}};e.$xhc=$,e.$xhc=$=l=Ge([qe(0,L.$wN),qe(1,m.$pj)],$),e.$yhc=(0,R.$8h)("IExtHostDecorations")}),define(Re[240],Ae([1,0,15,2,7,3,12,21,14]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=void 0;class y{static{this.a=0}constructor(k,l,$){this.d=l,this.e=$,this.b=new Map,this.c=k.getProxy(R.$lL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(L.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const $=y.a++;this.b.set($,l),this.c.$registerTextContentProvider($,k);let p;if(typeof l.onDidChange=="function"){let r;p=l.onDidChange(async c=>{if(c.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${c.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(c))return;r&&await r;const s=this.$provideTextDocumentContent($,c).then(async i=>{if(!i&&typeof i!="string")return;const o=this.d.getDocument(c);if(!o)return;const a=(0,d.$1e)(i);if(!o.equalLines(a))return this.c.$onVirtualDocumentChange(c,i)}).catch(S.$1).finally(()=>{r===s&&(r=void 0)});r=s})}return new I.$nL(()=>{this.b.delete($)&&this.c.$unregisterTextContentProvider($),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(k,l){const $=this.b.get(k);return $?Promise.resolve($.provideTextDocumentContent(M.URI.revive(l),m.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$Ahc=y}),define(Re[108],Ae([1,0,54,12,14,296,147,7,18]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AN=e.$zN=e.$yN=void 0;const y=new Map;function A(p,r){r?y.set(p,r):y.delete(p)}e.$yN=A;function k(p){return y.get(p)}class l extends R.$nv{constructor(r,c,s,i,o,a,u,t){super(c,s,i,o),this.c=r,this.m=a,this.q=u,this.notebook=t,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(r){return(0,d.$ub)(this.f,r)}get document(){if(!this.a){const r=this;this.a={get uri(){return r.d},get fileName(){return r.d.fsPath},get isUntitled(){return r.d.scheme===M.Schemas.untitled},get languageId(){return r.m},get version(){return r.h},get isClosed(){return r.b},get isDirty(){return r.q},save(){return r.r()},getText(c){return c?r.s(c):r.getText()},get eol(){return r.g===`
`?m.EndOfLine.LF:m.EndOfLine.CRLF},get lineCount(){return r.f.length},lineAt(c){return r.t(c)},offsetAt(c){return r.u(c)},positionAt(c){return r.v(c)},validateRange(c){return r.w(c)},validatePosition(c){return r.x(c)},getWordRangeAtPosition(c,s){return r.y(c,s)}}}return Object.freeze(this.a)}_acceptLanguageId(r){(0,S.ok)(!this.b),this.m=r}_acceptIsDirty(r){(0,S.ok)(!this.b),this.q=r}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(r){const c=this.w(r);if(c.isEmpty)return"";if(c.isSingleLine)return this.f[c.start.line].substring(c.start.character,c.end.character);const s=this.g,i=c.start.line,o=c.end.line,a=[];a.push(this.f[i].substring(c.start.character));for(let u=i+1;u<o;u++)a.push(this.f[u]);return a.push(this.f[o].substring(0,c.end.character)),a.join(s)}t(r){let c;if(r instanceof m.$oL?c=r.line:typeof r=="number"&&(c=r),typeof c!="number"||c<0||c>=this.f.length||Math.floor(c)!==c)throw new Error("Illegal value for `line`");return new $(c,this.f[c],c===this.f.length-1)}u(r){return r=this.x(r),this.l(),this.j.getPrefixSum(r.line-1)+r.character}v(r){r=Math.floor(r),r=Math.max(0,r),this.l();const c=this.j.getIndexOf(r),s=this.f[c.index].length;return new m.$oL(c.index,Math.min(c.remainder,s))}w(r){if(!(r instanceof m.$pL))throw new Error("Invalid argument");const c=this.x(r.start),s=this.x(r.end);return c===r.start&&s===r.end?r:new m.$pL(c.line,c.character,s.line,s.character)}x(r){if(!(r instanceof m.$oL))throw new Error("Invalid argument");if(this.f.length===0)return r.with(0,0);let{line:c,character:s}=r,i=!1;if(c<0)c=0,s=0,i=!0;else if(c>=this.f.length)c=this.f.length-1,s=this.f[c].length,i=!0;else{const o=this.f[c].length;s<0?(s=0,i=!0):s>o&&(s=o,i=!0)}return i?new m.$oL(c,s):r}y(r,c){const s=this.x(r);if(!c)c=k(this.m);else if((0,I.$Ze)(c))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${c.source}' because it matches the empty string.`);const i=(0,L.$zs)(s.character+1,(0,L.$xs)(c),this.f[s.line],0);if(i)return new m.$pL(s.line,i.startColumn-1,s.line,i.endColumn-1)}}e.$zN=l;class ${constructor(r,c,s){this.a=r,this.b=c,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new m.$pL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new m.$pL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$AN=$}),define(Re[241],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=void 0;class I{constructor(L){this.a=new Map,this.b=0,this.c=L.getProxy(S.$lL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(L,m,d){if(this.a.size===0)throw new Error("No embedding vector providers registered");const y=this.a.get(L);if(!y)throw new Error("Embedding vector provider not found");const A=await y.provideEmbeddingVector(m,d);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(L,m,d){const y=this.b;return this.b++,this.a.set(y,d),this.c.$registerAiEmbeddingVectorProvider(m,y),new M.$nL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(y),this.a.delete(y)})}}e.$Chc=I}),define(Re[62],Ae([1,0,3,42,7,23,4,17,43,6,11,24,12]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=e.$Pgc=void 0;let p=$=class{constructor(c,s){this.b=new Map,this.c=new A.$eh,this.a=c.getProxy(S.$lL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(o){try{let a;const u=i.b.get(o.scheme);return u?(await i.a.$ensureActivation(o.scheme),a=await u.impl.stat(o)):a=await i.a.$stat(o),{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions===M.FilePermission.Readonly?1:void 0}}catch(a){$.e(a)}},async readDirectory(o){try{const a=i.b.get(o.scheme);return a?(await i.a.$ensureActivation(o.scheme),(await a.impl.readDirectory(o)).slice()):await i.a.$readdir(o)}catch(a){return $.e(a)}},async createDirectory(o){try{const a=i.b.get(o.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(o.scheme),await i.d(a.impl,a.extUri,o)):await i.a.$mkdir(o)}catch(a){return $.e(a)}},async readFile(o){try{const a=i.b.get(o.scheme);return a?(await i.a.$ensureActivation(o.scheme),(await a.impl.readFile(o)).slice()):(await i.a.$readFile(o)).buffer}catch(a){return $.e(a)}},async writeFile(o,a){try{const u=i.b.get(o.scheme);return u&&!u.isReadonly?(await i.a.$ensureActivation(o.scheme),await i.d(u.impl,u.extUri,u.extUri.dirname(o)),await i.c.queueFor(o,()=>Promise.resolve(u.impl.writeFile(o,a,{create:!0,overwrite:!0})))):await i.a.$writeFile(o,R.$ke.wrap(a))}catch(u){return $.e(u)}},async delete(o,a){try{const u=i.b.get(o.scheme);return u&&!u.isReadonly&&!a?.useTrash?(await i.a.$ensureActivation(o.scheme),await u.impl.delete(o,{recursive:!1,...a})):await i.a.$delete(o,{recursive:!1,useTrash:!1,atomic:!1,...a})}catch(u){return $.e(u)}},async rename(o,a,u){try{return await i.a.$rename(o,a,{overwrite:!1,...u})}catch(t){return $.e(t)}},async copy(o,a,u){try{return await i.a.$copy(o,a,{overwrite:!1,...u})}catch(t){return $.e(t)}},isWritableFileSystem(o){const a=s.getCapabilities(o);if(typeof a=="number")return!(a&2048)}})}async d(c,s,i){const o=[];for(;!s.isEqual(i,s.dirname(i));)try{if(!((await c.stat(i)).type&M.FileType.Directory))throw I.$BM.FileExists(`Unable to create folder '${i.scheme===l.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(a){if(M.$Ik(a)!==M.FileSystemProviderErrorCode.FileNotFound)throw a;o.push(s.basename(i)),i=s.dirname(i)}for(let a=o.length-1;a>=0;a--){i=s.joinPath(i,o[a]);try{await c.createDirectory(i)}catch(u){if(M.$Ik(u)!==M.FileSystemProviderErrorCode.FileExists)throw u}}}static e(c){if(c instanceof I.$BM)throw c;if(c instanceof M.$Ek)switch(c.code){case M.FileSystemProviderErrorCode.FileExists:throw I.$BM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$BM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$BM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$BM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$BM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$BM.Unavailable(c.message);default:throw new I.$BM(c.message,c.name)}if(!(c instanceof Error))throw new I.$BM(String(c));if(c.name==="ENOPRO"||c.message.includes("ENOPRO"))throw I.$BM.Unavailable(c.message);switch(c.name){case M.FileSystemProviderErrorCode.FileExists:throw I.$BM.FileExists(c.message);case M.FileSystemProviderErrorCode.FileNotFound:throw I.$BM.FileNotFound(c.message);case M.FileSystemProviderErrorCode.FileNotADirectory:throw I.$BM.FileNotADirectory(c.message);case M.FileSystemProviderErrorCode.FileIsADirectory:throw I.$BM.FileIsADirectory(c.message);case M.FileSystemProviderErrorCode.NoPermissions:throw I.$BM.NoPermissions(c.message);case M.FileSystemProviderErrorCode.Unavailable:throw I.$BM.Unavailable(c.message);default:throw new I.$BM(c.message,c.name)}}addFileSystemProvider(c,s,i){return this.b.set(c,{impl:s,extUri:i?.isCaseSensitive?k.$yg:k.$Ag,isReadonly:!!i?.isReadonly}),(0,y.$Rc)(()=>this.b.delete(c))}getFileSystemProviderExtUri(c){return this.b.get(c)?.extUri??k.$yg}};e.$Pgc=p,e.$Pgc=p=$=Ge([qe(0,m.$wN),qe(1,d.$qgc)],p),e.$Qgc=(0,L.$8h)("IExtHostConsumerFileSystem")}),define(Re[242],Ae([1,0,3,7]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class I{constructor(L){this.a=new Map,this.b=new Map,this.c=L.getProxy(S.$lL.MainThreadIssueReporter)}async $getIssueReporterUri(L,m){if(this.a.size===0)throw new Error("No issue request handlers registered");const d=this.a.get(L);if(!d)throw new Error("Issue request handler not found");const y=await d.handleIssueUrlRequest();if(!y)throw new Error("Issue request handler returned no result");return y}async $getIssueReporterData(L,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(L);if(!d)throw new Error("Issue data provider not found");const y=await d.provideIssueData(m);if(!y)throw new Error("Issue data provider returned no result");return y}async $getIssueReporterTemplate(L,m){if(this.b.size===0)throw new Error("No issue request handlers registered");const d=this.b.get(L);if(!d)throw new Error("Issue data provider not found");const y=await d.provideIssueTemplate(m);if(!y)throw new Error("Issue template provider returned no result");return y}registerIssueUriRequestHandler(L,m){const d=L.identifier.value;return this.a.set(d,m),this.c.$registerIssueUriRequestHandler(d),new M.$nL(()=>{this.c.$unregisterIssueUriRequestHandler(d),this.a.delete(d)})}registerIssueDataProvider(L,m){const d=L.identifier.value;return this.b.set(d,m),this.c.$registerIssueDataProvider(d),new M.$nL(()=>{this.c.$unregisterIssueDataProvider(d),this.b.delete(d)})}}e.$Thc=I}),define(Re[84],Ae([1,0,4,27,13,62,2]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=e.$Rgc=void 0,e.$Rgc=(0,S.$8h)("IExtensionStoragePaths");let m=class{constructor(y,A,k){this.d=A,this.f=k,this.a=y.workspace??void 0,this.b=y.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(y){return L.URI.joinPath(this.b.workspaceStorageHome,y)}async h(){if(!this.a)return Promise.resolve(void 0);const y=this.a.id,A=await this.g(y);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(L.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:L.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(y){if(this.c)return L.URI.joinPath(this.c,y.identifier.value)}globalValue(y){return L.URI.joinPath(this.b.globalStorageHome,y.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$Sgc=m,e.$Sgc=m=Ge([qe(0,M.$MN),qe(1,I.$pj),qe(2,R.$Qgc)],m)}),define(Re[243],Ae([1,0,7,17,5]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=void 0;let R=class{constructor(m){this.a=new S.$LM(S.ColorThemeKind.Dark),this.b=new I.$Wd}get activeColorTheme(){return this.a}$onColorThemeChange(m){let d;switch(m){case"light":d=S.ColorThemeKind.Light;break;case"hcDark":d=S.ColorThemeKind.HighContrast;break;case"hcLight":d=S.ColorThemeKind.HighContrastLight;break;default:d=S.ColorThemeKind.Dark}this.a=new S.$LM(d),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$kic=R,e.$kic=R=Ge([qe(0,M.$wN)],R)}),define(Re[85],Ae([1,0,21,5,6,167,4,13,196,3,27,17,7]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wzb=e.$vzb=e.TunnelDtoConverter=void 0;class $ extends d.$Lv{}var p;(function(c){function s(o){return{remoteAddress:o.remoteAddress,localAddress:o.localAddress,public:!!o.public,privacy:o.privacy??(o.public?d.TunnelPrivacyId.Public:d.TunnelPrivacyId.Private),protocol:o.protocol}}c.fromApiTunnel=s;function i(o){return{remoteAddress:{host:o.tunnelRemoteHost,port:o.tunnelRemotePort},localAddress:o.localAddress,public:o.privacy!==d.TunnelPrivacyId.ConstantPrivate&&o.privacy!==d.TunnelPrivacyId.ConstantPrivate,privacy:o.privacy,protocol:o.protocol}}c.fromServiceTunnel=i})(p||(e.TunnelDtoConverter=p={})),e.$vzb=(0,L.$8h)("IExtHostTunnelService");let r=class extends I.$Tc{constructor(s,i,o){super(),this.s=o,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new M.$Wd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(y.$lL.MainThreadTunnelService)}async openTunnel(s,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const o=await this.a.$openTunnel(i,s.displayName);if(o){const a=new $(o.remoteAddress,o.localAddress,()=>this.a.$closeTunnel(o.remoteAddress));return this.B(a),a}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,i){const o=this.u();return this.r.set(o,{selector:s,provider:i}),this.a.$registerPortsAttributesProvider(s,o),new l.$nL(()=>{this.r.delete(o),this.a.$unregisterPortsAttributesProvider(o)})}async $providePortAttributes(s,i,o,a,u){const t=[];for(const n of s){const w=this.r.get(n);if(!w)return[];t.push(...await Promise.all(i.map(async D=>{let h;try{h=await w.provider.providePortAttributes({port:D,pid:o,commandLine:a},u)}catch{h=await w.provider.providePortAttributes(D,o,a,u)}return{providedAttributes:h,port:D}})))}const f=t.filter(n=>!!n.providedAttributes);return f.length>0?f.map(n=>({autoForwardAction:n.providedAttributes.autoForwardAction,port:n.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(a,u)=>await s.provideTunnel(a,u,new S.$7d().token)??void 0;const o=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(o),Promise.resolve((0,I.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,i){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const o=s.tunnelFactory??(i?this.w(i):void 0);if(o){this.b=o;let a=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&a.length===0&&(a=[{id:"private",label:R.localize(0,null),themeIcon:"lock"},{id:"public",label:R.localize(1,null),themeIcon:"eye"}]);const u=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:a,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,I.$Rc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,i){if(this.g.has(s.host)){const o=this.g.get(s.host);o.has(s.port)&&(i&&o.get(s.port).disposeListener.dispose(),await o.get(s.port).tunnel.dispose(),o.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const o=this.b(s,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),o!==void 0){const a=await o;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),a===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const u=this.B(a.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(a.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:a,disposeListener:u}),p.fromApiTunnel(a)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(o){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),o instanceof Error)return o.message}}async $applyCandidateFilter(s){const i=await Promise.all(s.map(a=>this.f(a.host,a.port,a.detail??""))),o=s.filter((a,u)=>i[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(a=>a.port).join(", ")} to ${o.map(a=>a.port).join(", ")}`),o}};e.$wzb=r,e.$wzb=r=Ge([qe(0,k.$wN),qe(1,A.$MN),qe(2,m.$pj)],r)}),define(Re[8],Ae([1,0,18,23,127,244,46,28,120,52,69,26,16,2,29,86,98,103,102,83,49,59,215,25,7,24]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f,n,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseMarkdownPart=e.ChatResponseTextPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$vN=e.$uN=e.MarkdownString=e.$tN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var D;(function(ye){function Fe(Q){const{selectionStartLineNumber:Me,selectionStartColumn:Ue,positionLineNumber:Ye,positionColumn:Ke}=Q,tt=new n.$oL(Me-1,Ue-1),pt=new n.$oL(Ye-1,Ke-1);return new n.$qL(tt,pt)}ye.to=Fe;function he(Q){const{anchor:Me,active:Ue}=Q;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ue.line+1,positionColumn:Ue.character+1}}ye.from=he})(D||(e.Selection=D={}));var h;(function(ye){function Fe(Q){if(!Q)return;const{start:Me,end:Ue}=Q;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ue.line+1,endColumn:Ue.character+1}}ye.from=Fe;function he(Q){if(!Q)return;const{startLineNumber:Me,startColumn:Ue,endLineNumber:Ye,endColumn:Ke}=Q;return new n.$pL(Me-1,Ue-1,Ye-1,Ke-1)}ye.to=he})(h||(e.Range=h={}));var b;(function(ye){function Fe(Q){return{uri:Q.uri,range:h.from(Q.range)}}ye.from=Fe;function he(Q){return new n.$zL($.URI.revive(Q.uri),h.to(Q.range))}ye.to=he})(b||(e.Location=b={}));var P;(function(ye){function Fe(he){switch(he){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 3:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}ye.to=Fe})(P||(e.TokenType=P={}));var g;(function(ye){function Fe(Q){return new n.$oL(Q.lineNumber-1,Q.column-1)}ye.to=Fe;function he(Q){return{lineNumber:Q.line+1,column:Q.character+1}}ye.from=he})(g||(e.Position=g={}));var v;(function(ye){function Fe(Me,Ue,Ye){return(0,S.$Hb)((0,S.$3b)(Me).map(Ke=>he(Ke,Ue,Ye)))}ye.from=Fe;function he(Me,Ue,Ye){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Ye?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:Q(Me.scheme,Ue),pattern:pe.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Ye?.isBuiltin}}function Q(Me,Ue){return Ue&&typeof Me=="string"?Ue.transformOutgoingScheme(Me):Me}})(v||(e.DocumentSelector=v={}));var E;(function(ye){function Fe(Q){switch(Q){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}}ye.from=Fe;function he(Q){switch(Q){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated;default:return}}ye.to=he})(E||(e.DiagnosticTag=E={}));var T;(function(ye){function Fe(Q){let Me;return Q.code&&((0,l.$Jf)(Q.code)||(0,l.$Nf)(Q.code)?Me=String(Q.code):Me={value:String(Q.code.value),target:Q.code.target}),{...h.from(Q.range),message:Q.message,source:Q.source,code:Me,severity:J.from(Q.severity),relatedInformation:Q.relatedInformation&&Q.relatedInformation.map(N.from),tags:Array.isArray(Q.tags)?(0,S.$Hb)(Q.tags.map(E.from)):void 0}}ye.from=Fe;function he(Q){const Me=new n.$BL(h.to(Q),Q.message,J.to(Q.severity));return Me.source=Q.source,Me.code=(0,l.$Jf)(Q.code)?Q.code:Q.code?.value,Me.relatedInformation=Q.relatedInformation&&Q.relatedInformation.map(N.to),Me.tags=Q.tags&&(0,S.$Hb)(Q.tags.map(E.to)),Me}ye.to=he})(T||(e.Diagnostic=T={}));var N;(function(ye){function Fe(Q){return{...h.from(Q.location.range),message:Q.message,resource:Q.location.uri}}ye.from=Fe;function he(Q){return new n.$AL(new n.$zL(Q.resource,h.to(Q)),Q.message)}ye.to=he})(N||(e.DiagnosticRelatedInformation=N={}));var J;(function(ye){function Fe(Q){switch(Q){case n.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}ye.from=Fe;function he(Q){switch(Q){case c.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return n.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint;default:return n.DiagnosticSeverity.Error}}ye.to=he})(J||(e.DiagnosticSeverity=J={}));var q;(function(ye){function Fe(Q){return typeof Q=="number"&&Q>=n.ViewColumn.One?Q-1:Q===n.ViewColumn.Beside?t.$gD:t.$fD}ye.from=Fe;function he(Q){if(typeof Q=="number"&&Q>=0)return Q+1;throw new Error("invalid 'EditorGroupColumn'")}ye.to=he})(q||(e.ViewColumn=q={}));function U(ye){return typeof ye.range<"u"}function C(ye){return ye.length===0?!0:!!U(ye[0])}e.$tN=C;var F;(function(ye){function Fe(Ke){return Ke.map(ye.from)}ye.fromMany=Fe;function he(Ke){return Ke&&typeof Ke=="object"&&typeof Ke.language=="string"&&typeof Ke.value=="string"}function Q(Ke){let tt;if(he(Ke)){const{language:Pt,value:Jt}=Ke;tt={value:"```"+Pt+`
`+Jt+"\n```\n"}}else n.$OL.isMarkdownString(Ke)?tt={value:Ke.value,isTrusted:Ke.isTrusted,supportThemeIcons:Ke.supportThemeIcons,supportHtml:Ke.supportHtml,baseUri:Ke.baseUri}:typeof Ke=="string"?tt={value:Ke}:tt={value:""};const pt=Object.create(null);tt.uris=pt;const zt=Pt=>{try{let Jt=$.URI.parse(Pt,!0);Jt=Jt.with({query:Me(Jt.query,pt)}),pt[Pt]=Jt}catch{}return""},Ut=new d.marked.Renderer;return Ut.link=zt,Ut.image=Pt=>typeof Pt=="string"?zt(L.$rk(Pt).href):"",(0,d.marked)(tt.value,{renderer:Ut}),tt}ye.from=Q;function Me(Ke,tt){if(!Ke)return Ke;let pt;try{pt=(0,y.$Dh)(Ke)}catch{}if(!pt)return Ke;let zt=!1;return pt=(0,k.$An)(pt,Ut=>{if($.URI.isUri(Ut)){const Pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[Pt]=Ut,zt=!0,Pt}else return}),zt?JSON.stringify(pt):Ke}function Ue(Ke){const tt=new n.$OL(Ke.value,Ke.supportThemeIcons);return tt.isTrusted=Ke.isTrusted,tt.supportHtml=Ke.supportHtml,tt.baseUri=Ke.baseUri?$.URI.from(Ke.baseUri):void 0,tt}ye.to=Ue;function Ye(Ke){if(Ke)return typeof Ke=="string"?Ke:ye.from(Ke)}ye.fromStrict=Ye})(F||(e.MarkdownString=F={}));function W(ye){return C(ye)?ye.map(Fe=>({range:h.from(Fe.range),hoverMessage:Array.isArray(Fe.hoverMessage)?F.fromMany(Fe.hoverMessage):Fe.hoverMessage?F.from(Fe.hoverMessage):void 0,renderOptions:Fe.renderOptions})):ye.map(Fe=>({range:h.from(Fe)}))}e.$uN=W;function re(ye){return typeof ye>"u"?ye:typeof ye=="string"?$.URI.file(ye):ye}e.$vN=re;var ce;(function(ye){function Fe(he){return typeof he>"u"?he:{contentText:he.contentText,contentIconPath:he.contentIconPath?re(he.contentIconPath):void 0,border:he.border,borderColor:he.borderColor,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,color:he.color,backgroundColor:he.backgroundColor,margin:he.margin,width:he.width,height:he.height}}ye.from=Fe})(ce||(e.ThemableDecorationAttachmentRenderOptions=ce={}));var we;(function(ye){function Fe(he){return typeof he>"u"?he:{backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?re(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?ce.from(he.before):void 0,after:he.after?ce.from(he.after):void 0}}ye.from=Fe})(we||(e.ThemableDecorationRenderOptions=we={}));var De;(function(ye){function Fe(he){if(typeof he>"u")return he;switch(he){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}ye.from=Fe})(De||(e.DecorationRangeBehavior=De={}));var le;(function(ye){function Fe(he){return{isWholeLine:he.isWholeLine,rangeBehavior:he.rangeBehavior?De.from(he.rangeBehavior):void 0,overviewRulerLane:he.overviewRulerLane,light:he.light?we.from(he.light):void 0,dark:he.dark?we.from(he.dark):void 0,backgroundColor:he.backgroundColor,outline:he.outline,outlineColor:he.outlineColor,outlineStyle:he.outlineStyle,outlineWidth:he.outlineWidth,border:he.border,borderColor:he.borderColor,borderRadius:he.borderRadius,borderSpacing:he.borderSpacing,borderStyle:he.borderStyle,borderWidth:he.borderWidth,fontStyle:he.fontStyle,fontWeight:he.fontWeight,textDecoration:he.textDecoration,cursor:he.cursor,color:he.color,opacity:he.opacity,letterSpacing:he.letterSpacing,gutterIconPath:he.gutterIconPath?re(he.gutterIconPath):void 0,gutterIconSize:he.gutterIconSize,overviewRulerColor:he.overviewRulerColor,before:he.before?ce.from(he.before):void 0,after:he.after?ce.from(he.after):void 0}}ye.from=Fe})(le||(e.DecorationRenderOptions=le={}));var ve;(function(ye){function Fe(Q){return{text:Q.newText,eol:Q.newEol&&ct.from(Q.newEol),range:h.from(Q.range)}}ye.from=Fe;function he(Q){const Me=new n.$uL(h.to(Q.range),Q.text);return Me.newEol=typeof Q.eol>"u"?void 0:ct.to(Q.eol),Me}ye.to=he})(ve||(e.TextEdit=ve={}));var se;(function(ye){function Fe(Q,Me){const Ue={edits:[]};if(Q instanceof n.$xL){const Ye=new m.$Bc;for(const Ke of Q._allEntries())Ke._type===1&&$.URI.isUri(Ke.to)&&Ke.from===void 0&&Ye.add(Ke.to);for(const Ke of Q._allEntries())if(Ke._type===1){let tt;Ke.options?.contents&&(ArrayBuffer.isView(Ke.options.contents)?tt={type:"base64",value:(0,M.$Ee)(M.$ke.wrap(Ke.options.contents))}:tt={type:"dataTransferItem",id:Ke.options.contents._itemId}),Ue.edits.push({oldResource:Ke.from,newResource:Ke.to,options:{...Ke.options,contents:tt},metadata:Ke.metadata})}else Ke._type===2?Ue.edits.push({resource:Ke.uri,textEdit:ve.from(Ke.edit),versionId:Ye.has(Ke.uri)?void 0:Me?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===6?Ue.edits.push({resource:Ke.uri,textEdit:{range:h.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ke.uri)?void 0:Me?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata}):Ke._type===3?Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ue.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Me?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(_t.from)}})}return Ue}ye.from=Fe;function he(Q){const Me=new n.$xL,Ue=new m.$Ac;for(const Ye of Q.edits)if(Ye.textEdit){const Ke=Ye,tt=$.URI.revive(Ke.resource),pt=h.to(Ke.textEdit.range),zt=Ke.textEdit.text,Ut=Ke.textEdit.insertAsSnippet;let Pt;Ut?Pt=n.$wL.replace(pt,new n.$yL(zt)):Pt=n.$uL.replace(pt,zt);const Jt=Ue.get(tt);Jt?Jt.push(Pt):Ue.set(tt,[Pt])}else Me.renameFile($.URI.revive(Ye.oldResource),$.URI.revive(Ye.newResource),Ye.options);for(const[Ye,Ke]of Ue)Me.set(Ye,Ke);return Me}ye.to=he})(se||(e.WorkspaceEdit=se={}));var $e;(function(ye){const Fe=Object.create(null);Fe[n.SymbolKind.File]=0,Fe[n.SymbolKind.Module]=1,Fe[n.SymbolKind.Namespace]=2,Fe[n.SymbolKind.Package]=3,Fe[n.SymbolKind.Class]=4,Fe[n.SymbolKind.Method]=5,Fe[n.SymbolKind.Property]=6,Fe[n.SymbolKind.Field]=7,Fe[n.SymbolKind.Constructor]=8,Fe[n.SymbolKind.Enum]=9,Fe[n.SymbolKind.Interface]=10,Fe[n.SymbolKind.Function]=11,Fe[n.SymbolKind.Variable]=12,Fe[n.SymbolKind.Constant]=13,Fe[n.SymbolKind.String]=14,Fe[n.SymbolKind.Number]=15,Fe[n.SymbolKind.Boolean]=16,Fe[n.SymbolKind.Array]=17,Fe[n.SymbolKind.Object]=18,Fe[n.SymbolKind.Key]=19,Fe[n.SymbolKind.Null]=20,Fe[n.SymbolKind.EnumMember]=21,Fe[n.SymbolKind.Struct]=22,Fe[n.SymbolKind.Event]=23,Fe[n.SymbolKind.Operator]=24,Fe[n.SymbolKind.TypeParameter]=25;function he(Me){return typeof Fe[Me]=="number"?Fe[Me]:6}ye.from=he;function Q(Me){for(const Ue in Fe)if(Fe[Ue]===Me)return Number(Ue);return n.SymbolKind.Property}ye.to=Q})($e||(e.SymbolKind=$e={}));var te;(function(ye){function Fe(Q){switch(Q){case n.SymbolTag.Deprecated:return 1}}ye.from=Fe;function he(Q){switch(Q){case 1:return n.SymbolTag.Deprecated}}ye.to=he})(te||(e.SymbolTag=te={}));var X;(function(ye){function Fe(Q){return{name:Q.name,kind:$e.from(Q.kind),tags:Q.tags&&Q.tags.map(te.from),containerName:Q.containerName,location:Pe.from(Q.location)}}ye.from=Fe;function he(Q){const Me=new n.$FL(Q.name,$e.to(Q.kind),Q.containerName,Pe.to(Q.location));return Me.tags=Q.tags&&Q.tags.map(te.to),Me}ye.to=he})(X||(e.WorkspaceSymbol=X={}));var V;(function(ye){function Fe(Q){const Me={name:Q.name||"!!MISSING: name!!",detail:Q.detail,range:h.from(Q.range),selectionRange:h.from(Q.selectionRange),kind:$e.from(Q.kind),tags:Q.tags?.map(te.from)??[]};return Q.children&&(Me.children=Q.children.map(Fe)),Me}ye.from=Fe;function he(Q){const Me=new n.$GL(Q.name,Q.detail,$e.to(Q.kind),h.to(Q.range),h.to(Q.selectionRange));return(0,S.$Lb)(Q.tags)&&(Me.tags=Q.tags.map(te.to)),Q.children&&(Me.children=Q.children.map(he)),Me}ye.to=he})(V||(e.DocumentSymbol=V={}));var ie;(function(ye){function Fe(Q){const Me=new n.$KL($e.to(Q.kind),Q.name,Q.detail||"",$.URI.revive(Q.uri),h.to(Q.range),h.to(Q.selectionRange));return Me._sessionId=Q._sessionId,Me._itemId=Q._itemId,Me}ye.to=Fe;function he(Q,Me,Ue){if(Me=Me??Q._sessionId,Ue=Ue??Q._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,name:Q.name,detail:Q.detail,kind:$e.from(Q.kind),uri:Q.uri,range:h.from(Q.range),selectionRange:h.from(Q.selectionRange),tags:Q.tags?.map(te.from)}}ye.from=he})(ie||(e.CallHierarchyItem=ie={}));var Ce;(function(ye){function Fe(he){return new n.$LL(ie.to(he.from),he.fromRanges.map(Q=>h.to(Q)))}ye.to=Fe})(Ce||(e.CallHierarchyIncomingCall=Ce={}));var Te;(function(ye){function Fe(he){return new n.$ML(ie.to(he.to),he.fromRanges.map(Q=>h.to(Q)))}ye.to=Fe})(Te||(e.CallHierarchyOutgoingCall=Te={}));var Pe;(function(ye){function Fe(Q){return{range:Q.range&&h.from(Q.range),uri:Q.uri}}ye.from=Fe;function he(Q){return new n.$zL($.URI.revive(Q.uri),h.to(Q.range))}ye.to=he})(Pe||(e.location=Pe={}));var be;(function(ye){function Fe(Q){const Me=Q,Ue=Q;return{originSelectionRange:Me.originSelectionRange?h.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ue.uri,range:h.from(Me.targetRange?Me.targetRange:Ue.range),targetSelectionRange:Me.targetSelectionRange?h.from(Me.targetSelectionRange):void 0}}ye.from=Fe;function he(Q){return{targetUri:$.URI.revive(Q.uri),targetRange:h.to(Q.range),targetSelectionRange:Q.targetSelectionRange?h.to(Q.targetSelectionRange):void 0,originSelectionRange:Q.originSelectionRange?h.to(Q.originSelectionRange):void 0}}ye.to=he})(be||(e.DefinitionLink=be={}));var ge;(function(ye){function Fe(Q){return{range:h.from(Q.range),contents:F.fromMany(Q.contents)}}ye.from=Fe;function he(Q){return new n.$CL(Q.contents.map(F.to),h.to(Q.range))}ye.to=he})(ge||(e.Hover=ge={}));var G;(function(ye){function Fe(Q){return{range:h.from(Q.range),expression:Q.expression}}ye.from=Fe;function he(Q){return new n.$wM(h.to(Q.range),Q.expression)}ye.to=he})(G||(e.EvaluatableExpression=G={}));var _;(function(ye){function Fe(Q){if(Q instanceof n.$xM)return{type:"text",range:h.from(Q.range),text:Q.text};if(Q instanceof n.$yM)return{type:"variable",range:h.from(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};if(Q instanceof n.$zM)return{type:"expression",range:h.from(Q.range),expression:Q.expression};throw new Error("Unknown 'InlineValue' type")}ye.from=Fe;function he(Q){switch(Q.type){case"text":return{range:h.to(Q.range),text:Q.text};case"variable":return{range:h.to(Q.range),variableName:Q.variableName,caseSensitiveLookup:Q.caseSensitiveLookup};case"expression":return{range:h.to(Q.range),expression:Q.expression}}}ye.to=he})(_||(e.InlineValue=_={}));var ue;(function(ye){function Fe(Q){return{frameId:Q.frameId,stoppedLocation:h.from(Q.stoppedLocation)}}ye.from=Fe;function he(Q){return new n.$AM(Q.frameId,h.to(Q.stoppedLocation))}ye.to=he})(ue||(e.InlineValueContext=ue={}));var de;(function(ye){function Fe(Q){return{range:h.from(Q.range),kind:Q.kind}}ye.from=Fe;function he(Q){return new n.$DL(h.to(Q.range),Q.kind)}ye.to=he})(de||(e.DocumentHighlight=de={}));var Le;(function(ye){function Fe(Q){return{uri:Q.uri,highlights:Q.highlights.map(de.from)}}ye.from=Fe;function he(Q){return new n.$EL($.URI.revive(Q.uri),Q.highlights.map(de.to))}ye.to=he})(Le||(e.MultiDocumentHighlight=Le={}));var fe;(function(ye){function Fe(he){switch(he){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}ye.to=Fe})(fe||(e.CompletionTriggerKind=fe={}));var ke;(function(ye){function Fe(he){return{triggerKind:fe.to(he.triggerKind),triggerCharacter:he.triggerCharacter}}ye.to=Fe})(ke||(e.CompletionContext=ke={}));var Ie;(function(ye){function Fe(Q){switch(Q){case n.CompletionItemTag.Deprecated:return 1}}ye.from=Fe;function he(Q){switch(Q){case 1:return n.CompletionItemTag.Deprecated}}ye.to=he})(Ie||(e.CompletionItemTag=Ie={}));var O;(function(ye){const Fe=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);function he(Ue){return Fe.get(Ue)??9}ye.from=he;const Q=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);function Me(Ue){return Q.get(Ue)??n.CompletionItemKind.Property}ye.to=Me})(O||(e.CompletionItemKind=O={}));var K;(function(ye){function Fe(he,Q){const Me=new n.$UL(he.label);return Me.insertText=he.insertText,Me.kind=O.to(he.kind),Me.tags=he.tags?.map(Ie.to),Me.detail=he.detail,Me.documentation=L.$lk(he.documentation)?F.to(he.documentation):he.documentation,Me.sortText=he.sortText,Me.filterText=he.filterText,Me.preselect=he.preselect,Me.commitCharacters=he.commitCharacters,p.$Ws.isIRange(he.range)?Me.range=h.to(he.range):typeof he.range=="object"&&(Me.range={inserting:h.to(he.range.insert),replacing:h.to(he.range.replace)}),Me.keepWhitespace=typeof he.insertTextRules>"u"?!1:!!(he.insertTextRules&1),typeof he.insertTextRules<"u"&&he.insertTextRules&4?Me.insertText=new n.$yL(he.insertText):(Me.insertText=he.insertText,Me.textEdit=Me.range instanceof n.$pL?new n.$uL(Me.range,Me.insertText):void 0),he.additionalTextEdits&&he.additionalTextEdits.length>0&&(Me.additionalTextEdits=he.additionalTextEdits.map(Ue=>ve.to(Ue))),Me.command=Q&&he.command?Q.fromInternal(he.command):void 0,Me}ye.to=Fe})(K||(e.CompletionItem=K={}));var j;(function(ye){function Fe(Q){if(typeof Q.label!="string"&&!Array.isArray(Q.label))throw new TypeError("Invalid label");return{label:Q.label,documentation:F.fromStrict(Q.documentation)}}ye.from=Fe;function he(Q){return{label:Q.label,documentation:L.$lk(Q.documentation)?F.to(Q.documentation):Q.documentation}}ye.to=he})(j||(e.ParameterInformation=j={}));var H;(function(ye){function Fe(Q){return{label:Q.label,documentation:F.fromStrict(Q.documentation),parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.from):[],activeParameter:Q.activeParameter}}ye.from=Fe;function he(Q){return{label:Q.label,documentation:L.$lk(Q.documentation)?F.to(Q.documentation):Q.documentation,parameters:Array.isArray(Q.parameters)?Q.parameters.map(j.to):[],activeParameter:Q.activeParameter}}ye.to=he})(H||(e.SignatureInformation=H={}));var Z;(function(ye){function Fe(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.from):[]}}ye.from=Fe;function he(Q){return{activeSignature:Q.activeSignature,activeParameter:Q.activeParameter,signatures:Array.isArray(Q.signatures)?Q.signatures.map(H.to):[]}}ye.to=he})(Z||(e.SignatureHelp=Z={}));var oe;(function(ye){function Fe(he,Q){const Me=new n.$TL(g.to(Q.position),typeof Q.label=="string"?Q.label:Q.label.map(Ee.to.bind(void 0,he)),Q.kind&&Be.to(Q.kind));return Me.textEdits=Q.textEdits&&Q.textEdits.map(ve.to),Me.tooltip=L.$lk(Q.tooltip)?F.to(Q.tooltip):Q.tooltip,Me.paddingLeft=Q.paddingLeft,Me.paddingRight=Q.paddingRight,Me}ye.to=Fe})(oe||(e.InlayHint=oe={}));var Ee;(function(ye){function Fe(he,Q){const Me=new n.$SL(Q.label);return Me.tooltip=L.$lk(Q.tooltip)?F.to(Q.tooltip):Q.tooltip,r.Command.is(Q.command)&&(Me.command=he.fromInternal(Q.command)),Q.location&&(Me.location=Pe.to(Q.location)),Me}ye.to=Fe})(Ee||(e.InlayHintLabelPart=Ee={}));var Be;(function(ye){function Fe(Q){return Q}ye.from=Fe;function he(Q){return Q}ye.to=he})(Be||(e.InlayHintKind=Be={}));var We;(function(ye){function Fe(Q){return{range:h.from(Q.range),url:Q.target,tooltip:Q.tooltip}}ye.from=Fe;function he(Q){let Me;if(Q.url)try{Me=typeof Q.url=="string"?$.URI.parse(Q.url,!0):$.URI.revive(Q.url)}catch{}return new n.$ZL(h.to(Q.range),Me)}ye.to=he})(We||(e.DocumentLink=We={}));var Ze;(function(ye){function Fe(Q){const Me=new n.$3L(Q.label);return Q.textEdit&&(Me.textEdit=ve.to(Q.textEdit)),Q.additionalTextEdits&&(Me.additionalTextEdits=Q.additionalTextEdits.map(Ue=>ve.to(Ue))),Me}ye.to=Fe;function he(Q){return{label:Q.label,textEdit:Q.textEdit?ve.from(Q.textEdit):void 0,additionalTextEdits:Q.additionalTextEdits?Q.additionalTextEdits.map(Me=>ve.from(Me)):void 0}}ye.from=he})(Ze||(e.ColorPresentation=Ze={}));var _e;(function(ye){function Fe(Q){return new n.$1L(Q[0],Q[1],Q[2],Q[3])}ye.to=Fe;function he(Q){return[Q.red,Q.green,Q.blue,Q.alpha]}ye.from=he})(_e||(e.Color=_e={}));var at;(function(ye){function Fe(Q){return{range:h.from(Q.range)}}ye.from=Fe;function he(Q){return new n.$JL(h.to(Q.range))}ye.to=he})(at||(e.SelectionRange=at={}));var rt;(function(ye){function Fe(he){switch(he){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}ye.to=Fe})(rt||(e.TextDocumentSaveReason=rt={}));var et;(function(ye){function Fe(Q){switch(Q){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.Interval:return 3;case n.TextEditorLineNumbersStyle.On:default:return 1}}ye.from=Fe;function he(Q){switch(Q){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:return n.TextEditorLineNumbersStyle.Relative;case 3:return n.TextEditorLineNumbersStyle.Interval;case 1:default:return n.TextEditorLineNumbersStyle.On}}ye.to=he})(et||(e.TextEditorLineNumbersStyle=et={}));var ct;(function(ye){function Fe(Q){if(Q===n.EndOfLine.CRLF)return 1;if(Q===n.EndOfLine.LF)return 0}ye.from=Fe;function he(Q){if(Q===1)return n.EndOfLine.CRLF;if(Q===0)return n.EndOfLine.LF}ye.to=he})(ct||(e.EndOfLine=ct={}));var je;(function(ye){function Fe(he){if(typeof he=="object")return he.viewId;switch(he){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ye.from=Fe})(je||(e.ProgressLocation=je={}));var vt;(function(ye){function Fe(Q){const Me={start:Q.start+1,end:Q.end+1};return Q.kind&&(Me.kind=Y.from(Q.kind)),Me}ye.from=Fe;function he(Q){const Me={start:Q.start-1,end:Q.end-1};return Q.kind&&(Me.kind=Y.to(Q.kind)),Me}ye.to=he})(vt||(e.FoldingRange=vt={}));var Y;(function(ye){function Fe(Q){if(Q)switch(Q){case n.FoldingRangeKind.Comment:return r.$Mt.Comment;case n.FoldingRangeKind.Imports:return r.$Mt.Imports;case n.FoldingRangeKind.Region:return r.$Mt.Region}}ye.from=Fe;function he(Q){if(Q)switch(Q.value){case r.$Mt.Comment.value:return n.FoldingRangeKind.Comment;case r.$Mt.Imports.value:return n.FoldingRangeKind.Imports;case r.$Mt.Region.value:return n.FoldingRangeKind.Region}}ye.to=he})(Y||(e.FoldingRangeKind=Y={}));var x;(function(ye){function Fe(he){if(he)return{pinned:typeof he.preview=="boolean"?!he.preview:void 0,inactive:he.background,preserveFocus:he.preserveFocus,selection:typeof he.selection=="object"?h.from(he.selection):void 0,override:typeof he.override=="boolean"?i.$IE.id:void 0}}ye.from=Fe})(x||(e.TextEditorOpenOptions=x={}));var pe;(function(ye){function Fe(Ue){return Ue instanceof n.$kM?Ue.toJSON():typeof Ue=="string"?Ue:he(Ue)||Q(Ue)?new n.$kM(Ue.baseUri??Ue.base,Ue.pattern).toJSON():Ue}ye.from=Fe;function he(Ue){const Ye=Ue;return Ye?$.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function Q(Ue){const Ye=Ue;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Me(Ue){return typeof Ue=="string"?Ue:new n.$kM($.URI.revive(Ue.baseUri),Ue.pattern)}ye.to=Me})(pe||(e.GlobPattern=pe={}));var Ve;(function(ye){function Fe(he){if(he){if(Array.isArray(he))return he.map(Fe);if(typeof he=="string")return he;{const Q=he;return{language:Q.language,scheme:Q.scheme,pattern:pe.from(Q.pattern),exclusive:Q.exclusive,notebookType:Q.notebookType}}}else return}ye.from=Fe})(Ve||(e.LanguageSelector=Ve={}));var Qe;(function(ye){function Fe(Q){return!!Q&&typeof Q=="object"&&"documents"in Q&&Array.isArray(Q.documents)&&Q.documents.every(Me=>Array.isArray(Me)&&Me.every(Ue=>Ue&&typeof Ue=="object"&&"uri"in Ue&&$.URI.isUri(Ue.uri)&&"version"in Ue&&typeof Ue.version=="number"&&"ranges"in Ue&&Array.isArray(Ue.ranges)&&Ue.ranges.every(Ye=>Ye instanceof n.$pL)))}ye.is=Fe;function he(Q){return{documents:Q.documents.map(Me=>Me.map(Ue=>({uri:$.URI.from(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ye=>h.from(Ye))})))}}ye.from=he})(Qe||(e.MappedEditsContext=Qe={}));var nt;(function(ye){function Fe(Q){return{start:Q.start,end:Q.end}}ye.from=Fe;function he(Q){return new n.$MM(Q.start,Q.end)}ye.to=he})(nt||(e.NotebookRange=nt={}));var st;(function(ye){function Fe(Q){return{timing:typeof Q.runStartTime=="number"&&typeof Q.runEndTime=="number"?{startTime:Q.runStartTime,endTime:Q.runEndTime}:void 0,executionOrder:Q.executionOrder,success:Q.lastRunSuccess}}ye.to=Fe;function he(Q){return{lastRunSuccess:Q.success,runStartTime:Q.timing?.startTime,runEndTime:Q.timing?.endTime,executionOrder:Q.executionOrder}}ye.from=he})(st||(e.NotebookCellExecutionSummary=st={}));var Ne;(function(ye){function Fe(he){if(he===o.NotebookCellExecutionState.Unconfirmed)return n.NotebookCellExecutionState.Pending;if(he===o.NotebookCellExecutionState.Pending)return;if(he===o.NotebookCellExecutionState.Executing)return n.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${he}`)}ye.to=Fe})(Ne||(e.NotebookCellExecutionState=Ne={}));var Mt;(function(ye){function Fe(Q){switch(Q){case n.NotebookCellKind.Markup:return o.CellKind.Markup;case n.NotebookCellKind.Code:default:return o.CellKind.Code}}ye.from=Fe;function he(Q){switch(Q){case o.CellKind.Markup:return n.NotebookCellKind.Markup;case o.CellKind.Code:default:return n.NotebookCellKind.Code}}ye.to=he})(Mt||(e.NotebookCellKind=Mt={}));var Qt;(function(ye){function Fe(Q){const Me={metadata:Q.metadata??Object.create(null),cells:[]};for(const Ue of Q.cells)n.$NM.validate(Ue),Me.cells.push(_t.from(Ue));return Me}ye.from=Fe;function he(Q){const Me=new n.$OM(Q.cells.map(_t.to));return(0,l.$Wf)(Q.metadata)||(Me.metadata=Q.metadata),Me}ye.to=he})(Qt||(e.NotebookData=Qt={}));var _t;(function(ye){function Fe(Q){return{cellKind:Mt.from(Q.kind),language:Q.languageId,mime:Q.mime,source:Q.value,metadata:Q.metadata,internalMetadata:st.from(Q.executionSummary??{}),outputs:Q.outputs?Q.outputs.map(yt.from):[]}}ye.from=Fe;function he(Q){return new n.$NM(Mt.to(Q.cellKind),Q.source,Q.language,Q.mime,Q.outputs?Q.outputs.map(yt.to):void 0,Q.metadata,Q.internalMetadata?st.to(Q.internalMetadata):void 0)}ye.to=he})(_t||(e.NotebookCellData=_t={}));var jt;(function(ye){function Fe(Q){return{mime:Q.mime,valueBytes:M.$ke.wrap(Q.data)}}ye.from=Fe;function he(Q){return new n.$PM(Q.valueBytes.buffer,Q.mime)}ye.to=he})(jt||(e.NotebookCellOutputItem=jt={}));var yt;(function(ye){function Fe(Q){return{outputId:Q.id,items:Q.items.map(jt.from),metadata:Q.metadata}}ye.from=Fe;function he(Q){const Me=Q.items.map(jt.to);return new n.$QM(Me,Q.outputId,Q.metadata)}ye.to=he})(yt||(e.NotebookCellOutput=yt={}));var ei;(function(ye){function Fe(Me){return Q(Me)?{include:pe.from(Me.include)??void 0,exclude:pe.from(Me.exclude)??void 0}:pe.from(Me)??void 0}ye.from=Fe;function he(Me){return Q(Me)?{include:pe.to(Me.include),exclude:pe.to(Me.exclude)}:pe.to(Me)}ye.to=he;function Q(Me){const Ue=Me;return Ue?!(0,l.$Sf)(Ue.include)&&!(0,l.$Sf)(Ue.exclude):!1}})(ei||(e.NotebookExclusiveDocumentPattern=ei={}));var Bt;(function(ye){function Fe(he,Q,Me){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{alignment:he.alignment===n.NotebookCellStatusBarAlignment.Left?1:2,command:Q.toInternal(Ue,Me),text:he.text,tooltip:he.tooltip,accessibilityInformation:he.accessibilityInformation,priority:he.priority}}ye.from=Fe})(Bt||(e.NotebookStatusBarItem=Bt={}));var ni;(function(ye){function Fe(he,Q,Me){const Ue=typeof he.command=="string"?{title:"",command:he.command}:he.command;return{command:Q.toInternal(Ue,Me),label:he.label,description:he.description,detail:he.detail,documentation:he.documentation}}ye.from=Fe})(ni||(e.NotebookKernelSourceAction=ni={}));var Zt;(function(ye){function Fe(he){return{transientOutputs:he?.transientOutputs??!1,transientCellMetadata:he?.transientCellMetadata??{},transientDocumentMetadata:he?.transientDocumentMetadata??{},cellContentMetadata:he?.cellContentMetadata??{}}}ye.from=Fe})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var Yt;(function(ye){function Fe(Q){return{uri:Q.uri,provides:Q.provides}}ye.from=Fe;function he(Q){return new n.$SM($.URI.revive(Q.uri),Q.provides)}ye.to=he})(Yt||(e.NotebookRendererScript=Yt={}));var Xe;(function(ye){function Fe(Q){return{message:F.fromStrict(Q.message)||"",type:0,expected:Q.expectedOutput,actual:Q.actualOutput,contextValue:Q.contextValue,location:Q.location&&{range:h.from(Q.location.range),uri:Q.location.uri}}}ye.from=Fe;function he(Q){const Me=new n.$YM(typeof Q.message=="string"?Q.message:F.to(Q.message));return Me.actualOutput=Q.actual,Me.expectedOutput=Q.expected,Me.contextValue=Q.contextValue,Me.location=Q.location?Pe.to(Q.location):void 0,Me}ye.to=he})(Xe||(e.TestMessage=Xe={}));var Wt;(function(ye){ye.namespace=u.$hK,ye.denamespace=u.$iK})(Wt||(e.TestTag=Wt={}));var ti;(function(ye){function Fe(Q){const Me=(0,s.$sN)(Q).controllerId;return{extId:a.$dK.fromExtHostTestItem(Q,Me).toString(),label:Q.label,uri:$.URI.revive(Q.uri),busy:Q.busy,tags:Q.tags.map(Ue=>Wt.namespace(Me,Ue.id)),range:p.$Ws.lift(h.from(Q.range)),description:Q.description||null,sortText:Q.sortText||null,error:Q.error&&F.fromStrict(Q.error)||null}}ye.from=Fe;function he(Q){return{parent:void 0,error:void 0,id:a.$dK.fromString(Q.extId).localId,label:Q.label,uri:$.URI.revive(Q.uri),tags:(Q.tags||[]).map(Me=>{const{tagId:Ue}=Wt.denamespace(Me);return new n.$ZM(Ue)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:h.to(Q.range||void 0),canResolveChildren:!1,busy:Q.busy,description:Q.description||void 0,sortText:Q.sortText||void 0}}ye.toPlain=he})(ti||(e.TestItem=ti={})),function(ye){function Fe(Q){return{id:Q.id}}ye.from=Fe;function he(Q){return new n.$ZM(Q.id)}ye.to=he}(Wt||(e.TestTag=Wt={}));var ht;(function(ye){const Fe=(Q,Me)=>{const Ue=[];for(const[Ke,tt]of Me)a.$dK.compare(tt.item.extId,Ke)===2&&(Me.delete(Ke),Ue.push(tt));const Ye={...ti.toPlain(Q.item),parent:void 0,taskStates:Q.tasks.map(Ke=>({state:Ke.state,duration:Ke.duration,messages:Ke.messages.filter(tt=>tt.type===0).map(Xe.to)})),children:Ue.map(Ke=>Fe(Ke,Me))};for(const Ke of Ye.children)Ke.parent=Ye;return Ye};function he(Q){const Me=[],Ue=new Map;for(const Ye of Q.items){Ue.set(Ye.item.extId,Ye);const Ke=a.$dK.root(Ye.item.extId);Q.request.targets.some(tt=>tt.controllerId===Ke&&tt.testIds.includes(Ye.item.extId))&&Me.push(Ye)}return{completedAt:Q.completedAt,results:Me.map(Ye=>Fe(Ye,Ue))}}ye.to=he})(ht||(e.TestResults=ht={}));var mt;(function(ye){function Fe(Ue){return{covered:Ue.covered,total:Ue.total}}function he(Ue){return"line"in Ue?g.from(Ue):h.from(Ue)}function Q(Ue){return"branches"in Ue?{count:Ue.executed,location:he(Ue.location),type:1,branches:Ue.branches.length?Ue.branches.map(Ye=>({count:Ye.executed,location:Ye.location&&he(Ye.location),label:Ye.label})):void 0}:{type:0,name:Ue.name,count:Ue.executed,location:he(Ue.location)}}ye.fromDetailed=Q;function Me(Ue){return{uri:Ue.uri,statement:Fe(Ue.statementCoverage),branch:Ue.branchCoverage&&Fe(Ue.branchCoverage),declaration:Ue.declarationCoverage&&Fe(Ue.declarationCoverage),details:Ue.detailedCoverage?.map(Q)}}ye.fromFile=Me})(mt||(e.TestCoverage=mt={}));var Kt;(function(ye){function Fe(he){switch(he){case 1:return n.CodeActionTriggerKind.Invoke;case 2:return n.CodeActionTriggerKind.Automatic}}ye.to=Fe})(Kt||(e.CodeActionTriggerKind=Kt={}));var ii;(function(ye){function Fe(Q){const Me=new n.$6M($e.to(Q.kind),Q.name,Q.detail||"",$.URI.revive(Q.uri),h.to(Q.range),h.to(Q.selectionRange));return Me._sessionId=Q._sessionId,Me._itemId=Q._itemId,Me}ye.to=Fe;function he(Q,Me,Ue){if(Me=Me??Q._sessionId,Ue=Ue??Q._itemId,Me===void 0||Ue===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ue,kind:$e.from(Q.kind),name:Q.name,detail:Q.detail??"",uri:Q.uri,range:h.from(Q.range),selectionRange:h.from(Q.selectionRange),tags:Q.tags?.map(te.from)}}ye.from=he})(ii||(e.TypeHierarchyItem=ii={}));var Ct;(function(ye){function Fe(he){if(he)return{value:he.value,tooltip:he.tooltip}}ye.from=Fe})(Ct||(e.ViewBadge=Ct={}));var dt;(function(ye){function Fe(Ue,Ye,Ke){const tt=Ye.fileData;return tt?new n.$dM(new n.$eM(tt.name,$.URI.revive(tt.uri),tt.id,(0,R.$db)(()=>Ke(tt.id)))):Ue===A.$hs.uriList&&Ye.uriListData?new n.$cM(Me(Ye.uriListData)):new n.$cM(Ye.asString)}ye.to=Fe;async function he(Ue,Ye){const Ke=await Ye.asString();if(Ue===A.$hs.uriList)return{asString:Ke,fileData:void 0,uriListData:Q(Ke)};const tt=Ye.asFile();return{asString:Ke,fileData:tt?{name:tt.name,uri:tt.uri,id:tt._itemId??tt.id}:void 0}}ye.from=he;function Q(Ue){return I.$tt.split(Ue).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return $.URI.parse(Ye)}catch{}return Ye})}function Me(Ue){return I.$tt.create(Ue.map(Ye=>typeof Ye=="string"?Ye:$.URI.revive(Ye)))}})(dt||(e.DataTransferItem=dt={}));var Lt;(function(ye){function Fe(Q,Me){const Ue=Q.items.map(([Ye,Ke])=>[Ye,dt.to(Ye,Ke,Me)]);return new n.$fM(Ue)}ye.toDataTransfer=Fe;async function he(Q){const Me={items:[]},Ue=[];for(const[Ye,Ke]of Q)Ue.push((async()=>{Me.items.push([Ye,await dt.from(Ye,Ke)])})());return await Promise.all(Ue),Me}ye.from=he})(Lt||(e.DataTransfer=Lt={}));var ri;(function(ye){function Fe(he){return{kind:"reply",message:he.message,title:he.title,tooltip:he.tooltip}}ye.from=Fe})(ri||(e.ChatReplyFollowup=ri={}));var Rt;(function(ye){function Fe(he){return typeof he=="string"?{title:he,message:he,kind:"reply"}:"commandId"in he?{kind:"command",title:he.title??"",commandId:he.commandId??"",when:he.when??"",args:he.args}:ri.from(he)}ye.from=Fe})(Rt||(e.ChatFollowup=Rt={}));var He;(function(ye){function Fe(Q){const Me=new n.$fN(Ft.to(Q.role),Q.content);return Me.name=Q.name,Me}ye.to=Fe;function he(Q){return{role:Ft.from(Q.role),content:Q.content,name:Q.name}}ye.from=he})(He||(e.ChatMessage=He={}));var Ft;(function(ye){function Fe(Q){switch(Q){case 0:return n.ChatMessageRole.System;case 1:return n.ChatMessageRole.User;case 2:return n.ChatMessageRole.Assistant}}ye.to=Fe;function he(Q){switch(Q){case n.ChatMessageRole.System:return 0;case n.ChatMessageRole.Assistant:return 2;case n.ChatMessageRole.User:default:return 1}}ye.from=he})(Ft||(e.ChatMessageRole=Ft={}));var Vt;(function(ye){function Fe(Me){const Ue={};for(const Ye of Object.keys(Me))Ue[Ye]=Me[Ye].map(ye.to);return Ue}ye.objectTo=Fe;function he(Me){return{level:Xt.to(Me.level),kind:Me.kind,value:(0,$.$vc)(Me.value)?$.URI.revive(Me.value):Me.value,description:Me.description}}ye.to=he;function Q(Me){return{level:Xt.from(Me.level),kind:Me.kind,value:Me.value,description:Me.description}}ye.from=Q})(Vt||(e.ChatVariable=Vt={}));var Xt;(function(ye){function Fe(Q){switch(Q){case"short":return n.ChatVariableLevel.Short;case"medium":return n.ChatVariableLevel.Medium;case"full":default:return n.ChatVariableLevel.Full}}ye.to=Fe;function he(Q){switch(Q){case n.ChatVariableLevel.Short:return"short";case n.ChatVariableLevel.Medium:return"medium";case n.ChatVariableLevel.Full:default:return"full"}}ye.from=he})(Xt||(e.ChatVariableLevel=Xt={}));var ft;(function(ye){function Fe(he){switch(he){case 1:return n.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return n.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return n.InteractiveEditorResponseFeedbackKind.Undone;case 3:return n.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return n.InteractiveEditorResponseFeedbackKind.Bug}}ye.to=Fe})(ft||(e.InteractiveEditorResponseFeedbackKind=ft={}));var Tt;(function(ye){function Fe(Q){return{kind:"markdownContent",content:F.from(new n.$OL().appendText(Q.value))}}ye.to=Fe;function he(Q){return new n.$gN(Q.content.value)}ye.from=he})(Tt||(e.ChatResponseTextPart=Tt={}));var It;(function(ye){function Fe(Q){return{kind:"markdownContent",content:F.from(Q.value)}}ye.to=Fe;function he(Q){return new n.$hN(F.to(Q.content))}ye.from=he})(It||(e.ChatResponseMarkdownPart=It={}));var Nt;(function(ye){function Fe(Q){const{value:Me,baseUri:Ue}=Q;function Ye(Ke,tt){return Ke.map(pt=>{const zt=$.URI.joinPath(tt,pt.name);return{label:pt.name,uri:zt,children:pt.children&&Ye(pt.children,zt)}})}return{kind:"treeData",treeData:{label:(0,w.$Fg)(Ue),uri:Ue,children:Ye(Me,Ue)}}}ye.to=Fe;function he(Q){const Me=(0,y.$Eh)(Q.treeData);function Ue(tt){return tt.map(pt=>({name:pt.label,children:pt.children&&Ue(pt.children)}))}const Ye=Me.uri,Ke=Me.children?Ue(Me.children):[];return new n.$iN(Ke,Ye)}ye.from=he})(Nt||(e.ChatResponseFilesPart=Nt={}));var qt;(function(ye){function Fe(Q){return{kind:"inlineReference",name:Q.title,inlineReference:$.URI.isUri(Q.value)?Q.value:b.from(Q.value)}}ye.to=Fe;function he(Q){const Me=(0,y.$Eh)(Q);return new n.$jN($.URI.isUri(Me.inlineReference)?Me.inlineReference:b.to(Me.inlineReference),Q.name)}ye.from=he})(qt||(e.ChatResponseAnchorPart=qt={}));var Ot;(function(ye){function Fe(Q){return{kind:"progressMessage",content:F.from(Q.value)}}ye.to=Fe;function he(Q){return new n.$kN(Q.content.value)}ye.from=he})(Ot||(e.ChatResponseProgressPart=Ot={}));var Dt;(function(ye){function Fe(Q){return{kind:"reference",reference:$.URI.isUri(Q.value)?Q.value:b.from(Q.value)}}ye.to=Fe;function he(Q){const Me=(0,y.$Eh)(Q);return new n.$lN($.URI.isUri(Me.reference)?Me.reference:b.to(Me.reference))}ye.from=he})(Dt||(e.ChatResponseReferencePart=Dt={}));var Gt;(function(ye){function Fe(Q){return Q instanceof n.$hN?It.to(Q):Q instanceof n.$jN?qt.to(Q):Q instanceof n.$lN?Dt.to(Q):Q instanceof n.$kN?Ot.to(Q):Q instanceof n.$iN?Nt.to(Q):{kind:"content",content:""}}ye.to=Fe;function he(Q){switch(Q.kind){case"markdownContent":return It.from(Q);case"inlineReference":return qt.from(Q);case"reference":return Dt.from(Q);case"progressMessage":return Ot.from(Q);case"treeData":return Nt.from(Q)}return new n.$gN("")}ye.from=he})(Gt||(e.ChatResponsePart=Gt={}));var Et;(function(ye){function Fe(Me,Ue){return"markdownContent"in Ue?((0,f.$LF)(Me,"chatAgents2Additions"),{content:F.from(Ue.markdownContent),kind:"markdownContent"}):"content"in Ue?"vulnerabilities"in Ue&&Ue.vulnerabilities?((0,f.$LF)(Me,"chatAgents2Additions"),{content:Ue.content,vulnerabilities:Ue.vulnerabilities,kind:"vulnerability"}):typeof Ue.content=="string"?{content:Ue.content,kind:"content"}:((0,f.$LF)(Me,"chatAgents2Additions"),{content:F.from(Ue.content),kind:"markdownContent"}):"documents"in Ue?{documents:Ue.documents.map(Ye=>({uri:Ye.uri,version:Ye.version,ranges:Ye.ranges.map(Ke=>h.from(Ke))})),kind:"usedContext"}:"reference"in Ue?{reference:"uri"in Ue.reference?{uri:Ue.reference.uri,range:h.from(Ue.reference.range)}:Ue.reference,kind:"reference"}:"inlineReference"in Ue?{inlineReference:"uri"in Ue.inlineReference?{uri:Ue.inlineReference.uri,range:h.from(Ue.inlineReference.range)}:Ue.inlineReference,name:Ue.title,kind:"inlineReference"}:"agentName"in Ue?((0,f.$LF)(Me,"chatAgents2Additions"),{agentName:Ue.agentName,command:Ue.command,kind:"agentDetection"}):"treeData"in Ue?{treeData:Ue.treeData,kind:"treeData"}:"message"in Ue?{content:F.from(Ue.message),kind:"progressMessage"}:void 0}ye.from=Fe;function he(Me){switch(Me.kind){case"markdownContent":case"inlineReference":case"treeData":return ye.to(Me);case"content":return{content:Me.content};case"usedContext":return{documents:Me.documents.map(Ue=>({uri:$.URI.revive(Ue.uri),version:Ue.version,ranges:Ue.ranges.map(Ye=>h.to(Ye))}))};case"reference":return{reference:(0,$.$vc)(Me.reference)?$.URI.revive(Me.reference):b.to(Me.reference)};case"agentDetection":return;case"progressMessage":return{message:Me.content.value};case"vulnerability":return{content:Me.content,vulnerabilities:Me.vulnerabilities};default:return}}ye.to=he;function Q(Me){switch(Me.kind){case"markdownContent":return{content:Me.content.value};case"inlineReference":return{inlineReference:(0,$.$vc)(Me.inlineReference)?$.URI.revive(Me.inlineReference):b.to(Me.inlineReference),title:Me.name};case"treeData":return{treeData:(0,y.$Eh)(Me.treeData)};default:return}}ye.toProgressContent=Q})(Et||(e.ChatResponseProgress=Et={}));var wt;(function(ye){function Fe(he){return{prompt:he.message,variables:Vt.objectTo(he.variables),subCommand:he.command,agentId:he.agentId}}ye.to=Fe})(wt||(e.ChatAgentRequest=wt={}));var St;(function(ye){function Fe(he){return{label:he.label,values:he.values.map(Vt.from),insertText:he.insertText,detail:he.detail,documentation:he.documentation}}ye.from=Fe})(St||(e.ChatAgentCompletionItem=St={}));var kt;(function(ye){function Fe(he,Q,Me){return"terminalCommand"in he?{terminalCommand:he.terminalCommand,shouldExecute:he.shouldExecute}:"uri"in he?{uri:he.uri}:Q.toInternal(he,Me)}ye.from=Fe})(kt||(e.TerminalQuickFix=kt={}))}),define(Re[245],Ae([1,0,3,17,8]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zgc=void 0;let R=class{constructor(m,d){this.a=m.getProxy(S.$lL.MainThreadBulkEdits),this.b={getTextDocumentVersion:y=>d.getDocument(y)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,d,y){const A=I.WorkspaceEdit.from(m,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,y?.isRefactoring??!1)}};e.$zgc=R,e.$zgc=R=Ge([qe(0,M.$wN)],R)}),define(Re[246],Ae([1,0,18,11,41,5,46,63,2,157,13,3,8,7,205,25]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cgc=void 0;let c=class{constructor(a,u,t,f){this.i=a,this.j=u,this.k=t,this.l=f,this.a=m.$Sd.create(!1),this.b=!1}close(){this.b=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.a.elapsed()}}get apiObject(){if(!this.g){let u=function(f){if(a.b){const n=new Error("Response stream has been closed");throw Error.captureStackTrace(n,f),n}};const a=this;this.a.reset();const t=f=>{typeof this.d>"u"&&"content"in f&&(this.d=this.a.elapsed()),this.k.$handleProgressChunk(this.j.requestId,f)};this.g={text(f){return u(this.text),this.markdown(new L.$jk().appendText(f)),this},markdown(f){u(this.markdown);const n=new $.$hN(f),w=l.ChatResponseMarkdownPart.to(n);return t(w),this},filetree(f,n){u(this.filetree);const w=new $.$iN(f,n),D=l.ChatResponseFilesPart.to(w);return t(D),this},anchor(f,n){u(this.anchor);const w=new $.$jN(f,n),D=l.ChatResponseAnchorPart.to(w);return t(D),this},progress(f){u(this.progress);const n=new $.$kN(f),w=l.ChatResponseProgressPart.to(n);return t(w),this},reference(f){u(this.reference);const n=new $.$lN(f),w=l.ChatResponseReferencePart.to(n);return t(w),this},push(f){u(this.push);const n=l.ChatResponsePart.to(f);return t(n),this},report(f){if(u(this.report),"placeholder"in f&&"resolvedContent"in f)return;const n=l.ChatResponseProgress.from(a.i,f);if(!n){a.l.error("Unknown progress type: "+JSON.stringify(f));return}return t(n),this}}}return this.g}};c=Ge([qe(3,A.$pj)],c);class s{static{this.a=0}constructor(a,u,t){this.j=u,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=a.getProxy(k.$lL.MainThreadChatAgents2)}createChatAgent(a,u,t){const f=s.a++,n=new i(a,u,this.d,f,t);return this.b.set(f,n),this.d.$registerAgent(f,u,{}),n.apiAgent}async $invokeAgent(a,u,t,f){this.g.delete(u.sessionId);const n=this.b.get(a);if(!n)throw new Error(`[CHAT](${a}) CANNOT invoke agent because the agent is not registered`);this.j.$updateAccesslist([{extension:n.extension.identifier,enabled:!0}]);const w=new c(n.extension,u,this.d,this.k);try{const D=await this.l(n,u,t),h=n.invoke(l.ChatAgentRequest.to(u),{history:D},w.apiObject,f);return await(0,M.$Vg)(Promise.resolve(h).then(b=>{if(b){this.g.set(u.sessionId,b);let P=this.i.get(u.sessionId);return P||(P=new Map,this.i.set(u.sessionId,P)),P.set(u.requestId,b),{errorDetails:b.errorDetails,timings:w.timings}}else this.g.delete(u.sessionId)}),f)}catch(D){return this.k.error(D,n.extension),{errorDetails:{message:(0,y.localize)(0,null,(0,I.$Si)(D)),responseIsIncomplete:!0}}}finally{w.close(),this.j.$updateAccesslist([{extension:n.extension.identifier,enabled:!1}])}}async l(a,u,t){return(0,S.$Hb)(await Promise.all(t.history.map(async f=>{const n=u.agentId===f.request.agentId&&this.i.get(u.sessionId)?.get(f.request.requestId)||f.result;return{request:l.ChatAgentRequest.to(f.request),response:(0,S.$Hb)(f.response.map(w=>l.ChatResponsePart.from(w))),result:n}})))}$releaseSession(a){this.g.delete(a),this.i.delete(a)}async $provideSlashCommands(a,u){const t=this.b.get(a);return t?t.provideSlashCommands(u):[]}$provideFollowups(a,u,t){const f=this.b.get(a);if(!f)return Promise.resolve([]);const n=this.g.get(u);return n?f.provideFollowups(n,t):Promise.resolve([])}$acceptFeedback(a,u,t,f,n){const w=this.b.get(a);if(!w)return;const D=this.i.get(u)?.get(t);if(!D)return;let h;switch(f){case p.InteractiveSessionVoteDirection.Down:h=$.ChatAgentResultFeedbackKind.Unhelpful;break;case p.InteractiveSessionVoteDirection.Up:h=$.ChatAgentResultFeedbackKind.Helpful;break}w.acceptFeedback(Object.freeze(n?{result:D,kind:h,reportIssue:n}:{result:D,kind:h}))}$acceptAction(a,u,t,f){const n=this.b.get(a);if(!n)return;const w=this.i.get(u)?.get(t);w&&f.action.kind!=="vote"&&n.acceptAction(Object.freeze({action:f.action,result:w}))}async $invokeCompletionProvider(a,u,t){const f=this.b.get(a);return f?(await f.invokeCompletionProvider(u,t)).map(l.ChatAgentCompletionItem.from):[]}async $provideWelcomeMessage(a,u){const t=this.b.get(a);if(t)return await t.provideWelcomeMessage(u)}async $provideSampleQuestions(a,u){const t=this.b.get(a);if(t)return await t.provideSampleQuestions(u)}}e.$Cgc=s;class i{constructor(a,u,t,f,n){this.extension=a,this.id=u,this.u=t,this.w=f,this.x=n,this.o=new R.$Wd,this.p=new R.$Wd}acceptFeedback(a){this.o.fire(a)}acceptAction(a){this.p.fire(a)}async invokeCompletionProvider(a,u){return this.s?await this.s.provider.provideCompletionItems(a,u)??[]:[]}async provideSlashCommands(a){if(!this.a)return[];const u=await this.a.provideSubCommands(a);return u?u.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest})):[]}async provideFollowups(a,u){if(!this.b)return[];const t=await this.b.provideFollowups(a,u);return t?t.map(f=>l.ChatFollowup.from(f)):[]}async provideWelcomeMessage(a){if(!this.t)return[];const u=await this.t.provideWelcomeMessage(a);return u?u.map(t=>typeof t=="string"?t:l.MarkdownString.from(t)):[]}async provideSampleQuestions(a){if(!this.t||!this.t.provideSampleQuestions)return[];const u=await this.t.provideSampleQuestions(a);return u?u?.map(t=>l.ChatReplyFollowup.from(t)):[]}get apiAgent(){let a=!1,u=!1;const t=()=>{a||u||(u=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{description:this.d??"",fullName:this.g,icon:this.i?this.i instanceof d.URI?this.i:"light"in this.i?this.i.light:void 0:void 0,iconDark:this.i&&"dark"in this.i?this.i.dark:void 0,themeIcon:this.i instanceof $.$iM?this.i:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.b!==void 0,isDefault:this.j,isSecondary:this.n,helpTextPrefix:!this.k||typeof this.k=="string"?this.k:l.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:l.MarkdownString.from(this.l),sampleRequest:this.m,supportIssueReporting:this.q}),u=!1}))},f=this;return{get name(){return f.id},get description(){return f.d??""},set description(n){f.d=n,t()},get fullName(){return f.g??f.extension.displayName??f.extension.name},set fullName(n){f.g=n,t()},get iconPath(){return f.i},set iconPath(n){f.i=n,t()},get subCommandProvider(){return f.a},set subCommandProvider(n){f.a=n,t()},get followupProvider(){return f.b},set followupProvider(n){f.b=n,t()},get isDefault(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.j},set isDefault(n){(0,r.$LF)(f.extension,"defaultChatAgent"),f.j=n,t()},get helpTextPrefix(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.k},set helpTextPrefix(n){if((0,r.$LF)(f.extension,"defaultChatAgent"),!f.j)throw new Error("helpTextPrefix is only available on the default chat agent");f.k=n,t()},get helpTextPostfix(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.l},set helpTextPostfix(n){if((0,r.$LF)(f.extension,"defaultChatAgent"),!f.j)throw new Error("helpTextPostfix is only available on the default chat agent");f.l=n,t()},get isSecondary(){return(0,r.$LF)(f.extension,"defaultChatAgent"),f.n},set isSecondary(n){(0,r.$LF)(f.extension,"defaultChatAgent"),f.n=n,t()},get sampleRequest(){return f.m},set sampleRequest(n){f.m=n,t()},get supportIssueReporting(){return(0,r.$LF)(f.extension,"chatAgents2Additions"),f.q},set supportIssueReporting(n){(0,r.$LF)(f.extension,"chatAgents2Additions"),f.q=n,t()},get onDidReceiveFeedback(){return f.o.event},set agentVariableProvider(n){if(f.s=n,n){if(!n.triggerCharacters.length)throw new Error("triggerCharacters are required");f.u.$registerAgentCompletionsProvider(f.w,n.triggerCharacters)}else f.u.$unregisterAgentCompletionsProvider(f.w)},get agentVariableProvider(){return f.s},set welcomeMessageProvider(n){f.t=n,t()},get welcomeMessageProvider(){return f.t},onDidPerformAction:(0,r.$KF)(this.extension,"chatAgents2Additions")?this.p.event:void 0,dispose(){a=!0,f.a=void 0,f.b=void 0,f.o.dispose(),f.u.$unregisterAgent(f.w)}}}invoke(a,u,t,f){return this.x(a,u,t,f)}}}),define(Re[247],Ae([1,0,21,6,3,8,99,22,11,5]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bgc=void 0;class A{constructor(p,r){this.option=p,this.stream=new d.$yh,this.stream=r??new d.$yh}}class k{constructor(p,r){this.cts=r,this.a=new Map,this.b=new d.$yh,this.c=!1;const c=this;this.apiObject={result:p,stream:c.b.asyncIterable},p.finally(()=>{if(this.c=!0,this.a.size>0)for(const[,s]of this.a)s.stream.resolve();else this.b.resolve()})}handleFragment(p){if(this.c)return;let r=this.a.get(p.index);r||(this.a.size===0?r=new A(p.index,this.b):r=new A(p.index),this.a.set(p.index,r)),r.stream.emitOne(p.part)}}class l{static{this.a=1}constructor(p,r){this.j=r,this.c=new y.$Wd,this.d=new y.$Wd,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Set,this.h=new m.$pm,this.i=new Map,this.b=p.getProxy(I.$lL.MainThreadChatProvider)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(p,r,c,s){const i=l.a++;return this.f.set(i,{extension:p,provider:c}),this.b.$registerProvider(i,r,{extension:p,model:s.name??""}),(0,M.$Rc)(()=>{this.f.delete(i),this.b.$unregisterProvider(i)})}async $provideLanguageModelResponse(p,r,c,s,i,o){const a=this.f.get(p);if(!a)return;const u=new L.$xv(async t=>{if(o.isCancellationRequested){this.j.warn(`[CHAT](${a.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(r,{index:t.index,part:t.part})});return a.provider.provideLanguageModelResponse?a.provider.provideLanguageModelResponse(s.map(R.ChatMessage.to),i,m.$nm.toKey(c),u,o):a.provider.provideChatResponse(s.map(R.ChatMessage.to),i,u,o)}$updateLanguageModels(p){const r=[],c=[];if(p.added)for(const s of p.added)this.g.add(s),r.push(s);if(p.removed)for(const s of p.removed){this.g.delete(s),c.push(s);for(const[i,o]of this.i)o.languageModelId===s&&(o.res.cts.cancel(),this.i.delete(i))}this.d.fire(Object.freeze({added:Object.freeze(r),removed:Object.freeze(c)}))}getLanguageModelIds(){return Array.from(this.g)}$updateAccesslist(p){const r=new m.$om;for(const{extension:c,enabled:s}of p)this.h.get(c)!==s&&(this.h.set(c,s),r.add(c));this.c.fire(r)}async requestLanguageModelAccess(p,r,c){if(this.h.get(p)===!1)throw new Error("Extension is NOT allowed to make chat requests");const s=await this.b.$prepareChatAccess(p,r,c?.justification);if(!s)throw this.h.get(p)?new Error(`Language model '${r}' NOT found`):new Error("Extension is NOT allowed to make chat requests");const i=this;return{get model(){return s.model},get isRevoked(){return!i.h.get(p)||!i.g.has(r)},get onDidChangeAccess(){const o=y.Event.filter(i.c.event,u=>u.has(p)),a=y.Event.filter(i.d.event,u=>u.removed.includes(r));return y.Event.signal(y.Event.any(o,a))},makeRequest(o,a,u){if(!i.h.get(p))throw new Error("Access to chat has been revoked");if(!i.g.has(r))throw new Error("Language Model has been removed");const t=new S.$7d(u),f=Math.random()*1e6|0,n=i.b.$fetchResponse(p,r,f,o.map(R.ChatMessage.from),a??{},t.token),w=new k(n,t);return i.i.set(f,{languageModelId:r,res:w}),n.finally(()=>{i.i.delete(f),t.dispose()}),w.apiObject}}}async $handleResponseFragment(p,r){const c=this.i.get(p);c&&c.res.handleFragment(r)}}e.$Bgc=l}),define(Re[248],Ae([1,0,6,3,15,8]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dgc=void 0;class L{static{this.a=0}constructor(d){this.b=new Map,this.c=d.getProxy(M.$lL.MainThreadChatVariables)}async $resolveVariable(d,y,A){const k=this.b.get(d);if(k)try{const l=await k.resolver.resolve(k.data.name,{prompt:y},A);if(l)return l.map(R.ChatVariable.from)}catch(l){(0,I.$2)(l)}}registerVariableResolver(d,y,A,k){const l=L.a++;return this.b.set(l,{extension:d.identifier,data:{name:y,description:A},resolver:k}),this.c.$registerVariable(l,{name:y,description:A}),(0,S.$Rc)(()=>{this.b.delete(l),this.c.$unregisterVariable(l)})}}e.$Dgc=L}),define(Re[249],Ae([1,0,11,67,5,6,2,86,22,8,7,3,25]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hgc=void 0;function $(p,r,c){const s=p.getProxy(k.$lL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new d.$pm,r.registerArgumentProcessor({processArgument:h=>{if(h&&h.$mid===6){const b=this.b.get(h.handle);return b?b.value:h}else if(h&&h.$mid===7){const b=this.b.get(h.commentControlHandle);if(!b)return h;const P=b.getCommentThread(h.commentThreadHandle);return P?P.value:h}else if(h&&(h.$mid===9||h.$mid===8)){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const P=b.getCommentThread(h.thread.commentThreadHandle);return P?h.$mid===8?P.value:{thread:P.value,text:h.text}:h}else if(h&&h.$mid===10){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const P=b.getCommentThread(h.thread.commentThreadHandle);if(!P)return h;const g=h.commentUniqueId,v=P.getCommentByUniqueId(g);return v||h}else if(h&&h.$mid===11){const b=this.b.get(h.thread.commentControlHandle);if(!b)return h;const P=b.getCommentThread(h.thread.commentThreadHandle);if(!P)return h;const g=h.text,v=h.commentUniqueId,E=P.getCommentByUniqueId(v);return E?(typeof E.body=="string"?E.body=g:E.body=new A.$OL(g),E):h}return h}})}createCommentController(h,b,P){const g=i.a++,v=new a(h,g,b,P);this.b.set(v.handle,v);const E=this.c.get(h.identifier)||[];return E.push(v),this.c.set(h.identifier,E),v.value}async $createCommentThreadTemplate(h,b,P){const g=this.b.get(h);g&&g.$createCommentThreadTemplate(b,P)}async $setActiveComment(h,b){const P=this.b.get(h);P&&P.$setActiveComment(b??void 0)}async $updateCommentThreadTemplate(h,b,P){const g=this.b.get(h);g&&g.$updateCommentThreadTemplate(b,P)}$deleteCommentThread(h,b){this.b.get(h)?.$deleteCommentThread(b)}$provideCommentingRanges(h,b,P){const g=this.b.get(h);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const v=c.getDocument(L.URI.revive(b));return(0,S.$Zg)(async()=>{const E=await g.commentingRangeProvider.provideCommentingRanges(v,P);let T;return Array.isArray(E)?T={ranges:E,fileComments:!1}:E?T={ranges:E.ranges||[],fileComments:E.fileComments||!1}:T=E??void 0,T}).then(E=>{let T;return E&&(T={ranges:E.ranges.map(N=>y.Range.from(N)),fileComments:E.fileComments}),T})}$toggleReaction(h,b,P,g,v){const E=this.b.get(h);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,S.$Zg)(()=>{const T=E.getCommentThread(b);if(T){const N=T.getCommentByUniqueId(g.uniqueIdInThread);if(E!==void 0&&N&&E.reactionHandler)return E.reactionHandler(N,f(v))}return Promise.resolve(void 0)})}}class o{static{this.a=0}set threadId(h){this.n=h}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(h){(h===void 0!=(this.p===void 0)||!h||!this.p||!h.isEqual(this.p))&&(this.p=h,this.b.range=h,this.c.fire())}get range(){return this.p}set canReply(h){this.d!==h&&(this.d=h,this.b.canReply=h,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(h){this.e=h,this.b.label=h,this.c.fire()}get contextValue(){return this.f}set contextValue(h){this.f=h,this.b.contextValue=h,this.c.fire()}get comments(){return this.q}set comments(h){this.q=h,this.b.comments=h,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(h){this.g=h,this.b.collapsibleState=h,this.c.fire()}get state(){return this.h}set state(h){this.h=h,this.b.state=h,this.c.fire()}get isDisposed(){return this.j}constructor(h,b,P,g,v,E,T,N){this.m=b,this.n=P,this.o=g,this.p=v,this.q=E,this.extensionDescription=T,this.r=N,this.handle=o.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.$Wd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.$Uc,this.l.value=new R.$Sc,this.n===void 0&&(this.n=`${h}.${this.handle}`),s.$createCommentThread(b,this.handle,this.n,this.o,y.Range.from(this.p),T.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{s.$deleteCommentThread(b,this.handle)}});const J=this;this.value={get uri(){return J.uri},get range(){return J.range},set range(q){J.range=q},get comments(){return J.comments},set comments(q){J.comments=q},get collapsibleState(){return J.collapsibleState},set collapsibleState(q){J.collapsibleState=q},get canReply(){return J.canReply},set canReply(q){J.canReply=q},get contextValue(){return J.contextValue},set contextValue(q){J.contextValue=q},get label(){return J.label},set label(q){J.label=q},get state(){return J.state},set state(q){J.state=q},dispose:()=>{J.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.$Sc);const h=P=>Object.prototype.hasOwnProperty.call(this.b,P),b={};h("range")&&(b.range=y.Range.from(this.p)),h("label")&&(b.label=this.label),h("contextValue")&&(b.contextValue=this.contextValue??null),h("comments")&&(b.comments=this.q.map(P=>u(this,P,this.k,this.extensionDescription))),h("collapsibleState")&&(b.collapseState=n(this.g)),h("canReply")&&(b.canReply=this.canReply),h("state")&&(b.state=w(this.h)),h("isTemplate")&&(b.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,b)}getCommentByUniqueId(h){for(const b of this.k){const P=b[0],g=b[1];if(h===g)return P}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(h=>h.dispose())}}Ge([(0,M.$Ah)(100)],o.prototype,"eventuallyUpdateCommentThread",null);class a{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(h){this.b=h,s.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(h){this.c=h,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!h})}get options(){return this.d}set options(h){this.d=h,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$LF)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$LF)(this.h,"activeComment"),this.f}constructor(h,b,P,g){this.h=h,this.i=b,this.j=P,this.k=g,this.a=new Map,s.$registerCommentController(this.handle,P,g,this.h.identifier.value);const v=this;this.value=Object.freeze({id:v.id,label:v.label,get options(){return v.options},set options(E){v.options=E},get commentingRangeProvider(){return v.commentingRangeProvider},set commentingRangeProvider(E){v.commentingRangeProvider=E},get reactionHandler(){return v.reactionHandler},set reactionHandler(E){v.reactionHandler=E},get activeCommentThread(){return v.activeCommentThread},createCommentThread(E,T,N){return v.createCommentThread(E,T,N).value},dispose:()=>{v.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(h,b,P){b===void 0&&(0,l.$LF)(this.h,"fileComments");const g=new o(this.id,this.handle,void 0,h,b,P,this.h,!1);return this.a.set(g.handle,g),g}$setActiveComment(h){if(!h){this.e=void 0,this.f=void 0;return}const b=this.a.get(h.commentThreadHandle);b&&(this.e=h.uniqueIdInThread?b.getCommentByUniqueId(h.uniqueIdInThread):void 0,this.f=b)}$createCommentThreadTemplate(h,b){const P=new o(this.id,this.handle,void 0,L.URI.revive(h),y.Range.to(b),[],this.h,!0);return P.collapsibleState=m.CommentThreadCollapsibleState.Expanded,this.a.set(P.handle,P),P}$updateCommentThreadTemplate(h,b){const P=this.a.get(h);P&&(P.range=y.Range.to(b))}$deleteCommentThread(h){this.a.get(h)?.dispose(),this.a.delete(h)}getCommentThread(h){return this.a.get(h)}dispose(){this.a.forEach(h=>{h.dispose()}),this.g.forEach(h=>h.dispose())}}function u(D,h,b,P){let g=b.get(h);return g||(g=++D.commentHandle,b.set(h,g)),h.state!==void 0&&(0,l.$LF)(P,"commentsDraftState"),h.reactions?.some(v=>v.reactors!==void 0)&&(0,l.$LF)(P,"commentReactor"),{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:g,body:typeof h.body=="string"?h.body:y.MarkdownString.from(h.body),userName:h.author.name,userIconPath:h.author.iconPath,label:h.label,commentReactions:h.reactions?h.reactions.map(v=>t(v)):void 0,state:h.state,timestamp:h.timestamp?.toJSON()}}function t(D){return{label:D.label,iconPath:D.iconPath?y.$vN(D.iconPath):void 0,count:D.count,hasReacted:D.authorHasReacted,reactors:D.reactors&&D.reactors.length>0&&typeof D.reactors[0]!="string"?D.reactors.map(h=>h.name):D.reactors}}function f(D){return{label:D.label||"",count:D.count||0,iconPath:D.iconPath?L.URI.revive(D.iconPath):"",authorHasReacted:D.hasReacted||!1,reactors:D.reactors?.map(h=>({name:h}))}}function n(D){if(D!==void 0)switch(D){case A.CommentThreadCollapsibleState.Expanded:return m.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return m.CommentThreadCollapsibleState.Collapsed}return m.CommentThreadCollapsibleState.Collapsed}function w(D){if(D!==void 0)switch(D){case A.CommentThreadState.Unresolved:return m.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return m.CommentThreadState.Resolved}return m.CommentThreadState.Unresolved}return new i}e.$Hgc=$}),define(Re[250],Ae([1,0,21,97,6,12,24,2,8,61,74,3,7]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;class ${constructor(f,n){this.document=f,this.b=n,this.a=1,this.c=new A.$mgc("custom documents")}addEdit(f){return this.c.add([f])}async undo(f,n){await this.f(f).undo(),n||this.disposeBackup()}async redo(f,n){await this.f(f).redo(),n||this.disposeBackup()}disposeEdits(f){for(const n of f)this.c.delete(n)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const f=u(this.document.uri)+this.a++;return(0,L.$Ig)(this.b,f)}updateBackup(f){this.d?.delete(),this.d=f}disposeBackup(){this.d?.delete(),this.d=void 0}f(f){const n=this.c.get(f,0);if(!n)throw new Error("No edit found");return n}}class p{constructor(){this.a=new Map}get(f,n){return this.a.get(this.b(f,n))}add(f,n,w){const D=this.b(f,n.uri);if(this.a.has(D))throw new Error(`Document already exists for viewType:${f} resource:${n.uri}`);const h=new $(n,w);return this.a.set(D,h),h}delete(f,n){const w=this.b(f,n.uri);this.a.delete(w)}b(f,n){return`${f}@@@${n}`}}var r;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(r||(r={}));class c{constructor(){this.a=new Map}addTextProvider(f,n,w){return this.b(0,f,n,w)}addCustomProvider(f,n,w){return this.b(1,f,n,w)}get(f){return this.a.get(f)}b(f,n,w,D){if(this.a.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this.a.set(n,{type:f,extension:w,provider:D}),new l.$nL(()=>this.a.delete(n))}}class s{constructor(f,n,w,D,h){this.d=n,this.f=w,this.g=D,this.h=h,this.b=new c,this.c=new p,this.a=f.getProxy(k.$lL.MainThreadCustomEditors)}registerCustomEditorProvider(f,n,w,D){const h=new I.$Sc;return o(w)?(h.add(this.b.addTextProvider(n,f,w)),this.a.$registerTextEditorProvider((0,y.$Wgc)(f),n,D.webviewOptions||{},{supportsMove:!!w.moveCustomTextEditor},(0,y.$Ugc)(f))):(h.add(this.b.addCustomProvider(n,f,w)),i(w)&&h.add(w.onDidChangeCustomDocument(b=>{const P=this.i(n,b.document.uri);if(a(b)){const g=P.addEdit(b);this.a.$onDidEdit(b.document.uri,n,g,b.label)}else this.a.$onContentChange(b.document.uri,n)})),this.a.$registerCustomEditorProvider((0,y.$Wgc)(f),n,D.webviewOptions||{},!!D.supportsMultipleEditorsPerDocument,(0,y.$Ugc)(f))),l.$nL.from(h,new l.$nL(()=>{this.a.$unregisterEditorProvider(n)}))}async $createCustomDocument(f,n,w,D,h){const b=this.b.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=m.URI.revive(f),g=await b.provider.openCustomDocument(P,{backupId:w,untitledDocumentData:D?.buffer},h);let v;return i(b.provider)&&this.f&&(v=this.f.workspaceValue(b.extension)??this.f.globalValue(b.extension)),this.c.add(n,g,v),{editable:i(b.provider)}}async $disposeCustomDocument(f,n){const w=this.b.get(n);if(!w)throw new Error(`No provider found for '${n}'`);if(w.type!==1)throw new Error(`Invalid provider type for '${n}'`);const D=m.URI.revive(f),{document:h}=this.i(n,D);this.c.delete(n,h),h.dispose()}async $resolveCustomEditor(f,n,w,D,h,b){const P=this.b.get(w);if(!P)throw new Error(`No provider found for '${w}'`);const g=d.ViewColumn.to(h),v=this.g.createNewWebview(n,D.contentOptions,P.extension),E=this.h.createNewWebviewPanel(n,w,D.title,g,D.options,v,D.active),T=m.URI.revive(f);switch(P.type){case 1:{const{document:N}=this.i(w,T);return P.provider.resolveCustomEditor(N,E,b)}case 0:{const N=this.d.getDocument(T);return P.provider.resolveCustomTextEditor(N,E,b)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(f,n,w){this.i(n,f).disposeEdits(w)}async $onMoveCustomEditor(f,n,w){const D=this.b.get(w);if(!D)throw new Error(`No provider found for '${w}'`);if(!D.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${w}'`);const h=this.h.getWebviewPanel(f);if(!h)throw new Error("No webview found");const b=m.URI.revive(n),P=this.d.getDocument(b);await D.provider.moveCustomTextEditor(P,h,S.CancellationToken.None)}async $undo(f,n,w,D){return this.i(n,f).undo(w,D)}async $redo(f,n,w,D){return this.i(n,f).redo(w,D)}async $revert(f,n,w){const D=this.i(n,f);await this.j(n).revertCustomDocument(D.document,w),D.disposeBackup()}async $onSave(f,n,w){const D=this.i(n,f);await this.j(n).saveCustomDocument(D.document,w),D.disposeBackup()}async $onSaveAs(f,n,w,D){const h=this.i(n,f);return this.j(n).saveCustomDocumentAs(h.document,m.URI.revive(w),D)}async $backup(f,n,w){const D=this.i(n,f),b=await this.j(n).backupCustomDocument(D.document,{destination:D.getNewBackupUri()},w);return D.updateBackup(b),b.id}i(f,n){const w=this.c.get(f,m.URI.revive(n));if(!w)throw new Error("No custom document found");return w}j(f){const w=this.b.get(f)?.provider;if(!w||!i(w))throw new Error("Custom document is not editable");return w}}e.$Zgc=s;function i(t){return!!t.onDidChangeCustomDocument}function o(t){return typeof t.resolveCustomTextEditor=="function"}function a(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function u(t){const f=t.scheme===R.Schemas.file||t.scheme===R.Schemas.untitled?t.fsPath:t.toString();return(0,M.$Vi)(f)+""}}),define(Re[251],Ae([1,0,158,98,2,3,7,8,5,13,28,43]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$sgc=e.$rgc=void 0;class ${#e;#t;#i;constructor(c,s,i,o,a,u,t,f){this.d=c,this.e=s,this.f=i,this.g=o,this.h=a,this.c=!1,this.f=Math.max(o,i),this.#i=new A.$Ac(n=>u.getComparisonKey(n)),this.#e=t,this.#t=f}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(c,s){if(!c){this.clear();return}this.j();let i=[];if(I.URI.isUri(c)){if(!s){this.delete(c);return}this.#i.set(c,s.slice()),i=[c]}else if(Array.isArray(c)){i=[];let u;c=[...c].sort($.k);for(const t of c){const[f,n]=t;if((!u||f.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=f,i.push(f),this.#i.set(f,[])),n)this.#i.get(f)?.push(...n);else{const w=this.#i.get(f);w&&(w.length=0)}}}if(this.#t.fire(i),!this.#e)return;const o=[];let a=0;for(const u of i){let t=[];const f=this.#i.get(u);if(f)if(f.length>this.g){t=[];const n=[L.DiagnosticSeverity.Error,L.DiagnosticSeverity.Warning,L.DiagnosticSeverity.Information,L.DiagnosticSeverity.Hint];e:for(let w=0;w<4;w++)for(const D of f)if(D.severity===n[w]&&t.push({...m.Diagnostic.from(D),modelVersionId:this.h(u)})===this.g)break e;t.push({severity:M.MarkerSeverity.Info,message:(0,S.localize)(0,null,f.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=f.map(n=>({...m.Diagnostic.from(n),modelVersionId:this.h(u)}));if(o.push([u,t]),a+=t.length,a>this.f)break}this.#e.$changeMany(this.e,o)}delete(c){this.j(),this.#t.fire([c]),this.#i.delete(c),this.#e?.$changeMany(this.e,[[c,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(c,s){this.j();for(const[i,o]of this)c.call(s,i,o,this)}*[Symbol.iterator](){this.j();for(const c of this.#i.keys())yield[c,this.get(c)]}get(c){this.j();const s=this.#i.get(c);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(c){return this.j(),Array.isArray(this.#i.get(c))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(c,s){return c[0].toString()<s[0].toString()?-1:c[0].toString()>s[0].toString()?1:0}}e.$rgc=$;let p=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(c){const s=new A.$Ac;for(const i of c)s.set(i,i);return{uris:Object.freeze(Array.from(s.values()))}}constructor(c,s,i,o){this.j=s,this.k=i,this.l=o,this.g=new Map,this.h=new d.$1d({merge:a=>a.flat(),delay:50}),this.onDidChangeDiagnostics=d.Event.map(this.h.event,l._mapper),this.f=c.getProxy(R.$lL.MainThreadDiagnostics)}createDiagnosticCollection(c,s){const{g:i,f:o,h:a,j:u,k:t,l:f}=this,n=new class{$changeMany(h,b){o.$changeMany(h,b),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,h,b.length===0?"CLEARING":b)}$clear(h){o.$clear(h),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,h)}dispose(){o.dispose()}};let w;if(!s)s="_generated_diagnostic_collection_name_#"+l.c++,w=s;else if(!i.has(s))w=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do w=s+l.c++;while(i.has(w))}return new class extends ${constructor(){super(s,w,l.e,l.d,h=>f.getDocument(h)?.version,t.extUri,n,a),i.set(w,this)}dispose(){super.dispose(),i.delete(w)}}}getDiagnostics(c){if(c)return this.m(c);{const s=new Map,i=[];for(const o of this.g.values())o.forEach((a,u)=>{let t=s.get(a.toString());typeof t>"u"&&(t=i.length,s.set(a.toString(),t),i.push([a,[]])),i[t][1]=i[t][1].concat(...u)});return i}}m(c){let s=[];for(const i of this.g.values())i.has(c)&&(s=s.concat(i.get(c)));return s}$acceptMarkersChange(c){if(!this.n){const s="_generated_mirror",i=new $(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,o=>{},this.k.extUri,void 0,this.h);this.g.set(s,i),this.n=i}for(const[s,i]of c)this.n.set(I.URI.revive(s),i.map(m.Diagnostic.to))}};e.$sgc=p,e.$sgc=p=l=Ge([qe(1,y.$pj),qe(2,k.$qgc)],p)}),define(Re[252],Ae([1,0,2,15,7,8,185]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bhc=void 0;class m{constructor(y,A,k,l={timeout:1500,errors:3}){this.c=y,this.d=A,this.f=k,this.g=l,this.a=new L.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(y){return(A,k,l)=>{const p={dispose:this.a.push([A,k,y])};return Array.isArray(l)&&l.push(p),p}}async $participateInSave(y,A){const k=S.URI.revive(y);let l=!1;const $=setTimeout(()=>l=!0,this.g.timeout),p=[];try{for(const r of[...this.a]){if(l)break;const c=this.d.getDocument(k),s=await this.h(r,{document:c,reason:R.TextDocumentSaveReason.to(A)});p.push(s)}}finally{clearTimeout($)}return p}h([y,A,k],l){const $=this.b.get(y);return typeof $=="number"&&$>this.g.errors?Promise.resolve(!1):this.i(k,y,A,l).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const r=this.b.get(y);this.b.set(y,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(y,A,k,l){const $=[],p=Date.now(),{document:r,reason:c}=l,{version:s}=r,i=Object.freeze({document:r,reason:c,waitUntil(o){if(Object.isFrozen($))throw(0,M.$8)("waitUntil can not be called async");$.push(Promise.resolve(o))}});try{A.apply(k,[i])}catch(o){return Promise.reject(o)}return Object.freeze($),new Promise((o,a)=>{const u=setTimeout(()=>a(new Error("timeout")),this.g.timeout);return Promise.all($).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(u),o(t)}).catch(t=>{clearTimeout(u),a(t)})}).then(o=>{const a={edits:[]};for(const u of o)if(Array.isArray(u)&&u.every(t=>t instanceof I.$uL))for(const{newText:t,newEol:f,range:n}of u)a.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:n&&R.Range.from(n),text:t,eol:f&&R.EndOfLine.from(f)}});if(a.edits.length!==0)return s===r.version?this.f.$tryApplyWorkspaceEdit(a):Promise.reject(new Error("concurrent_edits"))})}}e.$Bhc=m}),define(Re[253],Ae([1,0,5,6,2,3,108,8,16,26,7]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ogc=void 0;class k{constructor($,p){this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new M.$Sc,this.h=new Map,this.f=$.getProxy(R.$lL.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(r=>{for(const c of r)this.b.fire(c.document)},void 0,this.e),this.g.onDidAddDocuments(r=>{for(const c of r)this.a.fire(c.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData($){if(!$)return;const p=this.g.getDocument($);if(p)return p}getDocument($){const p=this.getDocumentData($);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${$}'`);return p.document}ensureDocumentData($){const p=this.g.getDocument($);if(p)return Promise.resolve(p);let r=this.h.get($.toString());return r||(r=this.f.$tryOpenDocument($).then(c=>{this.h.delete($.toString());const s=I.URI.revive(c);return(0,d.$Uf)(this.g.getDocument(s))},c=>(this.h.delete($.toString()),Promise.reject(c))),this.h.set($.toString(),r)),r}createDocumentData($){return this.f.$tryCreateDocument($).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged($,p){const r=I.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");this.b.fire(c.document),c._acceptLanguageId(p),this.a.fire(c.document)}$acceptModelSaved($){const p=I.URI.revive($),r=this.g.getDocument(p);if(!r)throw new Error("unknown document");this.$acceptDirtyStateChanged($,!1),this.d.fire(r.document)}$acceptDirtyStateChanged($,p){const r=I.URI.revive($),c=this.g.getDocument(r);if(!c)throw new Error("unknown document");c._acceptIsDirty(p),this.c.fire({document:c.document,contentChanges:[],reason:void 0})}$acceptModelChanged($,p,r){const c=I.URI.revive($),s=this.g.getDocument(c);if(!s)throw new Error("unknown document");s._acceptIsDirty(r),s.onEvents(p);let i;p.isUndoing?i=A.TextDocumentChangeReason.Undo:p.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,y.$zn)({document:s.document,contentChanges:p.changes.map(o=>({range:m.Range.to(o.range),rangeOffset:o.rangeOffset,rangeLength:o.rangeLength,text:o.text})),reason:i}))}setWordDefinitionFor($,p){(0,L.$yN)($,p)}}e.$ogc=k}),define(Re[64],Ae([1,0,254,5,16,2,4,3,17,8,7]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,L.$8h)("IExtHostEditorTabs");class k{constructor(c,s,i){this.e=i,this.d=s,this.acceptDtoUpdate(c)}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.id===c.e()},get label(){return c.b.label},get input(){return c.c},get isDirty(){return c.b.isDirty},get isPinned(){return c.b.isPinned},get isPreview(){return c.b.isPreview},get group(){return c.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(c){this.b=c,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$7M(R.URI.revive(this.b.input.uri));case 2:return new A.$8M(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified));case 3:return new A.$9M(R.URI.revive(this.b.input.base),R.URI.revive(this.b.input.input1),R.URI.revive(this.b.input.input2),R.URI.revive(this.b.input.result));case 6:return new A.$0M(R.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$$M(this.b.input.viewType);case 4:return new A.$_M(R.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$aN(R.URI.revive(this.b.input.original),R.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$bN;case 9:return new A.$cN(R.URI.revive(this.b.input.uri),R.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$dN(this.b.input.providerId);default:return}}}class l{constructor(c,s){this.c=[],this.d="",this.b=c,this.e=s;for(const i of c.tabs)i.isActive&&(this.d=i.id),this.c.push(new k(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const c=this,s={get isActive(){return c.b.groupId===c.e()},get viewColumn(){return y.ViewColumn.to(c.b.viewColumn)},get activeTab(){return c.c.find(i=>i.tabId===c.d)?.apiObject},get tabs(){return Object.freeze(c.c.map(i=>i.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(c){this.b=c}acceptTabOperation(c){if(c.kind===0){const i=new k(c.tabDto,this,()=>this.activeTabId());return this.c.splice(c.index,0,i),c.tabDto.isActive&&(this.d=i.tabId),i}else if(c.kind===1){const i=this.c.splice(c.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${c.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(c.kind===3){if(c.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(c.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${c.oldIndex} which does not exist`);return this.c.splice(c.index,0,i),i}const s=this.c.find(i=>i.tabId===c.tabDto.id);if(!s)throw new Error("INVALID tab");return c.tabDto.isActive?this.d=c.tabDto.id:this.d===c.tabDto.id&&!c.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(c.tabDto),s}activeTabId(){return this.d}}let $=class{constructor(c){this.b=new M.$Wd,this.c=new M.$Wd,this.e=[],this.a=c.getProxy(m.$lL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const c=this,s={onDidChangeTabGroups:c.c.event,onDidChangeTabs:c.b.event,get all(){return Object.freeze(c.e.map(i=>i.apiObject))},get activeTabGroup(){const i=c.d;return(0,I.$Uf)(c.e.find(a=>a.groupId===i)?.apiObject)},close:async(i,o)=>{const a=Array.isArray(i)?i:[i];return a.length?p(a[0])?this.j(a,o):this.i(a,o):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(c){const s=new Set(this.e.map(n=>n.groupId)),i=new Set(c.map(n=>n.groupId)),o=(0,S.$L)(s,i),a=this.e.filter(n=>o.removed.includes(n.groupId)).map(n=>n.apiObject),u=[],t=[];this.e=c.map(n=>{const w=new l(n,()=>this.d);return o.added.includes(w.groupId)?u.push(w.apiObject):t.push(w.apiObject),w});const f=(0,I.$Uf)(c.find(n=>n.isActive===!0)?.groupId);f!==void 0&&this.d!==f&&(this.d=f),this.c.fire(Object.freeze({opened:u,closed:a,changed:t}))}$acceptTabGroupUpdate(c){const s=this.e.find(i=>i.groupId===c.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(c),c.isActive&&(this.d=c.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(c){const s=this.e.find(o=>o.groupId===c.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const i=s.acceptTabOperation(c);switch(c.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(c){for(const s of this.e)for(const i of s.tabs)if(i.apiObject===c)return i}h(c){return this.e.find(s=>s.apiObject===c)}async i(c,s){const i=[];for(const o of c){const a=this.g(o);if(!a)throw new Error("Tab close: Invalid tab not found!");i.push(a.tabId)}return this.a.$closeTab(i,s)}async j(c,s){const i=[];for(const o of c){const a=this.h(o);if(!a)throw new Error("Group close: Invalid group not found!");i.push(a.groupId)}return this.a.$closeGroup(i,s)}};e.$2gc=$,e.$2gc=$=Ge([qe(0,d.$wN)],$);function p(r){return r.tabs!==void 0}}),define(Re[255],Ae([1,0,2,3,6,7,8,297,14,23,25,46]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dhc=void 0;class l{constructor(){this.a=[]}add(r){this.b=void 0,this.a.push(r)}delete(r){const c=this.a.indexOf(r);c>=0&&(this.a.splice(c,1),this.b=void 0)}c(){if(!this.b){const r=this.a.sort(),c=[];let s,i,o=14,a=14;for(const u of r){let t=s?(0,d.$cf)(s,u):0;for(t===0?i=1:i=a;t<u.length;t++)t+1===u.length?(o=a,a=9):a+=1,c.push([i,u.toUpperCase().charCodeAt(t),a]),c.push([i,u.toLowerCase().charCodeAt(t),a]),i=a;s=u,a=o}c.push([9,58,10]),c.push([10,47,12]),this.b=new m.$VZ(c)}}provideDocumentLinks(r){this.c();const c=[],s=m.$WZ.computeLinks({getLineContent(i){return r.lineAt(i-1).text},getLineCount(){return r.lineCount}},this.b);for(const i of s){const o=L.DocumentLink.to(i);o.target&&c.push(o)}return c}}class ${constructor(r,c){this.i=c,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=r.getProxy(M.$lL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(r,c,s,i={}){if($.j(s),this.d.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(r,"*",this.b));const o=this.h++;this.b.add(c),this.d.add(c),this.c.set(o,s);let a=2;i.isCaseSensitive&&(a+=1024),i.isReadonly&&(a+=2048),typeof s.copy=="function"&&(a+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,A.$LF)(r,"fsChunks"),a+=4);let u;i.isReadonly&&(0,k.$lk)(i.isReadonly)&&i.isReadonly.value!==""&&(u={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(o,c,a,u).catch(f=>{console.error(`FAILED to register filesystem provider of ${r.identifier.value}-extension for the scheme ${c}`),console.error(f)});const t=s.onDidChangeFile(f=>{const n=[];for(const w of f){const{uri:D,type:h}=w;if(D.scheme!==c)continue;let b;switch(h){case R.FileChangeType.Changed:b=0;break;case R.FileChangeType.Created:b=1;break;case R.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}n.push({resource:D,type:b})}this.a.$onFileSystemChange(o,n)});return(0,I.$Rc)(()=>{t.dispose(),this.b.delete(c),this.d.delete(c),this.c.delete(o),this.a.$unregisterProvider(o)})}static j(r){if(!r)throw new Error("MISSING provider");if(typeof r.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof r.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof r.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof r.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof r.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof r.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof r.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof r.rename!="function")throw new Error("Provider does NOT implement rename")}static k(r){const{type:c,ctime:s,mtime:i,size:o,permissions:a}=r;return{type:c,ctime:s,mtime:i,size:o,permissions:a}}$stat(r,c){return Promise.resolve(this.l(r).stat(S.URI.revive(c))).then(s=>$.k(s))}$readdir(r,c){return Promise.resolve(this.l(r).readDirectory(S.URI.revive(c)))}$readFile(r,c){return Promise.resolve(this.l(r).readFile(S.URI.revive(c))).then(s=>y.$ke.wrap(s))}$writeFile(r,c,s,i){return Promise.resolve(this.l(r).writeFile(S.URI.revive(c),s.buffer,i))}$delete(r,c,s){return Promise.resolve(this.l(r).delete(S.URI.revive(c),s))}$rename(r,c,s,i){return Promise.resolve(this.l(r).rename(S.URI.revive(c),S.URI.revive(s),i))}$copy(r,c,s,i){const o=this.l(r);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(o.copy(S.URI.revive(c),S.URI.revive(s),i))}$mkdir(r,c){return Promise.resolve(this.l(r).createDirectory(S.URI.revive(c)))}$watch(r,c,s,i){const o=this.l(r).watch(S.URI.revive(s),i);this.f.set(c,o)}$unwatch(r,c){const s=this.f.get(c);s&&(s.dispose(),this.f.delete(c))}$open(r,c,s){const i=this.l(r);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(S.URI.revive(c),s))}$close(r,c){const s=this.l(r);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(c))}$read(r,c,s,i){const o=this.l(r);if(!o.read)throw new Error('FileSystemProvider does not implement "read"');const a=y.$ke.alloc(i);return Promise.resolve(o.read(c,s,a.buffer,0,i)).then(u=>a.slice(0,u))}$write(r,c,s,i){const o=this.l(r);if(!o.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(o.write(c,s,i.buffer,0,i.byteLength))}l(r){const c=this.c.get(r);if(!c){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return c}}e.$Dhc=$}),define(Re[256],Ae([1,0,5,34,2,3,8,7,39]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ehc=void 0;class y{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor($,p,r,c,s,i){this.a=Math.random(),this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const o=(0,M.$Oj)(s),a=typeof s=="string",u=i?.correlate,t=c(f=>{if(!(typeof f.session=="number"&&f.session!==this.a)&&!(u&&typeof f.session>"u")){if(!i?.ignoreCreateEvents)for(const n of f.created){const w=I.URI.revive(n);o(w.fsPath)&&(!a||p.getWorkspaceFolder(w))&&this.b.fire(w)}if(!i?.ignoreChangeEvents)for(const n of f.changed){const w=I.URI.revive(n);o(w.fsPath)&&(!a||p.getWorkspaceFolder(w))&&this.c.fire(w)}if(!i?.ignoreDeleteEvents)for(const n of f.deleted){const w=I.URI.revive(n);o(w.fsPath)&&(!a||p.getWorkspaceFolder(w))&&this.d.fire(w)}}});this.g=m.$nL.from(this.i($,r,s,i,i?.correlate),this.b,this.c,this.d,t)}i($,p,r,c,s){const i=m.$nL.from();if(typeof r=="string")return i;const o=$.getProxy(R.$lL.MainThreadFileSystemEventService);let a=!1;return(r.pattern.includes(M.$Kj)||r.pattern.includes(M.$Lj))&&(a=!0),o.$watch(p.identifier.value,this.a,r.baseUri,{recursive:a,excludes:c?.excludes??[]},!!s),m.$nL.from({dispose:()=>o.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor($){this.a=$,this.session=this.a.session,this.b=new d.$V(()=>this.a.created.map(I.URI.revive)),this.c=new d.$V(()=>this.a.changed.map(I.URI.revive)),this.d=new d.$V(()=>this.a.deleted.map(I.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class k{constructor($,p,r){this.j=$,this.k=p,this.l=r,this.a=new S.$Wd,this.b=new S.$Wd,this.c=new S.$Wd,this.d=new S.$Wd,this.g=new S.$Yd,this.h=new S.$Yd,this.i=new S.$Yd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher($,p,r,c){return new y(this.j,$,p,this.a.event,L.GlobPattern.from(r),c)}$onFileEvent($){this.a.fire(new A($))}$onDidRunFileOperation($,p){switch($){case 2:this.b.fire(Object.freeze({files:p.map(r=>({oldUri:I.URI.revive(r.source),newUri:I.URI.revive(r.target)}))}));break;case 1:this.d.fire(Object.freeze({files:p.map(r=>I.URI.revive(r.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:p.map(r=>I.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent($){return this.m($,this.g)}getOnWillCreateFileEvent($){return this.m($,this.h)}getOnWillDeleteFileEvent($){return this.m($,this.i)}m($,p){return(r,c,s)=>{const i=function(a){r.call(c,a)};return i.extension=$,p.event(i,void 0,s)}}async $onWillRunFileOperation($,p,r,c){switch($){case 2:return await this.n(this.g,{files:p.map(s=>({oldUri:I.URI.revive(s.source),newUri:I.URI.revive(s.target)}))},r,c);case 1:return await this.n(this.i,{files:p.map(s=>I.URI.revive(s.target))},r,c);case 0:case 3:return await this.n(this.h,{files:p.map(s=>I.URI.revive(s.target))},r,c)}}async n($,p,r,c){const s=new Set,i=[];if(await $.fireAsync(p,c,async(a,u)=>{const t=Date.now(),f=await Promise.resolve(a);f instanceof m.$xL&&(i.push([u.extension,f]),s.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-t>r&&this.k.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||i.length===0)return;const o={edits:[]};for(const[,a]of i){const{edits:u}=L.WorkspaceEdit.from(a,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(u)}return{edit:o,extensionNames:Array.from(s)}}}e.$Ehc=k}),define(Re[257],Ae([1,0,2,26,8,7,86,3,14,29,18,16,298,21,22,6,95,88,74,63,15,11,25,160]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wgc=void 0;class n{constructor(O,K){this.d=O,this.e=K}async provideDocumentSymbols(O,K){const j=this.d.getDocument(O),H=await this.e.provideDocumentSymbols(j,K);if(!(0,A.$Kb)(H))return H[0]instanceof R.$GL?H.map(I.DocumentSymbol.from):n.f(H)}static f(O){O=O.slice(0).sort((H,Z)=>{let oe=H.location.range.start.compareTo(Z.location.range.start);return oe===0&&(oe=Z.location.range.end.compareTo(H.location.range.end)),oe});const K=[],j=[];for(const H of O){const Z={name:H.name||"!!MISSING: name!!",kind:I.SymbolKind.from(H.kind),tags:H.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:H.containerName,range:I.Range.from(H.location.range),selectionRange:I.Range.from(H.location.range),children:[]};for(;;){if(j.length===0){j.push(Z),K.push(Z);break}const oe=j[j.length-1];if(y.$Ws.containsRange(oe.range,Z.range)&&!y.$Ws.equalsRange(oe.range,Z.range)){oe.children?.push(Z),j.push(Z);break}j.pop()}}return K}}class w{constructor(O,K,j,H,Z,oe){this.f=O,this.g=K,this.h=j,this.j=H,this.k=Z,this.l=oe,this.d=new i.$mgc("CodeLens"),this.e=new Map}async provideCodeLenses(O,K){const j=this.f.getDocument(O),H=await this.h.provideCodeLenses(j,K);if(!H||K.isCancellationRequested)return;const Z=this.d.add(H),oe=new r.$Sc;this.e.set(Z,oe);const Ee={cacheId:Z,lenses:[]};for(let Be=0;Be<H.length;Be++)Ee.lenses.push({cacheId:[Z,Be],range:I.Range.from(H[Be].range),command:this.g.toInternal(H[Be].command,oe)});return Ee}async resolveCodeLens(O,K){const j=O.cacheId&&this.d.get(...O.cacheId);if(!j)return;let H;if(typeof this.h.resolveCodeLens!="function"||j.isResolved?H=j:H=await this.h.resolveCodeLens(j,K),H||(H=j),K.isCancellationRequested)return;const Z=O.cacheId&&this.e.get(O.cacheId[0]);if(Z){if(!H.command){const oe=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,oe),this.l.error(oe);return}return O.command=this.g.toInternal(H.command,Z),O}}releaseCodeLenses(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}}function D(Ie){return Array.isArray(Ie)?Ie.map(I.DefinitionLink.from):Ie?[I.DefinitionLink.from(Ie)]:[]}class h{constructor(O,K){this.d=O,this.e=K}async provideDefinition(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideDefinition(H,Z,j);return D(oe)}}class b{constructor(O,K){this.d=O,this.e=K}async provideDeclaration(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideDeclaration(H,Z,j);return D(oe)}}class P{constructor(O,K){this.d=O,this.e=K}async provideImplementation(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideImplementation(H,Z,j);return D(oe)}}class g{constructor(O,K){this.d=O,this.e=K}async provideTypeDefinition(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideTypeDefinition(H,Z,j);return D(oe)}}class v{constructor(O,K){this.d=O,this.e=K}async provideHover(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideHover(H,Z,j);if(!(!oe||(0,A.$Kb)(oe.contents)))return oe.range||(oe.range=H.getWordRangeAtPosition(Z)),oe.range||(oe.range=new R.$pL(Z,Z)),I.Hover.from(oe)}}class E{constructor(O,K){this.d=O,this.e=K}async provideEvaluatableExpression(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideEvaluatableExpression(H,Z,j);if(oe)return I.EvaluatableExpression.from(oe)}}class T{constructor(O,K){this.d=O,this.e=K}async provideInlineValues(O,K,j,H){const Z=this.d.getDocument(O),oe=await this.e.provideInlineValues(Z,I.Range.to(K),I.InlineValueContext.to(j),H);if(Array.isArray(oe))return oe.map(Ee=>I.InlineValue.from(Ee))}}class N{constructor(O,K){this.d=O,this.e=K}async provideDocumentHighlights(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideDocumentHighlights(H,Z,j);if(Array.isArray(oe))return oe.map(I.DocumentHighlight.from)}}class J{constructor(O,K){this.d=O,this.e=K}async provideMultiDocumentHighlights(O,K,j,H){const Z=this.d.getDocument(O),oe=j.map(We=>this.d.getDocument(We)),Ee=I.Position.to(K),Be=await this.e.provideMultiDocumentHighlights(Z,Ee,oe,H);if(Array.isArray(Be))return Be.map(I.MultiDocumentHighlight.from)}}class q{constructor(O,K){this.d=O,this.e=K}async provideLinkedEditingRanges(O,K,j){const H=this.d.getDocument(O),Z=I.Position.to(K),oe=await this.e.provideLinkedEditingRanges(H,Z,j);if(oe&&Array.isArray(oe.ranges))return{ranges:(0,A.$Hb)(oe.ranges.map(I.Range.from)),wordPattern:oe.wordPattern}}}class U{constructor(O,K){this.d=O,this.e=K}async provideReferences(O,K,j,H){const Z=this.d.getDocument(O),oe=I.Position.to(K),Ee=await this.e.provideReferences(Z,oe,j,H);if(Array.isArray(Ee))return Ee.map(I.location.from)}}class C{static{this.d=1e3}constructor(O,K,j,H,Z,oe,Ee){this.g=O,this.h=K,this.j=j,this.k=H,this.l=Z,this.m=oe,this.n=Ee,this.e=new i.$mgc("CodeAction"),this.f=new Map}async provideCodeActions(O,K,j,H){const Z=this.g.getDocument(O),oe=l.$Ys.isISelection(K)?I.Selection.to(K):I.Range.to(K),Ee=[];for(const rt of this.j.getDiagnostics(O))if(oe.intersection(rt.range)&&Ee.push(rt)>C.d)break;const Be={diagnostics:Ee,only:j.only?new R.$IL(j.only):void 0,triggerKind:I.CodeActionTriggerKind.to(j.trigger)},We=await this.k.provideCodeActions(Z,oe,Be,H);if(!(0,A.$Lb)(We)||H.isCancellationRequested)return;const Ze=this.e.add(We),_e=new r.$Sc;this.f.set(Ze,_e);const at=[];for(let rt=0;rt<We.length;rt++){const et=We[rt];if(et)if(C.o(et))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:et.title,command:this.h.toInternal(et,_e)});else{Be.only&&(et.kind?Be.only.contains(et.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${et.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const ct=et.ranges??[];at.push({cacheId:[Ze,rt],title:et.title,command:et.command&&this.h.toInternal(et.command,_e),diagnostics:et.diagnostics&&et.diagnostics.map(I.Diagnostic.from),edit:et.edit&&I.WorkspaceEdit.from(et.edit,void 0),kind:et.kind&&et.kind.value,isPreferred:et.isPreferred,isAI:(0,t.$KF)(this.m,"codeActionAI")?et.isAI:!1,ranges:(0,t.$KF)(this.m,"codeActionRanges")?(0,A.$Hb)(ct.map(I.Range.from)):void 0,disabled:et.disabled?.reason})}}return{cacheId:Ze,actions:at}}async resolveCodeAction(O,K){const[j,H]=O,Z=this.e.get(j,H);if(!Z||C.o(Z))return{};if(!this.k.resolveCodeAction)return{};const oe=await this.k.resolveCodeAction(Z,K)??Z;let Ee;oe.edit&&(Ee=I.WorkspaceEdit.from(oe.edit,void 0));let Be;if(oe.command){const We=this.f.get(j);We&&(Be=this.h.toInternal(oe.command,We))}return{edit:Ee,command:Be}}releaseCodeActions(O){this.f.get(O)?.dispose(),this.f.delete(O),this.e.delete(O)}static o(O){return typeof O.command=="string"&&typeof O.title=="string"}}class F{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,j,H,Z){this.d=O,this.e=K,this.f=j,this.g=H,this.h=Z}async prepareDocumentPaste(O,K,j,H){if(!this.f.prepareDocumentPaste)return;const Z=this.e.getDocument(O),oe=K.map(We=>I.Range.to(We)),Ee=I.DataTransfer.toDataTransfer(j,()=>{throw new a.$$});if(await this.f.prepareDocumentPaste(Z,oe,Ee,H),H.isCancellationRequested)return;const Be=Array.from(Ee).filter(([,We])=>!(We instanceof R.$cM));return I.DataTransfer.from(Be)}async providePasteEdits(O,K,j,H,Z){if(!this.f.provideDocumentPasteEdits)return;const oe=this.e.getDocument(K),Ee=j.map(Ze=>I.Range.to(Ze)),Be=I.DataTransfer.toDataTransfer(H,async Ze=>(await this.d.$resolvePasteFileData(this.g,O,Ze)).buffer),We=await this.f.provideDocumentPasteEdits(oe,Ee,Be,Z);if(We)return{label:We.label??(0,f.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:F.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class W{constructor(O,K){this.d=O,this.e=K}async provideDocumentFormattingEdits(O,K,j){const H=this.d.getDocument(O),Z=await this.e.provideDocumentFormattingEdits(H,K,j);if(Array.isArray(Z))return Z.map(I.TextEdit.from)}}class re{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeFormattingEdits(O,K,j,H){const Z=this.d.getDocument(O),oe=I.Range.to(K),Ee=await this.e.provideDocumentRangeFormattingEdits(Z,oe,j,H);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(O,K,j,H){(0,k.$Tf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const Z=this.d.getDocument(O),oe=K.map(I.Range.to),Ee=await this.e.provideDocumentRangesFormattingEdits(Z,oe,j,H);if(Array.isArray(Ee))return Ee.map(I.TextEdit.from)}}class ce{constructor(O,K){this.d=O,this.e=K,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(O,K,j,H,Z){const oe=this.d.getDocument(O),Ee=I.Position.to(K),Be=await this.e.provideOnTypeFormattingEdits(oe,Ee,j,H,Z);if(Array.isArray(Be))return Be.map(I.TextEdit.from)}}class we{constructor(O,K){this.e=O,this.f=K,this.d=new i.$mgc("WorkspaceSymbols")}async provideWorkspaceSymbols(O,K){const j=await this.e.provideWorkspaceSymbols(O,K);if(!(0,A.$Lb)(j))return{symbols:[]};const H=this.d.add(j),Z={cacheId:H,symbols:[]};for(let oe=0;oe<j.length;oe++){const Ee=j[oe];if(!Ee||!Ee.name){this.f.warn("INVALID SymbolInformation",Ee);continue}Z.symbols.push({...I.WorkspaceSymbol.from(Ee),cacheId:[H,oe]})}return Z}async resolveWorkspaceSymbol(O,K){if(typeof this.e.resolveWorkspaceSymbol!="function"||!O.cacheId)return O;const j=this.d.get(...O.cacheId);if(j){const H=await this.e.resolveWorkspaceSymbol(j,K);return H&&(0,M.$Bn)(O,I.WorkspaceSymbol.from(H),!0)}}releaseWorkspaceSymbols(O){this.d.delete(O)}}class De{static supportsResolving(O){return typeof O.prepareRename=="function"}constructor(O,K,j){this.d=O,this.e=K,this.f=j}async provideRenameEdits(O,K,j,H){const Z=this.d.getDocument(O),oe=I.Position.to(K);try{const Ee=await this.e.provideRenameEdits(Z,oe,j,H);return Ee?I.WorkspaceEdit.from(Ee):void 0}catch(Ee){const Be=De.g(Ee);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Ee)}}async resolveRenameLocation(O,K,j){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const H=this.d.getDocument(O),Z=I.Position.to(K);try{const oe=await this.e.prepareRename(H,Z,j);let Ee,Be;if(R.$pL.isRange(oe)?(Ee=oe,Be=H.getText(oe)):(0,k.$Lf)(oe)&&(Ee=oe.range,Be=oe.placeholder),!Ee||!Be)return;if(Ee.start.line>Z.line||Ee.end.line<Z.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(Ee),text:Be}}catch(oe){const Ee=De.g(oe);return Ee?{rejectReason:Ee,range:void 0,text:void 0}:Promise.reject(oe)}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class le{constructor(O,K,j){this.d=O,this.e=K,this.f=j}async provideNewSymbolNames(O,K,j){const H=this.d.getDocument(O),Z=I.Range.to(K);try{const oe=await this.e.provideNewSymbolNames(H,Z,j);return oe||void 0}catch(oe){this.f.error(le.g(oe)??JSON.stringify(oe,null,"	"));return}}static g(O){return typeof O=="string"?O:O instanceof Error&&typeof O.message=="string"?O.message:void 0}}class ve{constructor(O,K){this.resultId=O,this.tokens=K}}class se{constructor(O,K){this.f=O,this.g=K,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(O,K,j){const H=this.f.getDocument(O),Z=K!==0?this.d.get(K):null;let oe=typeof Z?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(H,Z.resultId,j):await this.g.provideDocumentSemanticTokens(H,j);return Z&&this.d.delete(K),oe?(oe=se.h(oe),this.o(se.n(Z,oe),oe)):null}async releaseDocumentSemanticColoring(O){this.d.delete(O)}static h(O){return se.j(O)?se.k(O)?O:new R.$FM(new Uint32Array(O.data),O.resultId):se.l(O)?se.m(O)?O:new R.$HM(O.edits.map(K=>new R.$GM(K.start,K.deleteCount,K.data?new Uint32Array(K.data):K.data)),O.resultId):O}static j(O){return O&&!!O.data}static k(O){return O.data instanceof Uint32Array}static l(O){return O&&Array.isArray(O.edits)}static m(O){for(const K of O.edits)if(!(K.data instanceof Uint32Array))return!1;return!0}static n(O,K){if(!se.j(K)||!O||!O.tokens)return K;const j=O.tokens,H=j.length,Z=K.data,oe=Z.length;let Ee=0;const Be=Math.min(H,oe);for(;Ee<Be&&j[Ee]===Z[Ee];)Ee++;if(Ee===H&&Ee===oe)return new R.$HM([],K.resultId);let We=0;const Ze=Be-Ee;for(;We<Ze&&j[H-We-1]===Z[oe-We-1];)We++;return new R.$HM([{start:Ee,deleteCount:H-Ee-We,data:Z.subarray(Ee,oe-We)}],K.resultId)}o(O,K){if(se.j(O)){const j=this.e++;return this.d.set(j,new ve(O.resultId,O.data)),(0,c.$Y$)({id:j,type:"full",data:O.data})}if(se.l(O)){const j=this.e++;return se.j(K)?this.d.set(j,new ve(K.resultId,K.data)):this.d.set(j,new ve(O.resultId)),(0,c.$Y$)({id:j,type:"delta",deltas:(O.edits||[]).map(H=>({start:H.start,deleteCount:H.deleteCount,data:H.data}))})}return null}}class $e{constructor(O,K){this.d=O,this.e=K}async provideDocumentRangeSemanticTokens(O,K,j){const H=this.d.getDocument(O),Z=await this.e.provideDocumentRangeSemanticTokens(H,I.Range.to(K),j);return Z?this.f(Z):null}f(O){return(0,c.$Y$)({id:0,type:"full",data:O.data})}}class te{static supportsResolving(O){return typeof O.resolveCompletionItem=="function"}constructor(O,K,j,H,Z){this.f=O,this.g=K,this.h=j,this.j=H,this.k=Z,this.d=new i.$mgc("CompletionItem"),this.e=new Map}async provideCompletionItems(O,K,j,H){const Z=this.f.getDocument(O),oe=I.Position.to(K),Ee=Z.getWordRangeAtPosition(oe)||new R.$pL(oe,oe),Be=Ee.with({end:oe}),We=new o.$Sd,Ze=await this.h.provideCompletionItems(Z,oe,H,I.CompletionContext.to(j));if(!Ze||H.isCancellationRequested)return;const _e=Array.isArray(Ze)?new R.$VL(Ze):Ze,at=te.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),rt=new r.$Sc;this.e.set(at,rt);const et=[],ct={x:at,b:et,a:{replace:I.Range.from(Ee),insert:I.Range.from(Be)},c:_e.isIncomplete||void 0,d:We.elapsed()};for(let je=0;je<_e.items.length;je++){const vt=_e.items[je],Y=this.l(vt,[at,je],Be,Ee);et.push(Y)}return ct}async resolveCompletionItem(O,K){if(typeof this.h.resolveCompletionItem!="function")return;const j=this.d.get(...O);if(!j)return;const H=this.l(j,O),Z=await this.h.resolveCompletionItem(j,K);if(!Z)return;const oe=this.l(Z,O);return(H.h!==oe.h||H.i!==oe.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(H.n!==oe.n||H.o!==oe.o||!(0,M.$Cn)(H.p,oe.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...H,d:oe.d,c:oe.c,l:oe.l,h:oe.h,i:oe.i,n:oe.n,o:oe.o,p:oe.p}}releaseCompletionItems(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K,j,H){const Z=this.e.get(K[0]);if(!Z)throw Error("DisposableStore is missing...");const oe=this.g.toInternal(O.command,Z),Ee={x:K,a:O.label,b:O.kind!==void 0?I.CompletionItemKind.from(O.kind):void 0,m:O.tags&&O.tags.map(I.CompletionItemTag.from),c:O.detail,d:typeof O.documentation>"u"?void 0:I.MarkdownString.fromStrict(O.documentation),e:O.sortText!==O.label?O.sortText:void 0,f:O.filterText!==O.label?O.filterText:void 0,g:O.preselect||void 0,i:O.keepWhitespace?1:0,k:O.commitCharacters?.join(""),l:O.additionalTextEdits&&O.additionalTextEdits.map(I.TextEdit.from),n:oe?.$ident,o:oe?.id,p:oe?.$ident?void 0:oe?.arguments};O.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ee.h=O.textEdit.newText):typeof O.insertText=="string"?Ee.h=O.insertText:O.insertText instanceof R.$yL&&(Ee.h=O.insertText.value,Ee.i|=4);let Be;return O.textEdit?Be=O.textEdit.range:O.range&&(Be=O.range),R.$pL.isRange(Be)?Ee.j=I.Range.from(Be):Be&&(!j?.isEqual(Be.inserting)||!H?.isEqual(Be.replacing))&&(Ee.j={insert:I.Range.from(Be.inserting),replace:I.Range.from(Be.replacing)}),Ee}}class X{async provideInlineCompletions(O,K,j,H){}disposeCompletions(O){}handleDidShowCompletionItem(O,K,j){}handlePartialAccept(O,K,j){}}class V extends X{constructor(O,K,j,H){super(),this.f=O,this.g=K,this.h=j,this.j=H,this.d=new ie,this.e=(0,t.$KF)(this.f,"inlineCompletionsAdditions"),this.k={[L.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[L.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$KF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(O,K,j,H){const Z=this.g.getDocument(O),oe=I.Position.to(K),Ee=await this.h.provideInlineCompletionItems(Z,oe,{selectedCompletionInfo:j.selectedSuggestionInfo?{range:I.Range.to(j.selectedSuggestionInfo.range),text:j.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[j.triggerKind]},H);if(!Ee||H.isCancellationRequested)return;const Be=Array.isArray(Ee)?Ee:Ee.items,We=this.e?Array.isArray(Ee)?[]:Ee.commands||[]:[],Ze=this.e&&!Array.isArray(Ee)?Ee.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:Be}),items:Be.map((rt,et)=>{let ct;rt.command&&(_e||(_e=new r.$Sc),ct=this.j.toInternal(rt.command,_e));const je=rt.insertText;return{insertText:typeof je=="string"?je:{snippet:je.value},filterText:rt.filterText,range:rt.range?I.Range.from(rt.range):void 0,command:ct,idx:et,completeBracketPairs:this.e?rt.completeBracketPairs:!1}}),commands:We.map(rt=>(_e||(_e=new r.$Sc),this.j.toInternal(rt,_e))),suppressSuggestions:!1,enableForwardStability:Ze}}disposeCompletions(O){this.d.disposeReferenceId(O)?.dispose()}handleDidShowCompletionItem(O,K,j){const H=this.d.get(O)?.items[K];H&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(H,j)}handlePartialAccept(O,K,j){const H=this.d.get(O)?.items[K];H&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(H,j)}}class ie{constructor(){this.d=new Map,this.e=1}createReferenceId(O){const K=this.e++;return this.d.set(K,O),K}disposeReferenceId(O){const K=this.d.get(O);return this.d.delete(O),K}get(O){return this.d.get(O)}}class Ce{constructor(O,K){this.e=O,this.f=K,this.d=new i.$mgc("SignatureHelp")}async provideSignatureHelp(O,K,j,H){const Z=this.e.getDocument(O),oe=I.Position.to(K),Ee=this.g(j),Be=await this.f.provideSignatureHelp(Z,oe,H,Ee);if(Be){const We=this.d.add([Be]);return{...I.SignatureHelp.from(Be),id:We}}}g(O){let K;if(O.activeSignatureHelp){const j=I.SignatureHelp.to(O.activeSignatureHelp),H=this.d.get(O.activeSignatureHelp.id,0);H?(K=H,K.activeSignature=j.activeSignature,K.activeParameter=j.activeParameter):K=j}return{...O,activeSignatureHelp:K}}releaseSignatureHelp(O){this.d.delete(O)}}class Te{constructor(O,K,j,H,Z){this.f=O,this.g=K,this.h=j,this.j=H,this.k=Z,this.d=new i.$mgc("InlayHints"),this.e=new Map}async provideInlayHints(O,K,j){const H=this.f.getDocument(O),Z=I.Range.to(K),oe=await this.h.provideInlayHints(H,Z,j);if(!Array.isArray(oe)||oe.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`);return}if(j.isCancellationRequested)return;const Ee=this.d.add(oe);this.e.set(Ee,new r.$Sc);const Be={hints:[],cacheId:Ee};for(let We=0;We<oe.length;We++)this.l(oe[We],Z)&&Be.hints.push(this.m(oe[We],[Ee,We]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(K)}`),Be}async resolveInlayHint(O,K){if(typeof this.h.resolveInlayHint!="function")return;const j=this.d.get(...O);if(!j)return;const H=await this.h.resolveInlayHint(j,K);if(H&&this.l(H))return this.m(H,O)}releaseHints(O){this.e.get(O)?.dispose(),this.e.delete(O),this.d.delete(O)}l(O,K){return O.label.length===0||Array.isArray(O.label)&&O.label.every(j=>j.value.length===0)?(console.log("INVALID inlay hint, empty label",O),!1):!(K&&!K.contains(O.position))}m(O,K){const j=this.e.get(K[0]);if(!j)throw Error("DisposableStore is missing...");const H={label:"",cacheId:K,tooltip:I.MarkdownString.fromStrict(O.tooltip),position:I.Position.from(O.position),textEdits:O.textEdits&&O.textEdits.map(I.TextEdit.from),kind:O.kind&&I.InlayHintKind.from(O.kind),paddingLeft:O.paddingLeft,paddingRight:O.paddingRight};if(typeof O.label=="string")H.label=O.label;else{const Z=[];H.label=Z;for(const oe of O.label){if(!oe.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ee={label:oe.value,tooltip:I.MarkdownString.fromStrict(oe.tooltip)};R.$zL.isLocation(oe.location)&&(Ee.location=I.location.from(oe.location)),oe.command&&(Ee.command=this.g.toInternal(oe.command,j)),Z.push(Ee)}}return H}}class Pe{constructor(O,K){this.e=O,this.f=K,this.d=new i.$mgc("DocumentLink")}async provideLinks(O,K){const j=this.e.getDocument(O),H=await this.f.provideDocumentLinks(j,K);if(!(!Array.isArray(H)||H.length===0)&&!K.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:H.filter(Pe.g).map(I.DocumentLink.from)};{const Z=this.d.add(H),oe={links:[],cacheId:Z};for(let Ee=0;Ee<H.length;Ee++){if(!Pe.g(H[Ee]))continue;const Be=I.DocumentLink.from(H[Ee]);Be.cacheId=[Z,Ee],oe.links.push(Be)}return oe}}}static g(O){return O.target&&O.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(O,K){if(typeof this.f.resolveDocumentLink!="function")return;const j=this.d.get(...O);if(!j)return;const H=await this.f.resolveDocumentLink(j,K);if(!(!H||!Pe.g(H)))return I.DocumentLink.from(H)}releaseLinks(O){this.d.delete(O)}}class be{constructor(O,K){this.d=O,this.e=K}async provideColors(O,K){const j=this.d.getDocument(O),H=await this.e.provideDocumentColors(j,K);return Array.isArray(H)?H.map(oe=>({color:I.Color.from(oe.color),range:I.Range.from(oe.range)})):[]}async provideColorPresentations(O,K,j){const H=this.d.getDocument(O),Z=I.Range.to(K.range),oe=I.Color.to(K.color),Ee=await this.e.provideColorPresentations(oe,{document:H,range:Z},j);if(Array.isArray(Ee))return Ee.map(I.ColorPresentation.from)}}class ge{constructor(O,K){this.d=O,this.e=K}async provideFoldingRanges(O,K,j){const H=this.d.getDocument(O),Z=await this.e.provideFoldingRanges(H,K,j);if(Array.isArray(Z))return Z.map(I.FoldingRange.from)}}class G{constructor(O,K,j){this.d=O,this.e=K,this.f=j}async provideSelectionRanges(O,K,j){const H=this.d.getDocument(O),Z=K.map(I.Position.to),oe=await this.e.provideSelectionRanges(H,Z,j);if(!(0,A.$Lb)(oe))return[];if(oe.length!==Z.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ee=[];for(let Be=0;Be<Z.length;Be++){const We=[];Ee.push(We);let Ze=Z[Be],_e=oe[Be];for(;;){if(!_e.range.contains(Ze))throw new Error("INVALID selection range, must contain the previous range");if(We.push(I.SelectionRange.from(_e)),!_e.parent)break;Ze=_e.range,_e=_e.parent}}return Ee}}class _{constructor(O,K){this.f=O,this.g=K,this.d=new s.$BN(""),this.e=new Map}async prepareSession(O,K,j){const H=this.f.getDocument(O),Z=I.Position.to(K),oe=await this.g.prepareCallHierarchy(H,Z,j);if(!oe)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Ee,Be)):[this.h(Ee,oe)]}async provideCallsTo(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyIncomingCalls(H,j);if(Z)return Z.map(oe=>({from:this.h(O,oe.from),fromRanges:oe.fromRanges.map(Ee=>I.Range.from(Ee))}))}async provideCallsFrom(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing call hierarchy item");const Z=await this.g.provideCallHierarchyOutgoingCalls(H,j);if(Z)return Z.map(oe=>({to:this.h(O,oe.to),fromRanges:oe.fromRanges.map(Ee=>I.Range.from(Ee))}))}releaseSession(O){this.e.delete(O)}h(O,K){const j=this.e.get(O),H=I.CallHierarchyItem.from(K,O,j.size.toString(36));return j.set(H._itemId,K),H}j(O,K){return this.e.get(O)?.get(K)}}class ue{constructor(O,K){this.f=O,this.g=K,this.d=new s.$BN(""),this.e=new Map}async prepareSession(O,K,j){const H=this.f.getDocument(O),Z=I.Position.to(K),oe=await this.g.prepareTypeHierarchy(H,Z,j);if(!oe)return;const Ee=this.d.nextId();return this.e.set(Ee,new Map),Array.isArray(oe)?oe.map(Be=>this.h(Ee,Be)):[this.h(Ee,oe)]}async provideSupertypes(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySupertypes(H,j);if(Z)return Z.map(oe=>this.h(O,oe))}async provideSubtypes(O,K,j){const H=this.j(O,K);if(!H)throw new Error("missing type hierarchy item");const Z=await this.g.provideTypeHierarchySubtypes(H,j);if(Z)return Z.map(oe=>this.h(O,oe))}releaseSession(O){this.e.delete(O)}h(O,K){const j=this.e.get(O),H=I.TypeHierarchyItem.from(K,O,j.size.toString(36));return j.set(H._itemId,K),H}j(O,K){return this.e.get(O)?.get(K)}}class de{static toInternalProviderId(O,K){return O+"."+K}constructor(O,K,j,H,Z){this.d=O,this.e=K,this.f=j,this.g=H,this.h=Z}async provideDocumentOnDropEdits(O,K,j,H,Z){const oe=this.e.getDocument(K),Ee=I.Position.to(j),Be=I.DataTransfer.toDataTransfer(H,async Ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,O,Ze)).buffer),We=await this.f.provideDocumentDropEdits(oe,Ee,Be,Z);if(We)return{label:We.label??(0,f.localize)(1,null,this.h.displayName||this.h.name),yieldTo:We.yieldTo?.map(Ze=>"mimeType"in Ze?Ze:{providerId:de.toInternalProviderId(Ze.extensionId,Ze.providerId)}),insertText:typeof We.insertText=="string"?We.insertText:{snippet:We.insertText.value},additionalEdit:We.additionalEdit?I.WorkspaceEdit.from(We.additionalEdit,void 0):void 0}}}class Le{constructor(O,K){this.d=O,this.e=K}async provideMappedEdits(O,K,j,H){const Z=S.URI.revive(O),oe=this.d.getDocument(Z),Ee=j.documents.map(Ze=>Ze.map(_e=>({uri:S.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>I.Range.to(at))}))),Be={documents:Ee,selections:Ee[0]?.[0]?.ranges??[]},We=await this.e.provideMappedEdits(oe,K,Be,H);return We?I.WorkspaceEdit.from(We):null}}class fe{constructor(O,K){this.adapter=O,this.extension=K}}class ke{static{this.d=0}constructor(O,K,j,H,Z,oe,Ee,Be){this.g=K,this.h=j,this.j=H,this.k=Z,this.l=oe,this.m=Ee,this.n=Be,this.f=new Map,this.e=O.getProxy(m.$lL.MainThreadLanguageFeatures)}o(O,K){return I.DocumentSelector.from(O,this.g,K)}p(O){return new R.$nL(()=>{this.f.delete(O),this.e.$unregister(O)})}q(){return ke.d++}async s(O,K,j,H,Z,oe=!1){const Ee=this.f.get(O);if(!Ee||!(Ee.adapter instanceof K))return H;const Be=Date.now();oe||this.l.trace(`[${Ee.extension.identifier.value}] INVOKE provider '${j.toString().replace(/[\r\n]/g,"")}'`);const We=j(Ee.adapter,Ee.extension);return Promise.resolve(We).catch(Ze=>{(0,a.$4)(Ze)||(this.l.error(`[${Ee.extension.identifier.value}] provider FAILED`),this.l.error(Ze),this.n.onExtensionError(Ee.extension.identifier,Ze))}).finally(()=>{oe||this.l.trace(`[${Ee.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),$.CancellationToken.isCancellationToken(Z)?(0,u.$Wg)(We,Z):We}t(O,K){const j=this.q();return this.f.set(j,new fe(O,K)),j}static u(O){return O.displayName||O.name}registerDocumentSymbolProvider(O,K,j,H){const Z=this.t(new n(this.h,j),O),oe=H&&H.label||ke.u(O);return this.e.$registerDocumentSymbolProvider(Z,this.o(K,O),oe),this.p(Z)}$provideDocumentSymbols(O,K,j){return this.s(O,n,H=>H.provideDocumentSymbols(S.URI.revive(K),j),void 0,j)}registerCodeLensProvider(O,K,j){const H=this.q(),Z=typeof j.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(H,new fe(new w(this.h,this.j.converter,j,O,this.n,this.l),O)),this.e.$registerCodeLensSupport(H,this.o(K,O),Z);let oe=this.p(H);if(Z!==void 0){const Ee=j.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(Z));oe=R.$nL.from(oe,Ee)}return oe}$provideCodeLenses(O,K,j){return this.s(O,w,H=>H.provideCodeLenses(S.URI.revive(K),j),void 0,j)}$resolveCodeLens(O,K,j){return this.s(O,w,H=>H.resolveCodeLens(K,j),void 0,void 0)}$releaseCodeLenses(O,K){this.s(O,w,j=>Promise.resolve(j.releaseCodeLenses(K)),void 0,void 0)}registerDefinitionProvider(O,K,j){const H=this.t(new h(this.h,j),O);return this.e.$registerDefinitionSupport(H,this.o(K,O)),this.p(H)}$provideDefinition(O,K,j,H){return this.s(O,h,Z=>Z.provideDefinition(S.URI.revive(K),j,H),[],H)}registerDeclarationProvider(O,K,j){const H=this.t(new b(this.h,j),O);return this.e.$registerDeclarationSupport(H,this.o(K,O)),this.p(H)}$provideDeclaration(O,K,j,H){return this.s(O,b,Z=>Z.provideDeclaration(S.URI.revive(K),j,H),[],H)}registerImplementationProvider(O,K,j){const H=this.t(new P(this.h,j),O);return this.e.$registerImplementationSupport(H,this.o(K,O)),this.p(H)}$provideImplementation(O,K,j,H){return this.s(O,P,Z=>Z.provideImplementation(S.URI.revive(K),j,H),[],H)}registerTypeDefinitionProvider(O,K,j){const H=this.t(new g(this.h,j),O);return this.e.$registerTypeDefinitionSupport(H,this.o(K,O)),this.p(H)}$provideTypeDefinition(O,K,j,H){return this.s(O,g,Z=>Z.provideTypeDefinition(S.URI.revive(K),j,H),[],H)}registerHoverProvider(O,K,j,H){const Z=this.t(new v(this.h,j),O);return this.e.$registerHoverProvider(Z,this.o(K,O)),this.p(Z)}$provideHover(O,K,j,H){return this.s(O,v,Z=>Z.provideHover(S.URI.revive(K),j,H),void 0,H)}registerEvaluatableExpressionProvider(O,K,j,H){const Z=this.t(new E(this.h,j),O);return this.e.$registerEvaluatableExpressionProvider(Z,this.o(K,O)),this.p(Z)}$provideEvaluatableExpression(O,K,j,H){return this.s(O,E,Z=>Z.provideEvaluatableExpression(S.URI.revive(K),j,H),void 0,H)}registerInlineValuesProvider(O,K,j,H){const Z=typeof j.onDidChangeInlineValues=="function"?this.q():void 0,oe=this.t(new T(this.h,j),O);this.e.$registerInlineValuesProvider(oe,this.o(K,O),Z);let Ee=this.p(oe);if(Z!==void 0){const Be=j.onDidChangeInlineValues(We=>this.e.$emitInlineValuesEvent(Z));Ee=R.$nL.from(Ee,Be)}return Ee}$provideInlineValues(O,K,j,H,Z){return this.s(O,T,oe=>oe.provideInlineValues(S.URI.revive(K),j,H,Z),void 0,Z)}registerDocumentHighlightProvider(O,K,j){const H=this.t(new N(this.h,j),O);return this.e.$registerDocumentHighlightProvider(H,this.o(K,O)),this.p(H)}registerMultiDocumentHighlightProvider(O,K,j){const H=this.t(new J(this.h,j),O);return this.e.$registerMultiDocumentHighlightProvider(H,this.o(K,O)),this.p(H)}$provideDocumentHighlights(O,K,j,H){return this.s(O,N,Z=>Z.provideDocumentHighlights(S.URI.revive(K),j,H),void 0,H)}$provideMultiDocumentHighlights(O,K,j,H,Z){return this.s(O,J,oe=>oe.provideMultiDocumentHighlights(S.URI.revive(K),j,H.map(Ee=>S.URI.revive(Ee)),Z),void 0,Z)}registerLinkedEditingRangeProvider(O,K,j){const H=this.t(new q(this.h,j),O);return this.e.$registerLinkedEditingRangeProvider(H,this.o(K,O)),this.p(H)}$provideLinkedEditingRanges(O,K,j,H){return this.s(O,q,async Z=>{const oe=await Z.provideLinkedEditingRanges(S.URI.revive(K),j,H);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?ke.w(oe.wordPattern):void 0}},void 0,H)}registerReferenceProvider(O,K,j){const H=this.t(new U(this.h,j),O);return this.e.$registerReferenceSupport(H,this.o(K,O)),this.p(H)}$provideReferences(O,K,j,H,Z){return this.s(O,U,oe=>oe.provideReferences(S.URI.revive(K),j,H,Z),void 0,Z)}registerCodeActionProvider(O,K,j,H){const Z=new r.$Sc,oe=this.t(new C(this.h,this.j.converter,this.k,j,this.l,O,this.m),O);return this.e.$registerQuickFixSupport(oe,this.o(K,O),{providedKinds:H?.providedCodeActionKinds?.map(Ee=>Ee.value),documentation:H?.documentation?.map(Ee=>({kind:Ee.kind.value,command:this.j.converter.toInternal(Ee.command,Z)}))},ke.u(O),!!j.resolveCodeAction),Z.add(this.p(oe)),Z}$provideCodeActions(O,K,j,H,Z){return this.s(O,C,oe=>oe.provideCodeActions(S.URI.revive(K),j,H,Z),void 0,Z)}$resolveCodeAction(O,K,j){return this.s(O,C,H=>H.resolveCodeAction(K,j),{},void 0)}$releaseCodeActions(O,K){this.s(O,C,j=>Promise.resolve(j.releaseCodeActions(K)),void 0,void 0)}registerDocumentFormattingEditProvider(O,K,j){const H=this.t(new W(this.h,j),O);return this.e.$registerDocumentFormattingSupport(H,this.o(K,O),O.identifier,O.displayName||O.name),this.p(H)}$provideDocumentFormattingEdits(O,K,j,H){return this.s(O,W,Z=>Z.provideDocumentFormattingEdits(S.URI.revive(K),j,H),void 0,H)}registerDocumentRangeFormattingEditProvider(O,K,j){const H=typeof j.provideDocumentRangesFormattingEdits=="function",Z=this.t(new re(this.h,j),O);return this.e.$registerRangeFormattingSupport(Z,this.o(K,O),O.identifier,O.displayName||O.name,H),this.p(Z)}$provideDocumentRangeFormattingEdits(O,K,j,H,Z){return this.s(O,re,oe=>oe.provideDocumentRangeFormattingEdits(S.URI.revive(K),j,H,Z),void 0,Z)}$provideDocumentRangesFormattingEdits(O,K,j,H,Z){return this.s(O,re,oe=>oe.provideDocumentRangesFormattingEdits(S.URI.revive(K),j,H,Z),void 0,Z)}registerOnTypeFormattingEditProvider(O,K,j,H){const Z=this.t(new ce(this.h,j),O);return this.e.$registerOnTypeFormattingSupport(Z,this.o(K,O),H,O.identifier),this.p(Z)}$provideOnTypeFormattingEdits(O,K,j,H,Z,oe){return this.s(O,ce,Ee=>Ee.provideOnTypeFormattingEdits(S.URI.revive(K),j,H,Z,oe),void 0,oe)}registerWorkspaceSymbolProvider(O,K){const j=this.t(new we(K,this.l),O);return this.e.$registerNavigateTypeSupport(j,typeof K.resolveWorkspaceSymbol=="function"),this.p(j)}$provideWorkspaceSymbols(O,K,j){return this.s(O,we,H=>H.provideWorkspaceSymbols(K,j),{symbols:[]},j)}$resolveWorkspaceSymbol(O,K,j){return this.s(O,we,H=>H.resolveWorkspaceSymbol(K,j),void 0,void 0)}$releaseWorkspaceSymbols(O,K){this.s(O,we,j=>j.releaseWorkspaceSymbols(K),void 0,void 0)}registerRenameProvider(O,K,j){const H=this.t(new De(this.h,j,this.l),O);return this.e.$registerRenameSupport(H,this.o(K,O),De.supportsResolving(j)),this.p(H)}$provideRenameEdits(O,K,j,H,Z){return this.s(O,De,oe=>oe.provideRenameEdits(S.URI.revive(K),j,H,Z),void 0,Z)}$resolveRenameLocation(O,K,j,H){return this.s(O,De,Z=>Z.resolveRenameLocation(S.URI.revive(K),j,H),void 0,H)}registerNewSymbolNamesProvider(O,K,j){const H=this.t(new le(this.h,j,this.l),O);return this.e.$registerNewSymbolNamesProvider(H,this.o(K,O)),this.p(H)}$provideNewSymbolNames(O,K,j,H){return this.s(O,le,Z=>Z.provideNewSymbolNames(S.URI.revive(K),j,H),void 0,H)}registerDocumentSemanticTokensProvider(O,K,j,H){const Z=this.t(new se(this.h,j),O),oe=typeof j.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(Z,this.o(K,O),H,oe);let Ee=this.p(Z);if(oe){const Be=j.onDidChangeSemanticTokens(We=>this.e.$emitDocumentSemanticTokensEvent(oe));Ee=R.$nL.from(Ee,Be)}return Ee}$provideDocumentSemanticTokens(O,K,j,H){return this.s(O,se,Z=>Z.provideDocumentSemanticTokens(S.URI.revive(K),j,H),null,H)}$releaseDocumentSemanticTokens(O,K){this.s(O,se,j=>j.releaseDocumentSemanticColoring(K),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(O,K,j,H){const Z=this.t(new $e(this.h,j),O);return this.e.$registerDocumentRangeSemanticTokensProvider(Z,this.o(K,O),H),this.p(Z)}$provideDocumentRangeSemanticTokens(O,K,j,H){return this.s(O,$e,Z=>Z.provideDocumentRangeSemanticTokens(S.URI.revive(K),j,H),null,H)}registerCompletionItemProvider(O,K,j,H){const Z=this.t(new te(this.h,this.j.converter,j,this.m,O),O);return this.e.$registerCompletionsProvider(Z,this.o(K,O),H,te.supportsResolving(j),O.identifier),this.p(Z)}$provideCompletionItems(O,K,j,H,Z){return this.s(O,te,oe=>oe.provideCompletionItems(S.URI.revive(K),j,H,Z),void 0,Z)}$resolveCompletionItem(O,K,j){return this.s(O,te,H=>H.resolveCompletionItem(K,j),void 0,j)}$releaseCompletionItems(O,K){this.s(O,te,j=>j.releaseCompletionItems(K),void 0,void 0)}registerInlineCompletionsProvider(O,K,j,H){const Z=new V(O,this.h,j,this.j.converter),oe=this.t(Z,O);return this.e.$registerInlineCompletionsSupport(oe,this.o(K,O),Z.supportsHandleEvents,p.$nm.toKey(O.identifier.value),H?.yieldTo?.map(Ee=>p.$nm.toKey(Ee))||[]),this.p(oe)}$provideInlineCompletions(O,K,j,H,Z){return this.s(O,X,oe=>oe.provideInlineCompletions(S.URI.revive(K),j,H,Z),void 0,Z)}$handleInlineCompletionDidShow(O,K,j,H){this.s(O,X,async Z=>{Z.handleDidShowCompletionItem(K,j,H)},void 0,void 0)}$handleInlineCompletionPartialAccept(O,K,j,H){this.s(O,X,async Z=>{Z.handlePartialAccept(K,j,H)},void 0,void 0)}$freeInlineCompletionsList(O,K){this.s(O,X,async j=>{j.disposeCompletions(K)},void 0,void 0)}registerSignatureHelpProvider(O,K,j,H){const Z=Array.isArray(H)?{triggerCharacters:H,retriggerCharacters:[]}:H,oe=this.t(new Ce(this.h,j),O);return this.e.$registerSignatureHelpProvider(oe,this.o(K,O),Z),this.p(oe)}$provideSignatureHelp(O,K,j,H,Z){return this.s(O,Ce,oe=>oe.provideSignatureHelp(S.URI.revive(K),j,H,Z),void 0,Z)}$releaseSignatureHelp(O,K){this.s(O,Ce,j=>j.releaseSignatureHelp(K),void 0,void 0)}registerInlayHintsProvider(O,K,j){const H=typeof j.onDidChangeInlayHints=="function"?this.q():void 0,Z=this.t(new Te(this.h,this.j.converter,j,this.l,O),O);this.e.$registerInlayHintsProvider(Z,this.o(K,O),typeof j.resolveInlayHint=="function",H,ke.u(O));let oe=this.p(Z);if(H!==void 0){const Ee=j.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(H));oe=R.$nL.from(oe,Ee)}return oe}$provideInlayHints(O,K,j,H){return this.s(O,Te,Z=>Z.provideInlayHints(S.URI.revive(K),j,H),void 0,H)}$resolveInlayHint(O,K,j){return this.s(O,Te,H=>H.resolveInlayHint(K,j),void 0,j)}$releaseInlayHints(O,K){this.s(O,Te,j=>j.releaseHints(K),void 0,void 0)}registerDocumentLinkProvider(O,K,j){const H=this.t(new Pe(this.h,j),O);return this.e.$registerDocumentLinkProvider(H,this.o(K,O),typeof j.resolveDocumentLink=="function"),this.p(H)}$provideDocumentLinks(O,K,j){return this.s(O,Pe,H=>H.provideLinks(S.URI.revive(K),j),void 0,j,K.scheme==="output")}$resolveDocumentLink(O,K,j){return this.s(O,Pe,H=>H.resolveLink(K,j),void 0,void 0,!0)}$releaseDocumentLinks(O,K){this.s(O,Pe,j=>j.releaseLinks(K),void 0,void 0,!0)}registerColorProvider(O,K,j){const H=this.t(new be(this.h,j),O);return this.e.$registerDocumentColorProvider(H,this.o(K,O)),this.p(H)}$provideDocumentColors(O,K,j){return this.s(O,be,H=>H.provideColors(S.URI.revive(K),j),[],j)}$provideColorPresentations(O,K,j,H){return this.s(O,be,Z=>Z.provideColorPresentations(S.URI.revive(K),j,H),void 0,H)}registerFoldingRangeProvider(O,K,j){const H=this.q(),Z=typeof j.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(H,new fe(new ge(this.h,j),O)),this.e.$registerFoldingRangeProvider(H,this.o(K,O),O.identifier,Z);let oe=this.p(H);if(Z!==void 0){const Ee=j.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(Z));oe=R.$nL.from(oe,Ee)}return oe}$provideFoldingRanges(O,K,j,H){return this.s(O,ge,Z=>Z.provideFoldingRanges(S.URI.revive(K),j,H),void 0,H)}registerSelectionRangeProvider(O,K,j){const H=this.t(new G(this.h,j,this.l),O);return this.e.$registerSelectionRangeProvider(H,this.o(K,O)),this.p(H)}$provideSelectionRanges(O,K,j,H){return this.s(O,G,Z=>Z.provideSelectionRanges(S.URI.revive(K),j,H),[],H)}registerCallHierarchyProvider(O,K,j){const H=this.t(new _(this.h,j),O);return this.e.$registerCallHierarchyProvider(H,this.o(K,O)),this.p(H)}$prepareCallHierarchy(O,K,j,H){return this.s(O,_,Z=>Promise.resolve(Z.prepareSession(S.URI.revive(K),j,H)),void 0,H)}$provideCallHierarchyIncomingCalls(O,K,j,H){return this.s(O,_,Z=>Z.provideCallsTo(K,j,H),void 0,H)}$provideCallHierarchyOutgoingCalls(O,K,j,H){return this.s(O,_,Z=>Z.provideCallsFrom(K,j,H),void 0,H)}$releaseCallHierarchy(O,K){this.s(O,_,j=>Promise.resolve(j.releaseSession(K)),void 0,void 0)}registerTypeHierarchyProvider(O,K,j){const H=this.t(new ue(this.h,j),O);return this.e.$registerTypeHierarchyProvider(H,this.o(K,O)),this.p(H)}$prepareTypeHierarchy(O,K,j,H){return this.s(O,ue,Z=>Promise.resolve(Z.prepareSession(S.URI.revive(K),j,H)),void 0,H)}$provideTypeHierarchySupertypes(O,K,j,H){return this.s(O,ue,Z=>Z.provideSupertypes(K,j,H),void 0,H)}$provideTypeHierarchySubtypes(O,K,j,H){return this.s(O,ue,Z=>Z.provideSubtypes(K,j,H),void 0,H)}$releaseTypeHierarchy(O,K){this.s(O,ue,j=>Promise.resolve(j.releaseSession(K)),void 0,void 0)}registerDocumentOnDropEditProvider(O,K,j,H){const Z=this.q();this.f.set(Z,new fe(new de(this.e,this.h,j,Z,O),O));const oe=(0,t.$KF)(O,"dropMetadata")&&H?de.toInternalProviderId(O.identifier.value,H.id):void 0;return this.e.$registerDocumentOnDropEditProvider(Z,this.o(K,O),oe,(0,t.$KF)(O,"dropMetadata")?H:void 0),this.p(Z)}$provideDocumentOnDropEdits(O,K,j,H,Z,oe){return this.s(O,de,Ee=>Promise.resolve(Ee.provideDocumentOnDropEdits(K,S.URI.revive(j),H,Z,oe)),void 0,void 0)}registerMappedEditsProvider(O,K,j){const H=this.t(new Le(this.h,j),O);return this.e.$registerMappedEditsProvider(H,this.o(K,O)),this.p(H)}$provideMappedEdits(O,K,j,H,Z){return this.s(O,Le,oe=>Promise.resolve(oe.provideMappedEdits(K,j,H,Z)),null,Z)}registerDocumentPasteEditProvider(O,K,j,H){const Z=this.q();this.f.set(Z,new fe(new F(this.e,this.h,j,Z,O),O));const oe=F.toInternalProviderId(O.identifier.value,H.id);return this.e.$registerPasteEditProvider(Z,this.o(K,O),oe,{supportsCopy:!!j.prepareDocumentPaste,supportsPaste:!!j.provideDocumentPasteEdits,copyMimeTypes:H.copyMimeTypes,pasteMimeTypes:H.pasteMimeTypes}),this.p(Z)}$prepareDocumentPaste(O,K,j,H,Z){return this.s(O,F,oe=>oe.prepareDocumentPaste(S.URI.revive(K),j,H,Z),void 0,Z)}$providePasteEdits(O,K,j,H,Z,oe){return this.s(O,F,Ee=>Ee.providePasteEdits(K,S.URI.revive(j),H,Z,oe),void 0,oe)}static w(O){return{pattern:O.source,flags:O.flags}}static y(O){return{decreaseIndentPattern:ke.w(O.decreaseIndentPattern),increaseIndentPattern:ke.w(O.increaseIndentPattern),indentNextLinePattern:O.indentNextLinePattern?ke.w(O.indentNextLinePattern):void 0,unIndentedLinePattern:O.unIndentedLinePattern?ke.w(O.unIndentedLinePattern):void 0}}static z(O){return{beforeText:ke.w(O.beforeText),afterText:O.afterText?ke.w(O.afterText):void 0,previousLineText:O.previousLineText?ke.w(O.previousLineText):void 0,action:O.action}}static B(O){return O.map(ke.z)}static C(O){return{open:O.open,close:O.close,notIn:O.notIn?O.notIn.map(K=>R.SyntaxTokenType.toString(K)):void 0}}static D(O){return O.map(ke.C)}setLanguageConfiguration(O,K,j){const{wordPattern:H}=j;if(H&&(0,d.$Ze)(H))throw new Error(`Invalid language configuration: wordPattern '${H}' is not allowed to match the empty string.`);H?this.h.setWordDefinitionFor(K,H):this.h.setWordDefinitionFor(K,void 0),j.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",O,"Do not use."),j.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",O,"Do not use.");const Z=this.q(),oe={comments:j.comments,brackets:j.brackets,wordPattern:j.wordPattern?ke.w(j.wordPattern):void 0,indentationRules:j.indentationRules?ke.y(j.indentationRules):void 0,onEnterRules:j.onEnterRules?ke.B(j.onEnterRules):void 0,__electricCharacterSupport:j.__electricCharacterSupport,__characterPairSupport:j.__characterPairSupport,autoClosingPairs:j.autoClosingPairs?ke.D(j.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(Z,K,oe),this.p(Z)}$setWordDefinitions(O){for(const K of O)this.h.setWordDefinitionFor(K.languageId,new RegExp(K.regexSource,K.regexFlags))}}e.$wgc=ke}),define(Re[258],Ae([1,0,3,8,7,32,11,6,25]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class y{constructor(k,l,$,p){this.c=l,this.d=$,this.e=p,this.b=[],this.f=0,this.g=new Set,this.a=k.getProxy(S.$lL.MainThreadLanguages)}$acceptLanguageIds(k){this.b=k}async getLanguages(){return this.b.slice(0)}async changeLanguage(k,l){await this.a.$changeLanguage(k,l);const $=this.c.getDocumentData(k);if(!$)throw new Error(`document '${k.toString()}' NOT found`);return $.document}async tokenAtPosition(k,l){const $=k.version,p=M.Position.from(l),r=await this.a.$tokensAtPosition(k.uri,p),c={type:I.StandardTokenType.Other,range:k.getWordRangeAtPosition(l)??new I.$pL(l.line,l.character,l.line,l.character)};if(!r)return c;const s={range:M.Range.to(r.range),type:M.TokenType.to(r.type)};return!s.range.contains(l)||$!==k.version?c:s}createLanguageStatusItem(k,l,$){const p=this.f++,r=this.a,c=this.g,s=`${k.identifier.value}/${l}`;if(c.has(s))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);c.add(s);const i={selector:$,id:l,name:k.displayName??k.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let o;const a=new m.$Sc,u=()=>{if(o?.dispose(),!c.has(s)){console.warn(`LanguageStatusItem (${l}) from ${k.identifier.value} has been disposed and CANNOT be updated anymore`);return}o=(0,L.$0g)(()=>{a.clear(),this.a.$setLanguageStatus(p,{id:s,name:i.name??k.displayName??k.name,source:k.displayName??k.name,selector:M.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===I.LanguageStatusSeverity.Error?R.default.Error:i.severity===I.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:i.command&&this.d.toInternal(i.command,a),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){a.dispose(),o?.dispose(),r.$removeLanguageStatus(p),c.delete(s)},get id(){return i.id},get name(){return i.name},set name(f){i.name=f,u()},get selector(){return i.selector},set selector(f){i.selector=f,u()},get text(){return i.text},set text(f){i.text=f,u()},set text2(f){(0,d.$LF)(k,"languageStatusText"),i.text=f,u()},get text2(){return(0,d.$LF)(k,"languageStatusText"),i.text},get detail(){return i.detail},set detail(f){i.detail=f,u()},get severity(){return i.severity},set severity(f){i.severity=f,u()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(f){i.accessibilityInformation=f,u()},get command(){return i.command},set command(f){i.command=f,u()},get busy(){return i.busy},set busy(f){i.busy=f,u()}};return u(),t}}e.$Vhc=y}),define(Re[259],Ae([1,0,12,2,8,7,83]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=void 0;class m{constructor(k,l,$,p){this.start=k,this.deletedCount=l,this.deletedItems=$,this.items=p}asApiEvent(){return{range:new R.$MM(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class d{static asModelAddData(k,l){return{EOL:l.eol,lines:l.source,languageId:l.language,uri:l.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,l,$){this.notebook=k,this.h=l,this.j=$,this.handle=$.handle,this.uri=M.URI.revive($.uri),this.cellKind=$.cellKind,this.a=$.outputs.map(I.NotebookCellOutput.to),this.e=$.internalMetadata??{},this.b=Object.freeze($.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to($.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const $={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return k.g},set mime(p){k.g=p},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze($)}return this.f}setOutputs(k){this.a=k.map(I.NotebookCellOutput.to)}setOutputItems(k,l,$){const p=$.map(I.NotebookCellOutputItem.to),r=this.a.find(c=>c.id===k);if(r&&(l||(r.items.length=0),r.items.push(...p),r.items.length>1&&r.items.every(c=>L.$oJ(c.mime)))){const c=new Map,s=[];r.items.forEach(i=>{let o;c.has(i.mime)?o=c.get(i.mime):(o=[],c.set(i.mime,o),s.push(i.mime)),o.push(i.data)}),r.items.length=0,s.forEach(i=>{const o=L.$pJ(c.get(i));r.items.push({mime:i,data:o.data.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.$Ghc=d;class y{static{this.a=0}constructor(k,l,$,p,r){this.k=k,this.l=l,this.m=$,this.uri=p,this.handle=y.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=r.viewType,this.f=Object.freeze(r.metadata??Object.create(null)),this.r([[0,0,r.cells]],!0,void 0),this.g=r.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const k=this,l={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===S.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt($){return $=k.n($),k.b[$].apiCell},getCells($){return($?k.p($):k.b).map(r=>r.apiCell)},save(){return k.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,l,$){this.g=k.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:$});const p={notebook:this.apiNotebook,metadata:$,cellChanges:[],contentChanges:[]},r=[];for(const s of k.rawEvents)s.kind===L.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,p.contentChanges):s.kind===L.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,p.contentChanges):s.kind===L.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),r.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===L.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===L.NotebookCellsChangeType.ChangeCellContent?r.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===L.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===L.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),r.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===L.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),r.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const c=new Map;for(let s=0;s<r.length;s++){const i=r[s],o=c.get(i.cell);if(o===void 0){const a=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});c.set(i.cell,a-1)}else p.cellChanges[o]={...p.cellChanges[o],...i}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let l=k.start|0,$=k.end|0;return l<0&&(l=0),$>this.b.length&&($=this.b.length),k.with({start:l,end:$})}p(k){k=this.o(k);const l=[];for(let $=k.start;$<k.end;$++)l.push(this.b[$]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,l,$){if(this.j)return;const p=[],r=[],c=[];if(k.reverse().forEach(s=>{const o=s[2].map(t=>{const f=new d(this,this.l,t);return l||r.push(d.asModelAddData(this.apiNotebook,t)),f}),a=new m(s[0],s[1],[],o),u=this.b.splice(s[0],s[1],...o);for(const t of u)c.push(t.uri),a.deletedItems.push(t.apiCell);p.push(a)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:r,removedDocuments:c}),$)for(const s of p)$.push(s.asApiEvent())}s(k,l,$,p){const r=this.b.splice(k,l);this.b.splice($,0,...r);const c=[new m(k,l,r.map(s=>s.apiCell),[]),new m($,0,[],r)];for(const s of c)p.push(s.asApiEvent())}t(k,l){this.b[k].setOutputs(l)}u(k,l,$,p){this.b[k].setOutputItems(l,$,p)}v(k,l){const $=this.b[k];$.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged($.uri,l)}w(k,l){const $=this.b[k];$.apiCell.mime=l}x(k,l){this.b[k].setMetadata(l)}y(k,l){this.b[k].setInternalMetadata(l)}getCellFromApiCell(k){return this.b.find(l=>l.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(l=>l.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.$Hhc=y}),define(Re[260],Ae([1,0,5,2,8,7]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class L{constructor(d,y,A,k={timeout:1500,errors:3}){this.b=d,this.c=y,this.d=A,this.f=k,this.a=new S.$Yd}dispose(){}getOnWillSaveNotebookDocumentEvent(d){return(y,A,k)=>{const l=function(p){y.call(A,p)};return l.extension=d,this.a.event(l,void 0,k)}}async $participateInSave(d,y,A){const k=M.URI.revive(d),l=this.c.getNotebookDocument(k);if(!l)throw new Error("Unable to resolve notebook document");const $=[];if(await this.a.fireAsync({notebook:l.apiNotebook,reason:I.TextDocumentSaveReason.to(y)},A,async(r,c)=>{const s=Date.now(),i=await await Promise.resolve(r);Date.now()-s>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof R.$xL?$.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",c.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if($.length===0)return!0;const p={edits:[]};for(const r of $){const{edits:c}=I.WorkspaceEdit.from(r);p.edits=p.edits.concat(c)}return this.d.$tryApplyWorkspaceEdit(p)}}e.$Xhc=L}),define(Re[109],Ae([1,0,15,8,7]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ihc=void 0;class R{static{this.apiEditorsToExtHost=new WeakMap}constructor(m,d,y,A,k,l){this.id=m,this.f=d,this.notebookData=y,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=A,this.c=l}get apiEditor(){if(!this.e){const m=this;this.e={get notebook(){return m.notebookData.apiNotebook},get selection(){return m.a[0]},set selection(d){this.selections=[d]},get selections(){return m.a},set selections(d){if(!Array.isArray(d)||!d.every(I.$MM.isNotebookRange))throw(0,S.$7)("selections");m.a=d,m.g(d)},get visibleRanges(){return m.b},revealRange(d,y){m.f.$tryRevealRange(m.id,M.NotebookRange.from(d),y??I.NotebookEditorRevealType.Default)},get viewColumn(){return m.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(m){this.d=m}_acceptVisibleRanges(m){this.b=m}_acceptSelections(m){this.a=m}g(m){this.f.$trySetSelections(this.id,m.map(M.NotebookRange.from))}_acceptViewColumn(m){this.c=m}}e.$Ihc=R}),define(Re[261],Ae([1,0,5,13,8]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=void 0;let R=class{constructor(m,d){this.c=m,this.d=d,this.a=new S.$Wd,this.b=new S.$Wd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(m,d){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",m,d);const y=this.d.getEditorById(m);d.visibleRanges&&y._acceptVisibleRanges(d.visibleRanges.ranges.map(I.NotebookRange.to)),d.selections&&y._acceptSelections(d.selections.selections.map(I.NotebookRange.to)),d.visibleRanges&&this.b.fire({notebookEditor:y.apiEditor,visibleRanges:y.apiEditor.visibleRanges}),d.selections&&this.a.fire(Object.freeze({notebookEditor:y.apiEditor,selections:y.apiEditor.selections}))}$acceptEditorViewColumns(m){for(const d in m)this.d.getEditorById(d)._acceptViewColumn(I.ViewColumn.to(m[d]))}};e.$Zhc=R,e.$Zhc=R=Ge([qe(0,M.$pj)],R)}),define(Re[262],Ae([1,0,5,3,109]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3hc=void 0;class R{constructor(m,d){this.c=d,this.a=new Map,this.b=m.getProxy(M.$lL.MainThreadNotebookRenderers)}$postRendererMessage(m,d,y){const A=this.c.getEditorById(m);this.a.get(d)?.fire({editor:A.apiEditor,message:y})}createRendererMessaging(m,d){if(!m.contributes?.notebookRenderer?.some(A=>A.id===d))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${d})`);return{onDidReceiveMessage:(A,k,l)=>this.d(d).event(A,k,l),postMessage:(A,k)=>{I.$Ihc.apiEditorsToExtHost.has(A)&&([A,k]=[k,A]);const l=k&&I.$Ihc.apiEditorsToExtHost.get(k);return this.b.$postMessage(l?.id,d,A)}}}d(m){let d=this.a.get(m);return d||(d=new S.$Wd({onDidRemoveLastListener:()=>{d?.dispose(),this.a.delete(m)}}),this.a.set(m,d),d)}}e.$3hc=R}),define(Re[263],Ae([1,0,8,99,21,67,15]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7hc=void 0;class m{constructor(k){this.b=0,this.c=new Map,this.a=k}async withProgress(k,l,$){const p=this.b++,{title:r,location:c,cancellable:s}=l,i={label:k.displayName||k.name,id:k.identifier.value};return this.a.$startProgress(p,{location:S.ProgressLocation.from(c),title:r,source:i,cancellable:s},k.isUnderDevelopment?void 0:k.identifier.value).catch(L.$2),this.d(p,$,!!s)}d(k,l,$){let p;$&&(p=new I.$7d,this.c.set(k,p));const r=s=>{this.a.$progressEnd(s),this.c.delete(s),p?.dispose()};let c;try{c=l(new y(this.a,k),$&&p?p.token:I.CancellationToken.None)}catch(s){throw r(k),s}return c.then(s=>r(k),s=>r(k)),c}$acceptProgressCanceled(k){const l=this.c.get(k);l&&(l.cancel(),this.c.delete(k))}}e.$7hc=m;function d(A,k){return A.message=k.message,typeof k.increment=="number"&&(typeof A.increment=="number"?A.increment+=k.increment:A.increment=k.increment),A}class y extends M.$xv{constructor(k,l){super($=>this.throttledReport($)),this.c=k,this.d=l}throttledReport(k){this.c.$progressReport(this.d,k)}}Ge([(0,R.$Bh)(100,(A,k)=>d(A,k),()=>Object.create(null))],y.prototype,"throttledReport",null)}),define(Re[264],Ae([1,0,2,3,11,8]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8hc=void 0;class L{static{this.a=0}constructor(d,y){this.d=y,this.c=new Map,this.b=d.getProxy(M.$lL.MainThreadQuickDiff)}$provideOriginalResource(d,y,A){const k=S.URI.revive(y),l=this.c.get(d);return l?(0,I.$Zg)(()=>l.provideOriginalResource(k,A)).then($=>$||null):Promise.resolve(null)}registerQuickDiffProvider(d,y,A,k){const l=L.a++;return this.c.set(l,y),this.b.$registerQuickDiffProvider(l,R.DocumentSelector.from(d,this.d),A,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$8hc=L}),define(Re[265],Ae([1,0,21,5,6,3,2,7,15,18,32,40,25,8]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=void 0;function p(r,c,s){const i=r.getProxy(R.$lL.MainThreadQuickOpen);class o{constructor(b,P){this.e=new Map,this.f=0,this.a=b,this.b=P}showQuickPick(b,P,g,v=S.CancellationToken.None){this.c=void 0;const E=Promise.resolve(P),T=++this.f,N=i.$show(T,{title:g?.title,placeHolder:g?.placeHolder,matchOnDescription:g?.matchOnDescription,matchOnDetail:g?.matchOnDetail,ignoreFocusLost:g?.ignoreFocusOut,canPickMany:g?.canPickMany},v),J={},q=N.then(()=>J);return Promise.race([q,E]).then(U=>{if(U===J)return;const C=(0,l.$KF)(b,"quickPickItemTooltip");return E.then(F=>{const W=[];for(let re=0;re<F.length;re++){const ce=F[re];if(typeof ce=="string")W.push({label:ce,handle:re});else if(ce.kind===m.QuickPickItemKind.Separator)W.push({type:"separator",label:ce.label});else{ce.tooltip&&!C&&console.warn(`Extension '${b.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`);const we=ce.iconPath?n(ce.iconPath):void 0;W.push({label:ce.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:ce.description,detail:ce.detail,picked:ce.picked,alwaysShow:ce.alwaysShow,tooltip:C?$.MarkdownString.fromStrict(ce.tooltip):void 0,handle:re})}}return g&&typeof g.onDidSelectItem=="function"&&(this.c=re=>{g.onDidSelectItem(F[re])}),i.$setItems(T,W),N.then(re=>{if(typeof re=="number")return F[re];if(Array.isArray(re))return re.map(ce=>F[ce])})})}).then(void 0,U=>{if(!(0,d.$4)(U))return i.$setError(T,U),Promise.reject(U)})}$onItemSelected(b){this.c?.(b)}showInput(b,P=S.CancellationToken.None){return this.d=b?.validateInput,i.$input(b,typeof this.d=="function",P).then(void 0,g=>{if(!(0,d.$4)(g))return Promise.reject(g)})}async $validateInput(b){if(!this.d)return;const P=await this.d(b);if(!P||typeof P=="string")return P;let g;switch(P.severity){case m.InputBoxValidationSeverity.Info:g=A.default.Info;break;case m.InputBoxValidationSeverity.Warning:g=A.default.Warning;break;case m.InputBoxValidationSeverity.Error:g=A.default.Error;break;default:g=P.message?A.default.Error:A.default.Ignore;break}return{content:P.message,severity:g}}async showWorkspaceFolderPick(b,P=S.CancellationToken.None){const g=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[b]);if(!g)return;const v=await this.a.getWorkspaceFolders2();if(v)return v.find(E=>E.uri.toString()===g.uri.toString())}createQuickPick(b){const P=new w(b,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}createInputBox(b){const P=new D(b,()=>this.e.delete(P._id));return this.e.set(P._id,P),P}$onDidChangeValue(b,P){this.e.get(b)?._fireDidChangeValue(P)}$onDidAccept(b){this.e.get(b)?._fireDidAccept()}$onDidChangeActive(b,P){const g=this.e.get(b);g instanceof w&&g._fireDidChangeActive(P)}$onDidChangeSelection(b,P){const g=this.e.get(b);g instanceof w&&g._fireDidChangeSelection(P)}$onDidTriggerButton(b,P){this.e.get(b)?._fireDidTriggerButton(P)}$onDidTriggerItemButton(b,P,g){const v=this.e.get(b);v instanceof w&&v._fireDidTriggerItemButton(P,g)}$onDidHide(b){this.e.get(b)?._fireDidHide()}}class a{static{this.a=1}constructor(b,P){this.x=b,this.y=P,this._id=w.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new M.$Wd,this.q=new M.$Wd,this.r=new M.$Wd,this.s=new M.$Wd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(b){this.b=b,this.z({title:b})}get step(){return this.c}set step(b){this.c=b,this.z({step:b})}get totalSteps(){return this.d}set totalSteps(b){this.d=b,this.z({totalSteps:b})}get enabled(){return this.g}set enabled(b){this.g=b,this.z({enabled:b})}get busy(){return this.j}set busy(b){this.j=b,this.z({busy:b})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(b){this.k=b,this.z({ignoreFocusOut:b})}get value(){return this.l}set value(b){this.l=b,this.z({value:b})}get placeholder(){return this.m}set placeholder(b){this.m=b,this.z({placeholder:b})}get buttons(){return this.n}set buttons(b){this.n=b.slice(),this.o.clear(),b.forEach((P,g)=>{const v=P===m.$JM.Back?-1:g;this.o.set(v,P)}),this.z({buttons:b.map((P,g)=>({...n(P.iconPath),tooltip:P.tooltip,handle:P===m.$JM.Back?-1:g}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(b){this.l=b,this.q.fire(b)}_fireDidTriggerButton(b){const P=this.o.get(b);P&&this.r.fire(P)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(b){if(!this.v){for(const P of Object.keys(b)){const g=b[P];this.u[P]=g===void 0?null:g}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function u(h){if(h instanceof m.$iM)return{id:h.id};const b=f(h),P=t(h);return{dark:typeof b=="string"?L.URI.file(b):b,light:typeof P=="string"?L.URI.file(P):P}}function t(h){return typeof h=="object"&&"light"in h?h.light:h}function f(h){return typeof h=="object"&&"dark"in h?h.dark:h}function n(h){const b=u(h);let P,g;return"id"in b?g=k.ThemeIcon.asClassName(b):P=b,{iconPath:P,iconClass:g}}class w extends a{constructor(b,P){super(b.identifier,P),this.O=b,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new M.$Wd,this.L=[],this.M=new M.$Wd,this.N=new M.$Wd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(b){this.B=b.slice(),this.C.clear(),this.D.clear(),b.forEach((v,E)=>{this.C.set(E,v),this.D.set(v,E)});const P=(0,l.$KF)(this.O,"quickPickItemTooltip"),g=[];for(let v=0;v<b.length;v++){const E=b[v];if(E.kind===m.QuickPickItemKind.Separator)g.push({type:"separator",label:E.label});else{E.tooltip&&!P&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const T=E.iconPath?n(E.iconPath):void 0;g.push({handle:v,label:E.label,iconPath:T?.iconPath,iconClass:T?.iconClass,description:E.description,detail:E.detail,picked:E.picked,alwaysShow:E.alwaysShow,tooltip:P?$.MarkdownString.fromStrict(E.tooltip):void 0,buttons:E.buttons?.map((N,J)=>({...n(N.iconPath),tooltip:N.tooltip,handle:J}))})}}this.z({items:g})}get canSelectMany(){return this.E}set canSelectMany(b){this.E=b,this.z({canSelectMany:b})}get matchOnDescription(){return this.F}set matchOnDescription(b){this.F=b,this.z({matchOnDescription:b})}get matchOnDetail(){return this.G}set matchOnDetail(b){this.G=b,this.z({matchOnDetail:b})}get sortByLabel(){return this.H}set sortByLabel(b){this.H=b,this.z({sortByLabel:b})}get keepScrollPosition(){return this.I}set keepScrollPosition(b){this.I=b,this.z({keepScrollPosition:b})}get activeItems(){return this.J}set activeItems(b){this.J=b.filter(P=>this.D.has(P)),this.z({activeItems:this.J.map(P=>this.D.get(P))})}get selectedItems(){return this.L}set selectedItems(b){this.L=b.filter(P=>this.D.has(P)),this.z({selectedItems:this.L.map(P=>this.D.get(P))})}_fireDidChangeActive(b){const P=(0,y.$Hb)(b.map(g=>this.C.get(g)));this.J=P,this.K.fire(P)}_fireDidChangeSelection(b){const P=(0,y.$Hb)(b.map(g=>this.C.get(g)));this.L=P,this.M.fire(P)}_fireDidTriggerItemButton(b,P){const g=this.C.get(b);if(!g||!g.buttons||!g.buttons.length)return;const v=g.buttons[P];v&&this.N.fire({button:v,item:g})}}class D extends a{constructor(b,P){super(b.identifier,P),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(b){this.B=b,this.z({password:b})}get prompt(){return this.C}set prompt(b){this.C=b,this.z({prompt:b})}get valueSelection(){return this.D}set valueSelection(b){this.D=b,this.z({valueSelection:b})}get validationMessage(){return this.E}set validationMessage(b){this.E=b,b?typeof b=="string"?this.z({validationMessage:b,severity:A.default.Error}):this.z({validationMessage:b.message,severity:b.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new o(c,s)}e.$9hc=p}),define(Re[266],Ae([1,0,2,5,67,6,11,3,18,138,13,22,40,8,25,12,20]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=e.$0hc=void 0;function i(T){return T instanceof S.URI}function o(T,N){return T.scheme===r.Schemas.file&&N.scheme===r.Schemas.file&&c.$k?T.toString()===N.toString():T.toString().toLowerCase()===N.toString().toLowerCase()}function a(T){if(T)return typeof T.iconPath=="string"?S.URI.file(T.iconPath):S.URI.isUri(T.iconPath)||l.ThemeIcon.isThemeIcon(T.iconPath)?T.iconPath:void 0}function u(T){if(T.icon){if(S.URI.isUri(T.icon))return T.icon;if(l.ThemeIcon.isThemeIcon(T.icon))return T.icon;{const N=T.icon;return{light:N.light,dark:N.dark}}}else return}function t(T,N){if(!T.iconPath&&!N.iconPath)return 0;if(T.iconPath){if(!N.iconPath)return 1}else return-1;const J=typeof T.iconPath=="string"?T.iconPath:S.URI.isUri(T.iconPath)?T.iconPath.fsPath:T.iconPath.id,q=typeof N.iconPath=="string"?N.iconPath:S.URI.isUri(N.iconPath)?N.iconPath.fsPath:N.iconPath.id;return(0,y.$Uq)(J,q)}function f(T,N){let J=0;if(T.strikeThrough!==N.strikeThrough)return T.strikeThrough?1:-1;if(T.faded!==N.faded)return T.faded?1:-1;if(T.tooltip!==N.tooltip)return(T.tooltip||"").localeCompare(N.tooltip||"");if(J=t(T,N),J!==0)return J;if(T.light&&N.light)J=t(T.light,N.light);else{if(T.light)return 1;if(N.light)return-1}if(J!==0)return J;if(T.dark&&N.dark)J=t(T.dark,N.dark);else{if(T.dark)return 1;if(N.dark)return-1}return J}function n(T,N){if(T.command!==N.command)return T.command<N.command?-1:1;if(T.title!==N.title)return T.title<N.title?-1:1;if(T.tooltip!==N.tooltip){if(T.tooltip!==void 0&&N.tooltip!==void 0)return T.tooltip<N.tooltip?-1:1;if(T.tooltip!==void 0)return 1;if(N.tooltip!==void 0)return-1}if(T.arguments===N.arguments)return 0;if(T.arguments)if(N.arguments){if(T.arguments.length!==N.arguments.length)return T.arguments.length-N.arguments.length}else return 1;else return-1;for(let J=0;J<T.arguments.length;J++){const q=T.arguments[J],U=N.arguments[J];if(q!==U&&!(i(q)&&i(U)&&o(q,U)))return q<U?-1:1}return 0}function w(T,N){let J=(0,y.$Uq)(T.resourceUri.fsPath,N.resourceUri.fsPath,!0);if(J!==0)return J;if(T.command&&N.command)J=n(T.command,N.command);else{if(T.command)return 1;if(N.command)return-1}if(J!==0)return J;if(T.decorations&&N.decorations)J=f(T.decorations,N.decorations);else{if(T.decorations)return 1;if(N.decorations)return-1}if(T.multiFileDiffEditorModifiedUri&&N.multiFileDiffEditorModifiedUri)J=(0,y.$Uq)(T.multiFileDiffEditorModifiedUri.fsPath,N.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(T.multiFileDiffEditorModifiedUri)return 1;if(N.multiFileDiffEditorModifiedUri)return-1}if(T.multiDiffEditorOriginalUri&&N.multiDiffEditorOriginalUri)J=(0,y.$Uq)(T.multiDiffEditorOriginalUri.fsPath,N.multiDiffEditorOriginalUri.fsPath,!0);else{if(T.multiDiffEditorOriginalUri)return 1;if(N.multiDiffEditorOriginalUri)return-1}return J}function D(T,N){for(let J=0;J<T.length;J++)if(T[J]!==N[J])return!1;return!0}function h(T,N){return T.command===N.command&&T.title===N.title&&T.tooltip===N.tooltip&&(T.arguments&&N.arguments?D(T.arguments,N.arguments):T.arguments===N.arguments)}function b(T,N){return(0,d.$ub)(T,N,h)}class P{#e;#t;get value(){return this.d}set value(N){N=N??"",this.#e.$setInputBoxValue(this.l,N),this.n(N)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(N){this.#e.$setInputBoxPlaceholder(this.l,N),this.f=N}get validateInput(){return(0,p.$LF)(this.k,"scmValidation"),this.g}set validateInput(N){if((0,p.$LF)(this.k,"scmValidation"),N&&typeof N!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=N,this.#e.$setValidationProviderIsEnabled(this.l,!!N)}get enabled(){return this.h}set enabled(N){N=!!N,this.h!==N&&(this.h=N,this.#e.$setInputBoxEnablement(this.l,N))}get visible(){return this.j}set visible(N){N=!!N,this.j!==N&&(this.j=N,this.#e.$setInputBoxVisibility(this.l,N))}get document(){return(0,p.$LF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(N,J,q,U,C){this.k=N,this.l=U,this.m=C,this.d="",this.e=new M.$Wd,this.f="",this.h=!0,this.j=!0,this.#t=J,this.#e=q}showValidationMessage(N,J){(0,p.$LF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,N,J)}$onInputBoxValueChange(N){this.n(N)}n(N){this.d=N,this.e.fire(N)}}e.$0hc=P;class g{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(N){this.v=N,this.q.$updateGroupLabel(this.t,this.handle,N)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(N){this.p=N,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(N){this.f=[...N],this.k.fire()}constructor(N,J,q,U,C,F,W){this.q=N,this.s=J,this.t=q,this.u=U,this.v=C,this.multiDiffEditorEnableViewChanges=F,this.w=W,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new M.$Wd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new M.$Wd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=g.d++}getResourceState(N){return this.g.get(N)}$executeResourceCommand(N,J){const q=this.h.get(N);return q?(0,L.$Zg)(()=>this.s.executeCommand(q.command,...q.arguments||[],J)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const N=[...this.f].sort(w),q=(0,d.$Db)(this.o,N,w).map(F=>{const W=F.toInsert.map(re=>{const ce=this.e++;this.g.set(ce,re);const we=re.resourceUri;let De;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const ge=new R.$Sc;De=this.s.converter.toInternal(re.command,ge),this.j.set(ce,ge)}else this.h.set(ce,re.command);const le=(0,p.$KF)(this.w,"scmMultiDiffEditor"),ve=le?re.multiDiffEditorOriginalUri:void 0,se=le?re.multiFileDiffEditorModifiedUri:void 0,$e=a(re.decorations),te=re.decorations&&a(re.decorations.light)||$e,X=re.decorations&&a(re.decorations.dark)||$e,V=[te,X],ie=re.decorations&&re.decorations.tooltip||"",Ce=re.decorations&&!!re.decorations.strikeThrough,Te=re.decorations&&!!re.decorations.faded,Pe=re.contextValue||"";return{rawResource:[ce,we,V,ie,Ce,Te,Pe,De,ve,se],handle:ce}});return{start:F.start,deleteCount:F.deleteCount,toInsert:W}}),U=q.map(({start:F,deleteCount:W,toInsert:re})=>[F,W,re.map(ce=>ce.rawResource)]),C=q.reverse();for(const{start:F,deleteCount:W,toInsert:re}of C){const ce=re.map(De=>De.handle),we=this.n.splice(F,W,...ce);for(const De of we)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=N,U}dispose(){this.l=!0,this.m.fire()}}class v{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(N){this.g!==N&&(this.g=N,this.#e.$updateSourceControl(this.w,{count:N}))}get quickDiffProvider(){return this.h}set quickDiffProvider(N){this.h=N;let J;(0,p.$KF)(this.x,"quickDiffProvider")&&(J=N?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!N,quickDiffLabel:J})}get historyProvider(){return(0,p.$LF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(N){(0,p.$LF)(this.x,"scmHistoryProvider"),this.j=N,this.k.value=new R.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!N}),N&&this.k.value.add(N.onDidChangeCurrentHistoryItemGroup(()=>{this.l=N?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(N){N!==this.m&&(this.m=N,this.#e.$updateSourceControl(this.w,{commitTemplate:N}))}get acceptInputCommand(){return this.o}set acceptInputCommand(N){this.n.value=new R.$Sc,this.o=N;const J=this.y.converter.toInternal(N,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:J})}get actionButton(){return(0,p.$LF)(this.x,"scmActionButton"),this.q}set actionButton(N){(0,p.$LF)(this.x,"scmActionButton"),this.p.value=new R.$Sc,this.q=N;const J=N!==void 0?{command:this.y.converter.toInternal(N.command,this.p.value),secondaryCommands:N.secondaryCommands?.map(q=>q.map(U=>this.y.converter.toInternal(U,this.p.value))),description:N.description,enabled:N.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:J??null})}get statusBarCommands(){return this.t}set statusBarCommands(N){if(this.t&&N&&b(this.t,N))return;this.s.value=new R.$Sc,this.t=N;const J=(N||[]).map(q=>this.y.converter.toInternal(q,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:J})}get selected(){return this.u}constructor(N,J,q,U,C,F,W){this.x=N,this.y=U,this.z=C,this.A=F,this.B=W,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new R.$Uc,this.m=void 0,this.n=new R.$Uc,this.o=void 0,this.p=new R.$Uc,this.s=new R.$Uc,this.t=void 0,this.u=!1,this.v=new M.$Wd,this.onDidChangeSelection=this.v.event,this.w=v.d++,this.C=new Map,this.D=new Set,this.#e=q;const re=S.URI.from({scheme:r.Schemas.vscodeSourceControl,path:`${C}/scm${this.w}/input`,query:W?`rootUri=${encodeURIComponent(W.toString())}`:void 0});this.f=new P(N,J,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,C,F,W,re)}createResourceGroup(N,J,q){const U=(0,p.$KF)(this.x,"scmMultiDiffEditor")&&q?.multiDiffEditorEnableViewChanges===!0,C=new g(this.#e,this.y,this.w,N,J,U,this.x),F=M.Event.once(C.onDidDispose)(()=>this.C.delete(C));return this.C.set(C,F),this.eventuallyAddResourceGroups(),C}eventuallyAddResourceGroups(){const N=[],J=[];for(const[q,U]of this.C){U.dispose();const C=q.onDidUpdateResourceStates(()=>{this.D.add(q),this.eventuallyUpdateResourceStates()});M.Event.once(q.onDidDispose)(()=>{this.D.delete(q),C.dispose(),this.e.delete(q.handle),this.#e.$unregisterGroup(this.w,q.handle)}),N.push([q.handle,q.id,q.label,q.features,q.multiDiffEditorEnableViewChanges]);const F=q._takeResourceStateSnapshot();F.length>0&&J.push([q.handle,F]),this.e.set(q.handle,q)}this.#e.$registerGroups(this.w,N,J),this.C.clear()}eventuallyUpdateResourceStates(){const N=[];this.D.forEach(J=>{const q=J._takeResourceStateSnapshot();q.length!==0&&N.push([J.handle,q])}),N.length>0&&this.#e.$spliceResourceStates(this.w,N),this.D.clear()}getResourceGroup(N){return this.e.get(N)}setSelectionState(N){this.u=N,this.v.fire(N)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(N=>N.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,I.$Ah)(100)],v.prototype,"eventuallyAddResourceGroups",null),Ge([(0,I.$Ah)(100)],v.prototype,"eventuallyUpdateResourceStates",null);let E=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(N,J,q,U){this.l=J,this.m=q,this.n=U,this.g=new Map,this.h=new k.$pm,this.j=new M.$Wd,this.e=N.getProxy(m.$lL.MainThreadSCM),this.f=N.getProxy(m.$lL.MainThreadTelemetry),J.registerArgumentProcessor({processArgument:C=>{if(C&&C.$mid===3){const F=this.g.get(C.sourceControlHandle);if(!F)return C;const W=F.getResourceGroup(C.groupHandle);return W?W.getResourceState(C.handle):C}else if(C&&C.$mid===4){const F=this.g.get(C.sourceControlHandle);return F?F.getResourceGroup(C.groupHandle):C}else if(C&&C.$mid===5){const F=this.g.get(C.handle);return F||C}return C}})}createSourceControl(N,J,q,U){this.n.trace("ExtHostSCM#createSourceControl",N.identifier.value,J,q,U),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:N.identifier.value});const C=s.d++,F=new v(N,this.m,this.e,this.l,J,q,U);this.g.set(C,F);const W=this.h.get(N.identifier)||[];return W.push(F),this.h.set(N.identifier,W),F}getLastInputBox(N){this.n.trace("ExtHostSCM#getLastInputBox",N.identifier.value);const J=this.h.get(N.identifier),q=J&&J[J.length-1];return q&&q.inputBox}$provideOriginalResource(N,J,q){const U=S.URI.revive(J);this.n.trace("ExtHostSCM#$provideOriginalResource",N,U.toString());const C=this.g.get(N);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,L.$Zg)(()=>C.quickDiffProvider.provideOriginalResource(U,q)).then(F=>F||null)}$onInputBoxValueChange(N,J){this.n.trace("ExtHostSCM#$onInputBoxValueChange",N);const q=this.g.get(N);return q&&q.inputBox.$onInputBoxValueChange(J),Promise.resolve(void 0)}$executeResourceCommand(N,J,q,U){this.n.trace("ExtHostSCM#$executeResourceCommand",N,J,q);const C=this.g.get(N);if(!C)return Promise.resolve(void 0);const F=C.getResourceGroup(J);return F?F.$executeResourceCommand(q,U):Promise.resolve(void 0)}$validateInput(N,J,q){this.n.trace("ExtHostSCM#$validateInput",N);const U=this.g.get(N);return!U||!U.inputBox.validateInput?Promise.resolve(void 0):(0,L.$Zg)(()=>U.inputBox.validateInput(J,q)).then(C=>{if(!C)return Promise.resolve(void 0);const F=$.MarkdownString.fromStrict(C.message);return F?Promise.resolve([F,C.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(N){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",N),N!==void 0&&this.g.get(N)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=N,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(N,J,q,U){return await this.g.get(N)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(J,q,U)??void 0}async $provideHistoryItems(N,J,q,U){return(await this.g.get(N)?.historyProvider?.provideHistoryItems(J,q,U))?.map(W=>({...W,icon:u(W)}))??void 0}async $provideHistoryItemSummary(N,J,q,U){const C=this.g.get(N)?.historyProvider;if(typeof C?.provideHistoryItemSummary!="function")return;const F=await C.provideHistoryItemSummary(J,q,U);return F?{...F,icon:u(F)}:void 0}async $provideHistoryItemChanges(N,J,q,U){return await this.g.get(N)?.historyProvider?.provideHistoryItemChanges(J,q,U)??void 0}};e.$$hc=E,e.$$hc=E=s=Ge([qe(3,A.$pj)],E)}),define(Re[267],Ae([1,0,3,8,2]),function(me,e,S,M,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class R{static{this.a=0}constructor(m,d){this.d=d,this.c=new Map,this.b=m.getProxy(S.$lL.MainThreadShare)}async $provideShare(m,d,y){return await this.c.get(m)?.provideShare({selection:M.Range.to(d.selection),resourceUri:I.URI.revive(d.resourceUri)},y)??void 0}registerShareProvider(m,d){const y=R.a++;return this.c.set(y,d),this.b.$registerShareProvider(y,M.DocumentSelector.from(m,this.d),d.id,d.label,d.priority),{dispose:()=>{this.b.$unregisterShareProvider(y),this.c.delete(y)}}}}e.$_hc=R}),define(Re[268],Ae([1,0,7,3,163,6,8,16]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=e.$bic=void 0;class d{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$jM("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$jM("statusBarItem.warningForeground")]])}#e;#t;constructor(l,$,p,r,c,s=S.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new R.$Sc,this.#e=l,this.#t=$,c&&r){this.c=(0,S.$YL)(r.identifier,c);const o=p.get(this.c);o&&(s=o.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,i=o.priority,this.j=!0,this.name=o.name,this.text=o.text,this.tooltip=o.tooltip,this.command=o.command,this.accessibilityInformation=o.accessibilityInformation)}else this.c=String(d.a++);this.e=r,this.f=c,this.g=s,this.h=this.u(i)}u(l){if((0,m.$Nf)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!d.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new R.$Sc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let $;this.m?$=this.m:$=(0,I.localize)(0,null,this.e.displayName||this.e.name);let p=this.n;this.o&&(p=d.b.get(this.o.id));const r=L.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,$,this.k,r,this.r?.internal,p,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$bic=d;class y{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const $={message:l};return this.b.unshift($),this.c(),new S.$nL(()=>{const p=this.b.indexOf($);p>=0&&(this.b.splice(p,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(l,$){this.e=new Map,this.a=l.getProxy(M.$lL.MainThreadStatusBar),this.b=$,this.c=new y(this)}$acceptStaticEntries(l){for(const $ of l)this.e.set($.entryId,$)}createStatusBarEntry(l,$,p,r){return new d(this.a,this.b,this.e,l,$,p,r)}setStatusBarMessage(l,$){const p=this.c.setMessage(l);let r;return typeof $=="number"?r=setTimeout(()=>p.dispose(),$):typeof $<"u"&&$.then(()=>p.dispose(),()=>p.dispose()),new S.$nL(()=>{p.dispose(),clearTimeout(r)})}}e.$cic=A}),define(Re[110],Ae([1,0,29,103,49,75,59,8,2]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LN=e.$KN=e.$JN=e.$IN=void 0;const y=(o,a,u,t)=>{let f=a;return{enumerable:!0,configurable:!1,get(){return f},set(n){if(!u(f,n)){const w=f;f=n,o.listener?.(t(n,w))}}}},A=(o,a)=>o===a,k={range:(o,a)=>o===a?!0:!o||!a?!1:o.isEqual(a),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(o,a)=>!(o.length!==a.length||o.some(u=>!a.find(t=>u.id===t.id)))},l=o=>a=>({op:4,update:o(a)}),$=(o,a)=>({range:(()=>{let u;const t=l(f=>({range:S.$Ws.lift(m.Range.from(f))}));return{enumerable:!0,configurable:!1,get(){return u},set(f){o.listener?.({op:6}),k.range(u,f)||(u=f,o.listener?.(t(f)))}}})(),label:y(o,a,k.label,l(u=>({label:u}))),description:y(o,void 0,k.description,l(u=>({description:u}))),sortText:y(o,void 0,k.sortText,l(u=>({sortText:u}))),canResolveChildren:y(o,!1,k.canResolveChildren,u=>({op:2,state:u})),busy:y(o,!1,k.busy,l(u=>({busy:u}))),error:y(o,void 0,k.error,l(u=>({error:m.MarkdownString.fromStrict(u)||null}))),tags:y(o,[],k.tags,(u,t)=>({op:1,new:u.map(m.TestTag.from),old:t.map(m.TestTag.from)}))}),p=o=>{const a=I.$dK.fromString(o.extId),u=new c(a.controllerId,a.localId,o.label,d.URI.revive(o.uri)||void 0);return u.range=m.Range.to(o.range||void 0),u.description=o.description||void 0,u.sortText=o.sortText||void 0,u.tags=o.tags.map(t=>m.TestTag.to({id:(0,L.$iK)(t).tagId})),u},r=o=>{let a;for(const u of o.tests){const t=p(u.item);(0,M.$sN)(t).parent=a,a=t}return a};e.$IN=r;class c{constructor(a,u,t,f){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const n=(0,M.$rN)(this,a);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:f,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof s?void 0:n.parent}},children:{value:(0,R.$qN)(n,M.$sN,c),enumerable:!0,writable:!1},...$(n,t)})}}e.$JN=c;class s extends c{constructor(a,u){super(a,a,u,void 0),this._isRoot=!0}}e.$KN=s;class i extends R.$mN{constructor(a,u,t){super({controllerId:a,getDocumentVersion:f=>f&&t.getDocument(f)?.version,getApiFor:M.$sN,getChildren:f=>f.children,root:new s(a,u),toITestItem:m.TestItem.from})}}e.$LN=i}),define(Re[31],Ae([1,0,16,7,8,26,3,18,13,52,29,91,2,6,4,17,110,23,50,41,63,57,60,33]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WN=e.$VN=e.$UN=e.$TN=e.$SN=e.$RN=void 0;let n=class{#e;#t;#i;constructor(g,v,E){this.b=new Map,this.c=new Map,this.#e=g.getProxy(L.$lL.MainThreadCommands),this.d=v,this.#i=E,this.#t=g.getProxy(L.$lL.MainThreadTelemetry),this.converter=new w(this,T=>{const N=this.c.get(T);return N?.result===h.Void?N:void 0},v),this.f=[{processArgument(T){return(0,y.$Eh)(T)}},{processArgument(T){return(0,R.$An)(T,function(N){if(A.$Ws.isIRange(N))return I.Range.to(N);if(k.$Vs.isIPosition(N))return I.Position.to(N);if(A.$Ws.isIRange(N.range)&&l.URI.isUri(N.uri))return I.location.to(N);if(N instanceof s.$ke)return N.buffer.buffer;if(!Array.isArray(N))return N})}}]}registerArgumentProcessor(g){this.f.push(g)}registerApiCommand(g){const v=this.registerCommand(!1,g.id,async(...E)=>{const T=g.args.map((J,q)=>{if(!J.validate(E[q]))throw new Error(`Invalid argument '${J.name}' when running '${g.id}', received: ${typeof E[q]=="object"?JSON.stringify(E[q],null,"	"):E[q]} `);return J.convert(E[q])}),N=await this.executeCommand(g.internalId,...T);return g.result.convert(N,E,this.converter)},void 0,{description:g.description,args:g.args,returns:g.result.description});return this.c.set(g.id,g),new M.$nL(()=>{v.dispose(),this.c.delete(g.id)})}registerCommand(g,v,E,T,N,J){if(this.d.trace("ExtHostCommands#registerCommand",v),!v.trim().length)throw new Error("invalid id");if(this.b.has(v))throw new Error(`command '${v}' already exists`);return this.b.set(v,{callback:E,thisArg:T,metadata:N,extension:J}),g&&this.#e.$registerCommand(v),new M.$nL(()=>{this.b.delete(v)&&g&&this.#e.$unregisterCommand(v)})}executeCommand(g,...v){return this.d.trace("ExtHostCommands#executeCommand",g),this.g(g,v,!0)}async g(g,v,E){if(this.b.has(g))return this.#e.$fireCommandActivationEvent(g),this.h(g,v,!1);{let T=!1;const N=(0,R.$An)(v,function(J){if(J instanceof M.$oL)return I.Position.from(J);if(J instanceof M.$pL)return I.Range.from(J);if(J instanceof M.$zL)return I.location.from(J);if(M.$MM.isNotebookRange(J))return I.NotebookRange.from(J);if(J instanceof ArrayBuffer)return T=!0,s.$ke.wrap(new Uint8Array(J));if(J instanceof Uint8Array)return T=!0,s.$ke.wrap(J);if(J instanceof s.$ke)return T=!0,J;if(!Array.isArray(J))return J});try{const J=await this.#e.$executeCommand(g,T?new i.$Vv(N):N,E);return(0,y.$Eh)(J)}catch(J){if(J instanceof Error&&J.message==="$executeCommand:retry")return this.g(g,v,!1);throw J}}}async h(g,v,E){const T=this.b.get(g);if(!T)throw new Error("Unknown command");const{callback:N,thisArg:J,metadata:q}=T;if(q?.args)for(let C=0;C<q.args.length;C++)try{(0,S.$1f)(v[C],q.args[C].constraint)}catch{throw new Error(`Running the contributed command: '${g}' failed. Illegal argument '${q.args[C].name}' - ${q.args[C].description}`)}const U=a.$Sd.create();try{return await N.apply(J,v)}catch(C){if(g===this.converter.delegatingCommandId){const F=this.converter.getActualCommand(...v);F&&(g=F.command)}if(this.d.error(C,g,T.extension?.identifier),!E)throw C;if(T.extension?.identifier){const F=this.#i.onExtensionError(T.extension.identifier,C);this.d.trace("forwarded error to extension?",F,T.extension?.identifier)}throw new class extends Error{constructor(){super((0,o.$Si)(C)),this.id=g,this.source=T.extension?.displayName??T.extension?.name}}}finally{this.j(T,g,U.elapsed())}}j(g,v,E){g.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:g.extension.identifier.value,id:new u.$No(v),duration:E})}$executeContributedCommand(g,...v){this.d.trace("ExtHostCommands#$executeContributedCommand",g);const E=this.b.get(g);return E?(v=v.map(T=>this.f.reduce((N,J)=>J.processArgument(N,E.extension?.identifier),T)),this.h(g,v,!0)):Promise.reject(new Error(`Contributed command '${g}' does not exist.`))}getCommands(g=!1){return this.d.trace("ExtHostCommands#getCommands",g),this.#e.$getCommands().then(v=>(g&&(v=v.filter(E=>E[0]!=="_")),v))}$getContributedCommandMetadata(){const g=Object.create(null);for(const[v,E]of this.b){const{metadata:T}=E;T&&(g[v]=T)}return Promise.resolve(g)}};e.$RN=n,e.$RN=n=Ge([qe(0,r.$wN),qe(1,d.$pj),qe(2,t.$QN)],n),e.$SN=(0,p.$8h)("IExtHostCommands");class w{constructor(g,v,E){this.d=g,this.f=v,this.g=E,this.delegatingCommandId=`__vsc${(0,f.$rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(g,v){if(!g)return;const E={$ident:void 0,id:g.command,title:g.title,tooltip:g.tooltip};if(!g.command)return E;const T=this.f(g.command);if(T)E.id=T.internalId,E.arguments=T.args.map((N,J)=>N.convert(g.arguments&&g.arguments[J]));else if((0,m.$Lb)(g.arguments)){const N=`${g.command} /${++this.c}`;this.b.set(N,g),v.add((0,$.$Rc)(()=>{this.b.delete(N),this.g.trace("CommandsConverter#DISPOSE",N)})),E.$ident=N,E.id=this.delegatingCommandId,E.arguments=[N],this.g.trace("CommandsConverter#CREATE",g.command,N)}return E}fromInternal(g){return typeof g.$ident=="string"?this.b.get(g.$ident):{command:g.id,title:g.title,arguments:g.arguments}}getActualCommand(...g){return this.b.get(g[0])}h(...g){const v=this.getActualCommand(...g);return this.g.trace("CommandsConverter#EXECUTE",g[0],v?v.command:"MISSING"),v?this.d.executeCommand(v.command,...v.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${g[0]}`)}}e.$TN=w;class D{static{this.Uri=new D("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g)}static{this.Position=new D("position","A position in a text document",g=>M.$oL.isPosition(g),I.Position.from)}static{this.Range=new D("range","A range in a text document",g=>M.$pL.isRange(g),I.Range.from)}static{this.Selection=new D("selection","A selection in a text document",g=>M.$qL.isSelection(g),I.Selection.from)}static{this.Number=new D("number","",g=>typeof g=="number",g=>g)}static{this.String=new D("string","",g=>typeof g=="string",g=>g)}static{this.StringArray=D.Arr(D.String)}static Arr(g){return new D(`${g.name}_array`,`Array of ${g.name}, ${g.description}`,v=>Array.isArray(v)&&v.every(E=>g.validate(E)),v=>v.map(E=>g.convert(E)))}static{this.CallHierarchyItem=new D("item","A call hierarchy item",g=>g instanceof M.$KL,I.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new D("item","A type hierarchy item",g=>g instanceof M.$6M,I.TypeHierarchyItem.from)}static{this.TestItem=new D("testItem","A VS Code TestItem",g=>g instanceof c.$JN,I.TestItem.from)}constructor(g,v,E,T){this.name=g,this.description=v,this.validate=E,this.convert=T}optional(){return new D(this.name,`(optional) ${this.description}`,g=>g==null||this.validate(g),g=>g===void 0?void 0:g===null?null:this.convert(g))}with(g,v){return new D(g??this.name,v??this.description,this.validate,this.convert)}}e.$UN=D;class h{static{this.Void=new h("no result",g=>g)}constructor(g,v){this.description=g,this.convert=v}}e.$VN=h;class b{constructor(g,v,E,T,N){this.id=g,this.internalId=v,this.description=E,this.args=T,this.result=N}}e.$WN=b}),define(Re[269],Ae([1,0,18,12,2,86,95,35,31,8,7]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xgc=void 0;const k=[new d.$WN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of DocumentHighlight-instances.",$(y.DocumentHighlight.to))),new d.$WN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[d.$UN.Uri],new d.$VN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,c)=>{if((0,S.$Kb)(r))return;class s extends A.$FL{static to(o){const a=new s(o.name,y.SymbolKind.to(o.kind),o.containerName||"",new A.$zL(c[0],y.Range.to(o.range)));return a.detail=o.detail,a.range=a.location.range,a.selectionRange=y.Range.to(o.selectionRange),a.children=o.children?o.children.map(s.to):[],a}}return r.map(s.to)})),new d.$WN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[d.$UN.Uri,new d.$UN("options","Formatting options",r=>!0,r=>r)],new d.$VN("A promise that resolves to an array of TextEdits.",$(y.TextEdit.to))),new d.$WN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[d.$UN.Uri,d.$UN.Range,new d.$UN("options","Formatting options",r=>!0,r=>r)],new d.$VN("A promise that resolves to an array of TextEdits.",$(y.TextEdit.to))),new d.$WN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[d.$UN.Uri,d.$UN.Position,new d.$UN("ch","Trigger character",r=>typeof r=="string",r=>r),new d.$UN("options","Formatting options",r=>!0,r=>r)],new d.$VN("A promise that resolves to an array of TextEdits.",$(y.TextEdit.to))),new d.$WN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$WN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$WN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$WN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of Location or LocationLink instances.",p)),new d.$WN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of Location-instances.",$(y.location.to))),new d.$WN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of Hover-instances.",$(y.Hover.to))),new d.$WN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[d.$UN.Uri,new d.$UN("position","A position in a text document",r=>Array.isArray(r)&&r.every(c=>A.$oL.isPosition(c)),r=>r.map(y.Position.from))],new d.$VN("A promise that resolves to an array of ranges.",r=>r.map(c=>{let s;for(const i of c.reverse())s=new A.$JL(y.Range.to(i),s);return s}))),new d.$WN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[d.$UN.String.with("query","Search string")],new d.$VN("A promise that resolves to an array of SymbolInformation-instances.",r=>r.map(y.WorkspaceSymbol.to))),new d.$WN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of CallHierarchyItem-instances",r=>r.map(y.CallHierarchyItem.to))),new d.$WN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[d.$UN.CallHierarchyItem],new d.$VN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",r=>r.map(y.CallHierarchyIncomingCall.to))),new d.$WN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[d.$UN.CallHierarchyItem],new d.$VN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",r=>r.map(y.CallHierarchyOutgoingCall.to))),new d.$WN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to a range and placeholder text.",r=>{if(r)return{range:y.Range.to(r.range),placeholder:r.text}})),new d.$WN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[d.$UN.Uri,d.$UN.Position,d.$UN.String.with("newName","The new symbol name")],new d.$VN("A promise that resolves to a WorkspaceEdit.",r=>{if(r){if(r.rejectReason)throw new Error(r.rejectReason);return y.WorkspaceEdit.to(r)}})),new d.$WN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[d.$UN.Uri,d.$UN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new d.$VN("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(y.DocumentLink.to))),new d.$WN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[d.$UN.Uri],new d.$VN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$DM(r.tokenTypes,r.tokenModifiers)})),new d.$WN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[d.$UN.Uri],new d.$VN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,L.$Z$)(r);if(c.type==="full")return new A.$FM(c.data,void 0)})),new d.$WN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[d.$UN.Uri,d.$UN.Range.optional()],new d.$VN("A promise that resolves to SemanticTokensLegend.",r=>{if(r)return new A.$DM(r.tokenTypes,r.tokenModifiers)})),new d.$WN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[d.$UN.Uri,d.$UN.Range],new d.$VN("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const c=(0,L.$Z$)(r);if(c.type==="full")return new A.$FM(c.data,void 0)})),new d.$WN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[d.$UN.Uri,d.$UN.Position,d.$UN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),d.$UN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new d.$VN("A promise that resolves to a CompletionList-instance.",(r,c,s)=>{if(!r)return new A.$VL([]);const i=r.suggestions.map(o=>y.CompletionItem.to(o,s));return new A.$VL(i,r.incomplete)})),new d.$WN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[d.$UN.Uri,d.$UN.Position,d.$UN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new d.$VN("A promise that resolves to SignatureHelp.",r=>{if(r)return y.SignatureHelp.to(r)})),new d.$WN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[d.$UN.Uri,d.$UN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new d.$VN("A promise that resolves to an array of CodeLens-instances.",(r,c,s)=>$(i=>new A.$NL(y.Range.to(i.range),i.command&&s.fromInternal(i.command)))(r))),new d.$WN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[d.$UN.Uri,new d.$UN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>A.$pL.isRange(r),r=>A.$qL.isSelection(r)?y.Selection.from(r):y.Range.from(r)),d.$UN.String.with("kind","Code action kind to return code actions for").optional(),d.$UN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new d.$VN("A promise that resolves to an array of Command-instances.",(r,c,s)=>$(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(i.command)}else{const o=new A.$HL(i.title,i.kind?new A.$IL(i.kind):void 0);return i.edit&&(o.edit=y.WorkspaceEdit.to(i.edit)),i.command&&(o.command=s.fromInternal(i.command)),o.isPreferred=i.isPreferred,o}})(r))),new d.$WN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[d.$UN.Uri],new d.$VN("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(c=>new A.$2L(y.Range.to(c.range),y.Color.to(c.color))):[])),new d.$WN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new d.$UN("color","The color to show and insert",r=>r instanceof A.$1L,y.Color.from),new d.$UN("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:y.Range.from(r.range)}))],new d.$VN("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(y.ColorPresentation.to):[])),new d.$WN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[d.$UN.Uri,d.$UN.Range],new d.$VN("A promise that resolves to an array of Inlay objects",(r,c,s)=>r.map(y.InlayHint.to.bind(void 0,s)))),new d.$WN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[d.$UN.Uri],new d.$VN("A promise that resolves to an array of FoldingRange objects",(r,c)=>{if(r)return r.map(y.FoldingRange.to)})),new d.$WN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new d.$VN("A promise that resolves to an array of NotebookContentProvider static info objects.",$(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(c=>y.NotebookExclusiveDocumentPattern.to(c))})))),new d.$WN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[d.$UN.Uri,d.$UN.Range,new d.$UN("context","An InlineValueContext",r=>r&&typeof r.frameId=="number"&&r.stoppedLocation instanceof A.$pL,r=>y.InlineValueContext.from(r))],new d.$VN("A promise that resolves to an array of InlineValue objects",r=>r.map(y.InlineValue.to))),new d.$WN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new d.$UN("uriOrString","Uri-instance or string (only http/https)",r=>I.URI.isUri(r)||typeof r=="string"&&(0,M.$gg)(r,M.Schemas.http,M.Schemas.https),r=>r),new d.$UN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[y.ViewColumn.from(r),void 0]:[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)])).optional(),d.$UN.String.with("label","").optional()],d.$VN.Void),new d.$WN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[d.$UN.Uri.with("resource","Resource to open"),d.$UN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new d.$UN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[y.ViewColumn.from(r),void 0]:[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)])).optional()],d.$VN.Void),new d.$WN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[d.$UN.Uri.with("left","Left-hand side resource of the diff editor"),d.$UN.Uri.with("right","Right-hand side resource of the diff editor"),d.$UN.String.with("title","Human readable title for the diff editor").optional(),new d.$UN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[y.ViewColumn.from(r.viewColumn),y.TextEditorOpenOptions.from(r)]).optional()],d.$VN.Void),new d.$WN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[d.$UN.String.with("title","Human readable title for the changes editor"),new d.$UN("resourceList","List of resources to compare",r=>{for(const c of r){if(c.length!==3)return!1;const[s,i,o]=c;if(!I.URI.isUri(s)||!I.URI.isUri(i)&&i!==void 0&&i!==null||!I.URI.isUri(o)&&o!==void 0&&o!==null)return!1}return!0},r=>r)],d.$VN.Void),new d.$WN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[d.$UN.Uri,d.$UN.Position],new d.$VN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new d.$WN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[d.$UN.TypeHierarchyItem],new d.$VN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new d.$WN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[d.$UN.TypeHierarchyItem],new d.$VN("A promise that resolves to an array of TypeHierarchyItem-instances",r=>r.map(y.TypeHierarchyItem.to))),new d.$WN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[d.$UN.TestItem],d.$VN.Void),new d.$WN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[d.$UN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],d.$VN.Void),new d.$WN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[d.$UN.String.with("name","The context key name"),new d.$UN("value","The context key value",()=>!0,r=>r)],d.$VN.Void),new d.$WN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[d.$UN.Uri,d.$UN.StringArray,new d.$UN("MappedEditsContext","Mapped Edits Context",r=>y.MappedEditsContext.is(r),r=>y.MappedEditsContext.from(r))],new d.$VN("A promise that resolves to a workspace edit or null",r=>r?y.WorkspaceEdit.to(r):null))];class l{static register(c){k.forEach(c.registerApiCommand,c),this.a(c)}static a(c){c.registerCommand(!1,"_validateWhenClauses",m.$7i)}}e.$xgc=l;function $(r){return c=>{if(Array.isArray(c))return c.map(r)}}function p(r){if(!Array.isArray(r))return;const c=[];for(const s of r)R.$It(s)?c.push(y.DefinitionLink.to(s)):c.push(y.location.to(s));return c}}),define(Re[270],Ae([1,0,6,2,3,8,7,31,11]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fhc=void 0;class y{static{this.a=0}constructor($,p){this.extension=$,this.provider=p,this.handle=y.a++}}class A{constructor($){this.session=$,this.responses=[]}}class k{static{this.a=0}constructor($,p,r,c){this.f=r,this.g=c,this.b=new Map,this.d=new Map,this.e=$.getProxy(I.$lL.MainThreadInlineChat),p.registerApiCommand(new m.$WN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$UN("Run arguments","",s=>!0,s=>{if(s)return{initialRange:s.initialRange?R.Range.from(s.initialRange):void 0,initialSelection:L.$qL.isSelection(s.initialSelection)?R.Selection.from(s.initialSelection):void 0,message:s.message,autoSend:s.autoSend,position:s.position?R.Position.from(s.position):void 0}})],m.$VN.Void))}registerProvider($,p,r){const c=new y($,p);return this.b.set(c.handle,c),this.e.$registerInteractiveEditorProvider(c.handle,r?.label??$.displayName??$.name,$.identifier.value,typeof p.handleInteractiveEditorResponseFeedback=="function",typeof p.provideFollowups=="function",r?.supportReportIssue??!1),(0,S.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(c.handle),this.b.delete(c.handle)})}async $prepareSession($,p,r,c){const s=this.b.get($);if(!s){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(M.URI.revive(p)),o=R.Selection.to(r),a=await s.provider.prepareInteractiveEditorSession({document:i,selection:o},c);if(!a)return;if(a.wholeRange&&!a.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const u=k.a++;return this.d.set(u,new A(a)),{id:u,placeholder:a.placeholder,input:a.input,slashCommands:a.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:R.Range.from(a.wholeRange),message:a.message}}async $provideResponse($,p,r,c){const s=this.b.get($);if(!s)return;const i=this.d.get(p.id);if(!i)return;const o={prompt:r.prompt,selection:R.Selection.to(r.selection),wholeRange:R.Range.to(r.wholeRange),attempt:r.attempt,live:r.live,previewDocument:this.f.getDocument(M.URI.revive(r.previewDocument)),withIntentDetection:r.withIntentDetection};let a=!1;const u={report:async P=>{if(!r.live&&P.edits?.length)throw new Error("Progress reporting is only supported for live sessions");a||c.isCancellationRequested||await this.e.$handleProgressChunk(r.requestId,{message:P.message,edits:P.edits?.map(R.TextEdit.from),editsShouldBeInstant:P.editsShouldBeInstant,slashCommand:P.slashCommand?.command,markdownFragment:L.$OL.isMarkdownString(P.content)?P.content.value:P.content})}},t=Promise.resolve(s.provider.provideInteractiveEditorResponse(i.session,o,u,c));let f;try{f=await(0,d.$Vg)(t,c)}finally{a=!0}if(!f)return;const n=i.responses.push(f)-1,w={wholeRange:R.Range.from(f.wholeRange),placeholder:f.placeholder};if(!k.h(f))return{...w,id:n,type:"editorEdit",message:R.MarkdownString.from(f.contents),edits:[]};const{edits:D,contents:h}=f,b=h!==void 0?R.MarkdownString.from(h):void 0;return D instanceof L.$xL?{...w,id:n,type:"bulkEdit",edits:R.WorkspaceEdit.from(D),message:b}:{...w,id:n,type:"editorEdit",edits:D.map(R.TextEdit.from),message:b}}async $provideFollowups($,p,r,c){const s=this.b.get($),i=this.d.get(p),o=i?.responses[r];if(s&&o&&s.provider.provideFollowups){const a=Promise.resolve(s.provider.provideFollowups(i.session,o,c));return(await(0,d.$Vg)(a,c))?.map(R.ChatFollowup.from)}}$handleFeedback($,p,r,c){const s=this.b.get($),i=this.d.get(p),o=i?.responses[r];if(s&&o){const a=R.InteractiveEditorResponseFeedbackKind.to(c);s.provider.handleInteractiveEditorResponseFeedback?.(i.session,o,a)}}$releaseSession($,p){}static h($){return typeof $=="object"&&typeof $.edits=="object"}}e.$Fhc=k}),define(Re[271],Ae([1,0,2,31]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class I{constructor(L,m,d,y,A){this.a=m,this.b=d,this.c=y;const k=new M.$WN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new M.$UN("showOptions","Show Options",l=>!0,l=>l),new M.$UN("resource","Interactive resource Uri",l=>!0,l=>l),new M.$UN("controllerId","Notebook controller Id",l=>!0,l=>l),new M.$UN("title","Interactive editor title",l=>!0,l=>l)],new M.$VN("Notebook and input URI",l=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const $=this.a.getEditorById(l.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",$.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:$.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(L,m,d,y){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:m,lines:[""],languageId:d,uri:L,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(S.URI.revive(y))?.apiNotebook}]})}$willRemoveInteractiveDocument(L,m){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[L]})}}e.$Shc=I}),define(Re[272],Ae([1,0,18,11,21,5,6,28,2,22,13,3,31,8,7,76,209,25,50,210]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=e.$1hc=void 0;let a=class{constructor(b,P,g,v,E){this.m=P,this.n=g,this.o=v,this.q=E,this.b=new m.$Ac,this.c=new m.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new R.$Wd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=b.getProxy(k.$lL.MainThreadNotebookKernels);const T=new l.$WN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$UN("options","Select kernel options",N=>!0,N=>{if(N&&"notebookEditor"in N&&"id"in N){const J=this.n.getIdByEditor(N.notebookEditor);return{id:N.id,extension:N.extension,notebookEditorId:J}}else if(N&&"notebookEditor"in N){const J=this.n.getIdByEditor(N.notebookEditor);if(J===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${N.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:J}}return N})],l.$VN.Void);this.o.registerApiCommand(T)}createNotebookController(b,P,g,v,E,T){for(const $e of this.j.values())if($e.controller.id===P&&y.$nm.equals(b.identifier,$e.extensionId))throw new Error(`notebook controller with id '${P}' ALREADY exist`);const N=this.k++,J=this;this.q.trace(`NotebookController[${N}], CREATED by ${b.identifier.value}, ${P}`);const q=()=>console.warn(`NO execute handler from notebook controller '${W.id}' of extension: '${b.identifier}'`);let U=!1;const C=new R.$Wd,F=new R.$Wd,W={id:D(b.identifier,P),notebookType:g,extensionId:b.identifier,extensionLocation:b.extensionLocation,label:v||b.identifier.value,preloads:T?T.map($.NotebookRendererScript.from):[]};let re=E??q,ce,we;this.a.$addKernel(N,W).catch($e=>{console.log($e),U=!0});let De=0;const le=()=>{if(U)return;const $e=++De;Promise.resolve().then(()=>{$e===De&&this.a.$updateKernel(N,W)})},ve=new m.$Ac,se={get id(){return P},get notebookType(){return W.notebookType},onDidChangeSelectedNotebooks:C.event,get label(){return W.label},set label($e){W.label=$e??b.displayName??b.name,le()},get detail(){return W.detail??""},set detail($e){W.detail=$e,le()},get description(){return W.description??""},set description($e){W.description=$e,le()},get supportedLanguages(){return W.supportedLanguages},set supportedLanguages($e){W.supportedLanguages=$e,le()},get supportsExecutionOrder(){return W.supportsExecutionOrder??!1},set supportsExecutionOrder($e){W.supportsExecutionOrder=$e,le()},get rendererScripts(){return W.preloads?W.preloads.map($.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler($e){re=$e??q},get interruptHandler(){return ce},set interruptHandler($e){ce=$e,W.supportsInterrupt=!!$e,le()},set variableProvider($e){(0,s.$LF)(b,"notebookVariableProvider"),we=$e,W.hasVariableProvider=!!$e,$e?.onDidChangeVariables(te=>J.a.$variablesUpdated(te.uri)),le()},get variableProvider(){return we},createNotebookCellExecution($e){if(U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.notebook.uri))throw J.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return J._createNotebookCellExecution($e,D(b.identifier,this.id))},createNotebookExecution($e){if((0,s.$LF)(b,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!ve.has($e.uri))throw J.q.trace(`NotebookController[${N}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ve.keys()).map(te=>te.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return J._createNotebookExecution($e,D(b.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${N}], DISPOSED`),U=!0,this.j.delete(N),C.dispose(),F.dispose(),this.a.$removeKernel(N))},updateNotebookAffinity($e,te){te===p.NotebookControllerAffinity2.Hidden&&(0,s.$LF)(b,"notebookControllerAffinityHidden"),J.a.$updateNotebookPriority(N,$e.uri,te)},onDidReceiveMessage:F.event,postMessage($e,te){return(0,s.$LF)(b,"notebookMessaging"),J.a.$postMessage(N,te&&J.n.getIdByEditor(te),$e)},asWebviewUri($e){return(0,s.$LF)(b,"notebookMessaging"),(0,r.$Cwb)($e,J.m.remote)}};return this.j.set(N,{extensionId:b.identifier,controller:se,onDidReceiveMessage:F,onDidChangeSelection:C,associatedNotebooks:ve}),se}getIdByController(b){for(const[P,g]of this.j)if(g.controller===b)return D(g.extensionId,b.id);return null}createNotebookControllerDetectionTask(b,P){const g=this.g++,v=this;this.q.trace(`NotebookControllerDetectionTask[${g}], CREATED by ${b.identifier.value}`),this.a.$addKernelDetectionTask(g,P);const E={dispose:()=>{this.f.delete(g),v.a.$removeKernelDetectionTask(g)}};return this.f.set(g,E),E}registerKernelSourceActionProvider(b,P,g){const v=this.i++,E=typeof g.onDidChangeNotebookKernelSourceActions=="function"?v:void 0,T=this;this.h.set(v,g),this.q.trace(`NotebookKernelSourceActionProvider[${v}], CREATED by ${b.identifier.value}`),this.a.$addKernelSourceActionProvider(v,v,P);let N;return E!==void 0&&(N=g.onDidChangeNotebookKernelSourceActions(J=>this.a.$emitNotebookKernelSourceActionsChangeEvent(E))),{dispose:()=>{this.h.delete(v),T.a.$removeKernelSourceActionProvider(v,v),N?.dispose()}}}async $provideKernelSourceActions(b,P){const g=this.h.get(b);if(g){const v=new L.$Sc;return(await g.provideNotebookKernelSourceActions(P)??[]).map(T=>$.NotebookKernelSourceAction.from(T,this.o.converter,v))}return[]}$acceptNotebookAssociation(b,P,g){const v=this.j.get(b);if(v){const E=this.n.getNotebookDocument(d.URI.revive(P));g?v.associatedNotebooks.set(E.uri,!0):v.associatedNotebooks.delete(E.uri),this.q.trace(`NotebookController[${b}] ASSOCIATE notebook`,E.uri.toString(),g),v.onDidChangeSelection.fire({selected:g,notebook:E.apiNotebook})}}async $executeCells(b,P,g){const v=this.j.get(b);if(!v)return;const E=this.n.getNotebookDocument(d.URI.revive(P)),T=[];for(const N of g){const J=E.getCell(N);J&&T.push(J.apiCell)}try{this.q.trace(`NotebookController[${b}] EXECUTE cells`,E.uri.toString(),T.length),await v.controller.executeHandler.call(v.controller,T,E.apiNotebook,v.controller)}catch(N){this.q.error(`NotebookController[${b}] execute cells FAILED`,N),console.error(N)}}async $cancelCells(b,P,g){const v=this.j.get(b);if(!v)return;const E=this.n.getNotebookDocument(d.URI.revive(P));if(v.controller.interruptHandler)await v.controller.interruptHandler.call(v.controller,E.apiNotebook);else for(const T of g){const N=E.getCell(T);N&&this.b.get(N.uri)?.cancel()}if(v.controller.interruptHandler){const T=this.c.get(E.uri);g.length&&Array.isArray(T)&&T.length&&T.forEach(N=>N.dispose())}}async $provideVariables(b,P,g,v,E,T,N){const J=this.j.get(b);if(!J)return;const q=this.n.getNotebookDocument(d.URI.revive(g)),U=J.controller.variableProvider;if(!U)return;let C;if(v!==void 0){if(C=this.s[v],!C)return}else this.s={};const F=E==="named"?p.NotebookVariablesRequestKind.Named:p.NotebookVariablesRequestKind.Indexed,W=U.provideVariables(q.apiNotebook,C,F,T,N);let re=0;for await(const ce of W){if(N.isCancellationRequested)return;const we={id:this.r++,name:ce.variable.name,value:ce.variable.value,type:ce.variable.type,hasNamedChildren:ce.hasNamedChildren,indexedChildrenCount:ce.indexedChildrenCount};if(this.s[we.id]=ce.variable,this.a.$receiveVariable(P,we),re++>=o.$Nfb)return}}$acceptKernelMessageFromRenderer(b,P,g){const v=this.j.get(b);if(!v)return;const E=this.n.getEditorById(P);v.onDidReceiveMessage.fire(Object.freeze({editor:E.apiEditor,message:g}))}$cellExecutionChanged(b,P,g){const E=this.n.getNotebookDocument(d.URI.revive(b)).getCell(P);if(E){const T=g?$.NotebookCellExecutionState.to(g):p.NotebookCellExecutionState.Idle;T!==void 0&&this.l.fire({cell:E.apiCell,state:T})}}_createNotebookCellExecution(b,P){if(b.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const v=this.n.getNotebookDocument(b.notebook.uri).getCellFromApiCell(b);if(!v)throw new Error("invalid cell");if(this.b.has(v.uri))throw new Error(`duplicate execution for ${v.uri}`);const E=new t(P,v,this.a);this.b.set(v.uri,E);const T=E.onDidChangeState(()=>{E.state===u.Resolved&&(E.dispose(),T.dispose(),this.b.delete(v.uri))});return E.asApiObject()}_createNotebookExecution(b,P){const g=this.n.getNotebookDocument(b.uri),v=b.getCells().find(N=>{const J=g.getCellFromApiCell(N);return J&&this.b.has(J.uri)});if(v)throw new Error(`duplicate cell execution for ${v.document.uri}`);if(this.c.has(g.uri))throw new Error(`duplicate notebook execution for ${g.uri}`);const E=new n(P,g,this.a),T=E.onDidChangeState(()=>{E.state===f.Resolved&&(E.dispose(),T.dispose(),this.c.delete(g.uri))});return this.c.set(g.uri,[E,T]),E.asApiObject()}};e.$1hc=a,e.$1hc=a=Ge([qe(4,A.$pj)],a);var u;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(u||(u={}));class t extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(b,P,g){super(),this.m=P,this.n=g,this.b=t.a++,this.c=new R.$Wd,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new I.$7d),this.h=new w(10,v=>this.s(v)),this.j=P.internalMetadata.executionOrder,this.n.$createExecution(this.b,b,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(b){await this.h.addItem(b)}async s(b){const P=Array.isArray(b)?b:[b];return this.n.$updateExecution(this.b,new i.$Vv(P))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(b){let P=this.m;if(b&&(P=this.m.notebook.getCellFromApiCell(b)),!P)throw new Error("INVALID cell");return P.handle}y(b){return b.map(P=>{const g=p.$QM.ensureUniqueMimeTypes(P.items,!0);return g===P.items?$.NotebookCellOutput.from(P):$.NotebookCellOutput.from({items:g,id:P.id,metadata:P.metadata})})}async z(b,P,g){const v=this.w(P),E=this.y((0,S.$3b)(b));return this.r({editType:c.CellExecutionUpdateType.Output,cellHandle:v,append:g,outputs:E})}async C(b,P,g){return b=p.$QM.ensureUniqueMimeTypes((0,S.$3b)(b),!0),this.r({editType:c.CellExecutionUpdateType.OutputItems,items:b.map($.NotebookCellOutputItem.from),outputId:P.id,append:g})}asApiObject(){const b=this;return Object.freeze({get token(){return b.g.token},get cell(){return b.m.apiCell},get executionOrder(){return b.j},set executionOrder(g){b.j=g,b.s([{editType:c.CellExecutionUpdateType.ExecutionState,executionOrder:b.j}])},start(g){if(b.f===u.Resolved||b.f===u.Started)throw new Error("Cannot call start again");b.f=u.Started,b.c.fire(),b.s({editType:c.CellExecutionUpdateType.ExecutionState,runStartTime:g})},end(g,v){if(b.f===u.Resolved)throw new Error("Cannot call resolve twice");b.f=u.Resolved,b.c.fire(),b.h.flush(),b.n.$completeExecution(b.b,new i.$Vv({runEndTime:v,lastRunSuccess:g}))},clearOutput(g){return b.t(),b.z([],g,!1)},appendOutput(g,v){return b.t(),b.z(g,v,!0)},replaceOutput(g,v){return b.t(),b.z(g,v,!1)},appendOutputItems(g,v){return b.t(),b.C(g,v,!0)},replaceOutputItems(g,v){return b.t(),b.C(g,v,!1)}})}}var f;(function(h){h[h.Init=0]="Init",h[h.Started=1]="Started",h[h.Resolved=2]="Resolved"})(f||(f={}));class n extends L.$Tc{static{this.a=0}get state(){return this.f}constructor(b,P,g){super(),this.h=P,this.j=g,this.b=n.a++,this.c=new R.$Wd,this.onDidChangeState=this.c.event,this.f=f.Init,this.g=this.B(new I.$7d),this.j.$createNotebookExecution(this.b,b,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===f.Resolved||this.f===f.Started)throw new Error("Cannot call start again");this.f=f.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===f.Resolved)throw new Error("Cannot call resolve twice");this.f=f.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class w{constructor(b,P){this.f=b,this.g=P,this.a=[],this.b=Date.now()}addItem(b){return this.a.push(b),this.c||(this.c=new M.$sh,this.b=Date.now(),(0,M.$9g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const b=this.c;this.c=void 0;const P=this.a;return this.a=[],this.g(P).finally(()=>b.complete())}}function D(h,b){return`${h.value}/${b}`}e.$2hc=D}),define(Re[65],Ae([1,0,5,3,4,2,17,6,7,165,15,193,21,33,194,40,11,8,31]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=e.$bhc=e.$ahc=void 0,e.$ahc=(0,I.$8h)("IExtHostTerminalService");class o{constructor(g,v,E,T){this.l=g,this._id=v,this.m=E,this.n=T,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(J=>this.f=J);const N=this;this.value={get name(){return N.n||""},get processId(){return N.b},get creationOptions(){return N.m},get exitStatus(){return N.h},get state(){return N.j},get selection(){return N.k},sendText(J,q=!0){N.q(),N.l.$sendText(N._id,J,q)},show(J){N.q(),N.l.$show(N._id,J)},hide(){N.q(),N.l.$hide(N._id)},dispose(){N.a||(N.a=!0,N.l.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(g,v){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:g.name,shellPath:g.shellPath??void 0,shellArgs:g.shellArgs??void 0,cwd:g.cwd??v?.cwd??void 0,env:g.env??void 0,icon:D(g.iconPath)??void 0,color:r.ThemeColor.isThemeColor(g.color)?g.color.id:void 0,initialText:g.message??void 0,strictEnv:g.strictEnv??void 0,hideFromUser:g.hideFromUser??void 0,isFeatureTerminal:v?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:v?.useShellEnvironment??void 0,location:v?.location||this.o(g.location,v?.resolvedExtHostIdentifier),isTransient:g.isTransient??void 0})}async createExtensionTerminal(g,v,E,T,N){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:T,color:r.ThemeColor.isThemeColor(N)?N.id:void 0,location:v?.location||this.o(g,E),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(g,v){return typeof g=="object"?"parentTerminal"in g&&g.parentTerminal&&v?{parentTerminal:v}:"viewColumn"in g?{viewColumn:s.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus}:void 0:g}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(g){this.n=g}setExitStatus(g,v){this.h=Object.freeze({code:g,reason:v})}setDimensions(g,v){return g===this.d&&v===this.g||g===0||v===0?!1:(this.d=g,this.g=v,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(g){this.k=g}_setProcessId(g){this.f?(this.f(g),this.f=void 0):this.b.then(v=>{v!==g&&(this.b=Promise.resolve(g))})}}e.$bhc=o;class a{get onProcessReady(){return this.b.event}constructor(g){this.g=g,this.id=0,this.shouldPersist=!1,this.a=new S.$Wd,this.onProcessData=this.a.event,this.b=new S.$Wd,this.d=new S.$Wd,this.onDidChangeProperty=this.d.event,this.f=new S.$Wd,this.onProcessExit=this.f.event}refreshProperty(g){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${g}`)}updateProperty(g,v){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${g}, value: ${v}`)}async start(){}shutdown(){this.g.close()}input(g){this.g.handleInput?.(g)}resize(g,v){this.g.setDimensions?.({columns:g,rows:v})}clearBuffer(){}async processBinary(g){}acknowledgeDataEvent(g){}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(g){this.g.onDidWrite(v=>this.a.fire(v)),this.g.onDidClose?.((v=void 0)=>{this.f.fire(v===void 0?void 0:v)}),this.g.onDidOverrideDimensions?.(v=>{v&&this.d.fire({type:"overrideDimensions",value:{cols:v.columns,rows:v.rows}})}),this.g.onDidChangeName?.(v=>{this.d.fire({type:"title",value:v})}),this.g.open(g||void 0),g&&this.g.setDimensions?.(g),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,t=class extends m.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(g=>g.value)}constructor(g,v,E){super(),this.Q=v,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new m.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$Wd,this.onDidCloseTerminal=this.H.event,this.I=new S.$Wd,this.onDidOpenTerminal=this.I.event,this.J=new S.$Wd,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$Wd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$Wd,this.onDidChangeTerminalState=this.M.event,this.N=new S.$Wd,this.onDidChangeShell=this.N.event,this.O=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$Wd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=E.getProxy(M.$lL.MainThreadTerminalService),this.y=new p.$Msb(this.a.$sendProcessData),this.a.$registerProcessSupport(g),this.Q.registerArgumentProcessor({processArgument:T=>{const N=J=>{const q=J;return this.W(q.instanceId)?.value};switch(T?.$mid){case 15:return N(T);default:{if(Array.isArray(T))for(let J=0;J<T.length&&T[J].$mid===15;J++)T[J]=N(T[J]);return T}}}}),this.B({dispose:()=>{for(const[T,N]of this.g)N.shutdown(!0)}})}getDefaultShell(g){return(g?this.u:this.s)?.path||""}getDefaultShellArgs(g){return(g?this.u:this.s)?.args||[]}createExtensionTerminal(g,v){const E=new o(this.a,(0,$.$rg)(),g,g.name),T=new a(g.pty);return E.createExtensionTerminal(g.location,v,this.R(g,v).resolvedExtHostIdentifier,D(g.iconPath),h(g.color)).then(N=>{const J=this.S(N,T);this.h[N]=J}),this.f.push(E),E.value}R(g,v){if(v=v||{},g.location&&typeof g.location=="object"&&"parentTerminal"in g.location){const E=g.location.parentTerminal;if(E){const T=this.f.find(N=>N.value===E);T&&(v.resolvedExtHostIdentifier=T._id)}}else g.location&&typeof g.location!="object"?v.location=g.location:v.location&&typeof v.location=="object"&&"splitActiveTerminal"in v.location&&(v.location={splitActiveTerminal:!0});return v}attachPtyToTerminal(g,v){if(!this.W(g))throw new Error(`Cannot resolve terminal with id ${g} for virtual process`);const T=new a(v),N=this.S(g,T);this.h[g]=N}async $acceptActiveTerminalChanged(g){const v=this.b;if(g===null){this.b=void 0,v!==this.b&&this.J.fire(this.b);return}const E=this.W(g);E&&(this.b=E,v!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(g,v){const E=this.W(g);E&&this.O.fire({terminal:E.value,data:v})}async $acceptTerminalDimensions(g,v,E){const T=this.W(g);T&&T.setDimensions(v,E)&&this.L.fire({terminal:T.value,dimensions:T.value.dimensions})}async $acceptDidExecuteCommand(g,v){const E=this.W(g);E&&this.P.fire({terminal:E.value,...v})}async $acceptTerminalMaximumDimensions(g,v,E){this.g.get(g)?.resize(v,E)}async $acceptTerminalTitleChange(g,v){const E=this.W(g);E&&(E.name=v)}async $acceptTerminalClosed(g,v,E){const T=this.Y(this.f,g);if(T!==null){const N=this.f.splice(T,1)[0];N.setExitStatus(v,E),this.H.fire(N.value)}}$acceptTerminalOpened(g,v,E,T){if(v){const q=this.Y(this.f,v);if(q!==null){this.f[q]._id=g,this.I.fire(this.terminals[q]),this.f[q].isOpen=!0;return}}const N={name:T.name,shellPath:T.executable,shellArgs:T.args,cwd:typeof T.cwd=="string"?T.cwd:R.URI.revive(T.cwd),env:T.env,hideFromUser:T.hideFromUser},J=new o(this.a,g,N,E);this.f.push(J),this.I.fire(J.value),J.isOpen=!0}async $acceptTerminalProcessId(g,v){this.W(g)?._setProcessId(v)}async $startExtensionTerminal(g,v){const E=this.W(g);if(!E)return{message:(0,y.localize)(0,null,g)};E.isOpen||await new Promise(N=>{const J=this.onDidOpenTerminal(async q=>{q===E.value&&(J.dispose(),N())})});const T=this.g.get(g);T?T.startSendingEvents(v):this.j[g]={initialDimensions:v}}S(g,v){const E=new m.$Sc;E.add(v.onProcessReady(N=>this.a.$sendProcessReady(g,N.pid,N.cwd,N.windowsPty))),E.add(v.onDidChangeProperty(N=>this.a.$sendProcessProperty(g,N))),this.y.startBuffering(g,v.onProcessData),E.add(v.onProcessExit(N=>this.U(g,N))),this.g.set(g,v);const T=this.j[g];return T&&v instanceof a&&(v.startSendingEvents(T.initialDimensions),delete this.j[g]),E}$acceptProcessAckDataEvent(g,v){this.g.get(g)?.acknowledgeDataEvent(v)}$acceptProcessInput(g,v){this.g.get(g)?.input(v)}$acceptTerminalInteraction(g){const v=this.W(g);v?.setInteractedWith()&&this.M.fire(v.value)}$acceptTerminalSelection(g,v){this.W(g)?.setSelection(v)}$acceptProcessResize(g,v,E){try{this.g.get(g)?.resize(v,E)}catch(T){if(T.code!=="EPIPE"&&T.code!=="ERR_IPC_CHANNEL_CLOSED")throw T}}$acceptProcessShutdown(g,v){this.g.get(g)?.shutdown(v)}$acceptProcessRequestInitialCwd(g){this.g.get(g)?.getInitialCwd().then(v=>this.a.$sendProcessProperty(g,{type:"initialCwd",value:v}))}$acceptProcessRequestCwd(g){this.g.get(g)?.getCwd().then(v=>this.a.$sendProcessProperty(g,{type:"cwd",value:v}))}$acceptProcessRequestLatency(g){return Promise.resolve(g)}registerLinkProvider(g){return this.z.add(g),this.z.size===1&&this.a.$startLinkProvider(),new d.$nL(()=>{this.z.delete(g),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(g,v,E){if(this.C.has(v))throw new Error(`Terminal profile provider "${v}" already registered`);return this.C.set(v,E),this.a.$registerProfileProvider(v,g.identifier.value),new d.$nL(()=>{this.C.delete(v),this.a.$unregisterProfileProvider(v)})}registerTerminalQuickFixProvider(g,v,E){if(this.D.has(g))throw new Error(`Terminal quick fix provider "${g}" is already registered`);return this.D.set(g,E),this.a.$registerQuickFixProvider(g,v),new d.$nL(()=>{this.D.delete(g),this.a.$unregisterQuickFixProvider(g)})}async $provideTerminalQuickFixes(g,v){const E=new l.$7d().token;if(E.isCancellationRequested)return;const T=this.D.get(g);if(!T)return;const N=await T.provideTerminalQuickFixes(v,E);if(N===null||Array.isArray(N)&&N.length===0)return;const J=new m.$Sc;if(this.w.value=J,!Array.isArray(N))return N?s.TerminalQuickFix.from(N,this.Q.converter,J):void 0;const q=[];for(const U of N){const C=s.TerminalQuickFix.from(U,this.Q.converter,J);C&&q.push(C)}return q}async $createContributedProfileTerminal(g,v){const E=new l.$7d().token;let T=await this.C.get(g)?.provideTerminalProfile(E);if(!E.isCancellationRequested){if(T&&!("options"in T)&&(T={options:T}),!T||!("options"in T))throw new Error(`No terminal profile options provided for id "${g}"`);if("pty"in T.options){this.createExtensionTerminal(T.options,v);return}this.createTerminalFromOptions(T.options,v)}}async $provideLinks(g,v){const E=this.W(g);if(!E)return[];this.F.delete(g),this.G.get(g)?.dispose(!0);const N=new l.$7d;this.G.set(g,N);const J=[],q={terminal:E.value,line:v},U=[];for(const W of this.z)U.push(c.Promises.withAsyncBody(async re=>{N.token.onCancellationRequested(()=>re({provider:W,links:[]}));const ce=await W.provideTerminalLinks(q,N.token)||[];N.token.isCancellationRequested||re({provider:W,links:ce})}));const C=await Promise.all(U);if(N.token.isCancellationRequested)return[];const F=new Map;for(const W of C)W&&W.links.length>0&&J.push(...W.links.map(re=>{const ce={id:u++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return F.set(ce.id,{provider:W.provider,link:re}),ce}));return this.F.set(g,F),J}$activateLink(g,v){const E=this.F.get(g)?.get(v);E&&E.provider.handleTerminalLink(E.link)}U(g,v){this.y.stopBuffering(g),this.g.delete(g),delete this.j[g];const E=this.h[g];E&&(E.dispose(),delete this.h[g]),this.a.$sendProcessExit(g,v)}W(g){return this.X(this.f,g)}X(g,v){const E=this.Y(g,v);return E!==null?g[E]:null}Y(g,v){const E=g.findIndex(T=>T._id===v);return E===-1?null:E}getEnvironmentVariableCollection(g){let v=this.n.get(g.identifier.value);return v||(v=new f,this.$(g.identifier.value,v)),v.getScopedEnvironmentVariableCollection(void 0)}Z(g,v){const E=(0,k.$Or)(v.map),T=(0,k.$Pr)(v.descriptionMap);this.a.$setEnvironmentVariableCollection(g,v.persistent,E.length===0?void 0:E,T)}$initEnvironmentVariableCollections(g){g.forEach(v=>{const E=v[0],T=new f(v[1]);this.$(E,T)})}$acceptDefaultProfile(g,v){const E=this.s;this.s=g,this.u=v,E?.path!==g.path&&this.N.fire(g.path)}$(g,v){this.n.set(g,v),v.onDidChangeCollection(()=>{this.Z(g,v)})}};e.$chc=t,e.$chc=t=Ge([qe(1,i.$SN),qe(2,L.$wN)],t);class f{get persistent(){return this.b}set persistent(g){this.b=g,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(g){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$Wd,this.map=new Map(g)}getScopedEnvironmentVariableCollection(g){const v=this.h(g);let E=this.a.get(v);return E||(E=new n(this,g),this.a.set(v,E),E.onDidChangeCollection(()=>this.d.fire())),E}replace(g,v,E,T){this.f(g,{value:v,type:d.EnvironmentVariableMutatorType.Replace,options:E??{applyAtProcessCreation:!0},scope:T})}append(g,v,E,T){this.f(g,{value:v,type:d.EnvironmentVariableMutatorType.Append,options:E??{applyAtProcessCreation:!0},scope:T})}prepend(g,v,E,T){this.f(g,{value:v,type:d.EnvironmentVariableMutatorType.Prepend,options:E??{applyAtProcessCreation:!0},scope:T})}f(g,v){if(v.options&&v.options.applyAtProcessCreation===!1&&!v.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const E=this.g(g,v.scope),T=this.map.get(E),N=v.options?{applyAtProcessCreation:v.options.applyAtProcessCreation??!1,applyAtShellIntegration:v.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!T||T.value!==v.value||T.type!==v.type||T.options?.applyAtProcessCreation!==N.applyAtProcessCreation||T.options?.applyAtShellIntegration!==N.applyAtShellIntegration||T.scope?.workspaceFolder?.index!==v.scope?.workspaceFolder?.index){const J=this.g(g,v.scope),q={variable:g,...v,options:N};this.map.set(J,q),this.d.fire()}}get(g,v){const E=this.g(g,v),T=this.map.get(E);return T?b(T):void 0}g(g,v){const E=this.h(v);return E.length?`${g}:::${E}`:g}h(g){return this.j(g?.workspaceFolder)??""}j(g){return g?g.uri.toString():void 0}getVariableMap(g){const v=new Map;for(const[E,T]of this.map)this.h(T.scope)===this.h(g)&&v.set(T.variable,b(T));return v}delete(g,v){const E=this.g(g,v);this.map.delete(E),this.d.fire()}clear(g){if(g?.workspaceFolder){for(const[v,E]of this.map)E.scope?.workspaceFolder?.index===g.workspaceFolder.index&&this.map.delete(v);this.k(g)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(g,v){const E=this.h(v),T=this.descriptionMap.get(E);if(!T||T.description!==g){let N;typeof g=="string"?N=g:N=g?.value.split(`

`)[0];const J={description:N,scope:v};this.descriptionMap.set(E,J),this.d.fire()}}getDescription(g){const v=this.h(g);return this.descriptionMap.get(v)?.description}k(g){const v=this.h(g);this.descriptionMap.delete(v)}}class n{get persistent(){return this.b.persistent}set persistent(g){this.b.persistent=g}get onDidChangeCollection(){return this.a&&this.a.event}constructor(g,v){this.b=g,this.d=v,this.a=new S.$Wd}getScoped(g){return this.b.getScopedEnvironmentVariableCollection(g)}replace(g,v,E){this.b.replace(g,v,E,this.d)}append(g,v,E){this.b.append(g,v,E,this.d)}prepend(g,v,E){this.b.prepend(g,v,E,this.d)}get(g){return this.b.get(g,this.d)}forEach(g,v){this.b.getVariableMap(this.d).forEach((E,T)=>g.call(v,T,E,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(g){this.b.delete(g,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(g){this.b.setDescription(g,this.d)}get description(){return this.b.getDescription(this.d)}}let w=class extends t{constructor(g,v){super(!1,g,v)}createTerminal(g,v,E){throw new A.$_}createTerminalFromOptions(g,v){throw new A.$_}};e.$dhc=w,e.$dhc=w=Ge([qe(0,i.$SN),qe(1,L.$wN)],w);function D(P){if(!(!P||typeof P=="string"))return"id"in P?{id:P.id,color:P.color}:P}function h(P){return r.ThemeColor.isThemeColor(P)?P:void 0}function b(P){const g={...P};return delete g.scope,g.options=g.options??void 0,delete g.variable,g}}),define(Re[273],Ae([1,0,11,23,21,5,244,97,6,26,16,33,13,3,17,110,8,7,49,75,59,25]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jic=e.$iic=e.$hic=e.$gic=void 0;let t=class extends d.$Tc{constructor(U,C,F,W){super(),this.w=W,this.f=this.B(new R.$Wd),this.g=new Map,this.s=this.B(new R.$Wd),this.onResultsChanged=this.f.event,this.results=[],this.h=U.getProxy($.$lL.MainThreadTesting),this.m=new E(this.h),this.j=new D(this.h,C),F.registerArgumentProcessor({processArgument:re=>{switch(re?.$mid){case 16:{const ce=re,we=ce.tests[ce.tests.length-1].item.extId;return this.g.get(i.$dK.root(we))?.collection.tree.get(we)?.actual??(0,r.$IN)(re)}case 18:{const{extId:ce,message:we}=re;return{test:this.g.get(i.$dK.root(ce))?.collection.tree.get(ce)?.actual,message:c.TestMessage.to(we)}}default:return re}}}),F.registerCommand(!1,"testing.getExplorerSelection",async()=>{const re=await F.executeCommand("_testing.getExplorerSelection"),ce=we=>{const De=this.g.get(i.$dK.root(we));if(De)return i.$dK.isRoot(we)?De.controller:De.collection.tree.get(we)?.actual};return{include:re?.include.map(ce).filter(A.$Rf)||[],exclude:re?.exclude.map(ce).filter(A.$Rf)||[]}})}createTestController(U,C,F,W){if(this.g.has(C))throw new Error(`Attempt to insert a duplicate controller with ID "${C}"`);const re=new d.$Sc,ce=re.add(new r.$LN(C,F,this.w));ce.root.label=F;const we=new Map,De=new Set,le=this.h,ve={items:ce.root.children,get label(){return F},set label($e){F=$e,ce.root.label=$e,le.$updateController(C,{label:F})},get refreshHandler(){return W},set refreshHandler($e){W=$e,le.$updateController(C,{canRefresh:!!$e})},get id(){return C},createRunProfile:($e,te,X,V,ie,Ce)=>{let Te=(0,m.$Vi)($e);for(;we.has(Te);)Te++;return new N(this.h,we,De,this.s.event,C,Te,$e,te,X,V,ie,Ce)},createTestItem($e,te,X){return new r.$JN(C,$e,te,X)},createTestRun:($e,te,X=!0)=>this.j.createTestRun(U,C,ce,$e,te,X),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const te=$e instanceof Array?$e:[$e];this.h.$markTestRetired(te.map(X=>i.$dK.fromExtHostTestItem(X,C).toString()))}},set resolveHandler($e){ce.resolveHandler=$e},get resolveHandler(){return ce.resolveHandler},dispose:()=>{re.dispose()}};le.$registerTestController(C,F,!!W),re.add((0,d.$Rc)(()=>le.$unregisterTestController(C)));const se={controller:ve,collection:ce,profiles:we,extension:U,activeProfiles:De};return this.g.set(C,se),re.add((0,d.$Rc)(()=>this.g.delete(C))),re.add(ce.onDidGenerateDiff($e=>le.$publishDiff(C,$e.map(a.TestsDiffOp.serialize)))),ve}createTestObserver(){return this.m.checkout()}async runTests(U,C=I.CancellationToken.None){const F=h(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.g.get(F.controllerId);if(!W)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(re=>i.$dK.fromExtHostTestItem(re,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:J[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(re=>re.id)},C)}$syncTests(){for(const{collection:U}of this.g.values())U.flushDiff();return Promise.resolve()}async $provideFileCoverage(U,C,F){return await this.j.getCoverageReport(U,C)?.provideFileCoverage(F)??[]}async $resolveFileCoverage(U,C,F,W){return await this.j.getCoverageReport(U,C)?.resolveFileCoverage(F,W)??[]}$configureRunProfile(U,C){this.g.get(U)?.profiles.get(C)?.configureHandler?.()}$setDefaultRunProfiles(U){const C=new Map;for(const[F,W]of Object.entries(U)){const re=this.g.get(F);if(!re)continue;const ce=new Map,we=W.filter(le=>!re.activeProfiles.has(le)),De=[...re.activeProfiles].filter(le=>!W.includes(le));for(const le of we)ce.set(le,!0),re.activeProfiles.add(le);for(const le of De)ce.set(le,!1),re.activeProfiles.delete(le);ce.size&&C.set(F,ce)}this.s.fire(C)}async $refreshTests(U,C){await this.g.get(U)?.controller.refreshHandler?.(C)}$publishTestResults(U){this.results=Object.freeze(U.map(C=>(0,y.$zn)(c.TestResults.to(C))).concat(this.results).sort((C,F)=>F.completedAt-C.completedAt).slice(0,32)),this.f.fire()}async $expandTest(U,C){const F=this.g.get(i.$dK.fromString(U).controllerId)?.collection;F&&(await F.expand(U,C<0?1/0:C),F.flushDiff())}$acceptDiff(U){this.m.applyDiff(U.map(C=>a.TestsDiffOp.deserialize({asCanonicalUri:F=>F},C)))}async $runControllerTests(U,C){return Promise.all(U.map(F=>this.y(F,!1,C)))}async $startContinuousRun(U,C){const F=new I.$7d(C),W=await Promise.all(U.map(re=>this.y(re,!0,F.token)));return!C.isCancellationRequested&&!W.some(re=>re.error)&&await new Promise(re=>C.onCancellationRequested(re)),F.dispose(!0),W}async y(U,C,F){const W=this.g.get(U.controllerId);if(!W)return{};const{collection:re,profiles:ce,extension:we}=W,De=ce.get(U.profileId);if(!De)return{};const le=U.testIds.map(te=>re.tree.get(te)).filter(A.$Rf),ve=U.excludeExtIds.map(te=>W.collection.tree.get(te)).filter(A.$Rf).filter(te=>le.some(X=>X.fullId.compare(te.fullId)===2));if(!le.length)return{};const se=new s.$XM(le.some(te=>te.actual instanceof r.$KN)?void 0:le.map(te=>te.actual),ve.map(te=>te.actual),De,C),$e=(0,a.$fK)(U)&&this.j.prepareForMainThreadTestRun(se,b.fromInternal(U,W.collection),we,F);try{return await De.runHandler(se,F),{}}catch(te){return{error:String(te)}}finally{$e&&($e.hasRunningTasks&&!F.isCancellationRequested&&await R.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.j.cancelAllRuns():this.j.cancelRunById(U)}};e.$gic=t,e.$gic=t=Ge([qe(0,p.$wN),qe(1,l.$pj)],t);const f=1e4;var n;(function(q){q[q.Running=0]="Running",q[q.Cancelling=1]="Cancelling",q[q.Ended=2]="Ended"})(n||(n={}));class w extends d.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(U,C,F,W,re){super(),this.s=U,this.w=C,this.y=F,this.z=W,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.$Wd),this.m=this.B(new R.$Wd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new I.$7d(re));const ce=this.B(new S.$hh(()=>this.C(),f));this.B(this.h.token.onCancellationRequested(()=>ce.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(U){const C=this.s.id,F=this.s.controllerId,W=(0,k.$rg)(),re=this.y,ce=this.m;let we;const De=$e=>(te,...X)=>{if(ve){this.z.warn(`Setting the state of test "${te.id}" is a no-op after the run ends.`);return}this.s.isIncluded(te)&&(this.F(te),$e(te,...X))},le=($e,te)=>{const X=te instanceof Array?te.map(c.TestMessage.from):[c.TestMessage.from(te)];if($e.uri&&$e.range){const V={range:c.Range.from($e.range),uri:$e.uri};for(const ie of X)ie.location=ie.location||V}this.w.$appendTestMessagesInRun(C,W,i.$dK.fromExtHostTestItem($e,F).toString(),X)};let ve=!1;const se={isPersisted:this.s.isPersisted,token:this.h.token,name:U,get coverageProvider(){return we?.provider},set coverageProvider($e){(0,u.$LF)(re,"testCoverage"),we=$e&&new P($e),ce.fire({taskId:W,runId:C,coverage:we})},enqueued:De($e=>{this.w.$updateTestStateInRun(C,W,i.$dK.fromExtHostTestItem($e,F).toString(),1)}),skipped:De($e=>{this.w.$updateTestStateInRun(C,W,i.$dK.fromExtHostTestItem($e,F).toString(),5)}),started:De($e=>{this.w.$updateTestStateInRun(C,W,i.$dK.fromExtHostTestItem($e,F).toString(),2)}),errored:De(($e,te,X)=>{le($e,te),this.w.$updateTestStateInRun(C,W,i.$dK.fromExtHostTestItem($e,F).toString(),6,X)}),failed:De(($e,te,X)=>{le($e,te),this.w.$updateTestStateInRun(C,W,i.$dK.fromExtHostTestItem($e,F).toString(),4,X)}),passed:De(($e,te)=>{this.w.$updateTestStateInRun(C,W,i.$dK.fromExtHostTestItem($e,this.s.controllerId).toString(),3,te)}),appendOutput:($e,te,X)=>{ve||(X&&(this.s.isIncluded(X)?this.F(X):X=void 0),this.w.$appendOutputToRun(C,W,M.$ke.fromString($e),te&&c.location.from(te),X&&i.$dK.fromExtHostTestItem(X,F).toString()))},end:()=>{ve||(ve=!0,this.w.$finishedTestRunTask(C,W),this.f.delete(W),this.f.size||this.D())}};return this.f.set(W,{run:se}),this.w.$startedTestRunTask(C,{id:W,name:U,running:!0}),se}C(){for(const{run:U}of this.f.values())U.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(U){if(!(U instanceof r.$JN))throw new o.$oN(U.id);if(this.g.has(i.$dK.fromExtHostTestItem(U,this.s.controllerId).toString()))return;const C=[],F=this.s.colllection.root;for(;;){const W=c.TestItem.from(U);if(C.unshift(W),this.g.has(W.extId)||(this.g.add(W.extId),U===F))break;U=U.parent||F}this.w.$addTestsToRun(this.s.controllerId,this.s.id,C)}dispose(){this.D(),super.dispose()}}class D{get trackers(){return this.c.values()}constructor(U,C){this.g=U,this.h=C,this.c=new Map,this.f=[]}getCoverageReport(U,C){return this.f.find(F=>F.runId===U)?.coverage.get(C)}prepareForMainThreadTestRun(U,C,F,W){return this.j(U,C,F,W)}cancelRunById(U){for(const C of this.c.values())if(C.id===U){C.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,C,F,W,re,ce){const we=this.c.get(W);if(we)return we.createRun(re);const De=b.fromPublic(C,F,W,ce),le=h(W);this.g.$startedExtensionTestRun({controllerId:C,continuous:!!W.continuous,profile:le&&{group:J[le.kind],id:le.profileId},exclude:W.exclude?.map(se=>i.$dK.fromExtHostTestItem(se,F.root.id).toString())??[],id:De.id,include:W.include?.map(se=>i.$dK.fromExtHostTestItem(se,F.root.id).toString())??[F.root.id],persist:ce});const ve=this.j(W,De,U);return R.Event.once(ve.onEnd)(()=>{this.g.$finishedExtensionTestRun(De.id),ve.dispose()}),ve.createRun(re)}j(U,C,F,W){const re=new w(C,this.g,F,this.h,W);this.c.set(U,re);let ce;const we=re.onDidCoverage(({runId:De,taskId:le,coverage:ve})=>{ce||(ce={runId:De,coverage:new Map},this.f.unshift(ce),this.f.length>a.$kK&&this.f.pop()),ce.coverage.set(le,ve),this.g.$signalCoverageAvailable(De,le,!!ve)});return R.Event.once(re.onEnd)(()=>{this.c.delete(U),we.dispose()}),re}}e.$hic=D;const h=q=>{if(q.profile){if(!(q.profile instanceof N))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return q.profile}};class b{static fromPublic(U,C,F,W){return new b(U,(0,k.$rg)(),F.include?.map(re=>i.$dK.fromExtHostTestItem(re,U).toString())??[U],F.exclude?.map(re=>i.$dK.fromExtHostTestItem(re,U).toString())??[],W,C)}static fromInternal(U,C){return new b(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,C)}constructor(U,C,F,W,re,ce){this.controllerId=U,this.id=C,this.isPersisted=re,this.colllection=ce,this.c=F.map(we=>we+"\0"),this.f=W.map(we=>we+"\0")}isIncluded(U){const C=i.$dK.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.f)if(C===F||C.startsWith(F))return!1;for(const F of this.c)if(C===F||C.startsWith(F))return!0;return!1}}e.$iic=b;class P{constructor(U){this.provider=U}async provideFileCoverage(U){this.c||(this.c=(async()=>this.provider.provideFileCoverage(U))());try{return(await this.c)?.map(c.TestCoverage.fromFile)??[]}catch(C){throw this.c=void 0,C}}async resolveFileCoverage(U,C){const F=await this.c;let W=F?.[U];return!this.provider||!F||!W?[]:(W.detailedCoverage||(W=F[U]=await this.provider.resolveFileCoverage?.(W,C)??W),W.detailedCoverage?.map(c.TestCoverage.fromDetailed)??[])}}class g{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(U){this.j=U,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,c.TestItem.toPlain(U.item)),this.c.has(U)||this.f.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.f.delete(U);const C=i.$dK.parentId(U.item.extId);if(C&&this.h.has(C.toString())){this.h.add(U.item.extId);return}this.g.add(U)}getChangeEvent(){const{c:U,f:C,g:F}=this;return{get added(){return[...U].map(W=>W.revived)},get updated(){return[...C].map(W=>W.revived)},get removed(){return[...F].map(W=>W.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class v extends a.$lK{constructor(){super(...arguments),this.s=new R.$Wd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(U){return this.f.get(U)}getMirroredTestDataByReference(U){return this.f.get(U.id)}w(U,C){return{...U,revived:c.TestItem.toPlain(U.item),depth:C?C.depth+1:0,children:new Set}}v(){return new g(this.s)}}class E{constructor(U){this.f=U}checkout(){this.c||(this.c=this.g());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(C=>C.revived)},dispose:(0,L.$db)(()=>{--U.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}g(){const U=new v({asCanonicalUri:C=>C});return this.f.$subscribeToDiffs(),{observers:0,tests:U}}}const T=(q,U,C,F)=>{C?Object.assign(C,F):U.$updateTestRunConfig(q.controllerId,q.profileId,F)};class N{#e;#t;#i;#n;#s;get label(){return this.f}set label(U){U!==this.f&&(this.f=U,T(this,this.#e,this.#n,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,T(this,this.#e,this.#n,{supportsContinuousRun:U}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(U){U!==this.isDefault&&(U?this.#t.add(this.profileId):this.#t.delete(this.profileId),T(this,this.#e,this.#n,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,T(this,this.#e,this.#n,{tag:U?c.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,T(this,this.#e,this.#n,{hasConfigurationHandler:!!U}))}get onDidChangeDefault(){return R.Event.chain(this.#i,U=>U.map(C=>C.get(this.controllerId)?.get(this.profileId)).filter(A.$Rf))}constructor(U,C,F,W,re,ce,we,De,le,ve=!1,se=void 0,$e=!1){this.controllerId=re,this.profileId=ce,this.f=we,this.kind=De,this.runHandler=le,this._tag=se,this.g=$e,this.#e=U,this.#s=C,this.#t=F,this.#i=W,C.set(ce,this);const te=J[De];if(typeof te!="number")throw new Error(`Unknown TestRunProfile.group ${De}`);ve&&F.add(ce),this.#n={profileId:ce,controllerId:re,tag:se?c.TestTag.namespace(this.controllerId,se.id):null,label:we,group:te,isDefault:ve,hasConfigurationHandler:!1,supportsContinuousRun:$e},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$jic=N;const J={[s.TestRunProfileKind.Coverage]:8,[s.TestRunProfileKind.Debug]:4,[s.TestRunProfileKind.Run]:2}}),define(Re[111],Ae([1,0,54,15,88,8,7]),function(me,e,S,M,I,R,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=e.$DN=void 0;class m{static{this.c=new I.$BN("TextEditorDecorationType")}constructor(l,$,p){const r=m.c.nextId();l.$registerTextEditorDecorationType($.identifier,r,R.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:r,dispose(){l.$removeTextEditorDecorationType(r)}})}}e.$DN=m;class d{constructor(l,$){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=$.undoStopBefore,this.f=$.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,$){this.k();let p=null;if(l instanceof L.$oL)p=new L.$pL(l,l);else if(l instanceof L.$pL)p=l;else throw new Error("Unrecognized location");this.l(p,$,!1)}insert(l,$){this.k(),this.l(new L.$pL(l,l),$,!0)}delete(l){this.k();let $=null;if(l instanceof L.$pL)$=l;else throw new Error("Unrecognized location");this.l($,null,!0)}l(l,$,p){const r=this.c.validateRange(l);this.g.push({range:r,text:$,forceMoveMarkers:p})}setEndOfLine(l){if(this.k(),l!==L.EndOfLine.LF&&l!==L.EndOfLine.CRLF)throw(0,M.$7)("endOfLine");this.h=l}}class y{constructor(l,$,p,r){this.c=l,this.d=$,this._accept(p),this.e=r;const c=this;this.value={get tabSize(){return c.f},set tabSize(s){c.n(s)},get indentSize(){return c.g},set indentSize(s){c.p(s)},get insertSpaces(){return c.j},set insertSpaces(s){c.s(s)},get cursorStyle(){return c.k},set cursorStyle(s){c.t(s)},get lineNumbers(){return c.l},set lineNumbers(s){c.u(s)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=R.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}n(l){const $=this.m(l);if($!==null){if(typeof $=="number"){if(this.f===$)return;this.f=$}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:$}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const $=Math.floor(l);return $>0?$:null}if(typeof l=="string"){const $=parseInt(l,10);return isNaN($)?null:$>0?$:null}return null}p(l){const $=this.o(l);if($!==null){if(typeof $=="number"){if(this.h===$)return;this.g=$,this.h=$}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:$}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const $=this.q(l);if(typeof $=="boolean"){if(this.j===$)return;this.j=$}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:$}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(l)})))}assign(l){const $={};let p=!1;if(typeof l.tabSize<"u"){const r=this.m(l.tabSize);r==="auto"?(p=!0,$.tabSize=r):typeof r=="number"&&this.f!==r&&(this.f=r,p=!0,$.tabSize=r)}if(typeof l.indentSize<"u"){const r=this.o(l.indentSize);r==="tabSize"?(p=!0,$.indentSize=r):typeof r=="number"&&this.h!==r&&(this.g=r,this.h=r,p=!0,$.indentSize=r)}if(typeof l.insertSpaces<"u"){const r=this.q(l.insertSpaces);r==="auto"?(p=!0,$.insertSpaces=r):this.j!==r&&(this.j=r,p=!0,$.insertSpaces=r)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,p=!0,$.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,p=!0,$.lineNumbers=R.TextEditorLineNumbersStyle.from(l.lineNumbers)),p&&this.v("setOptions",this.c.$trySetOptions(this.d,$))}v(l,$){$.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(p)})}}e.$EN=y;class A{constructor(l,$,p,r,c,s,i,o){this.id=l,this.j=$,this.k=p,this.g=!1,this.h=new Set,this.c=c,this.d=new y(this.j,this.id,s,p),this.e=i,this.f=o;const a=this;this.value=Object.freeze({get document(){return r.value},set document(u){throw new M.$9("document")},get selection(){return a.c&&a.c[0]},set selection(u){if(!(u instanceof L.$qL))throw(0,M.$7)("selection");a.c=[u],a.l()},get selections(){return a.c},set selections(u){if(!Array.isArray(u)||u.some(t=>!(t instanceof L.$qL)))throw(0,M.$7)("selections");a.c=u,a.l()},get visibleRanges(){return a.e},set visibleRanges(u){throw new M.$9("visibleRanges")},get options(){return a.d.value},set options(u){a.g||a.d.assign(u)},get viewColumn(){return a.f},set viewColumn(u){throw new M.$9("viewColumn")},edit(u,t={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const f=new d(r.value,t);return u(f),a.m(f)},insertSnippet(u,t,f={undoStopBefore:!0,undoStopAfter:!0}){if(a.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&t.length===0)n=a.c.map(w=>R.Range.from(w));else if(t instanceof L.$oL){const{lineNumber:w,column:D}=R.Position.from(t);n=[{startLineNumber:w,startColumn:D,endLineNumber:w,endColumn:D}]}else if(t instanceof L.$pL)n=[R.Range.from(t)];else{n=[];for(const w of t)if(w instanceof L.$pL)n.push(R.Range.from(w));else{const{lineNumber:D,column:h}=R.Position.from(w);n.push({startLineNumber:D,startColumn:h,endLineNumber:D,endColumn:h})}}return $.$tryInsertSnippet(l,r.value.version,u.value,n,f)},setDecorations(u,t){const f=t.length===0;f&&!a.h.has(u.key)||(f?a.h.delete(u.key):a.h.add(u.key),a.n(()=>{if(R.$tN(t))return $.$trySetDecorations(l,u.key,R.$uN(t));{const n=new Array(4*t.length);for(let w=0,D=t.length;w<D;w++){const h=t[w];n[4*w]=h.start.line+1,n[4*w+1]=h.start.character+1,n[4*w+2]=h.end.line+1,n[4*w+3]=h.end.character+1}return $.$trySetDecorationsFast(l,u.key,n)}}))},revealRange(u,t){a.n(()=>$.$tryRevealRange(l,R.Range.from(u),t||L.TextEditorRevealType.Default))},show(u){$.$tryShowEditor(l,R.ViewColumn.from(u))},hide(){$.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const $=l.finalize();if($.edits.length===0&&!$.setEndOfLine)return Promise.resolve(!0);const p=$.edits.map(c=>c.range);p.sort((c,s)=>c.end.line===s.end.line?c.end.character===s.end.character?c.start.line===s.start.line?c.start.character-s.start.character:c.start.line-s.start.line:c.end.character-s.end.character:c.end.line-s.end.line);for(let c=0,s=p.length-1;c<s;c++){const i=p[c].end;if(p[c+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const r=$.edits.map(c=>({range:R.Range.from(c.range),text:c.text,forceMoveMarkers:c.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,$.documentVersionId,r,{setEndOfLine:typeof $.setEndOfLine=="number"?R.EndOfLine.from($.setEndOfLine):void 0,undoStopBefore:$.undoStopBefore,undoStopAfter:$.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,$=>($ instanceof Error&&$.name==="DISPOSED"||this.k.warn($),null))}}e.$FN=A}),define(Re[66],Ae([1,0,54,5,6,2,4,3,108,17,111,8,13,28,12,68,39]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=void 0;class s{constructor(a){this.value=a,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(a,u){this.h=a,this.i=u,this.a=null,this.b=new Map,this.c=new $.$Ac,this.d=new M.$Wd,this.e=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(a){this.acceptDocumentsAndEditorsDelta(a)}acceptDocumentsAndEditorsDelta(a){const u=[],t=[],f=[];if(a.removedDocuments)for(const n of a.removedDocuments){const w=R.URI.revive(n),D=this.c.get(w);D?.unref()&&(this.c.delete(w),u.push(D.value))}if(a.addedDocuments)for(const n of a.addedDocuments){const w=R.URI.revive(n.uri);let D=this.c.get(w);if(D&&w.scheme!==p.Schemas.vscodeNotebookCell&&w.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${w} already exists!'`);D||(D=new s(new d.$zN(this.h.getProxy(m.$lL.MainThreadDocuments),w,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this.c.set(w,D),t.push(D.value)),D.ref()}if(a.removedEditors)for(const n of a.removedEditors){const w=this.b.get(n);this.b.delete(n),w&&f.push(w)}if(a.addedEditors)for(const n of a.addedEditors){const w=R.URI.revive(n.documentUri);S.ok(this.c.has(w),`document '${w}' does not exist`),S.ok(!this.b.has(n.id),`editor '${n.id}' already exists!`);const D=this.c.get(w).value,h=new A.$FN(n.id,this.h.getProxy(m.$lL.MainThreadTextEditors),this.i,new c.$V(()=>D.document),n.selections.map(k.Selection.to),n.options,n.visibleRanges.map(b=>k.Range.to(b)),typeof n.editorPosition=="number"?k.ViewColumn.to(n.editorPosition):void 0);this.b.set(n.id,h)}a.newActiveEditor!==void 0&&(S.ok(a.newActiveEditor===null||this.b.has(a.newActiveEditor),`active editor '${a.newActiveEditor}' does not exist`),this.a=a.newActiveEditor),(0,I.$Oc)(u),(0,I.$Oc)(f),a.removedDocuments&&this.e.fire(u),a.addedDocuments&&this.d.fire(t),(a.removedEditors||a.addedEditors)&&this.f.fire(this.allEditors().map(n=>n.value)),a.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(a){return this.c.get(a)?.value}allDocuments(){return r.Iterable.map(this.c.values(),a=>a.value)}getEditor(a){return this.b.get(a)}activeEditor(a){if(!this.a)return;const u=this.b.get(this.a);return a?u:u?.value}allEditors(){return[...this.b.values()]}};e.$GN=i,e.$GN=i=Ge([qe(0,y.$wN),qe(1,l.$pj)],i),e.$HN=(0,L.$8h)("IExtHostDocumentsAndEditors")}),define(Re[274],Ae([1,0,18,5,3,111,8,7]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class d{constructor(A,k){this.i=k,this.a=new M.$Wd,this.b=new M.$Wd,this.c=new M.$Wd,this.d=new M.$Wd,this.f=new M.$Wd,this.g=new M.$Wd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(I.$lL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const k=this.i.allEditors();return A?k:k.map(l=>l.value)}async showTextDocument(A,k,l){let $;typeof k=="number"?$={position:L.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?$={position:L.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?L.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:$={preserveFocus:!1};const p=await this.h.$tryShowTextDocument(A.uri,$),r=p&&this.i.getEditor(p);if(r)return r.value;throw p?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,k){return new R.$DN(this.h,A,k).value}$acceptEditorPropertiesChanged(A,k){const l=this.i.getEditor(A);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const $=k.selections.selections.map(L.Selection.to);l._acceptSelections($)}if(k.visibleRanges){const $=S.$Hb(k.visibleRanges.map(L.Range.to));l._acceptVisibleRanges($)}if(k.options&&this.b.fire({textEditor:l.value,options:{...k.options,lineNumbers:L.TextEditorLineNumbersStyle.to(k.options.lineNumbers)}}),k.selections){const $=m.TextEditorSelectionChangeKind.fromValue(k.selections.source),p=k.selections.selections.map(L.Selection.to);this.a.fire({textEditor:l.value,selections:p,kind:$})}if(k.visibleRanges){const $=S.$Hb(k.visibleRanges.map(L.Range.to));this.c.fire({textEditor:l.value,visibleRanges:$})}}$acceptEditorPositionData(A){for(const k in A){const l=this.i.getEditor(k);if(!l)throw new Error("Unknown text editor");const $=L.ViewColumn.to(A[k]);l.value.viewColumn!==$&&(l._acceptViewColumn($),this.d.fire({textEditor:l.value,viewColumn:$}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Fgc=d}),define(Re[275],Ae([1,0,2,4,3,6,7,8,22,16]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=e.$lic=void 0,e.$lic=(0,M.$8h)("IExtHostTimeline");class A{constructor($,p){this.b=new Map,this.c=new Map,this.a=$.getProxy(I.$lL.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(r,c)=>{if(r&&r.$mid===12)if(this.b.get(r.source)&&d.$nm.equals(c,this.b.get(r.source)?.extension)){const s=r.uri===void 0?void 0:S.URI.revive(r.uri);return this.c.get(r.source)?.get(k(s))?.get(r.handle)}else return;return r}})}async $getTimeline($,p,r,c){return this.b.get($)?.provider.provideTimeline(S.URI.revive(p),r,c)}registerTimelineProvider($,p,r,c){const s=new R.$Sc,i=this.d(p.id,c,s).bind(this);let o;p.onDidChange&&(o=p.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:p.id}),this));const a=this.c;return this.f({...p,scheme:$,onDidChange:void 0,async provideTimeline(u,t,f){t?.resetCache&&(s.clear(),a.get(p.id)?.clear());const n=await p.provideTimeline(u,t,f);if(n==null)return;const w=i(u,t);return{...n,source:p.id,items:n.items.map(w)}},dispose(){for(const u of a.values())u.get(p.id)?.clear();o?.dispose(),s.dispose()}},r)}d($,p,r){return(c,s)=>{let i;if(s?.cacheResults){let o=this.c.get($);o===void 0&&(o=new Map,this.c.set($,o));const a=k(c);i=o.get(a),i===void 0&&(i=new Map,o.set(a,i))}return o=>{const{iconPath:a,...u}=o,t=`${$}|${o.id??o.timestamp}`;i?.set(t,o);let f,n,w;o.iconPath&&(a instanceof L.$iM?w={id:a.id,color:a.color}:S.URI.isUri(a)?(f=a,n=a):{light:f,dark:n}=a);let D;return L.$OL.isMarkdownString(u.tooltip)?D=m.MarkdownString.from(u.tooltip):(0,y.$Jf)(u.tooltip)?D=u.tooltip:L.$OL.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),D=m.MarkdownString.from(u.detail)):(0,y.$Jf)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),D=u.detail),{...u,id:u.id??void 0,handle:t,source:$,command:o.command?p.toInternal(o.command,r):void 0,icon:f,iconDark:n,themeIcon:w,tooltip:D,accessibilityInformation:o.accessibilityInformation}}}}f($,p){if(this.b.get($.id))throw new Error(`Timeline Provider ${$.id} already exists.`);return this.a.$registerTimelineProvider({id:$.id,label:$.label,scheme:$.scheme}),this.b.set($.id,{provider:$,extension:p}),(0,R.$Rc)(()=>{for(const c of this.c.values())c.get($.id)?.clear();this.b.delete($.id),this.a.$unregisterTimelineProvider($.id),$.dispose()})}}e.$mic=A;function k(l){return l?.toString()}}),define(Re[276],Ae([1,0,166,24,2,5,6,204,11,7,16,18,8,46,21,132,25]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;function s(a,u){if((0,A.$Jf)(a))return{label:a};if(a&&typeof a=="object"&&typeof a.label=="string"){let t;return Array.isArray(a.highlights)&&(t=a.highlights.filter(f=>f.length===2&&typeof f[0]=="number"&&typeof f[1]=="number"),t=t.length?t:void 0),{label:a.label,highlights:t}}}class i extends L.$Tc{constructor(u,t,f){super(),this.f=u,this.g=t,this.h=f,this.a=new Map,this.b=new r.$O8;function n(w){return w&&w.$treeViewId&&(w.$treeItemHandle||w.$selectedTreeItems||w.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:w=>n(w)?this.r(w):Array.isArray(w)&&w.length>0?w.map(D=>n(D)?this.r(D):D):w})}registerTreeDataProvider(u,t,f){const n=this.createTreeView(u,{treeDataProvider:t},f);return{dispose:()=>n.dispose()}}createTreeView(u,t,f){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=t.dragAndDropController?.dropMimeTypes??[],w=t.dragAndDropController?.dragMimeTypes??[],D=!!t.dragAndDropController?.handleDrag,h=!!t.dragAndDropController?.handleDrop,b=this.m(u,t,f),P={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:n,dragMimeTypes:w,hasHandleDrag:D,hasHandleDrop:h,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},g=this.f.$registerTreeViewDataProvider(u,P),v={get onDidCollapseElement(){return b.onDidCollapseElement},get onDidExpandElement(){return b.onDidExpandElement},get selection(){return b.selectedElements},get onDidChangeSelection(){return b.onDidChangeSelection},get activeItem(){return(0,c.$LF)(f,"treeViewActiveItem"),b.focusedElement},get onDidChangeActiveItem(){return(0,c.$LF)(f,"treeViewActiveItem"),b.onDidChangeActiveItem},get visible(){return b.visible},get onDidChangeVisibility(){return b.onDidChangeVisibility},get onDidChangeCheckboxState(){return b.onDidChangeCheckboxState},get message(){return b.message},set message(E){(0,$.$lk)(E)&&(0,c.$LF)(f,"treeViewMarkdownMessage"),b.message=E},get title(){return b.title},set title(E){b.title=E},get description(){return b.description},set description(E){b.description=E},get badge(){return b.badge},set badge(E){E!==void 0&&y.ViewBadge.isViewBadge(E)?b.badge={value:Math.floor(Math.abs(E.value)),tooltip:E.tooltip}:E===void 0&&(b.badge=void 0)},reveal:(E,T)=>b.reveal(E,T),dispose:async()=>{await g,this.a.delete(u),b.dispose()}};return this.B(v),v}$getChildren(u,t){const f=this.a.get(u);return f?f.getChildren(t):Promise.reject(new m.$eF(u))}async $handleDrop(u,t,f,n,w,D,h,b){const P=this.a.get(u);if(!P)return Promise.reject(new m.$eF(u));const g=l.DataTransfer.toDataTransfer(f,async v=>(await this.f.$resolveDropFileData(u,t,v)).buffer);return h===u&&b&&await this.j(g,P,b,w,D),P.onDrop(g,n,w)}async j(u,t,f,n,w){const D=this.b.removeDragOperationTransfer(w);if(D)(await D)?.forEach((h,b)=>{h&&u.set(b,h)});else if(w&&t.handleDrag){const h=t.handleDrag(f,u,n);this.b.addDragOperationTransfer(w,h),await h}return u}async $handleDrag(u,t,f,n){const w=this.a.get(u);if(!w)return Promise.reject(new m.$eF(u));const D=await this.j(new y.$fM,w,t,n,f);if(!(!D||n.isCancellationRequested))return l.DataTransfer.from(D)}async $hasResolve(u){const t=this.a.get(u);if(!t)throw new m.$eF(u);return t.hasResolve}$resolve(u,t,f){const n=this.a.get(u);if(!n)throw new m.$eF(u);return n.resolveTreeItem(t,f)}$setExpanded(u,t,f){const n=this.a.get(u);if(!n)throw new m.$eF(u);n.setExpanded(t,f)}$setSelectionAndFocus(u,t,f){const n=this.a.get(u);if(!n)throw new m.$eF(u);n.setSelectionAndFocus(t,f)}$setVisible(u,t){const f=this.a.get(u);if(!f){if(!t)return;throw new m.$eF(u)}f.setVisible(t)}$changeCheckboxState(u,t){const f=this.a.get(u);if(!f)throw new m.$eF(u);f.setCheckboxState(t)}m(u,t,f){const n=this.B(new o(u,t,this.f,this.g.converter,this.h,f));return this.a.set(u,n),n}r(u){const t=this.a.get(u.$treeViewId);return t&&"$treeItemHandle"in u?t.getExtensionElement(u.$treeItemHandle):t&&"$focusedTreeItem"in u&&u.$focusedTreeItem?t.focusedElement:null}}e.$nic=i;class o extends L.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,A.$Sf)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,t,f,n,w,D){if(super(),this.I=u,this.J=f,this.L=n,this.M=w,this.N=D,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new R.$Wd),this.onDidExpandElement=this.u.event,this.w=this.B(new R.$Wd),this.onDidCollapseElement=this.w.event,this.y=this.B(new R.$Wd),this.onDidChangeSelection=this.y.event,this.z=this.B(new R.$Wd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new R.$Wd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new R.$Wd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new R.$Wd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new p.$7d,D.contributes&&D.contributes.views)for(const g in D.contributes.views)for(const v of D.contributes.views[g])v.id===u&&(this.P=v.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(g=>this.F.fire({message:!1,element:g})));let h,b;const P=R.Event.debounce(this.F.event,(g,v)=>(g||(g={message:!1,elements:[]}),v.element!==!1&&(h||(h=new Promise(E=>b=E),this.G=this.G.then(()=>h)),Array.isArray(v.element)?g.elements.push(...v.element):g.elements.push(v.element)),v.message&&(g.message=!0),g),200,!0);this.B(P(({message:g,elements:v})=>{v.length&&(this.H=this.H.then(()=>{const E=b;return h=null,this.$(v).then(()=>E())})),g&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const t=u?this.getExtensionElement(u):void 0;if(u&&!t)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let f=this.X(u);return f||(f=await this.Y(t)),f?f.map(n=>n.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,t){t=t||{select:!0,focus:!1};const f=(0,A.$Sf)(t.select)?!0:t.select,n=(0,A.$Sf)(t.focus)?!1:t.focus,w=(0,A.$Sf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(D=>this.W(u,D[D.length-1]).then(h=>this.J.$reveal(this.I,{item:h.item,parentChain:D.map(b=>b.item)},{select:f,focus:n,expand:w})),D=>this.M.error(D)):this.J.$reveal(this.I,void 0,{select:f,focus:n,expand:w})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=l.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,t){const f=this.getExtensionElement(u);f&&(t?this.u.fire(Object.freeze({element:f})):this.w.fire(Object.freeze({element:f})))}setSelectionAndFocus(u,t){const f=!(0,k.$ub)(this.s,u);this.s=u;const n=this.t!==t;this.t=t,f&&this.y.fire(Object.freeze({selection:this.selectedElements})),n&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const t=(await Promise.all(u.map(async f=>{const n=this.getExtensionElement(f.treeItemHandle);return n?{extensionItem:n,treeItem:await this.f.getTreeItem(n),newState:f.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(f=>f!==void 0);t.forEach(f=>{f.treeItem.checkboxState=f.newState?y.TreeItemCheckboxState.Checked:y.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(f=>[f.extensionItem,f.newState])})}async handleDrag(u,t,f){const n=[];for(const w of u){const D=this.getExtensionElement(w);D&&n.push(D)}if(!(!this.g?.handleDrag||n.length===0))return await this.g.handleDrag(n,t,f),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,t,f){const n=t?this.getExtensionElement(t):void 0;if(!(!n&&t||!this.g?.handleDrop))return(0,d.$Zg)(()=>this.g?.handleDrop?this.g.handleDrop(n,u,f):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,t){if(!this.f.resolveTreeItem)return;const f=this.j.get(u);if(f){const n=this.m.get(f);if(n){const w=await this.f.resolveTreeItem(n.extensionItem,f,t)??n.extensionItem;return this.hb(w),n.item.tooltip=this.eb(w.tooltip),n.item.command=this.fb(n.disposableStore,w.command),n.item}}}S(u){return this.U(u).then(t=>t?this.S(t).then(f=>this.W(t,f[f.length-1]).then(n=>(f.push(n),f))):Promise.resolve([]))}U(u){const t=this.m.get(u);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,d.$Zg)(()=>this.f.getParent(u))}W(u,t){const f=this.m.get(u);return f?Promise.resolve(f):(0,d.$Zg)(()=>this.f.getTreeItem(u)).then(n=>this.kb(u,n,t,!0)).then(n=>this.getChildren(t?t.item.handle:void 0).then(()=>{const w=this.getExtensionElement(n);if(w){const D=this.m.get(w);if(D)return Promise.resolve(D)}throw new Error(`Cannot resolve tree item for element ${n} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let t;if(typeof u=="string"){const f=this.getExtensionElement(u);t=f?this.m.get(f):void 0}else t=u;return t&&t.children||void 0}return this.h}async Y(u){this.rb(u);const t=new p.$7d(this.Z.token);try{const f=u?this.m.get(u):void 0,n=await this.f.getChildren(u);if(t.token.isCancellationRequested)return;const w=(0,k.$Hb)(n||[]),D=await Promise.all((0,k.$Hb)(w).map(b=>this.f.getTreeItem(b)));if(t.token.isCancellationRequested)return;const h=D.map((b,P)=>b?this.db(w[P],b,f):null);return(0,k.$Hb)(h)}finally{t.dispose()}}$(u){if(u.some(f=>!f))return this.Z.dispose(!0),this.Z=new p.$7d,this.tb(),this.J.$refresh(this.I);{const f=this.ab(u);if(f.length)return this.bb(f)}return Promise.resolve(void 0)}ab(u){const t=new Set,f=u.map(w=>this.m.get(w));for(const w of f)if(w&&!t.has(w.item.handle)){let D=w;for(;D&&D.parent&&f.findIndex(h=>D&&D.parent&&h&&h.item.handle===D.parent.item.handle)===-1;){const h=this.j.get(D.parent.item.handle);D=h?this.m.get(h):void 0}D&&!D.parent&&t.add(w.item.handle)}const n=[];return t.forEach(w=>{const D=this.j.get(w);if(D){const h=this.m.get(D);h&&(!h.parent||!t.has(h.parent.item.handle))&&n.push(w)}}),n}bb(u){const t={};return Promise.all(u.map(f=>this.cb(f).then(n=>{n&&(t[f]=n.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(u){const t=this.getExtensionElement(u);if(t){const f=this.m.get(t);if(f)return this.rb(t),(0,d.$Zg)(()=>this.f.getTreeItem(t)).then(n=>{if(n){const w=this.ib(t,n,f.parent);return this.pb(t,w,f,f.parent),f.dispose(),w}return null})}return Promise.resolve(null)}db(u,t,f){const n=this.ib(u,t,f);if(t.id&&this.j.has(n.item.handle))throw new Error((0,S.localize)(0,null,t.id));return this.ob(u,n),this.qb(n,f),n}eb(u){return y.$OL.isMarkdownString(u)?l.MarkdownString.from(u):u}fb(u,t){return t?{...this.L.toInternal(t,u),originalId:t.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let t,f,n;return typeof u.checkboxState=="number"?t=u.checkboxState:(t=u.checkboxState.state,f=u.checkboxState.tooltip,n=u.checkboxState.accessibilityInformation),{isChecked:t===y.TreeItemCheckboxState.Checked,tooltip:f,accessibilityInformation:n}}hb(u){if(!y.$aM.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,t,f){this.hb(t);const n=this.B(new L.$Sc),w=this.kb(u,t,f),D=this.lb(t);return{item:{handle:w,parentHandle:f?f.item.handle:void 0,label:s(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(n,t.command),contextValue:t.contextValue,icon:D,iconDark:this.mb(t)||D,themeIcon:this.jb(t),collapsibleState:(0,A.$Sf)(t.collapsibleState)?y.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:f,children:void 0,disposableStore:n,dispose(){n.dispose()}}}jb(u){return u.iconPath instanceof y.$iM?u.iconPath:void 0}kb(u,{id:t,label:f,resourceUri:n},w,D){if(t)return`${o.b}/${t}`;const h=s(f,this.N),b=w?w.item.handle:o.a;let P=h?h.label:n?(0,M.$Fg)(n):"";P=P.indexOf("/")!==-1?P.replace("/","//"):P;const g=this.m.has(u)?this.m.get(u).item.handle:void 0,v=this.X(w)||[];let E,T=0;do{if(E=`${b}/${T}:${P}`,D||!this.j.has(E)||g===E)break;T++}while(T<=v.length);return E}lb(u){if(u.iconPath&&!(u.iconPath instanceof y.$iM))return typeof u.iconPath=="string"||I.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof y.$iM)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return I.URI.isUri(u)?u:I.URI.file(u)}ob(u,t){this.j.set(t.item.handle,u),this.m.set(u,t)}pb(u,t,f,n){this.j.delete(t.item.handle),this.m.delete(u),t.item.handle!==f.item.handle&&this.j.delete(f.item.handle),this.ob(u,t);const w=this.X(n)||[],D=w.filter(h=>h.item.handle===f.item.handle)[0];D&&w.splice(w.indexOf(D),1,t)}qb(u,t){t?(t.children||(t.children=[]),t.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const n=this.j.get(f.item.handle);n&&this.sb(n)}t.children=void 0}}else this.tb()}sb(u){const t=this.m.get(u);if(t){if(t.children)for(const f of t.children){const n=this.j.get(f.item.handle);n&&this.sb(n)}this.m.delete(u),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Re[277],Ae([1,0,5,6,2,33,8,61,3,7]),function(me,e,S,M,I,R,L,m,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class A extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(p,r,c,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$Wd),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$Wd),this.onDidChangeViewState=this.#h.event,this.#e=p,this.#t=r,this.#n=c,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(p){this.c(),this.#r!==p&&(this.#r=p,this.#t.$setTitle(this.#e,p))}get iconPath(){return this.c(),this.#a}set iconPath(p){this.c(),this.#a!==p&&(this.#a=p,this.#t.$setIconPath(this.#e,I.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(p){this.#l||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(this.#u=p.active,this.#c=p.visible,this.#o=p.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(p,r){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof p>"u"?void 0:L.ViewColumn.from(p),preserveFocus:!!r})}c(){if(this.#l)throw new Error("Webview is disposed")}}class k extends M.$Tc{static c(){return(0,R.$rg)()}constructor(p,r,c){super(),this.j=r,this.m=c,this.g=new Map,this.h=new Map,this.f=p.getProxy(d.$lL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(p=>p.dispose()),this.g.clear()}createWebviewPanel(p,r,c,s,i={}){const o=typeof s=="object"?s.viewColumn:s,a={viewColumn:L.ViewColumn.from(o),preserveFocus:typeof s=="object"&&!!s.preserveFocus},u=(0,m.$Ugc)(p),t=k.c();this.f.$createWebviewPanel((0,m.$Wgc)(p),t,r,{title:c,panelOptions:l(i),webviewOptions:(0,m.$Xgc)(p,this.m,i),serializeBuffersForPostMessage:u},a);const f=this.j.createNewWebview(t,i,p);return this.createNewWebviewPanel(t,r,c,o,i,f,!0)}$onDidChangeWebviewPanelViewStates(p){const r=Object.keys(p);r.sort((c,s)=>{const i=p[c],o=p[s];return i.active?1:o.active?-1:+i.visible-+o.visible});for(const c of r){const s=this.getWebviewPanel(c);if(!s)continue;const i=p[c];s._updateViewState({active:i.active,visible:i.visible,viewColumn:L.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this.g.delete(p),this.j.deleteWebview(p)}registerWebviewPanelSerializer(p,r,c){if(this.h.has(r))throw new Error(`Serializer for '${r}' already registered`);return this.h.set(r,{serializer:c,extension:p}),this.f.$registerSerializer(r,{serializeBuffersForPostMessage:(0,m.$Ugc)(p)}),new y.$nL(()=>{this.h.delete(r),this.f.$unregisterSerializer(r)})}async $deserializeWebviewPanel(p,r,c,s){const i=this.h.get(r);if(!i)throw new Error(`No serializer found for '${r}'`);const{serializer:o,extension:a}=i,u=this.j.createNewWebview(p,c.webviewOptions,a),t=this.createNewWebviewPanel(p,r,c.title,s,c.panelOptions,u,c.active);await o.deserializeWebviewPanel(t,c.state)}createNewWebviewPanel(p,r,c,s,i,o,a){const u=new A(p,this.f,o,{viewType:r,title:c,viewColumn:s,panelOptions:i,active:a});return this.g.set(p,u),u}getWebviewPanel(p){return this.g.get(p)}}e.$Ygc=k;function l($){return{enableFindWidget:$.enableFindWidget,retainContextWhenHidden:$.retainContextWhenHidden}}}),define(Re[278],Ae([1,0,5,6,61,8,3,7]),function(me,e,S,M,I,R,L,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=void 0;class d extends M.$Tc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(k,l,$,p,r,c){super(),this.#s=!1,this.#u=this.B(new S.$Wd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$Wd),this.onDidDispose=this.#l.event,this.#i=$,this.#a=p,this.#e=k,this.#t=l,this.#n=r,this.#r=c}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(k){this.a(),this.#a!==k&&(this.#a=k,this.#t.$setWebviewViewTitle(this.#e,k))}get description(){return this.a(),this.#o}set description(k){this.a(),this.#o!==k&&(this.#o=k,this.#t.$setWebviewViewDescription(this.#e,k))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(k){k===this.#r||this.#s||(this.#r=k,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(k){this.a(),!(k?.value===this.#c?.value&&k?.tooltip===this.#c?.tooltip)&&(this.#c=R.ViewBadge.from(k),this.#t.$setWebviewViewBadge(this.#e,k))}show(k){this.a(),this.#t.$show(this.#e,!!k)}a(){if(this.#s)throw new Error("Webview is disposed")}}class y{constructor(k,l){this.d=l,this.b=new Map,this.c=new Map,this.a=k.getProxy(L.$lL.MainThreadWebviewViews)}registerWebviewViewProvider(k,l,$,p){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:$,extension:k}),this.a.$registerWebviewViewProvider((0,I.$Wgc)(k),l,{retainContextWhenHidden:p?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.$Ugc)(k)}),new m.$nL(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(k,l,$,p,r){const c=this.b.get(l);if(!c)throw new Error(`No view provider found for '${l}'`);const{provider:s,extension:i}=c,o=this.d.createNewWebview(k,{},i),a=new d(k,this.a,l,$,o,!0);this.c.set(k,a),await s.resolveWebviewView(a,{state:p},r)}async $onDidChangeWebviewViewVisibility(k,l){this.e(k)._setVisible(l)}async $disposeWebviewView(k){const l=this.e(k);this.c.delete(k),l.dispose(),this.d.deleteWebview(k)}e(k){const l=this.c.get(k);if(!l)throw new Error("No webview found");return l}}e.$qic=y}),define(Re[279],Ae([1,0,5,30,35,4]),function(me,e,S,M,I,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HK=e.$GK=e.OutputChannelUpdateMode=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.$AK=e.$zK=e.$yK=e.$xK=e.$wK=void 0,e.$wK="text/x-code-output",e.$xK="output",e.$yK="Log",e.$zK="text/x-code-log-output",e.$AK="log",e.$BK="workbench.panel.output",e.$CK=new I.$mj("inOutput",!1),e.$DK=new I.$mj("activeLogOutput",!1),e.$EK=new I.$mj("outputView.scrollLock",!1),e.$FK=(0,R.$8h)("outputService");var L;(function(d){d[d.Append=1]="Append",d[d.Replace=2]="Replace",d[d.Clear=3]="Clear"})(L||(e.OutputChannelUpdateMode=L={})),e.$GK={OutputChannels:"workbench.contributions.outputChannels"};class m{constructor(){this.a=new Map,this.b=new S.$Wd,this.onDidRegisterChannel=this.b.event,this.c=new S.$Wd,this.onDidRemoveChannel=this.c.event}registerChannel(y){this.a.has(y.id)||(this.a.set(y.id,y),this.b.fire(y.id))}getChannels(){const y=[];return this.a.forEach(A=>y.push(A)),y}getChannel(y){return this.a.get(y)}removeChannel(y){this.a.delete(y),this.c.fire(y)}}M.$Kn.add(e.$GK.OutputChannels,new m),e.$HK=new I.$mj("activeOutputChannel","")}),define(Re[112],Ae([1,0,3,4,17,22,13,279,62,27,43,136,23,16,42,5,6]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5hc=e.$4hc=void 0;class s extends L.$vj{get disposed(){return this.n}constructor(u,t,f,n,w){super(),this.id=u,this.name=t,this.r=f,this.s=n,this.extension=w,this.m=0,this.n=!1,this.visible=!1,this.setLevel(f.getLevel()),this.B(f.onDidChangeLogLevel(D=>this.setLevel(D)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Clear,u)}replace(u){const t=this.m;this.info(u),this.s.$update(this.id,m.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(u,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:t))}hide(){this.s.$close(this.id)}g(u,t){this.m+=l.$ke.fromString(t).byteLength,(0,L.log)(this.r,u,t),this.visible&&(this.r.flush(),this.s.$update(this.id,m.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends s{appendLine(u){this.append(u)}}let o=class{constructor(u,t,f,n,w,D){this.i=t,this.j=f,this.k=n,this.l=w,this.m=D,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(S.$lL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.$zm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[t,f]of this.g)f.visible=t===this.h}createOutputChannel(u,t,f){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const n=typeof t=="object"&&t.log,w=(0,$.$Jf)(t)?t:void 0;if((0,$.$Jf)(w)&&!w.trim())throw new Error("illegal argument `languageId`. must not be empty");let D;const h=this.i.environment.extensionLogLevel?.find(([P])=>R.$nm.equals(f.identifier,P))?.[1];h&&(D=(0,L.$Fj)(h));const b=n?this.o(u,D,f):this.n(u,w,f);return b.then(P=>{this.g.set(P.id,P),P.visible=P.id===this.h}),n?this.r(u,D??this.m.getLevel(),b):this.q(u,b)}async n(u,t,f){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const n=await this.c,w=this.k.extUri.joinPath(n,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),D=this.l.createLogger(w,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),h=await this.a.$register(u,w,t,f.identifier.value);return new s(h,u,D,this.a,f)}async o(u,t,f){const n=await this.p(f),w=u.replace(/[\\/:\*\?"<>\|]/g,""),D=this.k.extUri.joinPath(n,`${w}.log`),h=`${f.identifier.value}.${w}`,b=this.l.createLogger(D,{id:h,name:u,logLevel:t,extensionId:f.identifier.value});return new i(h,u,b,this.a,f)}p(u){let t=this.d.get(u.identifier.value);if(!t){const f=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(f)}catch(n){if((0,p.$Ik)(n)!==p.FileSystemProviderErrorCode.FileExists)throw n}return f})())}return t}q(u,t){let f=!1;const n=()=>{if(f)throw new Error("Channel has been closed")};return{get name(){return u},append(w){n(),t.then(D=>D.append(w))},appendLine(w){n(),t.then(D=>D.appendLine(w))},clear(){n(),t.then(w=>w.clear())},replace(w){n(),t.then(D=>D.replace(w))},show(w,D){n(),t.then(h=>h.show(w,D))},hide(){n(),t.then(w=>w.hide())},dispose(){f=!0,t.then(w=>w.dispose())}}}r(u,t,f){const n=new c.$Sc,w=()=>{if(n.isDisposed)throw new Error("Channel has been closed")},D=n.add(new r.$Wd);function h(b){t=b,D.fire(b)}return f.then(b=>{n.add(b),b.logLevel!==t&&h(b.logLevel),n.add(b.onDidChangeLogLevel(P=>h(P)))}),{...this.q(u,f),get logLevel(){return t},onDidChangeLogLevel:D.event,trace(b,...P){w(),f.then(g=>g.trace(b,...P))},debug(b,...P){w(),f.then(g=>g.debug(b,...P))},info(b,...P){w(),f.then(g=>g.info(b,...P))},warn(b,...P){w(),f.then(g=>g.warn(b,...P))},error(b,...P){w(),f.then(g=>g.error(b,...P))},dispose(){n.dispose()}}}};e.$4hc=o,e.$4hc=o=Ge([qe(0,I.$wN),qe(1,y.$MN),qe(2,d.$Qgc),qe(3,A.$qgc),qe(4,L.$qj),qe(5,L.$pj)],o),e.$5hc=(0,M.$8h)("IExtHostOutputService")}),define(Re[113],Ae([1,0,4,11]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pm=e.$Om=void 0,e.$Om=(0,S.$8h)("remoteAgentService"),e.$Pm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(I){let R=1/0;for(let m=0;m<this.maxSampleCount;m++){const d=await I.getRoundTripTime();if(d===void 0)return;R=Math.min(R,d/2),await(0,M.$9g)(this.sampleDelay)}this.average.push(R),this.average.length>this.maxAverageCount&&this.average.shift();let L;return this.initial.length<this.maxInitialCount?this.initial.push(R):L=this.initial.reduce((m,d)=>m+d,0)/this.initial.length,this.lastMeasurement={initial:L,current:R,average:this.average.reduce((m,d)=>m+d,0)/this.average.length,high:typeof L>"u"?!1:R>this.highLatencyMaxThreshold||R>this.highLatencyMinThreshold&&R>L*this.highLatencyMultiple},this.lastMeasurement}}}),define(Re[280],Ae([1,0,169,55,30,48,47,6,5,113,20,26,11]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$H=e.$0H=e.$9H=e.$8H=e.$7H=e.$6H=e.$5H=void 0,e.$5H=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$6H=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$7H=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$8H=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$9H={ConfigurationMigration:"base.contributions.configuration.migration"};class ${constructor(){this.migrations=[],this.a=new d.$Wd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(i){this.migrations.push(...i)}}const p=new $;I.$Kn.add(e.$9H.ConfigurationMigration,p);let r=class extends m.$Tc{static{this.ID="workbench.contrib.configurationMigration"}constructor(i,o){super(),this.a=i,this.b=o,this.B(this.b.onDidChangeWorkspaceFolders(async a=>{for(const u of a.added)await this.f(u,p.migrations)})),this.c(p.migrations),this.B(p.onDidRegisterConfigurationMigration(a=>this.c(a)))}async c(i){await this.f(void 0,i);for(const o of this.b.getWorkspace().folders)await this.f(o,i)}async f(i,o){await Promise.all([o.map(a=>this.g(a,i?.uri))])}async g(i,o){const a=this.a.inspect(i.key,{resource:o}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[t,f]of u){const n=a[t];if(!n)continue;const w=[];if(n.value!==void 0){const D=await this.h(i,t,n.value,o,void 0);for(const h of D??[])w.push([h,[]])}for(const{identifiers:D,value:h}of n.overrides??[])if(h!==void 0){const b=await this.h(i,t,h,o,D);for(const P of b??[])w.push([P,D])}w.length&&await Promise.allSettled(w.map(async([[D,h],b])=>this.a.updateValue(D,h.value,{resource:o,overrideIdentifiers:b},f)))}}async h(i,o,a,u,t){const f=w=>{const h=this.a.inspect(w,{resource:u})[o];if(h)return t?h.overrides?.find(({identifiers:b})=>(0,k.$Cn)(b,t))?.value:h.value},n=await i.migrateFn(a,f);return Array.isArray(n)?n:[[i.key,n]]}};e.$0H=r,e.$0H=r=Ge([qe(0,L.$Bi),qe(1,R.$ei)],r);let c=class extends m.$Tc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(i){super(),this.b=i,this.a=new l.$sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!A.$i&&(await this.b.getEnvironment())?.os!==1)return;I.$Kn.as(M.$Pn.Configuration).registerConfiguration({...e.$7H,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$$H=c,e.$$H=c=Ge([qe(0,y.$Om)],c)}),define(Re[281],Ae([1,0,34,12,19,24,177,280,55,4,30]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rdb=e.$Qdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$Pdb=e.$Odb=void 0,e.$Odb=(0,y.$8h)("editorResolverService"),e.$Pdb="workbench.editorAssociations";const k=A.$Kn.as(d.$Pn.Configuration),l={...m.$6H,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,L.localize)(0,null),additionalProperties:{type:"string"}}}};k.registerConfiguration(l);var $;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})($||(e.RegisteredEditorPriority=$={}));var p;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(p||(e.ResolvedStatus=p={}));function r(s){switch(s){case $.exclusive:return 5;case $.default:return 4;case $.builtin:return 3;case $.option:default:return 1}}e.$Qdb=r;function c(s,i){if(new Set([M.Schemas.extension,M.Schemas.webviewPanel,M.Schemas.vscodeWorkspaceTrust,M.Schemas.vscodeSettings]).has(i.scheme))return!1;const u=typeof s=="string"&&s.indexOf(I.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,R.$Fg)(i);return S.$Nj(typeof s=="string"?s.toLowerCase():s,u.toLowerCase())}e.$Rdb=c}),define(Re[282],Ae([1,0,45,12,19,20,24,2,4,198,48,216,113]),function(me,e,S,M,I,R,L,m,d,y,A,k,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=e.$ZK=void 0,e.$ZK=(0,d.$8h)("pathService");let p=$=class{constructor(c,s,i,o){this.d=c,this.e=s,this.f=i,this.g=o,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const a=await this.e.getEnvironment();return this.c=a?.userHome??c})()}hasValidBasename(c,s,i){return typeof s=="string"||typeof s>"u"?this.a.then(o=>this.h(c,o,s)):this.h(c,s,i)}h(c,s,i){return c.scheme===M.Schemas.file||c.scheme===M.Schemas.vscodeRemote?(0,S.$7f)(i??(0,L.$Fg)(c),s===1):!0}get defaultUriScheme(){return $.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(c,s){if(c.remoteAuthority)return M.Schemas.vscodeRemote;const i=(0,y.$WK)(s.getWorkspace());if(i)return i;const o=s.getWorkspace().folders[0];if(o)return o.uri.scheme;const a=s.getWorkspace().configuration;return a?a.scheme:M.Schemas.file}userHome(c){return c?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(c=>c===1?I.$fc:I.$gc)}async fileURI(c){let s="";if(await this.a===1&&(c=c.replace(/\\/g,"/")),c[0]==="/"&&c[1]==="/"){const o=c.indexOf("/",2);o===-1?(s=c.substring(2),c="/"):(s=c.substring(2,o),c=c.substring(o)||"/")}return m.URI.from({scheme:M.Schemas.file,authority:s,path:c,query:"",fragment:""})}};e.$1K=p,e.$1K=p=$=Ge([qe(1,l.$Om),qe(2,k.$IK),qe(3,A.$ei)],p)}),define(Re[114],Ae([1,0]),function(me,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$BJ=e.$AJ=void 0;class S{constructor(L,m){this.line=L,this.character=m}isBefore(L){return!1}isBeforeOrEqual(L){return!1}isAfter(L){return!1}isAfterOrEqual(L){return!1}isEqual(L){return!1}compareTo(L){return 0}translate(L,m){return new S(0,0)}with(L){return new S(0,0)}}e.$AJ=S;class M{constructor(L,m,d,y){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(L,m),this.end=new S(d,y)}contains(L){return!1}isEqual(L){return!1}intersection(L){}union(L){return new M(0,0,0,0)}with(L){return new M(0,0,0,0)}}e.$BJ=M;var I;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Re[44],Ae([1,0,18,34,26,45,14,4,19,15,114,11]),function(me,e,S,M,I,R,L,m,d,y,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.$2J=e.$1J=e.$ZJ=e.$YJ=e.$XJ=e.$WJ=e.$VJ=e.$UJ=e.$TJ=e.$SJ=e.$RJ=e.SearchErrorCode=e.$QJ=e.$PJ=e.SearchSortOrder=e.ViewMode=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.SearchCompletionExitCode=e.$KJ=e.$JJ=e.$IJ=e.QueryType=e.SearchProviderType=e.$HJ=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$CJ="workbench.view.search",e.$DJ="workbench.panel.search",e.$EJ="workbench.view.search",e.$FJ="search-result",e.$GJ="search.exclude";const l="\u27EA ",$=" characters skipped \u27EB",p=(l.length+$.length+5)*2;e.$HJ=(0,m.$8h)("searchService");var r;(function(le){le[le.file=0]="file",le[le.text=1]="text"})(r||(e.SearchProviderType=r={}));var c;(function(le){le[le.File=1]="File",le[le.Text=2]="Text"})(c||(e.QueryType=c={}));function s(le){return!!le.preview}e.$IJ=s;function i(le){return!!le.resource}e.$JJ=i;function o(le){return!!le.message}e.$KJ=o;var a;(function(le){le[le.Normal=0]="Normal",le[le.NewSearchStarted=1]="NewSearchStarted"})(a||(e.SearchCompletionExitCode=a={}));class u{constructor(ve){this.resource=ve,this.results=[]}}e.$LJ=u;class t{constructor(ve,se,$e,te){this.ranges=se,this.webviewIndex=te;const X=Array.isArray(se)?se:[se];if($e&&$e.matchLines===1&&f(X)){ve=(0,L.$Cf)(ve,$e.matchLines);let V="",ie=0,Ce=0;const Te=Math.floor($e.charsPerLine/5),Pe=[];for(const be of X){const ge=Math.max(be.startColumn-Te,0),G=be.startColumn+$e.charsPerLine;if(ge>Ce+Te+p){const _=l+(ge-Ce)+$;V+=_+ve.slice(ge,G),ie+=ge-(Ce+_.length)}else V+=ve.slice(Ce,G);Pe.push(new w(0,be.startColumn-ie,be.endColumn-ie)),Ce=G}this.preview={text:V,matches:Array.isArray(this.ranges)?Pe:Pe[0]}}else{const V=Array.isArray(se)?se[0].startLineNumber:se.startLineNumber;this.preview={text:ve,matches:(0,S.$2b)(se,ie=>new n(ie.startLineNumber-V,ie.startColumn,ie.endLineNumber-V,ie.endColumn))}}}}e.$MJ=t;function f(le){const ve=le[0].startLineNumber;for(const se of le)if(se.startLineNumber!==ve||se.endLineNumber!==ve)return!1;return!0}class n{constructor(ve,se,$e,te){this.startLineNumber=ve,this.startColumn=se,this.endLineNumber=$e,this.endColumn=te}}e.$NJ=n;class w extends n{constructor(ve,se,$e){super(ve,se,ve,$e)}}e.$OJ=w;var D;(function(le){le.List="list",le.Tree="tree"})(D||(e.ViewMode=D={}));var h;(function(le){le.Default="default",le.FileNames="fileNames",le.Type="type",le.Modified="modified",le.CountDescending="countDescending",le.CountAscending="countAscending"})(h||(e.SearchSortOrder=h={}));function b(le,ve=!0){const se=le&&le.files&&le.files.exclude,$e=ve&&le&&le.search&&le.search.exclude;if(!se&&!$e)return;if(!se||!$e)return se||$e;let te=Object.create(null);return te=I.$Bn(te,I.$yn(se)),te=I.$Bn(te,I.$yn($e),!0),te}e.$PJ=b;function P(le,ve){return le.excludePattern&&M.$Nj(le.excludePattern,ve)?!1:le.includePattern||le.usingSearchPaths?le.includePattern&&M.$Nj(le.includePattern,ve)?!0:le.usingSearchPaths?!!le.folderQueries&&le.folderQueries.some(se=>{const $e=se.folder.fsPath;if(R.$9f(ve,$e)){const te=d.$lc($e,ve);return!se.includePattern||!!M.$Nj(se.includePattern,te)}else return!1}):!1:!0}e.$QJ=P;var g;(function(le){le[le.unknownEncoding=1]="unknownEncoding",le[le.regexParseError=2]="regexParseError",le[le.globParseError=3]="globParseError",le[le.invalidLiteral=4]="invalidLiteral",le[le.rgProcessError=5]="rgProcessError",le[le.other=6]="other",le[le.canceled=7]="canceled"})(g||(e.SearchErrorCode=g={}));class v extends Error{constructor(ve,se){super(ve),this.code=se}}e.$RJ=v;function E(le){const ve=le.message;if((0,y.$4)(le))return new v(ve,g.canceled);try{const se=JSON.parse(ve);return new v(se.message,se.code)}catch{return new v(ve,g.other)}}e.$SJ=E;function T(le){const ve={message:le.message,code:le.code};return new Error(JSON.stringify(ve))}e.$TJ=T;function N(le){return le.type==="error"?!0:le.type==="success"}e.$UJ=N;function J(le){return le.type==="success"}e.$VJ=J;function q(le){return!!le.path}e.$WJ=q;function U(le,ve,se=!0){const $e=le.searchPath?le.searchPath:le.relativePath;return se?(0,L.$zf)($e,ve):M.$Nj(ve,$e)}e.$XJ=U;class C{constructor(ve){this.path=ve,this.results=[]}addMatch(ve){this.results.push(ve)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$YJ=C;function F(le,ve){const se={...le||{},...ve||{}};return Object.keys(se).filter($e=>{const te=se[$e];return typeof te=="boolean"&&te})}e.$ZJ=F;class W{constructor(ve,se){this.c=null,this.a={...ve.excludePattern||{},...se.excludePattern||{}},this.b=M.$Oj(this.a);let $e=ve.includePattern;se.includePattern&&($e?$e={...$e,...se.includePattern}:$e=se.includePattern),$e&&(this.c=M.$Oj($e))}matchesExcludesSync(ve,se,$e){return!!(this.b&&this.b(ve,se,$e))}includedInQuerySync(ve,se,$e){return!(this.b&&this.b(ve,se,$e)||this.c&&!this.c(ve,se,$e))}includedInQuery(ve,se,$e){const te=this.b(ve,se,$e),X=()=>this.c?!!this.c(ve,se,$e):!0;return(0,k.$Tg)(te)?te.then(V=>V?!1:X()):X()}hasSiblingExcludeClauses(){return re(this.a)}}e.$1J=W;function re(le){for(const ve in le)if(typeof le[ve]!="boolean")return!0;return!1}function ce(le){if(!le)return;let ve;return se=>(ve||(ve=(le()||Promise.resolve([])).then($e=>$e?De($e):{})),ve.then($e=>!!$e[se]))}e.$2J=ce;function we(le){if(!le)return;let ve;return se=>{if(!ve){const $e=le();ve=$e?De($e):{}}return!!ve[se]}}e.$3J=we;function De(le){const ve={};for(const se of le)ve[se]=!0;return ve}}),define(Re[36],Ae([1,0,18,11,21,5,6,51,12,122,24,14,2,168,4,13,187,48,43,27,17,8,7,58,44,3,52]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f,n,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lgc=e.$Kgc=void 0;function h(J,q,U){return new A.$xg(C=>v(C,U)).isEqual(J,q)}function b(J,q,U){return h(J.uri,q.uri,U)?0:(0,k.$6e)(J.uri.toString(),q.uri.toString())}function P(J,q,U){return J.index!==q.index?J.index<q.index?-1:1:h(J.uri,q.uri,U)?(0,k.$6e)(J.name,q.name):(0,k.$6e)(J.uri.toString(),q.uri.toString())}function g(J,q,U,C){const F=J.slice(0).sort((re,ce)=>U(re,ce,C)),W=q.slice(0).sort((re,ce)=>U(re,ce,C));return(0,S.$Eb)(F,W,(re,ce)=>U(re,ce,C))}function v(J,q){const U=q.getCapabilities(J.scheme);return!(U&&U&1024)}class E extends s.$oi{static toExtHostWorkspace(q,U,C,F){if(!q)return{workspace:null,added:[],removed:[]};const{id:W,name:re,folders:ce,configuration:we,transient:De,isUntitled:le}=q,ve=[],se=U;U?ce.forEach((V,ie)=>{const Ce=l.URI.revive(V.uri),Te=E.o(C||U,Ce,F);Te?(Te.name=V.name,Te.index=V.index,ve.push(Te)):ve.push({uri:Ce,name:V.name,index:ie})}):ve.push(...ce.map(({uri:V,name:ie,index:Ce})=>({uri:l.URI.revive(V),name:ie,index:Ce}))),ve.sort((V,ie)=>V.index<ie.index?-1:1);const $e=new E(W,re,ve,!!De,we?l.URI.revive(we):null,!!le,V=>v(V,F)),{added:te,removed:X}=g(se?se.workspaceFolders:[],$e.workspaceFolders,b,F);return{workspace:$e,added:te,removed:X}}static o(q,U,C){for(let F=0;F<q.folders.length;F++){const W=q.workspaceFolders[F];if(h(W.uri,U,C))return W}}constructor(q,U,C,F,W,re,ce){super(q,C.map(we=>new s.$pi(we)),F,W,ce),this.t=U,this.u=re,this.q=[],this.s=m.$bi.forUris(ce),C.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(q,U){return U&&this.s.get(q)&&(q=(0,A.$Hg)(q)),this.s.findSubstr(q)}resolveWorkspaceFolder(q){return this.s.get(q)}}let T=class{constructor(q,U,C,F,W){this.c=new R.$Wd,this.onDidChangeWorkspace=this.c.event,this.g=new R.$Wd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new R.$Yd,this.C=new Map,this.h=F,this.s=C,this.t=W,this.j=new y.$$l,this.k=new M.$7g,this.o=q.getProxy(w.$lL.MainThreadWorkspace),this.q=q.getProxy(w.$lL.MainThreadMessageService);const re=U.workspace;this.l=re?new E(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ce=>v(ce,C)):void 0}$initializeWorkspace(q,U){this.v=U,this.$acceptWorkspaceData(q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:d.Schemas.untitled,path:(0,A.$Fg)((0,A.$Hg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(q,U,C,...F){const W=[];if(Array.isArray(F)&&F.forEach(le=>{l.URI.isUri(le.uri)&&!W.some(ve=>h(ve.uri,le.uri,this.s))&&W.push({uri:le.uri,name:le.name||(0,A.$Eg)(le.uri)})}),this.n||[U,C].some(le=>typeof le!="number"||le<0)||C===0&&W.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(U+C>re.length)return!1;const ce=re.slice(0);ce.splice(U,C,...W.map(le=>({uri:le.uri,name:le.name||(0,A.$Eg)(le.uri),index:void 0})));for(let le=0;le<ce.length;le++){const ve=ce[le];if(ce.some((se,$e)=>$e!==le&&h(ve.uri,se.uri,this.s)))return!1}ce.forEach((le,ve)=>le.index=ve);const{added:we,removed:De}=g(re,ce,P,this.s);if(we.length===0&&De.length===0)return!1;if(this.o){const le=q.displayName||q.name;this.o.$updateWorkspaceFolders(le,U,C,W).then(void 0,ve=>{this.n=void 0;const se={source:{identifier:q.identifier,label:q.displayName||q.name}};this.q.$showMessage(c.Severity.Error,(0,$.localize)(0,null,le,ve.toString()),se,[])})}return this.y(ce),!0}getWorkspaceFolder(q,U){if(this.x)return this.x.getWorkspaceFolder(q,U)}async getWorkspaceFolder2(q,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(q,U)}async resolveWorkspaceFolder(q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(q)}getPath(){if(!this.x)return;const{folders:q}=this.x;if(q.length!==0)return q[0].uri.fsPath}getRelativePath(q,U){let C,F="";if(typeof q=="string"?(C=l.URI.file(q),F=q):typeof q<"u"&&(C=q,F=q.fsPath),!C)return F;const W=this.getWorkspaceFolder(C,!0);if(!W)return F;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let re=(0,A.$Kg)(W.uri,C);return U&&W.name&&(re=`${W.name}/${re}`),re}y(q){this.x&&(this.n=E.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(q){const{workspace:U,added:C,removed:F}=E.toExtHostWorkspace(q,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:C,removed:F}))}findFiles(q,U,C,F,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${F.value}, entryPoint: findFiles`);let re="",ce=!0;return U===null?ce=!1:U!==void 0&&(typeof U=="string"?re=U:re=U.pattern),this.z(q,void 0,{exclude:re,maxResults:C,useDefaultExcludes:ce,useDefaultSearchExcludes:!1,useIgnoreFiles:!0},W)}findFiles2(q,U={},C,F=I.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${C.value}, entryPoint: findFiles2`),this.z(void 0,q,U,F)}async z(q,U,C,F=I.CancellationToken.None){if(F&&F.isCancellationRequested)return Promise.resolve([]);const W=typeof C.exclude=="string"?C.exclude:C.exclude?C.exclude.pattern:void 0,re={ignoreSymlinks:typeof C.followSymlinks=="boolean"?!C.followSymlinks:void 0,disregardIgnoreFiles:typeof C.useIgnoreFiles=="boolean"?!C.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof C.useGlobalIgnoreFiles=="boolean"?!C.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof C.useParentIgnoreFiles=="boolean"?!C.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof C.useDefaultExcludes=="boolean"?!C.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof C.useDefaultSearchExcludes=="boolean"?!C.useDefaultSearchExcludes:!1,maxResults:C.maxResults,excludePattern:W,shouldGlobSearch:typeof C.fuzzy=="boolean"?!C.fuzzy:!0,_reason:"startFileSearch"};let ce;if(q){const{includePattern:we,folder:De}=N(u.GlobPattern.from(q));ce=De,re.includePattern=we}else{const{includePattern:we,folder:De}=N(u.GlobPattern.from(U));ce=De,re.filePattern=we}return this.o.$startFileSearch(ce??null,re,F).then(we=>Array.isArray(we)?we.map(De=>l.URI.revive(De)):[])}async findTextInFiles(q,U,C,F,W=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${F.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ce=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:we,folder:De}=N(u.GlobPattern.from(U.include)),le=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,ve={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:ce,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:we,excludePattern:le},se=!1;if(this.u[re]=$e=>{if(se)return;const te=l.URI.revive($e.resource);$e.results.forEach(X=>{const V=(0,D.$Eh)(X);(0,n.$IJ)(V)?C({uri:te,preview:{text:V.preview.text,matches:(0,S.$2b)(V.preview.matches,ie=>new t.$pL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,S.$2b)(V.ranges,ie=>new t.$pL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):C({uri:te,text:V.text,lineNumber:V.lineNumber})})},W.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(q,De??null,ve,re,W);return delete this.u[re],$e||{}}catch($e){throw delete this.u[re],$e}}$handleTextSearchResult(q,U){this.u[U]?.(q)}async save(q){const U=await this.o.$save(q,{saveAs:!1});return l.URI.revive(U)}async saveAs(q){const U=await this.o.$save(q,{saveAs:!0});return l.URI.revive(U)}saveAll(q){return this.o.$saveAll(q)}resolveProxy(q){return this.o.$resolveProxy(q)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(q){return this.o.$requestWorkspaceTrust(q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(q,U){if(this.w.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.w.set(q,U);const C=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerEditSessionIdentityProvider(F,C),(0,L.$Rc)(()=>{this.w.delete(q),this.o.$unregisterEditSessionIdentityProvider(F)})}async $getEditSessionIdentifier(q,U){this.h.info("Getting edit session identifier for workspaceFolder",q);const C=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!C){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",C);const F=this.w.get(C.uri.scheme);if(this.h.info(`Provider for scheme ${C.uri.scheme} is defined: `,!!F),!F)return;const W=await F.provideEditSessionIdentity(C,U);if(this.h.info("Provider returned edit session identifier: ",W),!!W)return W}async $provideEditSessionIdentityMatch(q,U,C,F){this.h.info("Getting edit session identifier for workspaceFolder",q);const W=await this.resolveWorkspaceFolder(l.URI.revive(q));if(!W){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",W);const re=this.w.get(W.uri.scheme);if(this.h.info(`Provider for scheme ${W.uri.scheme} is defined: `,!!re),!re)return;const ce=await re.provideEditSessionIdentityMatch?.(U,C,F);if(this.h.info("Provider returned edit session identifier match result: ",ce),!!ce)return ce}getOnWillCreateEditSessionIdentityEvent(q){return(U,C,F)=>{const W=function(ce){U.call(C,ce)};return W.extension=q,this.B.event(W,void 0,F)}}async $onWillCreateEditSessionIdentity(q,U,C){const F=await this.resolveWorkspaceFolder(l.URI.revive(q));if(F===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:F},U,async(W,re)=>{const ce=Date.now();await Promise.resolve(W),Date.now()-ce>C&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),U.isCancellationRequested}registerCanonicalUriProvider(q,U){if(this.C.has(q))throw new Error(`A provider has already been registered for scheme ${q}`);this.C.set(q,U);const C=this.t.transformOutgoingScheme(q),F=this.A++;return this.o.$registerCanonicalUriProvider(F,C),(0,L.$Rc)(()=>{this.C.delete(q),this.o.$unregisterCanonicalUriProvider(F)})}async provideCanonicalUri(q,U,C){const F=this.C.get(q.scheme);if(!F)return;const W=await F.provideCanonicalUri?.(l.URI.revive(q),U,C);if(W)return W}async $provideCanonicalUri(q,U,C){return this.provideCanonicalUri(l.URI.revive(q),{targetScheme:U},C)}};e.$Kgc=T,e.$Kgc=T=Ge([qe(0,a.$wN),qe(1,o.$MN),qe(2,i.$qgc),qe(3,r.$pj),qe(4,f.$Igc)],T),e.$Lgc=(0,p.$8h)("IExtHostWorkspace");function N(J){let q,U;return J&&(typeof J=="string"?q=J:(q=J.pattern,U=l.URI.revive(J.baseUri))),{includePattern:q,folder:U}}}),define(Re[37],Ae([1,0,26,5,36,3,7,189,55,16,11,4,17,13,2]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=e.$Ngc=e.$Mgc=void 0;function r(f,n){if(n){const w=n.split(".");let D=f;for(let h=0;D&&h<w.length;h++)D=D[w[h]];return D}}function c(f){return f instanceof p.URI}function s(f){return f&&f.uri instanceof p.URI&&f.languageId&&typeof f.languageId=="string"}function i(f){return f&&!f.uri&&f.languageId&&typeof f.languageId=="string"}function o(f){return f&&f.uri instanceof p.URI&&(!f.name||typeof f.name=="string")&&(!f.index||typeof f.index=="number")}function a(f){if(c(f))return{resource:f};if(s(f))return{resource:f.uri,overrideIdentifier:f.languageId};if(i(f))return{overrideIdentifier:f.languageId};if(o(f))return{resource:f.uri};if(f===null)return{resource:null}}let u=class{constructor(n,w,D){this.a=n.getProxy(R.$lL.MainThreadConfiguration),this.c=w,this.b=D,this.d=new A.$7g,this.e=null}getConfigProvider(){return this.d.wait().then(n=>this.e)}$initializeConfiguration(n){this.e=new t(this.a,this.c,n,this.b),this.d.open()}$acceptConfigurationChanged(n,w){this.getConfigProvider().then(D=>D.$acceptConfigurationChanged(n,w))}};e.$Mgc=u,e.$Mgc=u=Ge([qe(0,l.$wN),qe(1,I.$Lgc),qe(2,$.$pj)],u);class t{constructor(n,w,D,h){this.a=new M.$Wd,this.b=n,this.f=h,this.c=w,this.e=m.$9n.parse(D),this.d=this.k(D.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(n,w){const D={data:this.e.toData(),workspace:this.c.workspace};this.e=m.$9n.parse(n),this.d=this.k(n.configurationScopes),this.a.fire(this.j(w,D))}getConfiguration(n,w,D){const h=a(w)||{},b=this.g(n?r(this.e.getValue(void 0,h,this.c.workspace),n):this.e.getValue(void 0,h,this.c.workspace));n&&this.h(n,h,D?.identifier);function P(v){if(v==null)return null;if(typeof v=="boolean")return v?2:5;switch(v){case L.ConfigurationTarget.Global:return 2;case L.ConfigurationTarget.Workspace:return 5;case L.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(v){return typeof r(b,v)<"u"},get:(v,E)=>{this.h(n?`${n}.${v}`:v,h,D?.identifier);let T=r(b,v);if(typeof T>"u")T=E;else{let N;const J=(q,U)=>{if((0,y.$Lf)(q)){let C;const F=()=>{N=N||(0,S.$yn)(b),C=C||r(N,U)};return new Proxy(q,{get:(W,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return F(),()=>C;if(N)return C=C||r(N,U),C[re];const ce=W[re];return typeof re=="string"?J(ce,`${U}.${re}`):ce},set:(W,re,ce)=>(F(),C&&(C[re]=ce),!0),deleteProperty:(W,re)=>(F(),C&&delete C[re],!0),defineProperty:(W,re,ce)=>(F(),C&&Object.defineProperty(C,re,ce),!0)})}return Array.isArray(q)?(0,S.$yn)(q):q};T=J(T,v)}return T},update:(v,E,T,N)=>{v=n?`${n}.${v}`:v;const J=P(T);return E!==void 0?this.b.$updateConfigurationOption(J,v,E,h,N):this.b.$removeConfigurationOption(J,v,h,N)},inspect:v=>{v=n?`${n}.${v}`:v;const E=this.e.inspect(v,h,this.c.workspace);if(E)return{key:v,defaultValue:(0,S.$yn)(E.policy?.value??E.default?.value),globalValue:(0,S.$yn)(E.user?.value??E.application?.value),workspaceValue:(0,S.$yn)(E.workspace?.value),workspaceFolderValue:(0,S.$yn)(E.workspaceFolder?.value),defaultLanguageValue:(0,S.$yn)(E.default?.override),globalLanguageValue:(0,S.$yn)(E.user?.override??E.application?.override),workspaceLanguageValue:(0,S.$yn)(E.workspace?.override),workspaceFolderLanguageValue:(0,S.$yn)(E.workspaceFolder?.override),languageIds:(0,S.$yn)(E.overrideIdentifiers)}}};return typeof b=="object"&&(0,S.$Bn)(g,b,!1),Object.freeze(g)}g(n){const w=D=>(0,y.$Lf)(D)?new Proxy(D,{get:(h,b)=>w(h[b]),set:(h,b,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(h,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(h,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:h=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):D;return w(n)}h(n,w,D){const h=d.$Zn.test(n)?4:this.d.get(n),b=D?`[${D.value}] `:"";if(h===4){typeof w?.resource>"u"&&this.f.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(h===3){w?.resource&&this.f.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(n,w){const D=new m.$$n(n,w,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(h,b)=>D.affectsConfiguration(h,a(b))})}k(n){return n.reduce((w,D)=>(w.set(D[0],D[1]),w),new Map)}}e.$Ngc=t,e.$Ogc=(0,k.$8h)("IExtHostConfiguration")}),define(Re[115],Ae([1,0,2,11,5,3,7,36,66,37,21,65,17,27,4,12,20,13,78,221,15]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=e.$eic=e.$dic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(u||(u={}));var t;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(t||(t={}));var f;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(f||(f={}));var n;(function(J){function q(F){if(F){const W=F;return W&&!!W.process}else return!1}J.is=q;function U(F){if(F==null)return;const W={process:F.process,args:F.args};return F.options&&(W.options=f.from(F.options)),W}J.from=U;function C(F){if(F!=null)return new L.$9L(F.process,F.args,F.options)}J.to=C})(n||(n={}));var w;(function(J){function q(C){if(C!=null)return C}J.from=q;function U(C){if(C!=null)return C}J.to=U})(w||(w={}));var D;(function(J){function q(F){if(F){const W=F;return W&&(!!W.commandLine||!!W.command)}else return!1}J.is=q;function U(F){if(F==null)return;const W={};return F.commandLine!==void 0?W.commandLine=F.commandLine:(W.command=F.command,W.args=F.args),F.options&&(W.options=w.from(F.options)),W}J.from=U;function C(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new L.$0L(F.commandLine,F.options):new L.$0L(F.command,F.args?F.args:[],F.options)}J.to=C})(D||(D={}));var h;(function(J){function q(F){if(F){const W=F;return W&&W.customExecution==="customExecution"}else return!1}J.is=q;function U(F){return{customExecution:"customExecution"}}J.from=U;function C(F,W){return W.get(F)}J.to=C})(h||(e.CustomExecutionDTO=h={}));var b;(function(J){function q(U,C){let F;return U.scope!==void 0&&typeof U.scope!="number"?F=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===L.TaskScope.Workspace&&C&&C.workspaceFile?F=C.workspaceFile:F=o.$EG),{id:U._id,workspaceFolder:F}}J.from=q})(b||(e.TaskHandleDTO=b={}));var P;(function(J){function q(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}J.from=q})(P||(P={}));var g;(function(J){function q(F,W){if(F==null)return[];const re=[];for(const ce of F){const we=U(ce,W);we&&re.push(we)}return re}J.fromMany=q;function U(F,W){if(F==null)return;let re;F.execution instanceof L.$9L?re=n.from(F.execution):F.execution instanceof L.$0L?re=D.from(F.execution):F.execution&&F.execution instanceof L.$$L&&(re=h.from(F.execution));const ce=u.from(F.definition);let we;return F.scope?typeof F.scope=="number"?we=F.scope:we=F.scope.uri:we=L.TaskScope.Workspace,!ce||!we?void 0:{_id:F._id,definition:ce,name:F.name,source:{extensionId:W.identifier.value,label:F.source,scope:we},execution:re,isBackground:F.isBackground,group:P.from(F.group),presentationOptions:t.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}J.from=U;async function C(F,W,re){if(F==null)return;let ce;n.is(F.execution)?ce=n.to(F.execution):D.is(F.execution)?ce=D.to(F.execution):h.is(F.execution)&&(ce=h.to(F._id,re));const we=u.to(F.definition);let De;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?De=F.source.scope:De=await W.resolveWorkspaceFolder(S.URI.revive(F.source.scope)):De=L.TaskScope.Workspace),!we||!De)return;const le=new L.$_L(we,De,F.name,F.source.label,ce,F.problemMatchers);return F.isBackground!==void 0&&(le.isBackground=F.isBackground),F.group!==void 0&&(le.group=L.$8L.from(F.group._id),le.group&&F.group.isDefault&&(le.group=new L.$8L(le.group.id,le.group.label),F.group.isDefault===!0&&(le.group.isDefault=F.group.isDefault))),F.presentationOptions&&(le.presentationOptions=t.to(F.presentationOptions)),F._id&&(le._id=F._id),F.detail&&(le.detail=F.detail),le}J.to=C})(g||(e.TaskDTO=g={}));var v;(function(J){function q(C){return C}J.from=q;function U(C){if(C)return Object.assign(Object.create(null),C)}J.to=U})(v||(v={}));class E{#e;constructor(q,U,C){this._id=U,this.a=C,this.#e=q}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}let T=class{constructor(q,U,C,F,W,re,ce,we){this.q=new I.$Wd,this.r=new I.$Wd,this.s=new I.$Wd,this.u=new I.$Wd,this.a=q.getProxy(R.$lL.MainThreadTask),this.b=C,this.c=F,this.d=W,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ce,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(q,U,C){if(!C)return new L.$nL(()=>{});const F=this.x();return this.j.set(F,{type:U,provider:C,extension:q}),this.a.$registerTaskProvider(F,U),new L.$nL(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(q,U){this.a.$registerTaskSystem(q,U)}fetchTasks(q){return this.a.$fetchTasks(v.from(q)).then(async U=>{const C=[];for(const F of U){const W=await g.to(F,this.b,this.m);W&&C.push(W)}return C})}get taskExecutions(){const q=[];return this.k.forEach(U=>q.push(U)),q}terminateTask(q){if(!(q instanceof E))throw new Error("No valid task execution provided");return this.a.$terminateTask(q._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(q,U,C){const F=this.m.get(q.id);F&&(this.o.set(q.id,F),this.e.attachPtyToTerminal(U,await F.callback(C))),this.p=q.id,this.q.fire({execution:await this.z(q)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(q){if(!this.l.has(q.id))return;const U=await this.z(q);this.l.delete(q.id),this.k.delete(q.id),this.B(q),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(q){const U=await this.z(q.id);this.s.fire({execution:U,processId:q.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(q){const U=await this.z(q.id);this.u.fire({execution:U,exitCode:q.exitCode})}$provideTasks(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));const F=[],W=(0,M.$Zg)(()=>C.provider.provideTasks(A.CancellationToken.None)).then(re=>this.v(U,F,C,re));return new Promise(re=>{W.then(ce=>{Promise.all(F).then(()=>{re(ce)})})})}async $resolveTask(q,U){const C=this.j.get(q);if(!C)return Promise.reject(new Error("no handler found"));if(U.definition.type!==C.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${C.type}].`);const F=await g.to(U,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const W=await C.provider.resolveTask(F,A.CancellationToken.None);if(!W)return;this.A(W,C);const re=g.from(W,C.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(W.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return h.is(re.execution)&&await this.y(re,W,!0),await this.w(re)}x(){return this.h++}async y(q,U,C){const F=await this.a.$createTaskId(q);!C&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,U.execution)),this.m.set(F,U.execution)}async z(q,U){if(typeof q=="string"){const W=this.l.get(q);if(!W)throw new a.$bb("Unexpected: The specified task is missing an execution");return W}const C=this.l.get(q.id);if(C)return C;let F;return U?F=Promise.resolve(new E(this,q.id,U)):F=g.to(q.task,this.b,this.m).then(W=>{if(!W)throw new a.$bb("Unexpected: Task does not exist.");return new E(this,q.id,W)}),this.l.set(q.id,F),F.then(W=>(this.k.set(q.id,W),W))}A(q,U){q._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}B(q){this.o.get(q.id)&&this.o.delete(q.id),this.n.has(q.id)&&this.p!==q.id&&(this.m.delete(q.id),this.n.delete(q.id));const C=this.n.values();let F=C.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=C.next()}};e.$dic=T,e.$dic=T=Ge([qe(0,l.$wN),qe(1,$.$MN),qe(2,m.$Lgc),qe(3,d.$HN),qe(4,y.$Ogc),qe(5,k.$ahc),qe(6,s.$pj),qe(7,i.$tgc)],T);let N=class extends T{constructor(q,U,C,F,W,re,ce,we){super(q,U,C,F,W,re,ce,we),this.registerTaskSystem(r.Schemas.vscodeRemote,{scheme:r.Schemas.vscodeRemote,authority:"",platform:c.$h(0)})}async executeTask(q,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const C=g.from(U,q);if(C===void 0)throw new Error("Task is not valid");if(h.is(C.execution))await this.y(C,U,!1);else throw new a.$_;const F=await this.z(await this.a.$getTaskExecution(C),U);return this.a.$executeTask(C).catch(W=>{throw new Error(W)}),F}v(q,U,C,F){const W=[];if(F)for(const re of F){if(this.A(re,C),!re.definition||!q[re.definition.type]){const we=re.source?re.source:"No task source";this.f.warn(`The task [${we}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ce=g.from(re,C.extension);ce&&h.is(ce.execution)?(W.push(ce),U.push(this.y(ce,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:W,extension:C.extension}}async w(q){if(h.is(q.execution))return q;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(q,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,U,C){}};e.$eic=N,e.$eic=N=Ge([qe(0,l.$wN),qe(1,$.$MN),qe(2,m.$Lgc),qe(3,d.$HN),qe(4,y.$Ogc),qe(5,k.$ahc),qe(6,s.$pj),qe(7,i.$tgc)],N),e.$fic=(0,p.$8h)("IExtHostTask")}),define(Re[283],Ae([1,0,44,29]),function(me,e,S,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$J=e.$0J=e.$9J=void 0;function I(L){return"cellResults"in L}e.$9J=I,e.$0J="rawCell#";function R(L,m){let d=-1;const y=[];let A=[];return L.forEach(l=>{l.range.startLineNumber!==d&&A.length>0&&(y.push([...A]),A=[]),A.push(l),d=l.range.endLineNumber}),A.length>0&&y.push([...A]),y.map(l=>{const $=[],p=l[0].range.startLineNumber,r=l[l.length-1].range.endLineNumber;for(let c=p;c<=r;c++)$.push(m.getLineContent(c));return new S.$MJ($.join(`
`)+`
`,l.map(c=>new M.$Ws(c.range.startLineNumber-1,c.range.startColumn-1,c.range.endLineNumber-1,c.range.endColumn-1)))})}e.$$J=R}),define(Re[284],Ae([1,0,162,23,5,6,28,14,16,2,42,74,3,31,8,7,50,259,109,26,12,211,283,281]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class n{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(D=>D.apiEditor)}constructor(D,h,b,P,g,v){this.q=b,this.r=P,this.s=g,this.t=v,this.f=new Map,this.g=new L.$Ac,this.h=new Map,this.j=new I.$Wd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new I.$Wd,this.onDidOpenNotebookDocument=this.m.event,this.n=new I.$Wd,this.onDidCloseNotebookDocument=this.n.event,this.o=new I.$Wd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new k.$mgc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=D.getProxy(l.$lL.MainThreadNotebook),this.c=D.getProxy(l.$lL.MainThreadNotebookDocuments),this.d=D.getProxy(l.$lL.MainThreadNotebookEditors),this.i=h.converter,h.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===13){const T=E.notebookEditor?.notebookUri,N=E.cell.handle,q=this.g.get(T)?.getCell(N);if(q)return q.apiCell}if(E&&E.$mid===14){const T=E.uri,N=this.g.get(T);if(N)return N.apiNotebook}return E}}),n.B(h)}getEditorById(D){const h=this.h.get(D);if(!h)throw new Error(`unknown text editor: ${D}. known editors: ${[...this.h.keys()]} `);return h}getIdByEditor(D){for(const[h,b]of this.h)if(b.apiEditor===D)return h}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(D,h){const b=this.g.get(D);if(!b&&!h)throw new Error(`NO notebook document for '${D}'`);return b}static u(D,h){if(!h)return;const b=h.filenamePattern.map(P=>p.NotebookExclusiveDocumentPattern.from(P)).filter(P=>P!==void 0);if(h.filenamePattern&&!b){console.warn(`Notebook content provider view options file name pattern is invalid ${h.filenamePattern}`);return}return{extension:D.identifier,providerDisplayName:D.displayName||D.name,displayName:h.displayName,filenamePattern:b,exclusive:h.exclusive||!1}}registerNotebookCellStatusBarItemProvider(D,h,b){const P=n.a++,g=typeof b.onDidChangeCellStatusBarItems=="function"?n.a++:void 0;this.f.set(P,b),this.b.$registerNotebookCellStatusBarItemProvider(P,g,h);let v;return g!==void 0&&(v=b.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(g))),new r.$nL(()=>{this.f.delete(P),this.b.$unregisterNotebookCellStatusBarItemProvider(P,g),v?.dispose()})}async createNotebookDocument(D){const h=await this.c.$tryCreateNotebook({viewType:D.viewType,content:D.content&&p.NotebookData.from(D.content)});return y.URI.revive(h)}async openNotebookDocument(D){const h=this.g.get(D);if(h)return h.apiNotebook;const b=await this.c.$tryOpenNotebook(D),P=this.g.get(y.URI.revive(b));return(0,d.$Uf)(P?.apiNotebook)}async showNotebookDocument(D,h){y.URI.isUri(D)&&(D=await this.openNotebookDocument(D));let b;typeof h=="object"?b={position:p.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus,selections:h.selections&&h.selections.map(p.NotebookRange.from),pinned:typeof h.preview=="boolean"?!h.preview:void 0}:b={preserveFocus:!1};const P=await this.d.$tryShowNotebookDocument(D.uri,D.notebookType,b),g=P&&this.h.get(P)?.apiEditor;if(g)return g;throw P?new Error(`Could NOT open editor for "${D.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${D.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(D,h,b,P){const g=this.f.get(D),v=y.URI.revive(h),E=this.g.get(v);if(!E||!g)return;const T=E.getCellFromIndex(b);if(!T)return;const N=await g.provideCellStatusBarItems(T.apiCell,P);if(!N)return;const J=new R.$Sc,q=this.p.add([J]),C=(Array.isArray(N)?N:[N]).map(F=>p.NotebookStatusBarItem.from(F,this.i,J));return{cacheId:q,items:C}}$releaseNotebookCellStatusBarItems(D){this.p.delete(D)}registerNotebookSerializer(D,h,b,P,g){if((0,m.$Ke)(h))throw new Error("viewType cannot be empty or just whitespace");const v=this.w++;return this.x.set(v,{viewType:h,serializer:b,options:P}),this.b.$registerNotebookSerializer(v,{id:D.identifier,location:D.extensionLocation},h,p.NotebookDocumentContentOptions.from(P),n.u(D,g)),(0,R.$Rc)(()=>{this.b.$unregisterNotebookSerializer(v)})}async $dataToNotebook(D,h,b){const P=this.x.get(D);if(!P)throw new Error("NO serializer found");const g=await P.serializer.deserializeNotebook(h.buffer,b);return new c.$Vv(p.NotebookData.from(g))}async $notebookToData(D,h,b){const P=this.x.get(D);if(!P)throw new Error("NO serializer found");const g=await P.serializer.serializeNotebook(p.NotebookData.to(h.value),b);return M.$ke.wrap(g)}async $saveNotebook(D,h,b,P,g){const v=y.URI.revive(h),E=this.x.get(D);if(!E)throw new Error("NO serializer found");const T=this.g.get(v);if(!T)throw new Error("Document NOT found");if(T.versionId!==b)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(v.scheme))throw new A.$Nk((0,S.localize)(0,null,this.z(v)),6);await this.y(v,P);const N={metadata:(0,o.$Gn)(T.apiNotebook.metadata,F=>!(E.options?.transientDocumentMetadata??{})[F]),cells:[]};for(const F of T.apiNotebook.getCells()){const W=new r.$NM(F.kind,F.document.getText(),F.document.languageId,F.mime,E.options?.transientOutputs?[]:[...F.outputs],F.metadata,F.executionSummary);W.metadata=(0,o.$Gn)(F.metadata,re=>!(E.options?.transientCellMetadata??{})[re]),N.cells.push(W)}const J=await E.serializer.serializeNotebook(N,g);await this.s.value.writeFile(v,J);const q=this.s.getFileSystemProviderExtUri(v.scheme),U=await this.s.value.stat(v);return{name:q.basename(v),isFile:(U.type&A.FileType.File)!==0,isDirectory:(U.type&A.FileType.Directory)!==0,isSymbolicLink:(U.type&A.FileType.SymbolicLink)!==0,mtime:U.mtime,ctime:U.ctime,size:U.size,readonly:!!((U.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(v.scheme),locked:!!((U.permissions??0)&A.FilePermission.Locked),etag:A.$Yk({mtime:U.mtime,size:U.size}),children:void 0}}async $searchInNotebooks(D,h,b,P,g){const v=this.x.get(D)?.serializer;if(!v)return{limitHit:!1,results:[]};const E=new L.$Bc;await(async(U,C,F)=>{await Promise.all(U.map(async W=>await Promise.all(W.filenamePatterns.map(re=>{const ce={_reason:F._reason,folderQueries:F.folderQueries,includePattern:F.includePattern,excludePattern:F.excludePattern,maxResults:F.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ce,C,we=>{we.forEach(De=>{E.has(De)||P.some(ve=>W.isFromSettings&&!ve.isFromSettings?!1:ve.filenamePatterns.some(se=>(0,f.$Rdb)(se,De)))||E.add(De)})})}))))})(b,g,h);const N=new L.$Ac;let J=!1;const q=Array.from(E).map(async U=>{const C=[];try{if(g.isCancellationRequested)return;if(h.maxResults&&[...N.values()].reduce((ce,we)=>ce+we.cellResults.length,0)>h.maxResults){J=!0;return}const F=[],W=this.g.get(U);if(W)W.apiNotebook.getCells().forEach(we=>F.push({input:we.document.getText(),outputs:we.outputs.flatMap(De=>De.items.map(le=>le.data.toString()))}));else{const ce=await this.s.value.readFile(U),we=M.$ke.fromString(ce.toString()),De=await v.deserializeNotebook(we.buffer,g);if(g.isCancellationRequested)return;p.NotebookData.from(De).cells.forEach(ve=>F.push({input:ve.source,outputs:ve.outputs.flatMap(se=>se.items.map($e=>$e.valueBytes.toString()))}))}if(g.isCancellationRequested)return;F.forEach((ce,we)=>{const De=h.contentPattern.pattern,le=new u.$WRb(ce.input,void 0,ce.outputs),ve=le.findInInputs(De),se=le.findInOutputs(De),$e=se.flatMap(te=>(0,t.$$J)(te.matches,te.textBuffer)).map((te,X)=>(te.webviewIndex=X,te));if(ve.length>0||se.length>0){const te={index:we,contentResults:(0,t.$$J)(ve,le.inputTextBuffer),webviewResults:$e};C.push(te)}});const re={resource:U,cellResults:C};N.set(U,re);return}catch{return}});return await Promise.all(q),{limitHit:J,results:[...N.values()]}}async y(D,h){const b=await this.s.value.stat(D);if(typeof h?.mtime=="number"&&typeof h.etag=="string"&&h.etag!==A.$Xk&&typeof b.mtime=="number"&&typeof b.size=="number"&&h.mtime<b.mtime&&h.etag!==A.$Yk({mtime:h.mtime,size:b.size}))throw new A.$Nk((0,S.localize)(1,null),3,h)}z(D){return D.scheme===a.Schemas.file?D.fsPath:D.toString()}A(D,h,b){if(this.h.has(h))throw new Error(`editor with id ALREADY EXSIST: ${h}`);const P=new i.$Ihc(h,this.d,D,b.visibleRanges.map(p.NotebookRange.to),b.selections.map(p.NotebookRange.to),typeof b.viewColumn=="number"?p.ViewColumn.to(b.viewColumn):void 0);this.h.set(h,P)}$acceptDocumentAndEditorsDelta(D){if(D.value.removedDocuments)for(const b of D.value.removedDocuments){const P=y.URI.revive(b),g=this.g.get(P);g&&(g.dispose(),this.g.delete(P),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:g.apiNotebook.getCells().map(v=>v.document.uri)}),this.n.fire(g.apiNotebook));for(const v of this.h.values())v.notebookData.uri.toString()===P.toString()&&this.h.delete(v.id)}if(D.value.addedDocuments){const b=[];for(const P of D.value.addedDocuments){const g=y.URI.revive(P.uri);if(this.g.has(g))throw new Error(`adding EXISTING notebook ${g} `);const v=new s.$Hhc(this.c,this.q,this.r,g,P);b.push(...P.cells.map(E=>s.$Ghc.asModelAddData(v.apiNotebook,E))),this.g.get(g)?.dispose(),this.g.set(g,v),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:b}),this.m.fire(v.apiNotebook)}}if(D.value.addedEditors)for(const b of D.value.addedEditors){if(this.h.has(b.id))return;const P=y.URI.revive(b.documentUri),g=this.g.get(P);g&&this.A(g,b.id,b)}const h=[];if(D.value.removedEditors)for(const b of D.value.removedEditors){const P=this.h.get(b);P&&(this.h.delete(b),this.k?.id===P.id&&(this.k=void 0),h.push(P))}if(D.value.visibleEditors){this.l=D.value.visibleEditors.map(P=>this.h.get(P)).filter(P=>!!P);const b=new Set;this.l.forEach(P=>b.add(P.id));for(const P of this.h.values()){const g=b.has(P.id);P._acceptVisibility(g)}this.l=[...this.h.values()].map(P=>P).filter(P=>P.visible),this.o.fire(this.visibleNotebookEditors)}D.value.newActiveEditor===null?this.k=void 0:D.value.newActiveEditor&&(this.h.get(D.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${D.value.newActiveEditor}`),this.k=this.h.get(D.value.newActiveEditor)),D.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(D){const h=$.$UN.String.with("notebookType","A notebook type"),b=new $.$WN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[h,new $.$UN("data","Bytes to convert to data",g=>g instanceof Uint8Array,g=>M.$ke.wrap(g))],new $.$VN("Notebook Data",g=>p.NotebookData.to(g.value))),P=new $.$WN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[h,new $.$UN("NotebookData","Notebook data to convert to bytes",g=>!0,g=>new c.$Vv(p.NotebookData.from(g)))],new $.$VN("Bytes",g=>g.buffer));D.registerApiCommand(b),D.registerApiCommand(P)}}e.$Rhc=n}),define(Re[285],Ae([1,0,19,21,41,34,24,63,44]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=void 0;class y{constructor(l,$,p){this.k=l,this.l=$,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&R.$Oj(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&R.$Oj(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const $=this.k.folderQueries||[];return new Promise((p,r)=>{const c=s=>{this.f++,l(s)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const i=s.toString(),o=S.$nc(i);this.j&&this.j(i,o)||this.v(c,{base:s,basename:o})}),Promise.all($.map(s=>this.p(s,c))).then(s=>{p({limitHit:this.e,stats:s[0]||void 0})},s=>{r(new Error((0,I.$Si)(s)))})})}async p(l,$){const p=new M.$7d,r=this.q(l),c=this.r(),s=new d.$1J(this.k,l),i=!s.hasSiblingExcludeClauses();let o;try{this.h.add(p),o=m.$Sd.create();const a=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},r,p.token),u=o.elapsed(),t=m.$Sd.create();return this.g&&!this.e||(a&&a.forEach(f=>{const n=S.$gc.relative(l.folder.path,f.path);if(i){const w=S.$nc(f.path);this.v($,{base:l.folder,relativePath:n,basename:w});return}this.s(c,l.folder,n,$)}),this.g&&!this.e)?null:(this.u(c,s,$),{providerTime:u,postProcessTime:t.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(l){const $=(0,d.$ZJ)(this.k.includePattern,l.includePattern),p=(0,d.$ZJ)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:p,includes:$,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},$,p,r){if(p===this.a){const s=S.$nc(this.a);this.v(r,{base:$,relativePath:this.a,basename:s})}function c(s){const i=S.$nc(s),o=S.$mc(s);let a=l[o];a||(a=l[o]=[],c(o)),a.push({base:$,relativePath:s,basename:i})}c(p)}u({rootEntries:l,pathToEntries:$},p,r){const c=this,s=this.a;function i(o){const a=(0,d.$3J)(()=>o.map(u=>u.basename));for(let u=0,t=o.length;u<t;u++){const f=o[u],{relativePath:n,basename:w}=f;if(p.matchesExcludesSync(n,w,s!==w?a:void 0))continue;const D=$[n];if(D)i(D);else{if(n===s)continue;c.v(r,f)}if(c.e)break}}i(l)}v(l,$){(!this.b||$.relativePath&&this.b($.relativePath,$.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l($))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,$,p,r){const c=this.c(l.cacheKey),s=new y(l,$,c&&c.token);let i=0;const o=a=>{i+=a.length,p(a.map(u=>this.d(u)))};return this.e(s,A.a,o,r).then(a=>({limitHit:a.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:a.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new M.$7d),this.b.get(l)}d(l){return l.relativePath?{resource:L.$Ig(l.base,l.relativePath)}:{resource:l.base}}e(l,$,p,r){const c=r.onCancellationRequested(()=>{l.cancel()}),s=o=>{o&&(i.push(o),$>0&&i.length>=$&&(p(i),i=[]))};let i=[];return l.search(s).then(o=>(i.length&&p(i),c.dispose(),o),o=>(i.length&&p(i),c.dispose(),Promise.reject(o)))}}e.$Jhc=A}),define(Re[286],Ae([1,0,18,254,34,94,28,12,19,24,14,16,2,93,179,47,13,48,104,282,44]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3K=e.$2K=void 0;let u=class{constructor(v,E,T,N,J){this.a=v,this.b=E,this.c=T,this.d=N,this.e=J}text(v,E,T={}){v=this.f(v,T);const N=this.a.getValue(),J=E&&E.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(E?.map(s.$qi),T),type:2,contentPattern:v,previewOptions:T.previewOptions,maxFileSize:T.maxFileSize,usePCRE2:N.search.usePCRE2||J||!1,beforeContext:T.beforeContext,afterContext:T.afterContext,userDisabledExcludesAndIgnoreFiles:T.disregardExcludeSettings&&T.disregardIgnoreFiles}}f(v,E){const T=this.a.getValue();v.isRegExp&&(v.pattern=v.pattern.replace(/\r?\n/g,"\\n"));const N={...v,wordSeparators:T.editor.wordSeparators};return this.j(v,E)&&(N.isCaseSensitive=!0),this.k(v)&&(N.isMultiline=!0),E.notebookSearchConfig?.includeMarkupInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownInput=E.notebookSearchConfig.includeMarkupInput),E.notebookSearchConfig?.includeMarkupPreview&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookMarkdownPreview=E.notebookSearchConfig.includeMarkupPreview),E.notebookSearchConfig?.includeCodeInput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellInput=E.notebookSearchConfig.includeCodeInput),E.notebookSearchConfig?.includeOutput&&(N.notebookInfo||(N.notebookInfo={}),N.notebookInfo.isInNotebookCellOutput=E.notebookSearchConfig.includeOutput),N}file(v,E={}){return{...this.h(v,E),type:1,filePattern:E.filePattern?E.filePattern.trim():E.filePattern,exists:E.exists,sortByScore:E.sortByScore,cacheKey:E.cacheKey,shouldGlobMatchFilePattern:E.shouldGlobSearch}}g(v,E){return v?(v=Array.isArray(v)?v.map(D):D(v),E?this.parseSearchPaths(v):{pattern:f(...Array.isArray(v)?v:[v])}):{}}h(v=[],E={}){const T=this.g(E.includePattern,E.expandPatterns),N=this.g(E.excludePattern,E.expandPatterns),J=v.length>1,q=(T.searchPaths&&T.searchPaths.length?T.searchPaths.map(F=>this.q(F,E,N)):v.map(F=>this.r(F,E,N,J))).filter(F=>!!F),U={_reason:E._reason,folderQueries:q,usingSearchPaths:!!(T.searchPaths&&T.searchPaths.length),extraFileResources:E.extraFileResources,excludePattern:N.pattern,includePattern:T.pattern,onlyOpenEditors:E.onlyOpenEditors,maxResults:E.maxResults};if(E.onlyOpenEditors){const F=S.$Hb(S.$Rb(this.c.groups.map(ce=>ce.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(F));const W=F.filter(ce=>(0,a.$QJ)(U,ce.fsPath)),re=this.i(W);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...U,...re}}const C=E.extraFileResources&&E.extraFileResources.filter(F=>(0,a.$QJ)(U,F.fsPath));return U.extraFileResources=C&&C.length?C:void 0,U}i(v){const E=[],T=new L.$Ac,N={};let J=!1;return v.forEach(q=>{if(q.scheme===m.Schemas.walkThrough)return;if((0,y.$Mg)(q)){const C=this.b.getWorkspaceFolder(q)?.uri??q.with({path:d.$mc(q.fsPath)});let F=T.get(C);F||(J=!0,F={folder:C,includePattern:{}},E.push(F),T.set(C,F));const W=d.$lc(C.fsPath,q.fsPath);(0,k.$Uf)(F.includePattern)[W.replace(/\\/g,"/")]=!0}else q.fsPath&&(J=!0,N[q.fsPath]=!0)}),{folderQueries:E,includePattern:N,usingSearchPaths:!0,excludePattern:J?void 0:{"**/*":!0}}}j(v,E){if(E.isSmartCase){if(v.isRegExp){if(A.$Af(v.pattern,!0))return!0}else if(A.$Af(v.pattern))return!0}return!!v.isCaseSensitive}k(v){return v.isMultiline||v.isRegExp&&(0,$.$6B)(v.pattern)||v.pattern.indexOf(`
`)>=0?!0:!!v.isMultiline}parseSearchPaths(v){const E=re=>d.$ic(re)||/^\.\.?([\/\\]|$)/.test(re),N=(Array.isArray(v)?v:n(v)).map(re=>{const ce=this.e.resolvedUserHome;return ce?(0,R.$1v)(re,ce.scheme===m.Schemas.file?ce.fsPath:ce.path):re}),J=M.$K(N,re=>E(re)?"searchPaths":"exprSegments"),q=(J.exprSegments||[]).map(re=>A.$Ve(re,"/")).map(re=>A.$Ve(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),w(re))),U={},C=this.m(J.searchPaths||[]);C&&C.length&&(U.searchPaths=C);const F=S.$Rb(q),W=f(...F);return W&&(U.pattern=W),U}l(v,E){return E.disregardExcludeSettings?void 0:(0,a.$PJ)(v,!E.disregardSearchExcludeSettings)}m(v){if(!v||!v.length)return[];const E=v.flatMap(N=>{let{pathPortion:J,globPortion:q}=t(N);return q&&(q=h(q)),this.n(J).flatMap(C=>this.o(C,q))}),T=new Map;return E.forEach(N=>{const J=N.searchPath.toString(),q=T.get(J);q?N.pattern&&(q.pattern=q.pattern||{},q.pattern[N.pattern]=!0):T.set(J,{searchPath:N.searchPath,pattern:N.pattern?f(N.pattern):void 0})}),Array.from(T.values())}n(v){if(d.$ic(v)){const E=this.b.getWorkspace().folders;return E[0]&&E[0].uri.scheme!==m.Schemas.file?[{searchPath:E[0].uri.with({path:v})}]:[{searchPath:l.URI.file(d.$hc(v))}]}if(this.b.getWorkbenchState()===2){const E=this.b.getWorkspace().folders[0].uri;if(v=D(v),v.startsWith("../")||v===".."){const N=d.$gc.resolve(E.path,v);return[{searchPath:E.with({path:N})}]}const T=h(v);return[{searchPath:E,pattern:T}]}else{if(v==="./"||v===".\\")return[];{const E=v.replace(/^\.[\/\\]/,""),N=this.b.getWorkspace().folders.map(J=>{const q=E.match(new RegExp(`^${A.$Pe(J.name)}(?:/(.*)|$)`));return q?{match:q,folder:J}:null}).filter(k.$Rf);if(N.length)return N.map(J=>{const q=J.match[1];return{searchPath:J.folder.uri,pattern:q&&h(q)}});{const J=v.match(/\.[\/\\](.+)[\/\\]?/),q=J?J[1]:v,U=p.localize(0,null,q);throw new Error(U)}}}}o(v,E){const T=v.pattern&&E?`${v.pattern}/${E}`:v.pattern||E,N=[{searchPath:v.searchPath,pattern:T}];return T&&!T.endsWith("**")&&N.push({searchPath:v.searchPath,pattern:T+"/**"}),N}q(v,E,T){const N=this.r((0,s.$qi)(v.searchPath),E,T,!1);return N?{...N,includePattern:v.pattern}:null}r(v,E,T,N){let J;const q=l.URI.isUri(v)?v:v.uri;if(T.searchPaths){const re=T.searchPaths.filter(ce=>(0,y.$Bg)(ce.searchPath,q))[0];if(re&&!re.pattern)return null;re&&(J=re.pattern)}const U=this.a.getValue({resource:q}),F={...this.l(U,E)||{},...J||{}},W=l.URI.isUri(v)?(0,y.$Fg)(v):v.name;return{folder:q,folderName:N?W:void 0,excludePattern:Object.keys(F).length>0?F:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof E.disregardIgnoreFiles=="boolean"?E.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof E.disregardGlobalIgnoreFiles=="boolean"?E.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof E.disregardParentIgnoreFiles=="boolean"?E.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof E.ignoreSymlinks=="boolean"?E.ignoreSymlinks:!U.search.followSymlinks}}};e.$2K=u,e.$2K=u=Ge([qe(0,r.$Bi),qe(1,s.$ei),qe(2,i.$aD),qe(3,c.$pj),qe(4,o.$ZK)],u);function t(g){const v=g.match(/[\*\{\}\(\)\[\]\?]/);if(v){const E=v.index,T=g.substr(0,E).match(/[/|\\][^/\\]*$/);if(T){let N=g.substr(0,T.index);return N.match(/[/\\]/)||(N+="/"),{pathPortion:N,globPortion:g.substr((T.index||0)+1)}}}return{pathPortion:g}}function f(...g){return g.length?g.reduce((v,E)=>(v[E]=!0,v),Object.create(null)):void 0}function n(g){return I.$Mj(g,",").map(v=>v.trim()).filter(v=>!!v.length)}function w(g){return[`**/${g}/**`,`**/${g}`].map(E=>E.replace(/\*\*\/\*\*/g,"**"))}function D(g){return g.replace(/\\/g,"/")}function h(g){return D(g).replace(/^\.\//,"").replace(/\/+$/g,"")}function b(g){return g.replace(/([?*[\]])/g,"[$1]")}function P(g,v){g=S.$Mb(g,N=>N.toString());const E=[],T=v.getWorkspace();return g&&g.forEach(N=>{let J;if(v.getWorkbenchState()===2)J=(0,y.$Kg)(T.folders[0].uri,N),J&&J!=="."&&(J="./"+J);else{const q=v.getWorkspaceFolder(N);if(q){const U=q.name;if(T.folders.filter(F=>F.name===U).length===1){const F=(0,y.$Kg)(q.uri,N);F===""?J=`./${q.name}`:J=`./${q.name}/${F}`}else J=N.fsPath}}J&&E.push(b(J))}),E}e.$3K=P}),define(Re[287],Ae([1,0,24,2,21,15,4,286,44,48,11]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ttb=e.$stb=void 0;const k=7e3;function l(c,s){const i=s.activationEvents;if(!i)return Promise.resolve(void 0);const o=[],a=[];for(const D of i)if(/^workspaceContains:/.test(D)){const h=D.substr(18);h.indexOf("*")>=0||h.indexOf("?")>=0||c.forceUsingSearch?a.push(h):o.push(h)}if(o.length===0&&a.length===0)return Promise.resolve(void 0);const{promise:u,resolve:t}=(0,A.$1g)(),f=D=>t({activationEvent:D}),n=Promise.all(o.map(D=>$(c,D,f))).then(()=>{}),w=p(c,s.identifier,a,f);return Promise.all([n,w]).then(()=>{t(void 0)}),u}e.$stb=l;async function $(c,s,i){for(const o of c.folders)if(await c.exists(S.$Ig(M.URI.revive(o),s))){i(`workspaceContains:${s}`);return}}async function p(c,s,i,o){if(i.length===0)return Promise.resolve(void 0);const a=new I.$7d,u=c.checkExists(c.folders,i,a.token),t=setTimeout(async()=>{a.cancel(),c.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${i.join(",")}`)},k);let f=!1;try{f=await u}catch(n){R.$4(n)||R.$1(n)}a.dispose(),clearTimeout(t),f&&o(`workspaceContains:${i.join(",")}`)}function r(c,s,i,o){const a=c.get(L.$7h),u=c.get(d.$HJ),f=a.createInstance(m.$2K).file(s.map(n=>(0,y.$qi)(M.URI.revive(n))),{_reason:"checkExists",includePattern:i,exists:!0});return u.fileSearch(f,o).then(n=>!!n.limitHit,n=>R.$4(n)?!1:Promise.reject(n))}e.$ttb=r}),define(Re[38],Ae([1,0,159,19,87,24,11,6,51,2,13,3,37,217,82,36,25,105,15,22,23,200,7,100,4,27,84,17,71,85,65,5,287,81,202,12,79,63,20,80]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f,n,w,D,h,b,P,g,v,E,T,N,J,q,U,C,F){"use strict";var W;Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=e.$nhc=e.$mhc=e.$lhc=void 0,e.$lhc=(0,n.$8h)("IHostUtils");let re=W=class extends m.$Tc{constructor(X,V,ie,Ce,Te,Pe,be,ge,G,_,ue,de){super(),this.X=de,this.a=this.B(new v.$Wd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ie,this.f=be,this.j=Ce,this.m=Te,this.s=Pe,this.t=G,this.u=_,this.w=ue,this.y=this.g.getProxy(k.$lL.MainThreadWorkspace),this.z=this.g.getProxy(k.$lL.MainThreadTelemetry),this.C=this.g.getProxy(k.$lL.MainThreadExtensionService),this.D=new L.$7g,this.F=new L.$7g,this.G=new L.$7g,this.H=new L.$7g,this.I=new $e(this.f.extensions.activationEvents),this.L=new s.$q8b(this.I,this.f.extensions.allExtensions);const Le=new o.$om(this.f.extensions.myExtensions);this.J=new s.$q8b(this.I,ve(this.L,Le)),C.$t&&(this.s.info(`Creating extension host with the following global extensions: ${De(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${De(this.J)}`)),this.M=new p.$9gc(this.g,this.s),this.N=new T.$ehc(this.g),this.O=ge,this.h=X.createChild(new b.$6h([p.$0gc,this.M],[T.$fhc,this.N])),this.P=this.B(new $.$8gc(this.J,this.L,{onExtensionActivationError:(fe,ke,Ie)=>{this.C.$onExtensionActivationError(fe,i.$3(ke),Ie)},actualActivateExtension:async(fe,ke)=>{if(s.$q8b.isHostExtension(fe,this.J,this.L))return await this.C.$activateExtension(fe,ke),new $.$7gc;const Ie=this.J.getExtensionDescription(fe);return this.db(Ie,ke)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(X){i.$1(X)}}async Y(){this.O.onWillDeactivateAll();let X=[];try{X=this.J.getAllExtensionDescriptions().map(Te=>Te.identifier).filter(Te=>this.isActivated(Te)).map(Te=>this.cb(Te))}catch{}await Promise.all(X)}terminate(X,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${X}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(Ce=>{this.s.error(Ce)}),this.g.dispose();const ie=this.Y();Promise.race([(0,L.$9g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(X){return this.G.isOpen()?this.P.isActivated(X):!1}async getExtension(X){const V=await this.C.$getExtension(X);return V&&{...V,identifier:new o.$nm(V.identifier.value),extensionLocation:y.URI.revive(V.extensionLocation)}}Z(X,V){return this.P.activateByEvent(X,V)}$(X,V){return this.P.activateById(X,V)}activateByIdWithErrors(X,V){return this.$(X,V).then(()=>{const ie=this.P.getActivatedExtension(X);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(X=>this.J)}getExtensionExports(X){if(this.G.isOpen())return this.P.getActivatedExtension(X).exports;try{return this.P.getActivatedExtension(X).exports}catch{return null}}async ab(X){if(X.scheme===J.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(X.fsPath);return y.URI.file(V)}return X}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(X=>new se(X))),this.Q}async bb(X){const V=d.$bi.forUris(ie=>R.$zg.ignorePathCasing(ie));return await Promise.all(X.map(async ie=>{if(this.ub(ie)){const Ce=await this.ab(ie.extensionLocation);V.set(Ce,ie)}})),V}cb(X){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(X))return V;const ie=this.P.getActivatedExtension(X);if(!ie)return V;try{typeof ie.module.deactivate=="function"&&(V=Promise.resolve(ie.module.deactivate()).then(void 0,Ce=>(this.s.error(Ce),Promise.resolve(void 0))))}catch(Ce){this.s.error(`An error occurred when deactivating the extension '${X.value}':`),this.s.error(Ce)}try{(0,m.$Oc)(ie.subscriptions)}catch(Ce){this.s.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.s.error(Ce)}return V}async db(X,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(X.identifier):await this.C.$onWillActivateExtension(X.identifier),this.fb(X,V).then(ie=>{const Ce=ie.activationTimes;return this.C.$onDidActivateExtension(X.identifier,Ce.codeLoadingTime,Ce.activateCallTime,Ce.activateResolvedTime,V),this.eb(X,V,"success",Ce),ie},ie=>{throw this.eb(X,V,"failure"),ie})}eb(X,V,ie,Ce){const Te=we(X,V);this.z.$publicLog2("extensionActivationTimes",{...Te,...Ce||{},outcome:ie})}fb(X,V){const ie=we(X,V);this.z.$publicLog2("activatePlugin",ie);const Ce=this.ub(X);if(!Ce)return Promise.resolve(new $.$6gc($.$3gc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${X.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const Te=new $.$4gc(V.startup);return Promise.all([this.vb(X,(0,R.$Ig)(X.extensionLocation,Ce),Te),this.gb(X)]).then(Pe=>(I.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),W.hb(this.s,X.identifier,Pe[0],Pe[1],Te))).then(Pe=>(I.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Pe))}gb(X){const V=new u.$_gc(X,this.M),ie=new u.$$gc(X.identifier.value,!1,this.M),Ce=new N.$ghc(X,this.N),Te=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,Pe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([V.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const be=this;let ge,G;const _=(0,c.$KF)(X,"ipc")?this.f.messagePorts?.get(o.$nm.toKey(X.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ie,secrets:Ce,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(ue){return M.$jc(X.extensionLocation.fsPath,ue)},get storagePath(){return be.O.workspaceValue(X)?.fsPath},get globalStoragePath(){return be.O.globalValue(X).fsPath},get logPath(){return M.$jc(be.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return y.URI.joinPath(be.f.logsLocation,X.identifier.value)},get storageUri(){return be.O.workspaceValue(X)},get globalStorageUri(){return be.O.globalValue(X)},get extensionMode(){return Te},get extension(){return ge===void 0&&(ge=new le(be,X.identifier,X,Pe,!1)),ge},get extensionRuntime(){return(0,c.$LF)(X,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.u.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!G){if(!_)return;const ue=v.Event.buffer(v.Event.fromDOMEventEmitter(_,"message",de=>de.data));_.start(),G={onDidReceiveMessage:ue,postMessage:_.postMessage.bind(_)}}return G}})})}static hb(X,V,ie,Ce,Te){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(X,V,ie,Ce,Te).then(Pe=>new $.$5gc(!1,null,Te.build(),ie,Pe,Ce.subscriptions))}static ib(X,V,ie,Ce,Te){if(typeof ie.activate=="function")try{Te.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${V.value}`);const Pe=typeof global=="object"?global:self,be=ie.activate.apply(Pe,[Ce]);return Te.activateCallStop(),Te.activateResolveStart(),Promise.resolve(be).then(ge=>(Te.activateResolveStop(),ge))}catch(Pe){return Promise.reject(Pe)}else return Promise.resolve(ie)}jb(X,V){this.$(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:V}).then(void 0,ie=>{this.s.error(ie)})}kb(X,V=0){const Ce=Date.now();(0,C.$B)(()=>{for(let Te=V;Te<X.length;Te+=1){const Pe=X[Te];for(const be of Pe.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-Ce>50){this.kb(X,Te);break}else this.jb(Pe,be)}})}lb(){this.C.$setPerformanceMarks(I.getMarks()),this.m.getConfigProvider().then(X=>{const V=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(V)this.kb(ie);else for(const Ce of ie)if(Ce.activationEvents)for(const Te of Ce.activationEvents)Te==="onStartupFinished"&&this.jb(Ce,Te)})}mb(){const X=this.Z("*",!0).then(void 0,Pe=>{this.s.error(Pe)});this.B(this.j.onDidChangeWorkspace(Pe=>this.nb(Pe.added)));const V=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(V),Ce=this.pb(),Te=Promise.all([Ce,X,ie]).then(()=>{});return Promise.race([Te,(0,L.$9g)(1e4)]).then(()=>{this.lb()}),Te}nb(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(X,V))).then(()=>{})}async ob(X,V){if(this.isActivated(V.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,Ce={logService:this.s,folders:X.map(Pe=>Pe.uri),forceUsingSearch:ie||!this.c.fsExists,exists:Pe=>this.c.fsExists(Pe.fsPath),checkExists:(Pe,be,ge)=>this.y.$checkExists(Pe,be,ge)},Te=await(0,E.$stb)(Ce,V);if(Te)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:Te.activationEvent}).then(void 0,Pe=>this.s.error(Pe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(X){throw console.error(X),X}}async qb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:V}=this.f.environment;if(!X||!V)throw new Error(S.localize(0,null));const ie=await this.vb(null,V,new $.$4gc(!1));if(!ie||typeof ie.run!="function")throw new Error(S.localize(1,null,V.toString()));return new Promise((Ce,Te)=>{const Pe=(G,_)=>{G?(C.$t&&this.s.error("Test runner called back with error",G),Te(G)):(C.$t&&(_?this.s.info(`Test runner called back with ${_} failures.`):this.s.info("Test runner called back with successful outcome.")),Ce(typeof _=="number"&&_>0?1:0))},be=(0,R.$wg)(V),ge=ie.run(be,Pe);ge&&ge.then&&ge.then(()=>{C.$t&&this.s.info("Test runner finished successfully."),Ce(0)}).catch(G=>{C.$t&&this.s.error("Test runner finished with error",G),Te(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,L.$9g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,V){return this.R[X]=V,(0,m.$Rc)(()=>{delete this.R[X]})}async getRemoteExecServer(X){const{resolver:V}=await this.sb(X);return V?.resolveExecServer?.(X,{resolveAttempt:0})}async sb(X){const V=X.indexOf("+");if(V===-1)throw new t.$tL("Not an authority that can be resolved!",f.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=X.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(X,V){const ie=U.$Sd.create(!1),Ce=()=>`[resolveAuthority(${(0,f.$bl)(X)},${V})][${ie.elapsed()}ms] `,Te=K=>this.s.info(`${Ce()}${K}`),Pe=K=>this.s.warn(`${Ce()}${K}`),be=(K,j=void 0)=>this.s.error(`${Ce()}${K}`,j),ge=K=>{if(K instanceof t.$tL)return{type:"error",error:{code:K._code,message:K._message,detail:K._detail}};throw K},G=async K=>{Te(`activating resolver for ${K}...`);const{resolver:j,authorityPrefix:H}=await this.sb(K);if(!j)throw be(`no resolver for ${H}`),new t.$tL(`No remote extension installed to resolve ${H}.`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:j,authorityPrefix:H,remoteAuthority:K}},_=X.split(/@|%40/g).reverse();Te(`activating remote resolvers ${_.join(" -> ")}`);let ue;try{ue=await Promise.all(_.map(G)).catch(async K=>{if(!(K instanceof t.$tL)||K._code!==f.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw K;return Pe(`resolving nested authorities failed: ${K.message}`),[await G(X)]})}catch(K){return ge(K)}const de=new L.$gh;de.cancelAndSet(()=>Te("waiting..."),1e3);let Le,fe;for(const[K,{authorityPrefix:j,resolver:H,remoteAuthority:Z}]of ue.entries())try{if(K===ue.length-1)Te("invoking final resolve()..."),I.mark(`code/extHost/willResolveAuthority/${j}`),Le=await H.resolve(Z,{resolveAttempt:V,execServer:fe}),I.mark(`code/extHost/didResolveAuthorityOK/${j}`),Te("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(H,t.$sL.isManagedResolvedAuthority(Le)?Le:void 0));else{if(Te(`invoking resolveExecServer() for ${Z}`),I.mark(`code/extHost/willResolveExecServer/${j}`),fe=await H.resolveExecServer?.(Z,{resolveAttempt:V,execServer:fe}),!fe)throw new t.$tL(`Exec server was not available for ${Z}`,f.RemoteAuthorityResolverErrorCode.NoResolverFound);I.mark(`code/extHost/didResolveExecServerOK/${j}`)}}catch(oe){return I.mark(`code/extHost/didResolveAuthorityError/${j}`),be("returned an error",oe),de.dispose(),ge(oe)}de.dispose();const ke={environmentTunnels:Le.environmentTunnels,features:Le.tunnelFeatures?{elevation:Le.tunnelFeatures.elevation,privacyOptions:Le.tunnelFeatures.privacyOptions,protocol:Le.tunnelFeatures.protocol===void 0?!0:Le.tunnelFeatures.protocol}:void 0},Ie={extensionHostEnv:Le.extensionHostEnv,isTrusted:Le.isTrusted,authenticationSession:Le.authenticationSessionForInitializingExtensions?{id:Le.authenticationSessionForInitializingExtensions.id,providerId:Le.authenticationSessionForInitializingExtensions.providerId}:void 0};Te(`returned ${t.$sL.isManagedResolvedAuthority(Le)?"managed authority":`${Le.host}:${Le.port}`}`);let O;if(t.$sL.isManagedResolvedAuthority(Le)){const K=V;this.X.setFactory(K,Le.makeConnection),O={authority:X,connectTo:new f.$$k(K),connectionToken:Le.connectionToken}}else O={authority:X,connectTo:new f.$_k(Le.host,Le.port),connectionToken:Le.connectionToken};return{type:"ok",value:{authority:O,options:Ie,tunnelInformation:ke}}}async $getCanonicalURI(X,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,f.$bl)(X)})`);const{resolver:ie}=await this.sb(X);if(!ie)return null;const Ce=y.URI.revive(V);if(typeof ie.getCanonicalURI>"u")return Ce;const Te=await(0,L.$Zg)(()=>ie.getCanonicalURI(Ce));return Te||Ce}$startExtensionHost(X){X.toAdd.forEach(Ce=>Ce.extensionLocation=y.URI.revive(Ce.extensionLocation));const{globalRegistry:V,myExtensions:ie}=ce(this.I,this.L,this.J,X);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),C.$t&&(this.s.info(`$startExtensionHost: global extensions: ${De(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${De(this.J)}`)),this.rb()}$activateByEvent(X,V){return V===1?this.D.wait().then(ie=>this.Z(X,!1)):this.G.wait().then(ie=>this.Z(X,!1))}async $activate(X,V){return await this.G.wait(),this.J.getExtensionDescription(X)?(await this.$(X,V),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Pe=>Pe.extensionLocation=y.URI.revive(Pe.extensionLocation));const{globalRegistry:V,myExtensions:ie}=ce(this.I,this.L,this.J,X),Ce=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(Ce),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),C.$t&&(this.s.info(`$deltaExtensions: global extensions: ${De(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${De(this.J)}`)),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const V=a.$ke.alloc(X),ie=Math.random()%256;for(let Ce=0;Ce<X;Ce++)V.writeUInt8(ie,Ce);return V}async $updateRemoteConnectionData(X){this.W=X,this.a.fire()}};e.$mhc=re,e.$mhc=re=W=Ge([qe(0,n.$7h),qe(1,e.$lhc),qe(2,h.$wN),qe(3,r.$Lgc),qe(4,l.$Ogc),qe(5,A.$pj),qe(6,w.$MN),qe(7,D.$Rgc),qe(8,P.$vzb),qe(9,g.$ahc),qe(10,q.$ihc),qe(11,F.$jhc)],re);function ce(te,X,V,ie){te.addActivationEvents(ie.addActivationEvents);const Ce=new s.$q8b(te,X.getAllExtensionDescriptions());Ce.deltaExtensions(ie.toAdd,ie.toRemove);const Te=new o.$om(V.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of ie.myToRemove)Te.delete(be);for(const be of ie.myToAdd)Te.add(be);const Pe=ve(Ce,Te);return{globalRegistry:Ce,myExtensions:Pe}}function we(te,X){return{id:te.identifier.value,name:te.name,extensionVersion:te.version,publisherDisplayName:te.publisher,activationEvents:te.activationEvents?te.activationEvents.join(","):null,isBuiltin:te.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}function De(te){return te.getAllExtensionDescriptions().map(X=>X.identifier.value).join(",")}e.$nhc=(0,n.$8h)("IExtHostExtensionService");class le{#e;#t;#i;constructor(X,V,ie,Ce,Te){this.#e=X,this.#t=V,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=M.$hc((0,R.$wg)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=Ce,this.isFromDifferentExtensionHost=Te}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$ohc=le;function ve(te,X){return te.getAllExtensionDescriptions().filter(V=>X.has(V.identifier))}class se{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.$phc=se;class $e{constructor(X){this.a=new o.$pm,this.addActivationEvents(X)}readActivationEvents(X){return this.a.get(X.identifier)??[]}addActivationEvents(X){for(const V of Object.keys(X))this.a.set(V,X[V])}}}),define(Re[288],Ae([1,0,87,2,3,37,25,22,17,27,4,38,13,14]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=void 0;let r=class{constructor(a,u,t,f,n,w,D){this.c=a,this.d=u,this.e=t,this.f=f,this.g=n,this.h=w,this.i=D,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const a=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new s(this.c,u,this.d,a,this.i)),this.register(this.e.createInstance(c)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,u,this.h.environment.appUriScheme))}register(a){if("nodeModuleName"in a)if(Array.isArray(a.nodeModuleName))for(const u of a.nodeModuleName)this.a.set(u,a);else this.a.set(a.nodeModuleName,a);typeof a.alternativeModuleName=="function"&&this.b.push(u=>a.alternativeModuleName(u))}};e.$xic=r,e.$xic=r=Ge([qe(2,A.$7h),qe(3,R.$Ogc),qe(4,k.$nhc),qe(5,y.$MN),qe(6,l.$pj)],r);let c=class{static{p=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(a){if(a.environment.appRoot&&p.a.size){const u=(0,$.$Pe)(this.c(a.environment.appRoot.fsPath)),t="[a-z0-9_.-]",f=`@${t}+\\/${t}+|${t}+`,n="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${n}\\/)(${f})(.*)$`,"i")}}alternativeModuleName(a){if(!this.b)return;const u=this.b.exec(this.c(a));if(!u)return;const[,t,f,n]=u,w=p.a.get(f);if(w!==void 0)return console.warn(`${f} as been renamed to ${w}, please update your imports`),t+w+n}c(a){return a.replace(/\\/g,"/")}};c=p=Ge([qe(0,y.$MN)],c);class s{constructor(a,u,t,f,n){this.c=a,this.d=u,this.e=t,this.f=f,this.g=n,this.nodeModuleName="vscode",this.a=new m.$pm}load(a,u){const t=this.d.findSubstr(u);if(t){let f=this.a.get(t.identifier);return f||(f=this.c(t,this.e,this.f),this.a.set(t.identifier,f)),f}if(!this.b){let f="";this.d.forEach((n,w)=>f+=`	${w} -> ${n.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${f}`),this.b=this.c(L.$FF,this.e,this.f)}return this.b}}let i=class{constructor(a,u,t){this.e=a,this.f=u,this.nodeModuleName=["open","opn"],this.d=t.getProxy(I.$lL.MainThreadTelemetry);const f=t.getProxy(I.$lL.MainThreadWindow);this.c=(n,w)=>{const D=M.URI.parse(n);return w?this.g(n,w):D.scheme==="http"||D.scheme==="https"?f.$openUri(D,n,{allowTunneling:!0}):D.scheme==="mailto"||D.scheme===this.f?f.$openUri(D,n,{}):this.g(n,w)}}load(a,u,t){const f=this.e.findSubstr(u);return f&&(this.a=f.identifier.value,this.h()),this.b=t(a),this.c}g(a,u){return this.i(),this.b(a,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([qe(2,d.$wN)],i)}),define(Re[116],Ae([1,0,39,6,19,73,4,66,64,38,7,36,214,37]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=void 0,e.$qhc=(0,L.$8h)("IExtHostVariableResolverProvider");class p extends l.$xO{constructor(s,i,o,a,u,t,f){function n(){if(o){const w=o.activeEditor();if(w)return w.document.uri;const D=a.tabGroups.all.find(h=>h.isActive)?.activeTab;if(D!==void 0){if(D.input instanceof A.$8M||D.input instanceof A.$aN)return D.input.modified;if(D.input instanceof A.$7M||D.input instanceof A.$_M||D.input instanceof A.$0M)return D.input.uri}}}super({getFolderUri:w=>{const D=t.folders.filter(h=>h.name===w);if(D&&D.length>0)return D[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(w,D)=>u.getConfiguration(void 0,w).get(D),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const w=n();if(w)return I.$hc(w.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const w=n();if(w){const D=i.getWorkspaceFolder(w);if(D)return I.$hc(D.uri.fsPath)}}},getSelectedText:()=>{if(o){const w=o.activeEditor();if(w&&!w.selection.isEmpty)return w.document.getText(w.selection)}},getLineNumber:()=>{if(o){const w=o.activeEditor();if(w)return String(w.selection.end.line+1)}},getExtension:w=>s.getExtension(w)},void 0,f?Promise.resolve(f):void 0,Promise.resolve(R.env))}}let r=class extends M.$Tc{constructor(s,i,o,a,u){super(),this.b=s,this.c=i,this.g=o,this.h=a,this.j=u,this.a=new S.$V(async()=>{const t=await this.h.getConfigProvider(),n={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async w=>{n.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.j,t,n,this.m())})}getResolver(){return this.a.value}m(){}};e.$rhc=r,e.$rhc=r=Ge([qe(0,y.$nhc),qe(1,k.$Lgc),qe(2,m.$HN),qe(3,$.$Ogc),qe(4,d.$1gc)],r)}),define(Re[117],Ae([1,0,11,5,2,22,4,3,64,38,17,7,36,206,208,37,116,6,40,31]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$whc=e.$vhc=e.$uhc=e.$thc=e.$shc=void 0,e.$shc=(0,L.$8h)("IExtHostDebugService");let a=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q?.api}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(h,b,P,g,v,E,T){this.I=b,this.J=P,this.K=g,this.L=v,this.M=E,this.N=T,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new M.$Wd,this.n=new M.$Wd,this.o=new M.$Wd,this.u=new M.$Wd,this.k=h.getProxy(m.$lL.MainThreadDebugService),this.z=new M.$Wd,this.B=new M.$Wd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(N=>{N.onDidChange(J=>{this.O(N)}),this.O(N)})}asDebugSourceUri(h,b){const P=h;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let g=`debug:${encodeURIComponent(P.path||"")}`,v="?";return b&&(g+=`${v}session=${encodeURIComponent(b.id)}`,v="&"),g+=`${v}ref=${P.sourceReference}`,I.URI.parse(g)}else{if(P.path)return I.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(h){const b=[];for(const P of h.getAllExtensionDescriptions())if(P.contributes){const g=P.contributes.debuggers;if(g&&g.length>0)for(const v of g)(0,p.$hG)(v)&&b.push(v.type)}this.k.$registerDebugTypes(b)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const h=[];return this.y.forEach(b=>h.push(b)),h}async $resolveDebugVisualizer(h,b){const P=this.G.get(h);if(!P)throw new Error(`No debug visualizer found with id '${h}'`);let{v:g,provider:v}=P;if(g.visualization||(g=await v.resolveDebugVisualization?.(g,b)||g,P.v=g),!g.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${v}'`);return this.db(g.visualization)}async $executeDebugVisualizerCommand(h){const b=this.G.get(h);if(!b)throw new Error(`No debug visualizer found with id '${h}'`);const P=b.v.visualization;P&&"command"in P&&this.N.executeCommand(P.command,...P.arguments||[])}async $provideDebugVisualizers(h,b,P,g){const v=this.l.get(P.sessionId),E=this.cb(h,b),T=this.E.get(E);if(!v||!T)return[];const N=await T.provideDebugVisualization({session:v.api,variable:P.variable,containerId:P.containerId,frameId:P.frameId,threadId:P.threadId},g);return N?N.map(J=>{const q=++this.H;this.G.set(q,{v:J,provider:T});const U=J.iconPath?this.eb(J.iconPath):void 0;return{id:q,name:J.name,iconClass:U?.iconClass,iconPath:U?.iconPath,visualization:this.db(J.visualization)}}):[]}$disposeDebugVisualizers(h){for(const b of h)this.G.delete(b)}registerDebugVisualizationProvider(h,b,P){if(!h.contributes?.debugVisualizers?.some(E=>E.id===b))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${b})`);const g=R.$nm.toKey(h.identifier),v=this.cb(g,b);if(this.E.has(v))throw new Error(`A debug visualization provider with id '${b}' is already registered`);return this.E.set(v,P),this.k.$registerDebugVisualizer(g,b),(0,s.$Rc)(()=>{this.k.$unregisterDebugVisualizer(g,b),this.E.delete(b)})}addBreakpoints(h){const b=h.filter(v=>{const E=v.id;return this.y.has(E)?!1:(this.y.set(E,v),!0)});this.$(b,[],[]);const P=[],g=new Map;for(const v of b)if(v instanceof k.$nM){let E=g.get(v.location.uri.toString());E||(E={type:"sourceMulti",uri:v.location.uri,lines:[]},g.set(v.location.uri.toString(),E),P.push(E)),E.lines.push({id:v.id,enabled:v.enabled,condition:v.condition,hitCondition:v.hitCondition,logMessage:v.logMessage,line:v.location.range.start.line,character:v.location.range.start.character})}else v instanceof k.$oM&&P.push({type:"function",id:v.id,enabled:v.enabled,hitCondition:v.hitCondition,logMessage:v.logMessage,condition:v.condition,functionName:v.functionName});return this.k.$registerBreakpoints(P)}removeBreakpoints(h){const b=h.filter(E=>this.y.delete(E.id));this.$([],b,[]);const P=b.filter(E=>E instanceof k.$nM).map(E=>E.id),g=b.filter(E=>E instanceof k.$oM).map(E=>E.id),v=b.filter(E=>E instanceof k.$pM).map(E=>E.id);return this.k.$unregisterBreakpoints(P,g,v)}startDebugging(h,b,P){return this.k.$startDebugging(h?h.uri:void 0,b,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,suppressSaveBeforeStart:P.suppressSaveBeforeStart,suppressDebugStatusbar:P.suppressDebugStatusbar??P.debugUI?.simple,suppressDebugToolbar:P.suppressDebugToolbar??P.debugUI?.simple,suppressDebugView:P.suppressDebugView??P.debugUI?.simple})}stopDebugging(h){return this.k.$stopDebugging(h?h.id:void 0)}registerDebugConfigurationProvider(h,b,P){if(!b)return new k.$nL(()=>{});const g=this.d++;return this.f.push({type:h,handle:g,provider:b}),this.k.$registerDebugConfigurationProvider(h,P,!!b.provideDebugConfigurations,!!b.resolveDebugConfiguration,!!b.resolveDebugConfigurationWithSubstitutedVariables,g),new k.$nL(()=>{this.f=this.f.filter(v=>v.provider!==b),this.k.$unregisterDebugConfigurationProvider(g)})}registerDebugAdapterDescriptorFactory(h,b,P){if(!P)return new k.$nL(()=>{});if(!this.W(h,b))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${b}' debugger.`);if(this.S(b))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const g=this.g++;return this.h.push({type:b,handle:g,factory:P}),this.k.$registerDebugAdapterDescriptorFactory(b,g),new k.$nL(()=>{this.h=this.h.filter(v=>v.factory!==P),this.k.$unregisterDebugAdapterDescriptorFactory(g)})}registerDebugAdapterTrackerFactory(h,b){if(!b)return new k.$nL(()=>{});const P=this.i++;return this.j.push({type:h,handle:P,factory:b}),new k.$nL(()=>{this.j=this.j.filter(g=>g.factory!==b)})}async $runInTerminal(h,b){return Promise.resolve(void 0)}async $substituteVariables(h,b){let P;const g=await this.bb(h);return g&&(P={uri:g.uri,name:g.name,index:g.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(P,b)}P(h,b){if(h.type==="implementation")return new n(h.implementation)}Q(){}async $startDASession(h,b){const P=this,g=await this.ab(b);return this.Y(this.S(g.type),g).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}' (extension might have failed to activate)`);const E=this.R(v),T=this.P(E,g);if(!T)throw new Error(`Couldn't create a debug adapter for type '${g.type}'.`);const N=T;return this.C.set(h,N),this.X(g).then(J=>(J&&this.D.set(h,J),N.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const U=q,C={type:"response",seq:0,command:U.command,request_seq:U.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const F=await this.F.sign(U.arguments.value);C.body={signature:F},N.sendResponse(C)}else throw new Error("no signer")}catch(F){C.success=!1,C.message=F.message,N.sendResponse(C)}}else J&&J.onDidSendMessage&&J.onDidSendMessage(q),q=(0,p.$mG)(q,!0),P.k.$acceptDAMessage(h,q)}),N.onError(q=>{J&&J.onError&&J.onError(q),this.k.$acceptDAError(h,q.name,q.message,q.stack)}),N.onExit(q=>{J&&J.onExit&&J.onExit(q??void 0,void 0),this.k.$acceptDAExit(h,q??void 0,void 0)}),J&&J.onWillStartSession&&J.onWillStartSession(),N.startSession()))})}$sendDAMessage(h,b){b=(0,p.$lG)(b,!1);const P=this.D.get(h);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(b),this.C.get(h)?.sendMessage(b)}$stopDASession(h){const b=this.D.get(h);this.D.delete(h),b&&b.onWillStopSession&&b.onWillStopSession();const P=this.C.get(h);return this.C.delete(h),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(h){const b=[],P=[],g=[];if(h.added)for(const v of h.added){const E=v.id;if(E&&!this.y.has(E)){let T;if(v.type==="function")T=new k.$oM(v.functionName,v.enabled,v.condition,v.hitCondition,v.logMessage);else if(v.type==="data")T=new k.$pM(v.label,v.dataId,v.canPersist,v.enabled,v.hitCondition,v.condition,v.logMessage);else{const N=I.URI.revive(v.uri);T=new k.$nM(new k.$zL(N,new k.$oL(v.line,v.character)),v.enabled,v.condition,v.hitCondition,v.logMessage)}(0,k.$lM)(T,E),this.y.set(E,T),b.push(T)}}if(h.removed)for(const v of h.removed){const E=this.y.get(v);E&&(this.y.delete(v),P.push(E))}if(h.changed){for(const v of h.changed)if(v.id){const E=this.y.get(v.id);if(E){if(E instanceof k.$oM&&v.type==="function"){const T=E;T.enabled=v.enabled,T.condition=v.condition,T.hitCondition=v.hitCondition,T.logMessage=v.logMessage,T.functionName=v.functionName}else if(E instanceof k.$nM&&v.type==="source"){const T=E;T.enabled=v.enabled,T.condition=v.condition,T.hitCondition=v.hitCondition,T.logMessage=v.logMessage,T.location=new k.$zL(I.URI.revive(v.uri),new k.$oL(v.line,v.character))}g.push(E)}}}this.$(b,P,g)}async $acceptStackFrameFocus(h){let b;const P=h.sessionId?await this.ab(h.sessionId):void 0;if(!P)throw new Error("no DebugSession found for debug focus context");h.kind==="thread"?b=new k.$vM(P.api,h.threadId):b=new k.$uM(P.api,h.threadId,h.frameId),this.A=b,this.B.fire(this.A)}$provideDebugConfigurations(h,b,P){return(0,S.$Zg)(async()=>{const g=this.V(h);if(!g)throw new Error("no DebugConfigurationProvider found");if(!g.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const v=await this.bb(b);return g.provideDebugConfigurations(v,P)}).then(g=>{if(!g)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return g})}$resolveDebugConfiguration(h,b,P,g){return(0,S.$Zg)(async()=>{const v=this.V(h);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const E=await this.bb(b);return v.resolveDebugConfiguration(E,P,g)})}$resolveDebugConfigurationWithSubstitutedVariables(h,b,P,g){return(0,S.$Zg)(async()=>{const v=this.V(h);if(!v)throw new Error("no DebugConfigurationProvider found");if(!v.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const E=await this.bb(b);return v.resolveDebugConfigurationWithSubstitutedVariables(E,P,g)})}async $provideDebugAdapter(h,b){const P=this.U(h);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const g=await this.ab(b);return this.Y(P,g).then(v=>{if(!v)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${g.type}'`);return this.R(v)})}async $acceptDebugSessionStarted(h){const b=await this.ab(h);this.m.fire(b.api)}async $acceptDebugSessionTerminated(h){const b=await this.ab(h);b&&(this.n.fire(b.api),this.l.delete(b.id))}async $acceptDebugSessionActiveChanged(h){this.q=h?await this.ab(h):void 0,this.o.fire(this.q?.api)}async $acceptDebugSessionNameChanged(h,b){(await this.ab(h))?._acceptNameChanged(b)}async $acceptDebugSessionCustomEvent(h,b){const g={session:(await this.ab(h)).api,event:b.event,body:b.body};this.u.fire(g)}R(h){if(h instanceof k.$qM)return{type:"executable",command:h.command,args:h.args,options:h.options};if(h instanceof k.$rM)return{type:"server",port:h.port,host:h.host};if(h instanceof k.$sM)return{type:"pipeServer",path:h.path};if(h instanceof k.$tM)return{type:"implementation",implementation:h.implementation};throw new Error("convertToDto unexpected type")}S(h){const b=this.h.filter(P=>P.type===h);if(b.length>0)return b[0].factory}U(h){const b=this.h.filter(P=>P.handle===h);if(b.length>0)return b[0].factory}V(h){const b=this.f.filter(P=>P.handle===h);if(b.length>0)return b[0].provider}W(h,b){if(h.contributes){const P=h.contributes.debuggers;if(P&&P.length>0){for(const g of P)if(g.label&&g.type&&g.type===b)return!0}}return!1}X(h){const P=h.configuration.type,g=this.j.filter(v=>v.type===P||v.type==="*").map(v=>(0,S.$Zg)(()=>v.factory.createDebugAdapterTracker(h.api)).then(E=>E,E=>null));return Promise.race([Promise.all(g).then(v=>{const E=v.filter(T=>!!T);if(E.length>0)return new f(E)}),new Promise(v=>setTimeout(()=>v(void 0),1e3))]).catch(v=>{})}async Y(h,b){const P=b.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new k.$rM(P));if(h){const v=await this.J.getExtensionRegistry();return(0,S.$Zg)(()=>h.createDebugAdapterDescriptor(b.api,this.Z(b,v))).then(E=>{if(E)return E})}const g=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(b,g))}Z(h,b){}$(h,b,P){(h.length>0||b.length>0||P.length>0)&&this.z.fire(Object.freeze({added:h,removed:b,changed:P}))}async ab(h){if(h)if(typeof h=="string"){const b=this.l.get(h);if(b)return b}else{let b=this.l.get(h.id);if(!b){const P=await this.bb(h.folderUri),g=h.parent?this.l.get(h.parent):void 0;b=new u(this.k,h.id,h.type,h.name,P,h.configuration,g?.api),this.l.set(b.id,b),this.k.$sessionCached(b.id)}return b}throw new Error("cannot find session")}bb(h){if(h){const b=I.URI.revive(h);return this.I.resolveWorkspaceFolder(b)}return Promise.resolve(void 0)}cb(h,b){return`${h}\0${b}`}db(h){if(h){if("title"in h&&"command"in h)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(h){const b=this.fb(h);let P,g;return"id"in b?g=i.ThemeIcon.asClassName(b):P=b,{iconPath:P,iconClass:g}}fb(h){if(h instanceof k.$iM)return{id:h.id};const b=typeof h=="object"&&"dark"in h?h.dark:h,P=typeof h=="object"&&"light"in h?h.light:h;return{dark:typeof b=="string"?I.URI.file(b):b,light:typeof P=="string"?I.URI.file(P):P}}};e.$thc=a,e.$thc=a=Ge([qe(0,A.$wN),qe(1,l.$Lgc),qe(2,y.$nhc),qe(3,r.$Ogc),qe(4,d.$1gc),qe(5,c.$qhc),qe(6,o.$SN)],a);class u{constructor(h,b,P,g,v,E,T){this.f=h,this.g=b,this.h=P,this.i=g,this.j=v,this.k=E,this.l=T}get api(){const h=this;return this.d??=Object.freeze({id:h.g,type:h.h,get name(){return h.i},set name(b){h.i=b,h.f.$setDebugSessionName(h.g,b)},parentSession:h.l,workspaceFolder:h.j,configuration:h.k,customRequest(b,P){return h.f.$customDebugAdapterRequest(h.g,b,P)},getDebugProtocolBreakpoint(b){return h.f.$getDebugProtocolBreakpoint(h.g,b.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(h){this.i=h}get configuration(){return this.k}}e.$uhc=u;class t{constructor(h){this.value=Object.freeze({append(b){h.$appendDebugConsole(b)},appendLine(b){this.append(b+`
`)}})}}e.$vhc=t;class f{constructor(h){this.d=h}onWillStartSession(){this.d.forEach(h=>h.onWillStartSession?h.onWillStartSession():void 0)}onWillReceiveMessage(h){this.d.forEach(b=>b.onWillReceiveMessage?b.onWillReceiveMessage(h):void 0)}onDidSendMessage(h){this.d.forEach(b=>b.onDidSendMessage?b.onDidSendMessage(h):void 0)}onWillStopSession(){this.d.forEach(h=>h.onWillStopSession?h.onWillStopSession():void 0)}onError(h){this.d.forEach(b=>b.onError?b.onError(h):void 0)}onExit(h,b){this.d.forEach(P=>P.onExit?P.onExit(h,b):void 0)}}class n extends $.$nmb{constructor(h){super(),this.h=h,h.onDidSendMessage(b=>{this.acceptMessage(b)})}startSession(){return Promise.resolve(void 0)}sendMessage(h){this.h.handleMessage(h)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let w=class extends a{constructor(h,b,P,g,v,E,T){super(h,b,P,g,v,E,T)}};e.$whc=w,e.$whc=w=Ge([qe(0,A.$wN),qe(1,l.$Lgc),qe(2,y.$nhc),qe(3,r.$Ogc),qe(4,d.$1gc),qe(5,c.$qhc),qe(6,o.$SN)],w)}),define(Re[289],Ae([1,0,15,87,2,3,235,13,53,71,27,184,17,58,38,60]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zic=e.$yic=void 0;class c{static async installEarlyHandler(o){Error.stackTraceLimit=100;const a=o.get(m.$pj),t=o.get(l.$wN).getProxy(R.$lL.MainThreadErrors);S.setUnexpectedErrorHandler(f=>{a.error(f);const n=S.$3(f);t.$onUnexpectedError(n)})}static async installFullHandler(o){const a=o.get(m.$pj),u=o.get(l.$wN),t=o.get(p.$nhc),f=o.get(r.$QN),n=u.getProxy(R.$lL.MainThreadExtensionService),w=u.getProxy(R.$lL.MainThreadErrors),D=await t.getExtensionPathIndex(),h=new WeakMap;function b(v,E){if(h.has(v))return h.get(v).stack;let T="",N,J;for(const U of E)T+=`
	at ${U.toString()}`,J=U.getFileName(),!N&&J&&(N=D.findSubstr(I.URI.file(J)));const q=`${v.name||"Error"}: ${v.message||""}${T}`;return h.set(v,{extensionIdentifier:N?.identifier,stack:q}),q}const P=Symbol("prepareStackTrace wrapped");let g=b;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return g},set(v){if(v===b||!v||v[P]){g=v||b;return}g=function(E,T){return b(E,T),v.call(Error,E,T)},Object.assign(g,{[P]:!0})}}),S.setUnexpectedErrorHandler(v=>{a.error(v);const E=S.$3(v),T=h.get(v);if(!T?.extensionIdentifier){w.$onUnexpectedError(E);return}n.$onExtensionRuntimeError(T.extensionIdentifier,E);const N=f.onExtensionError(T.extensionIdentifier,v);a.trace("forwarded error to extension?",N,T)})}}e.$yic=c;class s{constructor(o,a,u,t,f){this.a=u,this.b=new L.$y8b(o,null,t),a=s.e(a,this.b);const n=new y.$6h(...(0,d.$2r)());n.set(A.$MN,{_serviceBrand:void 0,...a,messagePorts:f}),n.set(l.$wN,new l.$xN(this.b)),n.set($.$Igc,new $.$Jgc(t)),n.set(p.$lhc,u);const w=new k.$Gq(n,!0);w.invokeFunction(c.installEarlyHandler),this.d=w.invokeFunction(D=>D.get(m.$pj)),M.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",a),this.c=w.invokeFunction(D=>D.get(p.$nhc)),this.c.initialize(),w.invokeFunction(c.installFullHandler)}async asBrowserUri(o){const a=this.b.getProxy(R.$lL.MainThreadExtensionService);return I.URI.revive(await a.$asBrowserUri(o))}terminate(o){this.c.terminate(o)}static e(o,a){o.extensions.allExtensions.forEach(t=>{t.extensionLocation=I.URI.revive(a.transformIncomingURIs(t.extensionLocation))}),o.environment.appRoot=I.URI.revive(a.transformIncomingURIs(o.environment.appRoot));const u=o.environment.extensionDevelopmentLocationURI;return u&&(o.environment.extensionDevelopmentLocationURI=u.map(t=>I.URI.revive(a.transformIncomingURIs(t)))),o.environment.extensionTestsLocationURI=I.URI.revive(a.transformIncomingURIs(o.environment.extensionTestsLocationURI)),o.environment.globalStorageHome=I.URI.revive(a.transformIncomingURIs(o.environment.globalStorageHome)),o.environment.workspaceStorageHome=I.URI.revive(a.transformIncomingURIs(o.environment.workspaceStorageHome)),o.environment.extensionTelemetryLogResource=I.URI.revive(a.transformIncomingURIs(o.environment.extensionTelemetryLogResource)),o.nlsBaseUrl=I.URI.revive(a.transformIncomingURIs(o.nlsBaseUrl)),o.logsLocation=I.URI.revive(a.transformIncomingURIs(o.logsLocation)),o.workspace=a.transformIncomingURIs(o.workspace),o}}e.$zic=s}),define(Re[290],Ae([1,0,18,11,21,41,12,19,24,2,44]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nhc=e.$Mhc=e.$Lhc=e.$Khc=void 0;class k{constructor(i,o,a,u){this.d=i,this.e=o,this.f=a,this.g=u,this.a=null,this.b=!1,this.c=0}search(i,o){const a=this.d.folderQueries||[],u=new I.$7d(o);return new Promise((t,f)=>{this.a=new $(i);let n=!1;const w=(D,h)=>{if(!n&&!this.b){const b=this.h(D);r(D)&&typeof this.d.maxResults=="number"&&this.c+b>this.d.maxResults&&(this.b=!0,n=!0,u.cancel(),D=this.j(D,this.d.maxResults-this.c));const P=this.h(D);this.c+=P,(P>0||!r(D))&&this.a.add(D,h)}};Promise.all(a.map((D,h)=>this.k(D,b=>w(b,h),u.token))).then(D=>{u.dispose(),this.a.flush();const h=D.some(b=>!!b&&!!b.limitHit);t({limitHit:this.b||h,messages:(0,S.$Rb)(D.map(b=>b?.message?Array.isArray(b.message)?b.message:[b.message]:[])),stats:{type:this.g}})},D=>{u.dispose();const h=(0,R.$Si)(D);f(new Error(h))})})}h(i){return r(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,o){const a=Array.isArray(i.ranges)?i.ranges:[i.ranges],u=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:a.slice(0,o),preview:{matches:u.slice(0,o),text:i.preview.text},uri:i.uri}}async k(i,o,a){const u=new A.$1J(this.d,i),t=[],f={report:D=>{if(!this.l(D))return;const h=i.folder.scheme===L.Schemas.file?(0,A.$2J)(()=>this.f.readdir(d.$Hg(D.uri))):void 0,b=d.$Kg(i.folder,D.uri);if(b){const P=u.includedInQuery(b,m.$nc(b),h);(0,M.$Tg)(P)?t.push(P.then(g=>{g&&o(D)})):P&&o(D)}}},n=this.n(i),w=await this.e.provideTextSearchResults(l(this.d.contentPattern),n,f,a);return t.length&&await Promise.all(t),w}l(i){if(r(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const o=(0,A.$ZJ)(this.d.includePattern,i.includePattern),a=(0,A.$ZJ)(this.d.excludePattern,i.excludePattern),u={folder:y.URI.from(i.folder),excludes:a,includes:o,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return u.usePCRE2=this.d.usePCRE2,u}}e.$Khc=k;function l(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class ${constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new c(512,o=>this.g(o))}add(i,o){this.d&&(this.b!==o||!d.$Bg(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=o,this.d={resource:i.uri,results:[]}),this.d.results.push(p(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$Lhc=$;function p(s){return r(s)?{preview:{matches:(0,S.$2b)(s.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:s.preview.text},ranges:(0,S.$2b)(s.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function r(s){return!!s.preview}e.$Mhc=r;class c{static{this.a=4e3}static{this.b=50}constructor(i,o){this.g=i,this.h=o,this.c=0,this.d=[],this.e=0}addItem(i,o){i&&this.j(i,o)}addItems(i,o){i&&this.k(i,o)}j(i,o){this.d.push(i),this.e+=o,this.l()}k(i,o){this.d=this.d.concat(i),this.e+=o,this.l()}l(){this.c<c.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},c.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$Nhc=c}),define(Re[118],Ae([1,0,6,3,4,285,17,58,13,2,290]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=e.$Ohc=void 0,e.$Ohc=(0,I.$8h)("IExtHostSearch");let k=class{constructor(r,c,s){this.k=r,this.l=c,this.n=s,this.c=this.k.getProxy(M.$lL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.$Jhc}o(r){return this.l.transformOutgoingScheme(r)}registerTextSearchProvider(r,c){if(this.g.has(r))throw new Error(`a text search provider for the scheme '${r}' is already registered`);this.g.add(r);const s=this.d++;return this.e.set(s,c),this.c.$registerTextSearchProvider(s,this.o(r)),(0,S.$Rc)(()=>{this.g.delete(r),this.e.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(r,c){if(this.i.has(r))throw new Error(`a file search provider for the scheme '${r}' is already registered`);this.i.add(r);const s=this.d++;return this.h.set(s,c),this.c.$registerFileSearchProvider(s,this.o(r)),(0,S.$Rc)(()=>{this.i.delete(r),this.h.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(r,c,s,i){const o=l(s),a=this.h.get(r);if(a)return this.j.fileSearch(o,a,u=>{this.c.$handleFileMatch(r,c,u.map(t=>t.resource))},i);throw new Error("unknown provider: "+r)}async doInternalFileSearchWithCustomCallback(r,c,s){return{messages:[]}}$clearCache(r){return this.j.clearCache(r),Promise.resolve(void 0)}$provideTextSearchResults(r,c,s,i){const o=this.e.get(r);if(!o||!o.provideTextSearchResults)throw new Error(`Unknown provider ${r}`);const a=l(s);return this.q(a,o).search(t=>this.c.$handleTextMatch(r,c,t),i)}$enableExtensionHostSearch(){}q(r,c){return new A.$Khc(r,c,{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}};e.$Phc=k,e.$Phc=k=Ge([qe(0,L.$wN),qe(1,m.$Igc),qe(2,d.$pj)],k);function l(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map($),extraFileResources:p.extraFileResources&&p.extraFileResources.map(r=>y.URI.revive(r))}}e.$Qhc=l;function $(p){return{...p,folder:y.URI.revive(p.folder)}}}),define(Re[291],Ae([1,0,21,15,5,6,12,32,2,146,142,130,92,22,42,13,56,57,197,3,238,269,78,239,245,223,246,247,248,224,212,31,249,37,250,117,107,251,226,240,252,253,66,64,241,38,255,62,256,43,27,270,271,242,227,257,258,79,80,229,284,260,201,261,272,262,112,230,263,264,265,17,266,118,81,267,231,268,82,84,115,60,65,273,274,243,275,276,85,8,7,232,58,233,61,277,278,106,36,207,77,25,114]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f,n,w,D,h,b,P,g,v,E,T,N,J,q,U,C,F,W,re,ce,we,De,le,ve,se,$e,te,X,V,ie,Ce,Te,Pe,be,ge,G,_,ue,de,Le,fe,ke,Ie,O,K,j,H,Z,oe,Ee,Be,We,Ze,_e,at,rt,et,ct,je,vt,Y,x,pe,Ve,Qe,nt,st,Ne,Mt,Qt,_t,jt,yt,ei,Bt,ni,Zt,Yt,Xe,Wt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tic=void 0;function ti(ht){const mt=ht.get(X.$MN),Kt=ht.get(te.$qgc),ii=ht.get(se.$Qgc),Ct=ht.get(le.$nhc),dt=ht.get(ni.$Lgc),Lt=ht.get(je.$QN),ri=ht.get(T.$Ogc),Rt=ht.get(Qt.$Igc),He=ht.get(oe.$wN),Ft=ht.get(rt.$0gc),Vt=ht.get(et.$Rgc),Xt=ht.get(r.$qj),ft=ht.get(r.$pj),Tt=ht.get(nt.$vzb),It=ht.get(t.$tgc),Nt=ht.get(Bt.$sic),qt=ht.get(We.$fhc),Ot=ht.get(we.$1gc),Dt=ht.get(G.$jhc);He.set(o.$mL.ExtHostFileSystemInfo,Kt),He.set(o.$mL.ExtHostLogLevelServiceShape,Xt),He.set(o.$mL.ExtHostWorkspace,dt),He.set(o.$mL.ExtHostConfiguration,ri),He.set(o.$mL.ExtHostExtensionService,Ct),He.set(o.$mL.ExtHostStorage,Ft),He.set(o.$mL.ExtHostTunnelService,Tt),He.set(o.$mL.ExtHostWindow,Nt),He.set(o.$mL.ExtHostSecretState,qt),He.set(o.$mL.ExtHostTelemetry,Lt),He.set(o.$mL.ExtHostEditorTabs,Ot),He.set(o.$mL.ExtHostManagedSockets,Dt);const Gt=He.set(o.$mL.ExtHostDecorations,ht.get(q.$yhc)),Et=He.set(o.$mL.ExtHostDocumentsAndEditors,ht.get(ce.$HN)),wt=He.set(o.$mL.ExtHostCommands,ht.get(v.$SN)),St=He.set(o.$mL.ExtHostTerminalService,ht.get(vt.$ahc)),kt=He.set(o.$mL.ExtHostDebugService,ht.get(J.$shc)),ye=He.set(o.$mL.ExtHostSearch,ht.get(Be.$Ohc)),Fe=He.set(o.$mL.ExtHostTask,ht.get(ct.$fic)),he=He.set(o.$mL.ExtHostOutputService,ht.get(O.$5hc)),Q=He.set(o.$mL.ExtHostLocalization,ht.get(ge.$ihc)),Me=He.set(o.$mL.ExtHostUrls,new _t.$pic(He)),Ue=He.set(o.$mL.ExtHostDocuments,new re.$ogc(He,Et)),Ye=He.set(o.$mL.ExtHostDocumentContentProviders,new F.$Ahc(He,Et,ft)),Ke=He.set(o.$mL.ExtHostDocumentSaveParticipant,new W.$Bhc(ft,Ue,He.getProxy(o.$lL.MainThreadBulkEdits))),tt=He.set(o.$mL.ExtHostNotebook,new ue.$Rhc(He,wt,Et,Ue,ii,ye)),pt=He.set(o.$mL.ExtHostNotebookDocuments,new Le.$Yhc(tt)),zt=He.set(o.$mL.ExtHostNotebookEditors,new fe.$Zhc(ft,tt)),Ut=He.set(o.$mL.ExtHostNotebookKernels,new ke.$1hc(He,mt,tt,wt,ft)),Pt=He.set(o.$mL.ExtHostNotebookRenderers,new Ie.$3hc(He,tt)),Jt=He.set(o.$mL.ExtHostNotebookDocumentSaveParticipant,new de.$Xhc(ft,tt,He.getProxy(o.$lL.MainThreadBulkEdits))),Ht=He.set(o.$mL.ExtHostEditors,new x.$Fgc(He,Et)),yi=He.set(o.$mL.ExtHostTreeViews,new Qe.$nic(He.getProxy(o.$lL.MainThreadTreeViews),wt,ft)),Li=He.set(o.$mL.ExtHostEditorInsets,new g.$Ggc(He.getProxy(o.$lL.MainThreadEditorInsets),Ht,mt.remote)),mi=He.set(o.$mL.ExtHostDiagnostics,new U.$sgc(He,ft,Kt,Et)),$i=He.set(o.$mL.ExtHostLanguages,new be.$Vhc(He,Ue,wt.converter,Rt)),lt=He.set(o.$mL.ExtHostLanguageFeatures,new Pe.$wgc(He,Rt,Ue,wt,mi,ft,It,Lt)),Qi=He.set(o.$mL.ExtHostFileSystem,new ve.$Dhc(He,lt)),ai=He.set(o.$mL.ExtHostFileSystemEventService,new $e.$Ehc(He,ft,Et)),di=He.set(o.$mL.ExtHostQuickOpen,(0,Z.$9hc)(He,dt,wt)),Ei=He.set(o.$mL.ExtHostSCM,new Ee.$$hc(He,wt,Ue,ft)),Ri=He.set(o.$mL.ExtHostQuickDiff,new H.$8hc(He,Rt)),Zi=He.set(o.$mL.ExtHostShare,new Ze.$_hc(He,Rt)),Ai=He.set(o.$mL.ExtHostComments,(0,E.$Hgc)(He,wt,Ue)),Di=He.set(o.$mL.ExtHostProgress,new j.$7hc(He.getProxy(o.$lL.MainThreadProgress))),Yi=He.set(o.$mL.ExtHostLabelService,new Te.$Uhc(He)),Mi=He.set(o.$mL.ExtHostTheming,new pe.$kic(He)),pi=He.set(o.$mL.ExtHostAuthentication,new f.$ygc(He)),Xi=He.set(o.$mL.ExtHostTimeline,new Ve.$mic(He,wt)),ki=He.set(o.$mL.ExtHostWebviews,new jt.$Vgc(He,mt.remote,dt,ft,It)),Fi=He.set(o.$mL.ExtHostWebviewPanels,new yt.$Ygc(He,ki,dt)),ln=He.set(o.$mL.ExtHostCustomEditors,new N.$Zgc(He,Ue,Vt,ki,Fi)),Ti=He.set(o.$mL.ExtHostWebviewViews,new ei.$qic(He,ki)),fi=He.set(o.$mL.ExtHostTesting,new Y.$gic(He,ft,wt,Et)),hn=He.set(o.$mL.ExtHostUriOpeners,new Mt.$oic(He)),dn=He.set(o.$mL.ExtHostProfileContentHandlers,new K.$6hc(He));He.set(o.$mL.ExtHostInteractive,new ie.$Shc(He,tt,Et,wt,ft));const xi=He.set(o.$mL.ExtHostInlineChat,new V.$Fhc(He,wt,Ue,ft)),wi=He.set(o.$mL.ExtHostChatProvider,new h.$Bgc(He,ft)),Ni=He.set(o.$mL.ExtHostChatAgents2,new D.$Cgc(He,wi,ft)),_i=He.set(o.$mL.ExtHostChatVariables,new b.$Dgc(He)),Si=He.set(o.$mL.ExtHostChat,new w.$Agc(He)),Oi=He.set(o.$mL.ExtHostAiRelatedInformation,new a.$ngc(He)),fn=He.set(o.$mL.ExtHostAiEmbeddingVector,new De.$Chc(He)),Ii=He.set(o.$mL.ExtHostIssueReporter,new Ce.$Thc(He)),zi=He.set(o.$mL.ExtHostStatusBar,new at.$cic(He,wt.converter)),li=He.set(o.$mL.ExtHostSpeech,new _e.$aic(He)),Ci=Object.values(o.$mL);He.assertRegistered(Ci);const gn=new n.$zgc(He,Et),si=new P.$Egc(He),vi=new _.$Whc(He,ft),Ui=new C.$zhc(He);return u.$xgc.register(wt),function(ze,ci,ji){function it(ee){return(ae,Oe,ot)=>{const bt=ee(At=>{try{ae.call(Oe,At)}catch(Ki){M.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Ki.toString()}`,{cause:Ki})),Lt.onExtensionError(ze.identifier,Ki)}});return ot?.push(bt),bt}}const $t=function(){let ee=!ze.isUnderDevelopment;function ae(){ee||(ft.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function Oe(ot){if(Array.isArray(ot))ot.forEach(Oe);else if(typeof ot=="string")ae();else{const bt=ot;typeof bt.scheme>"u"&&ae(),typeof bt.exclusive=="boolean"&&(0,Xe.$LF)(ze,"documentFiltersExclusive")}return ot}}(),en={getSession(ee,ae,Oe){return pi.getSession(ze,ee,ae,Oe)},getSessions(ee,ae){return(0,Xe.$LF)(ze,"authGetSessions"),pi.getSessions(ze,ee,ae)},async hasSession(ee,ae){return(0,Xe.$LF)(ze,"authSession"),!!await pi.getSession(ze,ee,ae,{silent:!0})},get onDidChangeSessions(){return it(pi.onDidChangeSessions)},registerAuthenticationProvider(ee,ae,Oe,ot){return pi.registerAuthenticationProvider(ee,ae,Oe,ot)}},mn={registerCommand(ee,ae,Oe){return wt.registerCommand(!0,ee,ae,Oe,void 0,ze)},registerTextEditorCommand(ee,ae,Oe){return wt.registerCommand(!0,ee,(...ot)=>{const bt=Ht.getActiveTextEditor();if(!bt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}return bt.edit(At=>{ae.apply(Oe,[bt,At,...ot])}).then(At=>{At||ft.warn("Edits from command "+ee+" were not applied.")},At=>{ft.warn("An error occurred while running command "+ee,At)})},void 0,void 0,ze)},registerDiffInformationCommand:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"diffCommand"),wt.registerCommand(!0,ee,async(...ot)=>{const bt=Et.activeEditor(!0);if(!bt){ft.warn("Cannot execute "+ee+" because there is no active text editor.");return}const At=await Ht.getDiffInformation(bt.id);ae.apply(Oe,[At,...ot])},void 0,void 0,ze)),executeCommand(ee,...ae){return wt.executeCommand(ee,...ae)},getCommands(ee=!1){return wt.getCommands(ee)}},tn={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return si.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return it(St.onDidChangeShell)},get isTelemetryEnabled(){return Lt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return it(Lt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Xe.$LF)(ze,"telemetry"),Lt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Xe.$LF)(ze,"telemetry"),it(Lt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,je.$PN)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(ee,ae){return je.$ON.validateSender(ee),Lt.instantiateLogger(ze,ee,ae)},openExternal(ee,ae){return Nt.openUri(ee,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:ae?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===mt.environment.appUriScheme)return Me.createAppUri(ee);try{return await Nt.asExternalUri(ee,{allowTunneling:!!mt.remote.authority})}catch(ae){if((0,L.$fg)(ee,L.Schemas.http)||(0,L.$fg)(ee,L.Schemas.https))return ee;throw ae}},get remoteName(){return(0,c.$dl)(mt.remote.authority)},get remoteAuthority(){return(0,Xe.$LF)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return ft.getLevel()},get onDidChangeLogLevel(){return it(ft.onDidChangeLogLevel)},registerIssueUriRequestHandler(ee){return(0,Xe.$LF)(ze,"handleIssueUri"),Ii.registerIssueUriRequestHandler(ze,ee)},registerIssueDataProvider(ee){return(0,Xe.$LF)(ze,"handleIssueUri"),Ii.registerIssueDataProvider(ze,ee)},get appQuality(){return(0,Xe.$LF)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Xe.$LF)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(tn);const nn={createTestController(ee,ae,Oe){return fi.createTestController(ze,ee,ae,Oe)},createTestObserver(){return(0,Xe.$LF)(ze,"testObserver"),fi.createTestObserver()},runTests(ee){return(0,Xe.$LF)(ze,"testObserver"),fi.runTests(ee)},get onDidChangeTestResults(){return(0,Xe.$LF)(ze,"testObserver"),it(fi.onResultsChanged)},get testResults(){return(0,Xe.$LF)(ze,"testObserver"),fi.results}},bi=mt.remote.isRemote?Ne.ExtensionKind.Workspace:Ne.ExtensionKind.UI,rn={getExtension(ee,ae){(0,Xe.$KF)(ze,"extensionsAny")||(ae=!1);const Oe=ci.mine.getExtensionDescription(ee);if(Oe)return new le.$ohc(Ct,ze.identifier,Oe,bi,!1);if(ae){const ot=ci.all.getExtensionDescription(ee);if(ot)return new le.$ohc(Ct,ze.identifier,ot,bi,!0)}},get all(){const ee=[];for(const ae of ci.mine.getAllExtensionDescriptions())ee.push(new le.$ohc(Ct,ze.identifier,ae,bi,!1));return ee},get allAcrossExtensionHosts(){(0,Xe.$LF)(ze,"extensionsAny");const ee=new $.$om(ci.mine.getAllExtensionDescriptions().map(Oe=>Oe.identifier)),ae=[];for(const Oe of ci.all.getAllExtensionDescriptions()){const ot=!ee.has(Oe.identifier);ae.push(new le.$ohc(Ct,ze.identifier,Oe,bi,ot))}return ae},get onDidChange(){return(0,Xe.$KF)(ze,"extensionsAny")?it(I.Event.any(ci.mine.onDidChange,ci.all.onDidChange)):it(ci.mine.onDidChange)}},sn={createDiagnosticCollection(ee){return mi.createDiagnosticCollection(ze.identifier,ee)},get onDidChangeDiagnostics(){return it(mi.onDidChangeDiagnostics)},getDiagnostics:ee=>mi.getDiagnostics(ee),getLanguages(){return $i.getLanguages()},setTextDocumentLanguage(ee,ae){return $i.changeLanguage(ee.uri,ae)},match(ee,ae){const Oe=Ue.getDocumentData(ae.uri)?.notebook;return(0,A.$Dt)(st.LanguageSelector.from(ee),ae.uri,ae.languageId,!0,Oe?.uri,Oe?.notebookType)},registerCodeActionsProvider(ee,ae,Oe){return lt.registerCodeActionProvider(ze,$t(ee),ae,Oe)},registerDocumentPasteEditProvider(ee,ae,Oe){return(0,Xe.$LF)(ze,"documentPaste"),lt.registerDocumentPasteEditProvider(ze,$t(ee),ae,Oe)},registerCodeLensProvider(ee,ae){return lt.registerCodeLensProvider(ze,$t(ee),ae)},registerDefinitionProvider(ee,ae){return lt.registerDefinitionProvider(ze,$t(ee),ae)},registerDeclarationProvider(ee,ae){return lt.registerDeclarationProvider(ze,$t(ee),ae)},registerImplementationProvider(ee,ae){return lt.registerImplementationProvider(ze,$t(ee),ae)},registerTypeDefinitionProvider(ee,ae){return lt.registerTypeDefinitionProvider(ze,$t(ee),ae)},registerHoverProvider(ee,ae){return lt.registerHoverProvider(ze,$t(ee),ae,ze.identifier)},registerEvaluatableExpressionProvider(ee,ae){return lt.registerEvaluatableExpressionProvider(ze,$t(ee),ae,ze.identifier)},registerInlineValuesProvider(ee,ae){return lt.registerInlineValuesProvider(ze,$t(ee),ae,ze.identifier)},registerDocumentHighlightProvider(ee,ae){return lt.registerDocumentHighlightProvider(ze,$t(ee),ae)},registerMultiDocumentHighlightProvider(ee,ae){return lt.registerMultiDocumentHighlightProvider(ze,$t(ee),ae)},registerLinkedEditingRangeProvider(ee,ae){return lt.registerLinkedEditingRangeProvider(ze,$t(ee),ae)},registerReferenceProvider(ee,ae){return lt.registerReferenceProvider(ze,$t(ee),ae)},registerRenameProvider(ee,ae){return lt.registerRenameProvider(ze,$t(ee),ae)},registerNewSymbolNamesProvider(ee,ae){return(0,Xe.$LF)(ze,"newSymbolNamesProvider"),lt.registerNewSymbolNamesProvider(ze,$t(ee),ae)},registerDocumentSymbolProvider(ee,ae,Oe){return lt.registerDocumentSymbolProvider(ze,$t(ee),ae,Oe)},registerWorkspaceSymbolProvider(ee){return lt.registerWorkspaceSymbolProvider(ze,ee)},registerDocumentFormattingEditProvider(ee,ae){return lt.registerDocumentFormattingEditProvider(ze,$t(ee),ae)},registerDocumentRangeFormattingEditProvider(ee,ae){return lt.registerDocumentRangeFormattingEditProvider(ze,$t(ee),ae)},registerOnTypeFormattingEditProvider(ee,ae,Oe,...ot){return lt.registerOnTypeFormattingEditProvider(ze,$t(ee),ae,[Oe].concat(ot))},registerDocumentSemanticTokensProvider(ee,ae,Oe){return lt.registerDocumentSemanticTokensProvider(ze,$t(ee),ae,Oe)},registerDocumentRangeSemanticTokensProvider(ee,ae,Oe){return lt.registerDocumentRangeSemanticTokensProvider(ze,$t(ee),ae,Oe)},registerSignatureHelpProvider(ee,ae,Oe,...ot){return typeof Oe=="object"?lt.registerSignatureHelpProvider(ze,$t(ee),ae,Oe):lt.registerSignatureHelpProvider(ze,$t(ee),ae,typeof Oe>"u"?[]:[Oe,...ot])},registerCompletionItemProvider(ee,ae,...Oe){return lt.registerCompletionItemProvider(ze,$t(ee),ae,Oe)},registerInlineCompletionItemProvider(ee,ae,Oe){return ae.handleDidShowCompletionItem&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),ae.handleDidPartiallyAcceptCompletionItem&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),Oe&&(0,Xe.$LF)(ze,"inlineCompletionsAdditions"),lt.registerInlineCompletionsProvider(ze,$t(ee),ae,Oe)},registerDocumentLinkProvider(ee,ae){return lt.registerDocumentLinkProvider(ze,$t(ee),ae)},registerColorProvider(ee,ae){return lt.registerColorProvider(ze,$t(ee),ae)},registerFoldingRangeProvider(ee,ae){return lt.registerFoldingRangeProvider(ze,$t(ee),ae)},registerSelectionRangeProvider(ee,ae){return lt.registerSelectionRangeProvider(ze,ee,ae)},registerCallHierarchyProvider(ee,ae){return lt.registerCallHierarchyProvider(ze,ee,ae)},registerTypeHierarchyProvider(ee,ae){return lt.registerTypeHierarchyProvider(ze,ee,ae)},setLanguageConfiguration:(ee,ae)=>lt.setLanguageConfiguration(ze,ee,ae),getTokenInformationAtPosition(ee,ae){return(0,Xe.$LF)(ze,"tokenInformation"),$i.tokenAtPosition(ee,ae)},registerInlayHintsProvider(ee,ae){return lt.registerInlayHintsProvider(ze,ee,ae)},createLanguageStatusItem(ee,ae){return $i.createLanguageStatusItem(ze,ee,ae)},registerDocumentDropEditProvider(ee,ae,Oe){return lt.registerDocumentOnDropEditProvider(ze,ee,ae,(0,Xe.$KF)(ze,"dropMetadata")?Oe:void 0)}},on={get activeTextEditor(){return Ht.getActiveTextEditor()},get visibleTextEditors(){return Ht.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(ee,ae,Oe){d.URI.isUri(ee)&&ee.scheme===L.Schemas.vscodeRemote&&!ee.authority&&It.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(d.URI.isUri(ee)?Promise.resolve(an.openTextDocument(ee)):Promise.resolve(ee));return Ht.showTextDocument(ot,ae,Oe)},createTextEditorDecorationType(ee){return Ht.createTextEditorDecorationType(ze,ee)},onDidChangeActiveTextEditor(ee,ae,Oe){return it(Ht.onDidChangeActiveTextEditor)(ee,ae,Oe)},onDidChangeVisibleTextEditors(ee,ae,Oe){return it(Ht.onDidChangeVisibleTextEditors)(ee,ae,Oe)},onDidChangeTextEditorSelection(ee,ae,Oe){return it(Ht.onDidChangeTextEditorSelection)(ee,ae,Oe)},onDidChangeTextEditorOptions(ee,ae,Oe){return it(Ht.onDidChangeTextEditorOptions)(ee,ae,Oe)},onDidChangeTextEditorVisibleRanges(ee,ae,Oe){return it(Ht.onDidChangeTextEditorVisibleRanges)(ee,ae,Oe)},onDidChangeTextEditorViewColumn(ee,ae,Oe){return it(Ht.onDidChangeTextEditorViewColumn)(ee,ae,Oe)},onDidCloseTerminal(ee,ae,Oe){return it(St.onDidCloseTerminal)(ee,ae,Oe)},onDidOpenTerminal(ee,ae,Oe){return it(St.onDidOpenTerminal)(ee,ae,Oe)},onDidChangeActiveTerminal(ee,ae,Oe){return it(St.onDidChangeActiveTerminal)(ee,ae,Oe)},onDidChangeTerminalDimensions(ee,ae,Oe){return(0,Xe.$LF)(ze,"terminalDimensions"),it(St.onDidChangeTerminalDimensions)(ee,ae,Oe)},onDidChangeTerminalState(ee,ae,Oe){return it(St.onDidChangeTerminalState)(ee,ae,Oe)},onDidWriteTerminalData(ee,ae,Oe){return(0,Xe.$LF)(ze,"terminalDataWriteEvent"),it(St.onDidWriteTerminalData)(ee,ae,Oe)},onDidExecuteTerminalCommand(ee,ae,Oe){return(0,Xe.$LF)(ze,"terminalExecuteCommandEvent"),it(St.onDidExecuteTerminalCommand)(ee,ae,Oe)},get state(){return Nt.getState(ze)},onDidChangeWindowState(ee,ae,Oe){return it(Nt.onDidChangeWindowState)(ee,ae,Oe)},showInformationMessage(ee,...ae){return vi.showMessage(ze,m.default.Info,ee,ae[0],ae.slice(1))},showWarningMessage(ee,...ae){return vi.showMessage(ze,m.default.Warning,ee,ae[0],ae.slice(1))},showErrorMessage(ee,...ae){return vi.showMessage(ze,m.default.Error,ee,ae[0],ae.slice(1))},showQuickPick(ee,ae,Oe){return di.showQuickPick(ze,ee,ae,Oe)},showWorkspaceFolderPick(ee){return di.showWorkspaceFolderPick(ee)},showInputBox(ee,ae){return di.showInput(ee,ae)},showOpenDialog(ee){return Ui.showOpenDialog(ze,ee)},showSaveDialog(ee){return Ui.showSaveDialog(ee)},createStatusBarItem(ee,ae,Oe){let ot,bt,At;return typeof ee=="string"?(ot=ee,bt=ae,At=Oe):(bt=ee,At=ae),zi.createStatusBarEntry(ze,ot,bt,At)},setStatusBarMessage(ee,ae){return zi.setStatusBarMessage(ee,ae)},withScmProgress(ee){return It.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Di.withProgress(ze,{location:Ne.ProgressLocation.SourceControl},(ae,Oe)=>ee({report(ot){}}))},withProgress(ee,ae){return Di.withProgress(ze,ee,ae)},createOutputChannel(ee,ae){return he.createOutputChannel(ee,ae,ze)},createWebviewPanel(ee,ae,Oe,ot){return Fi.createWebviewPanel(ze,ee,ae,Oe,ot)},createWebviewTextEditorInset(ee,ae,Oe,ot){return(0,Xe.$LF)(ze,"editorInsets"),Li.createWebviewEditorInset(ee,ae,Oe,ot,ze)},createTerminal(ee,ae,Oe){return typeof ee=="object"?"pty"in ee?St.createExtensionTerminal(ee):St.createTerminalFromOptions(ee):St.createTerminal(ee,ae,Oe)},registerTerminalLinkProvider(ee){return St.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,ae){return St.registerProfileProvider(ze,ee,ae)},registerTerminalQuickFixProvider(ee,ae){return(0,Xe.$LF)(ze,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(ee,ze.identifier.value,ae)},registerTreeDataProvider(ee,ae){return yi.registerTreeDataProvider(ee,ae,ze)},createTreeView(ee,ae){return yi.createTreeView(ee,ae,ze)},registerWebviewPanelSerializer:(ee,ae)=>Fi.registerWebviewPanelSerializer(ze,ee,ae),registerCustomEditorProvider:(ee,ae,Oe={})=>ln.registerCustomEditorProvider(ze,ee,ae,Oe),registerFileDecorationProvider(ee){return Gt.registerFileDecorationProvider(ee,ze)},registerUriHandler(ee){return Me.registerUriHandler(ze,ee)},createQuickPick(){return di.createQuickPick(ze)},createInputBox(){return di.createInputBox(ze)},get activeColorTheme(){return Mi.activeColorTheme},onDidChangeActiveColorTheme(ee,ae,Oe){return it(Mi.onDidChangeActiveColorTheme)(ee,ae,Oe)},registerWebviewViewProvider(ee,ae,Oe){return Ti.registerWebviewViewProvider(ze,ee,ae,Oe?.webviewOptions)},get activeNotebookEditor(){return tt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,ae,Oe){return it(tt.onDidChangeActiveNotebookEditor)(ee,ae,Oe)},get visibleNotebookEditors(){return tt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return it(tt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(ee,ae,Oe){return it(zt.onDidChangeNotebookEditorSelection)(ee,ae,Oe)},onDidChangeNotebookEditorVisibleRanges(ee,ae,Oe){return it(zt.onDidChangeNotebookEditorVisibleRanges)(ee,ae,Oe)},showNotebookDocument(ee,ae){return tt.showNotebookDocument(ee,ae)},registerExternalUriOpener(ee,ae,Oe){return(0,Xe.$LF)(ze,"externalUriOpener"),hn.registerExternalUriOpener(ze.identifier,ee,ae,Oe)},registerProfileContentHandler(ee,ae){return(0,Xe.$LF)(ze,"profileContentHandlers"),dn.registerProfileContentHandler(ze,ee,ae)},registerQuickDiffProvider(ee,ae,Oe,ot){return(0,Xe.$LF)(ze,"quickDiffProvider"),Ri.registerQuickDiffProvider($t(ee),ae,Oe,ot)},get tabGroups(){return Ot.tabGroups},registerShareProvider(ee,ae){return(0,Xe.$LF)(ze,"shareProvider"),Zi.registerShareProvider($t(ee),ae)}},an={get rootPath(){return It.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw new M.$9("rootPath")},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw new M.$9("name")},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw new M.$9("workspaceFile")},updateWorkspaceFolders:(ee,ae,...Oe)=>dt.updateWorkspaceFolders(ze,ee,ae||0,...Oe),onDidChangeWorkspaceFolders:function(ee,ae,Oe){return it(dt.onDidChangeWorkspace)(ee,ae,Oe)},asRelativePath:(ee,ae)=>dt.getRelativePath(ee,ae),findFiles:(ee,ae,Oe,ot)=>dt.findFiles(ee,ae,Oe,ze.identifier,ot),findFiles2:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"findFiles2"),dt.findFiles2(ee,ae,ze.identifier,Oe)),findTextInFiles:(ee,ae,Oe,ot)=>{(0,Xe.$LF)(ze,"findTextInFiles");let bt,At;return typeof ae=="object"?(bt=ae,At=Oe):(bt={},At=ae,ot=Oe),dt.findTextInFiles(ee,bt||{},At,ze.identifier,ot)},save:ee=>dt.save(ee),saveAs:ee=>dt.saveAs(ee),saveAll:ee=>dt.saveAll(ee),applyEdit(ee,ae){return gn.applyWorkspaceEdit(ee,ze,ae)},createFileSystemWatcher:(ee,ae,Oe,ot)=>{let bt;return typeof ae=="boolean"?bt={ignoreCreateEvents:!!ae,ignoreChangeEvents:!!Oe,ignoreDeleteEvents:!!ot,correlate:!1}:ae&&((0,Xe.$LF)(ze,"createFileSystemWatcher"),bt={...ae,correlate:!0}),ai.createFileSystemWatcher(dt,ze,ee,bt)},get textDocuments(){return Ue.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw new M.$9("textDocuments")},openTextDocument(ee){let ae;const Oe=ee;if(typeof ee=="string")ae=Promise.resolve(d.URI.file(ee));else if(d.URI.isUri(ee))ae=Promise.resolve(ee);else if(!Oe||typeof Oe=="object")ae=Ue.createDocumentData(Oe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ae.then(ot=>(ot.scheme===L.Schemas.vscodeRemote&&!ot.authority&&It.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),Ue.ensureDocumentData(ot).then(bt=>bt.document)))},onDidOpenTextDocument:(ee,ae,Oe)=>it(Ue.onDidAddDocument)(ee,ae,Oe),onDidCloseTextDocument:(ee,ae,Oe)=>it(Ue.onDidRemoveDocument)(ee,ae,Oe),onDidChangeTextDocument:(ee,ae,Oe)=>it(Ue.onDidChangeDocument)(ee,ae,Oe),onDidSaveTextDocument:(ee,ae,Oe)=>it(Ue.onDidSaveDocument)(ee,ae,Oe),onWillSaveTextDocument:(ee,ae,Oe)=>it(Ke.getOnWillSaveTextDocumentEvent(ze))(ee,ae,Oe),get notebookDocuments(){return tt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,ae){let Oe;if(d.URI.isUri(ee))Oe=ee,await tt.openNotebookDocument(ee);else if(typeof ee=="string")Oe=d.URI.revive(await tt.createNotebookDocument({viewType:ee,content:ae}));else throw new Error("Invalid arguments");return tt.getNotebookDocument(Oe).apiNotebook},onDidSaveNotebookDocument(ee,ae,Oe){return it(pt.onDidSaveNotebookDocument)(ee,ae,Oe)},onDidChangeNotebookDocument(ee,ae,Oe){return it(pt.onDidChangeNotebookDocument)(ee,ae,Oe)},onWillSaveNotebookDocument(ee,ae,Oe){return it(Jt.getOnWillSaveNotebookDocumentEvent(ze))(ee,ae,Oe)},get onDidOpenNotebookDocument(){return it(tt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return it(tt.onDidCloseNotebookDocument)},registerNotebookSerializer(ee,ae,Oe,ot){return tt.registerNotebookSerializer(ze,ee,ae,Oe,(0,Xe.$KF)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(ee,ae,Oe)=>it(ji.onDidChangeConfiguration)(ee,ae,Oe),getConfiguration(ee,ae){return ae=arguments.length===1?void 0:ae,ji.getConfiguration(ee,ae,ze)},registerTextDocumentContentProvider(ee,ae){return Ye.registerTextDocumentContentProvider(ee,ae)},registerTaskProvider:(ee,ae)=>(It.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),Fe.registerTaskProvider(ze,ee,ae)),registerFileSystemProvider(ee,ae,Oe){return(0,R.$Qc)(Qi.registerFileSystemProvider(ze,ee,ae,Oe),ii.addFileSystemProvider(ee,ae,Oe))},get fs(){return ii.value},registerFileSearchProvider:(ee,ae)=>((0,Xe.$LF)(ze,"fileSearchProvider"),ye.registerFileSearchProvider(ee,ae)),registerTextSearchProvider:(ee,ae)=>((0,Xe.$LF)(ze,"textSearchProvider"),ye.registerTextSearchProvider(ee,ae)),registerRemoteAuthorityResolver:(ee,ae)=>((0,Xe.$LF)(ze,"resolvers"),Ct.registerRemoteAuthorityResolver(ee,ae)),registerResourceLabelFormatter:ee=>((0,Xe.$LF)(ze,"resolvers"),Yi.$registerResourceLabelFormatter(ee)),getRemoteExecServer:ee=>((0,Xe.$LF)(ze,"resolvers"),Ct.getRemoteExecServer(ee)),onDidCreateFiles:(ee,ae,Oe)=>it(ai.onDidCreateFile)(ee,ae,Oe),onDidDeleteFiles:(ee,ae,Oe)=>it(ai.onDidDeleteFile)(ee,ae,Oe),onDidRenameFiles:(ee,ae,Oe)=>it(ai.onDidRenameFile)(ee,ae,Oe),onWillCreateFiles:(ee,ae,Oe)=>it(ai.getOnWillCreateFileEvent(ze))(ee,ae,Oe),onWillDeleteFiles:(ee,ae,Oe)=>it(ai.getOnWillDeleteFileEvent(ze))(ee,ae,Oe),onWillRenameFiles:(ee,ae,Oe)=>it(ai.getOnWillRenameFileEvent(ze))(ee,ae,Oe),openTunnel:ee=>((0,Xe.$LF)(ze,"tunnels"),Tt.openTunnel(ze,ee).then(ae=>{if(!ae)throw new Error("cannot open tunnel");return ae})),get tunnels(){return(0,Xe.$LF)(ze,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"tunnels"),it(Tt.onDidChangeTunnels)(ee,ae,Oe)),registerPortAttributesProvider:(ee,ae)=>((0,Xe.$LF)(ze,"portsAttributes"),Tt.registerPortsAttributesProvider(ee,ae)),registerTunnelProvider:(ee,ae)=>((0,Xe.$LF)(ze,"tunnelFactory"),Tt.registerTunnelProvider(ee,ae)),registerTimelineProvider:(ee,ae)=>((0,Xe.$LF)(ze,"timeline"),Xi.registerTimelineProvider(ee,ae,ze.identifier,wt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,Xe.$LF)(ze,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,ae,Oe)=>it(dt.onDidGrantWorkspaceTrust)(ee,ae,Oe),registerEditSessionIdentityProvider:(ee,ae)=>((0,Xe.$LF)(ze,"editSessionIdentityProvider"),dt.registerEditSessionIdentityProvider(ee,ae)),onWillCreateEditSessionIdentity:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"editSessionIdentityProvider"),it(dt.getOnWillCreateEditSessionIdentityEvent(ze))(ee,ae,Oe)),registerCanonicalUriProvider:(ee,ae)=>((0,Xe.$LF)(ze,"canonicalUriProvider"),dt.registerCanonicalUriProvider(ee,ae)),getCanonicalUri:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"canonicalUriProvider"),dt.provideCanonicalUri(ee,ae,Oe))},$n={get inputBox(){return It.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ei.getLastInputBox(ze)},createSourceControl(ee,ae,Oe){return Ei.createSourceControl(ze,ee,ae,Oe)}},cn={createCommentController(ee,ae){return Ai.createCommentController(ze,ee,ae)}},un={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get stackFrameFocus(){return kt.stackFrameFocus},registerDebugVisualizationProvider(ee,ae){return(0,Xe.$LF)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,ee,ae)},onDidStartDebugSession(ee,ae,Oe){return it(kt.onDidStartDebugSession)(ee,ae,Oe)},onDidTerminateDebugSession(ee,ae,Oe){return it(kt.onDidTerminateDebugSession)(ee,ae,Oe)},onDidChangeActiveDebugSession(ee,ae,Oe){return it(kt.onDidChangeActiveDebugSession)(ee,ae,Oe)},onDidReceiveDebugSessionCustomEvent(ee,ae,Oe){return it(kt.onDidReceiveDebugSessionCustomEvent)(ee,ae,Oe)},onDidChangeBreakpoints(ee,ae,Oe){return it(kt.onDidChangeBreakpoints)(ee,ae,Oe)},onDidChangeStackFrameFocus(ee,ae,Oe){return(0,Xe.$LF)(ze,"debugFocus"),it(kt.onDidChangeStackFrameFocus)(ee,ae,Oe)},registerDebugConfigurationProvider(ee,ae,Oe){return kt.registerDebugConfigurationProvider(ee,ae,Oe||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,ae){return kt.registerDebugAdapterDescriptorFactory(ze,ee,ae)},registerDebugAdapterTrackerFactory(ee,ae){return kt.registerDebugAdapterTrackerFactory(ee,ae)},startDebugging(ee,ae,Oe){return!Oe||typeof Oe=="object"&&"configuration"in Oe?kt.startDebugging(ee,ae,{parentSession:Oe}):kt.startDebugging(ee,ae,Oe||{})},stopDebugging(ee){return kt.stopDebugging(ee)},addBreakpoints(ee){return kt.addBreakpoints(ee)},removeBreakpoints(ee){return kt.removeBreakpoints(ee)},asDebugSourceUri(ee,ae){return kt.asDebugSourceUri(ee,ae)}},Bi={registerTaskProvider:(ee,ae)=>Fe.registerTaskProvider(ze,ee,ae),fetchTasks:ee=>Fe.fetchTasks(ee),executeTask:ee=>Fe.executeTask(ze,ee),get taskExecutions(){return Fe.taskExecutions},onDidStartTask:(ee,ae,Oe)=>it(Fe.onDidStartTask)(ee,ae,Oe),onDidEndTask:(ee,ae,Oe)=>it(Fe.onDidEndTask)(ee,ae,Oe),onDidStartTaskProcess:(ee,ae,Oe)=>it(Fe.onDidStartTaskProcess)(ee,ae,Oe),onDidEndTaskProcess:(ee,ae,Oe)=>it(Fe.onDidEndTaskProcess)(ee,ae,Oe)},Wi={createNotebookController(ee,ae,Oe,ot,bt){return Ut.createNotebookController(ze,ee,ae,Oe,ot,(0,Xe.$KF)(ze,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,ae)=>tt.registerNotebookCellStatusBarItemProvider(ze,ee,ae),createRendererMessaging(ee){return Pt.createRendererMessaging(ze,ee)},createNotebookControllerDetectionTask(ee){return(0,Xe.$LF)(ze,"notebookKernelSource"),Ut.createNotebookControllerDetectionTask(ze,ee)},registerKernelSourceActionProvider(ee,ae){return(0,Xe.$LF)(ze,"notebookKernelSource"),Ut.registerKernelSourceActionProvider(ze,ee,ae)},onDidChangeNotebookCellExecutionState(ee,ae,Oe){return(0,Xe.$LF)(ze,"notebookCellExecutionState"),it(Ut.onDidChangeNotebookCellExecutionState)(ee,ae,Oe)}},Vi={t(...ee){if(typeof ee[0]=="string"){const ae=ee.shift(),Oe=!ee||typeof ee[0]!="object"?ee:ee[0];return Q.getMessage(ze.identifier.value,{message:ae,args:Oe})}return Q.getMessage(ze.identifier.value,ee[0])},get bundle(){return Q.getBundle(ze.identifier.value)},get uri(){return Q.getBundleUri(ze.identifier.value)}},Pi={_version:1,registerInteractiveEditorSessionProvider(ee,ae){return(0,Xe.$LF)(ze,"interactive"),xi.registerProvider(ze,ee,ae)},registerInteractiveSessionProvider(ee,ae){return(0,Xe.$LF)(ze,"interactive"),Si.registerChatProvider(ze,ee,ae)},sendInteractiveRequestToProvider(ee,ae){return(0,Xe.$LF)(ze,"interactive"),Si.sendInteractiveRequestToProvider(ee,ae)},transferChatSession(ee,ae){return(0,Xe.$LF)(ze,"interactive"),Si.transferChatSession(ee,ae)}},qi={getRelatedInformation(ee,ae){return(0,Xe.$LF)(ze,"aiRelatedInformation"),Oi.getRelatedInformation(ze,ee,ae)},registerRelatedInformationProvider(ee,ae){return(0,Xe.$LF)(ze,"aiRelatedInformation"),Oi.registerRelatedInformationProvider(ze,ee,ae)},registerEmbeddingVectorProvider(ee,ae){return(0,Xe.$LF)(ze,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(ze,ee,ae)}},Hi={registerChatResponseProvider(ee,ae,Oe){return(0,Xe.$LF)(ze,"chatProvider"),wi.registerLanguageModel(ze.identifier,ee,ae,Oe)},requestLanguageModelAccess(ee,ae){return(0,Xe.$LF)(ze,"chatRequestAccess"),wi.requestLanguageModelAccess(ze.identifier,ee,ae)},get languageModels(){return(0,Xe.$LF)(ze,"chatRequestAccess"),wi.getLanguageModelIds()},onDidChangeLanguageModels:(ee,ae,Oe)=>((0,Xe.$LF)(ze,"chatRequestAccess"),wi.onDidChangeProviders(ee,ae,Oe)),registerVariable(ee,ae,Oe){return(0,Xe.$LF)(ze,"chatAgents2"),_i.registerVariableResolver(ze,ee,ae,Oe)},registerMappedEditsProvider(ee,ae){return(0,Xe.$LF)(ze,"mappedEditsProvider"),lt.registerMappedEditsProvider(ze,ee,ae)},createChatAgent(ee,ae){return(0,Xe.$LF)(ze,"chatAgents2"),Ni.createChatAgent(ze,ee,ae)}},pn={registerSpeechProvider(ee,ae){return(0,Xe.$LF)(ze,"speech"),li.registerProvider(ze.identifier,ee,ae)}};return{version:mt.version,ai:qi,authentication:en,commands:mn,comments:cn,chat:Hi,debug:un,env:tn,extensions:rn,interactive:Pi,l10n:Vi,languages:sn,notebooks:Wi,scm:$n,speech:pn,tasks:Bi,tests:nn,window:on,workspace:an,Breakpoint:Ne.$mM,TerminalOutputAnchor:Ne.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Ne.ChatAgentResultFeedbackKind,ChatMessage:Ne.$fN,ChatMessageRole:Ne.ChatMessageRole,ChatVariableLevel:Ne.ChatVariableLevel,ChatAgentCompletionItem:Ne.$eN,CallHierarchyIncomingCall:Ne.$LL,CallHierarchyItem:Ne.$KL,CallHierarchyOutgoingCall:Ne.$ML,CancellationError:M.$5,CancellationTokenSource:S.$7d,CandidatePortSource:o.CandidatePortSource,CodeAction:Ne.$HL,CodeActionKind:Ne.$IL,CodeActionTriggerKind:Ne.CodeActionTriggerKind,CodeLens:Ne.$NL,Color:Ne.$1L,ColorInformation:Ne.$2L,ColorPresentation:Ne.$3L,ColorThemeKind:Ne.ColorThemeKind,CommentMode:Ne.CommentMode,CommentState:Ne.CommentState,CommentThreadCollapsibleState:Ne.CommentThreadCollapsibleState,CommentThreadState:Ne.CommentThreadState,CompletionItem:Ne.$UL,CompletionItemKind:Ne.CompletionItemKind,CompletionItemTag:Ne.CompletionItemTag,CompletionList:Ne.$VL,CompletionTriggerKind:Ne.CompletionTriggerKind,ConfigurationTarget:Ne.ConfigurationTarget,CustomExecution:Ne.$$L,DebugAdapterExecutable:Ne.$qM,DebugAdapterInlineImplementation:Ne.$tM,DebugAdapterNamedPipeServer:Ne.$sM,DebugAdapterServer:Ne.$rM,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Ne.DebugConsoleMode,DebugVisualization:Ne.$IM,DecorationRangeBehavior:Ne.DecorationRangeBehavior,Diagnostic:Ne.$BL,DiagnosticRelatedInformation:Ne.$AL,DiagnosticSeverity:Ne.DiagnosticSeverity,DiagnosticTag:Ne.DiagnosticTag,Disposable:Ne.$nL,DocumentHighlight:Ne.$DL,DocumentHighlightKind:Ne.DocumentHighlightKind,MultiDocumentHighlight:Ne.$EL,DocumentLink:Ne.$ZL,DocumentSymbol:Ne.$GL,EndOfLine:Ne.EndOfLine,EnvironmentVariableMutatorType:Ne.EnvironmentVariableMutatorType,EvaluatableExpression:Ne.$wM,InlineValueText:Ne.$xM,InlineValueVariableLookup:Ne.$yM,InlineValueEvaluatableExpression:Ne.$zM,InlineCompletionTriggerKind:Ne.InlineCompletionTriggerKind,EventEmitter:I.$Wd,ExtensionKind:Ne.ExtensionKind,ExtensionMode:Ne.ExtensionMode,ExternalUriOpenerPriority:Ne.ExternalUriOpenerPriority,FileChangeType:Ne.FileChangeType,FileDecoration:Ne.$KM,FileDecoration2:Ne.$KM,FileSystemError:Ne.$BM,FileType:p.FileType,FilePermission:p.FilePermission,FoldingRange:Ne.$CM,FoldingRangeKind:Ne.FoldingRangeKind,FunctionBreakpoint:Ne.$oM,InlineCompletionItem:Ne.$WL,InlineCompletionList:Ne.$XL,Hover:Ne.$CL,IndentAction:k.IndentAction,Location:Ne.$zL,MarkdownString:Ne.$OL,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:Ne.$PL,PortAutoForwardAction:Ne.PortAutoForwardAction,Position:Ne.$oL,ProcessExecution:Ne.$9L,ProgressLocation:Ne.ProgressLocation,QuickInputButtons:Ne.$JM,Range:Ne.$pL,RelativePattern:Ne.$kM,Selection:Ne.$qL,SelectionRange:Ne.$JL,SemanticTokens:Ne.$FM,SemanticTokensBuilder:Ne.$EM,SemanticTokensEdit:Ne.$GM,SemanticTokensEdits:Ne.$HM,SemanticTokensLegend:Ne.$DM,ShellExecution:Ne.$0L,ShellQuoting:Ne.ShellQuoting,SignatureHelp:Ne.$RL,SignatureHelpTriggerKind:Ne.SignatureHelpTriggerKind,SignatureInformation:Ne.$QL,SnippetString:Ne.$yL,SourceBreakpoint:Ne.$nM,StandardTokenType:Ne.StandardTokenType,StatusBarAlignment:Ne.StatusBarAlignment,SymbolInformation:Ne.$FL,SymbolKind:Ne.SymbolKind,SymbolTag:Ne.SymbolTag,Task:Ne.$_L,TaskGroup:Ne.$8L,TaskPanelKind:Ne.TaskPanelKind,TaskRevealKind:Ne.TaskRevealKind,TaskScope:Ne.TaskScope,TerminalLink:Ne.$4L,TerminalQuickFixTerminalCommand:Ne.$6L,TerminalQuickFixOpener:Ne.$5L,TerminalLocation:Ne.TerminalLocation,TerminalProfile:Ne.$7L,TerminalExitReason:Ne.TerminalExitReason,TextDocumentSaveReason:Ne.TextDocumentSaveReason,TextEdit:Ne.$uL,SnippetTextEdit:Ne.$wL,TextEditorCursorStyle:y.TextEditorCursorStyle,TextEditorLineNumbersStyle:Ne.TextEditorLineNumbersStyle,TextEditorRevealType:Ne.TextEditorRevealType,TextEditorSelectionChangeKind:Ne.TextEditorSelectionChangeKind,SyntaxTokenType:Ne.SyntaxTokenType,TextDocumentChangeReason:Ne.TextDocumentChangeReason,ThemeColor:Ne.$jM,ThemeIcon:Ne.$iM,TreeItem:Ne.$aM,TreeItemCheckboxState:Ne.TreeItemCheckboxState,TreeItemCollapsibleState:Ne.TreeItemCollapsibleState,TypeHierarchyItem:Ne.$6M,UIKind:Yt.UIKind,Uri:d.URI,ViewColumn:Ne.ViewColumn,WorkspaceEdit:Ne.$xL,DocumentDropEdit:Ne.$gM,DocumentPasteEdit:Ne.$hM,InlayHint:Ne.$TL,InlayHintLabelPart:Ne.$SL,InlayHintKind:Ne.InlayHintKind,RemoteAuthorityResolverError:Ne.$tL,ResolvedAuthority:Ne.$rL,ManagedResolvedAuthority:Ne.$sL,SourceControlInputBoxValidationType:Ne.SourceControlInputBoxValidationType,ExtensionRuntime:Ne.ExtensionRuntime,TimelineItem:Ne.$UM,NotebookRange:Ne.$MM,NotebookCellKind:Ne.NotebookCellKind,NotebookCellExecutionState:Ne.NotebookCellExecutionState,NotebookCellData:Ne.$NM,NotebookData:Ne.$OM,NotebookRendererScript:Ne.$SM,NotebookCellStatusBarAlignment:Ne.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Ne.NotebookEditorRevealType,NotebookCellOutput:Ne.$QM,NotebookCellOutputItem:Ne.$PM,NotebookCellStatusBarItem:Ne.$RM,NotebookControllerAffinity:Ne.NotebookControllerAffinity,NotebookControllerAffinity2:Ne.NotebookControllerAffinity2,NotebookEdit:Ne.$vL,NotebookKernelSourceAction:Ne.$TM,NotebookVariablesRequestKind:Ne.NotebookVariablesRequestKind,PortAttributes:Ne.$WM,LinkedEditingRanges:Ne.$VM,TestResultState:Ne.TestResultState,TestRunRequest:Ne.$XM,TestMessage:Ne.$YM,TestTag:Ne.$ZM,TestRunProfileKind:Ne.TestRunProfileKind,TextSearchCompleteMessageType:Wt.TextSearchCompleteMessageType,DataTransfer:Ne.$fM,DataTransferItem:Ne.$bM,CoveredCount:Ne.$1M,FileCoverage:Ne.$2M,StatementCoverage:Ne.$3M,BranchCoverage:Ne.$4M,DeclarationCoverage:Ne.$5M,FunctionCoverage:Ne.$5M,WorkspaceTrustState:Ne.WorkspaceTrustState,LanguageStatusSeverity:Ne.LanguageStatusSeverity,QuickPickItemKind:Ne.QuickPickItemKind,InputBoxValidationSeverity:Ne.InputBoxValidationSeverity,TabInputText:Ne.$7M,TabInputTextDiff:Ne.$8M,TabInputTextMerge:Ne.$9M,TabInputCustom:Ne.$0M,TabInputNotebook:Ne.$_M,TabInputNotebookDiff:Ne.$aN,TabInputWebview:Ne.$$M,TabInputTerminal:Ne.$bN,TabInputInteractiveWindow:Ne.$cN,TabInputChat:Ne.$dN,TelemetryTrustedValue:s.$No,LogLevel:r.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Ne.InteractiveSessionVoteDirection,ChatAgentCopyKind:Ne.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Ne.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Ne.$uM,ThreadFocus:Ne.$vM,RelatedInformationType:Ne.RelatedInformationType,SpeechToTextStatus:Ne.SpeechToTextStatus,KeywordRecognitionStatus:Ne.KeywordRecognitionStatus,ChatResponseTextPart:Ne.$gN,ChatResponseMarkdownPart:Ne.$hN,ChatResponseFileTreePart:Ne.$iN,ChatResponseAnchorPart:Ne.$jN,ChatResponseProgressPart:Ne.$kN,ChatResponseReferencePart:Ne.$lN}}}e.$tic=ti}),define(Re[292],Ae([1,0,53,112,36,107,37,31,66,65,115,117,118,82,85,78,106,62,43,81,60,64,228,13,116,79,80]),function(me,e,S,M,I,R,L,m,d,y,A,k,l,$,p,r,c,s,i,o,a,u,t,f,n,w,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$1r)(w.$ihc,w.$hhc,1),(0,S.$1r)(f.$qj,t.$uic,1),(0,S.$1r)(r.$tgc,r.$ugc,1),(0,S.$1r)(m.$SN,m.$RN,0),(0,S.$1r)(L.$Ogc,L.$Mgc,0),(0,S.$1r)(s.$Qgc,s.$Pgc,0),(0,S.$1r)(k.$shc,k.$whc,0),(0,S.$1r)(R.$yhc,R.$xhc,0),(0,S.$1r)(d.$HN,d.$GN,0),(0,S.$1r)(D.$jhc,D.$khc,0),(0,S.$1r)(i.$qgc,i.$pgc,0),(0,S.$1r)(M.$5hc,M.$4hc,1),(0,S.$1r)(l.$Ohc,l.$Phc,0),(0,S.$1r)($.$0gc,$.$9gc,0),(0,S.$1r)(A.$fic,A.$eic,0),(0,S.$1r)(y.$ahc,y.$dhc,0),(0,S.$1r)(p.$vzb,p.$wzb,0),(0,S.$1r)(c.$sic,c.$ric,0),(0,S.$1r)(I.$Lgc,I.$Kgc,0),(0,S.$1r)(o.$fhc,o.$ehc,0),(0,S.$1r)(a.$QN,a.$NN,0),(0,S.$1r)(u.$1gc,u.$2gc,0),(0,S.$1r)(n.$qhc,n.$rhc,0)}),define(Re[293],Ae([1,0,291,38,2,288,7,11,234]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fkc=void 0;class y extends R.$xic{j(){}getModule($,p){for(const r of this.b){const c=r($);if(c){$=c;break}}if(this.a.has($))return this.a.get($).load($,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class A extends M.$mhc{constructor(){super(...arguments),this.extensionRuntime=L.ExtensionRuntime.Webworker}async tb(){this.h.createInstance(d.$Ekc);const $=this.h.invokeFunction(S.$tic);this.r=this.h.createInstance(y,$,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.zb()}ub($){return $.browser}async vb($,p,r){p=p.with({path:k(p.path,".js")});const c=$?.identifier.value;c&&performance.mark(`code/extHost/willFetchExtensionCode/${c}`);const s=I.URI.revive(await this.C.$asBrowserUri(p)),i=await fetch(s.toString(!0));if(c&&performance.mark(`code/extHost/didFetchExtensionCode/${c}`),i.status!==200)throw new Error(i.statusText);const o=await i.text(),a=`${p.toString(!0)}#vscode-extension`,u=`${o}
//# sourceURL=${a}`;let t;try{t=new Function("module","exports","require",u)}catch(D){throw console.error(c?`Loading code for extension ${c} failed: ${D.message}`:`Loading code failed: ${D.message}`),console.error(`${p.toString(!0)}${typeof D.line=="number"?` line ${D.line}`:""}${typeof D.column=="number"?` column ${D.column}`:""}`),console.error(D),D}$&&await this.w.initializeLocalizedMessages($);const f={},n={exports:f},w=D=>{const h=this.r.getModule(D,p);if(h===void 0)throw new Error(`Cannot load module '${D}'`);return h};try{return r.codeLoadingStart(),c&&performance.mark(`code/extHost/willLoadExtensionCode/${c}`),t(n,f,w),n.exports!==f?n.exports:f}finally{c&&performance.mark(`code/extHost/didLoadExtensionCode/${c}`),r.codeLoadingStop()}}async $setRemoteEnvironment($){}async zb($=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+$;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,m.$9g)(10)}}e.$Fkc=A;function k(l,$){return l.endsWith($)?l:l+$}}),define(Re[294],Ae([1,0,70,53,13,38,199,84,293]),function(me,e,S,M,I,R,L,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,M.$1r)(I.$pj,new S.$5h(L.$wic,[!0],!0)),(0,M.$1r)(R.$nhc,d.$Fkc,0),(0,M.$1r)(m.$Rgc,m.$Sgc,0)}),define(Re[299],Ae([1,0,23,5,77,289,236,19,87,12,2,292,294]),function(me,e,S,M,I,R,L,m,d,y,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const k=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function $(t){return/^(file|vscode-remote):/i.test(t)}const p=fetch.bind(self);function r(t){self.fetch=async function(f,n){return f instanceof Request||$(String(f))&&(f=(await t(A.URI.parse(String(f)))).toString(!0)),p(f,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(f,n,w,D,h){(async()=>($(n.toString())&&(n=(await t(A.URI.parse(n.toString()))).toString(!0)),super.open(f,n,w??!0,D,h)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const t=self.Worker;Worker=function(f,n){if(/^file:/i.test(f.toString()))f=y.$pg.uriToBrowserUri(A.URI.parse(f.toString())).toString(!0);else if(/^vscode-remote:/i.test(f.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const D=`(${function(g){function v(N){return typeof N=="string"||N instanceof URL?String(N).replace(/^file:\/\//i,"vscode-file://vscode-app"):N}const E=fetch.bind(self);self.fetch=function(N,J){return N instanceof Request?E(N,J):E(v(N),J)},self.XMLHttpRequest=class extends XMLHttpRequest{open(N,J,q,U,C){return super.open(N,v(J),q??!0,U,C)}};const T=importScripts.bind(self);self.importScripts=(...N)=>{T(...N.map(v))},T(g)}.toString()}('${f}'))`;n=n||{},n.name=`${name} -> ${n.name||m.$nc(f.toString())}`;const h=new Blob([D],{type:"application/javascript"}),b=URL.createObjectURL(h);return new t(b,n)}}else self.Worker=class extends L.$Gkc{constructor(t,f){super(l,t,{name:m.$nc(t.toString()),...f})}};const c=new class{constructor(){this.pid=void 0}exit(t){k()}};class s{constructor(){const f=new MessageChannel,n=new M.$Wd;let w=!1;l(f.port2,[f.port2]),f.port1.onmessage=D=>{const{data:h}=D;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const b=S.$ke.wrap(new Uint8Array(h,0,h.byteLength));if((0,I.$wm)(b,2)){w=!0,o("received terminate message from renderer");return}n.fire(b)},this.protocol={onMessage:n.event,send:D=>{if(!w){const h=D.buffer.buffer.slice(D.buffer.byteOffset,D.buffer.byteOffset+D.buffer.byteLength);f.port1.postMessage(h,[h])}}}}}function i(t){return new Promise(f=>{const n=t.onMessage(w=>{n.dispose();const D=JSON.parse(w.toString());t.send((0,I.$vm)(0)),f({protocol:t,initData:D})});t.send((0,I.$vm)(1))})}let o=t=>k();function a(t){return!!t&&typeof t=="object"&&t.type==="vscode.init"&&t.data instanceof Map}function u(){d.mark("code/extHost/willConnectToRenderer");const t=new s;return{onmessage(f){a(f)&&i(t.protocol).then(n=>{d.mark("code/extHost/didWaitForInitData");const w=new R.$zic(n.protocol,n.initData,c,null,f.data);r(D=>w.asBrowserUri(D)),o=D=>w.terminate(D)})}}}e.create=u})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8fa84589eef3538dbc763ff98dc7d5a8a0c56374/core/vs/workbench/api/worker/extensionHostWorker.js.map
